diff -pruN 2.25.0-3/api-ref/source/conf.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/api-ref/source/conf.py
--- 2.25.0-3/api-ref/source/conf.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/api-ref/source/conf.py	2020-09-15 21:13:36.000000000 +0000
@@ -25,21 +25,18 @@
 
 import datetime
 import os
-from swift import __version__
-import subprocess
 import sys
 import warnings
 
-import openstackdocstheme
 
 html_theme = 'openstackdocs'
-html_theme_path = [openstackdocstheme.get_html_theme_path()]
 html_theme_options = {
     "sidebar_mode": "toc",
 }
 
 extensions = [
     'os_api_ref',
+    'openstackdocstheme'
 ]
 
 # If extensions (or modules to document with autodoc) are in another directory,
@@ -68,19 +65,6 @@ master_doc = 'index'
 project = u'Object Storage API Reference'
 copyright = u'2010-present, OpenStack Foundation'
 
-# The version info for the project you're documenting, acts as replacement for
-# |version| and |release|, also used in various other places throughout the
-# built documents.
-#
-# The short X.Y version.
-version = __version__.rsplit('.', 1)[0]
-# The full version, including alpha/beta/rc tags.
-release = __version__
-
-# html_context allows us to pass arbitrary values into the html template
-html_context = {'bug_tag': 'api-ref',
-                'bug_project': 'swift'}
-
 # The language for content autogenerated by Sphinx. Refer to documentation
 # for a list of supported languages.
 #
@@ -108,7 +92,12 @@ add_module_names = False
 show_authors = False
 
 # The name of the Pygments (syntax highlighting) style to use.
-pygments_style = 'sphinx'
+pygments_style = 'native'
+
+# openstackdocstheme options
+openstackdocs_repo_name = 'openstack/swift'
+openstackdocs_bug_project = 'swift'
+openstackdocs_bug_tag = 'api-ref'
 
 # -- Options for man page output ----------------------------------------------
 
@@ -152,25 +141,6 @@ pygments_style = 'sphinx'
 # so a file named "default.css" will overwrite the builtin "default.css".
 # html_static_path = ['_static']
 
-# If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
-# using the given strftime format.
-# html_last_updated_fmt = '%b %d, %Y'
-if 'SOURCE_DATE_EPOCH' in os.environ:
-    now = float(os.environ.get('SOURCE_DATE_EPOCH'))
-    html_last_updated_fmt = datetime.datetime.utcfromtimestamp(now).isoformat()
-else:
-    git_cmd = ["git", "log", "--pretty=format:'%ad, commit %h'",
-               "--date=local", "-n1"]
-    try:
-        html_last_updated_fmt = subprocess.Popen(
-            git_cmd, stdout=subprocess.PIPE).communicate()[0]
-    except OSError:
-        warnings.warn('Cannot get last updated time from git repository. '
-                      'Not setting "html_last_updated_fmt".')
-    else:
-        if not isinstance(html_last_updated_fmt, str):
-            # for py3
-            html_last_updated_fmt = html_last_updated_fmt.decode('ascii')
 # If true, SmartyPants will be used to convert quotes and dashes to
 # typographically correct entities.
 # html_use_smartypants = True
diff -pruN 2.25.0-3/bin/swift-container-info 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/bin/swift-container-info
--- 2.25.0-3/bin/swift-container-info	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/bin/swift-container-info	2020-09-15 21:13:36.000000000 +0000
@@ -42,6 +42,10 @@ if __name__ == '__main__':
     parser.add_option(
         '--drop-prefixes', default=False, action="store_true",
         help="When outputting metadata, drop the per-section common prefixes")
+    parser.add_option(
+        '-v', '--verbose', default=False, action="store_true",
+        help="Show all shard ranges. By default, only the number of shard "
+             "ranges is displayed if there are many shards.")
 
     options, args = parser.parse_args()
 
diff -pruN 2.25.0-3/bin/swift-get-nodes 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/bin/swift-get-nodes
--- 2.25.0-3/bin/swift-get-nodes	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/bin/swift-get-nodes	2020-09-15 21:13:36.000000000 +0000
@@ -52,6 +52,8 @@ if __name__ == '__main__':
                       help='Specify which policy to use')
     parser.add_option('-d', '--swift-dir', default='/etc/swift',
                       dest='swift_dir', help='Path to swift directory')
+    parser.add_option('-Q', '--quoted', action='store_true',
+                      help='Assume swift paths are quoted')
     options, args = parser.parse_args()
 
     if set_swift_dir(options.swift_dir):
diff -pruN 2.25.0-3/bin/swift-object-relinker 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/bin/swift-object-relinker
--- 2.25.0-3/bin/swift-object-relinker	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/bin/swift-object-relinker	2020-09-15 21:13:36.000000000 +0000
@@ -28,6 +28,8 @@ if __name__ == '__main__':
                         dest='swift_dir', help='Path to swift directory')
     parser.add_argument('--devices', default='/srv/node',
                         dest='devices', help='Path to swift device directory')
+    parser.add_argument('--device', default=None, dest='device',
+                        help='Device name to relink (default: all)')
     parser.add_argument('--skip-mount-check', default=False,
                         help='Don\'t test if disk is mounted',
                         action="store_true", dest='skip_mount_check')
diff -pruN 2.25.0-3/CHANGELOG 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/CHANGELOG
--- 2.25.0-3/CHANGELOG	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/CHANGELOG	2020-09-15 21:13:36.000000000 +0000
@@ -2,12 +2,6 @@ swift (2.25.0, OpenStack Ussuri)
 
     * WSGI server processes can now notify systemd when they are ready.
 
-    * Added a new middleware that allows users and operators to configure
-      accounts and containers to use RFC-compliant (i.e., double-quoted)
-      ETags. This may be useful when using Swift as an origin for some
-      content delivery networks. For more information, see
-      https://docs.openstack.org/swift/latest/middleware.html#etag-quoter
-
     * Added `ttfb` (Time to First Byte) and `pid` (Process ID) to the set
       of available proxy-server log fields. For more information, see
       https://docs.openstack.org/swift/latest/logs.html
@@ -58,8 +52,9 @@ swift (2.24.0)
     * Added support for S3 versioning using the above new mode.
 
     * Added a new middleware to allow accounts and containers to opt-in to
-      RFC-compliant ETags. For more information, see the documentation at
-      https://docs.openstack.org/swift/latest/middleware.html#module-swift.common.middleware.etag_quoter
+      RFC-compliant ETags. This may be useful when using Swift as an origin
+      for some content delivery networks. For more information, see the
+      documentation at https://docs.openstack.org/swift/latest/middleware.html#module-swift.common.middleware.etag_quoter
       Clients should be aware of the fact that ETags may be quoted for RFC
       compliance; this may become the default behavior in some future release.
 
diff -pruN 2.25.0-3/CONTRIBUTING.rst 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/CONTRIBUTING.rst
--- 2.25.0-3/CONTRIBUTING.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/CONTRIBUTING.rst	2020-09-15 21:13:36.000000000 +0000
@@ -21,6 +21,16 @@ Swift is nothing without the community b
 our community. Come find us in #openstack-swift on freenode IRC or on the
 OpenStack dev mailing list.
 
+For general information on contributing to OpenStack, please check out the
+`contributor guide <https://docs.openstack.org/contributors/>`_ to get started.
+It covers all the basics that are common to all OpenStack projects: the accounts
+you need, the basics of interacting with our Gerrit review system, how we
+communicate as a community, etc.
+
+If you want more Swift related project documentation make sure you checkout
+the Swift developer (contributor) documentation at
+https://docs.openstack.org/swift/latest/
+
 Filing a Bug
 ~~~~~~~~~~~~
 
diff -pruN 2.25.0-3/debian/account-server.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/account-server.conf
--- 2.25.0-3/debian/account-server.conf	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/account-server.conf	2020-09-15 21:14:38.000000000 +0000
@@ -0,0 +1,16 @@
+[DEFAULT]
+bind_ip = 0.0.0.0
+bind_port = 6002
+workers = 2
+
+[pipeline:main]
+pipeline = account-server
+
+[app:account-server]
+use = egg:swift#account
+
+[account-replicator]
+
+[account-auditor]
+
+[account-reaper]
diff -pruN 2.25.0-3/debian/changelog 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/changelog
--- 2.25.0-3/debian/changelog	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/changelog	2020-09-15 21:14:38.000000000 +0000
@@ -1,904 +1,1019 @@
-swift (2.25.0-3) unstable; urgency=medium
+swift (2.25.1~git2020091517.f8a9a6e11-0ubuntu1) groovy; urgency=medium
 
-  * Add py3_Work_with_proper_native_string_paths_in_crypto_meta.patch.
+  [ Chris MacNaughton ]
+  * d/control: Remove Breaks/Replaces that are older than Focal (LP: #1878419).
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 31 Aug 2020 09:47:24 +0200
+  [ Corey Bryant ]
+  * New upstream snapshot for OpenStack Victoria.
 
-swift (2.25.0-2) unstable; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Tue, 15 Sep 2020 17:14:38 -0400
 
-  * Uploading to unstable.
+swift (2.25.1~git2020073017.d6399b32e-0ubuntu1) groovy; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Fri, 12 Jun 2020 14:22:55 +0200
+  * New upstream snapshot for OpenStack Victoria.
+  * d/control, d/copyright: Update upstream URL.
 
-swift (2.25.0-1) experimental; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 30 Jul 2020 17:28:57 -0400
 
-  * New upstream release.
-  * Rebase patches.
+swift (2.25.1~git2020070613.2e001431f-0ubuntu1) groovy; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Tue, 21 Apr 2020 10:38:46 +0200
+  * New upstream snapshot for OpenStack Victoria.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/p/drop-ipaddress-requirement.patch: Dropped. No longer needed as package
+    is Python3-only.
+  * d/control, d/compat: Switch to debhelper compat 12.
+  * d/control: Update Standards-Version to 4.5.0.
 
-swift (2.24.0-1) experimental; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Mon, 06 Jul 2020 13:04:33 -0400
 
-  * New upstream release.
-  * d/patches: Rebased.
-  * Bump Standards-Version to 4.5.0.
-  * Rules-Requires-Root: no.
-  * Disable sphinxcontrib.rsvgconverter extension.
-  * d/patches/py38_cgi_lost_some_names.patch:
-    Drop, applied upstream.
-  * d/rules: Remove not needed override_dh_systemd_enable target.
+swift (2.25.0-0ubuntu3) groovy; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Fri, 13 Mar 2020 16:46:42 +0100
+  * d/t/swift-daemons: Update to give systemd units time to restart.
 
-swift (2.23.1-2) unstable; urgency=medium
+ -- Chris MacNaughton <chris.macnaughton@canonical.com>  Thu, 25 Jun 2020 11:30:03 +0000
 
-  * Add upstream patch: py38_cgi_lost_some_names.patch. (Closes: #951987).
+swift (2.25.0-0ubuntu2) groovy; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 25 Feb 2020 11:55:02 +0100
+  [ Chris MacNaughton ]
+  * Update to use Systemd unit files (LP: #1827340, LP: #1800676)
+    * d/*.init.in: Import init script (systemd) generation from Debian.
+    * d/*.upstart: Removed.
+    * d/*.init: Removed
+    * d/*.generator: Import from Debian.
+    * d/*.install: Added reference to generator files
+    * d/gen-init: Import from Debian. Remove WorkingDirectory.
 
-swift (2.23.1-1) unstable; urgency=medium
+  [ James Page ]
+  * d/control: Add sphinxdoc:Depends to swift-doc.
+  * d/*: wrap-and-sort -bast.
 
-  * New upstream release.
-  * Remove one more not needed
-    package-supports-alternative-init-but-no-init.d-script
-    lintian override.
-  * Drop Python 3 patches, applied upstream.
+ -- Chris MacNaughton <chris.macnaughton@canonical.com>  Wed, 24 Jun 2020 09:59:02 +0100
 
- -- Ondřej Nový <onovy@debian.org>  Wed, 23 Oct 2019 14:26:27 +0200
+swift (2.25.0-0ubuntu1) groovy; urgency=medium
 
-swift (2.23.0-6) unstable; urgency=medium
+  * New upstream release for OpenStack Ussuri (LP: #1877642).
 
-  * Uploading to unstable.
-  * Bump Standards-Version to 4.4.1.
-  * Remove not needed package-supports-alternative-init-but-no-init.d-script
-    lintian overrides.
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 14 May 2020 14:47:36 -0400
 
- -- Ondřej Nový <onovy@debian.org>  Mon, 21 Oct 2019 12:33:00 +0200
+swift (2.24.1~git2020041316.a495f1e32-0ubuntu1) focal; urgency=medium
 
-swift (2.23.0-5) experimental; urgency=medium
+  * d/watch: Update tarball URL to opendev.org.
+  * New upstream snapshot for OpenStack Ussuri.
 
-  * Add a number of Py3 fixes:
-    - py3_Fix_swift-drive-audit.patch
-    - py3_Fix_swift-recon.patch
-    - py3_fix_swift-dispersion-populate.patch
-    - py3_fix_swift-account-audit.patch
+ -- Corey Bryant <corey.bryant@canonical.com>  Mon, 13 Apr 2020 16:25:31 -0400
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 15 Oct 2019 16:53:21 +0200
+swift (2.24.1~git2020032711.712bf3c9f-0ubuntu2) focal; urgency=medium
 
-swift (2.23.0-4) experimental; urgency=medium
+  * d/control, d/rules: Move installation of /etc/swift/ files to
+    python3-swift package.
 
-  * Replace my old patch Fix_on-disk_encryption_under_Python_3.patch by the new
-    upstream one: Fix_kms_keymaster_under_Python_3.patch.
+ -- Corey Bryant <corey.bryant@canonical.com>  Mon, 30 Mar 2020 08:26:09 -0400
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 15 Oct 2019 03:16:37 +0200
+swift (2.24.1~git2020032711.712bf3c9f-0ubuntu1) focal; urgency=medium
 
-swift (2.23.0-3) experimental; urgency=medium
+  * New upstream snapshot for OpenStack Ussuri.
+  * d/glance-common.postinst: Set default ownership and permissions for
+    /etc/<pkg> (LP: #1859422).
 
-  * Add Fix_on-disk_encryption_under_Python_3.patch.
+ -- Corey Bryant <corey.bryant@canonical.com>  Fri, 27 Mar 2020 11:39:24 -0400
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 11 Oct 2019 14:16:53 +0200
+swift (2.24.0-0ubuntu1) focal; urgency=medium
 
-swift (2.23.0-2) experimental; urgency=medium
+  * New upstream release for OpenStack Ussuri.
 
-  * Do not use --processes=-1 when running tests, as this seems to fail on
-    buildds.
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 13 Feb 2020 14:01:08 -0500
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 07 Oct 2019 16:31:24 +0200
+swift (2.24.0~git2019121715.e890b0f0f-0ubuntu1) focal; urgency=medium
 
-swift (2.23.0-1) experimental; urgency=medium
+  * New upstream snapshot for OpenStack Ussuri.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/rules: Switch pybuild.
+  * d/rules: Update PBR_VERSION to handle ~git versioning.
+  * d/p/skip-test-local-py36.patch: Update to skip for all Py3 versions.
 
-  * New upstream release.
-  * Fixed version of eventlet in (b-)d for this release.
-  * Add  python3-barbicanclient and python3-castellan as recommends in
-    swift-proxy, as they are needed for on-disk encryption.
-  * Removed patches applied upstream:
-    - sphinx_reproducible_build.patch
-    - fix-xattr_supported_check.patch
-  * Run tests with --processes=-1 to run them in parallel.
+ -- Corey Bryant <corey.bryant@canonical.com>  Tue, 17 Dec 2019 15:16:47 -0500
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 04 Oct 2019 15:59:04 +0200
+swift (2.23.1-0ubuntu1) focal; urgency=medium
 
-swift (2.22.0-2) unstable; urgency=medium
+  * New stable point release for OpenStack Train (LP: #1853311).
 
-  * Remove swauth from Recommends.
+ -- Sahid Orentino Ferdjaoui <sahid.ferdjaoui@canonical.com>  Mon, 02 Dec 2019 15:19:23 +0100
 
- -- Ondřej Nový <onovy@debian.org>  Tue, 13 Aug 2019 10:37:49 +0200
+swift (2.23.0-0ubuntu1) eoan; urgency=medium
 
-swift (2.22.0-1) unstable; urgency=medium
+  * New upstream release for OpenStack Train.
 
-  * New upstream release.
-  * Bump Standards-Version to 4.4.0.
-  * Remove prerm/preinst scripts for upgrading from version 2.6.0-2.
-  * Add lintian overrides for
-    package-supports-alternative-init-but-no-init.d-script
-  * python3-swift.lintian-overrides: Fix wrong binary package name
-  * Use pybuild to build package.
-  * Clean using d/clean file instead of override_dh_auto_clean target.
-  * Bump debhelper compat level to 12.
-  * Cleanup systemd and init scripts generator.
+ -- Corey Bryant <corey.bryant@canonical.com>  Wed, 16 Oct 2019 11:26:04 -0400
 
- -- Ondřej Nový <onovy@debian.org>  Mon, 05 Aug 2019 19:12:51 +0200
+swift (2.22.0-0ubuntu2) eoan; urgency=medium
 
-swift (2.21.10+2019.07.13+git.4643412bd1-3) unstable; urgency=medium
+  * d/control: Add Breaks/Replaces on python-swift to ensure that
+    upgrades from py2->py3 are handled correctly (LP: #1847576).
 
-  [ Ondřej Nový ]
-  * Running wrap-and-sort -bast.
-  * Use debhelper-compat instead of debian/compat.
+ -- James Page <james.page@ubuntu.com>  Thu, 10 Oct 2019 12:04:12 +0100
 
-  [ Thomas Goirand ]
-  * Fixed python3-os-api-ref-common -> python-os-api-ref-common depends for
-    swift-doc, which was a mistake when converting to Python 3.
+swift (2.22.0-0ubuntu1) eoan; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 23 Jul 2019 18:41:54 +0200
+  * New upstream release for OpenStack Train.
 
-swift (2.21.10+2019.07.13+git.4643412bd1-2) unstable; urgency=medium
+ -- James Page <james.page@ubuntu.com>  Thu, 26 Sep 2019 15:15:04 +0100
 
-  * Uploading to unstable.
+swift (2.22.0~b2~git2019073018.d33e569be-0ubuntu1) eoan; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 17 Jul 2019 19:51:53 +0200
+  * New upstream snapshot for OpenStack Train.
+  * d/control: Align (Build-)Depends with upstream.
 
-swift (2.21.10+2019.07.13+git.4643412bd1-1) experimental; urgency=medium
+ -- Sahid Orentino Ferdjaoui <sahid.ferdjaoui@canonical.com>  Tue, 30 Jul 2019 18:52:11 +0200
 
-  * New upstream release.
-  * Switch swift to Python 3.
-  * Rebased patches.
-  * Added usr/bin/swift-container-deleter to the swift-container package.
+swift (2.22.0~b1~git2019071110.e62f07d98-0ubuntu3) eoan; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 15 Jul 2019 15:09:23 +0200
+  * d/rules: Use pkgos-dh_auto_install to install Python 3 modules.
 
-swift (2.21.0-1) experimental; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 18 Jul 2019 11:48:40 -0400
 
-  [ Michal Arbet ]
-  * d/control:
-      - Bump openstack-pkg-tools to version 99
-      - Add me to uploaders field
-  * d/copyright: Add me to copyright file
-  * New upstream version
+swift (2.22.0~b1~git2019071110.e62f07d98-0ubuntu2) eoan; urgency=medium
 
-  [ Ondřej Nový ]
-  * d/p/fix-decryption-of-object-if-metadata-is-missing.patch:
-    Remove, applied upstream
-  * Rebased patches
+  * d/control: Restore python-setuptools BDI for UCA backport.
+  * d/p/skip-test-local-py36.patch, d/control: Skip locale test for Python
+    3.6 as locale is not available by default in build environment.
 
- -- Ondřej Nový <onovy@debian.org>  Mon, 13 May 2019 12:06:24 +0200
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 11 Jul 2019 14:05:49 -0400
 
-swift (2.19.1-1) unstable; urgency=medium
+swift (2.22.0~b1~git2019071110.e62f07d98-0ubuntu1) eoan; urgency=medium
 
-  * New upstream bugfix release
+  * New upstream snapshot for OpenStack Train.
+  * d/control, d/rules, d/python(3)-swift*: Add support for Python 3
+    and remove support for Python 2.
+  * d/p/drop-ipaddress-requirement.patch: Drop ipaddress from requirements.txt.
 
- -- Ondřej Nový <onovy@debian.org>  Tue, 26 Feb 2019 11:53:35 +0100
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 11 Jul 2019 10:14:31 -0400
 
-swift (2.19.0-6) unstable; urgency=medium
+swift (2.22.0~b1~git2019061305.aa2f1db1b-0ubuntu1) eoan; urgency=medium
 
-  * Object decryption fix patch:
-    - Add a warning in the logs if path is different in
-      put_crypto_meta['key_id']['path'] and put_keys['id']['path']).
+  * New upstream snapshot for OpenStack Train.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/swift-container.install: Wildcard install of swift-container-*
+    binaries.
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 01 Feb 2019 13:38:08 +0100
+ -- James Page <james.page@ubuntu.com>  Thu, 13 Jun 2019 15:13:13 +0100
 
-swift (2.19.0-5) unstable; urgency=medium
+swift (2.21.0-0ubuntu1) disco; urgency=medium
 
-  * Fix decryption of objects that sometimes is wrong.
+  * New upstream release for OpenStack Stein.
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 24 Jan 2019 20:48:22 +0100
+ -- James Page <james.page@ubuntu.com>  Mon, 08 Apr 2019 09:13:45 +0100
 
-swift (2.19.0-3) unstable; urgency=medium
+swift (2.20.0-0ubuntu2) disco; urgency=medium
 
-  * Add Breaks of older systemd without CacheDirectory support
-  * Rename d/tests/control.autodep8 to d/tests/control.
-  * d/copyright: Bump my copyright year.
-  * Bump Standards-Version to 4.3.0 (no changes)
+  * d/control: Add python-keystonemiddleware to Depends (LP: #1815093).
 
- -- Ondřej Nový <onovy@debian.org>  Tue, 22 Jan 2019 17:41:50 +0100
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 07 Feb 2019 15:05:35 -0500
 
-swift (2.19.0-2) unstable; urgency=medium
+swift (2.20.0-0ubuntu1) disco; urgency=medium
 
-  * Uploading to unstable
-  * Bump Standards-Version to 4.2.1
+  * New upstream release for OpenStack Stein.
+  * d/control: Align (Build-)Depends with upstream.
 
- -- Ondřej Nový <onovy@debian.org>  Wed, 05 Sep 2018 12:24:08 +0200
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 31 Jan 2019 12:43:00 -0500
 
-swift (2.19.0-1) experimental; urgency=medium
+swift (2.19.0-0ubuntu1) cosmic; urgency=medium
 
-  * New upstream release
-  * d/p/syslog_log_name.patch: Rebased
-  * Add python-ipaddress to B-D and D
-  * Add swift-ring-composer CLI
+  * New upstream release.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/swift.install: Install binary for new CLI client swift-ring-composer.
 
- -- Ondřej Nový <onovy@debian.org>  Wed, 22 Aug 2018 14:30:40 +0200
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 30 Aug 2018 10:33:03 -0400
 
-swift (2.18.0-1) experimental; urgency=medium
+swift (2.18.0-0ubuntu1) cosmic; urgency=medium
 
-  * New upstream release
-  * d/p/Fix_tests_using_O_TMPFILE.patch: Drop, applied upstream
-  * d/p/syslog_log_name.patch: Rebased
-  * Fix B-D for new upstream release
-  * Add swift-object-relinker manpage
-  * Add swift-container-sharder daemon and swift-manage-shard-ranges CLI
-  * Enable autopkgtest-pkg-python testsuite
+  * New upstream release.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/swift-container.install, d/swift.install,
+    swift-container.swift-container-sharder.init: Install
+    usr/bin/swift-container-sharder and usr/bin/swift-manage-shard-ranges and
+    add init file for swift-container-sharder.
+  * d/control: Update Standards-Version to 4.1.4.
+  * d/control, d/tests/*: Drop obsolete autopkgtest header and enable
+    autopkgtest-pkg-python testsuite.
+  * d/control, d/watch: Use https URLs.
 
- -- Ondřej Nový <onovy@debian.org>  Mon, 20 Aug 2018 15:32:05 +0200
+ -- Corey Bryant <corey.bryant@canonical.com>  Wed, 13 Jun 2018 15:14:00 -0400
 
-swift (2.17.0-5) unstable; urgency=medium
+swift (2.17.0-0ubuntu1) bionic; urgency=medium
 
-  * d/tests: Use AUTOPKGTEST_TMP instead of ADTTMP
-  * d/control: Use team+openstack@tracker.debian.org as maintainer
-  * Don't use has_key, which is deprecated (Closes: #906413)
-  * Really build docs with Python 3
-  * Use LC_ALL=C.UTF-8 when building docs
-  * Use SOURCE_DATE_EPOCH in docs to make build reproducible (again)
-  * Bump standards version to 4.2.0 (no changes)
-  * Add upstream metadata
+  [ James Page ]
+  * d/p/*: Rebase.
 
- -- Ondřej Nový <onovy@debian.org>  Mon, 20 Aug 2018 11:49:41 +0200
+  [ Corey Bryant ]
+  * New upstream release candidate for OpenStack Queens.
+  * d/*: wrap-and-sort -bast.
+  * d/control: Update Standards-Version to 4.1.2.
+  * d/control: Bump debhelper compat to 10.
+  * d/control: Align (Build-)Depends with upstream.
 
-swift (2.17.0-4) unstable; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Wed, 14 Feb 2018 09:24:36 -0500
 
-  * Remove python-keystonemiddleware as runtime depends
-  * Add python-keystonemiddleware | swauth as recommends for swift-proxy
-  * d/p/Fix_tests_using_O_TMPFILE.patch: Refresh from current upstream review
+swift (2.16.0-0ubuntu2) bionic; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Tue, 13 Mar 2018 13:07:06 +0100
+  * d/rules, d/swift-doc.docs: Adjust sphinx-build command and drop
+    swift-doc.docs as the sphinx-build command already installs the files in
+    the temp directory.
 
-swift (2.17.0-3) unstable; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Wed, 22 Nov 2017 14:07:55 -0500
 
-  * Add python-keystonemiddleware as runtime depends.
-  * Removed versions when satisfied in Stretch.
-  * Removed breaks/replaces when transition is already done in Stretch.
-  * Refreshed patches.
-  * Add Fix_tests_using_O_TMPFILE.patch.
+swift (2.16.0-0ubuntu1) bionic; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 12 Mar 2018 08:58:19 +0000
+  * New upstream release.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/p/*: Rebase, drop patches accepted upstrea or no longer needed.
+  * d/compat: Bump to 9, inline with BD.
+  * d/swift.install: Drop swift-temp-url, no long shipped.
 
-swift (2.17.0-2) unstable; urgency=medium
+ -- James Page <james.page@ubuntu.com>  Fri, 17 Nov 2017 10:40:50 +0000
 
-  * Uploading to unstable
-  * d/control: Set Vcs-* to salsa.debian.org
-  * Running wrap-and-sort -bast
-  * d/copyright: Bump my copyright year
+swift (2.15.1-0ubuntu3) artful; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Tue, 27 Feb 2018 12:49:44 +0100
+  * d/p/update-test-drop-privs.patch: Drop group comparison from
+    drop_privileges test as it does not appear to be valid (LP: #1724342).
 
-swift (2.17.0-1) experimental; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Tue, 17 Oct 2017 15:01:59 -0400
 
-  * New upstream release
-  * Sync with unstable
-  * Standards-Version is 4.1.3 now (no change)
+swift (2.15.1-0ubuntu2) artful; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Fri, 09 Feb 2018 15:45:22 +0100
+  * d/p/fix-deployment-guide-header.patch: Extend deployment guide headers
+    to fix sphinx error for xenial-pike backport.
 
-swift (2.16.0-1) experimental; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Fri, 25 Aug 2017 17:57:20 -0400
 
-  * New upstream release
-  * Bump required version of python-cryptography
-  * d/patches/Be_more_tolerant_of_exception_messages_from_sqlite.patch:
-    Remove, applied upstream
-  * Rebased all patches
-  * Remove bin/swift-temp-url
+swift (2.15.1-0ubuntu1) artful; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Sat, 09 Dec 2017 22:29:12 +0100
+  * New upstream point release for OpenStack Pike.
+  * d/p/*: Rebased.
 
-swift (2.15.1-7) unstable; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 24 Aug 2017 12:29:58 -0400
 
-  * Fix wrong logrotate file
-  * Standards-Version is 4.1.2 now (no change)
+swift (2.15.0-0ubuntu1) artful; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Sun, 10 Dec 2017 10:35:18 +0100
+  * d/control: Drop oslosphinx and update min version of openstackdocstheme.
+  * New upstream release for OpenStack Pike.
+  * d/p/drop-openstackdoctheme.patch: Temporarily drop openstackdocstheme
+    sphinx extension until sphinx>=1.6.2 is available.
+  * d/p/skip-online-test.patch: Skip test that is failing without network
+    access.
+  * d/swift-object.install: Install swift-object-relinker binary.
 
-swift (2.15.1-6) unstable; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Tue, 01 Aug 2017 09:20:37 -0400
 
-  * d/swift-container-generator: Remove container-reconciler
-  * Use dh_missing --fail-missing
+swift (2.13.1-0ubuntu1) artful; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Sat, 09 Dec 2017 22:00:34 +0100
+  [ Chuck Short ]
+  * d/patches/use-pbr2.patch: Use pbr2 by default.
+  * d/patches/fix-doc-no-network.patch: Dropped not longer required.
 
-swift (2.15.1-5) unstable; urgency=medium
+  [ James Page ]
+  * New upstream point release.
 
-  * Create /var/log/swift and /var/lib/swift only during postinst
-  * Change WorkingDirectory to ~
-  * Use pkgos_var_user_group instead of pkgos_adduser in postinst
-  * Create /var/cache/swift in SysV init script
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 16 Jun 2017 11:45:54 +0100
 
- -- Ondřej Nový <onovy@debian.org>  Sat, 02 Dec 2017 19:45:07 +0100
+swift (2.13.0-0ubuntu1) zesty; urgency=medium
 
-swift (2.15.1-4) unstable; urgency=medium
+  * New upstream release for OpenStack Ocata.
+  * d/control: Align (build-)depends with upstream.
+  * d/README.Source: Removed it still mentioned bzr to package swift.
 
-  * Use tmpfiles.d, CacheDirectory and RuntimeDirectory instead of
-    ExecStartPre
-  * Set owner of /var/log/swift to root
-  * d/tests/daemon: Require isolation-container
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 16 Feb 2017 05:46:37 -0500
 
- -- Ondřej Nový <onovy@debian.org>  Sat, 02 Dec 2017 15:04:11 +0100
+swift (2.12.0-0ubuntu1) zesty; urgency=medium
 
-swift (2.15.1-3) unstable; urgency=medium
+  * New upstream version.
+  * d/p/avoid-infinite-loop-while-placing-parts.patch: Dropped. Included in
+    new upstream version.
+  * New upstream release for OpenStack Ocata.
 
-  * d/copyright: Add missing copyright holders
+ -- Corey Bryant <corey.bryant@canonical.com>  Mon, 19 Dec 2016 09:18:26 -0500
 
- -- Ondřej Nový <onovy@debian.org>  Mon, 06 Nov 2017 09:15:02 +0100
+swift (2.11.0-0ubuntu2) zesty; urgency=medium
 
-swift (2.15.1-2) unstable; urgency=medium
+  * d/p/avoid-infinite-loop-while-placing-parts.patch: Cherry-picked from
+    upstream master branch to avoid infinite loop while placing parts
+    (LP: #1642538).
 
-  * Uploading to unstable
+ -- Corey Bryant <corey.bryant@canonical.com>  Fri, 09 Dec 2016 09:05:26 -0500
 
- -- Ondřej Nový <onovy@debian.org>  Sun, 05 Nov 2017 21:12:27 +0100
+swift (2.11.0-0ubuntu1) zesty; urgency=medium
 
-swift (2.15.1-1) experimental; urgency=medium
+  [ Corey Bryant ]
+  * d/control: Align python-pyeclib with upstream.
 
-  [ Ondřej Nový ]
-  * New upstream release
-  * Bump required version of (build-)depends for new upstream release
-  * d/p/syslog_log_name.patch: rebase
-  * d/p/Be_more_tolerant_of_exception_messages_from_sqlite.patch:
-    fix sqlite error (Closes: #877298)
-  * Don't restart rsyslog in postrm/postinst, it's done by trigger
-  * d/copyright: Bump copyright years
-  * Install swift-object-relinker
-  * Install guide is now part of main docs
-  * d/control
-    - Don't depend on dh-systemd, it's not needed in new debhelper
-    - Remove deprecated ${python:Provides}
-  * Use python3-sphinx for building docs
-  * d/tests/help: Add swift-object-relinker
-  * Updating standards version to 4.1.1.
-
-  [ Daniel Baumann ]
-  * Updating vcs fields.
-  * Updating copyright format url.
-  * Updating maintainer field.
-  * Running wrap-and-sort -bast.
-  * Removing gbp.conf, not used anymore or should be specified in the
-    developers dotfiles.
-  * Correcting permissions in debian packaging files.
-
- -- Ondřej Nový <onovy@debian.org>  Tue, 31 Oct 2017 14:43:03 +0100
-
-swift (2.10.2-1) unstable; urgency=medium
-
-  * New upstream stable release
-  * Removed patches applied upstream:
-    - Quarantine_malformed_database_schema_SQLite_errors.patch
-    - For_any_part_only_one_replica_can_move_in_a_rebalance.patch
-    - FTBFS_i386.patch
-
- -- Ondřej Nový <onovy@debian.org>  Sat, 03 Jun 2017 13:35:44 +0200
-
-swift (2.10.1-3) unstable; urgency=medium
-
-  * d/patches/FTBFS_i386.patch: Fix FTBFS on i386 (Closes: #860638)
-
- -- Ondřej Nový <onovy@debian.org>  Thu, 20 Apr 2017 22:51:28 +0200
-
-swift (2.10.1-2) unstable; urgency=medium
-
-  * Don't start rsyslog during postinst/postrm if it's stopped
-  * d/tests
-    - Added Python module import test
-    - Added daemons test
-  * Added patches from upstream master:
-    - For any part only one replica can move in a rebalance
-    - Quarantine malformed database schema SQLite errors
+  [ David Della Vecchia ]
+  * New upstream release for OpenStack Ocata.
+  * d/control: Align (build-)depends with upstream.
 
- -- Ondřej Nový <onovy@debian.org>  Fri, 13 Jan 2017 10:05:12 +0100
+ -- David Della Vecchia <ddv@canonical.com>  Mon, 21 Nov 2016 09:18:15 -0500
 
-swift (2.10.1-1) unstable; urgency=medium
+swift (2.10.0-0ubuntu1) yakkety; urgency=medium
 
-  * New upstream release
-  * Bumped debhelper version to 10
+  * New upstream release for OpenStack Newton.
+  * d/control: Align (build-)depends with upstream.
 
- -- Ondřej Nový <onovy@debian.org>  Thu, 15 Dec 2016 16:11:51 +0100
+ -- Corey Bryant <corey.bryant@canonical.com>  Wed, 28 Sep 2016 14:06:46 -0400
 
-swift (2.10.0-3) unstable; urgency=medium
+swift (2.9.0-0ubuntu1) yakkety; urgency=medium
 
-  * Run swift-drive-audit cron by root
-    (needed for /var/log/kern.log reading and umount command)
+  * New upstream release for OpenStack Newton.
+  * d/control: Align (build-)depends with upstream.
 
- -- Ondřej Nový <onovy@debian.org>  Mon, 17 Oct 2016 14:40:10 +0200
+ -- Corey Bryant <corey.bryant@canonical.com>  Fri, 15 Jul 2016 08:32:18 -0400
 
-swift (2.10.0-2) unstable; urgency=medium
+swift (2.8.0-0ubuntu1) yakkety; urgency=medium
 
-  * Uploading to unstable
+  * New upstream version.
+  * d/p/drop-sphinx-git.patch: Dropped, no longer required.
+  * d/control: Bumped Standards-Version, no changes.
+  * d/swift-container.docs: Install container-sync-realms.conf sample
+    configuration file (LP: #1586483).
+  * d/swift-object.swift-object-reconstructor.{init|upstart},rules:
+    Add init and upstart configuration files for swift-object-reconstructor
+    (LP: #1522448).
 
- -- Ondřej Nový <onovy@debian.org>  Fri, 07 Oct 2016 10:33:11 +0200
+ -- James Page <james.page@ubuntu.com>  Fri, 10 Jun 2016 11:34:52 +0100
 
-swift (2.10.0-1) experimental; urgency=medium
+swift (2.7.0-0ubuntu2) xenial; urgency=medium
 
-  * New upstream release
-  * d/s/options: extend-diff-ignore of .gitreview
-  * d/control: Using OpenStack's Gerrit as VCS URLs.
-  * Bump required version of dnspython to 1.14.0
-  * Added missing manpages from upstream
+  * d/tests/swift-daemons: Set replica count for each ring to 1, resolving
+    autopkgtest failure during rebalance operations.
 
- -- Ondřej Nový <onovy@debian.org>  Thu, 29 Sep 2016 09:43:09 +0200
+ -- James Page <james.page@ubuntu.com>  Mon, 11 Apr 2016 12:21:44 +0100
 
-swift (2.9.0-2) experimental; urgency=medium
+swift (2.7.0-0ubuntu1) xenial; urgency=medium
 
-  * Rebased on 2.7.0-10
-  * Removed doctrees from doc to make build reproducible
-  * Moved swift-recon and swift-object-expirer manpages to correct binary
-    packages
-  * Moved swift-config cli to swift binary package
+  * New upstream release for OpenStack Mitaka.
+  * d/p/drop-sphinx-git.patch: Rebased.
+  * d/p/fix-doc-no-network.patch: Rebased.
 
- -- Ondřej Nový <onovy@debian.org>  Wed, 21 Sep 2016 20:57:37 +0200
+ -- David Della Vecchia <ddv@canonical.com>  Fri, 08 Apr 2016 09:02:57 -0400
 
-swift (2.9.0-1) experimental; urgency=medium
+swift (2.6.0-0ubuntu1) xenial; urgency=medium
 
-  * Rebased on 2.7.0-9
-  * New upstream release
-  * Changed (build) depends for new upstream release
-  * Build API ref and install guide documentation
-  * Added libjs-jquery, libjs-underscore and libjs-bootstrap dependency to
-    swift-doc
-  * Moved base documentation to "base" directory
+  [ David Della Vecchia ]
+  * New upstream release for OpenStack Mitaka.
+  * d/control: Align (build-)depends with upstream.
+  * d/p/pyeclib-version.patch: Removed, fixed in upstream.
+  * d/p/sphinx.patch: Remove git command to prevent build errors.
 
- -- Ondřej Nový <onovy@debian.org>  Sun, 17 Jul 2016 23:15:09 +0200
+  [ Corey Bryant ]
+  * d/p/sphinx.patch: Dropped in favor of adding git to BD's.
+  * d/control: Add git to build-depends for sphinx-build.
+  * d/control: Add python-cffi to BDs to fix failing tests.
+  * d/p/drop-sphinx-git.patch, d/control: Drop use of git from sphinx config.
 
-swift (2.8.0-2) experimental; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 10 Mar 2016 13:34:13 -0500
 
-  * Rebased on 2.7.0-7
+swift (2.5.0-0ubuntu1) wily; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Wed, 06 Jul 2016 00:35:48 +0200
+  * New upstream release for OpenStack Liberty.
+  * d/control,python-swift.postinst: Tidy lintian warning messages.
 
-swift (2.8.0-1) experimental; urgency=medium
+ -- James Page <james.page@ubuntu.com>  Thu, 08 Oct 2015 06:16:59 -0700
 
-  * New upstream release
-  * Removed build depend on git, not needed anymore
-  * Added missed example configs to docs
-  * Use dh_installdocs -A for installing AUTHORS file
+swift (2.4.0-0ubuntu1) wily; urgency=medium
 
- -- Ondřej Nový <novy@ondrej.org>  Tue, 14 Jun 2016 20:23:21 +0200
+  * New upstream release:
+    - d/p/CVE-2015-1856.patch,
+      d/p/fix-tempauth-acl-checks.patch,
+      d/p/increase-httplib-maxheaders.patch,
+      d/p/x-auth-token-should-be-bytestring.patch:
+      Dropped, included upstream.
+  * Align (build-)depends with upstream, wrap-and-sort.
+  * d/p/pyeclib-version.patch: Specify minimum bound for pyeclib only.
+  * Install new swift-object-reconstructor and swift-ring-builder-analyzer
+    binaries.
 
-swift (2.7.0-10) unstable; urgency=medium
+ -- James Page <james.page@ubuntu.com>  Mon, 07 Sep 2015 13:00:03 +0100
 
-  * Stop services first when upgrading from < 2.6.0-2 version
+swift (2.2.2-0ubuntu1.3) vivid-security; urgency=medium
 
- -- Ondřej Nový <onovy@debian.org>  Wed, 21 Sep 2016 19:34:00 +0200
+  [ Marc Deslauriers ]
+  * SECURITY UPDATE: object deletion via x-versions-location container
+    - debian/patches/CVE-2015-1856.patch: prevent unauthorized delete in
+      swift/proxy/controllers/obj.py, added tests to
+      test/functional/tests.py.
+    - CVE-2015-1856
 
-swift (2.7.0-9) unstable; urgency=medium
+  [ Jamie Strandboge ]
+  * debian/patches/x-auth-token-should-be-bytestring.patch: update for
+    functional test suite
+  * debian/patches/fix-tempauth-acl-checks.patch: fix tempauth acl checks when
+    simplejson has no speedups
+  * debian/patches/increase-httplib-maxheaders.patch: fix testuite and
+    increase httplib._MAXHEADERS
 
-  * Ignore errors when trying to restart rsyslog service in postrm too
-    (Closes: #830586)
+ -- Jamie Strandboge <jamie@ubuntu.com>  Thu, 30 Jul 2015 12:24:47 -0500
 
- -- Ondřej Nový <onovy@debian.org>  Mon, 11 Jul 2016 09:14:29 +0200
+swift (2.2.2-0ubuntu1) vivid; urgency=medium
 
-swift (2.7.0-8) unstable; urgency=medium
+  * New upstream release. 
+  * debian/patches/fixup-32bit-max-file-size.patch: Dropped no longer needed.
 
-  * Ignore errors when trying to restart rsyslog service and be more robust
+ -- Chuck Short <zulcss@ubuntu.com>  Mon, 09 Feb 2015 13:40:34 -0500
 
- -- Ondřej Nový <onovy@debian.org>  Thu, 07 Jul 2016 16:06:46 +0200
+swift (2.2.1-0ubuntu2) vivid; urgency=medium
 
-swift (2.7.0-7) unstable; urgency=medium
+  * Systemd enablement:
+    - d/*.init: Re-instate and re-write original init scripts. 
+    - d/*: Tidy incorrectly named init script files.
 
-  * Check for ring files before starting service (Closes: #829375)
-  * Remove all swift directories on purge
-  * Added missed example configs to docs
-  * Use dh_installdocs -A for installing AUTHORS file
-  * Added support for nodocs in DEB_BUILD_OPTIONS
-  * Use dh-exec for installing configs
-  * Use adm group for log directory
-  * Log to /var/log/swift and not to generic logfile
+ -- James Page <james.page@ubuntu.com>  Mon, 12 Jan 2015 10:42:51 +0000
 
- -- Ondřej Nový <onovy@debian.org>  Tue, 05 Jul 2016 23:24:04 +0200
+swift (2.2.1-0ubuntu1) vivid; urgency=medium
 
-swift (2.7.0-6) unstable; urgency=medium
+  [ Chuck Short ]
+  * Open for Vivid.
+  * d/control: Update branch locations.
 
-  * Don't add user swift to adm group
-  * d/{control,copyright}: Use my @debian.org email address
+  [ James Page ]
+  * New upstream release:
+    - d/p/*: Refresh.
+  * d/control: Bumped Standards-Version 3.9.6, no changes.
 
- -- Ondřej Nový <onovy@debian.org>  Tue, 21 Jun 2016 17:41:38 +0200
+ -- James Page <james.page@ubuntu.com>  Fri, 19 Dec 2014 14:33:19 +0000
 
-swift (2.7.0-5) unstable; urgency=medium
+swift (2.2.0-0ubuntu1) utopic; urgency=medium
 
-  * Bumped required version of python-setuptools to 20.6.8
-  * Use OSLO_PACKAGE_VERSION from openstack-pkg-tools
+  [ Corey Bryant ]
+  * New upstream release.
 
- -- Ondřej Nový <novy@ondrej.org>  Tue, 14 Jun 2016 16:59:08 +0200
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 16 Oct 2014 15:47:13 -0400
 
-swift (2.7.0-4) unstable; urgency=medium
+swift (2.2.0~rc1-0ubuntu3) utopic; urgency=medium
 
-  * Bump required openstack-pkg-tools version to 45
-  * Removed run depends on python-setuptools
-  * Removed (build-)depends on python-paste, it's satisfied by
-    python-pastedeploy
-  * Added python-keystoneclient to Build-Depends-Indep
+  * Fix autopkg tests due to upstream mandatory configuration changes:
+    - d/tests/swift-daemons,proxy-server.conf: Switch to using upstream
+      provided sample proxy server configuration, drop test specific
+      configuration.
+    - d/*.conf: Set default bind_port values inline with upstream.
 
- -- Ondřej Nový <novy@ondrej.org>  Thu, 09 Jun 2016 08:40:52 +0200
+ -- James Page <james.page@ubuntu.com>  Thu, 09 Oct 2014 11:51:59 +0100
 
-swift (2.7.0-3) unstable; urgency=medium
+swift (2.2.0~rc1-0ubuntu2) utopic; urgency=medium
 
-  * Standards-Version is 3.9.8 now (no change)
-  * Fix copyright year in documentation to make build reproducible
-  * Use pkgos includes inside postinst
-  * Sort inputs in d/rules to make build reproducible
-  * Override false-positive Lintian: spelling-error-in-copyright Thier Their
-  * Removed d/source/include-binaries, not needed anymore
-  * Change directory to $ADTTMP before running Debian tests
-  * wrap-and-sort -t -a
-  * Added Documentation to systemd units
+  * d/p/fixup-32bit-max-file-size.patch: Limit MAX_FILE_SIZE on 32bit
+    architectures during testing, fixing FTBFS on i386 builders
+    (LP: #1378810).
+  * d/p/fix-ubuntu-tests.patch: Drop, superceeded by above.
 
- -- Ondřej Nový <novy@ondrej.org>  Thu, 28 Apr 2016 21:33:07 +0200
+ -- James Page <james.page@ubuntu.com>  Thu, 09 Oct 2014 09:57:04 +0100
 
-swift (2.7.0-2) unstable; urgency=medium
+swift (2.2.0~rc1-0ubuntu1) utopic; urgency=medium
 
-  * Uploading to unstable
-  * Ignore errors when starting daemons during package install
+  * New upstream release candidate for OpenStack Juno:
+    - d/p/*: Refreshed.
 
- -- Ondřej Nový <novy@ondrej.org>  Mon, 04 Apr 2016 10:53:24 +0200
+ -- James Page <james.page@ubuntu.com>  Mon, 06 Oct 2014 15:05:01 +0100
 
-swift (2.7.0-1) experimental; urgency=medium
+swift (2.1.0-0ubuntu1) utopic; urgency=medium
 
-  * New upstream release
-  * Support of multiple conf files in /etc/swift/*-server/ directories
-  * Added dh-python build-depends
-  * Bumped python-pyeclib required version
-  * Enabled autostarting of all daemons
-
- -- Ondřej Nový <novy@ondrej.org>  Sun, 27 Mar 2016 23:24:34 +0200
-
-swift (2.6.0-2) experimental; urgency=medium
-
-  [ Ondřej Nový ]
-  * Added Debian tests.
-  * Removed swift-init.
-  * Systemd support.
-  * Added container-sync config files.
-  * Changed all dependencies to same version of swift package.
-  * Changed shell of "swift" user to /bin/false.
-  * Add user "swift" to group "adm", not replace group list.
-  * Standards-Version is 3.9.7 now (no change).
-  * Fixed Vcs URL.
+  [ Chuck Short ]
+  * debian/patches/fix-doc-no-network.patch: Refreshed.
+  * debian/control: Add python-oslosphinx as a build dependency.
 
-  [ Thomas Goirand ]
-  * Added a backups folder in /etc/swift/backups which links back to
-    /var/backups/swift.
+  [ James Page ]
+  * New upstream release for OpenStack Juno.
+  * d/copyright: Add linebreaks to fixup file-without-copyright-
+    information warning.
+
+ -- James Page <james.page@ubuntu.com>  Mon, 06 Oct 2014 10:06:11 +0100
 
- -- Ondřej Nový <novy@ondrej.org>  Wed, 02 Mar 2016 16:42:53 +0100
+swift (2.0.0-0ubuntu2) utopic; urgency=medium
 
-swift (2.6.0-1) experimental; urgency=medium
+  * Do not compress conf-sample files in the doc directories (used in
+    the autopkg tests).
 
-  [ Ondřej Nový ]
+ -- Matthias Klose <doko@ubuntu.com>  Wed, 13 Aug 2014 12:26:45 +0200
+
+swift (2.0.0-0ubuntu1) utopic; urgency=medium
 
   * New upstream release.
-  * Removed useless shlibs dependency.
-  * Watch file fixed.
-  * Removed PyEClib requirements patching.
-  * Removed simplejson dependency.
-  * Bumbed eventlet and dnspython dependency to new versions.
-  * Added python-os-testr build dependency.
-  * Added git build dependency.
-  * wrap-and-sort -t -a
-  * Removed wrong systemd unit files.
-  * Removed libjerasure2 build dependency.
+  * debian/control: Open up juno release
+  * debian/patches/ring-perms.patch: Dropped no longer needed.
+  * debian/switf-container.install: Add swift-reconciler-enqueue
+    and swift-container-reconciler.
 
-  [ Ivan Udovichenko ]
+ -- Chuck Short <zulcss@ubuntu.com>  Tue, 08 Jul 2014 10:31:47 -0400
 
-  * d/rules: Fix config location for swift-object-expirer service.
-  * d/control: Add Breaks field to swift-object-expirer package.
+swift (1.13.1-0ubuntu1) trusty; urgency=medium
 
- -- Ondřej Nový <novy@ondrej.org>  Wed, 20 Jan 2016 05:31:21 -0500
+  * New upstream release (LP: #1299055). 
 
-swift (2.5.0-2) unstable; urgency=medium
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 17 Apr 2014 04:52:50 -0400
 
-  [ Ondřej Nový ]
-  * Added cron job for drive audit.
-  * Removed python-swiftclient dependency.
-  * Added libjerasure2 build dependency.
-  * Added myself to copyright file.
-  * Fixed debian/copyright.
-  * Fixed typo in swift-container-sync upstart job.
+swift (1.13.1~rc2-0ubuntu1) trusty; urgency=medium
 
-  [ Marek Kaleta ]
-  * Moved drive audit to new package swift-drive-audit.
-  * Added myself to copyright file.
+  [ Chuck Short ]
+  * New upstream release candidate (LP: #1299055).
 
- -- Ondřej Nový <novy@ondrej.org>  Sat, 16 Jan 2016 05:05:21 -0500
+  [ James Page ]
+  * d/control: Add appropriate Breaks/Replaces to support move of man pages
+    between binary packages in 1.13.1~rc1-0ubuntu1 (LP: #1306241).
 
-swift (2.5.0-1) unstable; urgency=medium
+ -- James Page <james.page@ubuntu.com>  Mon, 14 Apr 2014 11:03:23 +0100
 
-  [ Ondřej Nový ]
-  * New upstream release.
-  * Workaround swift-init bug and send SIGKILL if SIGTERM is not successful.
-    Thanks to Petr Kuběna <petr.kubena@firma.seznam.cz>
-  * Moved same parts of init scripts to template.
-  * Allows one to change kill-interval in swift-init.
-  * man pages cleanup.
+swift (1.13.1~rc1-0ubuntu2) trusty; urgency=medium
 
-  [ Thomas Goirand ]
-  * Removed Pre-Depends on dpkg.
-  * Removed Breaks+Replaces now obsolete after the release of Jessie.
+  * d/p/ring-perms.patch: Ensure that generated rings can be read by
+    the swift user, fixing autopkgtest failure (LP: #1302700). 
+
+ -- James Page <james.page@ubuntu.com>  Sun, 06 Apr 2014 21:10:51 +0100
+
+swift (1.13.1~rc1-0ubuntu1) trusty; urgency=medium
+
+  [ Chuck Short ]
+  * Add new binaries:
+    - d/swift-container.install: Add swift-container-info binary.
+    - d/swift-account.install: Add swift-account-info binary.
+
+  [ James Page ]
+  * New upstream release candidate (LP: #1299055). 
+  * d/rules: Tidy dh_clean override.
+  * d/rules,swift-doc.docs: Re-enable documentation build.
+  * d/*.manpages: Rejig manpage installs into correct packages.
+  * d/container-server.conf: Add missing container-sync section
+    (LP: #1290813).
+  * d/*: Wrap-and-sort.
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 22 Oct 2015 20:54:44 +0000
+ -- James Page <james.page@ubuntu.com>  Fri, 04 Apr 2014 10:57:51 +0100
 
-swift (2.4.0-1) unstable; urgency=medium
+swift (1.13.0-0ubuntu1) trusty; urgency=medium
 
-  [ Ondřej Nový ]
+  [ Chuck Short ]
   * New upstream release.
-  * swift-object-reconstructor init script is correctly installed now.
-  * Fixed service name of object-expirer.
-  * Added container-sync init script.
-  * All init scripts is using swift-init.
-  * Added myself as uploader.
 
-  [ Thomas Goirand ]
-  * Adds patch-requirements.txt-to-allow-pyeclib-versions.patch.
+  [ James Page ]
+  * Add object-expirer package and associated configuration (LP: #1235495):
+    - d/control: Add swift-object-expirer package, break/replace swift-object
+      from earlier versions.
+    - d/swift-object.install: Drop install of swift-object-expirer.
+    - d/swift-object-expirer.{install,upstart}: Install swift-object-expirer
+      and associated upstart configuration.
+    - d/rules,object-expirer.conf: Provide basic object-expirer configuration.
+    - debian/swift-object-expirer.docs: Add full example configuration to docs.
+  * d/rules,swift-container.swift-container-sync.upstart: Add upstart
+    configuration for swift-container-sync process (LP: #1250171).
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 14 Sep 2015 13:21:00 +0000
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 06 Mar 2014 12:29:10 -0500
 
-swift (2.3.0-1) unstable; urgency=medium
+swift (1.12.0-0ubuntu1) trusty; urgency=medium
 
   * New upstream release.
-  * Added python-pyeclib as (build-)depends, bumped eventlet required version
-    to 0.16.1, and removed a few versions already provided by Jessie.
-  * Standards-Version is now 3.9.6.
-  * Removed applied upstream patch:
-    - CVE-2015-1856_Prevent-unauthorized-delete-in-versioned-container.patch
-  * Added usr/bin/swift-object-reconstructor to swift-object.
-  * Added startup scripts for swift-container-reconciler and
-    swift-object-reconstructor. Thanks to <ondrej.novy@firma.seznam.cz> for the
-    bug report and patch (Closes: #788450).
+  * debian/patches/fix-ubuntu-tests.patch: Rediffed.
+  * debian/rules: Add pythonpath for tests.
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 04 Jun 2015 09:49:04 +0200
+ -- Chuck Short <zulcss@ubuntu.com>  Wed, 29 Jan 2014 09:14:25 -0500
 
-swift (2.2.0-3) unstable; urgency=medium
+swift (1.11.0-0ubuntu2) trusty; urgency=low
 
-  * Fixed swift user creation (standardized on pkgos way).
+  * d/tests/swift-daemons: Use service command to restart daemons instead
+    of directly using non-existent scripts in /etc/init.d.
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 30 Jun 2015 17:03:05 +0200
+ -- James Page <james.page@ubuntu.com>  Fri, 13 Dec 2013 09:14:19 +0000
 
-swift (2.2.0-2) unstable; urgency=high
+swift (1.11.0-0ubuntu1) trusty; urgency=low
 
-  * CVE-2015-1856 & OSSA 2015-006: Unauthorized delete of versioned Swift
-    object. Applied upstream patch: Prevent unauthorized delete in versioned
-    container (Closes: #783163).
+  [ Chuck Short ]
+  * debian/control: open icehouse release.
+  * debian/rules:
+    - Fix doc installation.
+    - Removed debian distribution checking.
+  * Removed init scripts, they dont get installed anyways.
+  * Renamed upstart.in to regular upstart jobs.
+  * debian/swift-doc.docs: Drop doc/build/html.
+  * debian/swift.install: Remove swift-bench and swift-bench-client, it has
+    moved into its own project.
+  * debian/control: Suggest swift-bench.
+  * debian/fix-ubuntu-tests.patch: Disable tests that fail on buildds.
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 23 Apr 2015 09:42:47 +0200
+  [ James Page ]
+  * d/rules: Don't clean debian/*.upstart; we need those now! 
 
-swift (2.2.0-1) unstable; urgency=medium
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 12 Dec 2013 10:50:46 -0500
 
-  * New upstream release.
-  * Removed the no intersphinx patch.
+swift (1.10.0-0ubuntu1) saucy; urgency=low
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 16 Oct 2014 12:44:38 +0000
+  * New upstream release (LP: #1236462).
 
-swift (2.2.0~rc1-1) unstable; urgency=medium
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 17 Oct 2013 10:26:18 -0400
 
-  * New upstream release.
+swift (1.10.0~rc1-0ubuntu1) saucy; urgency=low
+
+  * New upstream release candidate.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Wed, 09 Oct 2013 15:05:24 -0400
+
+swift (1.9.1-0ubuntu3) saucy; urgency=low
+
+  * d/python-swift.postinst: Allow swift user to write to /var/cache/swift,
+    resolving repeated errors in swift syslog (LP: #1234657).
+
+ -- James Page <james.page@ubuntu.com>  Fri, 04 Oct 2013 16:21:14 +0100
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 08 Oct 2014 22:29:36 +0800
+swift (1.9.1-0ubuntu2) saucy; urgency=low
 
-swift (2.1.0-1) unstable; urgency=medium
+  * d/control: Add missing dependency on python-dnspython >= 1.10.0.
+  * d/control: Wrap and sort.
 
+ -- James Page <james.page@ubuntu.com>  Wed, 25 Sep 2013 16:08:35 +0100
+
+swift (1.9.1-0ubuntu1) saucy; urgency=low
+
+  [ James Page ]
+  * d/control: Update VCS fields for new branch locations.
+
+  [ Chuck Short ]
   * New upstream release.
-  * Removed CVE-2014-3497_properly_quote_www-authenticate_header_value.patch
-    applied upstream.
-  * Added new command lines into packages:
-    - usr/bin/swift-container-info
-    - usr/bin/swift-container-reconciler
-    - usr/bin/swift-reconciler-enqueue
-    - usr/bin/swift-account-info
-  * Added new package (+init script): swift-account-expirer (Closes: #760363).
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 01 Jul 2014 19:31:22 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Tue, 13 Aug 2013 10:37:13 -0400
 
-swift (1.13.1-1) unstable; urgency=high
+swift (1.9.0-0ubuntu1) saucy; urgency=low
 
+  [ Chuck Short ]
   * New upstream release.
-  * CVE-2014-3497: XSS in Swift requests through WWW-Authenticate header.
-    Appilied upstream patch properly_quote_www-authenticate_header_value.patch
-    (Closes: #752087).
+  * debian/swift.install: Add swift-config.
+  * debian/control: Nump standards version to 3.9.4
+ 
+  [ Yolanda Robla ]
+  * debian/tests: added autopkg tests
 
- -- Thomas Goirand <zigo@debian.org>  Sat, 12 Apr 2014 11:19:56 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Tue, 02 Jul 2013 10:26:07 -0500
 
-swift (1.12.0-1) unstable; urgency=medium
+swift (1.8.0-0ubuntu1) raring; urgency=low
 
-  * New upstream release (Closes: #737638).
-  * Added new (build-)dependency: python-dnspython.
-  * Removed CVE-2014-0006 patch, applied upstream.
-  * Added PYTHONPATH=. when running unit tests.
+  * New upstream release. 
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 04 Feb 2014 23:21:54 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 04 Apr 2013 10:38:18 -0500
 
-swift (1.11.0-2) unstable; urgency=high
+swift (1.8.0~rc2-0ubuntu1) raring; urgency=low
 
-  * CVE-2014-0006: Use constant time comparison in tempURL. Applied upstream
-    patch (Closes: #735582).
-  * Fix sphinx doc building.
+  * New usptream release candidate for grizzly.
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 17 Jan 2014 00:31:56 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Tue, 02 Apr 2013 09:06:48 -0500
 
-swift (1.11.0-1) unstable; urgency=medium
+swift (1.8.0~rc1-0ubuntu1) raring; urgency=low
 
-  * New upstream relase.
-  * Removed swift-bench things, since that's gone from upstream project (it's
-    moved as a separate project at https://github.com/openstack/swift-bench).
+  * New upstream release candidate for grizzly. 
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 13 Dec 2013 17:21:20 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Wed, 20 Mar 2013 08:19:17 -0500
 
-swift (1.10.0-1) unstable; urgency=low
+swift (1.7.6-0ubuntu1) raring; urgency=low
 
-  * New upstream release.
-  * Uploading to unstable.
+  *  New upstream release.
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 18 Oct 2013 01:08:31 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Mon, 28 Jan 2013 09:44:34 -0600
 
-swift (1.10.0~rc1-1) experimental; urgency=low
+swift (1.7.5-0ubuntu1) raring; urgency=low
 
   * New upstream release.
-  * Removed applied upstream patches.
+  * debian/control: Dropped python-webob.
+  * debian/swift.install: Add swift-bench-client.
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 10 Oct 2013 11:59:08 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Wed, 14 Nov 2012 12:11:47 -0600
 
-swift (1.8.0-7) unstable; urgency=low
+swift (1.7.4-0ubuntu2) quantal; urgency=low
 
-  * Added "Account Quota Correction" patch.
+  * debian/control: Conflicts/Breaks on swift 1.6.0-ubuntu1 when upgrading 
+    from precise, since the swift client has been moved to python-swiftclient.
+    (LP: #1061064)
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 26 Sep 2013 16:03:31 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 11 Oct 2012 09:06:02 -0500
 
-swift (1.8.0-6) unstable; urgency=low
+swift (1.7.4-0ubuntu1) quantal; urgency=low
 
-  [ Thomas Goirand ]
-  * Renamed all init script with .init extension in the debian folder, so it is
-    more easy to list them with ls.
-  * Added upstart scripts.
-  * Added myself and Julien in debian/copyright for the packaging, plus
-    Canonical for the upstart jobs.
-  * Removes unwanted python-webob (build-)depends (Closes: #715452).
-  * CVE-2013-4155: DoS using superfluous object tombstones. Upstream patch
-    fixes handling of DELETE obj reqs with old timestamp (Closes: #719008).
+  * New upstream release. 
+  * debian/rules: Fail to build the packages if testsuite fails.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Wed, 26 Sep 2012 09:19:43 -0500
+
+swift (1.7.2-0ubuntu1) quantal; urgency=low
 
-  [ Julien Cristau ]
-  * CVE-2013-2161: Check user input in XML responses (closes: #712202)
+  * New upstream release, this release fixes a major 
+    regression introduced in the last release.
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 28 Jun 2013 15:33:19 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 20 Sep 2012 08:42:59 -0500
 
-swift (1.8.0-5) unstable; urgency=low
+swift (1.7.0-0ubuntu1) quantal; urgency=low
 
-  * swift-account should be Breaks+Replaces: swift (<< 1.8.0-4~) to allow to
-    do backports.
-  * Added Fix-formpost-with-queries-without-user_agent.patch.
+  [ Soren Hansen ]
+  * Update debian/watch to account for symbolically named tarballs and
+    use newer URL.
+  * Run unit tests at build time.
+  * Fix Launchpad URLs in debian/watch.
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 17 Jun 2013 15:14:15 +0800
+  [ Chuck Short ]
+  * New upstream release
+  * debian/control: Add python-mock as a build dep
+  * debian/rules: Dont fail if testsuite fails.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 07 Sep 2012 19:02:36 -0500
 
-swift (1.8.0-4) unstable; urgency=low
+swift (1.6.0-0ubuntu1) quantal; urgency=low
 
-  * Corrects a mistake with the location of the account-server.conf, which
-    should have been in swift-account and not the swift package. As a
-    consequence, adds Breaks+Replaces: swift (<< 1.8.0-4) (Closes: #710916).
+  [ Adam Gandelman ]
+  * debian/patches/fix-ubuntu-unitteests.patch: Refreshed against tarball
+    generated by sdist.
+  * debian/control: Add python-swiftclient to Build-Depends.
+  * debian/swift.install: Remove swift CLI client, moved to
+    python-swiftclient.
+  * debian/patches/fix-ubuntu-unittests.patch: Dropped. Similar upstream
+    commit ensures logging exceptions are properly handled.
+  * debian/rules: *Temporarily* disable test suite.
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 04 Jun 2013 00:04:35 +0800
+  [ Chuck Short ]
+  * New upstream version.
+  * python-swift.dirs: Add /var/cache/swift
+  * debian/man/*: Removed used upstream man pages and replaced
+    with upstream manpages. (LP: #1006671)
 
-swift (1.8.0-3) unstable; urgency=low
+ -- Chuck Short <zulcss@ubuntu.com>  Tue, 07 Aug 2012 09:31:35 -0500
 
-  * Ran wrap-and-sort.
-  * Installs a default configuration file for swift-dispersion-report
-    (Closes: #668775), thanks to Loic Dachary <loic@dachary.org> for reporting.
-  * Now using upstream manpages when available.
-  * Now using upstream configuration files as default in /etc/swift
-    (Closes: #661811)
+swift (1.5.0-0ubuntu1) quantal; urgency=low
+
+  * New upstream version
+  * debian/patches/fix-ubuntu-unittests.patch: Refreshed
+  * debian/patches/fix-doc-no-network.patch: Refreshed
+  * swift.docs: Add changelog
+  * swift.install: Remove missing binaries.
+  * debian/control: Bump to version 3.9.3
+  * debian/swift.install: Add swift-temp-url and swift-form-signature.
 
- -- Thomas Goirand <zigo@debian.org>  Sat, 01 Jun 2013 19:55:10 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Mon, 18 Jun 2012 09:30:05 -0400
 
-swift (1.8.0-2) unstable; urgency=low
+swift (1.4.8-0ubuntu2) precise; urgency=low
 
-  * Upload to unstable.
-  * Updates the Allow-all-headers-requested-for-CORS.patch.
+  * debian/patches/fix-ubuntu-unittests.patch: Refreshed
+    to fix testsuite failures.
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 15 May 2013 22:32:52 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 12 Apr 2012 12:05:29 -0400
 
-swift (1.8.0-1) experimental; urgency=low
+swift (1.4.8-0ubuntu1) precise; urgency=low
 
   * New upstream release.
+  * debian/patches/fix-ubuntu-unittests.patch: Refreshed.
+  * debian/patches/fix-doc-no-network.patch: Dont access network when
+    trying to build docs.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Tue, 10 Apr 2012 09:23:54 -0400
+
+swift (1.4.7-0ubuntu3) precise; urgency=low
+
+  * debian/rules: Make the build fail if the testsuite doesnt pass.
+  * debian/patches/fix-ubuntu-unittests.patch: Various fixes to build
+    swift in the buildds. (LP: #961871)
+
+ -- Chuck Short <zulcss@ubuntu.com>  Mon, 26 Mar 2012 12:11:25 -0400
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 03 Apr 2013 20:30:31 +0800
+swift (1.4.7-0ubuntu2) precise; urgency=low
 
-swift (1.7.5-3) experimental; urgency=low
+  * Fixup upstart configurations (LP: #954477):
+    - d/rules: Correctly generate ALL upstart configurations when
+      building for Ubuntu.
+    - d/*.upstart.in: Update upstart config's to use new conf file locations.
 
+ -- James Page <james.page@ubuntu.com>  Thu, 15 Mar 2012 15:34:19 +0000
+
+swift (1.4.7-0ubuntu1) precise; urgency=low
+
+  [ Chuck Short ]
   * New upstream release.
-  * Fixed typoe dependency to python-swiftclient (and not python-swift-client).
-  * Removed patches now applied upstream.
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 03 Apr 2013 20:31:31 +0800
+  [ Thierry Carrez (ttx) ]
+  * Remove swift-stats-populate, swift-stats-report and stats.conf-sample to
+    match Swift 1.4.7 contents
 
-swift (1.7.5-2) experimental; urgency=low
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 09 Mar 2012 13:26:07 -0500
 
-  * Added missing python-swiftclient dependency in swift-account. Thanks to
-    Viktor Křivák for reporting (Closes: #703623).
-  * Adds adds Add-handler-for-CORS-actual-requests.patch.
+swift (1.4.7~20120302.1721-0ubuntu1) precise; urgency=low
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 22 Mar 2013 01:01:47 +0800
+  * New upstream release.
 
-swift (1.7.5-1) experimental; urgency=low
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 02 Mar 2012 13:27:27 -0500
 
-  [ Mehdi Abaakouk ]
-  * New upstream release
-  * Fixed -x switch issue in swift-bench
+swift (1.4.7~20120224.1690-0ubuntu1) precise; urgency=low
 
-  [ Thomas Goirand ]
-  * Fixed wrong format URL in debian/copyright.
-  * Added missing AUTHORS file in all packages.
-  * Removed useless X-Python-Version: >= 2.6 in control, since we already
-  Build-Depends: on python-all (>=2.6.6-3~).
-  * Removed \r from debian/copyright.
-  * Added missing Provides: ${python:Provides}, uses same short desc as in
-  Ubuntu, Break with versions << 1.6 (because of the python-swiftclient
-  package).
-  * Imported Ubuntu patch to stop accessing network when building docs.
-  * Fixes a log_daemon_msg typo present in most swift init scripts.
-  * Removes useless "swift is open source software" from long description.
+  [ Chuck Short ]
+  * New upstream release.
+
+  [ Chmouel Boudjnah ]
+  * Add more samples to packages (LP:#667935)
 
-  [ Julien Danjou ]
-  * Add /var/cache/swift to use swift-recon
-  * Add configuration and cron job for swift-recon
-  * Move swift-recon-cron to swift-object
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 24 Feb 2012 09:10:12 -0500
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 17 Dec 2012 15:34:54 +0000
+swift (1.4.7~20120210.1686-0ubuntu1) precise; urgency=low
 
-swift (1.4.8-2) unstable; urgency=high
+  * New upstream release.
+  * debian/control: Add python-paste.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 10 Feb 2012 09:41:51 -0500
+
+swift (1.4.6~20120202.1676-0ubuntu1) precise; urgency=low
+
+  * New upstream version.
 
-  * CVE-2012-4406: Do not use pickle for serialization in memcache, but JSON
-  (Closes: #686812).
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 03 Feb 2012 09:35:18 -0500
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 06 Sep 2012 08:40:18 +0000
+swift (1.4.6~20120119.1666-0ubuntu2) precise; urgency=low
 
-swift (1.4.8-1) unstable; urgency=low
+  * Update swift.install to reflect release.
 
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 26 Jan 2012 09:05:51 -0500
+
+swift (1.4.6~20120119.1666-0ubuntu1) precise; urgency=low
+
+  [Chuck Short]
   * New upstream release.
 
- -- Ghe Rivero <ghe.rivero@stackops.com>  Fri, 23 Mar 2012 08:09:54 +0100
+  [ Daniel T Chen ]
+  * debian/control: Fix Vcs entries.
+  * debian/swift.install: Add new scripts. Fixes FTBFS.
 
-swift (1.4.6-1) unstable; urgency=low
+  [ Marc Cluet ]
+  * Changed swift-proxy upstart script to watch /etc/swift/proxy-server.conf
+    (LP:#917893)
 
-  * New upstream release
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 20 Jan 2012 13:20:46 -0500
+
+swift (1.4.6~20120112.1660-0ubuntu1) precise; urgency=low
+
+  [Chuck Short]
+  * New upstream release.
+  * Merged changes from upstream packaging, thanks to Thierry Carrez.
+  * debian/rules:
+    + Remove egg-info on clean.
+
+  [Thierry Carrez (ttx)]
+  * Added usr/bin/swift-recon[-cron] to swift package.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Mon, 09 Jan 2012 11:26:25 -0500
+
+swift (1.4.5~20111202.1634-0ubuntu3) precise; urgency=low
+
+  * debian/swift.manpages: Remove swauth man pages.
+
+ -- Matthias Klose <doko@ubuntu.com>  Wed, 21 Dec 2011 18:29:35 +0100
+
+swift (1.4.5~20111202.1634-0ubuntu2) precise; urgency=low
 
- -- Ghe Rivero <ghe.rivero@stackops.com>  Mon, 13 Feb 2012 11:28:38 +0100
+  [ Chuck Short ]
+  * Drop swauth man pages. (LP: #900888)
+  * debian/control:
+    - Clean up build depends.
+    - Update VCS info to point to the right branches.
+  * debian/rules: Run the swift testsuite.
+  * debian/python-swift.postinst: Change user's shell to /bin/false.
+  * Fix some lintian warnings.
 
-swift (1.4.5-1) unstable; urgency=low
+  [ Thierry Carrez (ttx) ]
+  * Ship swift-oldies and swift-orphans in swift package
+
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 16 Dec 2011 09:45:28 -0500
+
+swift (1.4.5~20111202.1634-0ubuntu1) precise; urgency=low
+
+  * New upstream release.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 02 Dec 2011 09:49:32 -0500
+
+swift (1.4.5~20111117.1632-0ubuntu1) precise; urgency=low
 
   * New upstream release.
+  * Convert init scripts to upstart.
 
- -- Ghe Rivero <ghe@debian.org>  Mon, 09 Jan 2012 16:18:17 +0100
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 18 Nov 2011 13:25:16 -0500
 
-swift (1.4.4+git145-g89ef1f4-1) experimental; urgency=low
+swift (1.4.4~20111108.1612-0ubuntu1) precise; urgency=low
 
-  * New snapshot release.
+  * New upstream release.
+  * debian/rules: Add --fail-missing.
+  * Update .isntall files. (LP: #882679, #841853)
 
- -- Ghe Rivero <ghe@debian.org>  Wed, 04 Jan 2012 09:56:14 +0100
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 11 Nov 2011 10:49:12 -0500
 
-swift (1.4.4+git135-g913cfcf-1) experimental; urgency=low
+swift (1.4.4~20111014.1599-0ubuntu1) precise; urgency=low
 
-  * New snapshot release.
+  * New upstream verison.
+  * Dropped:
+    - debian/patches/backport-change-swift-ring-builder-exit-codes.
 
- -- Ghe Rivero <ghe@debian.org>  Wed, 28 Dec 2011 08:35:37 +0100
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 21 Oct 2011 13:50:47 -0400
 
-swift (1.4.4-2) unstable; urgency=low
+swift (1.4.3-0ubuntu2) oneiric; urgency=low
 
-  * Do not install test (Closes: #649908)
+  [ Adam Gandelman ]
+  * debian/patches/backport-change-swift-ring-builder-exit-codes: Standardize
+    exit codes now to reduce hassles after future upgrades (LP: #836922)
 
- -- Julien Danjou <acid@debian.org>  Mon, 19 Dec 2011 14:02:51 +0100
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 30 Sep 2011 15:00:26 -0400
 
-swift (1.4.4-1) unstable; urgency=low
+swift (1.4.3-0ubuntu1) oneiric; urgency=low
 
+  [Chuck Short]
   * New upstream release.
-  * Remove useless provides in control.
 
- -- Julien Danjou <acid@debian.org>  Thu, 24 Nov 2011 17:17:46 +0100
+  [Monty Taylor]
+  * Work around dh_python2 for lucid. (LP: #848971)
 
-swift (1.4.3-1) unstable; urgency=low
+ -- Monty Taylor <mordred@inaugust.com>  Fri, 16 Sep 2011 15:40:19 -0400
 
-  * [984c1f2] Imported Upstream version 1.4.3
-     - Closes: #629998  no more st binary
-  * Some package cleanup and sync with ubuntu pkg
+swift (1.4.3~20110902.354-0ubuntu1) oneiric; urgency=low
 
- -- Ghe Rivero <ghe@debian.org>  Tue, 08 Nov 2011 08:25:40 +0100
+  * New upstream release.
 
-swift (1.3.0-1) unstable; urgency=low
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 02 Sep 2011 14:10:27 -0400
+
+swift (1.4.3~20110823.347-0ubuntu1) oneiric; urgency=low
+
+  * New upstream release.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 26 Aug 2011 14:11:09 -0400
+
+swift (1.4.3~20110811.341-0ubuntu1) oneiric; urgency=low
+
+  * New upstream release.
 
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 12 Aug 2011 05:33:16 -0400
+
+swift (1.4.3~20110728.333-0ubuntu1) UNRELEASED; urgency=low
+
+  [ Soren Hansen ]
+  * New upstream snapshot.
+  * Remove debian-changes patch file.
+  * Remove SOURCES.txt in clean target to avoid gettings its changes in
+    our diff.gz.
+  * Add "status" support to all init scripts.
+  * Use "shutdown" instead of "stop" as the action argument for swift-
+    init. This shuts down the services gracefully (letting live requests
+    finish).
+  * Add swift-dispersion-{report,populate} to swift.install.
+
+  [ Thomas Goirand ]
   * Added missing adduser and lsb-base dependency.
   * Made the long description longer (it was really minimalistic).
   * Reworked all Debian init.d scripts.
   * Added many missing manpages.
   * Added default container-server.conf & object-server.conf files.
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 10 May 2011 09:24:33 +0000
+  [ James Page ]
+  * Added debian/python-swift.postrm:  Remove swift user when purging
+    package (LP: #825670).
+
+ -- James Page <james.page@ubuntu.com>  Tue, 16 Aug 2011 10:33:00 +0100
+
+swift (1.4.2-0ubuntu1) oneiric; urgency=low
+
+  * New upstream release.
+  * debian/control:
+    - Update vcs infomration.
+    - Cleaned up build dependencies.
+    - Bump standards to version 3.9.2.
+  * debian/README.Source: Add doc to upload swift to the ubuntu archive.
+  * dh_python2 transition.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 28 Jul 2011 10:39:51 -0400
+
+swift (1.4.2~20110624.319-0ubuntu3) oneiric; urgency=low
+
+  * Clean up missing files.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Mon, 27 Jun 2011 06:30:51 -0400
+
+swift (1.4.2~20110624.319-0ubuntu2) oneiric; urgency=low
+
+  * New upstream release.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 24 Jun 2011 14:00:18 -0400
+
+swift (1.4.1-0ubuntu1) oneiric; urgency=low
+
+  * New upstream release.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Mon, 20 Jun 2011 13:08:04 -0400
+
+swift (1.4.1~20110615.r304-0ubuntu1) oneiric; urgency=low
+
+  [ Gregory Holt ]
+  * Removed swauth references.
+
+  [ Soren Hansen ]
+  * st was renamed to swift.
+
+  [ Chuck Short ]
+  * New upstream release.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 16 Jun 2011 09:25:37 -0400
+
+swift (1.4-dev+bzr300-0ubuntu1) oneiric; urgency=low
+
+  * New upstream release.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Tue, 31 May 2011 14:29:10 -0400
 
 swift (1.3.0-0ubuntu1) natty; urgency=low
 
diff -pruN 2.25.0-3/debian/clean 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/clean
--- 2.25.0-3/debian/clean	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/clean	1970-01-01 00:00:00.000000000 +0000
@@ -1,4 +0,0 @@
-debian/*.upstart
-debian/*.init
-debian/*.service
-debian/python3-swift.postinst
diff -pruN 2.25.0-3/debian/container-server.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/container-server.conf
--- 2.25.0-3/debian/container-server.conf	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/container-server.conf	2020-09-15 21:14:38.000000000 +0000
@@ -0,0 +1,18 @@
+[DEFAULT]
+bind_ip = 0.0.0.0
+bind_port = 6001
+workers = 2
+
+[pipeline:main]
+pipeline = container-server
+
+[app:container-server]
+use = egg:swift#container
+
+[container-replicator]
+
+[container-updater]
+
+[container-auditor]
+
+[container-sync]
diff -pruN 2.25.0-3/debian/control 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/control
--- 2.25.0-3/debian/control	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/control	2020-09-15 21:14:38.000000000 +0000
@@ -1,90 +1,108 @@
 Source: swift
 Section: net
 Priority: optional
-Maintainer: Debian OpenStack <team+openstack@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Soren Hansen <soren@ubuntu.com>
 Uploaders:
+ Monty Taylor <mordred@inaugust.com>,
+ Greg Holt <gholt@rackspace.com>,
+ Jay Payne <letterj@racklabs.com>,
+ Michael Barton <michael.barton@rackspace.com>,
  Thomas Goirand <zigo@debian.org>,
- Michal Arbet <michal.arbet@ultimum.io>,
- Ondřej Nový <onovy@debian.org>,
+ David Della Vecchia <ddv@canonical.com>,
 Build-Depends:
  debhelper-compat (= 12),
- dh-exec,
  dh-python,
- openstack-pkg-tools (>= 99~),
+ openstack-pkg-tools,
  python3-all,
  python3-pbr,
  python3-setuptools,
- python3-sphinx (>= 1.6.2),
+ python3-sphinx (>= 2.0.0),
 Build-Depends-Indep:
- python3-boto,
- python3-boto3,
- python3-coverage,
- python3-cryptography,
- python3-dnspython,
+ libjerasure2,
+ python3-bandit (>= 1.1.0),
+ python3-boto (>= 2.32.1),
+ python3-boto3 (>= 1.9),
+ python3-botocore (>= 1.12),
+ python3-cffi,
+ python3-coverage (>= 3.6),
+ python3-cryptography (>= 2.0.2),
+ python3-dnspython (>= 1.15.0),
+ python3-docutils (>= 0.11),
  python3-eventlet (>= 0.25.0),
  python3-fixtures (>= 3.0.0),
- python3-greenlet,
- python3-keystoneclient,
+ python3-greenlet (>= 0.4.10),
+ python3-hacking (>= 0.11.0),
+ python3-keystoneclient (>= 1:2.0.0),
  python3-keystonemiddleware (>= 4.17.0),
- python3-lxml,
- python3-mock,
- python3-netifaces,
- python3-nose,
- python3-nose-exclude,
- python3-nosehtmloutput,
- python3-nosexcover,
- python3-openssl,
- python3-openstack.nose-plugin,
- python3-openstackclient,
- python3-openstackdocstheme (>= 1.11.0),
+ python3-lxml (>= 3.4.1),
+ python3-mock (>= 2.0),
+ python3-netifaces (>= 0.8),
+ python3-nose (>= 1.3.7),
+ python3-nosehtmloutput (>= 0.0.3),
+ python3-nosexcover (>= 1.0.10),
+ python3-openstackclient (>= 3.12.0),
+ python3-openstackdocstheme (>= 2.2.1),
  python3-os-api-ref (>= 1.0.0),
  python3-os-testr (>= 0.8.0),
- python3-oslosphinx,
- python3-pastedeploy,
- python3-pyeclib,
+ python3-pastedeploy (>= 1.3.3),
+ python3-pyeclib (>= 1.3.1),
  python3-requests (>= 2.14.2),
  python3-requests-mock (>= 1.2.0),
- python3-six,
- python3-swiftclient,
- python3-xattr,
+ python3-six (>= 1.10.0),
+ python3-sphinxcontrib.svg2pdfconverter (>= 0.1.0),
+ python3-swiftclient (>= 1:3.2.0),
+ python3-testtools,
+ python3-xattr (>= 0.4),
 Standards-Version: 4.5.0
-Vcs-Browser: https://salsa.debian.org/openstack-team/services/swift
-Vcs-Git: https://salsa.debian.org/openstack-team/services/swift.git
-Homepage: https://github.com/openstack/swift
+Vcs-Browser: https://git.launchpad.net/~ubuntu-server-dev/ubuntu/+source/swift
+Vcs-Git: https://git.launchpad.net/~ubuntu-server-dev/ubuntu/+source/swift
+Homepage: https://opendev.org/openstack/swift
 Testsuite: autopkgtest-pkg-python
-Rules-Requires-Root: no
 
 Package: python3-swift
 Architecture: all
 Section: python
-Pre-Depends:
- ${misc:Pre-Depends},
 Depends:
  adduser,
- python3-cryptography,
- python3-dnspython,
+ libjerasure2,
+ python3-cryptography (>= 2.0.2),
+ python3-dnspython (>= 1.15.0),
  python3-eventlet (>= 0.25.0),
- python3-greenlet,
- python3-netifaces,
- python3-openssl,
- python3-pastedeploy,
- python3-pyeclib,
- python3-six,
- python3-xattr,
+ python3-greenlet (>= 0.4.10),
+ python3-keystonemiddleware (>= 4.17.0),
+ python3-lxml (>= 3.4.1),
+ python3-netifaces (>= 0.8),
+ python3-pastedeploy (>= 1.3.3),
+ python3-pyeclib (>= 1.3.1),
+ python3-requests (>= 2.14.2),
+ python3-six (>= 1.10.0),
+ python3-xattr (>= 0.4),
  ${misc:Depends},
  ${python3:Depends},
+Provides:
+ ${python3:Provides},
 Breaks:
- systemd (<< 235~),
+ swift-account (<< 2.24.1~git2020032711.712bf3c9f-0ubuntu2~),
+ swift-container (<< 2.24.1~git2020032711.712bf3c9f-0ubuntu2~),
+ swift-object (<< 2.24.1~git2020032711.712bf3c9f-0ubuntu2~),
+ swift-object-expirer (<< 2.24.1~git2020032711.712bf3c9f-0ubuntu2~),
+Replaces:
+ python-swift (<< 2.22.0~b1~git2019071110.e62f07d98-0ubuntu1~),
+ swift-account (<< 2.24.1~git2020032711.712bf3c9f-0ubuntu2~),
+ swift-container (<< 2.24.1~git2020032711.712bf3c9f-0ubuntu2~),
+ swift-object (<< 2.24.1~git2020032711.712bf3c9f-0ubuntu2~),
+ swift-object-expirer (<< 2.24.1~git2020032711.712bf3c9f-0ubuntu2~),
 Description: distributed virtual object store - Python 3 libraries
- OpenStack Object Storage (code-named Swift) creates redundant, scalable object
- storage using clusters of standardized servers to store petabytes of
- accessible data. It is not a file system or real-time data storage system, but
- rather a long-term storage system for a more permanent type of static data
- that can be retrieved, leveraged, and then updated if necessary. Primary
- examples of data that best fit this type of storage model are virtual machine
- images, photo storage, email storage and backup archiving. Having no central
- "brain" or master point of control provides greater scalability, redundancy
- and permanence.
+ OpenStack Object Storage (code-named Swift) is open source software for
+ creating redundant, scalable object storage using clusters of standardized
+ servers to store petabytes of accessible data. It is not a file system or
+ real-time data storage system, but rather a long-term storage system for a
+ more permanent type of static data that can be retrieved, leveraged, and then
+ updated if necessary. Primary examples of data that best fit this type of
+ storage model are virtual machine images, photo storage, email storage and
+ backup archiving. Having no central "brain" or master point of control
+ provides greater scalability, redundancy and permanence.
  .
  Objects are written to multiple hardware devices in the data center, with
  the OpenStack software responsible for ensuring data replication and
@@ -100,24 +118,25 @@ Description: distributed virtual object
 
 Package: swift
 Architecture: all
-Pre-Depends:
- ${misc:Pre-Depends},
 Depends:
- logrotate,
  python3-swift (=${binary:Version}),
- rsyslog,
  ${misc:Depends},
  ${python3:Depends},
+ ${shlibs:Depends},
+Provides:
+ ${python3:Provides},
+Suggests:
+ swift-bench,
 Description: distributed virtual object store - common files
- OpenStack Object Storage (code-named Swift) creates redundant, scalable object
- storage using clusters of standardized servers to store petabytes of
- accessible data. It is not a file system or real-time data storage system, but
- rather a long-term storage system for a more permanent type of static data
- that can be retrieved, leveraged, and then updated if necessary. Primary
- examples of data that best fit this type of storage model are virtual machine
- images, photo storage, email storage and backup archiving. Having no central
- "brain" or master point of control provides greater scalability, redundancy
- and permanence.
+ OpenStack Object Storage (code-named Swift) is open source software for
+ creating redundant, scalable object storage using clusters of standardized
+ servers to store petabytes of accessible data. It is not a file system or
+ real-time data storage system, but rather a long-term storage system for a
+ more permanent type of static data that can be retrieved, leveraged, and then
+ updated if necessary. Primary examples of data that best fit this type of
+ storage model are virtual machine images, photo storage, email storage and
+ backup archiving. Having no central "brain" or master point of control
+ provides greater scalability, redundancy and permanence.
  .
  Objects are written to multiple hardware devices in the data center, with
  the OpenStack software responsible for ensuring data replication and
@@ -132,27 +151,24 @@ Description: distributed virtual object
 
 Package: swift-account
 Architecture: all
-Pre-Depends:
- ${misc:Pre-Depends},
 Depends:
- lsb-base,
  python3-swift (=${binary:Version}),
  rsync,
- swift (=${binary:Version}),
  ${misc:Depends},
  ${python3:Depends},
-Recommends:
- swift-drive-audit,
+ ${shlibs:Depends},
+Provides:
+ ${python3:Provides},
 Description: distributed virtual object store - account server
- OpenStack Object Storage (code-named Swift) creates redundant, scalable object
- storage using clusters of standardized servers to store petabytes of
- accessible data. It is not a file system or real-time data storage system, but
- rather a long-term storage system for a more permanent type of static data
- that can be retrieved, leveraged, and then updated if necessary. Primary
- examples of data that best fit this type of storage model are virtual machine
- images, photo storage, email storage and backup archiving. Having no central
- "brain" or master point of control provides greater scalability, redundancy
- and permanence.
+ OpenStack Object Storage (code-named Swift) is open source software for
+ creating redundant, scalable object storage using clusters of standardized
+ servers to store petabytes of accessible data. It is not a file system or
+ real-time data storage system, but rather a long-term storage system for a
+ more permanent type of static data that can be retrieved, leveraged, and then
+ updated if necessary. Primary examples of data that best fit this type of
+ storage model are virtual machine images, photo storage, email storage and
+ backup archiving. Having no central "brain" or master point of control
+ provides greater scalability, redundancy and permanence.
  .
  Objects are written to multiple hardware devices in the data center, with
  the OpenStack software responsible for ensuring data replication and
@@ -167,27 +183,24 @@ Description: distributed virtual object
 
 Package: swift-container
 Architecture: all
-Pre-Depends:
- ${misc:Pre-Depends},
 Depends:
- lsb-base,
  python3-swift (=${binary:Version}),
  rsync,
- swift (=${binary:Version}),
  ${misc:Depends},
  ${python3:Depends},
-Recommends:
- swift-drive-audit,
+ ${shlibs:Depends},
+Provides:
+ ${python3:Provides},
 Description: distributed virtual object store - container server
- OpenStack Object Storage (code-named Swift) creates redundant, scalable object
- storage using clusters of standardized servers to store petabytes of
- accessible data. It is not a file system or real-time data storage system, but
- rather a long-term storage system for a more permanent type of static data
- that can be retrieved, leveraged, and then updated if necessary. Primary
- examples of data that best fit this type of storage model are virtual machine
- images, photo storage, email storage and backup archiving. Having no central
- "brain" or master point of control provides greater scalability, redundancy
- and permanence.
+ OpenStack Object Storage (code-named Swift) is open source software for
+ creating redundant, scalable object storage using clusters of standardized
+ servers to store petabytes of accessible data. It is not a file system or
+ real-time data storage system, but rather a long-term storage system for a
+ more permanent type of static data that can be retrieved, leveraged, and then
+ updated if necessary. Primary examples of data that best fit this type of
+ storage model are virtual machine images, photo storage, email storage and
+ backup archiving. Having no central "brain" or master point of control
+ provides greater scalability, redundancy and permanence.
  .
  Objects are written to multiple hardware devices in the data center, with
  the OpenStack software responsible for ensuring data replication and
@@ -203,25 +216,20 @@ Description: distributed virtual object
 Package: swift-doc
 Architecture: all
 Section: doc
-Pre-Depends:
- ${misc:Pre-Depends},
 Depends:
- libjs-bootstrap,
  libjs-jquery,
- libjs-underscore,
- python-os-api-ref-common,
  ${misc:Depends},
  ${sphinxdoc:Depends},
 Description: distributed virtual object store - documentation
- OpenStack Object Storage (code-named Swift) creates redundant, scalable object
- storage using clusters of standardized servers to store petabytes of
- accessible data. It is not a file system or real-time data storage system, but
- rather a long-term storage system for a more permanent type of static data
- that can be retrieved, leveraged, and then updated if necessary. Primary
- examples of data that best fit this type of storage model are virtual machine
- images, photo storage, email storage and backup archiving. Having no central
- "brain" or master point of control provides greater scalability, redundancy
- and permanence.
+ OpenStack Object Storage (code-named Swift) is open source software for
+ creating redundant, scalable object storage using clusters of standardized
+ servers to store petabytes of accessible data. It is not a file system or
+ real-time data storage system, but rather a long-term storage system for a
+ more permanent type of static data that can be retrieved, leveraged, and then
+ updated if necessary. Primary examples of data that best fit this type of
+ storage model are virtual machine images, photo storage, email storage and
+ backup archiving. Having no central "brain" or master point of control
+ provides greater scalability, redundancy and permanence.
  .
  Objects are written to multiple hardware devices in the data center, with
  the OpenStack software responsible for ensuring data replication and
@@ -234,60 +242,26 @@ Description: distributed virtual object
  .
  This package provides the Sphinx generated documentation for Swift.
 
-Package: swift-drive-audit
-Architecture: all
-Pre-Depends:
- ${misc:Pre-Depends},
-Depends:
- python3-swift (=${binary:Version}),
- swift (=${binary:Version}),
- ${misc:Depends},
- ${python3:Depends},
-Description: distributed virtual object store - drive audit
- OpenStack Object Storage (code-named Swift) creates redundant, scalable object
- storage using clusters of standardized servers to store petabytes of
- accessible data. It is not a file system or real-time data storage system, but
- rather a long-term storage system for a more permanent type of static data
- that can be retrieved, leveraged, and then updated if necessary. Primary
- examples of data that best fit this type of storage model are virtual machine
- images, photo storage, email storage and backup archiving. Having no central
- "brain" or master point of control provides greater scalability, redundancy
- and permanence.
- .
- Objects are written to multiple hardware devices in the data center, with
- the OpenStack software responsible for ensuring data replication and
- integrity across the cluster. Storage clusters can scale horizontally by
- adding new nodes. Should a node fail, OpenStack works to replicate its
- content from other active nodes. Because OpenStack uses software logic to
- ensure data replication and distribution across different devices,
- inexpensive commodity hard drives and servers can be used in lieu of more
- expensive equipment.
- .
- This package provides the swift drive audit tool.
-
 Package: swift-object
 Architecture: all
-Pre-Depends:
- ${misc:Pre-Depends},
 Depends:
- lsb-base,
  python3-swift (=${binary:Version}),
  rsync,
- swift (=${binary:Version}),
  ${misc:Depends},
  ${python3:Depends},
-Recommends:
- swift-drive-audit,
+ ${shlibs:Depends},
+Provides:
+ ${python3:Provides},
 Description: distributed virtual object store - object server
- OpenStack Object Storage (code-named Swift) creates redundant, scalable object
- storage using clusters of standardized servers to store petabytes of
- accessible data. It is not a file system or real-time data storage system, but
- rather a long-term storage system for a more permanent type of static data
- that can be retrieved, leveraged, and then updated if necessary. Primary
- examples of data that best fit this type of storage model are virtual machine
- images, photo storage, email storage and backup archiving. Having no central
- "brain" or master point of control provides greater scalability, redundancy
- and permanence.
+ OpenStack Object Storage (code-named Swift) is open source software for
+ creating redundant, scalable object storage using clusters of standardized
+ servers to store petabytes of accessible data. It is not a file system or
+ real-time data storage system, but rather a long-term storage system for a
+ more permanent type of static data that can be retrieved, leveraged, and then
+ updated if necessary. Primary examples of data that best fit this type of
+ storage model are virtual machine images, photo storage, email storage and
+ backup archiving. Having no central "brain" or master point of control
+ provides greater scalability, redundancy and permanence.
  .
  Objects are written to multiple hardware devices in the data center, with
  the OpenStack software responsible for ensuring data replication and
@@ -302,25 +276,23 @@ Description: distributed virtual object
 
 Package: swift-object-expirer
 Architecture: all
-Pre-Depends:
- ${misc:Pre-Depends},
 Depends:
- lsb-base (>= 3.0-6),
  python3-swift (=${binary:Version}),
- rsync,
- swift (=${binary:Version}),
  ${misc:Depends},
  ${python3:Depends},
-Description: distributed virtual object store - object-expirer
- OpenStack Object Storage (code-named Swift) creates redundant, scalable object
- storage using clusters of standardized servers to store petabytes of
- accessible data. It is not a file system or real-time data storage system, but
- rather a long-term storage system for a more permanent type of static data
- that can be retrieved, leveraged, and then updated if necessary. Primary
- examples of data that best fit this type of storage model are virtual machine
- images, photo storage, email storage and backup archiving. Having no central
- "brain" or master point of control provides greater scalability, redundancy
- and permanence.
+ ${shlibs:Depends},
+Provides:
+ ${python3:Provides},
+Description: distributed virtual object store - object expirer
+ OpenStack Object Storage (code-named Swift) is open source software for
+ creating redundant, scalable object storage using clusters of standardized
+ servers to store petabytes of accessible data. It is not a file system or
+ real-time data storage system, but rather a long-term storage system for a
+ more permanent type of static data that can be retrieved, leveraged, and then
+ updated if necessary. Primary examples of data that best fit this type of
+ storage model are virtual machine images, photo storage, email storage and
+ backup archiving. Having no central "brain" or master point of control
+ provides greater scalability, redundancy and permanence.
  .
  Objects are written to multiple hardware devices in the data center, with
  the OpenStack software responsible for ensuring data replication and
@@ -331,34 +303,28 @@ Description: distributed virtual object
  inexpensive commodity hard drives and servers can be used in lieu of more
  expensive equipment.
  .
- This package provides the swift object expirer daemon. Only a single instance
- of this daemon is needed for a given swift cluster, which is why it is
- packaged separately.
+ This package provides the object-expirer service that provides scheduled
+ deletion of objects in Swift.
 
 Package: swift-proxy
 Architecture: all
-Pre-Depends:
- ${misc:Pre-Depends},
 Depends:
- lsb-base,
  python3-swift (=${binary:Version}),
- swift (=${binary:Version}),
  ${misc:Depends},
  ${python3:Depends},
-Recommends:
- python3-barbicanclient,
- python3-castellan,
- python3-keystonemiddleware,
+ ${shlibs:Depends},
+Provides:
+ ${python3:Provides},
 Description: distributed virtual object store - proxy server
- OpenStack Object Storage (code-named Swift) creates redundant, scalable object
- storage using clusters of standardized servers to store petabytes of
- accessible data. It is not a file system or real-time data storage system, but
- rather a long-term storage system for a more permanent type of static data
- that can be retrieved, leveraged, and then updated if necessary. Primary
- examples of data that best fit this type of storage model are virtual machine
- images, photo storage, email storage and backup archiving. Having no central
- "brain" or master point of control provides greater scalability, redundancy
- and permanence.
+ OpenStack Object Storage (code-named Swift) is open source software for
+ creating redundant, scalable object storage using clusters of standardized
+ servers to store petabytes of accessible data. It is not a file system or
+ real-time data storage system, but rather a long-term storage system for a
+ more permanent type of static data that can be retrieved, leveraged, and then
+ updated if necessary. Primary examples of data that best fit this type of
+ storage model are virtual machine images, photo storage, email storage and
+ backup archiving. Having no central "brain" or master point of control
+ provides greater scalability, redundancy and permanence.
  .
  Objects are written to multiple hardware devices in the data center, with
  the OpenStack software responsible for ensuring data replication and
diff -pruN 2.25.0-3/debian/copyright 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/copyright
--- 2.25.0-3/debian/copyright	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/copyright	2020-09-15 21:14:38.000000000 +0000
@@ -1,72 +1,9 @@
-Format: https://www.debian.org/doc/packaging-manuals/copyright-format/1.0/
+Format: http://dep.debian.net/deps/dep5
 Upstream-Name: swift
-Source: https://code.launchpad.net/swift
+Source: https://opendev.org/openstack/swift
 
 Files: *
-Copyright: (c) 2010-2017, See AUTHORS file
-           (c) 2013 Hewlett-Packard Development Company, L.P.
-           (c) 2010-2017 OpenStack Foundation
-License: Apache-2
-
-Files: debian/*
-Copyright: (c) 2010-2017, Thomas Goirand <zigo@debian.org>
-           (c) 2010-2012, Julien Danjou <acid@debian.org>
-           (c) 2015-2019, Ondřej Nový <onovy@debian.org>
-           (c) 2016, Marek Kaleta <marek.kaleta@firma.seznam.cz>
-           (c) 2019, Michal Arbet <michal.arbet@ultimum.io>
-License: Apache-2
-
-Files: swift/common/middleware/tempurl.py
-Copyright: (c) 2011-2014 Greg Holt
-           (c) 2012-2013 John Dickinson
-           (c) 2012 Felipe Reyes
-           (c) 2012 Peter Portante
-           (c) 2012 Victor Rodionov
-           (c) 2013-2014 Samuel Merritt
-           (c) 2013 Chuck Thier
-           (c) 2013 David Goetz
-           (c) 2013 Dirk Mueller
-           (c) 2013 Donagh McCabe
-           (c) 2013 Fabien Boucher
-           (c) 2013 Greg Lange
-           (c) 2013 Kun Huang
-           (c) 2013 Richard Hawkins
-           (c) 2013 Tong Li
-           (c) 2013 ZhiQiang Fan
-License: Apache-2
-
-Files: test/unit/common/middleware/test_tempurl.py
-Copyright: (c) 2011-2014 Greg Holt
-           (c) 2012-2013 Peter Portante
-           (c) 2012 Iryoung Jeong
-           (c) 2012 Michael Barton
-           (c) 2013 Alex Gaynor
-           (c) 2013 Chuck Thier
-           (c) 2013 David Goetz
-           (c) 2015 Donagh McCabe
-           (c) 2013 Greg Lange
-           (c) 2013 John Dickinson
-           (c) 2013 Kun Huang
-           (c) 2013 Richard Hawkins
-           (c) 2013 Samuel Merritt
-           (c) 2013 Shri Javadekar
-           (c) 2013 Tong Li
-           (c) 2013 ZhiQiang Fan
-License: Apache-2
-
-Files: bin/swift-ring-builder
-       bin/swift-recon
-       test/unit/cli/test_ringbuilder.py
-       test/unit/cli/test_recon.py
-Copyright: (c) 2013-2014 Christian Schwede <christian.schwede@enovance.com>
-License: Apache-2
-
-Files: bin/swift-ring-builder-analyzer
-       test/unit/cli/test_ring_builder_analyzer.py
-       test/unit/cli/test_form_signature.py
-Copyright: (c) 2014-2015 Samuel Merritt <sam@swiftstack.com>
-License: Apache-2
-
+Copyright: 2010 OpenStack, LLC.
 License: Apache-2
  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
diff -pruN 2.25.0-3/debian/gbp.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/gbp.conf
--- 2.25.0-3/debian/gbp.conf	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/gbp.conf	2020-09-15 21:14:38.000000000 +0000
@@ -0,0 +1,7 @@
+[DEFAULT]
+debian-branch = master
+upstream-tag = %(version)s
+pristine-tar = True
+
+[buildpackage]
+export-dir = ../build-area
diff -pruN 2.25.0-3/debian/gen-init 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/gen-init
--- 2.25.0-3/debian/gen-init	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/gen-init	2020-09-15 21:14:38.000000000 +0000
@@ -46,7 +46,6 @@ $AFTER
 [Service]
 User=${SYSTEM_USER}
 Group=${SYSTEM_GROUP}
-WorkingDirectory=~
 CacheDirectory=${PROJECT_NAME}
 RuntimeDirectory=${PROJECT_NAME} lock/${PROJECT_NAME}
 ExecStart=/usr/bin/${NAME} /etc/${PROJECT_NAME}/${CONFIG}.conf
diff -pruN 2.25.0-3/debian/object-expirer.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/object-expirer.conf
--- 2.25.0-3/debian/object-expirer.conf	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/object-expirer.conf	2020-09-15 21:14:38.000000000 +0000
@@ -0,0 +1,18 @@
+[DEFAULT]
+
+[object-expirer]
+interval = 300
+
+[pipeline:main]
+pipeline = catch_errors cache proxy-server
+
+[app:proxy-server]
+use = egg:swift#proxy
+
+[filter:cache]
+use = egg:swift#memcache
+
+[filter:catch_errors]
+use = egg:swift#catch_errors
+
+# See object-expirer.conf-sample for options
diff -pruN 2.25.0-3/debian/object-server.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/object-server.conf
--- 2.25.0-3/debian/object-server.conf	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/object-server.conf	2020-09-15 21:14:38.000000000 +0000
@@ -0,0 +1,16 @@
+[DEFAULT]
+bind_ip = 0.0.0.0
+bind_port = 6000
+workers = 2
+
+[pipeline:main]
+pipeline = object-server
+
+[app:object-server]
+use = egg:swift#object
+
+[object-replicator]
+
+[object-updater]
+
+[object-auditor]
diff -pruN 2.25.0-3/debian/patches/disable_sphinxcontrib_rsvgconverter.patch 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/patches/disable_sphinxcontrib_rsvgconverter.patch
--- 2.25.0-3/debian/patches/disable_sphinxcontrib_rsvgconverter.patch	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/patches/disable_sphinxcontrib_rsvgconverter.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,17 +0,0 @@
-Description: Disable sphinxcontrib.rsvgconverter extension
-Author: Ondřej Nový <novy@ondrej.org>
-Forwarded: not-needed
-Last-Update: 2020-02-12
-
---- a/doc/source/conf.py
-+++ b/doc/source/conf.py
-@@ -55,8 +55,7 @@
-               'sphinx.ext.todo',
-               'sphinx.ext.coverage',
-               'sphinx.ext.ifconfig',
--              'openstackdocstheme',
--              'sphinxcontrib.rsvgconverter']
-+              'openstackdocstheme']
- todo_include_todos = True
- 
- # Add any paths that contain templates here, relative to this directory.
diff -pruN 2.25.0-3/debian/patches/fix-deployment-guide-header.patch 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/patches/fix-deployment-guide-header.patch
--- 2.25.0-3/debian/patches/fix-deployment-guide-header.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/patches/fix-deployment-guide-header.patch	2020-09-15 21:14:38.000000000 +0000
@@ -0,0 +1,32 @@
+Description: Extend headers to prevent the following sphinx error:
+  sphinx.errors.SphinxWarning: /<<PKGBUILDDIR>>/doc/source/deployment_guide.rst:815: ERROR: Malformed table.
+  Column span alignment problem in table line 13.
+  This is required when building swift with the older version of python-docutils
+  that the Xenial-Pike cloud-archive picks up.
+Author: Corey Bryant <corey.bryant@canonical.com>
+Forwarded: no
+Last-Updated: 2017-08-25
+
+--- a/doc/source/deployment_guide.rst
++++ b/doc/source/deployment_guide.rst
+@@ -800,9 +800,9 @@ ionice_priority              None
+ [object-reconstructor]
+ **********************
+ 
+-===========================  ========================  ================================
++===========================  ========================  ======================================
+ Option                       Default                   Description
+----------------------------  ------------------------  --------------------------------
++---------------------------  ------------------------  --------------------------------------
+ log_name                     object-reconstructor      Label used when logging
+ log_facility                 LOG_LOCAL0                Syslog log facility
+ log_level                    INFO                      Logging level
+@@ -885,7 +885,7 @@ ionice_priority              None
+                                                        Work only with ionice_class.
+                                                        Ignored if IOPRIO_CLASS_IDLE
+                                                        is set.
+-===========================  ========================  ================================
++===========================  ========================  ======================================
+ 
+ ****************
+ [object-updater]
diff -pruN 2.25.0-3/debian/patches/py3_Work_with_proper_native_string_paths_in_crypto_meta.patch 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/patches/py3_Work_with_proper_native_string_paths_in_crypto_meta.patch
--- 2.25.0-3/debian/patches/py3_Work_with_proper_native_string_paths_in_crypto_meta.patch	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/patches/py3_Work_with_proper_native_string_paths_in_crypto_meta.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,565 +0,0 @@
-Author: Tim Burke <tim.burke@gmail.com>
-Date: Mon, 20 Jul 2020 14:18:33 -0700
-Description: py3: Work with proper native string paths in crypto meta
- Previously, we would work with these paths as WSGI strings -- this would
- work fine when all data were read and written on the same major version
- of Python, but fail pretty badly during and after upgrading Python.
- .
- In particular, if a py3 proxy-server tried to read existing data that
- was written down by a py2 proxy-server, it would hit an error and
- respond 500. Worse, if an un-upgraded py2 proxy tried to read data that
- was freshly-written by a py3 proxy, it would serve corrupt data back to
- the client (including a corrupt/invalid ETag and Content-Type).
- .
- Now, ensure that both py2 and py3 write down paths as native strings.
- Make an effort to still work with WSGI-string metadata, though it can be
- ambiguous as to whether a string is a WSGI string or not. The heuristic
- used is if
- .
-  * the path from metadata does not match the (native-string) request
-    path and
-  * the path from metadata (when interpreted as a WSGI string) can be
-    "un-wsgi-fied" without any encode/decode errors and
-  * the native-string path from metadata *does* match the native-string
-    request path
- .
- then trust the path from the request. By contrast, we usually prefer the
- path from metadata in case there was a pipeline misconfiguration (see
- related bug).
- .
- Add the ability to read and write a new, unambiguous version of metadata
- that always has the path as a native string. To support rolling
- upgrades, a new config option is added: meta_version_to_write. This
- defaults to 2 to support rolling upgrades without configuration changes,
- but the default may change to 3 in a future release.
- .
- UpgradeImpact
- =============
- When upgrading from Swift 2.20.0 or Swift 2.19.1 or earlier, set
- .
-    meta_version_to_write = 1
- .
- in your keymaster's configuration. Regardless of prior Swift version, set
- .
-    meta_version_to_write = 3
- .
- after upgrading all proxy servers.
- .
- When switching from Python 2 to Python 3, first upgrade Swift while on
- Python 2, then upgrade to Python 3.
-Change-Id: I00c6693c42c1a0220b64d8016d380d5985339658
-Bug-Ubuntu: https://bugs.launchpad.net/swift/+bug/1888037
-Bug-Ubuntu: https://bugs.launchpad.net/swift/+bug/1813725
-Origin: https://review.opendev.org/748882
-Last-Update: 2020-08-31
-
-Index: swift/etc/keymaster.conf-sample
-===================================================================
---- swift.orig/etc/keymaster.conf-sample
-+++ swift/etc/keymaster.conf-sample
-@@ -1,4 +1,13 @@
- [keymaster]
-+# Over time, the format of crypto metadata on disk may change slightly to resolve
-+# ambiguities. In general, you want to be writing the newest version, but to
-+# ensure that all writes can still be read during rolling upgrades, there's the
-+# option to write older formats as well.
-+# Before upgrading from Swift 2.20.0 or earlier, ensure this is set to 1
-+# Before upgrading from Swift 2.25.0 or earlier, ensure this is set to at most 2
-+# After upgrading all proxy servers, set this to 3 (currently the highest version)
-+# meta_version_to_write = 3
-+
- # Sets the root secret from which encryption keys are derived. This must be set
- # before first use to a value that is a base64 encoding of at least 32 bytes.
- # The security of all encrypted data critically depends on this key, therefore
-@@ -16,6 +25,15 @@
- # backends that use Keystone for authentication. Currently, the only
- # implemented backend is for Barbican.
- 
-+# Over time, the format of crypto metadata on disk may change slightly to resolve
-+# ambiguities. In general, you want to be writing the newest version, but to
-+# ensure that all writes can still be read during rolling upgrades, there's the
-+# option to write older formats as well.
-+# Before upgrading from Swift 2.20.0 or earlier, ensure this is set to 1
-+# Before upgrading from Swift 2.25.0 or earlier, ensure this is set to at most 2
-+# After upgrading all proxy servers, set this to 3 (currently the highest version)
-+# meta_version_to_write = 3
-+
- # The api_class tells Castellan which key manager to use to access the external
- # key management system. The default value that accesses Barbican is
- # castellan.key_manager.barbican_key_manager.BarbicanKeyManager.
-@@ -79,6 +97,15 @@
- # The kmip_keymaster section is used to configure a keymaster that fetches an
- # encryption root secret from a KMIP service.
- 
-+# Over time, the format of crypto metadata on disk may change slightly to resolve
-+# ambiguities. In general, you want to be writing the newest version, but to
-+# ensure that all writes can still be read during rolling upgrades, there's the
-+# option to write older formats as well.
-+# Before upgrading from Swift 2.20.0 or earlier, ensure this is set to 1
-+# Before upgrading from Swift 2.25.0 or earlier, ensure this is set to at most 2
-+# After upgrading all proxy servers, set this to 3 (currently the highest version)
-+# meta_version_to_write = 3
-+
- # The value of the ``key_id`` option should be the unique identifier for a
- # secret that will be retrieved from the KMIP service. The secret should be an
- # AES-256 symmetric key.
-Index: swift/etc/proxy-server.conf-sample
-===================================================================
---- swift.orig/etc/proxy-server.conf-sample
-+++ swift/etc/proxy-server.conf-sample
-@@ -1110,6 +1110,18 @@ use = egg:swift#copy
- [filter:keymaster]
- use = egg:swift#keymaster
- 
-+# Over time, the format of crypto metadata on disk may change slightly to resolve
-+# ambiguities. In general, you want to be writing the newest version, but to
-+# ensure that all writes can still be read during rolling upgrades, there's the
-+# option to write older formats as well.
-+# Before upgrading from Swift 2.20.0 or Swift 2.19.1 or earlier, ensure this is set to 1
-+# Before upgrading from Swift 2.25.0 or earlier, ensure this is set to at most 2
-+# After upgrading all proxy servers, set this to 3 (currently the highest version)
-+#
-+# The default is currently 2 to support upgrades with no configuration changes,
-+# but may change to 3 in the future.
-+meta_version_to_write = 2
-+
- # Sets the root secret from which encryption keys are derived. This must be set
- # before first use to a value that is a base64 encoding of at least 32 bytes.
- # The security of all encrypted data critically depends on this key, therefore
-Index: swift/swift/common/middleware/crypto/keymaster.py
-===================================================================
---- swift.orig/swift/common/middleware/crypto/keymaster.py
-+++ swift/swift/common/middleware/crypto/keymaster.py
-@@ -14,10 +14,11 @@
- # limitations under the License.
- import hashlib
- import hmac
-+import six
- 
- from swift.common.exceptions import UnknownSecretIdError
- from swift.common.middleware.crypto.crypto_utils import CRYPTO_KEY_CALLBACK
--from swift.common.swob import Request, HTTPException, wsgi_to_bytes
-+from swift.common.swob import Request, HTTPException, wsgi_to_str, str_to_wsgi
- from swift.common.utils import readconf, strict_b64decode, get_logger, \
-     split_path
- from swift.common.wsgi import WSGIContext
-@@ -33,7 +34,8 @@ class KeyMasterContext(WSGIContext):
- 
-       <path_key> = HMAC_SHA256(<root_secret>, <path>)
-     """
--    def __init__(self, keymaster, account, container, obj):
-+    def __init__(self, keymaster, account, container, obj,
-+                 meta_version_to_write='2'):
-         """
-         :param keymaster: a Keymaster instance
-         :param account: account name
-@@ -47,8 +49,11 @@ class KeyMasterContext(WSGIContext):
-         self.obj = obj
-         self._keys = {}
-         self.alternate_fetch_keys = None
-+        self.meta_version_to_write = meta_version_to_write
- 
-     def _make_key_id(self, path, secret_id, version):
-+        if version in ('1', '2'):
-+            path = str_to_wsgi(path)
-         key_id = {'v': version, 'path': path}
-         if secret_id:
-             # stash secret_id so that decrypter can pass it back to get the
-@@ -76,8 +81,9 @@ class KeyMasterContext(WSGIContext):
-         if key_id:
-             secret_id = key_id.get('secret_id')
-             version = key_id['v']
--            if version not in ('1', '2'):
-+            if version not in ('1', '2', '3'):
-                 raise ValueError('Unknown key_id version: %s' % version)
-+
-             if version == '1' and not key_id['path'].startswith(
-                     '/' + self.account + '/'):
-                 # Well shoot. This was the bug that made us notice we needed
-@@ -90,7 +96,32 @@ class KeyMasterContext(WSGIContext):
- 
-             check_path = (
-                 self.account, self.container or key_cont, self.obj or key_obj)
-+            if version in ('1', '2') and (
-+                    key_acct, key_cont, key_obj) != check_path:
-+                # Older py3 proxies may have written down crypto meta as WSGI
-+                # strings; we still need to be able to read that
-+                try:
-+                    if six.PY2:
-+                        alt_path = tuple(
-+                            part.decode('utf-8').encode('latin1')
-+                            for part in (key_acct, key_cont, key_obj))
-+                    else:
-+                        alt_path = tuple(
-+                            part.encode('latin1').decode('utf-8')
-+                            for part in (key_acct, key_cont, key_obj))
-+                except UnicodeError:
-+                    # Well, it was worth a shot
-+                    pass
-+                else:
-+                    if check_path == alt_path or (
-+                            check_path[:2] == alt_path[:2] and not self.obj):
-+                        # This object is affected by bug #1888037
-+                        key_acct, key_cont, key_obj = alt_path
-+
-             if (key_acct, key_cont, key_obj) != check_path:
-+                # Pipeline may have been misconfigured, with copy right of
-+                # encryption. In that case, path in meta may not be the
-+                # request path.
-                 self.keymaster.logger.info(
-                     "Path stored in meta (%r) does not match path from "
-                     "request (%r)! Using path from meta.",
-@@ -100,9 +131,11 @@ class KeyMasterContext(WSGIContext):
-         else:
-             secret_id = self.keymaster.active_secret_id
-             # v1 had a bug where we would claim the path was just the object
--            # name if the object started with a slash. Bump versions to
--            # establish that we can trust the path.
--            version = '2'
-+            # name if the object started with a slash.
-+            # v1 and v2 had a bug on py3 where we'd write the path in meta as
-+            # a WSGI string (ie, as Latin-1 chars decoded from UTF-8 bytes).
-+            # Bump versions to establish that we can trust the path.
-+            version = self.meta_version_to_write
-             key_acct, key_cont, key_obj = (
-                 self.account, self.container, self.obj)
- 
-@@ -219,6 +252,11 @@ class BaseKeyMaster(object):
-                 raise ValueError('Secret with id %s is %s, not bytes' % (
-                     secret_id, type(secret)))
- 
-+        self.meta_version_to_write = conf.get('meta_version_to_write') or '2'
-+        if self.meta_version_to_write not in ('1', '2', '3'):
-+            raise ValueError('Unknown/unsupported metadata version: %r' %
-+                             self.meta_version_to_write)
-+
-     @property
-     def root_secret(self):
-         # Returns the default root secret; this is here for historical reasons
-@@ -265,13 +303,15 @@ class BaseKeyMaster(object):
-         req = Request(env)
- 
-         try:
--            parts = req.split_path(2, 4, True)
-+            parts = [wsgi_to_str(part) for part in req.split_path(2, 4, True)]
-         except ValueError:
-             return self.app(env, start_response)
- 
-         if req.method in ('PUT', 'POST', 'GET', 'HEAD'):
-             # handle only those request methods that may require keys
--            km_context = KeyMasterContext(self, *parts[1:])
-+            km_context = KeyMasterContext(
-+                self, *parts[1:],
-+                meta_version_to_write=self.meta_version_to_write)
-             try:
-                 return km_context.handle_request(req, start_response)
-             except HTTPException as err_resp:
-@@ -296,8 +336,9 @@ class BaseKeyMaster(object):
-             self.logger.warning('Unrecognised secret id: %s' % secret_id)
-             raise UnknownSecretIdError(secret_id)
-         else:
--            return hmac.new(key, wsgi_to_bytes(path),
--                            digestmod=hashlib.sha256).digest()
-+            if not six.PY2:
-+                path = path.encode('utf-8')
-+            return hmac.new(key, path, digestmod=hashlib.sha256).digest()
- 
- 
- class KeyMaster(BaseKeyMaster):
-Index: swift/test/unit/common/middleware/crypto/test_keymaster.py
-===================================================================
---- swift.orig/test/unit/common/middleware/crypto/test_keymaster.py
-+++ swift/test/unit/common/middleware/crypto/test_keymaster.py
-@@ -20,6 +20,7 @@ import hmac
- import os
- 
- import mock
-+import six
- import unittest
- 
- from getpass import getuser
-@@ -49,17 +50,45 @@ class TestKeymaster(unittest.TestCase):
-         self.app = keymaster.KeyMaster(self.swift, TEST_KEYMASTER_CONF)
- 
-     def test_object_path(self):
--        self.verify_keys_for_path(
-+        self.verify_v3_keys_for_path(
-             '/a/c/o', expected_keys=('object', 'container'))
-+        self.verify_v3_keys_for_path(
-+            '/a/c//o', expected_keys=('object', 'container'))
-         self.verify_keys_for_path(
-             '/a/c//o', expected_keys=('object', 'container'))
-+        self.verify_v1_keys_for_path(
-+            '/a/c//o', expected_keys=('object', 'container'))
- 
-     def test_container_path(self):
--        self.verify_keys_for_path(
-+        self.verify_v3_keys_for_path(
-             '/a/c', expected_keys=('container',))
- 
--    def verify_keys_for_path(self, path, expected_keys, key_id=None):
-+    def test_unicode_object_path(self):
-+        # NB: path is WSGI
-+        self.verify_v3_keys_for_path(
-+            '/\xe2\x98\x83/\xf0\x9f\x8c\xb4/\xf0\x9f\x8c\x8a',
-+            expected_keys=('object', 'container'))
-+        self.verify_keys_for_path(
-+            '/\xe2\x98\x83/\xf0\x9f\x8c\xb4/\xf0\x9f\x8c\x8a',
-+            expected_keys=('object', 'container'))
-+        self.verify_v1_keys_for_path(
-+            '/\xe2\x98\x83/\xf0\x9f\x8c\xb4/\xf0\x9f\x8c\x8a',
-+            expected_keys=('object', 'container'))
-+
-+        # Double-whammy: *also* hit the os.path.join issue
-+        self.verify_v3_keys_for_path(
-+            '/\xe2\x98\x83/\xf0\x9f\x8c\xb4//\xf0\x9f\x8c\x8a',
-+            expected_keys=('object', 'container'))
-+        self.verify_keys_for_path(
-+            '/\xe2\x98\x83/\xf0\x9f\x8c\xb4//\xf0\x9f\x8c\x8a',
-+            expected_keys=('object', 'container'))
-+        self.verify_v1_keys_for_path(
-+            '/\xe2\x98\x83/\xf0\x9f\x8c\xb4//\xf0\x9f\x8c\x8a',
-+            expected_keys=('object', 'container'))
-+
-+    def verify_v3_keys_for_path(self, wsgi_path, expected_keys, key_id=None):
-         put_keys = None
-+        self.app.meta_version_to_write = '3'
-         for method, resp_class, status in (
-                 ('PUT', swob.HTTPCreated, '201'),
-                 ('POST', swob.HTTPAccepted, '202'),
-@@ -67,9 +96,9 @@ class TestKeymaster(unittest.TestCase):
-                 ('HEAD', swob.HTTPNoContent, '204')):
-             resp_headers = {}
-             self.swift.register(
--                method, '/v1' + path, resp_class, resp_headers, b'')
-+                method, '/v1' + wsgi_path, resp_class, resp_headers, b'')
-             req = Request.blank(
--                '/v1' + path, environ={'REQUEST_METHOD': method})
-+                '/v1' + wsgi_path, environ={'REQUEST_METHOD': method})
-             start_response, calls = capture_start_response()
-             self.app(req.environ, start_response)
-             self.assertEqual(1, len(calls))
-@@ -80,7 +109,48 @@ class TestKeymaster(unittest.TestCase):
-             keys = req.environ.get(CRYPTO_KEY_CALLBACK)(key_id=key_id)
-             self.assertIn('id', keys)
-             id = keys.pop('id')
-+            path = swob.wsgi_to_str(wsgi_path)
-             self.assertEqual(path, id['path'])
-+            self.assertEqual('3', id['v'])
-+            keys.pop('all_ids')
-+            self.assertListEqual(sorted(expected_keys), sorted(keys.keys()),
-+                                 '%s %s got keys %r, but expected %r'
-+                                 % (method, path, keys.keys(), expected_keys))
-+            if put_keys is not None:
-+                # check all key sets were consistent for this path
-+                self.assertDictEqual(put_keys, keys)
-+            else:
-+                put_keys = keys
-+        self.app.meta_version_to_write = '2'  # Clean up after ourselves
-+        return put_keys
-+
-+    def verify_keys_for_path(self, wsgi_path, expected_keys, key_id=None):
-+        put_keys = None
-+        for method, resp_class, status in (
-+                ('PUT', swob.HTTPCreated, '201'),
-+                ('POST', swob.HTTPAccepted, '202'),
-+                ('GET', swob.HTTPOk, '200'),
-+                ('HEAD', swob.HTTPNoContent, '204')):
-+            resp_headers = {}
-+            self.swift.register(
-+                method, '/v1' + wsgi_path, resp_class, resp_headers, b'')
-+            req = Request.blank(
-+                '/v1' + wsgi_path, environ={'REQUEST_METHOD': method})
-+            start_response, calls = capture_start_response()
-+            self.app(req.environ, start_response)
-+            self.assertEqual(1, len(calls))
-+            self.assertTrue(calls[0][0].startswith(status))
-+            self.assertNotIn('swift.crypto.override', req.environ)
-+            self.assertIn(CRYPTO_KEY_CALLBACK, req.environ,
-+                          '%s not set in env' % CRYPTO_KEY_CALLBACK)
-+            keys = req.environ.get(CRYPTO_KEY_CALLBACK)(key_id=key_id)
-+            self.assertIn('id', keys)
-+            id = keys.pop('id')
-+            path = swob.wsgi_to_str(wsgi_path)
-+            if six.PY2:
-+                self.assertEqual(path, id['path'])
-+            else:
-+                self.assertEqual(swob.str_to_wsgi(path), id['path'])
-             self.assertEqual('2', id['v'])
-             keys.pop('all_ids')
-             self.assertListEqual(sorted(expected_keys), sorted(keys.keys()),
-@@ -93,6 +163,49 @@ class TestKeymaster(unittest.TestCase):
-                 put_keys = keys
-         return put_keys
- 
-+    def verify_v1_keys_for_path(self, wsgi_path, expected_keys, key_id=None):
-+        put_keys = None
-+        self.app.meta_version_to_write = '1'
-+        for method, resp_class, status in (
-+                ('PUT', swob.HTTPCreated, '201'),
-+                ('POST', swob.HTTPAccepted, '202'),
-+                ('GET', swob.HTTPOk, '200'),
-+                ('HEAD', swob.HTTPNoContent, '204')):
-+            resp_headers = {}
-+            self.swift.register(
-+                method, '/v1' + wsgi_path, resp_class, resp_headers, b'')
-+            req = Request.blank(
-+                '/v1' + wsgi_path, environ={'REQUEST_METHOD': method})
-+            start_response, calls = capture_start_response()
-+            self.app(req.environ, start_response)
-+            self.assertEqual(1, len(calls))
-+            self.assertTrue(calls[0][0].startswith(status))
-+            self.assertNotIn('swift.crypto.override', req.environ)
-+            self.assertIn(CRYPTO_KEY_CALLBACK, req.environ,
-+                          '%s not set in env' % CRYPTO_KEY_CALLBACK)
-+            keys = req.environ.get(CRYPTO_KEY_CALLBACK)(key_id=key_id)
-+            self.assertIn('id', keys)
-+            id = keys.pop('id')
-+            path = swob.wsgi_to_str(wsgi_path)
-+            if '//' in path:
-+                path = path[path.index('//') + 1:]
-+            if six.PY2:
-+                self.assertEqual(path, id['path'])
-+            else:
-+                self.assertEqual(swob.str_to_wsgi(path), id['path'])
-+            self.assertEqual('1', id['v'])
-+            keys.pop('all_ids')
-+            self.assertListEqual(sorted(expected_keys), sorted(keys.keys()),
-+                                 '%s %s got keys %r, but expected %r'
-+                                 % (method, path, keys.keys(), expected_keys))
-+            if put_keys is not None:
-+                # check all key sets were consistent for this path
-+                self.assertDictEqual(put_keys, keys)
-+            else:
-+                put_keys = keys
-+        self.app.meta_version_to_write = '2'  # Clean up after ourselves
-+        return put_keys
-+
-     def test_key_uniqueness(self):
-         # a rudimentary check that different keys are made for different paths
-         ref_path_parts = ('a1', 'c1', 'o1')
-@@ -432,7 +545,7 @@ class TestKeymaster(unittest.TestCase):
-             return orig_create_key(path, secret_id)
- 
-         context = keymaster.KeyMasterContext(self.app, 'a', 'c', 'o')
--        for version in ('1', '2'):
-+        for version in ('1', '2', '3'):
-             with mock.patch.object(self.app, 'create_key', mock_create_key):
-                 keys = context.fetch_crypto_keys(key_id={
-                     'v': version, 'path': '/a/c/o'})
-@@ -502,7 +615,7 @@ class TestKeymaster(unittest.TestCase):
-         # request path doesn't match stored path -- this could happen if you
-         # misconfigured your proxy to have copy right of encryption
-         context = keymaster.KeyMasterContext(self.app, 'a', 'not-c', 'not-o')
--        for version in ('1', '2'):
-+        for version in ('1', '2', '3'):
-             with mock.patch.object(self.app, 'create_key', mock_create_key):
-                 keys = context.fetch_crypto_keys(key_id={
-                     'v': version, 'path': '/a/c/o'})
-@@ -554,6 +667,106 @@ class TestKeymaster(unittest.TestCase):
-         self.assertEqual(expected_keys, keys)
-         self.assertEqual([('/a/c', None), ('/a/c//o', None)], calls)
- 
-+    def test_v2_keys(self):
-+        secrets = {None: os.urandom(32),
-+                   '22': os.urandom(33)}
-+        conf = {}
-+        for secret_id, secret in secrets.items():
-+            opt = ('encryption_root_secret%s' %
-+                   (('_%s' % secret_id) if secret_id else ''))
-+            conf[opt] = base64.b64encode(secret)
-+        conf['active_root_secret_id'] = '22'
-+        self.app = keymaster.KeyMaster(self.swift, conf)
-+        orig_create_key = self.app.create_key
-+        calls = []
-+
-+        def mock_create_key(path, secret_id=None):
-+            calls.append((path, secret_id))
-+            return orig_create_key(path, secret_id)
-+
-+        container = u'\N{SNOWMAN}'
-+        obj = u'\N{SNOWFLAKE}'
-+        if six.PY2:
-+            container = container.encode('utf-8')
-+            obj = obj.encode('utf-8')
-+        good_con_path = '/a/%s' % container
-+        good_path = '/a/%s/%s' % (container, obj)
-+
-+        if six.PY2:
-+            mangled_con_path = ('/a/%s' % container).decode(
-+                'latin-1').encode('utf-8')
-+            mangled_path = ('/a/%s/%s' % (
-+                container, obj)).decode('latin-1').encode('utf-8')
-+        else:
-+            mangled_con_path = ('/a/%s' % container).encode(
-+                'utf-8').decode('latin-1')
-+            mangled_path = ('/a/%s/%s' % (
-+                container, obj)).encode('utf-8').decode('latin-1')
-+
-+        context = keymaster.KeyMasterContext(self.app, 'a', container, obj)
-+        for version in ('1', '2', '3'):
-+            with mock.patch.object(self.app, 'create_key', mock_create_key):
-+                keys = context.fetch_crypto_keys(key_id={
-+                    'v': version, 'path': good_path})
-+            key_id_path = (good_path if version == '3' or six.PY2
-+                           else mangled_path)
-+            expected_keys = {
-+                'container': hmac.new(secrets[None], b'/a/\xe2\x98\x83',
-+                                      digestmod=hashlib.sha256).digest(),
-+                'object': hmac.new(
-+                    secrets[None], b'/a/\xe2\x98\x83/\xe2\x9d\x84',
-+                    digestmod=hashlib.sha256).digest(),
-+                'id': {'path': key_id_path, 'v': version},
-+                'all_ids': [
-+                    {'path': key_id_path, 'v': version},
-+                    {'path': key_id_path, 'secret_id': '22', 'v': version}]}
-+            self.assertEqual(expected_keys, keys)
-+            self.assertEqual([(good_con_path, None), (good_path, None)], calls)
-+            del calls[:]
-+
-+        context = keymaster.KeyMasterContext(self.app, 'a', container, obj)
-+        for version in ('1', '2'):
-+            with mock.patch.object(self.app, 'create_key', mock_create_key):
-+                keys = context.fetch_crypto_keys(key_id={
-+                    'v': version, 'path': mangled_path})
-+            key_id_path = (good_path if six.PY2 else mangled_path)
-+            expected_keys = {
-+                'container': hmac.new(secrets[None], b'/a/\xe2\x98\x83',
-+                                      digestmod=hashlib.sha256).digest(),
-+                'object': hmac.new(
-+                    secrets[None], b'/a/\xe2\x98\x83/\xe2\x9d\x84',
-+                    digestmod=hashlib.sha256).digest(),
-+                'id': {'path': key_id_path, 'v': version},
-+                'all_ids': [
-+                    {'path': key_id_path, 'v': version},
-+                    {'path': key_id_path, 'secret_id': '22', 'v': version}]}
-+            self.assertEqual(expected_keys, keys)
-+            self.assertEqual([(good_con_path, None), (good_path, None)], calls)
-+            del calls[:]
-+
-+        # If v3, we know to trust the meta -- presumably, data was PUT with
-+        # the mojibake path then COPYed to the right path (but with bad
-+        # pipeline placement for copy)
-+        with mock.patch.object(self.app, 'create_key', mock_create_key):
-+            keys = context.fetch_crypto_keys(key_id={
-+                'v': '3', 'path': mangled_path})
-+        expected_keys = {
-+            'container': hmac.new(
-+                secrets[None], b'/a/\xc3\xa2\xc2\x98\xc2\x83',
-+                digestmod=hashlib.sha256).digest(),
-+            'object': hmac.new(
-+                secrets[None],
-+                b'/a/\xc3\xa2\xc2\x98\xc2\x83/\xc3\xa2\xc2\x9d\xc2\x84',
-+                digestmod=hashlib.sha256).digest(),
-+            'id': {'path': mangled_path, 'v': '3'},
-+            'all_ids': [
-+                {'path': mangled_path, 'v': '3'},
-+                {'path': mangled_path, 'secret_id': '22', 'v': '3'}]}
-+        self.assertEqual(expected_keys, keys)
-+        self.assertEqual([(mangled_con_path, None), (mangled_path, None)],
-+                         calls)
-+        del calls[:]
-+
-     @mock.patch('swift.common.middleware.crypto.keymaster.readconf')
-     def test_keymaster_config_path(self, mock_readconf):
-         for secret in (os.urandom(32), os.urandom(33), os.urandom(50)):
diff -pruN 2.25.0-3/debian/patches/series 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/patches/series
--- 2.25.0-3/debian/patches/series	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/patches/series	2020-09-15 21:14:38.000000000 +0000
@@ -1,3 +1,3 @@
-syslog_log_name.patch
-disable_sphinxcontrib_rsvgconverter.patch
-py3_Work_with_proper_native_string_paths_in_crypto_meta.patch
+skip-test-local-py36.patch
+fix-deployment-guide-header.patch
+skip-online-test.patch
diff -pruN 2.25.0-3/debian/patches/skip-online-test.patch 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/patches/skip-online-test.patch
--- 2.25.0-3/debian/patches/skip-online-test.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/patches/skip-online-test.patch	2020-09-15 21:14:38.000000000 +0000
@@ -0,0 +1,25 @@
+Description: Skip test that is erroring with "gaierror:
+  [Errno -2] Name or service not known" as LP builds don't
+  have network access.
+Author: Corey Bryant <corey.bryant@canonical.com>
+Forwarded: no
+Last-Update: 2017-08-01
+
+--- a/test/unit/common/test_utils.py
++++ b/test/unit/common/test_utils.py
+@@ -47,6 +47,7 @@ from six.moves import range
+ from textwrap import dedent
+ 
+ import tempfile
++import testtools
+ import time
+ import unittest
+ import fcntl
+@@ -1530,6 +1531,7 @@ class TestUtils(unittest.TestCase):
+         self.assertEqual(sio.getvalue(),
+                          'test1\ntest3\ntest4\ntest6\n')
+ 
++    @testtools.skip("Skipped by Ubuntu")
+     def test_get_logger_sysloghandler_plumbing(self):
+         orig_sysloghandler = utils.ThreadSafeSysLogHandler
+         syslog_handler_args = []
diff -pruN 2.25.0-3/debian/patches/skip-test-local-py36.patch 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/patches/skip-test-local-py36.patch
--- 2.25.0-3/debian/patches/skip-test-local-py36.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/patches/skip-test-local-py36.patch	2020-09-15 21:14:38.000000000 +0000
@@ -0,0 +1,22 @@
+Description: Skip this test for Python 3 as it expects en_US.UTF-8
+  locale to be installed.
+Author: Corey Bryant <corey.bryant@canonical.com>
+Forwarded: not-needed
+
+--- a/test/unit/test_locale/test_locale.py
++++ b/test/unit/test_locale/test_locale.py
+@@ -17,11 +17,14 @@
+ import os
+ import unittest
+ import sys
++import testtools
+ 
+ from subprocess import check_output
+ 
+ 
+ class TestTranslations(unittest.TestCase):
++    @testtools.skipIf(sys.version_info >= (3, 6),
++                      "Skipped by Ubuntu, build chroot doesn't include en_US.UTF-8 by default")
+     def test_translations(self):
+         translated_message = check_output([sys.executable, __file__], env={
+             # Need to set this so py36 can do UTF-8, but we override later
diff -pruN 2.25.0-3/debian/patches/syslog_log_name.patch 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/patches/syslog_log_name.patch
--- 2.25.0-3/debian/patches/syslog_log_name.patch	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/patches/syslog_log_name.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,320 +0,0 @@
-Description: Set log_name for Swift services in default configs
-Author: Ondřej Nový <novy@ondrej.org>
-Forwarded: not-needed
-Last-Update: 2016-07-05
-
---- a/etc/account-server.conf-sample
-+++ b/etc/account-server.conf-sample
-@@ -18,7 +18,7 @@
- # max_clients = 1024
- #
- # You can specify default log routing here if you want:
--# log_name = swift
-+log_name = swift-account
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -85,7 +85,7 @@
- [app:account-server]
- use = egg:swift#account
- # You can override the default log routing for this app here:
--# set log_name = account-server
-+set log_name = swift-account-server
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_requests = true
-@@ -130,7 +130,7 @@
- 
- [account-replicator]
- # You can override the default log routing for this app here (don't use set!):
--# log_name = account-replicator
-+log_name = swift-account-replicator
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -208,7 +208,7 @@
- 
- [account-auditor]
- # You can override the default log routing for this app here (don't use set!):
--# log_name = account-auditor
-+log_name = swift-account-auditor
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -233,7 +233,7 @@
- 
- [account-reaper]
- # You can override the default log routing for this app here (don't use set!):
--# log_name = account-reaper
-+log_name = swift-account-reaper
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
---- a/etc/container-reconciler.conf-sample
-+++ b/etc/container-reconciler.conf-sample
-@@ -2,7 +2,7 @@
- # swift_dir = /etc/swift
- # user = swift
- # You can specify default log routing here if you want:
--# log_name = swift
-+log_name = swift-container-reconciler
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
---- a/etc/container-server.conf-sample
-+++ b/etc/container-server.conf-sample
-@@ -24,7 +24,7 @@
- # allowed_sync_hosts = 127.0.0.1
- #
- # You can specify default log routing here if you want:
--# log_name = swift
-+log_name = swift-container
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -91,7 +91,7 @@
- [app:container-server]
- use = egg:swift#container
- # You can override the default log routing for this app here:
--# set log_name = container-server
-+set log_name = swift-container-server
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_requests = true
-@@ -140,7 +140,7 @@
- 
- [container-replicator]
- # You can override the default log routing for this app here (don't use set!):
--# log_name = container-replicator
-+log_name = swift-container-replicator
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -218,7 +218,7 @@
- 
- [container-updater]
- # You can override the default log routing for this app here (don't use set!):
--# log_name = container-updater
-+log_name = swift-container-updater
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -254,7 +254,7 @@
- 
- [container-auditor]
- # You can override the default log routing for this app here (don't use set!):
--# log_name = container-auditor
-+log_name = swift-container-auditor
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -279,7 +279,7 @@
- 
- [container-sync]
- # You can override the default log routing for this app here (don't use set!):
--# log_name = container-sync
-+log_name = swift-container-sync
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
---- a/etc/drive-audit.conf-sample
-+++ b/etc/drive-audit.conf-sample
-@@ -5,7 +5,7 @@
- # device_dir = /srv/node
- #
- # You can specify default log routing here if you want:
--# log_name = drive-audit
-+log_name = swift-drive-audit
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
---- a/etc/internal-client.conf-sample
-+++ b/etc/internal-client.conf-sample
-@@ -2,7 +2,7 @@
- # swift_dir = /etc/swift
- # user = swift
- # You can specify default log routing here if you want:
--# log_name = swift
-+log_name = swift-internal-client
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
---- a/etc/object-expirer.conf-sample
-+++ b/etc/object-expirer.conf-sample
-@@ -2,7 +2,7 @@
- # swift_dir = /etc/swift
- # user = swift
- # You can specify default log routing here if you want:
--# log_name = swift
-+log_name = swift-object-expirer
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
---- a/etc/object-server.conf-sample
-+++ b/etc/object-server.conf-sample
-@@ -26,7 +26,7 @@
- # max_clients = 1024
- #
- # You can specify default log routing here if you want:
--# log_name = swift
-+log_name = swift-object
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -105,7 +105,7 @@
- [app:object-server]
- use = egg:swift#object
- # You can override the default log routing for this app here:
--# set log_name = object-server
-+set log_name = swift-object-server
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_requests = true
-@@ -222,7 +222,7 @@
- 
- [object-replicator]
- # You can override the default log routing for this app here (don't use set!):
--# log_name = object-replicator
-+log_name = swift-object-replicator
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -321,7 +321,7 @@
- # in the [object-replicator] section, however these settings apply to the EC
- # reconstructor
- #
--# log_name = object-reconstructor
-+log_name = swift-object-reconstructor
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -383,7 +383,7 @@
- 
- [object-updater]
- # You can override the default log routing for this app here (don't use set!):
--# log_name = object-updater
-+log_name = swift-object-updater
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
-@@ -428,7 +428,7 @@
- 
- [object-auditor]
- # You can override the default log routing for this app here (don't use set!):
--# log_name = object-auditor
-+log_name = swift-object-auditor
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
---- a/etc/proxy-server.conf-sample
-+++ b/etc/proxy-server.conf-sample
-@@ -41,7 +41,7 @@
- # expiring_objects_account_name = expiring_objects
- #
- # You can specify default log routing here if you want:
--# log_name = swift
-+log_name = swift-proxy
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_headers = false
-@@ -113,7 +113,7 @@
- [app:proxy-server]
- use = egg:swift#proxy
- # You can override the default log routing for this app here:
--# set log_name = proxy-server
-+set log_name = swift-proxy-server
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_address = /dev/log
-@@ -302,7 +302,7 @@
- [filter:tempauth]
- use = egg:swift#tempauth
- # You can override the default log routing for this filter here:
--# set log_name = tempauth
-+set log_name = swift-proxy-tempauth
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_headers = false
-@@ -643,7 +643,7 @@
- [filter:cache]
- use = egg:swift#memcache
- # You can override the default log routing for this filter here:
--# set log_name = cache
-+set log_name = swift-proxy-cache
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_headers = false
-@@ -676,7 +676,7 @@
- [filter:ratelimit]
- use = egg:swift#ratelimit
- # You can override the default log routing for this filter here:
--# set log_name = ratelimit
-+set log_name = swift-proxy-ratelimit
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_headers = false
-@@ -733,7 +733,7 @@
- [filter:domain_remap]
- use = egg:swift#domain_remap
- # You can override the default log routing for this filter here:
--# set log_name = domain_remap
-+set log_name = swift-proxy-domain_remap
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_headers = false
-@@ -768,7 +768,7 @@
- [filter:catch_errors]
- use = egg:swift#catch_errors
- # You can override the default log routing for this filter here:
--# set log_name = catch_errors
-+set log_name = swift-proxy-catch_errors
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_headers = false
-@@ -778,7 +778,7 @@
- # Note: this middleware requires python-dnspython
- use = egg:swift#cname_lookup
- # You can override the default log routing for this filter here:
--# set log_name = cname_lookup
-+set log_name = swift-proxy-cname_lookup
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_headers = false
-@@ -800,7 +800,7 @@
- [filter:staticweb]
- use = egg:swift#staticweb
- # You can override the default log routing for this filter here:
--# set log_name = staticweb
-+set log_name = swift-proxy-staticweb
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_headers = false
-@@ -879,7 +879,7 @@
- [filter:proxy-logging]
- use = egg:swift#proxy_logging
- # If not set, logging directives from [DEFAULT] without "access_" will be used
--# access_log_name = swift
-+access_log_name = swift-proxy-proxy-logging
- # access_log_facility = LOG_LOCAL0
- # access_log_level = INFO
- # access_log_address = /dev/log
-@@ -1034,7 +1034,7 @@
- # allow_reserved_names_header = false
- #
- # You can override the default log routing for this filter here:
--# set log_name = gatekeeper
-+set log_name = swift-proxy-gatekeeper
- # set log_facility = LOG_LOCAL0
- # set log_level = INFO
- # set log_headers = false
---- a/swift/container/sync.py
-+++ b/swift/container/sync.py
-@@ -55,7 +55,7 @@
- # swift_dir = /etc/swift
- # user = swift
- # You can specify default log routing here if you want:
--# log_name = swift
-+log_name = swift-internal-client
- # log_facility = LOG_LOCAL0
- # log_level = INFO
- # log_address = /dev/log
diff -pruN 2.25.0-3/debian/pybuild.testfiles 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/pybuild.testfiles
--- 2.25.0-3/debian/pybuild.testfiles	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/pybuild.testfiles	1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
-etc
-test
-swift.egg-info
diff -pruN 2.25.0-3/debian/python3-swift.dirs 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/python3-swift.dirs
--- 2.25.0-3/debian/python3-swift.dirs	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/python3-swift.dirs	2020-09-15 21:14:38.000000000 +0000
@@ -0,0 +1 @@
+var/cache/swift
diff -pruN 2.25.0-3/debian/python3-swift.docs 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/python3-swift.docs
--- 2.25.0-3/debian/python3-swift.docs	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/python3-swift.docs	2020-09-15 21:14:38.000000000 +0000
@@ -0,0 +1 @@
+
diff -pruN 2.25.0-3/debian/python3-swift.install 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/python3-swift.install
--- 2.25.0-3/debian/python3-swift.install	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/python3-swift.install	2020-09-15 21:14:38.000000000 +0000
@@ -1 +1,3 @@
-usr/lib/python3*/dist-packages/*
+usr/bin/swift-drive-audit
+usr/bin/swift-init
+usr/lib/python*/dist-packages/*
diff -pruN 2.25.0-3/debian/python3-swift.lintian-overrides 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/python3-swift.lintian-overrides
--- 2.25.0-3/debian/python3-swift.lintian-overrides	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/python3-swift.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-python3-swift binary: spelling-error-in-copyright Thier Their
diff -pruN 2.25.0-3/debian/python3-swift.manpages 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/python3-swift.manpages
--- 2.25.0-3/debian/python3-swift.manpages	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/python3-swift.manpages	2020-09-15 21:14:38.000000000 +0000
@@ -0,0 +1 @@
+doc/manpages/swift-init.1
diff -pruN 2.25.0-3/debian/python3-swift.postinst 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/python3-swift.postinst
--- 2.25.0-3/debian/python3-swift.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/python3-swift.postinst	2020-09-15 21:14:38.000000000 +0000
@@ -0,0 +1,22 @@
+#!/bin/sh -e
+
+#DEBHELPER#
+
+if ! getent passwd swift > /dev/null ; then
+  adduser --system --quiet --disabled-login --home /var/lib/swift \
+        --disabled-password --no-create-home --group \
+        --shell /bin/false swift
+fi
+
+usermod -G adm swift
+
+find /etc/swift -exec chown root:swift "{}" +
+find /etc/swift -type f -exec chmod 0640 "{}" + -o -type d -exec chmod 0750 "{}" +
+
+if [ -d /var/cache/swift ] ; then
+  # Allow swift user to write to cache directory
+  chown root:swift /var/cache/swift
+  chmod 0775 /var/cache/swift
+fi
+
+exit 0
diff -pruN 2.25.0-3/debian/python3-swift.postinst.in 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/python3-swift.postinst.in
--- 2.25.0-3/debian/python3-swift.postinst.in	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/python3-swift.postinst.in	1970-01-01 00:00:00.000000000 +0000
@@ -1,17 +0,0 @@
-#!/bin/sh
-
-set -e
-
-#PKGOS-INCLUDE#
-
-if [ "$1" = "configure" ] || [ "$1" = "reconfigure" ] ; then
-	pkgos_var_user_group swift
-
-	mkdir -p /var/backups/swift
-	chown swift:swift /var/backups/swift
-	chmod 2770 /var/backups/swift
-fi
-
-#DEBHELPER#
-
-exit 0
diff -pruN 2.25.0-3/debian/python3-swift.postrm 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/python3-swift.postrm
--- 2.25.0-3/debian/python3-swift.postrm	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/python3-swift.postrm	2020-09-15 21:14:38.000000000 +0000
@@ -2,13 +2,20 @@
 
 set -e
 
-if [ "${1}" = "purge" ] ; then
-	for i in lock log run lib cache backups ; do
-		rm -rf /var/$i/swift
-	done
-	rm -rf /etc/swift
-fi
+case "$1" in
+    purge)
+        # Remove swift user if possible
+        userdel swift || true
+    ;;
+    remove|upgrade|failed-upgrade|abort-install|abort-upgrade|disappear)
+    ;;
+    *)
+        echo "postrm called with unknown argument \`$1'" >&2
+        exit 1
+    ;;
+esac
 
 #DEBHELPER#
 
 exit 0
+
diff -pruN 2.25.0-3/debian/rules 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/rules
--- 2.25.0-3/debian/rules	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/rules	2020-09-15 21:14:38.000000000 +0000
@@ -1,31 +1,56 @@
 #!/usr/bin/make -f
 
--include /usr/share/openstack-pkg-tools/pkgos.make
+# Verbose mode
+#export DH_VERBOSE=1
 
-export SWIFT_TEST_CONFIG_FILE=$(CURDIR)/debian/swift-test.conf
+export PYBUILD_NAME=swift
 
-export PYBUILD_TEST_ARGS=\
-	test/unit \
-	--exclude-test=test.unit.common.test_utils.TestUtils.test_get_logger_sysloghandler_plumbing
-	# --processes=-1
+SHELL := /bin/sh -e
+
+DEBVERS ?= $(shell dpkg-parsechangelog | sed -n -e 's/^Version: //p')
+VERSION ?= $(shell echo '$(DEBVERS)' | sed -e 's/^[[:digit:]]*://' -e 's/[-].*//' -e 's/[+].*//' -e 's/~git.*//g' -e 's/~/./g')
+export PBR_VERSION=$(VERSION)
 
 %:
-	dh $@ --buildsystem=pybuild --with python3,sphinxdoc
+	dh $@ --with python3,sphinxdoc --buildsystem=pybuild
 
-override_dh_auto_build:
-	dh_auto_build
+# clean sphinx build output
+override_dh_clean:
+	dh_clean
+	rm -rf doc/build
+
+# build with sphinx documentation
+ifeq (,$(findstring nodocs, $(DEB_BUILD_OPTIONS)))
+override_dh_sphinxdoc:
+	PYTHONPATH=. sphinx-build -b html doc/source $(CURDIR)/debian/swift-doc/usr/share/doc/swift-doc/html
+	dh_sphinxdoc
+endif
 
-	/usr/share/openstack-pkg-tools/pkgos_insert_include pkgos_func python3-swift.postinst
+ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
+override_dh_auto_test:
+	PYTHONPATH=. nosetests3 test/unit
+endif
+
+get-orig-source:
+	uscan --verbose --force-download --rename --destdir=../build-area
 
+override_dh_auto_build:
+	dh_auto_build
 	set -e ; set -x ; \
 	for i in $(sort $(wildcard debian/*.init.in)) ; do \
 		debian/gen-init $$i ; \
 	done
 
 override_dh_auto_install:
-	dh_auto_install
+	pkgos-dh_auto_install --no-py2 --in-tmp
 
-	rm debian/tmp/usr/bin/swift-init
+override_dh_install:
+	dh_install --sourcedir=debian/tmp -Xdebian/swift-account-generator -Xdebian/swift-object-generator -Xdebian/swift-container-generator
+	dh_missing --fail-missing
+	install -D -m 0640 $(CURDIR)/debian/account-server.conf $(CURDIR)/debian/python3-swift/etc/swift/account-server.conf
+	install -D -m 0640 $(CURDIR)/debian/container-server.conf $(CURDIR)/debian/python3-swift/etc/swift/container-server.conf
+	install -D -m 0640 $(CURDIR)/debian/object-server.conf $(CURDIR)/debian/python3-swift/etc/swift/object-server.conf
+	install -D -m 0640 $(CURDIR)/debian/object-expirer.conf $(CURDIR)/debian/python3-swift/etc/swift/object-expirer.conf
 
 override_dh_installinit:
 	set -e ; set -x ; \
@@ -43,21 +68,5 @@ override_dh_installsystemd:
 		dh_installsystemd -p$$PKG --name=$$NAME ;\
 	done
 
-gen-init-configurations:
-	echo "Do nothing"
-
-# build with sphinx documentation
-override_dh_sphinxdoc:
-ifeq (,$(findstring nodocs, $(DEB_BUILD_OPTIONS)))
-	LC_ALL=C.UTF-8 PYTHONPATH=. python3 -m sphinx doc/source $(CURDIR)/debian/swift-doc/usr/share/doc/swift-doc/base
-	LC_ALL=C.UTF-8 PYTHONPATH=. python3 -m sphinx api-ref/source $(CURDIR)/debian/swift-doc/usr/share/doc/swift-doc/api-ref
-	dh_sphinxdoc
-endif
-
-override_dh_installdocs:
-	dh_installdocs
-
-	dh_installdocs -A AUTHORS
-
-override_dh_missing:
-	dh_missing --fail-missing
+override_dh_compress:
+	dh_compress -Xconf-sample
diff -pruN 2.25.0-3/debian/source/include-binaries 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/source/include-binaries
--- 2.25.0-3/debian/source/include-binaries	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/source/include-binaries	2020-09-15 21:14:38.000000000 +0000
@@ -0,0 +1 @@
+doc/source/howto_cyberduck_config.png
diff -pruN 2.25.0-3/debian/source/options 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/source/options
--- 2.25.0-3/debian/source/options	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/source/options	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-extend-diff-ignore = "^[^/]*[.]egg-info/"
-extend-diff-ignore = "^[.]gitreview$"
diff -pruN 2.25.0-3/debian/swift-account.docs 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-account.docs
--- 2.25.0-3/debian/swift-account.docs	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-account.docs	2020-09-15 21:14:38.000000000 +0000
@@ -0,0 +1 @@
+etc/account-server.conf-sample
diff -pruN 2.25.0-3/debian/swift-account.install 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-account.install
--- 2.25.0-3/debian/swift-account.install	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-account.install	2020-09-15 21:14:38.000000000 +0000
@@ -1,7 +1,5 @@
 #! /usr/bin/dh-exec --with=install
 debian/swift-account-generator /lib/systemd/system-generators
-etc/account-server.conf-sample => /etc/swift/account-server.conf
-etc/account-server.conf-sample => /usr/share/doc/swift-account/examples/account-server.conf
 usr/bin/swift-account-audit
 usr/bin/swift-account-auditor
 usr/bin/swift-account-info
diff -pruN 2.25.0-3/debian/swift-account.links 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-account.links
--- 2.25.0-3/debian/swift-account.links	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-account.links	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-usr/share/doc/swift-account/examples/account-server.conf usr/share/doc/swift/examples/account-server.conf
diff -pruN 2.25.0-3/debian/swift-account.lintian-overrides 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-account.lintian-overrides
--- 2.25.0-3/debian/swift-account.lintian-overrides	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-account.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-swift-account binary: spelling-error-in-copyright Thier Their
diff -pruN 2.25.0-3/debian/swift-account.manpages 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-account.manpages
--- 2.25.0-3/debian/swift-account.manpages	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-account.manpages	2020-09-15 21:14:38.000000000 +0000
@@ -1,7 +1,2 @@
-doc/manpages/account-server.conf.5
-doc/manpages/swift-account-audit.1
-doc/manpages/swift-account-auditor.1
-doc/manpages/swift-account-info.1
-doc/manpages/swift-account-reaper.1
-doc/manpages/swift-account-replicator.1
-doc/manpages/swift-account-server.1
+doc/manpages/account*
+doc/manpages/swift-account*
diff -pruN 2.25.0-3/debian/swift-container.docs 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-container.docs
--- 2.25.0-3/debian/swift-container.docs	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-container.docs	2020-09-15 21:14:38.000000000 +0000
@@ -0,0 +1,2 @@
+etc/container-server.conf-sample
+etc/container-sync-realms.conf-sample
diff -pruN 2.25.0-3/debian/swift-container.install 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-container.install
--- 2.25.0-3/debian/swift-container.install	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-container.install	2020-09-15 21:14:38.000000000 +0000
@@ -1,18 +1,5 @@
 #! /usr/bin/dh-exec --with=install
-etc/container-reconciler.conf-sample => /etc/swift/container-reconciler.conf
-etc/container-reconciler.conf-sample => /usr/share/doc/swift-container/examples/container-reconciler.conf
-etc/container-server.conf-sample => /etc/swift/container-server.conf
-etc/container-server.conf-sample => /usr/share/doc/swift-container/examples/container-server.conf
-etc/internal-client.conf-sample => /etc/swift/internal-client.conf
-etc/internal-client.conf-sample => /usr/share/doc/swift-container/examples/internal-client.conf
 debian/swift-container-generator /lib/systemd/system-generators
-usr/bin/swift-container-auditor
-usr/bin/swift-container-info
-usr/bin/swift-container-reconciler
-usr/bin/swift-container-replicator
-usr/bin/swift-container-server
-usr/bin/swift-container-sharder
-usr/bin/swift-container-sync
-usr/bin/swift-container-updater
+usr/bin/swift-container-*
 usr/bin/swift-manage-shard-ranges
 usr/bin/swift-reconciler-enqueue
diff -pruN 2.25.0-3/debian/swift-container.links 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-container.links
--- 2.25.0-3/debian/swift-container.links	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-container.links	1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
-usr/share/doc/swift-container/examples/container-reconciler.conf usr/share/doc/swift/examples/container-reconciler.conf
-usr/share/doc/swift-container/examples/container-server.conf usr/share/doc/swift/examples/container-server.conf
-usr/share/doc/swift-container/examples/internal-client.conf usr/share/doc/swift/examples/internal-client.conf
diff -pruN 2.25.0-3/debian/swift-container.lintian-overrides 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-container.lintian-overrides
--- 2.25.0-3/debian/swift-container.lintian-overrides	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-container.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-swift-container binary: spelling-error-in-copyright Thier Their
diff -pruN 2.25.0-3/debian/swift-container.manpages 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-container.manpages
--- 2.25.0-3/debian/swift-container.manpages	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-container.manpages	2020-09-15 21:14:38.000000000 +0000
@@ -1,9 +1,2 @@
-doc/manpages/container-server.conf.5
-doc/manpages/swift-container-auditor.1
-doc/manpages/swift-container-info.1
-doc/manpages/swift-container-reconciler.1
-doc/manpages/swift-container-replicator.1
-doc/manpages/swift-container-server.1
-doc/manpages/swift-container-sync.1
-doc/manpages/swift-container-updater.1
-doc/manpages/swift-reconciler-enqueue.1
+doc/manpages/container*
+doc/manpages/swift-container*
diff -pruN 2.25.0-3/debian/swift-doc.doc-base 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-doc.doc-base
--- 2.25.0-3/debian/swift-doc.doc-base	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-doc.doc-base	2020-09-15 21:14:38.000000000 +0000
@@ -5,5 +5,5 @@ Abstract: Sphinx documentation for Swift
 Section: Network/File Transfer
 
 Format: HTML
-Index: /usr/share/doc/swift-doc/base/index.html
-Files: /usr/share/doc/swift-doc/base/*
+Index: /usr/share/doc/swift-doc/html/index.html
+Files: /usr/share/doc/swift-doc/html/*
diff -pruN 2.25.0-3/debian/swift-doc.links 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-doc.links
--- 2.25.0-3/debian/swift-doc.links	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-doc.links	2020-09-15 21:14:38.000000000 +0000
@@ -1,7 +1,3 @@
-usr/share/doc/swift-doc/api-ref usr/share/doc/swift/api-ref
-usr/share/doc/swift-doc/base usr/share/doc/swift/base
-usr/share/doc/swift-doc/install-guide usr/share/doc/swift/install-guide
-usr/share/javascript/bootstrap/css/bootstrap.min.css usr/share/doc/swift-doc/install-guide/_static/css/bootstrap.min.css
-usr/share/javascript/bootstrap/js/bootstrap.min.js usr/share/doc/swift-doc/install-guide/_static/js/bootstrap.min.js
-usr/share/javascript/jquery/jquery.min.js usr/share/doc/swift-doc/install-guide/_static/jquery.js
-usr/share/javascript/underscore/underscore.min.js usr/share/doc/swift-doc/install-guide/_static/underscore.js
+# Overwrite jquery.js  from upstream tarball with a  link to jquery.js
+# provided by jQuery Debian package
+/usr/share/javascript/jquery/jquery.js usr/share/doc/swift-doc/html/_static/jquery.js
diff -pruN 2.25.0-3/debian/swift-doc.lintian-overrides 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-doc.lintian-overrides
--- 2.25.0-3/debian/swift-doc.lintian-overrides	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-doc.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-swift-doc binary: spelling-error-in-copyright Thier Their
diff -pruN 2.25.0-3/debian/swift.docs 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift.docs
--- 2.25.0-3/debian/swift.docs	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift.docs	2020-09-15 21:14:38.000000000 +0000
@@ -0,0 +1,4 @@
+CHANGELOG
+etc/dispersion.conf-sample
+etc/drive-audit.conf-sample
+etc/swift.conf-sample
diff -pruN 2.25.0-3/debian/swift-drive-audit.cron.d 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-drive-audit.cron.d
--- 2.25.0-3/debian/swift-drive-audit.cron.d	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-drive-audit.cron.d	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-*/5 * * * *     root   test -x /usr/bin/swift-drive-audit && test -r /etc/swift/drive-audit.conf && /usr/bin/swift-drive-audit /etc/swift/drive-audit.conf
diff -pruN 2.25.0-3/debian/swift-drive-audit.install 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-drive-audit.install
--- 2.25.0-3/debian/swift-drive-audit.install	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-drive-audit.install	1970-01-01 00:00:00.000000000 +0000
@@ -1,4 +0,0 @@
-#! /usr/bin/dh-exec --with=install
-etc/drive-audit.conf-sample => /etc/swift/drive-audit.conf
-etc/drive-audit.conf-sample => /usr/share/doc/swift-drive-audit/examples/drive-audit.conf
-usr/bin/swift-drive-audit
diff -pruN 2.25.0-3/debian/swift-drive-audit.links 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-drive-audit.links
--- 2.25.0-3/debian/swift-drive-audit.links	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-drive-audit.links	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-usr/share/doc/swift-drive-audit/examples/drive-audit.conf usr/share/doc/swift/examples/drive-audit.conf
diff -pruN 2.25.0-3/debian/swift-drive-audit.lintian-overrides 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-drive-audit.lintian-overrides
--- 2.25.0-3/debian/swift-drive-audit.lintian-overrides	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-drive-audit.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-swift-drive-audit binary: spelling-error-in-copyright Thier Their
diff -pruN 2.25.0-3/debian/swift-drive-audit.manpages 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-drive-audit.manpages
--- 2.25.0-3/debian/swift-drive-audit.manpages	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-drive-audit.manpages	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-doc/manpages/swift-drive-audit.1
diff -pruN 2.25.0-3/debian/swift.install 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift.install
--- 2.25.0-3/debian/swift.install	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift.install	2020-09-15 21:14:38.000000000 +0000
@@ -1,13 +1,4 @@
-#! /usr/bin/dh-exec --with=install
-debian/swift.rsyslog => /etc/rsyslog.d/swift.conf
-etc/container-sync-realms.conf-sample => /etc/swift/container-sync-realms.conf
-etc/container-sync-realms.conf-sample => /usr/share/doc/swift/examples/container-sync-realms.conf
-etc/dispersion.conf-sample => /etc/swift/dispersion.conf
-etc/dispersion.conf-sample => /usr/share/doc/swift/examples/dispersion.conf
-etc/swift.conf-sample => /etc/swift/swift.conf
-etc/swift.conf-sample => /usr/share/doc/swift/examples/swift.conf
 usr/bin/swift-config
-usr/bin/swift-container-deleter
 usr/bin/swift-dispersion-populate
 usr/bin/swift-dispersion-report
 usr/bin/swift-form-signature
@@ -15,6 +6,9 @@ usr/bin/swift-get-nodes
 usr/bin/swift-oldies
 usr/bin/swift-orphans
 usr/bin/swift-recon
+usr/bin/swift-recon
+usr/bin/swift-recon-cron
+usr/bin/swift-recon-cron
 usr/bin/swift-ring-builder
 usr/bin/swift-ring-builder-analyzer
 usr/bin/swift-ring-composer
diff -pruN 2.25.0-3/debian/swift.links 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift.links
--- 2.25.0-3/debian/swift.links	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift.links	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-/var/backups/swift	/etc/swift/backups
diff -pruN 2.25.0-3/debian/swift.lintian-overrides 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift.lintian-overrides
--- 2.25.0-3/debian/swift.lintian-overrides	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-swift binary: spelling-error-in-copyright Thier Their
diff -pruN 2.25.0-3/debian/swift.logrotate 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift.logrotate
--- 2.25.0-3/debian/swift.logrotate	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift.logrotate	1970-01-01 00:00:00.000000000 +0000
@@ -1,12 +0,0 @@
-/var/log/swift/*.log {
-	rotate 7
-	daily
-	missingok
-	notifempty
-	delaycompress
-	compress
-	sharedscripts
-	postrotate
-		invoke-rc.d rsyslog rotate > /dev/null
-	endscript
-}
diff -pruN 2.25.0-3/debian/swift.manpages 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift.manpages
--- 2.25.0-3/debian/swift.manpages	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift.manpages	2020-09-15 21:14:38.000000000 +0000
@@ -1,13 +1,7 @@
 doc/manpages/dispersion.conf.5
-doc/manpages/swift-config.1
 doc/manpages/swift-dispersion-populate.1
 doc/manpages/swift-dispersion-report.1
-doc/manpages/swift-form-signature.1
 doc/manpages/swift-get-nodes.1
-doc/manpages/swift-oldies.1
 doc/manpages/swift-orphans.1
 doc/manpages/swift-recon.1
-doc/manpages/swift-ring-builder-analyzer.1
 doc/manpages/swift-ring-builder.1
-doc/manpages/swift-ring-composer.1
-doc/manpages/swift.conf.5
diff -pruN 2.25.0-3/debian/swift-object.cron.d 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object.cron.d
--- 2.25.0-3/debian/swift-object.cron.d	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object.cron.d	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-*/5 * * * *     swift   test -x /usr/bin/swift-recon-cron && test -r /etc/swift/object-server.conf && /usr/bin/swift-recon-cron /etc/swift/object-server.conf
diff -pruN 2.25.0-3/debian/swift-object.docs 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object.docs
--- 2.25.0-3/debian/swift-object.docs	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object.docs	2020-09-15 21:14:38.000000000 +0000
@@ -0,0 +1,3 @@
+etc/object-expirer.conf-sample
+etc/object-server.conf-sample
+etc/rsyncd.conf-sample
diff -pruN 2.25.0-3/debian/swift-object-expirer.docs 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object-expirer.docs
--- 2.25.0-3/debian/swift-object-expirer.docs	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object-expirer.docs	2020-09-15 21:14:38.000000000 +0000
@@ -0,0 +1 @@
+etc/object-expirer.conf-sample
diff -pruN 2.25.0-3/debian/swift-object-expirer.install 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object-expirer.install
--- 2.25.0-3/debian/swift-object-expirer.install	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object-expirer.install	2020-09-15 21:14:38.000000000 +0000
@@ -1,4 +1 @@
-#! /usr/bin/dh-exec --with=install
-etc/object-expirer.conf-sample => /etc/swift/object-expirer.conf
-etc/object-expirer.conf-sample => /usr/share/doc/swift-object-expirer/examples/object-expirer.conf
 usr/bin/swift-object-expirer
diff -pruN 2.25.0-3/debian/swift-object-expirer.links 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object-expirer.links
--- 2.25.0-3/debian/swift-object-expirer.links	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object-expirer.links	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-usr/share/doc/swift-object-expirer/examples/object-expirer.conf usr/share/doc/swift/examples/object-expirer.conf
diff -pruN 2.25.0-3/debian/swift-object-expirer.lintian-overrides 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object-expirer.lintian-overrides
--- 2.25.0-3/debian/swift-object-expirer.lintian-overrides	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object-expirer.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-swift-object-expirer binary: spelling-error-in-copyright Thier Their
diff -pruN 2.25.0-3/debian/swift-object-expirer.manpages 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object-expirer.manpages
--- 2.25.0-3/debian/swift-object-expirer.manpages	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object-expirer.manpages	2020-09-15 21:14:38.000000000 +0000
@@ -1 +1,2 @@
+doc/manpages/object-expirer.conf.5
 doc/manpages/swift-object-expirer.1
diff -pruN 2.25.0-3/debian/swift-object.install 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object.install
--- 2.25.0-3/debian/swift-object.install	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object.install	2020-09-15 21:14:38.000000000 +0000
@@ -1,8 +1,5 @@
 #! /usr/bin/dh-exec --with=install
 debian/swift-object-generator /lib/systemd/system-generators
-etc/object-server.conf-sample => /etc/swift/object-server.conf
-etc/object-server.conf-sample => /usr/share/doc/swift-object/examples/object-server.conf
-etc/rsyncd.conf-sample => /usr/share/doc/swift-object/examples/rsyncd.conf
 usr/bin/swift-object-auditor
 usr/bin/swift-object-info
 usr/bin/swift-object-reconstructor
@@ -10,4 +7,3 @@ usr/bin/swift-object-relinker
 usr/bin/swift-object-replicator
 usr/bin/swift-object-server
 usr/bin/swift-object-updater
-usr/bin/swift-recon-cron
diff -pruN 2.25.0-3/debian/swift-object.links 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object.links
--- 2.25.0-3/debian/swift-object.links	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object.links	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-usr/share/doc/swift-object/examples/object-server.conf usr/share/doc/swift/examples/object-server.conf
-usr/share/doc/swift-object/examples/rsyncd.conf usr/share/doc/swift/examples/rsyncd.conf
diff -pruN 2.25.0-3/debian/swift-object.lintian-overrides 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object.lintian-overrides
--- 2.25.0-3/debian/swift-object.lintian-overrides	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-swift-object binary: spelling-error-in-copyright Thier Their
diff -pruN 2.25.0-3/debian/swift-object.manpages 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object.manpages
--- 2.25.0-3/debian/swift-object.manpages	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-object.manpages	2020-09-15 21:14:38.000000000 +0000
@@ -1,10 +1,6 @@
-doc/manpages/object-expirer.conf.5
 doc/manpages/object-server.conf.5
 doc/manpages/swift-object-auditor.1
 doc/manpages/swift-object-info.1
-doc/manpages/swift-object-reconstructor.1
-doc/manpages/swift-object-relinker.1
 doc/manpages/swift-object-replicator.1
 doc/manpages/swift-object-server.1
 doc/manpages/swift-object-updater.1
-doc/manpages/swift-recon-cron.1
diff -pruN 2.25.0-3/debian/swift-proxy.docs 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-proxy.docs
--- 2.25.0-3/debian/swift-proxy.docs	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-proxy.docs	2020-09-15 21:14:38.000000000 +0000
@@ -0,0 +1,3 @@
+etc/memcache.conf-sample
+etc/mime.types-sample
+etc/proxy-server.conf-sample
diff -pruN 2.25.0-3/debian/swift-proxy.install 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-proxy.install
--- 2.25.0-3/debian/swift-proxy.install	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-proxy.install	2020-09-15 21:14:38.000000000 +0000
@@ -1,8 +1 @@
-#! /usr/bin/dh-exec --with=install
-etc/memcache.conf-sample => /etc/swift/memcache.conf
-etc/memcache.conf-sample => /usr/share/doc/swift-proxy/examples/memcache.conf
-etc/mime.types-sample => /etc/swift/mime.types
-etc/mime.types-sample => /usr/share/doc/swift-proxy/examples/mime.types
-etc/proxy-server.conf-sample => /etc/swift/proxy-server.conf
-etc/proxy-server.conf-sample => /usr/share/doc/swift-proxy/examples/proxy-server.conf
 usr/bin/swift-proxy-server
diff -pruN 2.25.0-3/debian/swift-proxy.links 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-proxy.links
--- 2.25.0-3/debian/swift-proxy.links	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-proxy.links	1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
-usr/share/doc/swift-proxy/examples/memcache.conf usr/share/doc/swift/examples/memcache.conf
-usr/share/doc/swift-proxy/examples/mime.types usr/share/doc/swift/examples/mime.types
-usr/share/doc/swift-proxy/examples/proxy-server.conf usr/share/doc/swift/examples/proxy-server.conf
diff -pruN 2.25.0-3/debian/swift-proxy.lintian-overrides 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-proxy.lintian-overrides
--- 2.25.0-3/debian/swift-proxy.lintian-overrides	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-proxy.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-swift-proxy binary: spelling-error-in-copyright Thier Their
diff -pruN 2.25.0-3/debian/swift.rsyslog 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift.rsyslog
--- 2.25.0-3/debian/swift.rsyslog	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift.rsyslog	1970-01-01 00:00:00.000000000 +0000
@@ -1,12 +0,0 @@
-if $programname startswith 'swift-account' then /var/log/swift/account.log
-if $programname startswith 'swift-account' then stop
-if $programname startswith 'swift-container' then /var/log/swift/container.log
-if $programname startswith 'swift-container' then stop
-if $programname startswith 'swift-object' then /var/log/swift/object.log
-if $programname startswith 'swift-object' then stop
-if $programname startswith 'swift-proxy' then /var/log/swift/proxy.log
-if $programname startswith 'swift-proxy' then stop
-if $programname startswith 'swift-drive-audit' then /var/log/swift/drive-audit.log
-if $programname startswith 'swift-drive-audit' then stop
-if $programname startswith 'swift' then /var/log/swift/swift.log
-if $programname startswith 'swift' then stop
diff -pruN 2.25.0-3/debian/swift-test.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-test.conf
--- 2.25.0-3/debian/swift-test.conf	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/swift-test.conf	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-[unit_test]
-fake_syslog = True
diff -pruN 2.25.0-3/debian/tests/control 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/tests/control
--- 2.25.0-3/debian/tests/control	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/tests/control	2020-09-15 21:14:38.000000000 +0000
@@ -1,18 +1,8 @@
-Tests: help
+Tests: swift-daemons
 Depends:
+ swift,
  swift-account,
  swift-container,
- swift-drive-audit,
  swift-object,
- swift-object-expirer,
  swift-proxy,
-
-Tests: daemons
-Depends:
- swift-account,
- swift-container,
- swift-object,
- swift-object-expirer,
- swift-proxy,
- wget,
-Restrictions: needs-root, isolation-container
+Restrictions: needs-root
diff -pruN 2.25.0-3/debian/tests/daemons 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/tests/daemons
--- 2.25.0-3/debian/tests/daemons	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/tests/daemons	1970-01-01 00:00:00.000000000 +0000
@@ -1,89 +0,0 @@
-#!/bin/bash
-#----------------
-# Testing daemons
-#----------------
-
-set -e
-
-export SYSTEMD_PAGER=
-
-# Daemons to test
-DAEMONS=(
-    swift-account
-    swift-account-auditor
-    swift-account-reaper
-    swift-account-replicator
-    swift-container
-    swift-container-auditor
-    swift-container-reconciler
-    swift-container-replicator
-    swift-container-sharder
-    swift-container-sync
-    swift-container-updater
-    swift-object
-    swift-object-auditor
-    swift-object-expirer
-    swift-object-reconstructor
-    swift-object-replicator
-    swift-object-updater
-    swift-proxy
-)
-
-
-echo "##### Create rings #####"
-mkdir -p /srv/node/sda1
-chown swift:swift /srv/node/sda1
-cd /etc/swift
-
-swift-ring-builder account.builder create 4 1 1
-swift-ring-builder object.builder create 4 1 1
-swift-ring-builder container.builder create 4 1 1
-
-swift-ring-builder account.builder add r1z1-127.0.0.1:6202/sda1 1
-swift-ring-builder container.builder add r1z1-127.0.0.1:6201/sda1 1
-swift-ring-builder object.builder add r1z1-127.0.0.1:6200/sda1 1
-
-swift-ring-builder account.builder rebalance
-swift-ring-builder container.builder rebalance
-swift-ring-builder object.builder rebalance
-
-echo "##### Start all daemons #####"
-for DAEMON in "${DAEMONS[@]}"; do
-    service "$DAEMON" restart
-done
-
-echo "##### Waiting for start #####"
-# Swift daemons sometimes crash after couple of seconds from start
-sleep 10
-
-echo "##### HTTP GET #####"
-echo -n "Object: "
-wget --no-verbose -t 5 --retry-connrefused --no-proxy -O - \
-    http://127.0.0.1:6200/recon/version 2>&1
-echo ""
-echo -n "Container: "
-wget --no-verbose -t 5 --retry-connrefused --no-proxy -O - \
-    http://127.0.0.1:6201/recon/version 2>&1
-echo ""
-echo -n "Account: "
-wget --no-verbose -t 5 --retry-connrefused --no-proxy -O - \
-    http://127.0.0.1:6202/recon/version 2>&1
-echo ""
-echo -n "Proxy: "
-wget --no-verbose -t 5 --retry-connrefused --no-proxy -O - \
-    http://127.0.0.1:8080/info 2>&1
-echo ""
-
-echo "##### Check all daemons #####"
-for DAEMON in "${DAEMONS[@]}"; do
-    service "$DAEMON" status </dev/null
-done
-
-echo "##### Stop all daemons #####"
-for DAEMON in "${DAEMONS[@]}"; do
-    service "$DAEMON" stop
-done
-
-echo "##### ALL DONE #####"
-
-exit 0
diff -pruN 2.25.0-3/debian/tests/help 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/tests/help
--- 2.25.0-3/debian/tests/help	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/tests/help	1970-01-01 00:00:00.000000000 +0000
@@ -1,38 +0,0 @@
-#!/bin/bash
-#-----------------------
-# Testing utilities help
-#-----------------------
-set -e
-
-cd "$AUTOPKGTEST_TMP"
-
-# Not working
-#  swift-account-audit
-#  swift-drive-audit
-#  swift-form-signature
-#  swift-recon-cron
-#  swift-ring-builder
-#  swift-temp-url
-
-CMDS=(
- 'swift-account-auditor' 'swift-account-info' 'swift-account-reaper'
- 'swift-account-replicator' 'swift-account-server' 'swift-config'
- 'swift-container-auditor' 'swift-container-info' 'swift-container-reconciler'
- 'swift-container-replicator' 'swift-container-server' 'swift-container-sharder'
- 'swift-container-sync' 'swift-container-updater' 'swift-dispersion-populate'
- 'swift-dispersion-report' 'swift-get-nodes'
- 'swift-object-auditor' 'swift-object-expirer' 'swift-object-info'
- 'swift-object-reconstructor' 'swift-object-replicator' 'swift-object-server'
- 'swift-object-updater' 'swift-oldies' 'swift-orphans' 'swift-proxy-server'
- 'swift-recon' 'swift-reconciler-enqueue' 'swift-ring-builder-analyzer'
- 'swift-ring-composer' 'swift-manage-shard-ranges' 'swift-object-relinker'
-)
-for cmd in "${CMDS[@]}"; do
-    if ! $cmd -h 2>&1 > /dev/null; then
-        echo "ERROR, ${cmd} is not running"
-        exit 1
-    else
-        echo "OK: ${cmd} is running"
-    fi
-done
-exit 0
diff -pruN 2.25.0-3/debian/tests/swift-daemons 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/tests/swift-daemons
--- 2.25.0-3/debian/tests/swift-daemons	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/tests/swift-daemons	2020-09-15 21:14:38.000000000 +0000
@@ -0,0 +1,56 @@
+#!/bin/bash
+#--------------------
+# Testing swift-proxy
+#--------------------
+set -e
+failure=false
+
+# copy config files
+mkdir -p /etc/swift 2>&1 > /dev/null
+cp /usr/share/doc/swift/swift.conf-sample /etc/swift/swift.conf 2>&1 > /dev/null
+cp /usr/share/doc/swift-proxy/proxy-server.conf-sample /etc/swift/proxy-server.conf 2>&1 > /dev/null
+
+# create rings
+cd /etc/swift 2>&1 > /dev/null
+swift-ring-builder account.builder create 18 1 1 2>&1 > /dev/null
+swift-ring-builder container.builder create 18 1 1 2>&1 > /dev/null
+swift-ring-builder object.builder create 18 1 1 2>&1 > /dev/null
+
+swift-ring-builder account.builder add z1-127.0.0.1:6002/sda1 100 2>&1 > /dev/null
+swift-ring-builder container.builder add z1-127.0.0.1:6001/sda1 100 2>&1 > /dev/null
+swift-ring-builder object.builder add z1-127.0.0.1:6000/sda1 100 2>&1 > /dev/null
+
+swift-ring-builder account.builder rebalance 2>&1 > /dev/null
+swift-ring-builder container.builder rebalance 2>&1 > /dev/null
+swift-ring-builder object.builder rebalance 2>&1 > /dev/null
+
+DAEMONS=('swift-proxy' 'swift-object' 'swift-container' 'swift-account')
+
+for daemon in "${DAEMONS[@]}"; do
+    systemctl restart $daemon
+done
+
+for daemon in "${DAEMONS[@]}"; do
+    TIMEOUT=50
+    while [ "$TIMEOUT" -gt 0 ]; do
+        if pidof -x ${daemon}-server > /dev/null; then
+            echo "OK"
+            break
+        fi
+        TIMEOUT=$((TIMEOUT - 1))
+        sleep 0.1
+    done
+
+    if [ "$TIMEOUT" -le 0 ]; then
+        echo "ERROR: ${daemon}-server IS NOT RUNNING"
+        failure=true
+    else
+        echo "${daemon}-server IS RUNNING"
+    fi
+done
+
+if [ "$failure" = true ]; then
+    exit 1
+fi
+
+exit 0
diff -pruN 2.25.0-3/debian/upstream/metadata 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/upstream/metadata
--- 2.25.0-3/debian/upstream/metadata	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/upstream/metadata	1970-01-01 00:00:00.000000000 +0000
@@ -1,5 +0,0 @@
-Bug-Database: https://bugs.launchpad.net/swift
-Bug-Submit: https://bugs.launchpad.net/swift/+filebug
-Name: Swift
-Repository: https://github.com/openstack/swift.git
-Repository-Browse: https://github.com/openstack/swift
diff -pruN 2.25.0-3/debian/watch 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/watch
--- 2.25.0-3/debian/watch	2020-08-31 07:47:24.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/debian/watch	2020-09-15 21:14:38.000000000 +0000
@@ -1,3 +1,3 @@
 version=3
-https://github.com/openstack/swift/tags .*/(\d[\d\.]+.*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
-https://tarballs.openstack.org/swift/ swift-(\d[\d\.]+.*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
+opts="uversionmangle=s/rc/~rc/" \
+ https://tarballs.opendev.org/openstack/swift/ swift-(\d.*).tar.gz
diff -pruN 2.25.0-3/doc/requirements.txt 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/requirements.txt
--- 2.25.0-3/doc/requirements.txt	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/requirements.txt	2020-09-15 21:13:36.000000000 +0000
@@ -2,10 +2,9 @@
 # of appearance. Changing the order has an impact on the overall integration
 # process, which may cause wedges in the gate later.
 # this is required for the docs build jobs
-sphinx>=1.6.2,<2.0.0;python_version=='2.7' # BSD
-sphinx>=1.6.2;python_version>='3.4' # BSD
-openstackdocstheme>=1.30.0 # Apache-2.0
-reno>=1.8.0  # Apache-2.0
+sphinx>=2.0.0,!=2.1.0 # BSD
+openstackdocstheme>=2.2.1 # Apache-2.0
+reno>=3.1.0 # Apache-2.0
 os-api-ref>=1.0.0 # Apache-2.0
 python-keystoneclient!=2.1.0,>=2.0.0 # Apache-2.0
 sphinxcontrib-svg2pdfconverter>=0.1.0 # BSD
diff -pruN 2.25.0-3/doc/saio/bin/remakerings 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/bin/remakerings
--- 2.25.0-3/doc/saio/bin/remakerings	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/bin/remakerings	2020-09-15 21:13:36.000000000 +0000
@@ -7,36 +7,36 @@ cd /etc/swift
 rm -f *.builder *.ring.gz backups/*.builder backups/*.ring.gz
 
 swift-ring-builder object.builder create 10 3 1
-swift-ring-builder object.builder add r1z1-127.0.0.1:6010/sdb1 1
-swift-ring-builder object.builder add r1z2-127.0.0.2:6020/sdb2 1
-swift-ring-builder object.builder add r1z3-127.0.0.3:6030/sdb3 1
-swift-ring-builder object.builder add r1z4-127.0.0.4:6040/sdb4 1
+swift-ring-builder object.builder add r1z1-127.0.0.1:6210/sdb1 1
+swift-ring-builder object.builder add r1z2-127.0.0.2:6220/sdb2 1
+swift-ring-builder object.builder add r1z3-127.0.0.3:6230/sdb3 1
+swift-ring-builder object.builder add r1z4-127.0.0.4:6240/sdb4 1
 swift-ring-builder object.builder rebalance
 swift-ring-builder object-1.builder create 10 2 1
-swift-ring-builder object-1.builder add r1z1-127.0.0.1:6010/sdb1 1
-swift-ring-builder object-1.builder add r1z2-127.0.0.2:6020/sdb2 1
-swift-ring-builder object-1.builder add r1z3-127.0.0.3:6030/sdb3 1
-swift-ring-builder object-1.builder add r1z4-127.0.0.4:6040/sdb4 1
+swift-ring-builder object-1.builder add r1z1-127.0.0.1:6210/sdb1 1
+swift-ring-builder object-1.builder add r1z2-127.0.0.2:6220/sdb2 1
+swift-ring-builder object-1.builder add r1z3-127.0.0.3:6230/sdb3 1
+swift-ring-builder object-1.builder add r1z4-127.0.0.4:6240/sdb4 1
 swift-ring-builder object-1.builder rebalance
 swift-ring-builder object-2.builder create 10 6 1
-swift-ring-builder object-2.builder add r1z1-127.0.0.1:6010/sdb1 1
-swift-ring-builder object-2.builder add r1z1-127.0.0.1:6010/sdb5 1
-swift-ring-builder object-2.builder add r1z2-127.0.0.2:6020/sdb2 1
-swift-ring-builder object-2.builder add r1z2-127.0.0.2:6020/sdb6 1
-swift-ring-builder object-2.builder add r1z3-127.0.0.3:6030/sdb3 1
-swift-ring-builder object-2.builder add r1z3-127.0.0.3:6030/sdb7 1
-swift-ring-builder object-2.builder add r1z4-127.0.0.4:6040/sdb4 1
-swift-ring-builder object-2.builder add r1z4-127.0.0.4:6040/sdb8 1
+swift-ring-builder object-2.builder add r1z1-127.0.0.1:6210/sdb1 1
+swift-ring-builder object-2.builder add r1z1-127.0.0.1:6210/sdb5 1
+swift-ring-builder object-2.builder add r1z2-127.0.0.2:6220/sdb2 1
+swift-ring-builder object-2.builder add r1z2-127.0.0.2:6220/sdb6 1
+swift-ring-builder object-2.builder add r1z3-127.0.0.3:6230/sdb3 1
+swift-ring-builder object-2.builder add r1z3-127.0.0.3:6230/sdb7 1
+swift-ring-builder object-2.builder add r1z4-127.0.0.4:6240/sdb4 1
+swift-ring-builder object-2.builder add r1z4-127.0.0.4:6240/sdb8 1
 swift-ring-builder object-2.builder rebalance
 swift-ring-builder container.builder create 10 3 1
-swift-ring-builder container.builder add r1z1-127.0.0.1:6011/sdb1 1
-swift-ring-builder container.builder add r1z2-127.0.0.2:6021/sdb2 1
-swift-ring-builder container.builder add r1z3-127.0.0.3:6031/sdb3 1
-swift-ring-builder container.builder add r1z4-127.0.0.4:6041/sdb4 1
+swift-ring-builder container.builder add r1z1-127.0.0.1:6211/sdb1 1
+swift-ring-builder container.builder add r1z2-127.0.0.2:6221/sdb2 1
+swift-ring-builder container.builder add r1z3-127.0.0.3:6231/sdb3 1
+swift-ring-builder container.builder add r1z4-127.0.0.4:6241/sdb4 1
 swift-ring-builder container.builder rebalance
 swift-ring-builder account.builder create 10 3 1
-swift-ring-builder account.builder add r1z1-127.0.0.1:6012/sdb1 1
-swift-ring-builder account.builder add r1z2-127.0.0.2:6022/sdb2 1
-swift-ring-builder account.builder add r1z3-127.0.0.3:6032/sdb3 1
-swift-ring-builder account.builder add r1z4-127.0.0.4:6042/sdb4 1
+swift-ring-builder account.builder add r1z1-127.0.0.1:6212/sdb1 1
+swift-ring-builder account.builder add r1z2-127.0.0.2:6222/sdb2 1
+swift-ring-builder account.builder add r1z3-127.0.0.3:6232/sdb3 1
+swift-ring-builder account.builder add r1z4-127.0.0.4:6242/sdb4 1
 swift-ring-builder account.builder rebalance
diff -pruN 2.25.0-3/doc/saio/rsyncd.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/rsyncd.conf
--- 2.25.0-3/doc/saio/rsyncd.conf	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/rsyncd.conf	2020-09-15 21:13:36.000000000 +0000
@@ -4,74 +4,74 @@ log file = /var/log/rsyncd.log
 pid file = /var/run/rsyncd.pid
 address = 0.0.0.0
 
-[account6012]
+[account6212]
 max connections = 25
 path = /srv/1/node/
 read only = false
-lock file = /var/lock/account6012.lock
+lock file = /var/lock/account6212.lock
 
-[account6022]
+[account6222]
 max connections = 25
 path = /srv/2/node/
 read only = false
-lock file = /var/lock/account6022.lock
+lock file = /var/lock/account6222.lock
 
-[account6032]
+[account6232]
 max connections = 25
 path = /srv/3/node/
 read only = false
-lock file = /var/lock/account6032.lock
+lock file = /var/lock/account6232.lock
 
-[account6042]
+[account6242]
 max connections = 25
 path = /srv/4/node/
 read only = false
-lock file = /var/lock/account6042.lock
+lock file = /var/lock/account6242.lock
 
-[container6011]
+[container6211]
 max connections = 25
 path = /srv/1/node/
 read only = false
-lock file = /var/lock/container6011.lock
+lock file = /var/lock/container6211.lock
 
-[container6021]
+[container6221]
 max connections = 25
 path = /srv/2/node/
 read only = false
-lock file = /var/lock/container6021.lock
+lock file = /var/lock/container6221.lock
 
-[container6031]
+[container6231]
 max connections = 25
 path = /srv/3/node/
 read only = false
-lock file = /var/lock/container6031.lock
+lock file = /var/lock/container6231.lock
 
-[container6041]
+[container6241]
 max connections = 25
 path = /srv/4/node/
 read only = false
-lock file = /var/lock/container6041.lock
+lock file = /var/lock/container6241.lock
 
-[object6010]
+[object6210]
 max connections = 25
 path = /srv/1/node/
 read only = false
-lock file = /var/lock/object6010.lock
+lock file = /var/lock/object6210.lock
 
-[object6020]
+[object6220]
 max connections = 25
 path = /srv/2/node/
 read only = false
-lock file = /var/lock/object6020.lock
+lock file = /var/lock/object6220.lock
 
-[object6030]
+[object6230]
 max connections = 25
 path = /srv/3/node/
 read only = false
-lock file = /var/lock/object6030.lock
+lock file = /var/lock/object6230.lock
 
-[object6040]
+[object6240]
 max connections = 25
 path = /srv/4/node/
 read only = false
-lock file = /var/lock/object6040.lock
+lock file = /var/lock/object6240.lock
diff -pruN 2.25.0-3/doc/saio/swift/account-server/1.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/account-server/1.conf
--- 2.25.0-3/doc/saio/swift/account-server/1.conf	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/account-server/1.conf	2020-09-15 21:13:36.000000000 +0000
@@ -3,7 +3,7 @@ devices = /srv/1/node
 mount_check = false
 disable_fallocate = true
 bind_ip = 127.0.0.1
-bind_port = 6012
+bind_port = 6212
 workers = 1
 user = <your-user-name>
 log_facility = LOG_LOCAL2
diff -pruN 2.25.0-3/doc/saio/swift/account-server/2.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/account-server/2.conf
--- 2.25.0-3/doc/saio/swift/account-server/2.conf	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/account-server/2.conf	2020-09-15 21:13:36.000000000 +0000
@@ -3,7 +3,7 @@ devices = /srv/2/node
 mount_check = false
 disable_fallocate = true
 bind_ip = 127.0.0.2
-bind_port = 6022
+bind_port = 6222
 workers = 1
 user = <your-user-name>
 log_facility = LOG_LOCAL3
diff -pruN 2.25.0-3/doc/saio/swift/account-server/3.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/account-server/3.conf
--- 2.25.0-3/doc/saio/swift/account-server/3.conf	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/account-server/3.conf	2020-09-15 21:13:36.000000000 +0000
@@ -3,7 +3,7 @@ devices = /srv/3/node
 mount_check = false
 disable_fallocate = true
 bind_ip = 127.0.0.3
-bind_port = 6032
+bind_port = 6232
 workers = 1
 user = <your-user-name>
 log_facility = LOG_LOCAL4
diff -pruN 2.25.0-3/doc/saio/swift/account-server/4.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/account-server/4.conf
--- 2.25.0-3/doc/saio/swift/account-server/4.conf	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/account-server/4.conf	2020-09-15 21:13:36.000000000 +0000
@@ -3,7 +3,7 @@ devices = /srv/4/node
 mount_check = false
 disable_fallocate = true
 bind_ip = 127.0.0.4
-bind_port = 6042
+bind_port = 6242
 workers = 1
 user = <your-user-name>
 log_facility = LOG_LOCAL5
diff -pruN 2.25.0-3/doc/saio/swift/container-server/1.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/container-server/1.conf
--- 2.25.0-3/doc/saio/swift/container-server/1.conf	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/container-server/1.conf	2020-09-15 21:13:36.000000000 +0000
@@ -3,7 +3,7 @@ devices = /srv/1/node
 mount_check = false
 disable_fallocate = true
 bind_ip = 127.0.0.1
-bind_port = 6011
+bind_port = 6211
 workers = 1
 user = <your-user-name>
 log_facility = LOG_LOCAL2
diff -pruN 2.25.0-3/doc/saio/swift/container-server/2.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/container-server/2.conf
--- 2.25.0-3/doc/saio/swift/container-server/2.conf	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/container-server/2.conf	2020-09-15 21:13:36.000000000 +0000
@@ -3,7 +3,7 @@ devices = /srv/2/node
 mount_check = false
 disable_fallocate = true
 bind_ip = 127.0.0.2
-bind_port = 6021
+bind_port = 6221
 workers = 1
 user = <your-user-name>
 log_facility = LOG_LOCAL3
diff -pruN 2.25.0-3/doc/saio/swift/container-server/3.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/container-server/3.conf
--- 2.25.0-3/doc/saio/swift/container-server/3.conf	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/container-server/3.conf	2020-09-15 21:13:36.000000000 +0000
@@ -3,7 +3,7 @@ devices = /srv/3/node
 mount_check = false
 disable_fallocate = true
 bind_ip = 127.0.0.3
-bind_port = 6031
+bind_port = 6231
 workers = 1
 user = <your-user-name>
 log_facility = LOG_LOCAL4
diff -pruN 2.25.0-3/doc/saio/swift/container-server/4.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/container-server/4.conf
--- 2.25.0-3/doc/saio/swift/container-server/4.conf	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/container-server/4.conf	2020-09-15 21:13:36.000000000 +0000
@@ -3,7 +3,7 @@ devices = /srv/4/node
 mount_check = false
 disable_fallocate = true
 bind_ip = 127.0.0.4
-bind_port = 6041
+bind_port = 6241
 workers = 1
 user = <your-user-name>
 log_facility = LOG_LOCAL5
diff -pruN 2.25.0-3/doc/saio/swift/object-server/1.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/object-server/1.conf
--- 2.25.0-3/doc/saio/swift/object-server/1.conf	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/object-server/1.conf	2020-09-15 21:13:36.000000000 +0000
@@ -3,7 +3,7 @@ devices = /srv/1/node
 mount_check = false
 disable_fallocate = true
 bind_ip = 127.0.0.1
-bind_port = 6010
+bind_port = 6210
 workers = 1
 user = <your-user-name>
 log_facility = LOG_LOCAL2
diff -pruN 2.25.0-3/doc/saio/swift/object-server/2.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/object-server/2.conf
--- 2.25.0-3/doc/saio/swift/object-server/2.conf	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/object-server/2.conf	2020-09-15 21:13:36.000000000 +0000
@@ -3,7 +3,7 @@ devices = /srv/2/node
 mount_check = false
 disable_fallocate = true
 bind_ip = 127.0.0.2
-bind_port = 6020
+bind_port = 6220
 workers = 1
 user = <your-user-name>
 log_facility = LOG_LOCAL3
diff -pruN 2.25.0-3/doc/saio/swift/object-server/3.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/object-server/3.conf
--- 2.25.0-3/doc/saio/swift/object-server/3.conf	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/object-server/3.conf	2020-09-15 21:13:36.000000000 +0000
@@ -3,7 +3,7 @@ devices = /srv/3/node
 mount_check = false
 disable_fallocate = true
 bind_ip = 127.0.0.3
-bind_port = 6030
+bind_port = 6230
 workers = 1
 user = <your-user-name>
 log_facility = LOG_LOCAL4
diff -pruN 2.25.0-3/doc/saio/swift/object-server/4.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/object-server/4.conf
--- 2.25.0-3/doc/saio/swift/object-server/4.conf	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/object-server/4.conf	2020-09-15 21:13:36.000000000 +0000
@@ -3,7 +3,7 @@ devices = /srv/4/node
 mount_check = false
 disable_fallocate = true
 bind_ip = 127.0.0.4
-bind_port = 6040
+bind_port = 6240
 workers = 1
 user = <your-user-name>
 log_facility = LOG_LOCAL5
diff -pruN 2.25.0-3/doc/saio/swift/proxy-server.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/proxy-server.conf
--- 2.25.0-3/doc/saio/swift/proxy-server.conf	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/saio/swift/proxy-server.conf	2020-09-15 21:13:36.000000000 +0000
@@ -80,6 +80,9 @@ use = egg:swift#copy
 [filter:listing_formats]
 use = egg:swift#listing_formats
 
+[filter:domain_remap]
+use = egg:swift#domain_remap
+
 [filter:symlink]
 use = egg:swift#symlink
 
diff -pruN 2.25.0-3/doc/source/admin_guide.rst 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/admin_guide.rst
--- 2.25.0-3/doc/source/admin_guide.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/admin_guide.rst	2020-09-15 21:13:36.000000000 +0000
@@ -717,7 +717,7 @@ Once the recon middleware is enabled, a
 "/recon/<metric>" to the backend object server will return a
 JSON-formatted response::
 
-    fhines@ubuntu:~$ curl -i http://localhost:6030/recon/async
+    fhines@ubuntu:~$ curl -i http://localhost:6230/recon/async
     HTTP/1.1 200 OK
     Content-Type: application/json
     Content-Length: 20
@@ -727,7 +727,7 @@ JSON-formatted response::
 
 
 Note that the default port for the object server is 6200, except on a
-Swift All-In-One installation, which uses 6010, 6020, 6030, and 6040.
+Swift All-In-One installation, which uses 6210, 6220, 6230, and 6240.
 
 The following metrics and telemetry are currently exposed:
 
diff -pruN 2.25.0-3/doc/source/conf.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/conf.py
--- 2.25.0-3/doc/source/conf.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/conf.py	2020-09-15 21:13:36.000000000 +0000
@@ -29,7 +29,6 @@
 import datetime
 import logging
 import os
-from swift import __version__
 import sys
 
 # NOTE(amotoki): Our current doc build job uses an older version of
@@ -80,15 +79,6 @@ else:
     now = datetime.date.today()
 copyright = u'%d, OpenStack Foundation' % now.year
 
-# The version info for the project you're documenting, acts as replacement for
-# |version| and |release|, also used in various other places throughout the
-# built documents.
-#
-# The short X.Y version.
-version = __version__.rsplit('.', 1)[0]
-# The full version, including alpha/beta/rc tags.
-release = __version__
-
 # The language for content autogenerated by Sphinx. Refer to documentation
 # for a list of supported languages.
 # language = None
@@ -122,7 +112,7 @@ exclude_trees = []
 show_authors = True
 
 # The name of the Pygments (syntax highlighting) style to use.
-pygments_style = 'sphinx'
+pygments_style = 'native'
 
 # A list of ignored prefixes for module index sorting.
 modindex_common_prefix = ['swift.']
@@ -172,11 +162,6 @@ html_theme_options = {
 # robots.txt.
 html_extra_path = ['_extra']
 
-# If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
-# using the given strftime format.
-# html_last_updated_fmt = '%b %d, %Y'
-html_last_updated_fmt = '%Y-%m-%d %H:%M'
-
 # If true, SmartyPants will be used to convert quotes and dashes to
 # typographically correct entities.
 # html_use_smartypants = True
@@ -248,6 +233,8 @@ latex_documents = [
 latex_use_xindy = False
 
 # -- Options for openstackdocstheme -------------------------------------------
-repository_name = 'openstack/swift'
-bug_project = 'swift'
-bug_tag = ''
+openstackdocs_repo_name = 'openstack/swift'
+openstackdocs_pdf_link = True
+openstackdocs_auto_name = False
+openstackdocs_bug_project = 'swift'
+openstackdocs_bug_tag = ''
diff -pruN 2.25.0-3/doc/source/contributor/contributing.rst 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/contributor/contributing.rst
--- 2.25.0-3/doc/source/contributor/contributing.rst	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/contributor/contributing.rst	2020-09-15 21:13:36.000000000 +0000
@@ -0,0 +1,79 @@
+.. include:: ../../../CONTRIBUTING.rst
+
+Community
+=========
+
+Communication
+-------------
+IRC
+    People working on the Swift project may be found in the
+    ``#openstack-swift`` channel on Freenode during working hours
+    in their timezone.  The channel is logged, so if you ask a question
+    when no one is around, you can check the log to see if it's been
+    answered: http://eavesdrop.openstack.org/irclogs/%23openstack-swift/
+
+weekly meeting
+    This is a Swift team meeting. The discussion in this meeting is about
+    all things related to the Swift project:
+
+- time: http://eavesdrop.openstack.org/#Swift_Team_Meeting
+- agenda: https://wiki.openstack.org/wiki/Meetings/Swift
+
+mailing list
+    We use the openstack-discuss@lists.openstack.org mailing list for
+    asynchronous discussions or to communicate with other OpenStack teams.
+    Use the prefix ``[swift]`` in your subject line (it's a high-volume
+    list, so most people use email filters).
+
+    More information about the mailing list, including how to subscribe
+    and read the archives, can be found at:
+    http://lists.openstack.org/cgi-bin/mailman/listinfo/openstack-discuss
+
+Contacting the Core Team
+------------------------
+
+The swift-core team is an active group of contributors who are responsible
+for directing and maintaining the Swift project.  As a new contributor, your
+interaction with this group will be mostly through code reviews, because
+only members of swift-core can approve a code change to be merged into the
+code repository. But the swift-core team also spend time on IRC so feel
+free to drop in to ask questions or just to meet us.
+
+.. note::
+   Although your contribution will require reviews by members of
+   swift-core, these aren't the only people whose reviews matter.
+   Anyone with a gerrit account can post reviews, so you can ask
+   other developers you know to review your code ... and you can
+   review theirs.  (A good way to learn your way around the codebase
+   is to review other people's patches.)
+
+   If you're thinking, "I'm new at this, how can I possibly provide
+   a helpful review?", take a look at `How to Review Changes the
+   OpenStack Way
+   <https://docs.openstack.org/project-team-guide/review-the-openstack-way.html>`_.
+
+   Or for more specifically in a Swift context read :doc:`review_guidelines`
+
+You can learn more about the role of core reviewers in the OpenStack
+governance documentation:
+https://docs.openstack.org/contributors/common/governance.html#core-reviewer
+
+The membership list of swift-core is maintained in gerrit:
+https://review.opendev.org/#/admin/groups/24,members
+
+You can also find the members of the swift-core team at the Swift weekly
+meetings.
+
+Getting Your Patch Merged
+-------------------------
+Understanding how reviewers review and what they look for will help getting
+your code merged. See `Swift Review Guidelines <contributor/review_guidelines>`_
+for how we review code.
+
+Keep in mind that reviewers are also human; if something feels stalled, then
+come and poke us on IRC or add it to our meeting agenda.
+
+Project Team Lead Duties
+------------------------
+All common PTL duties are enumerated in the `PTL guide
+<https://docs.openstack.org/project-team-guide/ptl.html>`_.
diff -pruN 2.25.0-3/doc/source/contributor/review_guidelines.rst 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/contributor/review_guidelines.rst
--- 2.25.0-3/doc/source/contributor/review_guidelines.rst	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/contributor/review_guidelines.rst	2020-09-15 21:13:36.000000000 +0000
@@ -0,0 +1 @@
+.. include:: ../../../REVIEW_GUIDELINES.rst
diff -pruN 2.25.0-3/doc/source/deployment_guide.rst 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/deployment_guide.rst
--- 2.25.0-3/doc/source/deployment_guide.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/deployment_guide.rst	2020-09-15 21:13:36.000000000 +0000
@@ -179,7 +179,7 @@ each)::
               2       1     2       1.1.0.2    6200       1.1.0.2                6200      d3
               3       1     2       1.1.0.2    6200       1.1.0.2                6200      d4
 
-And here's the same ring set up for `servers_per_port`::
+And here's the same ring set up for ``servers_per_port``::
 
  Devices:    id  region  zone      ip address  port  replication ip  replication port      name
               0       1     1       1.1.0.1    6200       1.1.0.1                6200      d1
@@ -187,24 +187,24 @@ And here's the same ring set up for `ser
               2       1     2       1.1.0.2    6200       1.1.0.2                6200      d3
               3       1     2       1.1.0.2    6201       1.1.0.2                6201      d4
 
-When migrating from normal to `servers_per_port`, perform these steps in order:
+When migrating from normal to ``servers_per_port``, perform these steps in order:
 
- #. Upgrade Swift code to a version capable of doing `servers_per_port`.
+#. Upgrade Swift code to a version capable of doing ``servers_per_port``.
 
- #. Enable `servers_per_port` with a > 0 value
+#. Enable ``servers_per_port`` with a value greater than zero.
 
- #. Restart `swift-object-server` processes with a SIGHUP.  At this point, you
-    will have the `servers_per_port` number of `swift-object-server` processes
-    serving all requests for all disks on each node.  This preserves
-    availability, but you should perform the next step as quickly as possible.
-
- #. Push out new rings that actually have different ports per disk on each
-    server.  One of the ports in the new ring should be the same as the port
-    used in the old ring ("6200" in the example above).  This will cover
-    existing proxy-server processes who haven't loaded the new ring yet.  They
-    can still talk to any storage node regardless of whether or not that
-    storage node has loaded the ring and started object-server processes on the
-    new ports.
+#. Restart ``swift-object-server`` processes with a SIGHUP.  At this point, you
+   will have the ``servers_per_port`` number of ``swift-object-server`` processes
+   serving all requests for all disks on each node.  This preserves
+   availability, but you should perform the next step as quickly as possible.
+
+#. Push out new rings that actually have different ports per disk on each
+   server.  One of the ports in the new ring should be the same as the port
+   used in the old ring ("6200" in the example above).  This will cover
+   existing proxy-server processes who haven't loaded the new ring yet.  They
+   can still talk to any storage node regardless of whether or not that
+   storage node has loaded the ring and started object-server processes on the
+   new ports.
 
 If you do not run a separate object-server for replication, then this setting
 must be available to the object-replicator and object-reconstructor (i.e.
@@ -302,7 +302,7 @@ General Server Configuration
 Swift uses paste.deploy (http://pythonpaste.org/deploy/) to manage server
 configurations.
 
-Default configuration options are set in the `[DEFAULT]` section, and any
+Default configuration options are set in the ``[DEFAULT]`` section, and any
 options specified there can be overridden in any of the other sections BUT
 ONLY BY USING THE SYNTAX ``set option_name = value``. This is the unfortunate
 way paste.deploy works and I'll try to explain it in full.
@@ -336,30 +336,30 @@ The resulting configuration that myapp r
             'set name4': 'globalvalue'}
     local {'name6': 'localvalue'}
 
-So, `name1` got the global value which is fine since it's only in the `DEFAULT`
+So, ``name1`` got the global value which is fine since it's only in the ``DEFAULT``
 section anyway.
 
-`name2` got the global value from `DEFAULT` even though it appears to be
-overridden in the `app:myapp` subsection. This is just the unfortunate way
+``name2`` got the global value from ``DEFAULT`` even though it appears to be
+overridden in the ``app:myapp`` subsection. This is just the unfortunate way
 paste.deploy works (at least at the time of this writing.)
 
-`name3` got the local value from the `app:myapp` subsection because it is using
+``name3`` got the local value from the ``app:myapp`` subsection because it is using
 the special paste.deploy syntax of ``set option_name = value``. So, if you want
 a default value for most app/filters but want to override it in one
 subsection, this is how you do it.
 
-`name4` got the global value from `DEFAULT` since it's only in that section
-anyway. But, since we used the ``set`` syntax in the `DEFAULT` section even
+``name4`` got the global value from ``DEFAULT`` since it's only in that section
+anyway. But, since we used the ``set`` syntax in the ``DEFAULT`` section even
 though we shouldn't, notice we also got a ``set name4`` variable. Weird, but
 probably not harmful.
 
-`name5` got the local value from the `app:myapp` subsection since it's only
+``name5`` got the local value from the ``app:myapp`` subsection since it's only
 there anyway, but notice that it is in the global configuration and not the
 local configuration. This is because we used the ``set`` syntax to set the
 value. Again, weird, but not harmful since Swift just treats the two sets of
 configuration values as one set anyway.
 
-`name6` got the local value from `app:myapp` subsection since it's only there,
+``name6`` got the local value from ``app:myapp`` subsection since it's only there,
 and since we didn't use the ``set`` syntax, it's only in the local
 configuration and not the global one. Though, as indicated above, there is no
 special distinction with Swift.
@@ -573,7 +573,7 @@ Option                             Defau
 use                                                       paste.deploy entry point for the
                                                           object server.  For most cases,
                                                           this should be
-                                                          `egg:swift#object`.
+                                                          ``egg:swift#object``.
 set log_name                       object-server          Label used when logging
 set log_facility                   LOG_LOCAL0             Syslog log facility
 set log_level                      INFO                   Logging level
@@ -1026,13 +1026,13 @@ processes                     0
                                                               When set 0 means that a single legacy
                                                               process will be doing all the work.
                                                               This can only be used in conjunction with
-                                                              `dequeue_from_legacy`.
+                                                              ``dequeue_from_legacy``.
 process                       0                               Which of the parts a particular legacy process will
                                                               work on. It is "zero based", if you want to use 3
                                                               processes, you should run processes with process
                                                               set to 0, 1, and 2.
                                                               This can only be used in conjunction with
-                                                              `dequeue_from_legacy`.
+                                                              ``dequeue_from_legacy``.
 reclaim_age                   604800                          How long an un-processable expired object
                                                               marker will be retried before it is abandoned.
                                                               It is not coupled with the tombstone reclaim age
@@ -1184,7 +1184,7 @@ Option                          Default
 ------------------------------  ----------------  ----------------------------------------
 use                                               paste.deploy entry point for the
                                                   container server.  For most cases, this
-                                                  should be `egg:swift#container`.
+                                                  should be ``egg:swift#container``.
 set log_name                    container-server  Label used when logging
 set log_facility                LOG_LOCAL0        Syslog log facility
 set log_level                   INFO              Logging level
@@ -1541,7 +1541,7 @@ Option                         Default
 -----------------------------  --------------  ------------------------------------------
 use                                            Entry point for paste.deploy for the account
                                                server.  For most cases, this should be
-                                               `egg:swift#account`.
+                                               ``egg:swift#account``.
 set log_name                   account-server  Label used when logging
 set log_facility               LOG_LOCAL0      Syslog log facility
 set log_level                  INFO            Logging level
@@ -1929,7 +1929,7 @@ Option
 use                                                      Entry point for paste.deploy for
                                                          the proxy server.  For most
                                                          cases, this should be
-                                                         `egg:swift#proxy`.
+                                                         ``egg:swift#proxy``.
 set log_name                            proxy-server     Label used when logging
 set log_facility                        LOG_LOCAL0       Syslog log facility
 set log_level                           INFO             Log level
@@ -2232,8 +2232,8 @@ Several of the Services rely on Memcache
 lookups, such as auth tokens, and container/account existence.  Swift does
 not do any caching of actual object data.  Memcached should be able to run
 on any servers that have available RAM and CPU.  At Rackspace, we run
-Memcached on the proxy servers.  The `memcache_servers` config option
-in the `proxy-server.conf` should contain all memcached servers.
+Memcached on the proxy servers.  The ``memcache_servers`` config option
+in the ``proxy-server.conf`` should contain all memcached servers.
 
 -----------
 System Time
@@ -2253,7 +2253,7 @@ should also be monitored to ensure that
 General Service Tuning
 ----------------------
 
-Most services support either a `worker` or `concurrency` value in the
+Most services support either a ``workers`` or ``concurrency`` value in the
 settings.  This allows the services to make effective use of the cores
 available. A good starting point to set the concurrency level for the proxy
 and storage services to 2 times the number of cores available. If more than
@@ -2270,7 +2270,7 @@ and Object servers with 8 workers each.
 a concurrency of 1, with the exception of the replicators which are run at a
 concurrency of 2.
 
-The `max_clients` parameter can be used to adjust the number of client
+The ``max_clients`` parameter can be used to adjust the number of client
 requests an individual worker accepts for processing. The fewer requests being
 processed at one time, the less likely a request that consumes the worker's
 CPU time, or blocks in the OS, will negatively impact other requests. The more
@@ -2282,8 +2282,8 @@ more workers, raising the number of work
 clients serviced per worker can lessen the impact of CPU intensive or stalled
 requests.
 
-The `nice_priority` parameter can be used to set program scheduling priority.
-The `ionice_class` and `ionice_priority` parameters can be used to set I/O scheduling
+The ``nice_priority`` parameter can be used to set program scheduling priority.
+The ``ionice_class`` and ``ionice_priority`` parameters can be used to set I/O scheduling
 class and priority on the systems that use an I/O scheduler that supports
 I/O priorities. As at kernel 2.6.17 the only such scheduler is the Completely
 Fair Queuing (CFQ) I/O scheduler. If you run your Storage servers all together
@@ -2331,7 +2331,7 @@ headroom.
 
 The following example mount options are recommended when using XFS::
 
-    mount -t xfs -o noatime,nodiratime,logbufs=8 -L D1 /srv/node/d1
+    mount -t xfs -o noatime -L D1 /srv/node/d1
 
 We do not recommend running Swift on RAID, but if you are using
 RAID it is also important to make sure that the proper sunit and swidth
@@ -2340,7 +2340,7 @@ settings get set so that XFS can make mo
 For a standard Swift install, all data drives are mounted directly under
 ``/srv/node`` (as can be seen in the above example of mounting label ``D1``
 as ``/srv/node/d1``). If you choose to mount the drives in another directory,
-be sure to set the `devices` config option in all of the server configs to
+be sure to set the ``devices`` config option in all of the server configs to
 point to the correct directory.
 
 The mount points for each drive in ``/srv/node/`` should be owned by the root user
@@ -2348,8 +2348,8 @@ almost exclusively (``root:root 755``).
 syncing files into the root drive in the event a drive is unmounted.
 
 Swift uses system calls to reserve space for new objects being written into
-the system. If your filesystem does not support `fallocate()` or
-`posix_fallocate()`, be sure to set the `disable_fallocate = true` config
+the system. If your filesystem does not support ``fallocate()`` or
+``posix_fallocate()``, be sure to set the ``disable_fallocate = true`` config
 parameter in account, container, and object server configs.
 
 Most current Linux distributions ship with a default installation of updatedb.
@@ -2357,7 +2357,7 @@ This tool runs periodically and updates
 the GNU locate tool. However, including Swift object and container database
 files is most likely not required and the periodic update affects the
 performance quite a bit. To disable the inclusion of these files add the path
-where Swift stores its data to the setting PRUNEPATHS in `/etc/updatedb.conf`::
+where Swift stores its data to the setting PRUNEPATHS in ``/etc/updatedb.conf``::
 
     PRUNEPATHS="... /tmp ... /var/spool ... /srv/node"
 
@@ -2369,7 +2369,7 @@ General System Tuning
 Rackspace currently runs Swift on Ubuntu Server 10.04, and the following
 changes have been found to be useful for our use cases.
 
-The following settings should be in `/etc/sysctl.conf`::
+The following settings should be in ``/etc/sysctl.conf``::
 
     # disable TIME_WAIT.. wait..
     net.ipv4.tcp_tw_recycle=1
@@ -2395,7 +2395,7 @@ Logging Considerations
 ----------------------
 
 Swift is set up to log directly to syslog. Every service can be configured
-with the `log_facility` option to set the syslog log facility destination.
+with the ``log_facility`` option to set the syslog log facility destination.
 We recommended using syslog-ng to route the logs to specific log
 files locally on the server and also to remote log collecting servers.
 Additionally, custom log handlers can be used via the custom_log_handlers
diff -pruN 2.25.0-3/doc/source/development_saio.rst 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/development_saio.rst
--- 2.25.0-3/doc/source/development_saio.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/development_saio.rst	2020-09-15 21:13:36.000000000 +0000
@@ -141,7 +141,7 @@ another device when creating the VM, and
 
 #. Edit ``/etc/fstab`` and add::
 
-      UUID="<UUID-from-output-above>" /mnt/sdb1 xfs noatime,nodiratime,logbufs=8 0 0
+      UUID="<UUID-from-output-above>" /mnt/sdb1 xfs noatime 0 0
 
 #. Create the Swift data mount point and test that mounting works::
 
@@ -169,7 +169,7 @@ these instructions:
 
 #. Edit `/etc/fstab` and add::
 
-      /srv/swift-disk /mnt/sdb1 xfs loop,noatime,nodiratime,logbufs=8 0 0
+      /srv/swift-disk /mnt/sdb1 xfs loop,noatime 0 0
 
 #. Create the Swift data mount point and test that mounting works::
 
@@ -258,23 +258,23 @@ environment variable.
 
 * To mount the tmp loopback device at ``/tmp``, do the following::
 
-      sudo mount -o loop,noatime,nodiratime /srv/swift-tmp /tmp
+      sudo mount -o loop,noatime /srv/swift-tmp /tmp
       sudo chmod -R 1777 /tmp
 
   * To persist this, edit and add the following to ``/etc/fstab``::
 
-        /srv/swift-tmp /tmp xfs rw,noatime,nodiratime,attr2,inode64,noquota 0 0
+        /srv/swift-tmp /tmp xfs rw,noatime,attr2,inode64,noquota 0 0
 
 * To mount the tmp loopback at an alternate location (for example, ``/mnt/tmp``),
   do the following::
 
       sudo mkdir -p /mnt/tmp
-      sudo mount -o loop,noatime,nodiratime /srv/swift-tmp /mnt/tmp
+      sudo mount -o loop,noatime /srv/swift-tmp /mnt/tmp
       sudo chown ${USER}:${USER} /mnt/tmp
 
   * To persist this, edit and add the following to ``/etc/fstab``::
 
-        /srv/swift-tmp /mnt/tmp xfs rw,noatime,nodiratime,attr2,inode64,noquota 0 0
+        /srv/swift-tmp /mnt/tmp xfs rw,noatime,attr2,inode64,noquota 0 0
 
   * Set your ``TMPDIR`` environment dir so that Swift looks in the right location::
 
@@ -385,18 +385,18 @@ Setting up rsync
 
    You should see the following output from the above command::
 
-      account6012
-      account6022
-      account6032
-      account6042
-      container6011
-      container6021
-      container6031
-      container6041
-      object6010
-      object6020
-      object6030
-      object6040
+      account6212
+      account6222
+      account6232
+      account6242
+      container6211
+      container6221
+      container6231
+      container6241
+      object6210
+      object6220
+      object6230
+      object6240
 
 ------------------
 Starting memcached
@@ -670,34 +670,34 @@ Constructing initial rings
 
    .. code-block:: console
 
-      Device d0r1z1-127.0.0.1:6010R127.0.0.1:6010/sdb1_"" with 1.0 weight got id 0
-      Device d1r1z2-127.0.0.2:6020R127.0.0.2:6020/sdb2_"" with 1.0 weight got id 1
-      Device d2r1z3-127.0.0.3:6030R127.0.0.3:6030/sdb3_"" with 1.0 weight got id 2
-      Device d3r1z4-127.0.0.4:6040R127.0.0.4:6040/sdb4_"" with 1.0 weight got id 3
+      Device d0r1z1-127.0.0.1:6210R127.0.0.1:6210/sdb1_"" with 1.0 weight got id 0
+      Device d1r1z2-127.0.0.2:6220R127.0.0.2:6220/sdb2_"" with 1.0 weight got id 1
+      Device d2r1z3-127.0.0.3:6230R127.0.0.3:6230/sdb3_"" with 1.0 weight got id 2
+      Device d3r1z4-127.0.0.4:6240R127.0.0.4:6240/sdb4_"" with 1.0 weight got id 3
       Reassigned 3072 (300.00%) partitions. Balance is now 0.00.  Dispersion is now 0.00
-      Device d0r1z1-127.0.0.1:6010R127.0.0.1:6010/sdb1_"" with 1.0 weight got id 0
-      Device d1r1z2-127.0.0.2:6020R127.0.0.2:6020/sdb2_"" with 1.0 weight got id 1
-      Device d2r1z3-127.0.0.3:6030R127.0.0.3:6030/sdb3_"" with 1.0 weight got id 2
-      Device d3r1z4-127.0.0.4:6040R127.0.0.4:6040/sdb4_"" with 1.0 weight got id 3
+      Device d0r1z1-127.0.0.1:6210R127.0.0.1:6210/sdb1_"" with 1.0 weight got id 0
+      Device d1r1z2-127.0.0.2:6220R127.0.0.2:6220/sdb2_"" with 1.0 weight got id 1
+      Device d2r1z3-127.0.0.3:6230R127.0.0.3:6230/sdb3_"" with 1.0 weight got id 2
+      Device d3r1z4-127.0.0.4:6240R127.0.0.4:6240/sdb4_"" with 1.0 weight got id 3
       Reassigned 2048 (200.00%) partitions. Balance is now 0.00.  Dispersion is now 0.00
-      Device d0r1z1-127.0.0.1:6010R127.0.0.1:6010/sdb1_"" with 1.0 weight got id 0
-      Device d1r1z1-127.0.0.1:6010R127.0.0.1:6010/sdb5_"" with 1.0 weight got id 1
-      Device d2r1z2-127.0.0.2:6020R127.0.0.2:6020/sdb2_"" with 1.0 weight got id 2
-      Device d3r1z2-127.0.0.2:6020R127.0.0.2:6020/sdb6_"" with 1.0 weight got id 3
-      Device d4r1z3-127.0.0.3:6030R127.0.0.3:6030/sdb3_"" with 1.0 weight got id 4
-      Device d5r1z3-127.0.0.3:6030R127.0.0.3:6030/sdb7_"" with 1.0 weight got id 5
-      Device d6r1z4-127.0.0.4:6040R127.0.0.4:6040/sdb4_"" with 1.0 weight got id 6
-      Device d7r1z4-127.0.0.4:6040R127.0.0.4:6040/sdb8_"" with 1.0 weight got id 7
+      Device d0r1z1-127.0.0.1:6210R127.0.0.1:6210/sdb1_"" with 1.0 weight got id 0
+      Device d1r1z1-127.0.0.1:6210R127.0.0.1:6210/sdb5_"" with 1.0 weight got id 1
+      Device d2r1z2-127.0.0.2:6220R127.0.0.2:6220/sdb2_"" with 1.0 weight got id 2
+      Device d3r1z2-127.0.0.2:6220R127.0.0.2:6220/sdb6_"" with 1.0 weight got id 3
+      Device d4r1z3-127.0.0.3:6230R127.0.0.3:6230/sdb3_"" with 1.0 weight got id 4
+      Device d5r1z3-127.0.0.3:6230R127.0.0.3:6230/sdb7_"" with 1.0 weight got id 5
+      Device d6r1z4-127.0.0.4:6240R127.0.0.4:6240/sdb4_"" with 1.0 weight got id 6
+      Device d7r1z4-127.0.0.4:6240R127.0.0.4:6240/sdb8_"" with 1.0 weight got id 7
       Reassigned 6144 (600.00%) partitions. Balance is now 0.00.  Dispersion is now 0.00
-      Device d0r1z1-127.0.0.1:6011R127.0.0.1:6011/sdb1_"" with 1.0 weight got id 0
-      Device d1r1z2-127.0.0.2:6021R127.0.0.2:6021/sdb2_"" with 1.0 weight got id 1
-      Device d2r1z3-127.0.0.3:6031R127.0.0.3:6031/sdb3_"" with 1.0 weight got id 2
-      Device d3r1z4-127.0.0.4:6041R127.0.0.4:6041/sdb4_"" with 1.0 weight got id 3
+      Device d0r1z1-127.0.0.1:6211R127.0.0.1:6211/sdb1_"" with 1.0 weight got id 0
+      Device d1r1z2-127.0.0.2:6221R127.0.0.2:6221/sdb2_"" with 1.0 weight got id 1
+      Device d2r1z3-127.0.0.3:6231R127.0.0.3:6231/sdb3_"" with 1.0 weight got id 2
+      Device d3r1z4-127.0.0.4:6241R127.0.0.4:6241/sdb4_"" with 1.0 weight got id 3
       Reassigned 3072 (300.00%) partitions. Balance is now 0.00.  Dispersion is now 0.00
-      Device d0r1z1-127.0.0.1:6012R127.0.0.1:6012/sdb1_"" with 1.0 weight got id 0
-      Device d1r1z2-127.0.0.2:6022R127.0.0.2:6022/sdb2_"" with 1.0 weight got id 1
-      Device d2r1z3-127.0.0.3:6032R127.0.0.3:6032/sdb3_"" with 1.0 weight got id 2
-      Device d3r1z4-127.0.0.4:6042R127.0.0.4:6042/sdb4_"" with 1.0 weight got id 3
+      Device d0r1z1-127.0.0.1:6212R127.0.0.1:6212/sdb1_"" with 1.0 weight got id 0
+      Device d1r1z2-127.0.0.2:6222R127.0.0.2:6222/sdb2_"" with 1.0 weight got id 1
+      Device d2r1z3-127.0.0.3:6232R127.0.0.3:6232/sdb3_"" with 1.0 weight got id 2
+      Device d3r1z4-127.0.0.4:6242R127.0.0.4:6242/sdb4_"" with 1.0 weight got id 3
       Reassigned 3072 (300.00%) partitions. Balance is now 0.00.  Dispersion is now 0.00
 
 
diff -pruN 2.25.0-3/doc/source/index.rst 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/index.rst
--- 2.25.0-3/doc/source/index.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/index.rst	2020-09-15 21:13:36.000000000 +0000
@@ -66,6 +66,15 @@ Overview and Concepts
     ring_partpower
     associated_projects
 
+Contributor Documentation
+=========================
+
+.. toctree::
+    :maxdepth: 2
+
+    contributor/contributing
+    contributor/review_guidelines
+
 Developer Documentation
 =======================
 
diff -pruN 2.25.0-3/doc/source/install/storage-install-obs.rst 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/install/storage-install-obs.rst
--- 2.25.0-3/doc/source/install/storage-install-obs.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/install/storage-install-obs.rst	2020-09-15 21:13:36.000000000 +0000
@@ -59,8 +59,8 @@ storage nodes, you must prepare the stor
 
    .. code-block:: none
 
-      UUID="<UUID-from-output-above>" /srv/node/sdb xfs noatime,nodiratime,logbufs=8 0 2
-      UUID="<UUID-from-output-above>" /srv/node/sdc xfs noatime,nodiratime,logbufs=8 0 2
+      UUID="<UUID-from-output-above>" /srv/node/sdb xfs noatime 0 2
+      UUID="<UUID-from-output-above>" /srv/node/sdc xfs noatime 0 2
 
 #. Mount the devices:
 
diff -pruN 2.25.0-3/doc/source/install/storage-install-rdo.rst 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/install/storage-install-rdo.rst
--- 2.25.0-3/doc/source/install/storage-install-rdo.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/install/storage-install-rdo.rst	2020-09-15 21:13:36.000000000 +0000
@@ -58,8 +58,8 @@ storage nodes, you must prepare the stor
 
    .. code-block:: none
 
-      UUID="<UUID-from-output-above>" /srv/node/sdb xfs noatime,nodiratime,logbufs=8 0 2
-      UUID="<UUID-from-output-above>" /srv/node/sdc xfs noatime,nodiratime,logbufs=8 0 2
+      UUID="<UUID-from-output-above>" /srv/node/sdb xfs noatime 0 2
+      UUID="<UUID-from-output-above>" /srv/node/sdc xfs noatime 0 2
 
 #. Mount the devices:
 
@@ -159,3 +159,14 @@ Install and configure components
       # mkdir -p /var/cache/swift
       # chown -R root:swift /var/cache/swift
       # chmod -R 775 /var/cache/swift
+
+8. Enable necessary access in the firewall
+
+   .. code-block:: console
+
+      # firewall-cmd --permanent --add-port=6200/tcp
+      # firewall-cmd --permanent --add-port=6201/tcp
+      # firewall-cmd --permanent --add-port=6202/tcp
+
+   The rsync service includes its own firewall configuration.
+   Connect from one node to another to ensure that access is allowed.
diff -pruN 2.25.0-3/doc/source/install/storage-install-ubuntu-debian.rst 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/install/storage-install-ubuntu-debian.rst
--- 2.25.0-3/doc/source/install/storage-install-ubuntu-debian.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/install/storage-install-ubuntu-debian.rst	2020-09-15 21:13:36.000000000 +0000
@@ -58,8 +58,8 @@ storage nodes, you must prepare the stor
 
    .. code-block:: none
 
-      UUID="<UUID-from-output-above>" /srv/node/sdb xfs noatime,nodiratime,logbufs=8 0 2
-      UUID="<UUID-from-output-above>" /srv/node/sdc xfs noatime,nodiratime,logbufs=8 0 2
+      UUID="<UUID-from-output-above>" /srv/node/sdb xfs noatime 0 2
+      UUID="<UUID-from-output-above>" /srv/node/sdc xfs noatime 0 2
 
 #. Mount the devices:
 
diff -pruN 2.25.0-3/doc/source/logs.rst 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/logs.rst
--- 2.25.0-3/doc/source/logs.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/logs.rst	2020-09-15 21:13:36.000000000 +0000
@@ -177,7 +177,8 @@ user_agent          The value of the HTT
                     the process ID, such as ``"proxy-server <pid of the
                     proxy>"`` or ``"object-updater <pid of the object
                     updater>"``.
-request_time        The duration of the request.
+request_time        The time between request received and response started.
+                    **Note**: This includes transfer time on PUT, but not GET.
 additional_info     Additional useful information.
 server_pid          The process id of the server
 policy_index        The value of the storage policy index.
diff -pruN 2.25.0-3/doc/source/policies_saio.rst 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/policies_saio.rst
--- 2.25.0-3/doc/source/policies_saio.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/policies_saio.rst	2020-09-15 21:13:36.000000000 +0000
@@ -40,10 +40,10 @@ to implement a usable set of policies.
    these changes)::
 
         swift-ring-builder object-1.builder create 10 2 1
-        swift-ring-builder object-1.builder add r1z1-127.0.0.1:6010/sdb1 1
-        swift-ring-builder object-1.builder add r1z2-127.0.0.1:6020/sdb2 1
-        swift-ring-builder object-1.builder add r1z3-127.0.0.1:6030/sdb3 1
-        swift-ring-builder object-1.builder add r1z4-127.0.0.1:6040/sdb4 1
+        swift-ring-builder object-1.builder add r1z1-127.0.0.1:6210/sdb1 1
+        swift-ring-builder object-1.builder add r1z2-127.0.0.1:6220/sdb2 1
+        swift-ring-builder object-1.builder add r1z3-127.0.0.1:6230/sdb3 1
+        swift-ring-builder object-1.builder add r1z4-127.0.0.1:6240/sdb4 1
         swift-ring-builder object-1.builder rebalance
 
   Note that the reduced replication of the silver policy is only a function
@@ -101,9 +101,9 @@ Storage Policies effect placement of dat
 
   You should see this: (note placement on expected devices)::
 
-        ["http://127.0.0.1:6030/sdb3/761/AUTH_test/myCont0/file0.txt",
-        "http://127.0.0.1:6010/sdb1/761/AUTH_test/myCont0/file0.txt",
-        "http://127.0.0.1:6020/sdb2/761/AUTH_test/myCont0/file0.txt"]
+        ["http://127.0.0.1:6230/sdb3/761/AUTH_test/myCont0/file0.txt",
+        "http://127.0.0.1:6210/sdb1/761/AUTH_test/myCont0/file0.txt",
+        "http://127.0.0.1:6220/sdb2/761/AUTH_test/myCont0/file0.txt"]
 
 5. Create a container using policy 'silver' and put a different file in it::
 
@@ -119,8 +119,8 @@ Storage Policies effect placement of dat
 
   You should see this: (note placement on expected devices)::
 
-        ["http://127.0.0.1:6010/sdb1/32/AUTH_test/myCont1/file1.txt",
-         "http://127.0.0.1:6040/sdb4/32/AUTH_test/myCont1/file1.txt"]
+        ["http://127.0.0.1:6210/sdb1/32/AUTH_test/myCont1/file1.txt",
+         "http://127.0.0.1:6240/sdb4/32/AUTH_test/myCont1/file1.txt"]
 
 7. Confirm account information with HEAD, make sure that your container-updater
    service is running and has executed once since you performed the PUTs or the
diff -pruN 2.25.0-3/doc/source/replication_network.rst 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/replication_network.rst
--- 2.25.0-3/doc/source/replication_network.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/replication_network.rst	2020-09-15 21:13:36.000000000 +0000
@@ -31,122 +31,141 @@ node's standard IP and port will be used
 For SAIO replication
 --------------------
 
-#. Create new script in ~/bin/ (for example: remakerings_new)::
+#. Create new script in ``~/bin/`` (for example: ``remakerings_new``)::
 
         #!/bin/bash
+        set -e
         cd /etc/swift
         rm -f *.builder *.ring.gz backups/*.builder backups/*.ring.gz
-        swift-ring-builder object.builder create 18 3 1
-        swift-ring-builder object.builder add z1-127.0.0.1:6010R127.0.0.1:6050/sdb1 1
-        swift-ring-builder object.builder add z2-127.0.0.1:6020R127.0.0.1:6060/sdb2 1
-        swift-ring-builder object.builder add z3-127.0.0.1:6030R127.0.0.1:6070/sdb3 1
-        swift-ring-builder object.builder add z4-127.0.0.1:6040R127.0.0.1:6080/sdb4 1
+        swift-ring-builder object.builder create 10 3 1
+        swift-ring-builder object.builder add z1-127.0.0.1:6210R127.0.0.1:6250/sdb1 1
+        swift-ring-builder object.builder add z2-127.0.0.1:6220R127.0.0.1:6260/sdb2 1
+        swift-ring-builder object.builder add z3-127.0.0.1:6230R127.0.0.1:6270/sdb3 1
+        swift-ring-builder object.builder add z4-127.0.0.1:6240R127.0.0.1:6280/sdb4 1
         swift-ring-builder object.builder rebalance
-        swift-ring-builder container.builder create 18 3 1
-        swift-ring-builder container.builder add z1-127.0.0.1:6011R127.0.0.1:6051/sdb1 1
-        swift-ring-builder container.builder add z2-127.0.0.1:6021R127.0.0.1:6061/sdb2 1
-        swift-ring-builder container.builder add z3-127.0.0.1:6031R127.0.0.1:6071/sdb3 1
-        swift-ring-builder container.builder add z4-127.0.0.1:6041R127.0.0.1:6081/sdb4 1
+        swift-ring-builder object-1.builder create 10 2 1
+        swift-ring-builder object-1.builder add z1-127.0.0.1:6210R127.0.0.1:6250/sdb1 1
+        swift-ring-builder object-1.builder add z2-127.0.0.1:6220R127.0.0.1:6260/sdb2 1
+        swift-ring-builder object-1.builder add z3-127.0.0.1:6230R127.0.0.1:6270/sdb3 1
+        swift-ring-builder object-1.builder add z4-127.0.0.1:6240R127.0.0.1:6280/sdb4 1
+        swift-ring-builder object-1.builder rebalance
+        swift-ring-builder object-2.builder create 10 6 1
+        swift-ring-builder object-2.builder add z1-127.0.0.1:6210R127.0.0.1:6250/sdb1 1
+        swift-ring-builder object-2.builder add z1-127.0.0.1:6210R127.0.0.1:6250/sdb5 1
+        swift-ring-builder object-2.builder add z2-127.0.0.1:6220R127.0.0.1:6260/sdb2 1
+        swift-ring-builder object-2.builder add z2-127.0.0.1:6220R127.0.0.1:6260/sdb6 1
+        swift-ring-builder object-2.builder add z3-127.0.0.1:6230R127.0.0.1:6270/sdb3 1
+        swift-ring-builder object-2.builder add z3-127.0.0.1:6230R127.0.0.1:6270/sdb7 1
+        swift-ring-builder object-2.builder add z4-127.0.0.1:6240R127.0.0.1:6280/sdb4 1
+        swift-ring-builder object-2.builder add z4-127.0.0.1:6240R127.0.0.1:6280/sdb8 1
+        swift-ring-builder object-2.builder rebalance
+        swift-ring-builder container.builder create 10 3 1
+        swift-ring-builder container.builder add z1-127.0.0.1:6211R127.0.0.1:6251/sdb1 1
+        swift-ring-builder container.builder add z2-127.0.0.1:6221R127.0.0.1:6261/sdb2 1
+        swift-ring-builder container.builder add z3-127.0.0.1:6231R127.0.0.1:6271/sdb3 1
+        swift-ring-builder container.builder add z4-127.0.0.1:6241R127.0.0.1:6281/sdb4 1
         swift-ring-builder container.builder rebalance
-        swift-ring-builder account.builder create 18 3 1
-        swift-ring-builder account.builder add z1-127.0.0.1:6012R127.0.0.1:6052/sdb1 1
-        swift-ring-builder account.builder add z2-127.0.0.1:6022R127.0.0.1:6062/sdb2 1
-        swift-ring-builder account.builder add z3-127.0.0.1:6032R127.0.0.1:6072/sdb3 1
-        swift-ring-builder account.builder add z4-127.0.0.1:6042R127.0.0.1:6082/sdb4 1
+        swift-ring-builder account.builder create 10 3 1
+        swift-ring-builder account.builder add z1-127.0.0.1:6212R127.0.0.1:6252/sdb1 1
+        swift-ring-builder account.builder add z2-127.0.0.1:6222R127.0.0.1:6262/sdb2 1
+        swift-ring-builder account.builder add z3-127.0.0.1:6232R127.0.0.1:6272/sdb3 1
+        swift-ring-builder account.builder add z4-127.0.0.1:6242R127.0.0.1:6282/sdb4 1
         swift-ring-builder account.builder rebalance
 
    .. note::
-      Syntax of adding device has been changed: R<ip_replication>:<port_replication> was added between z<zone>-<ip>:<port> and /<device_name>_<meta> <weight>. Added devices will use <ip_replication> and <port_replication> for replication activities.
+      Syntax of adding device has been changed: ``R<ip_replication>:<port_replication>``
+      was added between ``z<zone>-<ip>:<port>`` and ``/<device_name>_<meta> <weight>``.
+      Added devices will use <ip_replication> and <port_replication> for replication activities.
 
-#. Add next rows in /etc/rsyncd.conf::
+#. Add next rows in ``/etc/rsyncd.conf``::
 
-        [account6052]
+        [account6252]
         max connections = 25
         path = /srv/1/node/
         read only = false
-        lock file = /var/lock/account6052.lock
+        lock file = /var/lock/account6252.lock
 
-        [account6062]
+        [account6262]
         max connections = 25
         path = /srv/2/node/
         read only = false
-        lock file = /var/lock/account6062.lock
+        lock file = /var/lock/account6262.lock
 
-        [account6072]
+        [account6272]
         max connections = 25
         path = /srv/3/node/
         read only = false
-        lock file = /var/lock/account6072.lock
+        lock file = /var/lock/account6272.lock
 
-        [account6082]
+        [account6282]
         max connections = 25
         path = /srv/4/node/
         read only = false
-        lock file = /var/lock/account6082.lock
+        lock file = /var/lock/account6282.lock
 
 
-        [container6051]
+        [container6251]
         max connections = 25
         path = /srv/1/node/
         read only = false
-        lock file = /var/lock/container6051.lock
+        lock file = /var/lock/container6251.lock
 
-        [container6061]
+        [container6261]
         max connections = 25
         path = /srv/2/node/
         read only = false
-        lock file = /var/lock/container6061.lock
+        lock file = /var/lock/container6261.lock
 
-        [container6071]
+        [container6271]
         max connections = 25
         path = /srv/3/node/
         read only = false
-        lock file = /var/lock/container6071.lock
+        lock file = /var/lock/container6271.lock
 
-        [container6081]
+        [container6281]
         max connections = 25
         path = /srv/4/node/
         read only = false
-        lock file = /var/lock/container6081.lock
+        lock file = /var/lock/container6281.lock
 
 
-        [object6050]
+        [object6250]
         max connections = 25
         path = /srv/1/node/
         read only = false
-        lock file = /var/lock/object6050.lock
+        lock file = /var/lock/object6250.lock
 
-        [object6060]
+        [object6260]
         max connections = 25
         path = /srv/2/node/
         read only = false
-        lock file = /var/lock/object6060.lock
+        lock file = /var/lock/object6260.lock
 
-        [object6070]
+        [object6270]
         max connections = 25
         path = /srv/3/node/
         read only = false
-        lock file = /var/lock/object6070.lock
+        lock file = /var/lock/object6270.lock
 
-        [object6080]
+        [object6280]
         max connections = 25
         path = /srv/4/node/
         read only = false
-        lock file = /var/lock/object6080.lock
+        lock file = /var/lock/object6280.lock
 
 #. Restart rsync daemon::
 
         service rsync restart
 
-#. Add changes in configuration files in directories:
+#. Update configuration files in directories:
 
    * /etc/swift/object-server(files: 1.conf, 2.conf, 3.conf, 4.conf)
    * /etc/swift/container-server(files: 1.conf, 2.conf, 3.conf, 4.conf)
    * /etc/swift/account-server(files: 1.conf, 2.conf, 3.conf, 4.conf)
 
-   delete all configuration options in section [<*>-replicator]
+   delete all configuration options in section ``[<*>-replicator]``
 
-#. Add configuration files for object-server, in /etc/swift/object-server/
+#. Add configuration files for object-server, in ``/etc/swift/object-server/``
 
    * 5.conf::
 
@@ -154,7 +173,7 @@ For SAIO replication
         devices = /srv/1/node
         mount_check = false
         disable_fallocate = true
-        bind_port = 6050
+        bind_port = 6250
         user = swift
         log_facility = LOG_LOCAL2
         recon_cache_path = /var/cache/swift
@@ -178,7 +197,7 @@ For SAIO replication
         devices = /srv/2/node
         mount_check = false
         disable_fallocate = true
-        bind_port = 6060
+        bind_port = 6260
         user = swift
         log_facility = LOG_LOCAL3
         recon_cache_path = /var/cache/swift2
@@ -202,7 +221,7 @@ For SAIO replication
         devices = /srv/3/node
         mount_check = false
         disable_fallocate = true
-        bind_port = 6070
+        bind_port = 6270
         user = swift
         log_facility = LOG_LOCAL4
         recon_cache_path = /var/cache/swift3
@@ -226,7 +245,7 @@ For SAIO replication
         devices = /srv/4/node
         mount_check = false
         disable_fallocate = true
-        bind_port = 6080
+        bind_port = 6280
         user = swift
         log_facility = LOG_LOCAL5
         recon_cache_path = /var/cache/swift4
@@ -244,7 +263,7 @@ For SAIO replication
         [object-replicator]
         rsync_module = {replication_ip}::object{replication_port}
 
-#. Add configuration files for container-server, in /etc/swift/container-server/
+#. Add configuration files for container-server, in ``/etc/swift/container-server/``
 
    * 5.conf::
 
@@ -252,7 +271,7 @@ For SAIO replication
         devices = /srv/1/node
         mount_check = false
         disable_fallocate = true
-        bind_port = 6051
+        bind_port = 6251
         user = swift
         log_facility = LOG_LOCAL2
         recon_cache_path = /var/cache/swift
@@ -276,7 +295,7 @@ For SAIO replication
         devices = /srv/2/node
         mount_check = false
         disable_fallocate = true
-        bind_port = 6061
+        bind_port = 6261
         user = swift
         log_facility = LOG_LOCAL3
         recon_cache_path = /var/cache/swift2
@@ -300,7 +319,7 @@ For SAIO replication
         devices = /srv/3/node
         mount_check = false
         disable_fallocate = true
-        bind_port = 6071
+        bind_port = 6271
         user = swift
         log_facility = LOG_LOCAL4
         recon_cache_path = /var/cache/swift3
@@ -324,7 +343,7 @@ For SAIO replication
         devices = /srv/4/node
         mount_check = false
         disable_fallocate = true
-        bind_port = 6081
+        bind_port = 6281
         user = swift
         log_facility = LOG_LOCAL5
         recon_cache_path = /var/cache/swift4
@@ -342,7 +361,7 @@ For SAIO replication
         [container-replicator]
         rsync_module = {replication_ip}::container{replication_port}
 
-#. Add configuration files for account-server, in /etc/swift/account-server/
+#. Add configuration files for account-server, in ``/etc/swift/account-server/``
 
    * 5.conf::
 
@@ -350,7 +369,7 @@ For SAIO replication
         devices = /srv/1/node
         mount_check = false
         disable_fallocate = true
-        bind_port = 6052
+        bind_port = 6252
         user = swift
         log_facility = LOG_LOCAL2
         recon_cache_path = /var/cache/swift
@@ -374,7 +393,7 @@ For SAIO replication
         devices = /srv/2/node
         mount_check = false
         disable_fallocate = true
-        bind_port = 6062
+        bind_port = 6262
         user = swift
         log_facility = LOG_LOCAL3
         recon_cache_path = /var/cache/swift2
@@ -398,7 +417,7 @@ For SAIO replication
         devices = /srv/3/node
         mount_check = false
         disable_fallocate = true
-        bind_port = 6072
+        bind_port = 6272
         user = swift
         log_facility = LOG_LOCAL4
         recon_cache_path = /var/cache/swift3
@@ -422,7 +441,7 @@ For SAIO replication
         devices = /srv/4/node
         mount_check = false
         disable_fallocate = true
-        bind_port = 6082
+        bind_port = 6282
         user = swift
         log_facility = LOG_LOCAL5
         recon_cache_path = /var/cache/swift4
diff -pruN 2.25.0-3/doc/source/s3_compat.rst 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/s3_compat.rst
--- 2.25.0-3/doc/source/s3_compat.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/doc/source/s3_compat.rst	2020-09-15 21:13:36.000000000 +0000
@@ -60,8 +60,6 @@ Amazon S3 operations
 +------------------------------------------------+------------------+--------------+
 | `PUT Bucket acl`_                              | Core-API         | Yes          |
 +------------------------------------------------+------------------+--------------+
-| `Object tagging`_                              | Core-API         | Yes          |
-+------------------------------------------------+------------------+--------------+
 | `Versioning`_                                  | Versioning       | Yes          |
 +------------------------------------------------+------------------+--------------+
 | `Bucket notification`_                         | Notifications    | No           |
@@ -78,6 +76,8 @@ Amazon S3 operations
 +------------------------------------------------+------------------+--------------+
 | `Delete Multiple Objects`_                     | Advanced Feature | Yes          |
 +------------------------------------------------+------------------+--------------+
+| `Object tagging`_                              | Advanced Feature | No           |
++------------------------------------------------+------------------+--------------+
 | `GET Object torrent`_                          | Advanced Feature | No           |
 +------------------------------------------------+------------------+--------------+
 | `Bucket inventory`_                            | Advanced Feature | No           |
diff -pruN 2.25.0-3/docker/rootfs/etc/swift/account-server.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/docker/rootfs/etc/swift/account-server.conf
--- 2.25.0-3/docker/rootfs/etc/swift/account-server.conf	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/docker/rootfs/etc/swift/account-server.conf	2020-09-15 21:13:36.000000000 +0000
@@ -1,7 +1,7 @@
 [DEFAULT]
 devices = /srv/node/
 bind_ip = 127.0.0.1
-bind_port = 6002
+bind_port = 6202
 workers = 2
 mount_check = false
 log_facility = LOG_LOCAL5
diff -pruN 2.25.0-3/docker/rootfs/etc/swift/container-server.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/docker/rootfs/etc/swift/container-server.conf
--- 2.25.0-3/docker/rootfs/etc/swift/container-server.conf	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/docker/rootfs/etc/swift/container-server.conf	2020-09-15 21:13:36.000000000 +0000
@@ -1,7 +1,7 @@
 [DEFAULT]
 devices = /srv/node/
 bind_ip = 127.0.0.1
-bind_port = 6001
+bind_port = 6201
 workers = 2
 mount_check = false
 log_facility = LOG_LOCAL4
diff -pruN 2.25.0-3/docker/rootfs/etc/swift/object-server.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/docker/rootfs/etc/swift/object-server.conf
--- 2.25.0-3/docker/rootfs/etc/swift/object-server.conf	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/docker/rootfs/etc/swift/object-server.conf	2020-09-15 21:13:36.000000000 +0000
@@ -1,7 +1,7 @@
 [DEFAULT]
 devices = /srv/node/
 bind_ip = 127.0.0.1
-bind_port = 6000
+bind_port = 6200
 workers = 2
 mount_check = false
 log_facility = LOG_LOCAL3
diff -pruN 2.25.0-3/docker/rootfs/etc/swift_build/build_devices 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/docker/rootfs/etc/swift_build/build_devices
--- 2.25.0-3/docker/rootfs/etc/swift_build/build_devices	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/docker/rootfs/etc/swift_build/build_devices	2020-09-15 21:13:36.000000000 +0000
@@ -56,7 +56,7 @@ if [[ $MY_STORAGE_TYPE == "internal_devi
     # echo "created storage device /dev/swift-d$i of $DEV_SIZE";
     mkfs.xfs -f -L D$i -i size=512 /dev/$device;
     echo "  created XFS file system on device /dev/$device";
-    mount -t xfs -o noatime,nodiratime,logbufs=8 /dev/$device /srv/node/$device;
+    mount -t xfs -o noatime /dev/$device /srv/node/$device;
     echo "  mounted /dev/$device as /srv/node/$device";
   done
 fi
diff -pruN 2.25.0-3/docker/rootfs/etc/swift_build/build_remakerings 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/docker/rootfs/etc/swift_build/build_remakerings
--- 2.25.0-3/docker/rootfs/etc/swift_build/build_remakerings	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/docker/rootfs/etc/swift_build/build_remakerings	2020-09-15 21:13:36.000000000 +0000
@@ -9,12 +9,12 @@ done
 
 
 for drive in `ls /srv/node/ | grep 'swift-d'`; do
-  echo "swift-ring-builder object.builder add r1z1-127.0.0.1:6000/$drive 1" >> /etc/swift/remakerings.object
-  echo "pushed command to add r1z1-127.0.0.1:6000/$drive to /etc/swift/remakerings.object"
-  echo "swift-ring-builder container.builder add r1z1-127.0.0.1:6001/$drive 1" >> /etc/swift/remakerings.container
-  echo "pushed command to add r1z1-127.0.0.1:6001/$drive to /etc/swift/remakerings.container"
-  echo "swift-ring-builder account.builder add r1z1-127.0.0.1:6002/$drive 1" >> /etc/swift/remakerings.account
-  echo "pushed command to add r1z1-127.0.0.1:6002/$drive to /etc/swift/remakerings.account"
+  echo "swift-ring-builder object.builder add r1z1-127.0.0.1:6200/$drive 1" >> /etc/swift/remakerings.object
+  echo "pushed command to add r1z1-127.0.0.1:6200/$drive to /etc/swift/remakerings.object"
+  echo "swift-ring-builder container.builder add r1z1-127.0.0.1:6201/$drive 1" >> /etc/swift/remakerings.container
+  echo "pushed command to add r1z1-127.0.0.1:6201/$drive to /etc/swift/remakerings.container"
+  echo "swift-ring-builder account.builder add r1z1-127.0.0.1:6202/$drive 1" >> /etc/swift/remakerings.account
+  echo "pushed command to add r1z1-127.0.0.1:6202/$drive to /etc/swift/remakerings.account"
 done
 
 for p in $POLICIES; do
diff -pruN 2.25.0-3/etc/account-server.conf-sample 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/etc/account-server.conf-sample
--- 2.25.0-3/etc/account-server.conf-sample	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/etc/account-server.conf-sample	2020-09-15 21:13:36.000000000 +0000
@@ -91,13 +91,13 @@ use = egg:swift#account
 # set log_requests = true
 # set log_address = /dev/log
 #
-# Configure parameter for creating specific server
-# To handle all verbs, including replication verbs, do not specify
-# "replication_server" (this is the default). To only handle replication,
-# set to a True value (e.g. "True" or "1"). To handle only non-replication
-# verbs, set to "False". Unless you have a separate replication network, you
-# should not specify any value for "replication_server". Default is empty.
-# replication_server = false
+# You can disable REPLICATE handling (default is to allow it). When deploying
+# a cluster with a separate replication network, you'll want multiple
+# account-server processes running: one for client-driven traffic and another
+# for replication traffic. The server handling client-driven traffic may set
+# this to false. If there is only one account-server process, leave this as
+# true.
+# replication_server = true
 #
 # You can set scheduling priority of processes. Niceness values range from -20
 # (most favorable to the process) to 19 (least favorable to the process).
diff -pruN 2.25.0-3/etc/container-server.conf-sample 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/etc/container-server.conf-sample
--- 2.25.0-3/etc/container-server.conf-sample	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/etc/container-server.conf-sample	2020-09-15 21:13:36.000000000 +0000
@@ -101,13 +101,13 @@ use = egg:swift#container
 # conn_timeout = 0.5
 # allow_versions = false
 #
-# Configure parameter for creating specific server
-# To handle all verbs, including replication verbs, do not specify
-# "replication_server" (this is the default). To only handle replication,
-# set to a True value (e.g. "True" or "1"). To handle only non-replication
-# verbs, set to "False". Unless you have a separate replication network, you
-# should not specify any value for "replication_server".
-# replication_server = false
+# You can disable REPLICATE handling (default is to allow it). When deploying
+# a cluster with a separate replication network, you'll want multiple
+# container-server processes running: one for client-driven traffic and another
+# for replication traffic. The server handling client-driven traffic may set
+# this to false. If there is only one container-server process, leave this as
+# true.
+# replication_server = true
 #
 # You can set scheduling priority of processes. Niceness values range from -20
 # (most favorable to the process) to 19 (least favorable to the process).
diff -pruN 2.25.0-3/etc/keymaster.conf-sample 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/etc/keymaster.conf-sample
--- 2.25.0-3/etc/keymaster.conf-sample	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/etc/keymaster.conf-sample	2020-09-15 21:13:36.000000000 +0000
@@ -1,4 +1,13 @@
 [keymaster]
+# Over time, the format of crypto metadata on disk may change slightly to resolve
+# ambiguities. In general, you want to be writing the newest version, but to
+# ensure that all writes can still be read during rolling upgrades, there's the
+# option to write older formats as well.
+# Before upgrading from Swift 2.20.0 or earlier, ensure this is set to 1
+# Before upgrading from Swift 2.25.0 or earlier, ensure this is set to at most 2
+# After upgrading all proxy servers, set this to 3 (currently the highest version)
+# meta_version_to_write = 3
+
 # Sets the root secret from which encryption keys are derived. This must be set
 # before first use to a value that is a base64 encoding of at least 32 bytes.
 # The security of all encrypted data critically depends on this key, therefore
@@ -16,6 +25,15 @@
 # backends that use Keystone for authentication. Currently, the only
 # implemented backend is for Barbican.
 
+# Over time, the format of crypto metadata on disk may change slightly to resolve
+# ambiguities. In general, you want to be writing the newest version, but to
+# ensure that all writes can still be read during rolling upgrades, there's the
+# option to write older formats as well.
+# Before upgrading from Swift 2.20.0 or earlier, ensure this is set to 1
+# Before upgrading from Swift 2.25.0 or earlier, ensure this is set to at most 2
+# After upgrading all proxy servers, set this to 3 (currently the highest version)
+# meta_version_to_write = 3
+
 # The api_class tells Castellan which key manager to use to access the external
 # key management system. The default value that accesses Barbican is
 # castellan.key_manager.barbican_key_manager.BarbicanKeyManager.
@@ -79,6 +97,15 @@
 # The kmip_keymaster section is used to configure a keymaster that fetches an
 # encryption root secret from a KMIP service.
 
+# Over time, the format of crypto metadata on disk may change slightly to resolve
+# ambiguities. In general, you want to be writing the newest version, but to
+# ensure that all writes can still be read during rolling upgrades, there's the
+# option to write older formats as well.
+# Before upgrading from Swift 2.20.0 or earlier, ensure this is set to 1
+# Before upgrading from Swift 2.25.0 or earlier, ensure this is set to at most 2
+# After upgrading all proxy servers, set this to 3 (currently the highest version)
+# meta_version_to_write = 3
+
 # The value of the ``key_id`` option should be the unique identifier for a
 # secret that will be retrieved from the KMIP service. The secret should be an
 # AES-256 symmetric key.
diff -pruN 2.25.0-3/etc/object-server.conf-sample 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/etc/object-server.conf-sample
--- 2.25.0-3/etc/object-server.conf-sample	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/etc/object-server.conf-sample	2020-09-15 21:13:36.000000000 +0000
@@ -156,13 +156,13 @@ use = egg:swift#object
 #
 # eventlet_tpool_num_threads = auto
 
-# Configure parameter for creating specific server
-# To handle all verbs, including replication verbs, do not specify
-# "replication_server" (this is the default). To only handle replication,
-# set to a True value (e.g. "True" or "1"). To handle only non-replication
-# verbs, set to "False". Unless you have a separate replication network, you
-# should not specify any value for "replication_server".
-# replication_server = false
+# You can disable REPLICATE and SSYNC handling (default is to allow it). When
+# deploying a cluster with a separate replication network, you'll want multiple
+# object-server processes running: one for client-driven traffic and another
+# for replication traffic. The server handling client-driven traffic may set
+# this to false. If there is only one object-server process, leave this as
+# true.
+# replication_server = true
 #
 # Set to restrict the number of concurrent incoming SSYNC requests
 # Set to 0 for unlimited
diff -pruN 2.25.0-3/etc/proxy-server.conf-sample 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/etc/proxy-server.conf-sample
--- 2.25.0-3/etc/proxy-server.conf-sample	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/etc/proxy-server.conf-sample	2020-09-15 21:13:36.000000000 +0000
@@ -200,12 +200,20 @@ use = egg:swift#proxy
 # the number of seconds configured by timing_expiry.
 # timing_expiry = 300
 #
-# By default on a GET/HEAD swift will connect to a storage node one at a time
-# in a single thread. There is smarts in the order they are hit however. If you
-# turn on concurrent_gets below, then replica count threads will be used.
-# With addition of the concurrency_timeout option this will allow swift to send
-# out GET/HEAD requests to the storage nodes concurrently and answer with the
-# first to respond. With an EC policy the parameter only affects HEAD requests.
+# Normally, you should only be moving one replica's worth of data at a time
+# when rebalancing. If you're rebalancing more aggressively, increase this
+# to avoid erroneously returning a 404 when the primary assignments that
+# *didn't* change get overloaded.
+# rebalance_missing_suppression_count = 1
+#
+# By default on a GET/HEAD swift will connect to a minimum number storage nodes
+# in a minimum number of threads - for replicated data just a single request to
+# a single node one at a time.  When enabled concurrent_gets allows the proxy
+# to use up to replica count threads when waiting on a response.  In
+# conjunction with the concurrency_timeout option this will allow swift to send
+# out GET/HEAD requests to the storage nodes concurrently and answer as soon as
+# the minimum number of backend responses are availabe - in replicated contexts
+# this will be the first backend replica to respond.
 # concurrent_gets = off
 #
 # This parameter controls how long to wait before firing off the next
@@ -215,6 +223,13 @@ use = egg:swift#proxy
 # conn_timeout parameter.
 # concurrency_timeout = 0.5
 #
+# By default on a EC GET request swift will connect to a minimum number of
+# storage nodes in a minimum number of threads - for erasure coded data, ndata
+# requests to primary nodes are started at the same time.  When greater than
+# zero this option provides additional robustness and may reduce first byte
+# latency by starting additional requests - up to as many as nparity.
+# concurrent_ec_extra_requests = 0
+#
 # Set to the number of nodes to contact for a normal request. You can use
 # '* replicas' at the end to have it use the number given times the number of
 # replicas for the ring being used for the request.
@@ -298,6 +313,10 @@ use = egg:swift#proxy
 # write_affinity =
 # write_affinity_node_count =
 # write_affinity_handoff_delete_count =
+# rebalance_missing_suppression_count = 1
+# concurrent_gets = off
+# concurrency_timeout = 0.5
+# concurrent_ec_extra_requests = 0
 
 [filter:tempauth]
 use = egg:swift#tempauth
@@ -470,7 +489,10 @@ use = egg:swift#s3api
 # With either tempauth or your custom auth:
 # - Put s3api just before your auth filter(s) in the pipeline
 # With keystone:
-# - Put s3api and s3token before keystoneauth in the pipeline
+# - Put s3api and s3token before keystoneauth in the pipeline, but after
+#   auth_token
+# If you have ratelimit enabled for Swift requests, you may want to place a
+# second copy after auth to also ratelimit S3 requests.
 #
 # Swift has no concept of the S3's resource owner; the resources
 # (i.e. containers and objects) created via the Swift API have no owner
@@ -884,6 +906,10 @@ use = egg:swift#proxy_logging
 # access_log_level = INFO
 # access_log_address = /dev/log
 #
+# Log route for this filter. Useful if you want to have different configs for
+# the two proxy-logging filters.
+# access_log_route = proxy-server
+#
 # If set, access_log_udp_host will override access_log_address
 # access_log_udp_host =
 # access_log_udp_port = 514
@@ -1110,6 +1136,18 @@ use = egg:swift#copy
 [filter:keymaster]
 use = egg:swift#keymaster
 
+# Over time, the format of crypto metadata on disk may change slightly to resolve
+# ambiguities. In general, you want to be writing the newest version, but to
+# ensure that all writes can still be read during rolling upgrades, there's the
+# option to write older formats as well.
+# Before upgrading from Swift 2.20.0 or Swift 2.19.1 or earlier, ensure this is set to 1
+# Before upgrading from Swift 2.25.0 or earlier, ensure this is set to at most 2
+# After upgrading all proxy servers, set this to 3 (currently the highest version)
+#
+# The default is currently 2 to support upgrades with no configuration changes,
+# but may change to 3 in the future.
+meta_version_to_write = 2
+
 # Sets the root secret from which encryption keys are derived. This must be set
 # before first use to a value that is a base64 encoding of at least 32 bytes.
 # The security of all encrypted data critically depends on this key, therefore
diff -pruN 2.25.0-3/etc/rsyncd.conf-sample 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/etc/rsyncd.conf-sample
--- 2.25.0-3/etc/rsyncd.conf-sample	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/etc/rsyncd.conf-sample	2020-09-15 21:13:36.000000000 +0000
@@ -56,26 +56,26 @@ lock file = /var/lock/object.lock
 #
 # So, on your SAIO, you have to set the following rsyncd configuration:
 #
-#[object6010]
+#[object6210]
 #max connections = 25
 #path = /srv/1/node/
 #read only = false
-#lock file = /var/lock/object6010.lock
+#lock file = /var/lock/object6210.lock
 #
-#[object6020]
+#[object6220]
 #max connections = 25
 #path = /srv/2/node/
 #read only = false
-#lock file = /var/lock/object6020.lock
+#lock file = /var/lock/object6220.lock
 #
-#[object6030]
+#[object6230]
 #max connections = 25
 #path = /srv/3/node/
 #read only = false
-#lock file = /var/lock/object6030.lock
+#lock file = /var/lock/object6230.lock
 #
-#[object6040]
+#[object6240]
 #max connections = 25
 #path = /srv/4/node/
 #read only = false
-#lock file = /var/lock/object6040.lock
+#lock file = /var/lock/object6240.lock
diff -pruN 2.25.0-3/examples/apache2/account-server.template 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/examples/apache2/account-server.template
--- 2.25.0-3/examples/apache2/account-server.template	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/examples/apache2/account-server.template	2020-09-15 21:13:36.000000000 +0000
@@ -6,7 +6,7 @@
 # Change the debug level as you see fit
 #
 # For example:
-#     Replace %PORT% by 6012
+#     Replace %PORT% by 6212
 #     Replace %SERVICENAME% by account-server-1
 #     Replace %USER% with apache (or remove it for default)
 
diff -pruN 2.25.0-3/examples/apache2/container-server.template 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/examples/apache2/container-server.template
--- 2.25.0-3/examples/apache2/container-server.template	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/examples/apache2/container-server.template	2020-09-15 21:13:36.000000000 +0000
@@ -6,7 +6,7 @@
 # Change the debug level as you see fit
 #
 # For example:
-#     Replace %PORT% by 6011
+#     Replace %PORT% by 6211
 #     Replace %SERVICENAME% by container-server-1
 #     Replace %USER% with apache (or remove it for default)
 
diff -pruN 2.25.0-3/examples/apache2/object-server.template 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/examples/apache2/object-server.template
--- 2.25.0-3/examples/apache2/object-server.template	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/examples/apache2/object-server.template	2020-09-15 21:13:36.000000000 +0000
@@ -6,7 +6,7 @@
 # Change the debug level as you see fit
 #
 # For example:
-#     Replace %PORT% by 6010
+#     Replace %PORT% by 6210
 #     Replace %SERVICENAME% by object-server-1
 #     Replace %USER% with apache (or remove it for default)
 
diff -pruN 2.25.0-3/.gitignore 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/.gitignore
--- 2.25.0-3/.gitignore	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/.gitignore	1970-01-01 00:00:00.000000000 +0000
@@ -1,25 +0,0 @@
-*.py[co]
-*.sw?
-*~
-doc/build/*
-dist
-build
-cover
-ChangeLog
-.coverage
-*.egg
-*.egg-info
-.eggs/*
-.DS_Store
-.tox
-pycscope.*
-.idea
-MANIFEST
-
-.testrepository/*
-.stestr/*
-subunit.log
-test/probe/.noseids
-RELEASENOTES.rst
-releasenotes/notes/reno.cache
-/tools/playbooks/**/*.retry
diff -pruN 2.25.0-3/.gitreview 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/.gitreview
--- 2.25.0-3/.gitreview	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/.gitreview	1970-01-01 00:00:00.000000000 +0000
@@ -1,4 +0,0 @@
-[gerrit]
-host=review.opendev.org
-port=29418
-project=openstack/swift.git
diff -pruN 2.25.0-3/lower-constraints.txt 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/lower-constraints.txt
--- 2.25.0-3/lower-constraints.txt	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/lower-constraints.txt	2020-09-15 21:13:36.000000000 +0000
@@ -44,8 +44,6 @@ netifaces==0.8
 nose==1.3.7
 nosehtmloutput==0.0.3
 nosexcover==1.0.10
-openstackdocstheme==1.30.0
-os-api-ref==1.0.0
 os-testr==0.8.0
 oslo.config==4.0.0
 oslo.i18n==3.20.0
@@ -68,15 +66,12 @@ python-swiftclient==3.2.0
 python-openstackclient==3.12.0
 pytz==2018.3
 PyYAML==3.12
-reno==1.8.0
 requests==2.14.2
 requests-mock==1.2.0
 rfc3986==1.1.0
 six==1.10.0
 smmap2==2.0.3
 snowballstemmer==1.2.1
-Sphinx==1.6.2
-sphinxcontrib-websupport==1.0.1
 stestr==2.0.0
 stevedore==1.28.0
 testtools==2.3.0
diff -pruN 2.25.0-3/PKG-INFO 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/PKG-INFO
--- 2.25.0-3/PKG-INFO	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/PKG-INFO	2020-09-15 21:13:40.931434400 +0000
@@ -0,0 +1,188 @@
+Metadata-Version: 2.1
+Name: swift
+Version: 2.26.0.dev186
+Summary: OpenStack Object Storage
+Home-page: https://docs.openstack.org/swift/latest/
+Author: OpenStack
+Author-email: openstack-discuss@lists.openstack.org
+License: UNKNOWN
+Description: ===============
+        OpenStack Swift
+        ===============
+        
+        .. image:: https://governance.openstack.org/tc/badges/swift.svg
+            :target: https://governance.openstack.org/tc/reference/tags/index.html
+        
+        .. Change things from this point on
+        
+        OpenStack Swift is a distributed object storage system designed to scale
+        from a single machine to thousands of servers. Swift is optimized for
+        multi-tenancy and high concurrency. Swift is ideal for backups, web and mobile
+        content, and any other unstructured data that can grow without bound.
+        
+        Swift provides a simple, REST-based API fully documented at
+        https://docs.openstack.org/swift/latest/.
+        
+        Swift was originally developed as the basis for Rackspace's Cloud Files
+        and was open-sourced in 2010 as part of the OpenStack project. It has
+        since grown to include contributions from many companies and has spawned
+        a thriving ecosystem of 3rd party tools. Swift's contributors are listed
+        in the AUTHORS file.
+        
+        Docs
+        ----
+        
+        To build documentation run::
+        
+            pip install -r requirements.txt -r doc/requirements.txt
+            sphinx-build -W -b html doc/source doc/build/html
+        
+        and then browse to doc/build/html/index.html. These docs are auto-generated
+        after every commit and available online at
+        https://docs.openstack.org/swift/latest/.
+        
+        For Developers
+        --------------
+        
+        Getting Started
+        ~~~~~~~~~~~~~~~
+        
+        Swift is part of OpenStack and follows the code contribution, review, and
+        testing processes common to all OpenStack projects.
+        
+        If you would like to start contributing, check out these
+        `notes <CONTRIBUTING.rst>`__ to help you get started.
+        
+        The best place to get started is the
+        `"SAIO - Swift All In One" <https://docs.openstack.org/swift/latest/development_saio.html>`__.
+        This document will walk you through setting up a development cluster of
+        Swift in a VM. The SAIO environment is ideal for running small-scale
+        tests against Swift and trying out new features and bug fixes.
+        
+        Tests
+        ~~~~~
+        
+        There are three types of tests included in Swift's source tree.
+        
+        #. Unit tests
+        #. Functional tests
+        #. Probe tests
+        
+        Unit tests check that small sections of the code behave properly. For example,
+        a unit test may test a single function to ensure that various input gives the
+        expected output. This validates that the code is correct and regressions are
+        not introduced.
+        
+        Functional tests check that the client API is working as expected. These can
+        be run against any endpoint claiming to support the Swift API (although some
+        tests require multiple accounts with different privilege levels). These are
+        "black box" tests that ensure that client apps written against Swift will
+        continue to work.
+        
+        Probe tests are "white box" tests that validate the internal workings of a
+        Swift cluster. They are written to work against the
+        `"SAIO - Swift All In One" <https://docs.openstack.org/swift/latest/development_saio.html>`__
+        dev environment. For example, a probe test may create an object, delete one
+        replica, and ensure that the background consistency processes find and correct
+        the error.
+        
+        You can run unit tests with ``.unittests``, functional tests with
+        ``.functests``, and probe tests with ``.probetests``. There is an
+        additional ``.alltests`` script that wraps the other three.
+        
+        To fully run the tests, the target environment must use a filesystem that
+        supports large xattrs. XFS is strongly recommended. For unit tests and in-
+        process functional tests, either mount ``/tmp`` with XFS or provide another
+        XFS filesystem via the ``TMPDIR`` environment variable. Without this setting,
+        tests should still pass, but a very large number will be skipped.
+        
+        Code Organization
+        ~~~~~~~~~~~~~~~~~
+        
+        -  bin/: Executable scripts that are the processes run by the deployer
+        -  doc/: Documentation
+        -  etc/: Sample config files
+        -  examples/: Config snippets used in the docs
+        -  swift/: Core code
+        
+           -  account/: account server
+           -  cli/: code that backs some of the CLI tools in bin/
+           -  common/: code shared by different modules
+        
+              -  middleware/: "standard", officially-supported middleware
+              -  ring/: code implementing Swift's ring
+        
+           -  container/: container server
+           -  locale/: internationalization (translation) data
+           -  obj/: object server
+           -  proxy/: proxy server
+        
+        -  test/: Unit, functional, and probe tests
+        
+        Data Flow
+        ~~~~~~~~~
+        
+        Swift is a WSGI application and uses eventlet's WSGI server. After the
+        processes are running, the entry point for new requests is the
+        ``Application`` class in ``swift/proxy/server.py``. From there, a
+        controller is chosen, and the request is processed. The proxy may choose
+        to forward the request to a back-end server. For example, the entry
+        point for requests to the object server is the ``ObjectController``
+        class in ``swift/obj/server.py``.
+        
+        For Deployers
+        -------------
+        
+        Deployer docs are also available at
+        https://docs.openstack.org/swift/latest/. A good starting point is at
+        https://docs.openstack.org/swift/latest/deployment_guide.html
+        There is an `ops runbook <https://docs.openstack.org/swift/latest/ops_runbook/index.html>`__
+        that gives information about how to diagnose and troubleshoot common issues
+        when running a Swift cluster.
+        
+        You can run functional tests against a Swift cluster with
+        ``.functests``. These functional tests require ``/etc/swift/test.conf``
+        to run. A sample config file can be found in this source tree in
+        ``test/sample.conf``.
+        
+        For Client Apps
+        ---------------
+        
+        For client applications, official Python language bindings are provided
+        at https://github.com/openstack/python-swiftclient.
+        
+        Complete API documentation at
+        https://docs.openstack.org/api-ref/object-store/
+        
+        There is a large ecosystem of applications and libraries that support and
+        work with OpenStack Swift. Several are listed on the
+        `associated projects <https://docs.openstack.org/swift/latest/associated_projects.html>`__
+        page.
+        
+        --------------
+        
+        For more information come hang out in #openstack-swift on freenode.
+        
+        Thanks,
+        
+        The Swift Development Team
+        
+        
+Platform: UNKNOWN
+Classifier: Development Status :: 5 - Production/Stable
+Classifier: Environment :: OpenStack
+Classifier: Intended Audience :: Information Technology
+Classifier: Intended Audience :: System Administrators
+Classifier: License :: OSI Approved :: Apache Software License
+Classifier: Operating System :: POSIX :: Linux
+Classifier: Programming Language :: Python
+Classifier: Programming Language :: Python :: 2
+Classifier: Programming Language :: Python :: 2.7
+Classifier: Programming Language :: Python :: 3
+Classifier: Programming Language :: Python :: 3.6
+Classifier: Programming Language :: Python :: 3.7
+Classifier: Programming Language :: Python :: 3.8
+Provides-Extra: keystone
+Provides-Extra: kmip_keymaster
+Provides-Extra: kms_keymaster
+Provides-Extra: test
diff -pruN 2.25.0-3/py2-constraints.txt 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/py2-constraints.txt
--- 2.25.0-3/py2-constraints.txt	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/py2-constraints.txt	2020-09-15 21:13:36.000000000 +0000
@@ -0,0 +1,72 @@
+voluptuous===0.11.7
+chardet===3.0.4
+enum-compat===0.0.3
+os-api-ref===1.6.2
+lxml===4.5.0
+certifi===2020.4.5.1
+alabaster===0.7.12
+pbr===5.4.5
+oslo.i18n===3.25.1
+fixtures===3.0.0
+nose===1.3.7
+nosehtmloutput===0.0.7
+sphinxcontrib-websupport===1.1.2
+ipaddress===1.0.23
+nosexcover===1.0.11
+debtcollector===1.22.0
+MarkupSafe===1.1.1
+netaddr===0.7.19
+prettytable===0.7.2
+traceback2===1.4.0
+eventlet===0.25.2
+extras===1.0.0
+reno===2.11.3
+imagesize===1.2.0
+urllib3===1.25.8
+mock===3.0.5
+PyYAML===5.3.1
+cryptography===2.9
+requests-mock===1.7.0
+unittest2===1.1.0
+Pygments===2.5.2
+requests===2.23.0
+snowballstemmer===2.0.0
+Jinja2===2.11.1
+cliff===2.18.0
+castellan===1.4.0
+coverage===5.0.4
+oslo.log===3.45.2
+docutils===0.15.2
+boto3===1.12.39
+stestr===2.6.0
+oslo.serialization===2.29.2
+testtools===2.4.0
+keystonemiddleware===9.0.0
+iso8601===0.1.12
+linecache2===1.0.0
+idna===2.9
+msgpack===0.6.2
+Sphinx===1.8.5
+oslo.config===7.0.0
+openstackdocstheme===1.31.2
+stevedore===1.32.0
+botocore===1.15.39
+cmd2===0.8.9
+os-testr===1.1.0
+xattr===0.9.7
+six===1.14.0
+dulwich===0.19.15
+GitPython===2.1.11
+wrapt===1.12.1
+rfc3986===1.4.0
+future===0.18.2
+boto===2.49.0
+monotonic===1.5
+netifaces===0.10.9
+keystoneauth1===4.0.0
+cffi===1.14.0
+Babel===2.8.0
+greenlet===0.4.15
+oslo.utils===3.42.1
+gitdb===0.6.4
+gitdb2===2.0.6
diff -pruN 2.25.0-3/releasenotes/source/conf.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/releasenotes/source/conf.py
--- 2.25.0-3/releasenotes/source/conf.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/releasenotes/source/conf.py	2020-09-15 21:13:36.000000000 +0000
@@ -116,7 +116,7 @@ exclude_patterns = ['_build', 'Thumbs.db
 # show_authors = False
 
 # The name of the Pygments (syntax highlighting) style to use.
-pygments_style = 'sphinx'
+pygments_style = 'native'
 
 # A list of ignored prefixes for module index sorting.
 # modindex_common_prefix = []
@@ -174,11 +174,6 @@ html_theme = 'openstackdocs'
 #
 # html_extra_path = []
 
-# If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
-# using the given strftime format.
-# html_last_updated_fmt = '%b %d, %Y'
-html_last_updated_fmt = '%Y-%m-%d %H:%M'
-
 # If true, SmartyPants will be used to convert quotes and dashes to
 # typographically correct entities.
 #
@@ -352,6 +347,7 @@ htmlhelp_basename = 'SwiftReleaseNotesdo
 locale_dirs = ['locale/']
 
 # -- Options for openstackdocstheme -------------------------------------------
-repository_name = 'openstack/swift'
-bug_project = 'swift'
-bug_tag = ''
+openstackdocs_repo_name = 'openstack/swift'
+openstackdocs_auto_name = False
+openstackdocs_bug_project = 'swift'
+openstackdocs_bug_tag = ''
diff -pruN 2.25.0-3/releasenotes/source/index.rst 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/releasenotes/source/index.rst
--- 2.25.0-3/releasenotes/source/index.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/releasenotes/source/index.rst	2020-09-15 21:13:36.000000000 +0000
@@ -7,6 +7,8 @@
 
    current
 
+   ussuri
+
    train
 
    stein
diff -pruN 2.25.0-3/releasenotes/source/locale/en_GB/LC_MESSAGES/releasenotes.po 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/releasenotes/source/locale/en_GB/LC_MESSAGES/releasenotes.po
--- 2.25.0-3/releasenotes/source/locale/en_GB/LC_MESSAGES/releasenotes.po	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/releasenotes/source/locale/en_GB/LC_MESSAGES/releasenotes.po	2020-09-15 21:13:36.000000000 +0000
@@ -5,11 +5,11 @@ msgid ""
 msgstr ""
 "Project-Id-Version: swift\n"
 "Report-Msgid-Bugs-To: \n"
-"POT-Creation-Date: 2020-04-14 13:23+0000\n"
+"POT-Creation-Date: 2020-05-27 04:38+0000\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"PO-Revision-Date: 2020-04-16 12:48+0000\n"
+"PO-Revision-Date: 2020-05-26 11:24+0000\n"
 "Last-Translator: Andi Chandler <andi@gowling.com>\n"
 "Language-Team: English (United Kingdom)\n"
 "Language: en_GB\n"
@@ -112,6 +112,9 @@ msgstr "2.23.1"
 msgid "2.24.0"
 msgstr "2.24.0"
 
+msgid "2.25.0"
+msgstr "2.25.0"
+
 msgid ""
 "A PUT or POST to a container will now update the container's Last-Modified "
 "time, and that value will be included in a GET/HEAD response."
@@ -156,6 +159,9 @@ msgstr ""
 "Account and container replication stats logs now include ``remote_merges``, "
 "the number of times a whole database was sent to another node."
 
+msgid "Account quotas are now enforced even on empty accounts."
+msgstr "Account quotas are now enforced even on empty accounts."
+
 msgid "Add Composite Ring Functionality"
 msgstr "Add Composite Ring Functionality"
 
@@ -239,6 +245,19 @@ msgstr ""
 "setting to enable or disable this functionality."
 
 msgid ""
+"Add support for multiple root encryption secrets for the trivial and KMIP "
+"keymasters. This allows operators to rotate encryption keys over time "
+"without needing to re-encrypt all existing data in the cluster. Please see "
+"the included sample config files for instructions on how to multiple "
+"encryption keys."
+msgstr ""
+"Add support for multiple root encryption secrets for the trivial and KMIP "
+"keymasters. This allows operators to rotate encryption keys over time "
+"without needing to re-encrypt all existing data in the cluster. Please see "
+"the included sample config files for instructions on how to multiple "
+"encryption keys."
+
+msgid ""
 "Add support to increase object ring partition power transparently to end "
 "users and with no cluster downtime. Increasing the ring part power allows "
 "for incremental adjustment to the upper bound of the cluster size. Please "
@@ -261,6 +280,19 @@ msgstr ""
 "locations more quickly. This helps when adding capacity to a ring."
 
 msgid ""
+"Added \"static symlinks\", which perform some validation as they follow "
+"redirects and include more information about their target in container "
+"listings. For more information, see the `symlink middleware <https://docs."
+"openstack.org/swift/latest/middleware.html#symlink>`__ section of the "
+"documentation."
+msgstr ""
+"Added \"static symlinks\", which perform some validation as they follow "
+"redirects and include more information about their target in container "
+"listings. For more information, see the `symlink middleware <https://docs."
+"openstack.org/swift/latest/middleware.html#symlink>`__ section of the "
+"documentation."
+
+msgid ""
 "Added ``--swift-versions`` to ``swift-recon`` CLI to compare installed "
 "versions in the cluster."
 msgstr ""
@@ -271,6 +303,15 @@ msgid "Added ``-d <devs>`` and ``-p <par
 msgstr "Added ``-d <devs>`` and ``-p <partitions>`` command line options."
 
 msgid ""
+"Added ``ttfb`` (Time to First Byte) and ``pid`` (Process ID) to the set of "
+"available proxy-server log fields. For more information, see `the "
+"documentation <https://docs.openstack.org/swift/latest/logs.html>`__."
+msgstr ""
+"Added ``ttfb`` (Time to First Byte) and ``pid`` (Process ID) to the set of "
+"available proxy-server log fields. For more information, see `the "
+"documentation <https://docs.openstack.org/swift/latest/logs.html>`__."
+
+msgid ""
 "Added a \"user\" option to the drive-audit config file. Its value is used to "
 "set the owner of the drive-audit recon cache."
 msgstr ""
@@ -278,6 +319,13 @@ msgstr ""
 "set the owner of the drive-audit recon cache."
 
 msgid ""
+"Added a ``keep_idle`` config option to configure KEEPIDLE time for TCP "
+"sockets. The default value is the old constant of 600."
+msgstr ""
+"Added a ``keep_idle`` config option to configure KEEPIDLE time for TCP "
+"sockets. The default value is the old constant of 600."
+
+msgid ""
 "Added a configurable URL base to staticweb, fixing issues when the "
 "accessible endpoint isn't known to the Swift cluster (eg http vs https)."
 msgstr ""
@@ -291,6 +339,66 @@ msgid "Added a handoffs-only mode."
 msgstr "Added a handoffs-only mode."
 
 msgid ""
+"Added a new middleware that allows users and operators to configure accounts "
+"and containers to use RFC-compliant (i.e., double-quoted) ETags. This may be "
+"useful when using Swift as an origin for some content delivery networks. For "
+"more information, see `the middleware documentation <https://docs.openstack."
+"org/swift/latest/middleware.html#etag-quoter>`__."
+msgstr ""
+"Added a new middleware that allows users and operators to configure accounts "
+"and containers to use RFC-compliant (i.e., double-quoted) ETags. This may be "
+"useful when using Swift as an origin for some content delivery networks. For "
+"more information, see `the middleware documentation <https://docs.openstack."
+"org/swift/latest/middleware.html#etag-quoter>`__."
+
+msgid ""
+"Added a new middleware to allow accounts and containers to opt-in to RFC-"
+"compliant ETags. For more information, see `the documentation <https://docs."
+"openstack.org/swift/latest/middleware.html#module-swift.common.middleware."
+"etag_quoter>`__. Clients should be aware of the fact that ETags may be "
+"quoted for RFC compliance; this may become the default behavior in some "
+"future release."
+msgstr ""
+"Added a new middleware to allow accounts and containers to opt-in to RFC-"
+"compliant ETags. For more information, see `the documentation <https://docs."
+"openstack.org/swift/latest/middleware.html#module-swift.common.middleware."
+"etag_quoter>`__. Clients should be aware of the fact that ETags may be "
+"quoted for RFC compliance; this may become the default behaviour in some "
+"future release."
+
+msgid ""
+"Added a new object versioning mode, with APIs for querying and accessing old "
+"versions. For more information, see `the documentation <https://docs."
+"openstack.org/swift/latest/middleware.html#module-swift.common.middleware."
+"versioned_writes.object_versioning>`__."
+msgstr ""
+"Added a new object versioning mode, with APIs for querying and accessing old "
+"versions. For more information, see `the documentation <https://docs."
+"openstack.org/swift/latest/middleware.html#module-swift.common.middleware."
+"versioned_writes.object_versioning>`__."
+
+msgid ""
+"Added an experimental ``swift-ring-composer`` CLI tool to build composite "
+"rings."
+msgstr ""
+"Added an experimental ``swift-ring-composer`` CLI tool to build composite "
+"rings."
+
+msgid ""
+"Added an operator tool, ``swift-container-deleter``, to asynchronously "
+"delete some or all objects in a container using the object expirers."
+msgstr ""
+"Added an operator tool, ``swift-container-deleter``, to asynchronously "
+"delete some or all objects in a container using the object expirers."
+
+msgid ""
+"Added an optional ``read_only`` middleware to make an entire cluster or "
+"individual accounts read only."
+msgstr ""
+"Added an optional ``read_only`` middleware to make an entire cluster or "
+"individual accounts read only."
+
+msgid ""
 "Added container sharding, an operator controlled feature that may be used to "
 "shard very large container databases into a number of smaller shard "
 "containers. This mitigates the issues with one large DB by distributing the "
@@ -308,6 +416,12 @@ msgstr ""
 msgid "Added container/object listing with prefix to InternalClient."
 msgstr "Added container/object listing with prefix to InternalClient."
 
+msgid "Added support for Python 3.8."
+msgstr "Added support for Python 3.8."
+
+msgid "Added support for S3 versioning using the above new mode."
+msgstr "Added support for S3 versioning using the above new mode."
+
 msgid "Added support for inline data segments in SLO manifests."
 msgstr "Added support for inline data segments in SLO manifests."
 
@@ -347,19 +461,46 @@ msgstr ""
 "unsatisfied-range value. This allows the caller to know the valid range "
 "request value for an object."
 
+msgid "Allow ``fallocate_reserve`` to be specified as a percentage."
+msgstr "Allow ``fallocate_reserve`` to be specified as a percentage."
+
+msgid "Allow direct_client users to overwrite the ``X-Timestamp`` header."
+msgstr "Allow direct_client users to overwrite the ``X-Timestamp`` header."
+
 msgid "Allow the expirer to gracefully move past updating stale work items."
 msgstr "Allow the expirer to gracefully move past updating stale work items."
 
 msgid "Always set Swift processes to use UTC."
 msgstr "Always set Swift processes to use UTC."
 
+msgid "Background corruption-detection improvements"
+msgstr "Background corruption-detection improvements"
+
 msgid "Bug Fixes"
 msgstr "Bug Fixes"
 
+msgid "COPY now works with unicode account names."
+msgstr "COPY now works with Unicode account names."
+
 msgid "Cache all answers from nameservers in cname_lookup."
 msgstr "Cache all answers from nameservers in cname_lookup."
 
 msgid ""
+"Change the behavior of the EC reconstructor to perform a fragment rebuild to "
+"a handoff node when a primary peer responds with 507 to the REPLICATE "
+"request. This changes EC to match the existing behavior of replication when "
+"drives fail. After a rebalance of EC rings (potentially removing unmounted/"
+"failed devices), it's most IO efficient to run in handoffs_only mode to "
+"avoid unnecessary rebuilds."
+msgstr ""
+"Change the behaviour of the EC reconstructor to perform a fragment rebuild "
+"to a handoff node when a primary peer responds with 507 to the REPLICATE "
+"request. This changes EC to match the existing behaviour of replication when "
+"drives fail. After a rebalance of EC rings (potentially removing unmounted/"
+"failed devices), it's most IO efficient to run in handoffs_only mode to "
+"avoid unnecessary rebuilds."
+
+msgid ""
 "Changed where liberasurecode-devel for CentOS 7 is referenced and installed "
 "as a dependency."
 msgstr ""
@@ -395,6 +536,9 @@ msgstr ""
 "fragment metadata will now be validated when read and, if bad data is found, "
 "the fragment will be quarantined."
 
+msgid "CompleteMultipartUpload requests with a ``Content-MD5`` now work."
+msgstr "CompleteMultipartUpload requests with a ``Content-MD5`` now work."
+
 msgid ""
 "Composite rings can be used for explicit replica placement and \"replicated "
 "EC\" for global erasure codes policies."
@@ -414,6 +558,11 @@ msgstr ""
 "moved in multiple components."
 
 msgid ""
+"Container metadata related to sharding are now removed when no longer needed."
+msgstr ""
+"Container metadata related to sharding are now removed when no longer needed."
+
+msgid ""
 "Container sync can now copy SLOs more efficiently by allowing the manifest "
 "to be synced before all of the referenced segments. This fixes a bug where "
 "container sync would not copy SLO manifests."
@@ -422,6 +571,13 @@ msgstr ""
 "to be synced before all of the referenced segments. This fixes a bug where "
 "container sync would not copy SLO manifests."
 
+msgid ""
+"Container sync now synchronizes static symlinks in a way similar to static "
+"large objects."
+msgstr ""
+"Container sync now synchronizes static symlinks in a way similar to static "
+"large objects."
+
 msgid "Correctly handle deleted files with if-none-match requests."
 msgstr "Correctly handle deleted files with if-none-match requests."
 
@@ -432,9 +588,19 @@ msgstr ""
 "Correctly send 412 Precondition Failed if a user sends an invalid copy "
 "destination. Previously Swift would send a 500 Internal Server Error."
 
+msgid "Correctness improvements"
+msgstr "Correctness improvements"
+
 msgid "Critical Issues"
 msgstr "Critical Issues"
 
+msgid ""
+"Cross-account symlinks now store correct account information in container "
+"listings. This was previously fixed in 2.22.0."
+msgstr ""
+"Cross-account symlinks now store correct account information in container "
+"listings. This was previously fixed in 2.22.0."
+
 msgid "Current (Unreleased) Release Notes"
 msgstr "Current (Unreleased) Release Notes"
 
@@ -452,6 +618,9 @@ msgstr ""
 msgid "Daemons using InternalClient can now be properly killed with SIGTERM."
 msgstr "Daemons using InternalClient can now be properly killed with SIGTERM."
 
+msgid "Data encryption updates"
+msgstr "Data encryption updates"
+
 msgid ""
 "Deleting an expiring object will now cause less work in the system. The "
 "number of async pending files written has been reduced for all objects and "
@@ -464,6 +633,15 @@ msgstr ""
 "burden on container servers."
 
 msgid ""
+"Deployers with clusters that relied on the old implicit default location of "
+"\"US\" should explicitly set ``location = US`` in the ``[filter:s3api]`` "
+"section of proxy-server.conf before upgrading."
+msgstr ""
+"Deployers with clusters that relied on the old implicit default location of "
+"\"US\" should explicitly set ``location = US`` in the ``[filter:s3api]`` "
+"section of proxy-server.conf before upgrading."
+
+msgid ""
 "Deprecate swift-temp-url and call python-swiftclient's implementation "
 "instead. This adds python-swiftclient as an optional dependency of Swift."
 msgstr ""
@@ -473,9 +651,24 @@ msgstr ""
 msgid "Deprecation Notes"
 msgstr "Deprecation Notes"
 
+msgid "Detect and remove invalid entries from ``hashes.pkl``"
+msgstr "Detect and remove invalid entries from ``hashes.pkl``"
+
+msgid ""
+"Device region and zone can now be changed via ``swift-ring-builder``. Note "
+"that this may cause a lot of data movement on the next rebalance as the "
+"builder tries to reach full dispersion."
+msgstr ""
+"Device region and zone can now be changed via ``swift-ring-builder``. Note "
+"that this may cause a lot of data movement on the next rebalance as the "
+"builder tries to reach full dispersion."
+
 msgid "Disallow X-Delete-At header values equal to the X-Timestamp header."
 msgstr "Disallow X-Delete-At header values equal to the X-Timestamp header."
 
+msgid "Display crypto data/metadata details in swift-object-info."
+msgstr "Display crypto data/metadata details in swift-object-info."
+
 msgid "Display more info on empty rings."
 msgstr "Display more info on empty rings."
 
@@ -563,6 +756,15 @@ msgid "Fix SLO delete for accounts with
 msgstr "Fix SLO delete for accounts with non-ASCII names."
 
 msgid ""
+"Fixed 500 from cname_lookup middleware. Previously, if the looked-up domain "
+"was used by domain_remap to update the request path, the server would "
+"respond Internal Error."
+msgstr ""
+"Fixed 500 from cname_lookup middleware. Previously, if the looked-up domain "
+"was used by domain_remap to update the request path, the server would "
+"respond Internal Error."
+
+msgid ""
 "Fixed UnicodeDecodeError in the object reconstructor that would prevent "
 "objects with non-ascii names from being reconstructed and caused the "
 "reconstructor process to hang."
@@ -603,6 +805,13 @@ msgstr ""
 "only requested if the sync request was successful."
 
 msgid ""
+"Fixed a bug in the new object versioning API that would cause more than "
+"``limit`` results to be returned when listing."
+msgstr ""
+"Fixed a bug in the new object versioning API that would cause more than "
+"``limit`` results to be returned when listing."
+
+msgid ""
 "Fixed a bug introduced in 2.15.0 where the object reconstructor would exit "
 "with a traceback if no EC policy was configured."
 msgstr ""
@@ -627,6 +836,13 @@ msgstr ""
 "a 5xx series response."
 
 msgid ""
+"Fixed a bug where encryption would store the incorrect key metadata if the "
+"object name starts with a slash."
+msgstr ""
+"Fixed a bug where encryption would store the incorrect key metadata if the "
+"object name starts with a slash."
+
+msgid ""
 "Fixed a bug where some headers weren't being copied correctly in a COPY "
 "request."
 msgstr ""
@@ -643,6 +859,22 @@ msgstr ""
 "Fixed a bug where the ring builder would not allow removal of a device when "
 "min_part_seconds_left was greater than zero."
 
+msgid ""
+"Fixed a bug where zero-byte PUTs would not work properly with \"If-None-"
+"Match: \\*\" conditional requests."
+msgstr ""
+"Fixed a bug where zero-byte PUTs would not work properly with \"If-None-"
+"Match: \\*\" conditional requests."
+
+msgid ""
+"Fixed a cache invalidation issue related to GET and PUT requests to "
+"containers that would occasionally cause object PUTs to a container to 404 "
+"after the container had been successfully created."
+msgstr ""
+"Fixed a cache invalidation issue related to GET and PUT requests to "
+"containers that would occasionally cause object PUTs to a container to 404 "
+"after the container had been successfully created."
+
 msgid "Fixed a few areas where the ``swiftdir`` option was not respected."
 msgstr "Fixed a few areas where the ``swiftdir`` option was not respected."
 
@@ -668,16 +900,114 @@ msgid "Fixed a socket leak in copy middl
 msgstr "Fixed a socket leak in copy middleware when a large object was copied."
 
 msgid ""
+"Fixed an issue in COPY where concurrent requests may have copied the wrong "
+"data."
+msgstr ""
+"Fixed an issue in COPY where concurrent requests may have copied the wrong "
+"data."
+
+msgid ""
+"Fixed an issue that caused Delete Multiple Objects requests with large "
+"bodies to 400. This was previously fixed in 2.20.0."
+msgstr ""
+"Fixed an issue that caused Delete Multiple Objects requests with large "
+"bodies to 400. This was previously fixed in 2.20.0."
+
+msgid ""
+"Fixed an issue where S3 API v4 signatures would not be validated against the "
+"body of the request, allowing a replay attack if request headers were "
+"captured by a malicious third party."
+msgstr ""
+"Fixed an issue where S3 API v4 signatures would not be validated against the "
+"body of the request, allowing a replay attack if request headers were "
+"captured by a malicious third party."
+
+msgid ""
+"Fixed an issue where a failed drive could prevent the container sharder from "
+"making progress."
+msgstr ""
+"Fixed an issue where a failed drive could prevent the container sharder from "
+"making progress."
+
+msgid ""
+"Fixed an issue where an object server failure during a client download could "
+"leave an open socket between the proxy and client."
+msgstr ""
+"Fixed an issue where an object server failure during a client download could "
+"leave an open socket between the proxy and client."
+
+msgid ""
 "Fixed an issue where background consistency daemon child processes would "
 "deadlock waiting on the same file descriptor."
 msgstr ""
 "Fixed an issue where background consistency daemon child processes would "
 "deadlock waiting on the same file descriptor."
 
+msgid ""
+"Fixed an issue where deleted EC objects didn't have their on-disk "
+"directories cleaned up. This would cause extra resource usage on the object "
+"servers."
+msgstr ""
+"Fixed an issue where deleted EC objects didn't have their on-disk "
+"directories cleaned up. This would cause extra resource usage on the object "
+"servers."
+
+msgid ""
+"Fixed an issue where multipart uploads with the S3 API would sometimes "
+"report an error despite all segments being upload successfully."
+msgstr ""
+"Fixed an issue where multipart uploads with the S3 API would sometimes "
+"report an error despite all segments being upload successfully."
+
+msgid ""
+"Fixed an issue where non-ASCII Keystone EC2 credentials would not get mapped "
+"to the correct account. This was previously fixed in 2.20.0."
+msgstr ""
+"Fixed an issue where non-ASCII Keystone EC2 credentials would not get mapped "
+"to the correct account. This was previously fixed in 2.20.0."
+
+msgid ""
+"Fixed an issue where v4 signatures would not be validated against the body "
+"of the request, allowing a replay attack if request headers were captured by "
+"a malicious third party. Note that unsigned payloads still function normally."
+msgstr ""
+"Fixed an issue where v4 signatures would not be validated against the body "
+"of the request, allowing a replay attack if request headers were captured by "
+"a malicious third party. Note that unsigned payloads still function normally."
+
+msgid ""
+"Fixed an issue with SSYNC requests to ensure that only one request can be "
+"running on a partition at a time."
+msgstr ""
+"Fixed an issue with SSYNC requests to ensure that only one request can be "
+"running on a partition at a time."
+
+msgid ""
+"Fixed an issue with multi-region EC policies that caused the EC "
+"reconstructor to constantly attempt cross-region rebuild traffic."
+msgstr ""
+"Fixed an issue with multi-region EC policies that caused the EC "
+"reconstructor to constantly attempt cross-region rebuild traffic."
+
 msgid "Fixed deadlock when logging from a tpool thread."
 msgstr "Fixed deadlock when logging from a tpool thread."
 
 msgid ""
+"Fixed deadlock when logging from a tpool thread. The object server runs "
+"certain IO-intensive methods outside the main pthread for performance. "
+"Previously, if one of those methods tried to log, this can cause a crash "
+"that eventually leads to an object server with hundreds or thousands of "
+"greenthreads, all deadlocked. The fix is to use a mutex that works across "
+"different greenlets and different pthreads."
+msgstr ""
+"Fixed deadlock when logging from a tpool thread. The object server runs "
+"certain IO-intensive methods outside the main pthread for performance. "
+"Previously, if one of those methods tried to log, this can cause a crash "
+"that eventually leads to an object server with hundreds or thousands of "
+"greenthreads, all deadlocked. The fix is to use a mutex that works across "
+"different greenlets and different pthreads."
+
+msgid ""
 "Fixed encoding issue in ssync where a mix of ascii and non-ascii metadata "
 "values would cause an error."
 msgstr ""
@@ -696,6 +1026,19 @@ msgstr ""
 "drive space used and filling the cluster."
 
 msgid ""
+"Fixed issue where bulk requests using xml and expect 100-continue would "
+"return a malformed HTTP response."
+msgstr ""
+"Fixed issue where bulk requests using XML and expect 100-continue would "
+"return a malformed HTTP response."
+
+msgid "Fixed listings for sharded containers."
+msgstr "Fixed listings for sharded containers."
+
+msgid "Fixed non-ASCII account metadata handling."
+msgstr "Fixed non-ASCII account metadata handling."
+
+msgid ""
 "Fixed non-deterministic suffix updates in hashes.pkl where a partition may "
 "be updated much less often than expected."
 msgstr ""
@@ -730,17 +1073,26 @@ msgstr ""
 msgid "Fixed some minor test compatibility issues."
 msgstr "Fixed some minor test compatibility issues."
 
+msgid "Fixed some title-casing of headers."
+msgstr "Fixed some title-casing of headers."
+
 msgid "Fixed the KeyError message when auditor finds an expired object."
 msgstr "Fixed the KeyError message when auditor finds an expired object."
 
 msgid "Fixed the stats calculation in the erasure code reconstructor."
 msgstr "Fixed the stats calculation in the erasure code reconstructor."
 
+msgid "Fixed time skew when using X-Delete-After."
+msgstr "Fixed time skew when using X-Delete-After."
+
 msgid ""
 "Fixed using ``swift-ring-builder set_weight`` with more than one device."
 msgstr ""
 "Fixed using ``swift-ring-builder set_weight`` with more than one device."
 
+msgid "Fixed v1 listings that end with a non-ASCII object name."
+msgstr "Fixed v1 listings that end with a non-ASCII object name."
+
 msgid ""
 "For further information see the `docs <https://docs.openstack.org/swift/"
 "latest/overview_ring.html#module-swift.common.ring.composite_builder>`__"
@@ -748,6 +1100,23 @@ msgstr ""
 "For further information see the `docs <https://docs.openstack.org/swift/"
 "latest/overview_ring.html#module-swift.common.ring.composite_builder>`__"
 
+msgid ""
+"For new multipart-uploads via the S3 API, the ETag that is stored will be "
+"calculated in the same way that AWS uses. This ETag will be used in GET/HEAD "
+"responses, bucket listings, and conditional requests via the S3 API. "
+"Accessing the same object via the Swift API will use the SLO Etag; however, "
+"in JSON container listings the multipart upload etag will be exposed in a "
+"new \"s3_etag\" key. Previously, some S3 clients would complain about "
+"download corruption when the ETag did not have a '-'."
+msgstr ""
+"For new multipart-uploads via the S3 API, the ETag that is stored will be "
+"calculated in the same way that AWS uses. This ETag will be used in GET/HEAD "
+"responses, bucket listings, and conditional requests via the S3 API. "
+"Accessing the same object via the Swift API will use the SLO Etag; however, "
+"in JSON container listings the multipart upload etag will be exposed in a "
+"new \"s3_etag\" key. Previously, some S3 clients would complain about "
+"download corruption when the ETag did not have a '-'."
+
 msgid "Fractional replicas are no longer allowed for erasure code policies."
 msgstr "Fractional replicas are no longer allowed for erasure code policies."
 
@@ -764,6 +1133,15 @@ msgstr ""
 "forwarded to the referenced object. POST requests sent to a symlink will "
 "result in a 307 Temporary Redirect response."
 
+msgid ""
+"Getting an SLO manifest with ``?format=raw`` now responds with an ETag that "
+"matches the MD5 of the generated body rather than the MD5 of the manifest "
+"stored on disk."
+msgstr ""
+"Getting an SLO manifest with ``?format=raw`` now responds with an ETag that "
+"matches the MD5 of the generated body rather than the MD5 of the manifest "
+"stored on disk."
+
 msgid "I/O priority is now supported on AArch64 architecture."
 msgstr "I/O priority is now supported on AArch64 architecture."
 
@@ -776,6 +1154,9 @@ msgstr ""
 "create fails, it will now return a server error (500) instead of Not Found "
 "(404)."
 
+msgid "If running Swift under Python 3, ``eventlet`` must be at least 0.25.0."
+msgstr "If running Swift under Python 3, ``eventlet`` must be at least 0.25.0."
+
 msgid ""
 "If using erasure coding with ISA-L in rs_vand mode and 5 or more parity "
 "fragments, Swift will emit a warning. This is a configuration that is known "
@@ -793,12 +1174,28 @@ msgstr ""
 "be migrated as soon as possible. Please see https://bugs.launchpad.net/swift/"
 "+bug/1639691 for more information."
 
+msgid "If you have a config file like this::"
+msgstr "If you have a config file like this::"
+
 msgid "If you upgrade and roll back, you must delete all `hashes.pkl` files."
 msgstr "If you upgrade and roll back, you must delete all `hashes.pkl` files."
 
+msgid "If you want updates to be processed exactly as before, do this::"
+msgstr "If you want updates to be processed exactly as before, do this::"
+
+msgid ""
+"If you've been testing Swift on Python 3, upgrade at your earliest "
+"convenience."
+msgstr ""
+"If you've been testing Swift on Python 3, upgrade at your earliest "
+"convenience."
+
 msgid "Imported docs content from openstack-manuals project."
 msgstr "Imported docs content from openstack-manuals project."
 
+msgid "Improved S3 API compatibility."
+msgstr "Improved S3 API compatibility."
+
 msgid ""
 "Improved ``object-updater`` stats logging. It now tells you all of its stats "
 "(successes, failures, quarantines due to bad pickles, unlinks, and errors), "
@@ -811,11 +1208,35 @@ msgstr ""
 "end of a pass remains and has been expanded to also include all stats."
 
 msgid ""
+"Improved container-sync performance when data has already been deleted or "
+"overwritten."
+msgstr ""
+"Improved container-sync performance when data has already been deleted or "
+"overwritten."
+
+msgid ""
 "Improved performance by eliminating an unneeded directory structure hash."
 msgstr ""
 "Improved performance by eliminating an unneeded directory structure hash."
 
 msgid ""
+"Improved performance of sharded container listings when performing prefix "
+"listings."
+msgstr ""
+"Improved performance of sharded container listings when performing prefix "
+"listings."
+
+msgid ""
+"Improved proxy-server performance by reducing unnecessary locking, memory "
+"copies, and eventlet scheduling."
+msgstr ""
+"Improved proxy-server performance by reducing unnecessary locking, memory "
+"copies, and eventlet scheduling."
+
+msgid "Improved proxy-to-backend requests to be more RFC-compliant."
+msgstr "Improved proxy-to-backend requests to be more RFC-compliant."
+
+msgid ""
 "Improved the granularity of the ring dispersion metric so that small "
 "improvements after a rebalance can show changes in the dispersion number. "
 "Dispersion in existing and new rings can be recalculated using the new ``--"
@@ -878,6 +1299,9 @@ msgstr ""
 "the filename. This saves one inode for every EC .data file. Existing ."
 "durable files will not be removed, and they will continue to work just fine."
 
+msgid "Internal client no longer logs object DELETEs as status 499."
+msgstr "Internal client no longer logs object DELETEs as status 499."
+
 msgid ""
 "Let clients request heartbeats during SLO PUTs by including the query "
 "parameter ``heartbeat=on``."
@@ -896,6 +1320,13 @@ msgstr ""
 "exposes the value to offer consistency with the object listings on "
 "containers."
 
+msgid ""
+"Lock timeouts in the container updater are now logged at INFO level, not "
+"ERROR."
+msgstr ""
+"Lock timeouts in the container updater are now logged at INFO level, not "
+"ERROR."
+
 msgid "Log correct status code for conditional requests."
 msgstr "Log correct status code for conditional requests."
 
@@ -908,10 +1339,37 @@ msgstr ""
 "config. Configure the ``versioned_writes`` middleware in the proxy server "
 "instead. This option will be ignored in a future release."
 
+msgid ""
+"Log deprecation warnings for ``run_pause``. This setting was deprecated in "
+"Swift 2.4.0 and is replaced by ``interval``. It may be removed in a future "
+"release."
+msgstr ""
+"Log deprecation warnings for ``run_pause``. This setting was deprecated in "
+"Swift 2.4.0 and is replaced by ``interval``. It may be removed in a future "
+"release."
+
+msgid ""
+"Log formats are now more configurable and include support for anonymization. "
+"See the ``log_msg_template`` option in ``proxy-server.conf`` and `the Swift "
+"documentation <https://docs.openstack.org/swift/latest/logs.html#proxy-"
+"logs>`__ for more information."
+msgstr ""
+"Log formats are now more configurable and include support for anonymization. "
+"See the ``log_msg_template`` option in ``proxy-server.conf`` and `the Swift "
+"documentation <https://docs.openstack.org/swift/latest/logs.html#proxy-"
+"logs>`__ for more information."
+
 msgid "Log the correct request type of a subrequest downstream of copy."
 msgstr "Log the correct request type of a sub-request downstream of copy."
 
 msgid ""
+"Lower bounds of dependencies have been updated to reflect what is actually "
+"tested."
+msgstr ""
+"Lower bounds of dependencies have been updated to reflect what is actually "
+"tested."
+
+msgid ""
 "Make mount_check option usable in containerized environments by adding a "
 "check for an \".ismount\" file at the root directory of a device."
 msgstr ""
@@ -942,10 +1400,43 @@ msgstr ""
 "Moved other-requirements.txt to bindep.txt. bindep.txt lists non-Python "
 "dependencies of Swift."
 
+msgid ""
+"Multi-character strings may now be used as delimiters in account and "
+"container listings."
+msgstr ""
+"Multi-character strings may now be used as delimiters in account and "
+"container listings."
+
+msgid ""
+"Multipart object segments are now actually deleted when the multipart object "
+"is deleted via the S3 API."
+msgstr ""
+"Multipart object segments are now actually deleted when the multipart object "
+"is deleted via the S3 API."
+
+msgid "Multipart upload parts may now be copied from other multipart uploads."
+msgstr "Multipart upload parts may now be copied from other multipart uploads."
+
+msgid ""
+"Multiple keymaster middlewares are now supported. This allows migration from "
+"one key provider to another."
+msgstr ""
+"Multiple keymaster middlewares are now supported. This allows migration from "
+"one key provider to another."
+
 msgid "New Features"
 msgstr "New Features"
 
 msgid ""
+"New buckets created via the S3 API will now store multi-part upload data in "
+"the same storage policy as other data rather than the cluster's default "
+"storage policy."
+msgstr ""
+"New buckets created via the S3 API will now store multi-part upload data in "
+"the same storage policy as other data rather than the cluster's default "
+"storage policy."
+
+msgid ""
 "New config variables to change the schedule priority and I/O scheduling "
 "class. Servers and daemons now understand `nice_priority`, `ionice_class`, "
 "and `ionice_priority` to schedule their relative importance. Please read "
@@ -962,6 +1453,15 @@ msgid "Newton Series Release Notes"
 msgstr "Newton Series Release Notes"
 
 msgid ""
+"Note that ``secret_id`` values must remain unique across all keymasters in a "
+"given pipeline. If they are not unique, the right-most keymaster will take "
+"precedence."
+msgstr ""
+"Note that ``secret_id`` values must remain unique across all keymasters in a "
+"given pipeline. If they are not unique, the right-most keymaster will take "
+"precedence."
+
+msgid ""
 "Note that after writing EC data with Swift 2.11.0 or later, that data will "
 "not be accessible to earlier versions of Swift."
 msgstr ""
@@ -991,10 +1491,28 @@ msgstr ""
 msgid "Now ``swift-recon-cron`` works with conf.d configs."
 msgstr "Now ``swift-recon-cron`` works with conf.d configs."
 
+msgid ""
+"O_TMPFILE support is now detected by attempting to use it instead of looking "
+"at the kernel version. This allows older kernels with backported patches to "
+"take advantage of the O_TMPFILE functionality."
+msgstr ""
+"O_TMPFILE support is now detected by attempting to use it instead of looking "
+"at the kernel version. This allows older kernels with backported patches to "
+"take advantage of the O_TMPFILE functionality."
+
 msgid "Object expiry improvements"
 msgstr "Object expiry improvements"
 
 msgid ""
+"Object reconstructor logs are now prefixed with information about the "
+"specific worker process logging the message. This makes reading the logs and "
+"understanding the messages much simpler."
+msgstr ""
+"Object reconstructor logs are now prefixed with information about the "
+"specific worker process logging the message. This makes reading the logs and "
+"understanding the messages much simpler."
+
+msgid ""
 "Object versioning now supports a \"history\" mode in addition to the older "
 "\"stack\" mode. The difference is in how DELETE requests are handled. For "
 "full details, please read http://docs.openstack.org/developer/swift/"
@@ -1005,10 +1523,56 @@ msgstr ""
 "full details, please read http://docs.openstack.org/developer/swift/"
 "overview_object_versioning.html."
 
+msgid ""
+"Object writes to a container whose existence cannot be verified now 503 "
+"instead of 404."
+msgstr ""
+"Object writes to a container whose existence cannot be verified now 503 "
+"instead of 404."
+
+msgid ""
+"Objects with an ``X-Delete-At`` value in the far future no longer cause "
+"backend server errors."
+msgstr ""
+"Objects with an ``X-Delete-At`` value in the far future no longer cause "
+"backend server errors."
+
 msgid "Ocata Series Release Notes"
 msgstr "Ocata Series Release Notes"
 
 msgid ""
+"On Python 3, certain S3 API headers are now lower case as they would be "
+"coming from AWS."
+msgstr ""
+"On Python 3, certain S3 API headers are now lower case as they would be "
+"coming from AWS."
+
+msgid ""
+"On Python 3, fixed a RecursionError in swift-dispersion-report when using "
+"TLS."
+msgstr ""
+"On Python 3, fixed a RecursionError in swift-dispersion-report when using "
+"TLS."
+
+msgid ""
+"On Python 3, fixed an issue when reading or writing objects with a content "
+"type like ``message/*``. Previously, Swift would fail to respond."
+msgstr ""
+"On Python 3, fixed an issue when reading or writing objects with a content "
+"type like ``message/*``. Previously, Swift would fail to respond."
+
+msgid ""
+"On Python 3, the KMS keymaster now works with secrets stored in Barbican "
+"with a ``text/plain`` payload-content-type."
+msgstr ""
+"On Python 3, the KMS keymaster now works with secrets stored in Barbican "
+"with a ``text/plain`` payload-content-type."
+
+msgid "On Python 3, the formpost middleware now works with unicode file names."
+msgstr ""
+"On Python 3, the formpost middleware now works with Unicode file names."
+
+msgid ""
 "On newer kernels (3.15+ when using xfs), Swift will use the O_TMPFILE flag "
 "when opening a file instead of creating a temporary file and renaming it on "
 "commit. This makes the data path simpler and allows the filesystem to more "
@@ -1020,6 +1584,13 @@ msgstr ""
 "efficiently optimise the files on disk, resulting in better performance."
 
 msgid ""
+"On upgrade, a node configured with concurrency=N will still handle async "
+"updates N-at-a-time, but will do so using only one process instead of N."
+msgstr ""
+"On upgrade, a node configured with concurrency=N will still handle async "
+"updates N-at-a-time, but will do so using only one process instead of N."
+
+msgid ""
 "Optimize the Erasure Code reconstructor protocol to reduce IO load on "
 "servers."
 msgstr ""
@@ -1033,6 +1604,19 @@ msgstr ""
 "Optimised the common case for hashing filesystem trees, thus eliminating a "
 "lot of extraneous disk I/O."
 
+msgid ""
+"Ordinary objects in S3 use the MD5 of the object as the ETag, just like "
+"Swift. Multipart Uploads follow a different format, notably including a dash "
+"followed by the number of segments. To that end (and for S3 API requests "
+"*only*), SLO responses via the S3 API have a literal '-N' added on the end "
+"of the ETag."
+msgstr ""
+"Ordinary objects in S3 use the MD5 of the object as the ETag, just like "
+"Swift. Multipart Uploads follow a different format, notably including a dash "
+"followed by the number of segments. To that end (and for S3 API requests "
+"*only*), SLO responses via the S3 API have a literal '-N' added on the end "
+"of the ETag."
+
 msgid "Other Notes"
 msgstr "Other Notes"
 
@@ -1045,10 +1629,41 @@ msgstr ""
 "SSC (server-side copy) Swift source field. See https://docs.openstack.org/"
 "developer/swift/logs.html#swift-source for more information."
 
+msgid ""
+"Per-service ``auto_create_account_prefix`` settings are now deprecated and "
+"may be ignored in a future release; if you need to use this, please set it "
+"in the ``[swift-constraints]`` section of ``/etc/swift/swift.conf``."
+msgstr ""
+"Per-service ``auto_create_account_prefix`` settings are now deprecated and "
+"may be ignored in a future release; if you need to use this, please set it "
+"in the ``[swift-constraints]`` section of ``/etc/swift/swift.conf``."
+
 msgid "Pike Series Release Notes"
 msgstr "Pike Series Release Notes"
 
 msgid ""
+"Prevent PyKMIP's kmip_protocol logger from logging at DEBUG. Previously, "
+"some versions of PyKMIP would include all wire data when the root logger was "
+"configured to log at DEBUG; this could expose key material in logs. Only the "
+"``kmip_keymaster`` was affected."
+msgstr ""
+"Prevent PyKMIP's kmip_protocol logger from logging at DEBUG. Previously, "
+"some versions of PyKMIP would include all wire data when the root logger was "
+"configured to log at DEBUG; this could expose key material in logs. Only the "
+"``kmip_keymaster`` was affected."
+
+msgid ""
+"Prevent PyKMIP's kmip_protocol logger from logging at DEBUG. Previously, "
+"some versions of PyKMIP would include all wire data when the root logger was "
+"configured to log at DEBUG; this could expose key material in logs. Only the "
+"kmip_keymaster was affected."
+msgstr ""
+"Prevent PyKMIP's kmip_protocol logger from logging at DEBUG. Previously, "
+"some versions of PyKMIP would include all wire data when the root logger was "
+"configured to log at DEBUG; this could expose key material in logs. Only the "
+"kmip_keymaster was affected."
+
+msgid ""
 "Prevent logged traceback in object-server on client disconnect for chunked "
 "transfers to replicated policies."
 msgstr ""
@@ -1071,10 +1686,43 @@ msgstr ""
 "Provide an S3 API compatibility layer. The external \"swift3\" project has "
 "been imported into Swift's codebase as the \"s3api\" middleware."
 
+msgid ""
+"Provide useful status codes in logs for some versioning and symlink "
+"subrequests that were previously logged as 499."
+msgstr ""
+"Provide useful status codes in logs for some versioning and symlink "
+"subrequests that were previously logged as 499."
+
+msgid ""
+"Proxy, account, container, and object servers now support \"seamless reloads"
+"\" via ``SIGUSR1``. This is similar to the existing graceful restarts but "
+"keeps the server socket open the whole time, reducing service downtime."
+msgstr ""
+"Proxy, account, container, and object servers now support \"seamless reloads"
+"\" via ``SIGUSR1``. This is similar to the existing graceful restarts but "
+"keeps the server socket open the whole time, reducing service downtime."
+
+msgid "Python 3 fixes:"
+msgstr "Python 3 fixes:"
+
+msgid ""
+"Python 3.6 and 3.7 are now fully supported. If you've been testing Swift on "
+"Python 3, upgrade at your earliest convenience."
+msgstr ""
+"Python 3.6 and 3.7 are now fully supported. If you've been testing Swift on "
+"Python 3, upgrade at your earliest convenience."
+
 msgid "Queens Series Release Notes"
 msgstr "Queens Series Release Notes"
 
 msgid ""
+"Reduced object-replicator and object-reconstructor CPU usage by only "
+"checking that the device list is current when rings change."
+msgstr ""
+"Reduced object-replicator and object-reconstructor CPU usage by only "
+"checking that the device list is current when rings change."
+
+msgid ""
 "Remove ``swift-temp-url`` script. The functionality has been in swiftclient "
 "for a long time and this script has been deprecated since 2.10.0."
 msgstr ""
@@ -1100,6 +1748,11 @@ msgstr ""
 "Large-Object metadata."
 
 msgid ""
+"Removed a request-smuggling vector when running a mixed py2/py3 cluster."
+msgstr ""
+"Removed a request-smuggling vector when running a mixed py2/py3 cluster."
+
+msgid ""
 "Removed all ``post_as_copy`` related code and configs. The option has been "
 "deprecated since 2.13.0."
 msgstr ""
@@ -1124,6 +1777,13 @@ msgstr ""
 "deprecated, but continues to function for now. If both values are defined, "
 "the old ``replication_one_per_device`` is ignored."
 
+msgid ""
+"Requesting multiple ranges from a Dynamic Large Object now returns the "
+"entire object instead of incorrect data. This was previously fixed in 2.23.0."
+msgstr ""
+"Requesting multiple ranges from a Dynamic Large Object now returns the "
+"entire object instead of incorrect data. This was previously fixed in 2.23.0."
+
 msgid "Require that known-bad EC schemes be deprecated"
 msgstr "Require that known-bad EC schemes be deprecated"
 
@@ -1170,6 +1830,22 @@ msgstr ""
 msgid "Rocky Series Release Notes"
 msgstr "Rocky Series Release Notes"
 
+msgid "S3 API compatibility updates"
+msgstr "S3 API compatibility updates"
+
+msgid "S3 API improvements"
+msgstr "S3 API improvements"
+
+msgid ""
+"S3 API now translates ``503 Service Unavailable`` responses to a more S3-"
+"like response instead of raising an error."
+msgstr ""
+"S3 API now translates ``503 Service Unavailable`` responses to a more S3-"
+"like response instead of raising an error."
+
+msgid "S3 ETag for SLOs now include a '-'."
+msgstr "S3 ETag for SLOs now include a '-'."
+
 msgid ""
 "SLO manifest PUT requests can now be properly validated by sending an ETag "
 "header of the md5 sum of the concatenated md5 sums of the referenced "
@@ -1191,6 +1867,15 @@ msgstr ""
 "setting in the \"[filter:slo]\" section of the proxy server config."
 
 msgid ""
+"SSYNC replication mode now removes as much of the directory structure as "
+"possible as soon at it observes that the directory is empty. This reduces "
+"the work needed for subsequent replication passes."
+msgstr ""
+"SSYNC replication mode now removes as much of the directory structure as "
+"possible as soon at it observes that the directory is empty. This reduces "
+"the work needed for subsequent replication passes."
+
+msgid ""
 "Save the ring when dispersion improves, even if balance doesn't improve."
 msgstr ""
 "Save the ring when dispersion improves, even if balance doesn't improve."
@@ -1198,6 +1883,12 @@ msgstr ""
 msgid "Send ETag header in 206 Partial Content responses to SLO reads."
 msgstr "Send ETag header in 206 Partial Content responses to SLO reads."
 
+msgid "Several utility scripts now work better on Python 3:"
+msgstr "Several utility scripts now work better on Python 3:"
+
+msgid "Sharding improvements"
+msgstr "Sharding improvements"
+
 msgid ""
 "Significant improvements to the api-ref doc available at http://developer."
 "openstack.org/api-ref/object-storage/."
@@ -1212,6 +1903,13 @@ msgstr ""
 "Static Large Object (SLO) manifest may now (again) have zero-byte last "
 "segments."
 
+msgid ""
+"Static Large Object sizes in listings for versioned containers are now more "
+"accurate."
+msgstr ""
+"Static Large Object sizes in listings for versioned containers are now more "
+"accurate."
+
 msgid "Stein Series Release Notes"
 msgstr "Stein Series Release Notes"
 
@@ -1225,6 +1923,15 @@ msgstr ""
 msgid "Stopped logging tracebacks when receiving an unexpected response."
 msgstr "Stopped logging tracebacks when receiving an unexpected response."
 
+msgid ""
+"Storage policy definitions in swift.conf can now define the diskfile to use "
+"to access objects. See the included swift.conf-sample file for a description "
+"of usage."
+msgstr ""
+"Storage policy definitions in swift.conf can now define the diskfile to use "
+"to access objects. See the included swift.conf-sample file for a description "
+"of usage."
+
 msgid "Support multi-range GETs for static large objects."
 msgstr "Support multi-range GETs for static large objects."
 
@@ -1238,6 +1945,17 @@ msgid "Swift Release Notes"
 msgstr "Swift Release Notes"
 
 msgid ""
+"Swift can now cache the S3 secret from Keystone to use for subsequent "
+"requests. This functionality is disabled by default but can be enabled by "
+"setting the ``secret_cache_duration`` in the ``[filter:s3token]`` section of "
+"the proxy server config to a number greater than 0."
+msgstr ""
+"Swift can now cache the S3 secret from Keystone to use for subsequent "
+"requests. This functionality is disabled by default but can be enabled by "
+"setting the ``secret_cache_duration`` in the ``[filter:s3token]`` section of "
+"the proxy server config to a number greater than 0."
+
+msgid ""
 "Swift now returns a 503 (instead of a 500) when an account auto-create fails."
 msgstr ""
 "Swift now returns a 503 (instead of a 500) when an account auto-create fails."
@@ -1267,6 +1985,15 @@ msgstr ""
 "including the X-Symlink-Target-Account header."
 
 msgid ""
+"TempURLs now support IP range restrictions. Please see https://docs."
+"openstack.org/swift/latest/middleware.html#client-usage for more information "
+"on how to use this additional restriction."
+msgstr ""
+"TempURLs now support IP range restrictions. Please see https://docs."
+"openstack.org/swift/latest/middleware.html#client-usage for more information "
+"on how to use this additional restriction."
+
+msgid ""
 "TempURLs now support a validation against a common prefix. A prefix-based "
 "signature grants access to all objects which share the same prefix. This "
 "avoids the creation of a large amount of signatures, when a whole container "
@@ -1307,6 +2034,31 @@ msgstr ""
 "on servers with many drives."
 
 msgid ""
+"The EC reconstructor will now attempt to remove empty directories "
+"immediately, while the inodes are still cached, rather than waiting until "
+"the next run."
+msgstr ""
+"The EC reconstructor will now attempt to remove empty directories "
+"immediately, while the inodes are still cached, rather than waiting until "
+"the next run."
+
+msgid ""
+"The ``container-replicator`` now correctly enqueues ``container-reconciler`` "
+"work for sharded containers."
+msgstr ""
+"The ``container-replicator`` now correctly enqueues ``container-reconciler`` "
+"work for sharded containers."
+
+msgid ""
+"The ``container-replicator`` now only attempts to fetch shard ranges if the "
+"remote indicates that it has shard ranges. Further, it does so with a "
+"timeout to prevent the process from hanging in certain cases."
+msgstr ""
+"The ``container-replicator`` now only attempts to fetch shard ranges if the "
+"remote indicates that it has shard ranges. Further, it does so with a "
+"timeout to prevent the process from hanging in certain cases."
+
+msgid ""
 "The ``domain_remap`` middleware now supports the ``mangle_client_paths`` "
 "option. Its default \"false\" value changes ``domain_remap`` parsing to stop "
 "stripping the ``path_root`` value from URL paths. If users depend on this "
@@ -1320,6 +2072,67 @@ msgstr ""
 "before upgrading."
 
 msgid ""
+"The ``kmip_keymaster`` middleware can now be configured directly in the "
+"proxy-server config file. The existing behavior of using an external config "
+"file is still supported."
+msgstr ""
+"The ``kmip_keymaster`` middleware can now be configured directly in the "
+"proxy-server config file. The existing behaviour of using an external config "
+"file is still supported."
+
+msgid ""
+"The ``object-expirer`` may now be configured in ``object-server.conf``. This "
+"is in anticipation of a future change to allow the ``object-expirer`` to be "
+"deployed on all nodes that run the ``object-server``."
+msgstr ""
+"The ``object-expirer`` may now be configured in ``object-server.conf``. This "
+"is in anticipation of a future change to allow the ``object-expirer`` to be "
+"deployed on all nodes that run the ``object-server``."
+
+msgid ""
+"The ``proxy-server`` now caches 'updating' shards, improving write "
+"performance for sharded containers. A new config option, "
+"``recheck_updating_shard_ranges``, controls the cache time; set it to 0 to "
+"disable caching."
+msgstr ""
+"The ``proxy-server`` now caches 'updating' shards, improving write "
+"performance for sharded containers. A new config option, "
+"``recheck_updating_shard_ranges``, controls the cache time; set it to 0 to "
+"disable caching."
+
+msgid ""
+"The ``proxy-server`` now ignores 404 responses from handoffs that have no "
+"data when deciding on the correct response for object requests, similar to "
+"what it already does for account and container requests."
+msgstr ""
+"The ``proxy-server`` now ignores 404 responses from handoffs that have no "
+"data when deciding on the correct response for object requests, similar to "
+"what it already does for account and container requests."
+
+msgid ""
+"The ``proxy-server`` now ignores 404 responses from handoffs without "
+"databases when deciding on the correct response for account and container "
+"requests."
+msgstr ""
+"The ``proxy-server`` now ignores 404 responses from handoffs without "
+"databases when deciding on the correct response for account and container "
+"requests."
+
+msgid ""
+"The bulk extract middleware once again allows clients to specify metadata "
+"(including expiration timestamps) for all objects in the archive."
+msgstr ""
+"The bulk extract middleware once again allows clients to specify metadata "
+"(including expiration timestamps) for all objects in the archive."
+
+msgid ""
+"The container sharder can now handle containers with special characters in "
+"their names."
+msgstr ""
+"The container sharder can now handle containers with special characters in "
+"their names."
+
+msgid ""
 "The container-updater now reports zero objects and bytes used for child DBs "
 "in sharded containers. This prevents double-counting in utilization reports."
 msgstr ""
@@ -1532,6 +2345,9 @@ msgstr ""
 "write a manifest that an out-of-date proxy server will not be able to read. "
 "This will resolve itself once the upgrade completes on all nodes."
 
+msgid "Ussuri Series Release Notes"
+msgstr "Ussuri Series Release Notes"
+
 msgid "Various other minor bug fixes and improvements."
 msgstr "Various other minor bug fixes and improvements."
 
@@ -1546,6 +2362,9 @@ msgstr ""
 "using isa_l_rs_vand with more than 4 parity, please read https://bugs."
 "launchpad.net/swift/+bug/1639691 and take necessary action."
 
+msgid "WSGI server processes can now notify systemd when they are ready."
+msgstr "WSGI server processes can now notify systemd when they are ready."
+
 msgid ""
 "We do not yet have CLI tools for creating composite rings, but the "
 "functionality has been enabled in the ring modules to support this advanced "
@@ -1569,6 +2388,38 @@ msgstr ""
 "unaffected by this change."
 
 msgid ""
+"When looking for the active root secret, only the right-most keymaster is "
+"used."
+msgstr ""
+"When looking for the active root secret, only the right-most keymaster is "
+"used."
+
+msgid ""
+"When making backend requests, the ``proxy-server`` now ensures query "
+"parameters are always properly quoted. Previously, the proxy would encounter "
+"an error on Python 2.7.17 if the client included non-ASCII query parameters "
+"in object requests. This was previously fixed in 2.23.0."
+msgstr ""
+"When making backend requests, the ``proxy-server`` now ensures query "
+"parameters are always properly quoted. Previously, the proxy would encounter "
+"an error on Python 2.7.17 if the client included non-ASCII query parameters "
+"in object requests. This was previously fixed in 2.23.0."
+
+msgid ""
+"When object path is not a directory, just quarantine it, rather than the "
+"whole suffix."
+msgstr ""
+"When object path is not a directory, just quarantine it, rather than the "
+"whole suffix."
+
+msgid ""
+"When refetching Static Large Object manifests, non-manifest responses are "
+"now handled better."
+msgstr ""
+"When refetching Static Large Object manifests, non-manifest responses are "
+"now handled better."
+
+msgid ""
 "When requesting objects, return 404 if a tombstone is found and is newer "
 "than any data found. Previous behavior was to return stale data."
 msgstr ""
@@ -1618,10 +2469,37 @@ msgstr ""
 "X-Delete-At computation now uses X-Timestamp instead of system time. This "
 "prevents clock skew causing inconsistent expiry data."
 
+msgid "``Content-Type`` can now be updated when copying an object."
+msgstr "``Content-Type`` can now be updated when copying an object."
+
+msgid "``swift-account-audit``"
+msgstr "``swift-account-audit``"
+
+msgid "``swift-dispersion-populate``"
+msgstr "``swift-dispersion-populate``"
+
+msgid "``swift-drive-recon``"
+msgstr "``swift-drive-recon``"
+
+msgid "``swift-recon``"
+msgstr "``swift-recon``"
+
 msgid "``swift-ring-builder`` improvements"
 msgstr "``swift-ring-builder`` improvements"
 
 msgid ""
+"``swift_source`` is set for more sub-requests in the proxy-server. See `the "
+"documentation <https://docs.openstack.org/swift/latest/logs.html#swift-"
+"source>`__."
+msgstr ""
+"``swift_source`` is set for more sub-requests in the proxy-server. See `the "
+"documentation <https://docs.openstack.org/swift/latest/logs.html#swift-"
+"source>`__."
+
+msgid "and you want to take advantage of faster updates, then do this::"
+msgstr "and you want to take advantage of faster updates, then do this::"
+
+msgid ""
 "cname_lookup middleware now accepts a ``nameservers`` config variable that, "
 "if defined, will be used for DNS lookups instead of the system default."
 msgstr ""
diff -pruN 2.25.0-3/releasenotes/source/ussuri.rst 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/releasenotes/source/ussuri.rst
--- 2.25.0-3/releasenotes/source/ussuri.rst	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/releasenotes/source/ussuri.rst	2020-09-15 21:13:36.000000000 +0000
@@ -0,0 +1,6 @@
+===========================
+Ussuri Series Release Notes
+===========================
+
+.. release-notes::
+   :branch: stable/ussuri
diff -pruN 2.25.0-3/requirements.txt 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/requirements.txt
--- 2.25.0-3/requirements.txt	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/requirements.txt	2020-09-15 21:13:36.000000000 +0000
@@ -2,7 +2,6 @@
 # of appearance. Changing the order has an impact on the overall integration
 # process, which may cause wedges in the gate later.
 
-dnspython>=1.15.0;python_version=='2.7' # http://www.dnspython.org/LICENSE
 eventlet>=0.25.0                        # MIT
 greenlet>=0.3.2
 netifaces>=0.8,!=0.10.0,!=0.10.1
@@ -13,4 +12,12 @@ six>=1.10.0
 xattr>=0.4;sys_platform!='win32'        # MIT
 PyECLib>=1.3.1                          # BSD
 cryptography>=2.0.2                     # BSD/Apache-2.0
-ipaddress>=1.0.16;python_version<'3.3'  # PSF
+
+# For python 2.7, the following requirements are needed; they are not
+# included since the requirments-check check will fail otherwise since
+# global requirements do not support these anymore.
+# Fortunately, these packages come in as dependencies from others and
+# thus the py27 jobs still work.
+#
+# dnspython>=1.15.0;python_version=='2.7' # http://www.dnspython.org/LICENSE
+# ipaddress>=1.0.16;python_version<'3.3'  # PSF
diff -pruN 2.25.0-3/REVIEW_GUIDELINES.rst 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/REVIEW_GUIDELINES.rst
--- 2.25.0-3/REVIEW_GUIDELINES.rst	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/REVIEW_GUIDELINES.rst	2020-09-15 21:13:36.000000000 +0000
@@ -369,7 +369,7 @@ Endeavor to leave a positive or negative
 Use your best judgment.
 
 A note on Swift Core Maintainers
-================================
+--------------------------------
 
 Swift Core maintainers may provide positive reviews scores that *look*
 different from your reviews - a "+2" instead of a "+1".
diff -pruN 2.25.0-3/roles/additional-keystone-users/tasks/main.yaml 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/roles/additional-keystone-users/tasks/main.yaml
--- 2.25.0-3/roles/additional-keystone-users/tasks/main.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/roles/additional-keystone-users/tasks/main.yaml	2020-09-15 21:13:36.000000000 +0000
@@ -0,0 +1,134 @@
+- name: Set S3 endpoint
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: s3_storage_url
+    value: http://localhost:8080
+  become: true
+
+- name: Create primary S3 user
+  shell: >
+    openstack --os-auth-url http://localhost/identity
+    --os-project-domain-id default --os-project-name admin
+    --os-user-domain-id default --os-username admin
+    --os-password secretadmin
+    credential create --type ec2 --project swiftprojecttest1 swiftusertest1
+    '{"access": "s3-user1", "secret": "s3-secret1"}'
+- name: Add primary S3 user to test.conf
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: s3_access_key
+    value: s3-user1
+  become: true
+- name: Add primary S3 user secret to test.conf
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: s3_secret_key
+    value: s3-secret1
+  become: true
+
+- name: Clear secondary S3 user from test.conf
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: s3_access_key2
+    value: ""
+  become: true
+
+- name: Create restricted S3 user
+  shell: >
+    openstack --os-auth-url http://localhost/identity
+    --os-project-domain-id default --os-project-name admin
+    --os-user-domain-id default --os-username admin
+    --os-password secretadmin
+    credential create --type ec2 --project swiftprojecttest1 swiftusertest3
+    '{"access": "s3-user3", "secret": "s3-secret3"}'
+- name: Add restricted S3 user to test.conf
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: s3_access_key3
+    value: s3-user3
+  become: true
+- name: Add restricted S3 user secret to test.conf
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: s3_secret_key3
+    value: s3-secret3
+  become: true
+
+- name: Create service role
+  shell: >
+    openstack --os-auth-url http://localhost/identity
+    --os-project-domain-id default --os-project-name admin
+    --os-user-domain-id default --os-username admin
+    --os-password secretadmin
+    role create swift_service
+- name: Create service project
+  shell: >
+    openstack --os-auth-url http://localhost/identity
+    --os-project-domain-id default --os-project-name admin
+    --os-user-domain-id default --os-username admin
+    --os-password secretadmin
+    project create swiftprojecttest5
+- name: Create service user
+  shell: >
+    openstack --os-auth-url http://localhost/identity
+    --os-project-domain-id default --os-project-name admin
+    --os-user-domain-id default --os-username admin
+    --os-password secretadmin
+    user create --project swiftprojecttest5 swiftusertest5 --password testing5
+- name: Assign service role
+  shell: >
+    openstack --os-auth-url http://localhost/identity
+    --os-project-domain-id default --os-project-name admin
+    --os-user-domain-id default --os-username admin
+    --os-password secretadmin
+    role add --project swiftprojecttest5 --user swiftusertest5 swift_service
+
+- name: Add service_roles to proxy-server.conf
+  ini_file:
+    path: /etc/swift/proxy-server.conf
+    section: filter:keystoneauth
+    option: SERVICE_KEY_service_roles
+    value: swift_service
+  become: true
+- name: Update reseller prefixes in proxy-server.conf
+  ini_file:
+    path: /etc/swift/proxy-server.conf
+    section: filter:keystoneauth
+    option: reseller_prefix
+    value: AUTH, SERVICE_KEY
+  become: true
+
+- name: Add service account to test.conf
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: account5
+    value: swiftprojecttest5
+  become: true
+- name: Add service user to test.conf
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: username5
+    value: swiftusertest5
+  become: true
+- name: Add service password to test.conf
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: password5
+    value: testing5
+  become: true
+- name: Add service prefix to test.conf
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: service_prefix
+    value: SERVICE_KEY
+  become: true
diff -pruN 2.25.0-3/roles/additional-tempauth-users/tasks/main.yaml 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/roles/additional-tempauth-users/tasks/main.yaml
--- 2.25.0-3/roles/additional-tempauth-users/tasks/main.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/roles/additional-tempauth-users/tasks/main.yaml	2020-09-15 21:13:36.000000000 +0000
@@ -0,0 +1,47 @@
+- name: Configure service auth prefix for tempauth tests
+  ini_file:
+    path: /etc/swift/proxy-server.conf
+    section: filter:tempauth
+    option: reseller_prefix
+    value: TEMPAUTH, SERVICE_TA
+  become: true
+
+- name: Configure service group for tempauth tests
+  ini_file:
+    path: /etc/swift/proxy-server.conf
+    section: filter:tempauth
+    option: SERVICE_TA_require_group
+    value: service
+  become: true
+
+- name: Configure service account for tempauth tests
+  ini_file:
+    path: "{{ ansible_env.HOME }}/{{ zuul.project.src_dir }}/test/sample.conf"
+    section: func_test
+    option: account5
+    value: test5
+  become: true
+
+- name: Configure service username for tempauth tests
+  ini_file:
+    path: "{{ ansible_env.HOME }}/{{ zuul.project.src_dir }}/test/sample.conf"
+    section: func_test
+    option: username5
+    value: tester5
+  become: true
+
+- name: Configure service user password for tempauth tests
+  ini_file:
+    path: "{{ ansible_env.HOME }}/{{ zuul.project.src_dir }}/test/sample.conf"
+    section: func_test
+    option: password5
+    value: testing5
+  become: true
+
+- name: Configure service prefix for tempauth tests
+  ini_file:
+    path: "{{ ansible_env.HOME }}/{{ zuul.project.src_dir }}/test/sample.conf"
+    section: func_test
+    option: service_prefix
+    value: SERVICE_TA
+  become: true
diff -pruN 2.25.0-3/roles/dsvm-additional-middlewares/tasks/main.yaml 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/roles/dsvm-additional-middlewares/tasks/main.yaml
--- 2.25.0-3/roles/dsvm-additional-middlewares/tasks/main.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/roles/dsvm-additional-middlewares/tasks/main.yaml	2020-09-15 21:13:36.000000000 +0000
@@ -0,0 +1,70 @@
+- name: Add domain_remap and etag-quoter to pipeline
+  replace:
+    path: "/etc/swift/proxy-server.conf"
+    regexp: "cache listing_formats"
+    replace: "cache domain_remap etag-quoter listing_formats"
+  become: true
+
+- name: Set domain_remap domain
+  ini_file:
+    path: /etc/swift/proxy-server.conf
+    section: filter:domain_remap
+    option: storage_domain
+    value: example.com
+  become: true
+
+- name: Set storage_domain in test.conf (for Keystone tests)
+  ini_file:
+    path: /etc/swift/test.conf
+    section: func_test
+    option: storage_domain
+    value: example.com
+  become: true
+
+- name: Set storage_domain in test/sample.conf (for tempauth tests)
+  ini_file:
+    path: "{{ ansible_env.HOME }}/{{ zuul.project.src_dir }}/test/sample.conf"
+    section: func_test
+    option: storage_domain
+    value: example.com
+  become: true
+
+- name: Enable object versioning
+  ini_file:
+    path: /etc/swift/proxy-server.conf
+    section: filter:versioned_writes
+    option: allow_object_versioning
+    value: true
+  become: true
+
+- name: Configure s3api force_swift_request_proxy_log
+  ini_file:
+    path: /etc/swift/proxy-server.conf
+    section: filter:s3api
+    option: force_swift_request_proxy_log
+    value: true
+  become: true
+
+- name: Copy ring for Policy-1
+  copy:
+    remote_src: true
+    src: /etc/swift/object.ring.gz
+    dest: /etc/swift/object-1.ring.gz
+  become: true
+
+- name: Add Policy-1 to swift.conf
+  ini_file:
+    path: /etc/swift/swift.conf
+    section: storage-policy:1
+    option: name
+    value: Policy-1
+  become: true
+
+- name: Restart service to pick up config changes
+  command: systemctl restart devstack@s-{{ item }}.service
+  become: true
+  with_items:
+    - proxy
+    - account
+    - container
+    - object
diff -pruN 2.25.0-3/setup.cfg 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/setup.cfg
--- 2.25.0-3/setup.cfg	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/setup.cfg	2020-09-15 21:13:40.935434600 +0000
@@ -1,139 +1,135 @@
 [metadata]
 name = swift
 summary = OpenStack Object Storage
-description-file =
-    README.rst
+description-file = 
+	README.rst
 author = OpenStack
 author-email = openstack-discuss@lists.openstack.org
 home-page = https://docs.openstack.org/swift/latest/
-classifier =
-    Development Status :: 5 - Production/Stable
-    Environment :: OpenStack
-    Intended Audience :: Information Technology
-    Intended Audience :: System Administrators
-    License :: OSI Approved :: Apache Software License
-    Operating System :: POSIX :: Linux
-    Programming Language :: Python
-    Programming Language :: Python :: 2
-    Programming Language :: Python :: 2.7
-    Programming Language :: Python :: 3
-    Programming Language :: Python :: 3.6
-    Programming Language :: Python :: 3.7
+classifier = 
+	Development Status :: 5 - Production/Stable
+	Environment :: OpenStack
+	Intended Audience :: Information Technology
+	Intended Audience :: System Administrators
+	License :: OSI Approved :: Apache Software License
+	Operating System :: POSIX :: Linux
+	Programming Language :: Python
+	Programming Language :: Python :: 2
+	Programming Language :: Python :: 2.7
+	Programming Language :: Python :: 3
+	Programming Language :: Python :: 3.6
+	Programming Language :: Python :: 3.7
+	Programming Language :: Python :: 3.8
 
 [pbr]
 skip_authors = True
 skip_changelog = True
 
 [files]
-packages =
-    swift
-scripts =
-    bin/swift-account-audit
-    bin/swift-account-auditor
-    bin/swift-account-info
-    bin/swift-account-reaper
-    bin/swift-account-replicator
-    bin/swift-account-server
-    bin/swift-config
-    bin/swift-container-auditor
-    bin/swift-container-info
-    bin/swift-container-replicator
-    bin/swift-container-server
-    bin/swift-container-sharder
-    bin/swift-container-sync
-    bin/swift-container-updater
-    bin/swift-container-reconciler
-    bin/swift-reconciler-enqueue
-    bin/swift-dispersion-populate
-    bin/swift-dispersion-report
-    bin/swift-drive-audit
-    bin/swift-form-signature
-    bin/swift-get-nodes
-    bin/swift-init
-    bin/swift-object-auditor
-    bin/swift-object-expirer
-    bin/swift-object-info
-    bin/swift-object-replicator
-    bin/swift-object-reconstructor
-    bin/swift-object-relinker
-    bin/swift-object-server
-    bin/swift-object-updater
-    bin/swift-oldies
-    bin/swift-orphans
-    bin/swift-proxy-server
-    bin/swift-recon
-    bin/swift-recon-cron
-    bin/swift-ring-builder
-    bin/swift-ring-builder-analyzer
-    bin/swift-ring-composer
+packages = 
+	swift
+scripts = 
+	bin/swift-account-audit
+	bin/swift-account-auditor
+	bin/swift-account-info
+	bin/swift-account-reaper
+	bin/swift-account-replicator
+	bin/swift-account-server
+	bin/swift-config
+	bin/swift-container-auditor
+	bin/swift-container-info
+	bin/swift-container-replicator
+	bin/swift-container-server
+	bin/swift-container-sharder
+	bin/swift-container-sync
+	bin/swift-container-updater
+	bin/swift-container-reconciler
+	bin/swift-reconciler-enqueue
+	bin/swift-dispersion-populate
+	bin/swift-dispersion-report
+	bin/swift-drive-audit
+	bin/swift-form-signature
+	bin/swift-get-nodes
+	bin/swift-init
+	bin/swift-object-auditor
+	bin/swift-object-expirer
+	bin/swift-object-info
+	bin/swift-object-replicator
+	bin/swift-object-reconstructor
+	bin/swift-object-relinker
+	bin/swift-object-server
+	bin/swift-object-updater
+	bin/swift-oldies
+	bin/swift-orphans
+	bin/swift-proxy-server
+	bin/swift-recon
+	bin/swift-recon-cron
+	bin/swift-ring-builder
+	bin/swift-ring-builder-analyzer
+	bin/swift-ring-composer
 
 [extras]
-kms_keymaster =
-    oslo.config>=4.0.0,!=4.3.0,!=4.4.0 # Apache-2.0
-    castellan>=0.13.0 # Apache-2.0
-
-kmip_keymaster =
-    pykmip>=0.7.0 # Apache-2.0
-
-keystone =
-    keystonemiddleware>=4.17.0
+kms_keymaster = 
+	oslo.config>=4.0.0,!=4.3.0,!=4.4.0 # Apache-2.0
+	castellan>=0.13.0 # Apache-2.0
+kmip_keymaster = 
+	pykmip>=0.7.0 # Apache-2.0
+keystone = 
+	keystonemiddleware>=4.17.0
 
 [entry_points]
-console_scripts =
-    swift-manage-shard-ranges = swift.cli.manage_shard_ranges:main
-    swift-container-deleter = swift.cli.container_deleter:main
-
-paste.app_factory =
-    proxy = swift.proxy.server:app_factory
-    object = swift.obj.server:app_factory
-    mem_object = swift.obj.mem_server:app_factory
-    container = swift.container.server:app_factory
-    account = swift.account.server:app_factory
-
-paste.filter_factory =
-    healthcheck = swift.common.middleware.healthcheck:filter_factory
-    crossdomain = swift.common.middleware.crossdomain:filter_factory
-    memcache = swift.common.middleware.memcache:filter_factory
-    read_only = swift.common.middleware.read_only:filter_factory
-    ratelimit = swift.common.middleware.ratelimit:filter_factory
-    cname_lookup = swift.common.middleware.cname_lookup:filter_factory
-    catch_errors = swift.common.middleware.catch_errors:filter_factory
-    domain_remap = swift.common.middleware.domain_remap:filter_factory
-    staticweb = swift.common.middleware.staticweb:filter_factory
-    tempauth = swift.common.middleware.tempauth:filter_factory
-    keystoneauth = swift.common.middleware.keystoneauth:filter_factory
-    recon = swift.common.middleware.recon:filter_factory
-    tempurl = swift.common.middleware.tempurl:filter_factory
-    formpost = swift.common.middleware.formpost:filter_factory
-    name_check = swift.common.middleware.name_check:filter_factory
-    bulk = swift.common.middleware.bulk:filter_factory
-    container_quotas = swift.common.middleware.container_quotas:filter_factory
-    account_quotas = swift.common.middleware.account_quotas:filter_factory
-    proxy_logging = swift.common.middleware.proxy_logging:filter_factory
-    dlo = swift.common.middleware.dlo:filter_factory
-    slo = swift.common.middleware.slo:filter_factory
-    list_endpoints = swift.common.middleware.list_endpoints:filter_factory
-    gatekeeper = swift.common.middleware.gatekeeper:filter_factory
-    container_sync = swift.common.middleware.container_sync:filter_factory
-    xprofile = swift.common.middleware.xprofile:filter_factory
-    versioned_writes = swift.common.middleware.versioned_writes:filter_factory
-    copy = swift.common.middleware.copy:filter_factory
-    keymaster = swift.common.middleware.crypto.keymaster:filter_factory
-    encryption = swift.common.middleware.crypto:filter_factory
-    kms_keymaster = swift.common.middleware.crypto.kms_keymaster:filter_factory
-    kmip_keymaster = swift.common.middleware.crypto.kmip_keymaster:filter_factory
-    listing_formats = swift.common.middleware.listing_formats:filter_factory
-    symlink = swift.common.middleware.symlink:filter_factory
-    s3api = swift.common.middleware.s3api.s3api:filter_factory
-    s3token = swift.common.middleware.s3api.s3token:filter_factory
-    etag_quoter = swift.common.middleware.etag_quoter:filter_factory
-
-swift.diskfile =
-    replication.fs = swift.obj.diskfile:DiskFileManager
-    erasure_coding.fs = swift.obj.diskfile:ECDiskFileManager
+console_scripts = 
+	swift-manage-shard-ranges = swift.cli.manage_shard_ranges:main
+	swift-container-deleter = swift.cli.container_deleter:main
+paste.app_factory = 
+	proxy = swift.proxy.server:app_factory
+	object = swift.obj.server:app_factory
+	mem_object = swift.obj.mem_server:app_factory
+	container = swift.container.server:app_factory
+	account = swift.account.server:app_factory
+paste.filter_factory = 
+	healthcheck = swift.common.middleware.healthcheck:filter_factory
+	crossdomain = swift.common.middleware.crossdomain:filter_factory
+	memcache = swift.common.middleware.memcache:filter_factory
+	read_only = swift.common.middleware.read_only:filter_factory
+	ratelimit = swift.common.middleware.ratelimit:filter_factory
+	cname_lookup = swift.common.middleware.cname_lookup:filter_factory
+	catch_errors = swift.common.middleware.catch_errors:filter_factory
+	domain_remap = swift.common.middleware.domain_remap:filter_factory
+	staticweb = swift.common.middleware.staticweb:filter_factory
+	tempauth = swift.common.middleware.tempauth:filter_factory
+	keystoneauth = swift.common.middleware.keystoneauth:filter_factory
+	recon = swift.common.middleware.recon:filter_factory
+	tempurl = swift.common.middleware.tempurl:filter_factory
+	formpost = swift.common.middleware.formpost:filter_factory
+	name_check = swift.common.middleware.name_check:filter_factory
+	bulk = swift.common.middleware.bulk:filter_factory
+	container_quotas = swift.common.middleware.container_quotas:filter_factory
+	account_quotas = swift.common.middleware.account_quotas:filter_factory
+	proxy_logging = swift.common.middleware.proxy_logging:filter_factory
+	dlo = swift.common.middleware.dlo:filter_factory
+	slo = swift.common.middleware.slo:filter_factory
+	list_endpoints = swift.common.middleware.list_endpoints:filter_factory
+	gatekeeper = swift.common.middleware.gatekeeper:filter_factory
+	container_sync = swift.common.middleware.container_sync:filter_factory
+	xprofile = swift.common.middleware.xprofile:filter_factory
+	versioned_writes = swift.common.middleware.versioned_writes:filter_factory
+	copy = swift.common.middleware.copy:filter_factory
+	keymaster = swift.common.middleware.crypto.keymaster:filter_factory
+	encryption = swift.common.middleware.crypto:filter_factory
+	kms_keymaster = swift.common.middleware.crypto.kms_keymaster:filter_factory
+	kmip_keymaster = swift.common.middleware.crypto.kmip_keymaster:filter_factory
+	listing_formats = swift.common.middleware.listing_formats:filter_factory
+	symlink = swift.common.middleware.symlink:filter_factory
+	s3api = swift.common.middleware.s3api.s3api:filter_factory
+	s3token = swift.common.middleware.s3api.s3token:filter_factory
+	etag_quoter = swift.common.middleware.etag_quoter:filter_factory
+swift.diskfile = 
+	replication.fs = swift.obj.diskfile:DiskFileManager
+	erasure_coding.fs = swift.obj.diskfile:ECDiskFileManager
 
 [egg_info]
-tag_build =
+tag_build = 
 tag_date = 0
 tag_svn_revision = 0
 
@@ -161,3 +157,4 @@ detailed-errors = 1
 cover-package = swift
 cover-html = true
 cover-erase = true
+
diff -pruN 2.25.0-3/swift/account/reaper.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/account/reaper.py
--- 2.25.0-3/swift/account/reaper.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/account/reaper.py	2020-09-15 21:13:36.000000000 +0000
@@ -31,6 +31,7 @@ from swift.common.constraints import che
 from swift.common.direct_client import direct_delete_container, \
     direct_delete_object, direct_get_container
 from swift.common.exceptions import ClientException
+from swift.common.request_helpers import USE_REPLICATION_NETWORK_HEADER
 from swift.common.ring import Ring
 from swift.common.ring.utils import is_local_device
 from swift.common.utils import get_logger, whataremyips, config_true_value, \
@@ -370,7 +371,8 @@ class AccountReaper(Daemon):
                     node, part, account, container,
                     marker=marker,
                     conn_timeout=self.conn_timeout,
-                    response_timeout=self.node_timeout)
+                    response_timeout=self.node_timeout,
+                    headers={USE_REPLICATION_NETWORK_HEADER: 'true'})
                 self.stats_return_codes[2] = \
                     self.stats_return_codes.get(2, 0) + 1
                 self.logger.increment('return_codes.2')
@@ -418,7 +420,8 @@ class AccountReaper(Daemon):
                              'X-Account-Partition': str(account_partition),
                              'X-Account-Device': anode['device'],
                              'X-Account-Override-Deleted': 'yes',
-                             'X-Timestamp': timestamp.internal})
+                             'X-Timestamp': timestamp.internal,
+                             USE_REPLICATION_NETWORK_HEADER: 'true'})
                 successes += 1
                 self.stats_return_codes[2] = \
                     self.stats_return_codes.get(2, 0) + 1
@@ -494,7 +497,8 @@ class AccountReaper(Daemon):
                              'X-Container-Partition': str(container_partition),
                              'X-Container-Device': cnode['device'],
                              'X-Backend-Storage-Policy-Index': policy_index,
-                             'X-Timestamp': timestamp.internal})
+                             'X-Timestamp': timestamp.internal,
+                             USE_REPLICATION_NETWORK_HEADER: 'true'})
                 successes += 1
                 self.stats_return_codes[2] = \
                     self.stats_return_codes.get(2, 0) + 1
diff -pruN 2.25.0-3/swift/cli/info.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/cli/info.py
--- 2.25.0-3/swift/cli/info.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/cli/info.py	2020-09-15 21:13:36.000000000 +0000
@@ -16,6 +16,7 @@ import json
 import os
 import sqlite3
 from hashlib import md5
+from collections import defaultdict
 
 from six.moves import urllib
 
@@ -57,6 +58,8 @@ def parse_get_node_args(options, args):
         else:
             raise InfoSystemExit('Ring file does not exist')
 
+    if options.quoted:
+        args = [urllib.parse.unquote(arg) for arg in args]
     if len(args) == 1:
         args = args[0].strip('/').split('/', 2)
 
@@ -90,7 +93,7 @@ def curl_head_command(ip, port, device,
     else:
         formatted_ip = ip
 
-    cmd = 'curl -g -I -XHEAD "http://%s:%s/%s/%s/%s"' % (
+    cmd = 'curl --path-as-is -g -I -XHEAD "http://%s:%s/%s/%s/%s"' % (
         formatted_ip, port, device, part, urllib.parse.quote(target))
     if policy_index is not None:
         cmd += ' -H "%s: %s"' % ('X-Backend-Storage-Policy-Index',
@@ -193,7 +196,8 @@ def print_ring_locations(ring, datadir,
           'real value is set in the config file on each storage node.')
 
 
-def print_db_info_metadata(db_type, info, metadata, drop_prefixes=False):
+def print_db_info_metadata(db_type, info, metadata, drop_prefixes=False,
+                           verbose=False):
     """
     print out data base info/metadata based on its type
 
@@ -307,20 +311,31 @@ def print_db_info_metadata(db_type, info
         print('  Type: %s' % shard_type)
         print('  State: %s' % info['db_state'])
     if info.get('shard_ranges'):
-        print('Shard Ranges (%d):' % len(info['shard_ranges']))
+        num_shards = len(info['shard_ranges'])
+        print('Shard Ranges (%d):' % num_shards)
+        count_by_state = defaultdict(int)
         for srange in info['shard_ranges']:
-            srange = dict(srange, state_text=srange.state_text)
-            print('  Name: %(name)s' % srange)
-            print('    lower: %(lower)r, upper: %(upper)r' % srange)
-            print('    Object Count: %(object_count)d, Bytes Used: '
-                  '%(bytes_used)d, State: %(state_text)s (%(state)d)'
-                  % srange)
-            print('    Created at: %s (%s)'
-                  % (Timestamp(srange['timestamp']).isoformat,
-                     srange['timestamp']))
-            print('    Meta Timestamp: %s (%s)'
-                  % (Timestamp(srange['meta_timestamp']).isoformat,
-                     srange['meta_timestamp']))
+            count_by_state[(srange.state, srange.state_text)] += 1
+        print('  States:')
+        for key_state, count in sorted(count_by_state.items()):
+            key, state = key_state
+            print('    %9s: %s' % (state, count))
+        if verbose:
+            for srange in info['shard_ranges']:
+                srange = dict(srange, state_text=srange.state_text)
+                print('  Name: %(name)s' % srange)
+                print('    lower: %(lower)r, upper: %(upper)r' % srange)
+                print('    Object Count: %(object_count)d, Bytes Used: '
+                      '%(bytes_used)d, State: %(state_text)s (%(state)d)'
+                      % srange)
+                print('    Created at: %s (%s)'
+                      % (Timestamp(srange['timestamp']).isoformat,
+                         srange['timestamp']))
+                print('    Meta Timestamp: %s (%s)'
+                      % (Timestamp(srange['meta_timestamp']).isoformat,
+                         srange['meta_timestamp']))
+        else:
+            print('(Use -v/--verbose to show more Shard Ranges details)')
 
 
 def print_obj_metadata(metadata, drop_prefixes=False):
@@ -418,7 +433,7 @@ def print_obj_metadata(metadata, drop_pr
 
 
 def print_info(db_type, db_file, swift_dir='/etc/swift', stale_reads_ok=False,
-               drop_prefixes=False):
+               drop_prefixes=False, verbose=False):
     if db_type not in ('account', 'container'):
         print("Unrecognized DB type: internal error")
         raise InfoSystemExit()
@@ -450,7 +465,8 @@ def print_info(db_type, db_file, swift_d
         sranges = broker.get_shard_ranges()
         if sranges:
             info['shard_ranges'] = sranges
-    print_db_info_metadata(db_type, info, broker.metadata, drop_prefixes)
+    print_db_info_metadata(
+        db_type, info, broker.metadata, drop_prefixes, verbose)
     try:
         ring = Ring(swift_dir, ring_name=db_type)
     except Exception:
@@ -614,15 +630,15 @@ def print_item_locations(ring, ring_name
         ring = POLICIES.get_object_ring(policy_index, swift_dir)
         ring_name = (POLICIES.get_by_name(policy_name)).ring_name
 
-    if account is None and (container is not None or obj is not None):
+    if (container or obj) and not account:
         print('No account specified')
         raise InfoSystemExit()
 
-    if container is None and obj is not None:
+    if obj and not container:
         print('No container specified')
         raise InfoSystemExit()
 
-    if account is None and part is None:
+    if not account and not part:
         print('No target specified')
         raise InfoSystemExit()
 
@@ -654,8 +670,11 @@ def print_item_locations(ring, ring_name
                 print('Warning: account specified ' +
                       'but ring not named "account"')
 
-    print('\nAccount  \t%s' % account)
-    print('Container\t%s' % container)
-    print('Object   \t%s\n\n' % obj)
+    if account:
+        print('\nAccount  \t%s' % urllib.parse.quote(account))
+    if container:
+        print('Container\t%s' % urllib.parse.quote(container))
+    if obj:
+        print('Object   \t%s\n\n' % urllib.parse.quote(obj))
     print_ring_locations(ring, loc, account, container, obj, part, all_nodes,
                          policy_index=policy_index)
diff -pruN 2.25.0-3/swift/cli/manage_shard_ranges.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/cli/manage_shard_ranges.py
--- 2.25.0-3/swift/cli/manage_shard_ranges.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/cli/manage_shard_ranges.py	2020-09-15 21:13:36.000000000 +0000
@@ -343,7 +343,9 @@ def _replace_shard_ranges(broker, args,
 
     # Crank up the timeout in an effort to *make sure* this succeeds
     with broker.updated_timeout(max(timeout, args.replace_timeout)):
-        delete_shard_ranges(broker, args)
+        delete_status = delete_shard_ranges(broker, args)
+        if delete_status != 0:
+            return delete_status
         broker.merge_shard_ranges(shard_ranges)
 
     print('Injected %d shard ranges.' % len(shard_ranges))
diff -pruN 2.25.0-3/swift/cli/recon.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/cli/recon.py
--- 2.25.0-3/swift/cli/recon.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/cli/recon.py	2020-09-15 21:13:36.000000000 +0000
@@ -221,7 +221,7 @@ class SwiftRecon(object):
         Compare ring md5sum's with those on remote host
 
         :param hosts: set of hosts to check. in the format of:
-            set([('127.0.0.1', 6020), ('127.0.0.2', 6030)])
+            set([('127.0.0.1', 6220), ('127.0.0.2', 6230)])
         :param swift_dir: The local directory with the ring files.
         """
         matches = 0
@@ -275,7 +275,7 @@ class SwiftRecon(object):
         Compare swift.conf md5sum with that on remote hosts
 
         :param hosts: set of hosts to check. in the format of:
-            set([('127.0.0.1', 6020), ('127.0.0.2', 6030)])
+            set([('127.0.0.1', 6220), ('127.0.0.2', 6230)])
         :param printfn: function to print text; defaults to print()
         """
         matches = 0
@@ -307,7 +307,7 @@ class SwiftRecon(object):
         Obtain and print async pending statistics
 
         :param hosts: set of hosts to check. in the format of:
-            set([('127.0.0.1', 6020), ('127.0.0.2', 6030)])
+            set([('127.0.0.1', 6220), ('127.0.0.2', 6230)])
         """
         scan = {}
         recon = Scout("async", self.verbose, self.suppress_errors,
@@ -329,7 +329,7 @@ class SwiftRecon(object):
         Obtain and print drive audit error statistics
 
         :param hosts: set of hosts to check. in the format of:
-            set([('127.0.0.1', 6020), ('127.0.0.2', 6030)]
+            set([('127.0.0.1', 6220), ('127.0.0.2', 6230)]
         """
         scan = {}
         recon = Scout("driveaudit", self.verbose, self.suppress_errors,
@@ -351,7 +351,7 @@ class SwiftRecon(object):
         Check for and print unmounted drives
 
         :param hosts: set of hosts to check. in the format of:
-            set([('127.0.0.1', 6020), ('127.0.0.2', 6030)])
+            set([('127.0.0.1', 6220), ('127.0.0.2', 6230)])
         """
         unmounted = {}
         errors = {}
@@ -384,7 +384,7 @@ class SwiftRecon(object):
         Check for server types on the ring
 
         :param hosts: set of hosts to check. in the format of:
-            set([('127.0.0.1', 6020), ('127.0.0.2', 6030)])
+            set([('127.0.0.1', 6220), ('127.0.0.2', 6230)])
         """
         errors = {}
         recon = Scout("server_type_check", self.verbose, self.suppress_errors,
@@ -407,7 +407,7 @@ class SwiftRecon(object):
         Obtain and print expirer statistics
 
         :param hosts: set of hosts to check. in the format of:
-            set([('127.0.0.1', 6020), ('127.0.0.2', 6030)])
+            set([('127.0.0.1', 6220), ('127.0.0.2', 6230)])
         """
         stats = {'object_expiration_pass': [], 'expired_last_pass': []}
         recon = Scout("expirer/%s" % self.server_type, self.verbose,
@@ -436,7 +436,7 @@ class SwiftRecon(object):
         Obtain and print replication statistics
 
         :param hosts: set of hosts to check. in the format of:
-            set([('127.0.0.1', 6020), ('127.0.0.2', 6030)])
+            set([('127.0.0.1', 6220), ('127.0.0.2', 6230)])
         """
         stats = {'replication_time': [], 'failure': [], 'success': [],
                  'attempted': []}
@@ -504,7 +504,7 @@ class SwiftRecon(object):
         Obtain and print updater statistics
 
         :param hosts: set of hosts to check. in the format of:
-            set([('127.0.0.1', 6020), ('127.0.0.2', 6030)])
+            set([('127.0.0.1', 6220), ('127.0.0.2', 6230)])
         """
         stats = []
         recon = Scout("updater/%s" % self.server_type, self.verbose,
@@ -531,7 +531,7 @@ class SwiftRecon(object):
         Obtain and print obj auditor statistics
 
         :param hosts: set of hosts to check. in the format of:
-            set([('127.0.0.1', 6020), ('127.0.0.2', 6030)])
+            set([('127.0.0.1', 6220), ('127.0.0.2', 6230)])
         """
         scan = {}
         adone = '%s_auditor_pass_completed' % self.server_type
@@ -603,7 +603,7 @@ class SwiftRecon(object):
         Obtain and print obj auditor statistics
 
         :param hosts: set of hosts to check. in the format of:
-            set([('127.0.0.1', 6020), ('127.0.0.2', 6030)])
+            set([('127.0.0.1', 6220), ('127.0.0.2', 6230)])
         """
         all_scan = {}
         zbf_scan = {}
@@ -679,7 +679,7 @@ class SwiftRecon(object):
         Obtain and print load average statistics
 
         :param hosts: set of hosts to check. in the format of:
-            set([('127.0.0.1', 6020), ('127.0.0.2', 6030)])
+            set([('127.0.0.1', 6220), ('127.0.0.2', 6230)])
         """
         load1 = {}
         load5 = {}
@@ -708,7 +708,7 @@ class SwiftRecon(object):
         Obtain and print quarantine statistics
 
         :param hosts: set of hosts to check. in the format of:
-            set([('127.0.0.1', 6020), ('127.0.0.2', 6030)])
+            set([('127.0.0.1', 6220), ('127.0.0.2', 6230)])
         """
         objq = {}
         conq = {}
@@ -742,7 +742,7 @@ class SwiftRecon(object):
         Obtain and print /proc/net/sockstat statistics
 
         :param hosts: set of hosts to check. in the format of:
-            set([('127.0.0.1', 6020), ('127.0.0.2', 6030)])
+            set([('127.0.0.1', 6220), ('127.0.0.2', 6230)])
         """
         inuse4 = {}
         mem = {}
@@ -776,7 +776,7 @@ class SwiftRecon(object):
         Obtain and print disk usage statistics
 
         :param hosts: set of hosts to check. in the format of:
-            set([('127.0.0.1', 6020), ('127.0.0.2', 6030)])
+            set([('127.0.0.1', 6220), ('127.0.0.2', 6230)])
         """
         stats = {}
         highs = []
@@ -875,7 +875,7 @@ class SwiftRecon(object):
         Check a time synchronization of hosts with current time
 
         :param hosts: set of hosts to check. in the format of:
-            set([('127.0.0.1', 6020), ('127.0.0.2', 6030)])
+            set([('127.0.0.1', 6220), ('127.0.0.2', 6230)])
         :param jitter: Maximal allowed time jitter
         """
 
@@ -914,7 +914,7 @@ class SwiftRecon(object):
         Check OS Swift version of hosts. Inform if differs.
 
         :param hosts: set of hosts to check. in the format of:
-            set([('127.0.0.1', 6020), ('127.0.0.2', 6030)])
+            set([('127.0.0.1', 6220), ('127.0.0.2', 6230)])
         """
         versions = set()
         errors = 0
diff -pruN 2.25.0-3/swift/cli/relinker.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/cli/relinker.py
--- 2.25.0-3/swift/cli/relinker.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/cli/relinker.py	2020-09-15 21:13:36.000000000 +0000
@@ -14,8 +14,12 @@
 # limitations under the License.
 
 
+import errno
+import fcntl
+import json
 import logging
 import os
+from functools import partial
 from swift.common.storage_policy import POLICIES
 from swift.common.exceptions import DiskFileDeleted, DiskFileNotExist, \
     DiskFileQuarantined
@@ -24,10 +28,126 @@ from swift.common.utils import replace_p
 from swift.obj import diskfile
 
 
+LOCK_FILE = '.relink.{datadir}.lock'
+STATE_FILE = 'relink.{datadir}.json'
+STATE_TMP_FILE = '.relink.{datadir}.json.tmp'
+STEP_RELINK = 'relink'
+STEP_CLEANUP = 'cleanup'
+
+
+def devices_filter(device, _, devices):
+    if device:
+        devices = [d for d in devices if d == device]
+
+    return set(devices)
+
+
+def hook_pre_device(locks, states, datadir, device_path):
+    lock_file = os.path.join(device_path, LOCK_FILE.format(datadir=datadir))
+
+    fd = os.open(lock_file, os.O_CREAT | os.O_WRONLY)
+    fcntl.flock(fd, fcntl.LOCK_EX)
+    locks[0] = fd
+
+    state_file = os.path.join(device_path, STATE_FILE.format(datadir=datadir))
+    states.clear()
+    try:
+        with open(state_file, 'rt') as f:
+            tmp = json.load(f)
+            states.update(tmp)
+    except ValueError:
+        # Invalid JSON: remove the file to restart from scratch
+        os.unlink(state_file)
+    except IOError as err:
+        # Ignore file not found error
+        if err.errno != errno.ENOENT:
+            raise
+
+
+def hook_post_device(locks, _):
+    os.close(locks[0])
+    locks[0] = None
+
+
+def partitions_filter(states, step, part_power, next_part_power,
+                      datadir_path, partitions):
+    # Remove all non partitions first (eg: auditor_status_ALL.json)
+    partitions = [p for p in partitions if p.isdigit()]
+
+    if not (step == STEP_CLEANUP and part_power == next_part_power):
+        # This is not a cleanup after cancel, partitions in the upper half are
+        # new partitions, there is nothing to relink/cleanup from there
+        partitions = [p for p in partitions
+                      if int(p) < 2 ** next_part_power / 2]
+
+    # Format: { 'part': [relinked, cleaned] }
+    if states:
+        missing = list(set(partitions) - set(states.keys()))
+        if missing:
+            # All missing partitions was created after the first run of
+            # relink, so after the new ring was distribued, so they already
+            # are hardlinked in both partitions, but they will need to
+            # cleaned.. Just update the state file.
+            for part in missing:
+                states[part] = [True, False]
+        if step == STEP_RELINK:
+            partitions = [str(p) for p, (r, c) in states.items() if not r]
+        elif step == STEP_CLEANUP:
+            partitions = [str(p) for p, (r, c) in states.items() if not c]
+    else:
+        states.update({str(p): [False, False] for p in partitions})
+
+    # Always scan the partitions in reverse order to minimize the amount of IO
+    # (it actually only matters for relink, not for cleanup).
+    #
+    # Initial situation:
+    #  objects/0/000/00000000000000000000000000000000/12345.data
+    #  -> relinked to objects/1/000/10000000000000000000000000000000/12345.data
+    #
+    # If the relinker then scan partition 1, it will listdir that object while
+    # it's unnecessary. By working in reverse order of partitions, this is
+    # avoided.
+    partitions = sorted(partitions, key=lambda x: int(x), reverse=True)
+
+    return partitions
+
+
+# Save states when a partition is done
+def hook_post_partition(states, step,
+                        partition_path):
+    part = os.path.basename(os.path.abspath(partition_path))
+    datadir_path = os.path.dirname(os.path.abspath(partition_path))
+    device_path = os.path.dirname(os.path.abspath(datadir_path))
+    datadir_name = os.path.basename(os.path.abspath(datadir_path))
+    state_tmp_file = os.path.join(device_path,
+                                  STATE_TMP_FILE.format(datadir=datadir_name))
+    state_file = os.path.join(device_path,
+                              STATE_FILE.format(datadir=datadir_name))
+
+    if step == STEP_RELINK:
+        states[part][0] = True
+    elif step == STEP_CLEANUP:
+        states[part][1] = True
+    with open(state_tmp_file, 'wt') as f:
+        json.dump(states, f)
+        os.fsync(f.fileno())
+    os.rename(state_tmp_file, state_file)
+
+
+def hashes_filter(next_part_power, suff_path, hashes):
+    hashes = list(hashes)
+    for hsh in hashes:
+        fname = os.path.join(suff_path, hsh, 'fake-file-name')
+        if replace_partition_in_path(fname, next_part_power) == fname:
+            hashes.remove(hsh)
+    return hashes
+
+
 def relink(swift_dir='/etc/swift',
            devices='/srv/node',
            skip_mount_check=False,
-           logger=logging.getLogger()):
+           logger=logging.getLogger(),
+           device=None):
     mount_check = not skip_mount_check
     run = False
     relinked = errors = 0
@@ -41,10 +161,31 @@ def relink(swift_dir='/etc/swift',
         logging.info('Relinking files for policy %s under %s',
                      policy.name, devices)
         run = True
+        datadir = diskfile.get_data_dir(policy)
+
+        locks = [None]
+        states = {}
+        relink_devices_filter = partial(devices_filter, device)
+        relink_hook_pre_device = partial(hook_pre_device, locks, states,
+                                         datadir)
+        relink_hook_post_device = partial(hook_post_device, locks)
+        relink_partition_filter = partial(partitions_filter,
+                                          states, STEP_RELINK,
+                                          part_power, next_part_power)
+        relink_hook_post_partition = partial(hook_post_partition,
+                                             states, STEP_RELINK)
+        relink_hashes_filter = partial(hashes_filter, next_part_power)
+
         locations = audit_location_generator(
             devices,
-            diskfile.get_data_dir(policy),
-            mount_check=mount_check)
+            datadir,
+            mount_check=mount_check,
+            devices_filter=relink_devices_filter,
+            hook_pre_device=relink_hook_pre_device,
+            hook_post_device=relink_hook_post_device,
+            partitions_filter=relink_partition_filter,
+            hook_post_partition=relink_hook_post_partition,
+            hashes_filter=relink_hashes_filter)
         for fname, _, _ in locations:
             newfname = replace_partition_in_path(fname, next_part_power)
             try:
@@ -67,7 +208,8 @@ def relink(swift_dir='/etc/swift',
 def cleanup(swift_dir='/etc/swift',
             devices='/srv/node',
             skip_mount_check=False,
-            logger=logging.getLogger()):
+            logger=logging.getLogger(),
+            device=None):
     mount_check = not skip_mount_check
     conf = {'devices': devices, 'mount_check': mount_check}
     diskfile_router = diskfile.DiskFileRouter(conf, get_logger(conf))
@@ -83,10 +225,31 @@ def cleanup(swift_dir='/etc/swift',
         logging.info('Cleaning up files for policy %s under %s',
                      policy.name, devices)
         run = True
+        datadir = diskfile.get_data_dir(policy)
+
+        locks = [None]
+        states = {}
+        cleanup_devices_filter = partial(devices_filter, device)
+        cleanup_hook_pre_device = partial(hook_pre_device, locks, states,
+                                          datadir)
+        cleanup_hook_post_device = partial(hook_post_device, locks)
+        cleanup_partition_filter = partial(partitions_filter,
+                                           states, STEP_CLEANUP,
+                                           part_power, next_part_power)
+        cleanup_hook_post_partition = partial(hook_post_partition,
+                                              states, STEP_CLEANUP)
+        cleanup_hashes_filter = partial(hashes_filter, next_part_power)
+
         locations = audit_location_generator(
             devices,
-            diskfile.get_data_dir(policy),
-            mount_check=mount_check)
+            datadir,
+            mount_check=mount_check,
+            devices_filter=cleanup_devices_filter,
+            hook_pre_device=cleanup_hook_pre_device,
+            hook_post_device=cleanup_hook_post_device,
+            partitions_filter=cleanup_partition_filter,
+            hook_post_partition=cleanup_hook_post_partition,
+            hashes_filter=cleanup_hashes_filter)
         for fname, device, partition in locations:
             expected_fname = replace_partition_in_path(fname, part_power)
             if fname == expected_fname:
@@ -152,8 +315,10 @@ def main(args):
 
     if args.action == 'relink':
         return relink(
-            args.swift_dir, args.devices, args.skip_mount_check, logger)
+            args.swift_dir, args.devices, args.skip_mount_check, logger,
+            device=args.device)
 
     if args.action == 'cleanup':
         return cleanup(
-            args.swift_dir, args.devices, args.skip_mount_check, logger)
+            args.swift_dir, args.devices, args.skip_mount_check, logger,
+            device=args.device)
diff -pruN 2.25.0-3/swift/cli/ringbuilder.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/cli/ringbuilder.py
--- 2.25.0-3/swift/cli/ringbuilder.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/cli/ringbuilder.py	2020-09-15 21:13:36.000000000 +0000
@@ -777,7 +777,7 @@ swift-ring-builder <builder_file> add
         if builder.next_part_power:
             print('Partition power increase in progress. You need ')
             print('to finish the increase first before adding devices.')
-            exit(EXIT_WARNING)
+            exit(EXIT_ERROR)
 
         try:
             for new_dev in _parse_add_values(argv[3:]):
@@ -996,7 +996,7 @@ swift-ring-builder <builder_file> remove
         if builder.next_part_power:
             print('Partition power increase in progress. You need ')
             print('to finish the increase first before removing devices.')
-            exit(EXIT_WARNING)
+            exit(EXIT_ERROR)
 
         devs, opts = _parse_remove_values(argv[3:])
 
@@ -1063,7 +1063,7 @@ swift-ring-builder <builder_file> rebala
         if builder.next_part_power:
             print('Partition power increase in progress.')
             print('You need to finish the increase first before rebalancing.')
-            exit(EXIT_WARNING)
+            exit(EXIT_ERROR)
 
         devs_changed = builder.devs_changed
         min_part_seconds_left = builder.min_part_seconds_left
@@ -1658,7 +1658,7 @@ def main(arguments=None):
         print(msg)
         exit(EXIT_ERROR)
     except (exceptions.FileNotFoundError, exceptions.PermissionError) as e:
-        if len(argv) < 3 or argv[2] not in('create', 'write_builder'):
+        if len(argv) < 3 or argv[2] not in ('create', 'write_builder'):
             print(e)
             exit(EXIT_ERROR)
     except Exception as e:
diff -pruN 2.25.0-3/swift/common/base_storage_server.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/base_storage_server.py
--- 2.25.0-3/swift/common/base_storage_server.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/base_storage_server.py	2020-09-15 21:13:36.000000000 +0000
@@ -27,10 +27,8 @@ class BaseStorageServer(object):
 
     def __init__(self, conf, **kwargs):
         self._allowed_methods = None
-        replication_server = conf.get('replication_server', None)
-        if replication_server is not None:
-            replication_server = config_true_value(replication_server)
-        self.replication_server = replication_server
+        self.replication_server = config_true_value(
+            conf.get('replication_server', 'true'))
         self.log_format = conf.get('log_format', LOG_LINE_DEFAULT_FORMAT)
         self.anonymization_method = conf.get('log_anonymization_method', 'md5')
         self.anonymization_salt = conf.get('log_anonymization_salt', '')
@@ -45,22 +43,13 @@ class BaseStorageServer(object):
         if self._allowed_methods is None:
             self._allowed_methods = []
             all_methods = inspect.getmembers(self, predicate=callable)
-
-            if self.replication_server is True:
-                for name, m in all_methods:
-                    if (getattr(m, 'publicly_accessible', False) and
-                            getattr(m, 'replication', False)):
-                        self._allowed_methods.append(name)
-            elif self.replication_server is False:
-                for name, m in all_methods:
-                    if (getattr(m, 'publicly_accessible', False) and not
-                            getattr(m, 'replication', False)):
-                        self._allowed_methods.append(name)
-            elif self.replication_server is None:
-                for name, m in all_methods:
-                    if getattr(m, 'publicly_accessible', False):
-                        self._allowed_methods.append(name)
-
+            for name, m in all_methods:
+                if not getattr(m, 'publicly_accessible', False):
+                    continue
+                if getattr(m, 'replication', False) and \
+                        not self.replication_server:
+                    continue
+                self._allowed_methods.append(name)
             self._allowed_methods.sort()
         return self._allowed_methods
 
diff -pruN 2.25.0-3/swift/common/db.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/db.py
--- 2.25.0-3/swift/common/db.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/db.py	2020-09-15 21:13:36.000000000 +0000
@@ -53,6 +53,9 @@ PICKLE_PROTOCOL = 2
 # records will be merged.
 PENDING_CAP = 131072
 
+SQLITE_ARG_LIMIT = 999
+RECLAIM_PAGE_SIZE = 10000
+
 
 def utf8encode(*args):
     return [(s.encode('utf8') if isinstance(s, six.text_type) else s)
@@ -981,16 +984,48 @@ class DatabaseBroker(object):
             with lock_parent_directory(self.pending_file,
                                        self.pending_timeout):
                 self._commit_puts()
-        with self.get() as conn:
-            self._reclaim(conn, age_timestamp, sync_timestamp)
-            self._reclaim_metadata(conn, age_timestamp)
-            conn.commit()
+        marker = ''
+        finished = False
+        while not finished:
+            with self.get() as conn:
+                marker = self._reclaim(conn, age_timestamp, marker)
+                if not marker:
+                    finished = True
+                    self._reclaim_other_stuff(
+                        conn, age_timestamp, sync_timestamp)
+                conn.commit()
+
+    def _reclaim_other_stuff(self, conn, age_timestamp, sync_timestamp):
+        """
+        This is only called once at the end of reclaim after _reclaim has been
+        called for each page.
+        """
+        self._reclaim_sync(conn, sync_timestamp)
+        self._reclaim_metadata(conn, age_timestamp)
+
+    def _reclaim(self, conn, age_timestamp, marker):
+        clean_batch_qry = '''
+            DELETE FROM %s WHERE deleted = 1
+            AND name > ? AND %s < ?
+        ''' % (self.db_contains_type, self.db_reclaim_timestamp)
+        curs = conn.execute('''
+            SELECT name FROM %s WHERE deleted = 1
+            AND name > ?
+            ORDER BY NAME LIMIT 1 OFFSET ?
+        ''' % (self.db_contains_type,), (marker, RECLAIM_PAGE_SIZE))
+        row = curs.fetchone()
+        if row:
+            # do a single book-ended DELETE and bounce out
+            end_marker = row[0]
+            conn.execute(clean_batch_qry + ' AND name <= ?', (
+                marker, age_timestamp, end_marker))
+        else:
+            # delete off the end and reset marker to indicate we're done
+            end_marker = ''
+            conn.execute(clean_batch_qry, (marker, age_timestamp))
+        return end_marker
 
-    def _reclaim(self, conn, age_timestamp, sync_timestamp):
-        conn.execute('''
-            DELETE FROM %s WHERE deleted = 1 AND %s < ?
-        ''' % (self.db_contains_type, self.db_reclaim_timestamp),
-            (age_timestamp,))
+    def _reclaim_sync(self, conn, sync_timestamp):
         try:
             conn.execute('''
                 DELETE FROM outgoing_sync WHERE updated_at < ?
diff -pruN 2.25.0-3/swift/common/db_replicator.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/db_replicator.py
--- 2.25.0-3/swift/common/db_replicator.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/db_replicator.py	2020-09-15 21:13:36.000000000 +0000
@@ -205,7 +205,7 @@ class Replicator(Daemon):
                                 ' to use option %(type)s-replicator/'
                                 'interval.'
                                 % {'type': self.server_type})
-        self.databases_per_second = int(
+        self.databases_per_second = float(
             conf.get('databases_per_second', 50))
         self.node_timeout = float(conf.get('node_timeout', 10))
         self.conn_timeout = float(conf.get('conn_timeout', 0.5))
diff -pruN 2.25.0-3/swift/common/direct_client.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/direct_client.py
--- 2.25.0-3/swift/common/direct_client.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/direct_client.py	2020-09-15 21:13:36.000000000 +0000
@@ -29,6 +29,8 @@ from six.moves.http_client import HTTPEx
 
 from swift.common.bufferedhttp import http_connect
 from swift.common.exceptions import ClientException
+from swift.common.request_helpers import USE_REPLICATION_NETWORK_HEADER, \
+    get_ip_port
 from swift.common.swob import normalize_etag
 from swift.common.utils import Timestamp, FileLikeIter, quote
 from swift.common.http import HTTP_NO_CONTENT, HTTP_INSUFFICIENT_STORAGE, \
@@ -100,9 +102,10 @@ def _make_req(node, part, method, path,
         if content_length is None:
             headers['Transfer-Encoding'] = 'chunked'
 
+    ip, port = get_ip_port(node, headers)
     headers.setdefault('X-Backend-Allow-Reserved-Names', 'true')
     with Timeout(conn_timeout):
-        conn = http_connect(node['ip'], node['port'], node['device'], part,
+        conn = http_connect(ip, port, node['device'], part,
                             method, path, headers=headers)
 
     if contents is not None:
@@ -145,6 +148,9 @@ def _get_direct_account_container(path,
     Do not use directly use the get_direct_account or
     get_direct_container instead.
     """
+    if headers is None:
+        headers = {}
+
     params = ['format=json']
     if marker:
         params.append('marker=%s' % quote(marker))
@@ -159,8 +165,10 @@ def _get_direct_account_container(path,
     if reverse:
         params.append('reverse=%s' % quote(reverse))
     qs = '&'.join(params)
+
+    ip, port = get_ip_port(node, headers)
     with Timeout(conn_timeout):
-        conn = http_connect(node['ip'], node['port'], node['device'], part,
+        conn = http_connect(ip, port, node['device'], part,
                             'GET', path, query_string=qs,
                             headers=gen_headers(hdrs_in=headers))
     with Timeout(response_timeout):
@@ -200,7 +208,8 @@ def gen_headers(hdrs_in=None, add_ts=Tru
 
 def direct_get_account(node, part, account, marker=None, limit=None,
                        prefix=None, delimiter=None, conn_timeout=5,
-                       response_timeout=15, end_marker=None, reverse=None):
+                       response_timeout=15, end_marker=None, reverse=None,
+                       headers=None):
     """
     Get listings directly from the account server.
 
@@ -220,6 +229,7 @@ def direct_get_account(node, part, accou
     """
     path = _make_path(account)
     return _get_direct_account_container(path, "Account", node, part,
+                                         headers=headers,
                                          marker=marker,
                                          limit=limit, prefix=prefix,
                                          delimiter=delimiter,
@@ -240,7 +250,7 @@ def direct_delete_account(node, part, ac
 
 
 def direct_head_container(node, part, account, container, conn_timeout=5,
-                          response_timeout=15):
+                          response_timeout=15, headers=None):
     """
     Request container information directly from the container server.
 
@@ -253,8 +263,11 @@ def direct_head_container(node, part, ac
     :returns: a dict containing the response's headers in a HeaderKeyDict
     :raises ClientException: HTTP HEAD request failed
     """
+    if headers is None:
+        headers = {}
+
     path = _make_path(account, container)
-    resp = _make_req(node, part, 'HEAD', path, gen_headers(),
+    resp = _make_req(node, part, 'HEAD', path, gen_headers(headers),
                      'Container', conn_timeout, response_timeout)
 
     resp_headers = HeaderKeyDict()
@@ -431,9 +444,10 @@ def direct_get_object(node, part, accoun
     if headers is None:
         headers = {}
 
+    ip, port = get_ip_port(node, headers)
     path = _make_path(account, container, obj)
     with Timeout(conn_timeout):
-        conn = http_connect(node['ip'], node['port'], node['device'], part,
+        conn = http_connect(ip, port, node['device'], part,
                             'GET', path, headers=gen_headers(headers))
     with Timeout(response_timeout):
         resp = conn.getresponse()
@@ -551,6 +565,9 @@ def direct_get_suffix_hashes(node, part,
     """
     Get suffix hashes directly from the object server.
 
+    Note that unlike other ``direct_client`` functions, this one defaults
+    to using the replication network to make requests.
+
     :param node: node dictionary from the ring
     :param part: partition the container is on
     :param conn_timeout: timeout in seconds for establishing the connection
@@ -562,9 +579,11 @@ def direct_get_suffix_hashes(node, part,
     if headers is None:
         headers = {}
 
+    headers.setdefault(USE_REPLICATION_NETWORK_HEADER, 'true')
+    ip, port = get_ip_port(node, headers)
     path = '/%s' % '-'.join(suffixes)
     with Timeout(conn_timeout):
-        conn = http_connect(node['replication_ip'], node['replication_port'],
+        conn = http_connect(ip, port,
                             node['device'], part, 'REPLICATE', path,
                             headers=gen_headers(headers))
     with Timeout(response_timeout):
diff -pruN 2.25.0-3/swift/common/internal_client.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/internal_client.py
--- 2.25.0-3/swift/common/internal_client.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/internal_client.py	2020-09-15 21:13:36.000000000 +0000
@@ -29,6 +29,7 @@ from swift.common.constraints import AUT
 from swift.common.exceptions import ClientException
 from swift.common.http import (HTTP_NOT_FOUND, HTTP_MULTIPLE_CHOICES,
                                is_client_error, is_server_error)
+from swift.common.request_helpers import USE_REPLICATION_NETWORK_HEADER
 from swift.common.swob import Request, bytes_to_wsgi
 from swift.common.utils import quote, closing_if_possible
 from swift.common.wsgi import loadapp, pipeline_property
@@ -147,13 +148,14 @@ class InternalClient(object):
     """
 
     def __init__(self, conf_path, user_agent, request_tries,
-                 allow_modify_pipeline=False):
+                 allow_modify_pipeline=False, use_replication_network=False):
         if request_tries < 1:
             raise ValueError('request_tries must be positive')
         self.app = loadapp(conf_path,
                            allow_modify_pipeline=allow_modify_pipeline)
         self.user_agent = user_agent
         self.request_tries = request_tries
+        self.use_replication_network = use_replication_network
 
     get_object_ring = pipeline_property('get_object_ring')
     container_ring = pipeline_property('container_ring')
@@ -186,6 +188,9 @@ class InternalClient(object):
         headers = dict(headers)
         headers['user-agent'] = self.user_agent
         headers.setdefault('x-backend-allow-reserved-names', 'true')
+        if self.use_replication_network:
+            headers.setdefault(USE_REPLICATION_NETWORK_HEADER, 'true')
+
         for attempt in range(self.request_tries):
             resp = exc_type = exc_value = exc_traceback = None
             req = Request.blank(
diff -pruN 2.25.0-3/swift/common/manager.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/manager.py
--- 2.25.0-3/swift/common/manager.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/manager.py	2020-09-15 21:13:36.000000000 +0000
@@ -381,6 +381,16 @@ class Manager(object):
                 status += 1
         return status
 
+    def kill_child_pids(self, **kwargs):
+        """kill child pids, optionally servicing accepted connections"""
+        status = 0
+        for server in self.servers:
+            signaled_pids = server.kill_child_pids(**kwargs)
+            if not signaled_pids:
+                print(_('No %s running') % server)
+                status += 1
+        return status
+
     @command
     def force_reload(self, **kwargs):
         """alias for reload
@@ -594,6 +604,32 @@ class Server(object):
                 pid = None
             yield pid_file, pid
 
+    def _signal_pid(self, sig, pid, pid_file, verbose):
+        try:
+            if sig != signal.SIG_DFL:
+                print(_('Signal %(server)s  pid: %(pid)s  signal: '
+                        '%(signal)s') %
+                      {'server': self.server, 'pid': pid, 'signal': sig})
+            safe_kill(pid, sig, 'swift-%s' % self.server)
+        except InvalidPidFileException:
+            if verbose:
+                print(_('Removing pid file %(pid_file)s with wrong pid '
+                        '%(pid)d') % {'pid_file': pid_file, 'pid': pid})
+            remove_file(pid_file)
+            return False
+        except OSError as e:
+            if e.errno == errno.ESRCH:
+                # pid does not exist
+                if verbose:
+                    print(_("Removing stale pid file %s") % pid_file)
+                remove_file(pid_file)
+            elif e.errno == errno.EPERM:
+                print(_("No permission to signal PID %d") % pid)
+            return False
+        else:
+            # process exists
+            return True
+
     def signal_pids(self, sig, **kwargs):
         """Send a signal to pids for this server
 
@@ -608,30 +644,31 @@ class Server(object):
                 print(_('Removing pid file %s with invalid pid') % pid_file)
                 remove_file(pid_file)
                 continue
-            try:
-                if sig != signal.SIG_DFL:
-                    print(_('Signal %(server)s  pid: %(pid)s  signal: '
-                            '%(signal)s') %
-                          {'server': self.server, 'pid': pid, 'signal': sig})
-                safe_kill(pid, sig, 'swift-%s' % self.server)
-            except InvalidPidFileException:
-                if kwargs.get('verbose'):
-                    print(_('Removing pid file %(pid_file)s with wrong pid '
-                            '%(pid)d') % {'pid_file': pid_file, 'pid': pid})
-                remove_file(pid_file)
-            except OSError as e:
-                if e.errno == errno.ESRCH:
-                    # pid does not exist
-                    if kwargs.get('verbose'):
-                        print(_("Removing stale pid file %s") % pid_file)
-                    remove_file(pid_file)
-                elif e.errno == errno.EPERM:
-                    print(_("No permission to signal PID %d") % pid)
-            else:
-                # process exists
+            if self._signal_pid(sig, pid, pid_file, kwargs.get('verbose')):
                 pids[pid] = pid_file
         return pids
 
+    def signal_children(self, sig, **kwargs):
+        """Send a signal to child pids for this server
+
+        :param sig: signal to send
+
+        :returns: a dict mapping pids (ints) to pid_files (paths)
+
+        """
+        pids = {}
+        for pid_file, pid in self.iter_pid_files(**kwargs):
+            if not pid:  # Catches None and 0
+                print(_('Removing pid file %s with invalid pid') % pid_file)
+                remove_file(pid_file)
+                continue
+            ps_cmd = ['ps', '--ppid', str(pid), '--no-headers', '-o', 'pid']
+            for pid in subprocess.check_output(ps_cmd).split():
+                pid = int(pid)
+                if self._signal_pid(sig, pid, pid_file, kwargs.get('verbose')):
+                    pids[pid] = pid_file
+        return pids
+
     def get_running_pids(self, **kwargs):
         """Get running pids
 
@@ -659,6 +696,25 @@ class Server(object):
             sig = signal.SIGTERM
         return self.signal_pids(sig, **kwargs)
 
+    def kill_child_pids(self, **kwargs):
+        """Kill child pids, leaving server overseer to respawn them
+
+        :param graceful: if True, attempt SIGHUP on supporting servers
+        :param seamless: if True, attempt SIGUSR1 on supporting servers
+
+        :returns: a dict mapping pids (ints) to pid_files (paths)
+
+        """
+        graceful = kwargs.get('graceful')
+        seamless = kwargs.get('seamless')
+        if graceful and self.server in GRACEFUL_SHUTDOWN_SERVERS:
+            sig = signal.SIGHUP
+        elif seamless and self.server in SEAMLESS_SHUTDOWN_SERVERS:
+            sig = signal.SIGUSR1
+        else:
+            sig = signal.SIGTERM
+        return self.signal_children(sig, **kwargs)
+
     def status(self, pids=None, **kwargs):
         """Display status of server
 
diff -pruN 2.25.0-3/swift/common/memcached.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/memcached.py
--- 2.25.0-3/swift/common/memcached.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/memcached.py	2020-09-15 21:13:36.000000000 +0000
@@ -160,7 +160,7 @@ class MemcacheRing(object):
     def __init__(self, servers, connect_timeout=CONN_TIMEOUT,
                  io_timeout=IO_TIMEOUT, pool_timeout=POOL_TIMEOUT,
                  tries=TRY_COUNT, allow_pickle=False, allow_unpickle=False,
-                 max_conns=2):
+                 max_conns=2, logger=None):
         self._ring = {}
         self._errors = dict(((serv, []) for serv in servers))
         self._error_limited = dict(((serv, 0) for serv in servers))
@@ -178,18 +178,23 @@ class MemcacheRing(object):
         self._pool_timeout = pool_timeout
         self._allow_pickle = allow_pickle
         self._allow_unpickle = allow_unpickle or allow_pickle
+        if logger is None:
+            self.logger = logging.getLogger()
+        else:
+            self.logger = logger
 
     def _exception_occurred(self, server, e, action='talking',
                             sock=None, fp=None, got_connection=True):
         if isinstance(e, Timeout):
-            logging.error("Timeout %(action)s to memcached: %(server)s",
-                          {'action': action, 'server': server})
+            self.logger.error("Timeout %(action)s to memcached: %(server)s",
+                              {'action': action, 'server': server})
         elif isinstance(e, (socket.error, MemcacheConnectionError)):
-            logging.error("Error %(action)s to memcached: %(server)s: %(err)s",
-                          {'action': action, 'server': server, 'err': e})
+            self.logger.error(
+                "Error %(action)s to memcached: %(server)s: %(err)s",
+                {'action': action, 'server': server, 'err': e})
         else:
-            logging.exception("Error %(action)s to memcached: %(server)s",
-                              {'action': action, 'server': server})
+            self.logger.exception("Error %(action)s to memcached: %(server)s",
+                                  {'action': action, 'server': server})
         try:
             if fp:
                 fp.close()
@@ -213,7 +218,7 @@ class MemcacheRing(object):
                                     if err > now - ERROR_LIMIT_TIME]
             if len(self._errors[server]) > ERROR_LIMIT_COUNT:
                 self._error_limited[server] = now + ERROR_LIMIT_DURATION
-                logging.error('Error limiting server %s', server)
+                self.logger.error('Error limiting server %s', server)
 
     def _get_conns(self, key):
         """
diff -pruN 2.25.0-3/swift/common/middleware/crypto/keymaster.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/crypto/keymaster.py
--- 2.25.0-3/swift/common/middleware/crypto/keymaster.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/crypto/keymaster.py	2020-09-15 21:13:36.000000000 +0000
@@ -14,10 +14,11 @@
 # limitations under the License.
 import hashlib
 import hmac
+import six
 
 from swift.common.exceptions import UnknownSecretIdError
 from swift.common.middleware.crypto.crypto_utils import CRYPTO_KEY_CALLBACK
-from swift.common.swob import Request, HTTPException, wsgi_to_bytes
+from swift.common.swob import Request, HTTPException, wsgi_to_str, str_to_wsgi
 from swift.common.utils import readconf, strict_b64decode, get_logger, \
     split_path
 from swift.common.wsgi import WSGIContext
@@ -33,7 +34,8 @@ class KeyMasterContext(WSGIContext):
 
       <path_key> = HMAC_SHA256(<root_secret>, <path>)
     """
-    def __init__(self, keymaster, account, container, obj):
+    def __init__(self, keymaster, account, container, obj,
+                 meta_version_to_write='2'):
         """
         :param keymaster: a Keymaster instance
         :param account: account name
@@ -47,8 +49,11 @@ class KeyMasterContext(WSGIContext):
         self.obj = obj
         self._keys = {}
         self.alternate_fetch_keys = None
+        self.meta_version_to_write = meta_version_to_write
 
     def _make_key_id(self, path, secret_id, version):
+        if version in ('1', '2'):
+            path = str_to_wsgi(path)
         key_id = {'v': version, 'path': path}
         if secret_id:
             # stash secret_id so that decrypter can pass it back to get the
@@ -76,8 +81,9 @@ class KeyMasterContext(WSGIContext):
         if key_id:
             secret_id = key_id.get('secret_id')
             version = key_id['v']
-            if version not in ('1', '2'):
+            if version not in ('1', '2', '3'):
                 raise ValueError('Unknown key_id version: %s' % version)
+
             if version == '1' and not key_id['path'].startswith(
                     '/' + self.account + '/'):
                 # Well shoot. This was the bug that made us notice we needed
@@ -90,7 +96,32 @@ class KeyMasterContext(WSGIContext):
 
             check_path = (
                 self.account, self.container or key_cont, self.obj or key_obj)
+            if version in ('1', '2') and (
+                    key_acct, key_cont, key_obj) != check_path:
+                # Older py3 proxies may have written down crypto meta as WSGI
+                # strings; we still need to be able to read that
+                try:
+                    if six.PY2:
+                        alt_path = tuple(
+                            part.decode('utf-8').encode('latin1')
+                            for part in (key_acct, key_cont, key_obj))
+                    else:
+                        alt_path = tuple(
+                            part.encode('latin1').decode('utf-8')
+                            for part in (key_acct, key_cont, key_obj))
+                except UnicodeError:
+                    # Well, it was worth a shot
+                    pass
+                else:
+                    if check_path == alt_path or (
+                            check_path[:2] == alt_path[:2] and not self.obj):
+                        # This object is affected by bug #1888037
+                        key_acct, key_cont, key_obj = alt_path
+
             if (key_acct, key_cont, key_obj) != check_path:
+                # Pipeline may have been misconfigured, with copy right of
+                # encryption. In that case, path in meta may not be the
+                # request path.
                 self.keymaster.logger.info(
                     "Path stored in meta (%r) does not match path from "
                     "request (%r)! Using path from meta.",
@@ -100,9 +131,11 @@ class KeyMasterContext(WSGIContext):
         else:
             secret_id = self.keymaster.active_secret_id
             # v1 had a bug where we would claim the path was just the object
-            # name if the object started with a slash. Bump versions to
-            # establish that we can trust the path.
-            version = '2'
+            # name if the object started with a slash.
+            # v1 and v2 had a bug on py3 where we'd write the path in meta as
+            # a WSGI string (ie, as Latin-1 chars decoded from UTF-8 bytes).
+            # Bump versions to establish that we can trust the path.
+            version = self.meta_version_to_write
             key_acct, key_cont, key_obj = (
                 self.account, self.container, self.obj)
 
@@ -219,6 +252,11 @@ class BaseKeyMaster(object):
                 raise ValueError('Secret with id %s is %s, not bytes' % (
                     secret_id, type(secret)))
 
+        self.meta_version_to_write = conf.get('meta_version_to_write') or '2'
+        if self.meta_version_to_write not in ('1', '2', '3'):
+            raise ValueError('Unknown/unsupported metadata version: %r' %
+                             self.meta_version_to_write)
+
     @property
     def root_secret(self):
         # Returns the default root secret; this is here for historical reasons
@@ -265,13 +303,15 @@ class BaseKeyMaster(object):
         req = Request(env)
 
         try:
-            parts = req.split_path(2, 4, True)
+            parts = [wsgi_to_str(part) for part in req.split_path(2, 4, True)]
         except ValueError:
             return self.app(env, start_response)
 
         if req.method in ('PUT', 'POST', 'GET', 'HEAD'):
             # handle only those request methods that may require keys
-            km_context = KeyMasterContext(self, *parts[1:])
+            km_context = KeyMasterContext(
+                self, *parts[1:],
+                meta_version_to_write=self.meta_version_to_write)
             try:
                 return km_context.handle_request(req, start_response)
             except HTTPException as err_resp:
@@ -296,8 +336,9 @@ class BaseKeyMaster(object):
             self.logger.warning('Unrecognised secret id: %s' % secret_id)
             raise UnknownSecretIdError(secret_id)
         else:
-            return hmac.new(key, wsgi_to_bytes(path),
-                            digestmod=hashlib.sha256).digest()
+            if not six.PY2:
+                path = path.encode('utf-8')
+            return hmac.new(key, path, digestmod=hashlib.sha256).digest()
 
 
 class KeyMaster(BaseKeyMaster):
diff -pruN 2.25.0-3/swift/common/middleware/etag_quoter.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/etag_quoter.py
--- 2.25.0-3/swift/common/middleware/etag_quoter.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/etag_quoter.py	2020-09-15 21:13:36.000000000 +0000
@@ -105,11 +105,11 @@ class EtagQuoterMiddleware(object):
 
         status, headers, resp_iter = req.call_application(self.app)
 
-        for i, (header, value) in enumerate(headers):
-            if header.lower() == 'etag':
-                if not value.startswith(('"', 'W/"')) or \
-                        not value.endswith('"'):
-                    headers[i] = (header, '"%s"' % value)
+        headers = [
+            (header, value) if header.lower() != 'etag' or (
+                value.startswith(('"', 'W/"')) and value.endswith('"'))
+            else (header, '"%s"' % value)
+            for header, value in headers]
 
         start_response(status, headers)
         return resp_iter
diff -pruN 2.25.0-3/swift/common/middleware/list_endpoints.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/list_endpoints.py
--- 2.25.0-3/swift/common/middleware/list_endpoints.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/list_endpoints.py	2020-09-15 21:13:36.000000000 +0000
@@ -52,9 +52,9 @@ of endpoints having the same form as des
 maps to a dictionary of headers that should be sent with a request made to
 the endpoints, e.g.::
 
-    { "endpoints": {"http://10.1.1.1:6010/sda1/2/a/c3/o1",
-                    "http://10.1.1.1:6030/sda3/2/a/c3/o1",
-                    "http://10.1.1.1:6040/sda4/2/a/c3/o1"},
+    { "endpoints": {"http://10.1.1.1:6210/sda1/2/a/c3/o1",
+                    "http://10.1.1.1:6230/sda3/2/a/c3/o1",
+                    "http://10.1.1.1:6240/sda4/2/a/c3/o1"},
       "headers": {"X-Backend-Storage-Policy-Index": "1"}}
 
 In this example, the 'headers' dictionary indicates that requests to the
diff -pruN 2.25.0-3/swift/common/middleware/memcache.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/memcache.py
--- 2.25.0-3/swift/common/middleware/memcache.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/memcache.py	2020-09-15 21:13:36.000000000 +0000
@@ -19,6 +19,7 @@ from six.moves.configparser import Confi
 
 from swift.common.memcached import (MemcacheRing, CONN_TIMEOUT, POOL_TIMEOUT,
                                     IO_TIMEOUT, TRY_COUNT)
+from swift.common.utils import get_logger
 
 
 class MemcacheMiddleware(object):
@@ -28,6 +29,7 @@ class MemcacheMiddleware(object):
 
     def __init__(self, app, conf):
         self.app = app
+        self.logger = get_logger(conf, log_route='memcache')
         self.memcache_servers = conf.get('memcache_servers')
         serialization_format = conf.get('memcache_serialization_support')
         try:
@@ -102,7 +104,8 @@ class MemcacheMiddleware(object):
             io_timeout=io_timeout,
             allow_pickle=(serialization_format == 0),
             allow_unpickle=(serialization_format <= 1),
-            max_conns=max_conns)
+            max_conns=max_conns,
+            logger=self.logger)
 
     def __call__(self, env, start_response):
         env['swift.cache'] = self.memcache
diff -pruN 2.25.0-3/swift/common/middleware/proxy_logging.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/proxy_logging.py
--- 2.25.0-3/swift/common/middleware/proxy_logging.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/proxy_logging.py	2020-09-15 21:13:36.000000000 +0000
@@ -129,8 +129,9 @@ class ProxyLoggingMiddleware(object):
             value = conf.get('access_' + key, conf.get(key, None))
             if value:
                 access_log_conf[key] = value
-        self.access_logger = logger or get_logger(access_log_conf,
-                                                  log_route='proxy-access')
+        self.access_logger = logger or get_logger(
+            access_log_conf,
+            log_route=conf.get('access_log_route', 'proxy-access'))
         self.access_logger.set_statsd_prefix('proxy-server')
         self.reveal_sensitive_prefix = int(
             conf.get('reveal_sensitive_prefix', 16))
@@ -225,8 +226,9 @@ class ProxyLoggingMiddleware(object):
         policy_index = get_policy_index(req.headers, resp_headers)
 
         acc, cont, obj = None, None, None
-        if req.path.startswith('/v1/'):
-            _, acc, cont, obj = split_path(req.path, 1, 4, True)
+        swift_path = req.environ.get('swift.backend_path', req.path)
+        if swift_path.startswith('/v1/'):
+            _, acc, cont, obj = split_path(swift_path, 1, 4, True)
 
         replacements = {
             # Time information
@@ -300,10 +302,11 @@ class ProxyLoggingMiddleware(object):
                                             bytes_received + bytes_sent)
 
     def get_metric_name_type(self, req):
-        if req.path.startswith('/v1/'):
+        swift_path = req.environ.get('swift.backend_path', req.path)
+        if swift_path.startswith('/v1/'):
             try:
                 stat_type = [None, 'account', 'container',
-                             'object'][req.path.strip('/').count('/')]
+                             'object'][swift_path.strip('/').count('/')]
             except IndexError:
                 stat_type = 'object'
         else:
diff -pruN 2.25.0-3/swift/common/middleware/ratelimit.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/ratelimit.py
--- 2.25.0-3/swift/common/middleware/ratelimit.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/ratelimit.py	2020-09-15 21:13:36.000000000 +0000
@@ -242,6 +242,10 @@ class RateLimitMiddleware(object):
         if not self.memcache_client:
             return None
 
+        if req.environ.get('swift.ratelimit.handled'):
+            return None
+        req.environ['swift.ratelimit.handled'] = True
+
         try:
             account_info = get_account_info(req.environ, self.app,
                                             swift_source='RL')
diff -pruN 2.25.0-3/swift/common/middleware/s3api/controllers/__init__.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/s3api/controllers/__init__.py
--- 2.25.0-3/swift/common/middleware/s3api/controllers/__init__.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/s3api/controllers/__init__.py	2020-09-15 21:13:36.000000000 +0000
@@ -31,6 +31,8 @@ from swift.common.middleware.s3api.contr
     LoggingStatusController
 from swift.common.middleware.s3api.controllers.versioning import \
     VersioningController
+from swift.common.middleware.s3api.controllers.tagging import \
+    TaggingController
 
 __all__ = [
     'Controller',
@@ -47,6 +49,7 @@ __all__ = [
     'LocationController',
     'LoggingStatusController',
     'VersioningController',
+    'TaggingController',
 
     'UnsupportedController',
 ]
diff -pruN 2.25.0-3/swift/common/middleware/s3api/controllers/multi_upload.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/s3api/controllers/multi_upload.py
--- 2.25.0-3/swift/common/middleware/s3api/controllers/multi_upload.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/s3api/controllers/multi_upload.py	2020-09-15 21:13:36.000000000 +0000
@@ -108,6 +108,13 @@ def _get_upload_info(req, app, upload_id
     try:
         return req.get_response(app, 'HEAD', container=container, obj=obj)
     except NoSuchKey:
+        try:
+            resp = req.get_response(app, 'HEAD')
+            if resp.sysmeta_headers.get(sysmeta_header(
+                    'object', 'upload-id')) == upload_id:
+                return resp
+        except NoSuchKey:
+            pass
         raise NoSuchUpload(upload_id=upload_id)
     finally:
         # ...making sure to restore any copy-source before returning
@@ -115,9 +122,34 @@ def _get_upload_info(req, app, upload_id
             req.headers['X-Amz-Copy-Source'] = copy_source
 
 
-def _check_upload_info(req, app, upload_id):
+def _make_complete_body(req, s3_etag, yielded_anything):
+    result_elem = Element('CompleteMultipartUploadResult')
 
-    _get_upload_info(req, app, upload_id)
+    # NOTE: boto with sig v4 appends port to HTTP_HOST value at
+    # the request header when the port is non default value and it
+    # makes req.host_url like as http://localhost:8080:8080/path
+    # that obviously invalid. Probably it should be resolved at
+    # swift.common.swob though, tentatively we are parsing and
+    # reconstructing the correct host_url info here.
+    # in detail, https://github.com/boto/boto/pull/3513
+    parsed_url = urlparse(req.host_url)
+    host_url = '%s://%s' % (parsed_url.scheme, parsed_url.hostname)
+    # Why are we doing our own port parsing? Because py3 decided
+    # to start raising ValueErrors on access after parsing such
+    # an invalid port
+    netloc = parsed_url.netloc.split('@')[-1].split(']')[-1]
+    if ':' in netloc:
+        port = netloc.split(':', 2)[1]
+        host_url += ':%s' % port
+
+    SubElement(result_elem, 'Location').text = host_url + req.path
+    SubElement(result_elem, 'Bucket').text = req.container_name
+    SubElement(result_elem, 'Key').text = req.object_name
+    SubElement(result_elem, 'ETag').text = '"%s"' % s3_etag
+    body = tostring(result_elem, xml_declaration=not yielded_anything)
+    if yielded_anything:
+        return b'\n' + body
+    return body
 
 
 class PartController(Controller):
@@ -152,7 +184,7 @@ class PartController(Controller):
                                   err_msg)
 
         upload_id = req.params['uploadId']
-        _check_upload_info(req, self.app, upload_id)
+        _get_upload_info(req, self.app, upload_id)
 
         req.container_name += MULTIUPLOAD_SUFFIX
         req.object_name = '%s/%s/%d' % (req.object_name, upload_id,
@@ -449,7 +481,7 @@ class UploadController(Controller):
             raise InvalidArgument('encoding-type', encoding_type, err_msg)
 
         upload_id = req.params['uploadId']
-        _check_upload_info(req, self.app, upload_id)
+        _get_upload_info(req, self.app, upload_id)
 
         maxparts = req.get_validated_param(
             'max-parts', DEFAULT_MAX_PARTS_LISTING,
@@ -536,7 +568,7 @@ class UploadController(Controller):
         Handles Abort Multipart Upload.
         """
         upload_id = req.params['uploadId']
-        _check_upload_info(req, self.app, upload_id)
+        _get_upload_info(req, self.app, upload_id)
 
         # First check to see if this multi-part upload was already
         # completed.  Look in the primary container, if the object exists,
@@ -580,7 +612,8 @@ class UploadController(Controller):
         """
         upload_id = req.params['uploadId']
         resp = _get_upload_info(req, self.app, upload_id)
-        headers = {'Accept': 'application/json'}
+        headers = {'Accept': 'application/json',
+                   sysmeta_header('object', 'upload-id'): upload_id}
         for key, val in resp.headers.items():
             _key = key.lower()
             if _key.startswith('x-amz-meta-'):
@@ -650,7 +683,15 @@ class UploadController(Controller):
             raise
 
         s3_etag = '%s-%d' % (s3_etag_hasher.hexdigest(), len(manifest))
-        headers[sysmeta_header('object', 'etag')] = s3_etag
+        s3_etag_header = sysmeta_header('object', 'etag')
+        if resp.sysmeta_headers.get(s3_etag_header) == s3_etag:
+            # This header should only already be present if the upload marker
+            # has been cleaned up and the current target uses the same
+            # upload-id; assuming the segments to use haven't changed, the work
+            # is already done
+            return HTTPOk(body=_make_complete_body(req, s3_etag, False),
+                          content_type='application/xml')
+        headers[s3_etag_header] = s3_etag
         # Leave base header value blank; SLO will populate
         c_etag = '; s3_etag=%s' % s3_etag
         headers[get_container_update_override_key('etag')] = c_etag
@@ -730,37 +771,13 @@ class UploadController(Controller):
                 try:
                     req.get_response(self.app, 'DELETE', container, obj)
                 except NoSuchKey:
-                    # We know that this existed long enough for us to HEAD
+                    # The important thing is that we wrote out a tombstone to
+                    # make sure the marker got cleaned up. If it's already
+                    # gone (e.g., because of concurrent completes or a retried
+                    # complete), so much the better.
                     pass
 
-                result_elem = Element('CompleteMultipartUploadResult')
-
-                # NOTE: boto with sig v4 appends port to HTTP_HOST value at
-                # the request header when the port is non default value and it
-                # makes req.host_url like as http://localhost:8080:8080/path
-                # that obviously invalid. Probably it should be resolved at
-                # swift.common.swob though, tentatively we are parsing and
-                # reconstructing the correct host_url info here.
-                # in detail, https://github.com/boto/boto/pull/3513
-                parsed_url = urlparse(req.host_url)
-                host_url = '%s://%s' % (parsed_url.scheme, parsed_url.hostname)
-                # Why are we doing our own port parsing? Because py3 decided
-                # to start raising ValueErrors on access after parsing such
-                # an invalid port
-                netloc = parsed_url.netloc.split('@')[-1].split(']')[-1]
-                if ':' in netloc:
-                    port = netloc.split(':', 2)[1]
-                    host_url += ':%s' % port
-
-                SubElement(result_elem, 'Location').text = host_url + req.path
-                SubElement(result_elem, 'Bucket').text = req.container_name
-                SubElement(result_elem, 'Key').text = req.object_name
-                SubElement(result_elem, 'ETag').text = '"%s"' % s3_etag
-                resp.headers.pop('ETag', None)
-                if yielded_anything:
-                    yield b'\n'
-                yield tostring(result_elem,
-                               xml_declaration=not yielded_anything)
+                yield _make_complete_body(req, s3_etag, yielded_anything)
             except ErrorResponse as err_resp:
                 if yielded_anything:
                     err_resp.xml_declaration = False
diff -pruN 2.25.0-3/swift/common/middleware/s3api/controllers/obj.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/s3api/controllers/obj.py
--- 2.25.0-3/swift/common/middleware/s3api/controllers/obj.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/s3api/controllers/obj.py	2020-09-15 21:13:36.000000000 +0000
@@ -26,7 +26,7 @@ from swift.common.middleware.versioned_w
 from swift.common.middleware.s3api.utils import S3Timestamp, sysmeta_header
 from swift.common.middleware.s3api.controllers.base import Controller
 from swift.common.middleware.s3api.s3response import S3NotImplemented, \
-    InvalidRange, NoSuchKey, InvalidArgument, HTTPNoContent, \
+    InvalidRange, NoSuchKey, NoSuchVersion, InvalidArgument, HTTPNoContent, \
     PreconditionFailed
 
 
@@ -88,7 +88,15 @@ class ObjectController(Controller):
         if version_id not in ('null', None) and \
                 'object_versioning' not in get_swift_info():
             raise S3NotImplemented()
+
         query = {} if version_id is None else {'version-id': version_id}
+        if version_id not in ('null', None):
+            container_info = req.get_container_info(self.app)
+            if not container_info.get(
+                    'sysmeta', {}).get('versions-container', ''):
+                # Versioning has never been enabled
+                raise NoSuchVersion(object_name, version_id)
+
         resp = req.get_response(self.app, query=query)
 
         if req.method == 'HEAD':
@@ -193,17 +201,25 @@ class ObjectController(Controller):
                 'object_versioning' not in get_swift_info():
             raise S3NotImplemented()
 
+        version_id = req.params.get('versionId')
+        if version_id not in ('null', None):
+            container_info = req.get_container_info(self.app)
+            if not container_info.get(
+                    'sysmeta', {}).get('versions-container', ''):
+                # Versioning has never been enabled
+                return HTTPNoContent(headers={'x-amz-version-id': version_id})
+
         try:
             try:
                 query = req.gen_multipart_manifest_delete_query(
-                    self.app, version=req.params.get('versionId'))
+                    self.app, version=version_id)
             except NoSuchKey:
                 query = {}
 
             req.headers['Content-Type'] = None  # Ignore client content-type
 
-            if 'versionId' in req.params:
-                query['version-id'] = req.params['versionId']
+            if version_id is not None:
+                query['version-id'] = version_id
                 query['symlink'] = 'get'
 
             resp = req.get_response(self.app, query=query)
diff -pruN 2.25.0-3/swift/common/middleware/s3api/controllers/tagging.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/s3api/controllers/tagging.py
--- 2.25.0-3/swift/common/middleware/s3api/controllers/tagging.py	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/s3api/controllers/tagging.py	2020-09-15 21:13:36.000000000 +0000
@@ -0,0 +1,57 @@
+# Copyright (c) 2014 OpenStack Foundation.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#    http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
+# implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+from swift.common.utils import public
+
+from swift.common.middleware.s3api.controllers.base import Controller, \
+    S3NotImplemented
+from swift.common.middleware.s3api.s3response import HTTPOk
+from swift.common.middleware.s3api.etree import Element, tostring, \
+    SubElement
+
+
+class TaggingController(Controller):
+    """
+    Handles the following APIs:
+
+    * GET Bucket and Object tagging
+    * PUT Bucket and Object tagging
+    * DELETE Bucket and Object tagging
+
+    """
+    @public
+    def GET(self, req):
+        """
+        Handles GET Bucket and Object tagging.
+        """
+        elem = Element('Tagging')
+        SubElement(elem, 'TagSet')
+        body = tostring(elem)
+
+        return HTTPOk(body=body, content_type=None)
+
+    @public
+    def PUT(self, req):
+        """
+        Handles PUT Bucket and Object tagging.
+        """
+        raise S3NotImplemented('The requested resource is not implemented')
+
+    @public
+    def DELETE(self, req):
+        """
+        Handles DELETE Bucket and Object tagging.
+        """
+        raise S3NotImplemented('The requested resource is not implemented')
diff -pruN 2.25.0-3/swift/common/middleware/s3api/etree.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/s3api/etree.py
--- 2.25.0-3/swift/common/middleware/s3api/etree.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/s3api/etree.py	2020-09-15 21:13:36.000000000 +0000
@@ -92,7 +92,7 @@ def tostring(tree, use_s3ns=True, xml_de
 
         root = Element(tree.tag, attrib=tree.attrib, nsmap=nsmap)
         root.text = tree.text
-        root.extend(deepcopy(tree.getchildren()))
+        root.extend(deepcopy(list(tree)))
         tree = root
 
     return lxml.etree.tostring(tree, xml_declaration=xml_declaration,
diff -pruN 2.25.0-3/swift/common/middleware/s3api/s3api.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/s3api/s3api.py
--- 2.25.0-3/swift/common/middleware/s3api/s3api.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/s3api/s3api.py	2020-09-15 21:13:36.000000000 +0000
@@ -306,6 +306,8 @@ class S3ApiMiddleware(object):
             resp.headers['x-amz-id-2'] = env['swift.trans_id']
             resp.headers['x-amz-request-id'] = env['swift.trans_id']
 
+        if 's3api.backend_path' in env and 'swift.backend_path' not in env:
+            env['swift.backend_path'] = env['s3api.backend_path']
         return resp(env, start_response)
 
     def handle_request(self, req):
diff -pruN 2.25.0-3/swift/common/middleware/s3api/s3request.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/s3api/s3request.py
--- 2.25.0-3/swift/common/middleware/s3api/s3request.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/s3api/s3request.py	2020-09-15 21:13:36.000000000 +0000
@@ -37,15 +37,15 @@ from swift.common.http import HTTP_OK, H
     HTTP_TOO_MANY_REQUESTS, HTTP_RATE_LIMITED, is_success
 
 from swift.common.constraints import check_utf8
-from swift.proxy.controllers.base import get_container_info, \
-    headers_to_container_info
+from swift.proxy.controllers.base import get_container_info
 from swift.common.request_helpers import check_path_header
 
 from swift.common.middleware.s3api.controllers import ServiceController, \
     ObjectController, AclController, MultiObjectDeleteController, \
     LocationController, LoggingStatusController, PartController, \
     UploadController, UploadsController, VersioningController, \
-    UnsupportedController, S3AclController, BucketController
+    UnsupportedController, S3AclController, BucketController, \
+    TaggingController
 from swift.common.middleware.s3api.s3response import AccessDenied, \
     InvalidArgument, InvalidDigest, BucketAlreadyOwnedByYou, \
     RequestTimeTooSkewed, S3Response, SignatureDoesNotMatch, \
@@ -283,6 +283,12 @@ class SigV4Mixin(object):
             if cred_param[key] != self.scope[key]:
                 kwargs = {}
                 if key == 'region':
+                    # Allow lowercase region name
+                    # for AWS .NET SDK compatibility
+                    if not self.scope[key].islower() and \
+                            cred_param[key] == self.scope[key].lower():
+                        self.location = self.location.lower()
+                        continue
                     kwargs = {'region': self.scope['region']}
                 raise AuthorizationQueryParametersError(
                     invalid_messages[key] % (cred_param[key], self.scope[key]),
@@ -325,6 +331,12 @@ class SigV4Mixin(object):
             if cred_param[key] != self.scope[key]:
                 kwargs = {}
                 if key == 'region':
+                    # Allow lowercase region name
+                    # for AWS .NET SDK compatibility
+                    if not self.scope[key].islower() and \
+                            cred_param[key] == self.scope[key].lower():
+                        self.location = self.location.lower()
+                        continue
                     kwargs = {'region': self.scope['region']}
                 raise AuthorizationHeaderMalformed(
                     invalid_messages[key] % (cred_param[key], self.scope[key]),
@@ -1026,9 +1038,11 @@ class S3Request(swob.Request):
             return UploadsController
         if 'versioning' in self.params:
             return VersioningController
+        if 'tagging' in self.params:
+            return TaggingController
 
         unsupported = ('notification', 'policy', 'requestPayment', 'torrent',
-                       'website', 'cors', 'tagging', 'restore')
+                       'website', 'cors', 'restore')
         if set(unsupported) & set(self.params):
             return UnsupportedController
 
@@ -1334,10 +1348,8 @@ class S3Request(swob.Request):
                                             2, 3, True)
             # Propagate swift.backend_path in environ for middleware
             # in pipeline that need Swift PATH_INFO like ceilometermiddleware.
-            # Store PATH_INFO only the first time to ignore multipart requests.
-            if 'swift.backend_path' not in self.environ:
-                self.environ['swift.backend_path'] = \
-                    sw_resp.environ['PATH_INFO']
+            self.environ['s3api.backend_path'] = \
+                sw_resp.environ['PATH_INFO']
 
         resp = S3Response.from_swift_resp(sw_resp)
         status = resp.status_int  # pylint: disable-msg=E1101
@@ -1368,6 +1380,8 @@ class S3Request(swob.Request):
                 error_codes[sw_resp.status_int]  # pylint: disable-msg=E1101
             if isinstance(err_resp, tuple):
                 raise err_resp[0](*err_resp[1:])
+            elif b'quota' in err_msg:
+                raise err_resp(err_msg)
             else:
                 raise err_resp()
 
@@ -1436,25 +1450,28 @@ class S3Request(swob.Request):
         :raises: NoSuchBucket when the container doesn't exist
         :raises: InternalError when the request failed without 404
         """
-        if self.is_authenticated:
-            # if we have already authenticated, yes we can use the account
-            # name like as AUTH_xxx for performance efficiency
-            sw_req = self.to_swift_req(app, self.container_name, None)
-            info = get_container_info(sw_req.environ, app, swift_source='S3')
-            if is_success(info['status']):
-                return info
-            elif info['status'] == 404:
-                raise NoSuchBucket(self.container_name)
-            else:
-                raise InternalError(
-                    'unexpected status code %d' % info['status'])
+        if not self.is_authenticated:
+            sw_req = self.to_swift_req('TEST', None, None, body='')
+            # don't show log message of this request
+            sw_req.environ['swift.proxy_access_log_made'] = True
+
+            sw_resp = sw_req.get_response(app)
+
+            if not sw_req.remote_user:
+                raise SignatureDoesNotMatch(
+                    **self.signature_does_not_match_kwargs())
+
+            _, self.account, _ = split_path(sw_resp.environ['PATH_INFO'],
+                                            2, 3, True)
+        sw_req = self.to_swift_req(app, self.container_name, None)
+        info = get_container_info(sw_req.environ, app, swift_source='S3')
+        if is_success(info['status']):
+            return info
+        elif info['status'] == 404:
+            raise NoSuchBucket(self.container_name)
         else:
-            # otherwise we do naive HEAD request with the authentication
-            resp = self.get_response(app, 'HEAD', self.container_name, '')
-            headers = resp.sw_headers.copy()
-            headers.update(resp.sysmeta_headers)
-            return headers_to_container_info(
-                headers, resp.status_int)  # pylint: disable-msg=E1101
+            raise InternalError(
+                'unexpected status code %d' % info['status'])
 
     def gen_multipart_manifest_delete_query(self, app, obj=None, version=None):
         if not self.allow_multipart_uploads:
diff -pruN 2.25.0-3/swift/common/middleware/s3api/utils.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/s3api/utils.py
--- 2.25.0-3/swift/common/middleware/s3api/utils.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/s3api/utils.py	2020-09-15 21:13:36.000000000 +0000
@@ -120,10 +120,6 @@ class S3Timestamp(utils.Timestamp):
         return self.isoformat.replace(
             '-', '').replace(':', '')[:-7] + 'Z'
 
-    @classmethod
-    def now(cls):
-        return cls(time.time())
-
 
 def mktime(timestamp_str, time_format='%Y-%m-%dT%H:%M:%S'):
     """
diff -pruN 2.25.0-3/swift/common/middleware/symlink.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/symlink.py
--- 2.25.0-3/swift/common/middleware/symlink.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/symlink.py	2020-09-15 21:13:36.000000000 +0000
@@ -205,7 +205,8 @@ from swift.common.utils import get_logge
     MD5_OF_EMPTY_STRING, close_if_possible, closing_if_possible, \
     config_true_value, drain_and_close
 from swift.common.constraints import check_account_format
-from swift.common.wsgi import WSGIContext, make_subrequest
+from swift.common.wsgi import WSGIContext, make_subrequest, \
+    make_pre_authed_request
 from swift.common.request_helpers import get_sys_meta_prefix, \
     check_path_header, get_container_update_override_key, \
     update_ignore_range_header
@@ -442,7 +443,9 @@ class SymlinkObjectContext(WSGIContext):
                                content_type='text/plain')
 
     def _recursive_get_head(self, req, target_etag=None,
-                            follow_softlinks=True):
+                            follow_softlinks=True, orig_req=None):
+        if not orig_req:
+            orig_req = req
         resp = self._app_call(req.environ)
 
         def build_traversal_req(symlink_target):
@@ -457,9 +460,20 @@ class SymlinkObjectContext(WSGIContext):
                 '/', version, account,
                 symlink_target.lstrip('/'))
             self._last_target_path = target_path
-            new_req = make_subrequest(
-                req.environ, path=target_path, method=req.method,
-                headers=req.headers, swift_source='SYM')
+
+            subreq_headers = dict(req.headers)
+            if self._response_header_value(ALLOW_RESERVED_NAMES):
+                # this symlink's sysmeta says it can point to reserved names,
+                # we're infering that some piece of middleware had previously
+                # authorized this request because users can't access reserved
+                # names directly
+                subreq_meth = make_pre_authed_request
+                subreq_headers['X-Backend-Allow-Reserved-Names'] = 'true'
+            else:
+                subreq_meth = make_subrequest
+            new_req = subreq_meth(orig_req.environ, path=target_path,
+                                  method=req.method, headers=subreq_headers,
+                                  swift_source='SYM')
             new_req.headers.pop('X-Backend-Storage-Policy-Index', None)
             return new_req
 
@@ -484,11 +498,8 @@ class SymlinkObjectContext(WSGIContext):
             if not config_true_value(
                     self._response_header_value(SYMLOOP_EXTEND)):
                 self._loop_count += 1
-            if config_true_value(
-                    self._response_header_value(ALLOW_RESERVED_NAMES)):
-                new_req.headers['X-Backend-Allow-Reserved-Names'] = 'true'
-
-            return self._recursive_get_head(new_req, target_etag=resp_etag)
+            return self._recursive_get_head(new_req, target_etag=resp_etag,
+                                            orig_req=req)
         else:
             final_etag = self._response_header_value('etag')
             if final_etag and target_etag and target_etag != final_etag:
diff -pruN 2.25.0-3/swift/common/middleware/tempauth.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/tempauth.py
--- 2.25.0-3/swift/common/middleware/tempauth.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/tempauth.py	2020-09-15 21:13:36.000000000 +0000
@@ -666,8 +666,6 @@ class TempAuth(object):
             req = Request(env)
             if self.auth_prefix:
                 req.path_info_pop()
-            req.bytes_transferred = '-'
-            req.client_disconnect = False
             if 'x-storage-token' in req.headers and \
                     'x-auth-token' not in req.headers:
                 req.headers['x-auth-token'] = req.headers['x-storage-token']
diff -pruN 2.25.0-3/swift/common/middleware/versioned_writes/object_versioning.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/versioned_writes/object_versioning.py
--- 2.25.0-3/swift/common/middleware/versioned_writes/object_versioning.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/middleware/versioned_writes/object_versioning.py	2020-09-15 21:13:36.000000000 +0000
@@ -152,7 +152,7 @@ from cgi import parse_header
 from six.moves.urllib.parse import unquote
 
 from swift.common.constraints import MAX_FILE_SIZE, valid_api_version, \
-    ACCOUNT_LISTING_LIMIT
+    ACCOUNT_LISTING_LIMIT, CONTAINER_LISTING_LIMIT
 from swift.common.http import is_success, is_client_error, HTTP_NOT_FOUND, \
     HTTP_CONFLICT
 from swift.common.request_helpers import get_sys_meta_prefix, \
@@ -1191,7 +1191,7 @@ class ContainerContext(ObjectVersioningC
                     'hash': item['hash'],
                     'last_modified': item['last_modified'],
                 })
-            limit = constrain_req_limit(req, ACCOUNT_LISTING_LIMIT)
+            limit = constrain_req_limit(req, CONTAINER_LISTING_LIMIT)
             body = build_listing(
                 null_listing, subdir_listing, broken_listing,
                 reverse=config_true_value(params.get('reverse', 'no')),
@@ -1256,7 +1256,7 @@ class ContainerContext(ObjectVersioningC
                         'last_modified': item['last_modified'],
                     })
 
-                limit = constrain_req_limit(req, ACCOUNT_LISTING_LIMIT)
+                limit = constrain_req_limit(req, CONTAINER_LISTING_LIMIT)
                 body = build_listing(
                     null_listing, versions_listing,
                     subdir_listing, broken_listing,
diff -pruN 2.25.0-3/swift/common/request_helpers.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/request_helpers.py
--- 2.25.0-3/swift/common/request_helpers.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/request_helpers.py	2020-09-15 21:13:36.000000000 +0000
@@ -40,14 +40,15 @@ from swift.common.utils import split_pat
     close_if_possible, maybe_multipart_byteranges_to_document_iters, \
     multipart_byteranges_to_document_iters, parse_content_type, \
     parse_content_range, csv_append, list_from_csv, Spliterator, quote, \
-    RESERVED
+    RESERVED, config_true_value
 from swift.common.wsgi import make_subrequest
-from swift.container.reconciler import MISPLACED_OBJECTS_ACCOUNT
 
 
 OBJECT_TRANSIENT_SYSMETA_PREFIX = 'x-object-transient-sysmeta-'
 OBJECT_SYSMETA_CONTAINER_UPDATE_OVERRIDE_PREFIX = \
     'x-object-sysmeta-container-update-override-'
+USE_REPLICATION_NETWORK_HEADER = 'x-backend-use-replication-network'
+MISPLACED_OBJECTS_ACCOUNT = '.misplaced_objects'
 
 
 if six.PY2:
@@ -357,7 +358,7 @@ def get_reserved_name(*parts):
 
 def split_reserved_name(name):
     """
-    Seperate a valid reserved name into the component parts.
+    Separate a valid reserved name into the component parts.
 
     :returns: a list of strings
     """
@@ -849,3 +850,15 @@ def update_ignore_range_header(req, name
         raise ValueError('Header name must not contain commas')
     hdr = 'X-Backend-Ignore-Range-If-Metadata-Present'
     req.headers[hdr] = csv_append(req.headers.get(hdr), name)
+
+
+def get_ip_port(node, headers):
+    use_replication_network = False
+    for h, v in headers.items():
+        if h.lower() == USE_REPLICATION_NETWORK_HEADER:
+            use_replication_network = config_true_value(v)
+            break
+    if use_replication_network:
+        return node['replication_ip'], node['replication_port']
+    else:
+        return node['ip'], node['port']
diff -pruN 2.25.0-3/swift/common/ring/builder.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/ring/builder.py
--- 2.25.0-3/swift/common/ring/builder.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/ring/builder.py	2020-09-15 21:13:36.000000000 +0000
@@ -1437,17 +1437,17 @@ class RingBuilder(object):
             {(): 3.0,
             (1,): 3.0,
             (1, 1): 1.0,
-            (1, 1, '127.0.0.1:6010'): 1.0,
-            (1, 1, '127.0.0.1:6010', 0): 1.0,
+            (1, 1, '127.0.0.1:6210'): 1.0,
+            (1, 1, '127.0.0.1:6210', 0): 1.0,
             (1, 2): 1.0,
-            (1, 2, '127.0.0.1:6020'): 1.0,
-            (1, 2, '127.0.0.1:6020', 1): 1.0,
+            (1, 2, '127.0.0.1:6220'): 1.0,
+            (1, 2, '127.0.0.1:6220', 1): 1.0,
             (1, 3): 1.0,
-            (1, 3, '127.0.0.1:6030'): 1.0,
-            (1, 3, '127.0.0.1:6030', 2): 1.0,
+            (1, 3, '127.0.0.1:6230'): 1.0,
+            (1, 3, '127.0.0.1:6230', 2): 1.0,
             (1, 4): 1.0,
-            (1, 4, '127.0.0.1:6040'): 1.0,
-            (1, 4, '127.0.0.1:6040', 3): 1.0}
+            (1, 4, '127.0.0.1:6240'): 1.0,
+            (1, 4, '127.0.0.1:6240', 3): 1.0}
 
         """
         # Used by walk_tree to know what entries to create for each recursive
diff -pruN 2.25.0-3/swift/common/swob.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/swob.py
--- 2.25.0-3/swift/common/swob.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/swob.py	2020-09-15 21:13:36.000000000 +0000
@@ -43,7 +43,6 @@ from email.utils import parsedate
 import re
 import random
 import functools
-import inspect
 from io import BytesIO
 
 import six
@@ -1563,23 +1562,15 @@ def wsgify(func):
     return a Response object into WSGI callables.  Also catches any raised
     HTTPExceptions and treats them as a returned Response.
     """
-    argspec = inspect.getargspec(func)
-    if argspec.args and argspec.args[0] == 'self':
-        @functools.wraps(func)
-        def _wsgify_self(self, env, start_response):
-            try:
-                return func(self, Request(env))(env, start_response)
-            except HTTPException as err_resp:
-                return err_resp(env, start_response)
-        return _wsgify_self
-    else:
-        @functools.wraps(func)
-        def _wsgify_bare(env, start_response):
-            try:
-                return func(Request(env))(env, start_response)
-            except HTTPException as err_resp:
-                return err_resp(env, start_response)
-        return _wsgify_bare
+    @functools.wraps(func)
+    def _wsgify(*args):
+        env, start_response = args[-2:]
+        new_args = args[:-2] + (Request(env), )
+        try:
+            return func(*new_args)(env, start_response)
+        except HTTPException as err_resp:
+            return err_resp(env, start_response)
+    return _wsgify
 
 
 class StatusMap(object):
diff -pruN 2.25.0-3/swift/common/utils.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/utils.py
--- 2.25.0-3/swift/common/utils.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/utils.py	2020-09-15 21:13:36.000000000 +0000
@@ -48,6 +48,7 @@ import ctypes.util
 from copy import deepcopy
 from optparse import OptionParser
 import traceback
+import warnings
 
 from tempfile import gettempdir, mkstemp, NamedTemporaryFile
 import glob
@@ -75,6 +76,7 @@ if not six.PY2:
     utf16_decoder = codecs.getdecoder('utf-16')
     utf16_encoder = codecs.getencoder('utf-16')
 from six.moves import cPickle as pickle
+from six.moves import configparser
 from six.moves.configparser import (ConfigParser, NoSectionError,
                                     NoOptionError, RawConfigParser)
 from six.moves import range, http_client
@@ -2984,6 +2986,17 @@ def read_conf_dir(parser, conf_dir):
     return parser.read(sorted(conf_files))
 
 
+if six.PY2:
+    NicerInterpolation = None  # just don't cause ImportErrors over in wsgi.py
+else:
+    class NicerInterpolation(configparser.BasicInterpolation):
+        def before_get(self, parser, section, option, value, defaults):
+            if '%(' not in value:
+                return value
+            return super(NicerInterpolation, self).before_get(
+                parser, section, option, value, defaults)
+
+
 def readconf(conf_path, section_name=None, log_name=None, defaults=None,
              raw=False):
     """
@@ -3005,7 +3018,19 @@ def readconf(conf_path, section_name=Non
     if raw:
         c = RawConfigParser(defaults)
     else:
-        c = ConfigParser(defaults)
+        if six.PY2:
+            c = ConfigParser(defaults)
+        else:
+            # In general, we haven't really thought much about interpolation
+            # in configs. Python's default ConfigParser has always supported
+            # it, though, so *we* got it "for free". Unfortunatley, since we
+            # "supported" interpolation, we have to assume there are
+            # deployments in the wild that use it, and try not to break them.
+            # So, do what we can to mimic the py2 behavior of passing through
+            # values like "1%" (which we want to support for
+            # fallocate_reserve).
+            c = ConfigParser(defaults, interpolation=NicerInterpolation())
+
     if hasattr(conf_path, 'readline'):
         if hasattr(conf_path, 'seek'):
             conf_path.seek(0)
@@ -3151,11 +3176,26 @@ def remove_directory(path):
 
 
 def audit_location_generator(devices, datadir, suffix='',
-                             mount_check=True, logger=None):
+                             mount_check=True, logger=None,
+                             devices_filter=None, partitions_filter=None,
+                             suffixes_filter=None, hashes_filter=None,
+                             hook_pre_device=None, hook_post_device=None,
+                             hook_pre_partition=None, hook_post_partition=None,
+                             hook_pre_suffix=None, hook_post_suffix=None,
+                             hook_pre_hash=None, hook_post_hash=None):
     """
     Given a devices path and a data directory, yield (path, device,
     partition) for all files in that directory
 
+    (devices|partitions|suffixes|hashes)_filter are meant to modify the list of
+    elements that will be iterated. eg: they can be used to exclude some
+    elements based on a custom condition defined by the caller.
+
+    hook_pre_(device|partition|suffix|hash) are called before yielding the
+    element, hook_pos_(device|partition|suffix|hash) are called after the
+    element was yielded. They are meant to do some pre/post processing.
+    eg: saving a progress status.
+
     :param devices: parent directory of the devices to be audited
     :param datadir: a directory located under self.devices. This should be
                     one of the DATADIR constants defined in the account,
@@ -3164,11 +3204,31 @@ def audit_location_generator(devices, da
     :param mount_check: Flag to check if a mount check should be performed
                     on devices
     :param logger: a logger object
+    :devices_filter: a callable taking (devices, [list of devices]) as
+                     parameters and returning a [list of devices]
+    :partitions_filter: a callable taking (datadir_path, [list of parts]) as
+                        parameters and returning a [list of parts]
+    :suffixes_filter: a callable taking (part_path, [list of suffixes]) as
+                      parameters and returning a [list of suffixes]
+    :hashes_filter: a callable taking (suff_path, [list of hashes]) as
+                    parameters and returning a [list of hashes]
+    :hook_pre_device: a callable taking device_path as parameter
+    :hook_post_device: a callable taking device_path as parameter
+    :hook_pre_partition: a callable taking part_path as parameter
+    :hook_post_partition: a callable taking part_path as parameter
+    :hook_pre_suffix: a callable taking suff_path as parameter
+    :hook_post_suffix: a callable taking suff_path as parameter
+    :hook_pre_hash: a callable taking hash_path as parameter
+    :hook_post_hash: a callable taking hash_path as parameter
     """
     device_dir = listdir(devices)
     # randomize devices in case of process restart before sweep completed
     shuffle(device_dir)
+    if devices_filter:
+        device_dir = devices_filter(devices, device_dir)
     for device in device_dir:
+        if hook_pre_device:
+            hook_pre_device(os.path.join(devices, device))
         if mount_check and not ismount(os.path.join(devices, device)):
             if logger:
                 logger.warning(
@@ -3182,24 +3242,36 @@ def audit_location_generator(devices, da
                 logger.warning(_('Skipping %(datadir)s because %(err)s'),
                                {'datadir': datadir_path, 'err': e})
             continue
+        if partitions_filter:
+            partitions = partitions_filter(datadir_path, partitions)
         for partition in partitions:
             part_path = os.path.join(datadir_path, partition)
+            if hook_pre_partition:
+                hook_pre_partition(part_path)
             try:
                 suffixes = listdir(part_path)
             except OSError as e:
                 if e.errno != errno.ENOTDIR:
                     raise
                 continue
+            if suffixes_filter:
+                suffixes = suffixes_filter(part_path, suffixes)
             for asuffix in suffixes:
                 suff_path = os.path.join(part_path, asuffix)
+                if hook_pre_suffix:
+                    hook_pre_suffix(suff_path)
                 try:
                     hashes = listdir(suff_path)
                 except OSError as e:
                     if e.errno != errno.ENOTDIR:
                         raise
                     continue
+                if hashes_filter:
+                    hashes = hashes_filter(suff_path, hashes)
                 for hsh in hashes:
                     hash_path = os.path.join(suff_path, hsh)
+                    if hook_pre_hash:
+                        hook_pre_hash(hash_path)
                     try:
                         files = sorted(listdir(hash_path), reverse=True)
                     except OSError as e:
@@ -3211,6 +3283,14 @@ def audit_location_generator(devices, da
                             continue
                         path = os.path.join(hash_path, fname)
                         yield path, device, partition
+                    if hook_post_hash:
+                        hook_post_hash(hash_path)
+                if hook_post_suffix:
+                    hook_post_suffix(suff_path)
+            if hook_post_partition:
+                hook_post_partition(part_path)
+        if hook_post_device:
+            hook_post_device(os.path.join(devices, device))
 
 
 def ratelimit_sleep(running_time, max_rate, incr_by=1, rate_buffer=5):
@@ -4346,7 +4426,7 @@ def get_expirer_container(x_delete_at, e
     """
     shard_int = int(hash_path(acc, cont, obj), 16) % 100
     return normalize_delete_at_timestamp(
-        int(x_delete_at) / expirer_divisor * expirer_divisor - shard_int)
+        int(x_delete_at) // expirer_divisor * expirer_divisor - shard_int)
 
 
 class _MultipartMimeFileLikeObject(object):
@@ -4813,6 +4893,8 @@ class ShardRange(object):
         value.
     :param epoch: optional epoch timestamp which represents the time at which
         sharding was enabled for a container.
+    :param reported: optional indicator that this shard and its stats have
+        been reported to the root container.
     """
     FOUND = 10
     CREATED = 20
@@ -4863,7 +4945,8 @@ class ShardRange(object):
 
     def __init__(self, name, timestamp, lower=MIN, upper=MAX,
                  object_count=0, bytes_used=0, meta_timestamp=None,
-                 deleted=False, state=None, state_timestamp=None, epoch=None):
+                 deleted=False, state=None, state_timestamp=None, epoch=None,
+                 reported=False):
         self.account = self.container = self._timestamp = \
             self._meta_timestamp = self._state_timestamp = self._epoch = None
         self._lower = ShardRange.MIN
@@ -4882,6 +4965,7 @@ class ShardRange(object):
         self.state = self.FOUND if state is None else state
         self.state_timestamp = state_timestamp
         self.epoch = epoch
+        self.reported = reported
 
     @classmethod
     def _encode(cls, value):
@@ -4985,8 +5069,10 @@ class ShardRange(object):
 
     @lower.setter
     def lower(self, value):
-        if value in (None, b'', u''):
-            value = ShardRange.MIN
+        with warnings.catch_warnings():
+            warnings.simplefilter('ignore', UnicodeWarning)
+            if value in (None, b'', u''):
+                value = ShardRange.MIN
         try:
             value = self._encode_bound(value)
         except TypeError as err:
@@ -5011,8 +5097,10 @@ class ShardRange(object):
 
     @upper.setter
     def upper(self, value):
-        if value in (None, b'', u''):
-            value = ShardRange.MAX
+        with warnings.catch_warnings():
+            warnings.simplefilter('ignore', UnicodeWarning)
+            if value in (None, b'', u''):
+                value = ShardRange.MAX
         try:
             value = self._encode_bound(value)
         except TypeError as err:
@@ -5058,8 +5146,14 @@ class ShardRange(object):
             cast to an int, or if meta_timestamp is neither None nor can be
             cast to a :class:`~swift.common.utils.Timestamp`.
         """
-        self.object_count = int(object_count)
-        self.bytes_used = int(bytes_used)
+        if self.object_count != int(object_count):
+            self.object_count = int(object_count)
+            self.reported = False
+
+        if self.bytes_used != int(bytes_used):
+            self.bytes_used = int(bytes_used)
+            self.reported = False
+
         if meta_timestamp is None:
             self.meta_timestamp = Timestamp.now()
         else:
@@ -5140,6 +5234,14 @@ class ShardRange(object):
     def epoch(self, epoch):
         self._epoch = self._to_timestamp(epoch)
 
+    @property
+    def reported(self):
+        return self._reported
+
+    @reported.setter
+    def reported(self, value):
+        self._reported = bool(value)
+
     def update_state(self, state, state_timestamp=None):
         """
         Set state to the given value and optionally update the state_timestamp
@@ -5156,6 +5258,7 @@ class ShardRange(object):
         self.state = state
         if state_timestamp is not None:
             self.state_timestamp = state_timestamp
+        self.reported = False
         return True
 
     @property
@@ -5278,6 +5381,7 @@ class ShardRange(object):
         yield 'state', self.state
         yield 'state_timestamp', self.state_timestamp.internal
         yield 'epoch', self.epoch.internal if self.epoch is not None else None
+        yield 'reported', 1 if self.reported else 0
 
     def copy(self, timestamp=None, **kwargs):
         """
@@ -5309,7 +5413,8 @@ class ShardRange(object):
             params['name'], params['timestamp'], params['lower'],
             params['upper'], params['object_count'], params['bytes_used'],
             params['meta_timestamp'], params['deleted'], params['state'],
-            params['state_timestamp'], params['epoch'])
+            params['state_timestamp'], params['epoch'],
+            params.get('reported', 0))
 
 
 def find_shard_range(item, ranges):
diff -pruN 2.25.0-3/swift/common/wsgi.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/wsgi.py
--- 2.25.0-3/swift/common/wsgi.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/common/wsgi.py	2020-09-15 21:13:36.000000000 +0000
@@ -36,7 +36,6 @@ from io import BytesIO
 
 import six
 from six import StringIO
-from six.moves import configparser
 
 from swift.common import utils, constraints
 from swift.common.storage_policy import BindPortsCache
@@ -45,7 +44,7 @@ from swift.common.swob import Request, w
 from swift.common.utils import capture_stdio, disable_fallocate, \
     drop_privileges, get_logger, NullLogger, config_true_value, \
     validate_configuration, get_hub, config_auto_int_value, \
-    reiterate, clean_up_daemon_hygiene, systemd_notify
+    reiterate, clean_up_daemon_hygiene, systemd_notify, NicerInterpolation
 
 SIGNUM_TO_NAME = {getattr(signal, n): n for n in dir(signal)
                   if n.startswith('SIG') and '_' not in n}
@@ -61,23 +60,6 @@ except (ImportError, NotImplementedError
     CPU_COUNT = 1
 
 
-if not six.PY2:
-    # In general, we haven't really thought much about interpolation in
-    # configs. Python's default ConfigParser has always supported it, though,
-    # so *we* got it "for free". Unfortunatley, since we "supported"
-    # interpolation, we have to assume there are deployments in the wild that
-    # use it, and try not to break them. So, do what we can to mimic the py2
-    # behavior of passing through values like "1%" (which we want to support
-    # for fallocate_reserve).
-    class NicerInterpolation(configparser.BasicInterpolation):
-        def before_get(self, parser, section, option, value, defaults):
-            if '%(' not in value:
-                return value
-            return super(NicerInterpolation, self).before_get(
-                parser, section, option, value, defaults)
-    configparser.ConfigParser._DEFAULT_INTERPOLATION = NicerInterpolation()
-
-
 class NamedConfigLoader(loadwsgi.ConfigLoader):
     """
     Patch paste.deploy's ConfigLoader so each context object will know what
@@ -85,6 +67,8 @@ class NamedConfigLoader(loadwsgi.ConfigL
     """
 
     def get_context(self, object_type, name=None, global_conf=None):
+        if not six.PY2:
+            self.parser._interpolation = NicerInterpolation()
         context = super(NamedConfigLoader, self).get_context(
             object_type, name=name, global_conf=global_conf)
         context.name = name
@@ -468,17 +452,21 @@ class SwiftHttpProtocol(wsgi.HttpProtoco
             return ''
 
     def parse_request(self):
+        # Need to track the bytes-on-the-wire for S3 signatures -- eventlet
+        # would do it for us, but since we rewrite the path on py3, we need to
+        # fix it ourselves later.
+        self.__raw_path_info = None
+
         if not six.PY2:
             # request lines *should* be ascii per the RFC, but historically
             # we've allowed (and even have func tests that use) arbitrary
             # bytes. This breaks on py3 (see https://bugs.python.org/issue33973
             # ) but the work-around is simple: munge the request line to be
-            # properly quoted. py2 will do the right thing without this, but it
-            # doesn't hurt to re-write the request line like this and it
-            # simplifies testing.
+            # properly quoted.
             if self.raw_requestline.count(b' ') >= 2:
                 parts = self.raw_requestline.split(b' ', 2)
                 path, q, query = parts[1].partition(b'?')
+                self.__raw_path_info = path
                 # unquote first, so we don't over-quote something
                 # that was *correctly* quoted
                 path = wsgi_to_bytes(wsgi_quote(wsgi_unquote(
@@ -500,6 +488,8 @@ class SwiftHttpProtocol(wsgi.HttpProtoco
     if not six.PY2:
         def get_environ(self, *args, **kwargs):
             environ = wsgi.HttpProtocol.get_environ(self, *args, **kwargs)
+            environ['RAW_PATH_INFO'] = bytes_to_wsgi(
+                self.__raw_path_info)
             header_payload = self.headers.get_payload()
             if isinstance(header_payload, list) and len(header_payload) == 1:
                 header_payload = header_payload[0].get_payload()
@@ -646,7 +636,7 @@ class SwiftHttpProxiedProtocol(SwiftHttp
         return environ
 
 
-def run_server(conf, logger, sock, global_conf=None):
+def run_server(conf, logger, sock, global_conf=None, ready_callback=None):
     # Ensure TZ environment variable exists to avoid stat('/etc/localtime') on
     # some platforms. This locks in reported times to UTC.
     os.environ['TZ'] = 'UTC+0'
@@ -687,6 +677,8 @@ def run_server(conf, logger, sock, globa
         # header; "Etag" just won't do).
         'capitalize_response_headers': False,
     }
+    if ready_callback:
+        ready_callback()
     try:
         wsgi.server(sock, app, wsgi_logger, **server_kwargs)
     except socket.error as err:
@@ -699,6 +691,15 @@ class StrategyBase(object):
     """
     Some operations common to all strategy classes.
     """
+    def __init__(self, conf, logger):
+        self.conf = conf
+        self.logger = logger
+        self.signaled_ready = False
+
+        # Each strategy is welcome to track data however it likes, but all
+        # socket refs should be somewhere in this dict. This allows forked-off
+        # children to easily drop refs to sibling sockets in post_fork_hook().
+        self.tracking_data = {}
 
     def post_fork_hook(self):
         """
@@ -706,7 +707,10 @@ class StrategyBase(object):
         wsgi server, to perform any initialization such as drop privileges.
         """
 
+        if not self.signaled_ready:
+            capture_stdio(self.logger)
         drop_privileges(self.conf.get('user', 'swift'))
+        del self.tracking_data  # children don't need to track siblings
 
     def shutdown_sockets(self):
         """
@@ -731,12 +735,40 @@ class StrategyBase(object):
                 # on socket objects is provided to toggle it.
                 sock.set_inheritable(False)
 
+    def signal_ready(self):
+        """
+        Signal that the server is up and accepting connections.
+        """
+        if self.signaled_ready:
+            return  # Already did it
+
+        # Redirect errors to logger and close stdio. swift-init (for example)
+        # uses this to know that the service is ready to accept connections.
+        capture_stdio(self.logger)
+
+        # If necessary, signal an old copy of us that it's okay to shutdown
+        # its listen sockets now because ours are up and ready to receive
+        # connections. This is used for seamless reloading using SIGUSR1.
+        reexec_signal_fd = os.getenv(NOTIFY_FD_ENV_KEY)
+        if reexec_signal_fd:
+            reexec_signal_fd = int(reexec_signal_fd)
+            os.write(reexec_signal_fd, str(os.getpid()).encode('utf8'))
+            os.close(reexec_signal_fd)
+
+        # Finally, signal systemd (if appropriate) that process started
+        # properly.
+        systemd_notify(logger=self.logger)
+
+        self.signaled_ready = True
+
 
 class WorkersStrategy(StrategyBase):
     """
     WSGI server management strategy object for a single bind port and listen
     socket shared by a configured number of forked-off workers.
 
+    Tracking data is a map of ``pid -> socket``.
+
     Used in :py:func:`run_wsgi`.
 
     :param dict conf: Server configuration dictionary.
@@ -745,10 +777,7 @@ class WorkersStrategy(StrategyBase):
     """
 
     def __init__(self, conf, logger):
-        self.conf = conf
-        self.logger = logger
-        self.sock = None
-        self.children = []
+        super(WorkersStrategy, self).__init__(conf, logger)
         self.worker_count = config_auto_int_value(conf.get('workers'),
                                                   CPU_COUNT)
 
@@ -763,18 +792,6 @@ class WorkersStrategy(StrategyBase):
 
         return 0.5
 
-    def do_bind_ports(self):
-        """
-        Bind the one listen socket for this strategy.
-        """
-
-        try:
-            self.sock = get_socket(self.conf)
-        except ConfigFilePortError:
-            msg = 'bind_port wasn\'t properly set in the config file. ' \
-                'It must be explicitly set to a valid port number.'
-            return msg
-
     def no_fork_sock(self):
         """
         Return a server listen socket if the server should run in the
@@ -783,7 +800,7 @@ class WorkersStrategy(StrategyBase):
 
         # Useful for profiling [no forks].
         if self.worker_count == 0:
-            return self.sock
+            return get_socket(self.conf)
 
     def new_worker_socks(self):
         """
@@ -795,8 +812,8 @@ class WorkersStrategy(StrategyBase):
         where it will be ignored.
         """
 
-        while len(self.children) < self.worker_count:
-            yield self.sock, None
+        while len(self.tracking_data) < self.worker_count:
+            yield get_socket(self.conf), None
 
     def log_sock_exit(self, sock, _unused):
         """
@@ -820,7 +837,7 @@ class WorkersStrategy(StrategyBase):
 
         self.logger.notice('Started child %s from parent %s',
                            pid, os.getpid())
-        self.children.append(pid)
+        self.tracking_data[pid] = sock
 
     def register_worker_exit(self, pid):
         """
@@ -833,139 +850,22 @@ class WorkersStrategy(StrategyBase):
         :param int pid: The PID of the worker that exited.
         """
 
-        if pid in self.children:
+        sock = self.tracking_data.pop(pid, None)
+        if sock is None:
+            self.logger.info('Ignoring wait() result from unknown PID %s', pid)
+        else:
             self.logger.error('Removing dead child %s from parent %s',
                               pid, os.getpid())
-            self.children.remove(pid)
-        else:
-            self.logger.info('Ignoring wait() result from unknown PID %s', pid)
+            greenio.shutdown_safe(sock)
+            sock.close()
 
     def iter_sockets(self):
         """
         Yields all known listen sockets.
         """
 
-        if self.sock:
-            yield self.sock
-
-
-class PortPidState(object):
-    """
-    A helper class for :py:class:`ServersPerPortStrategy` to track listen
-    sockets and PIDs for each port.
-
-    :param int servers_per_port: The configured number of servers per port.
-    :param logger: The server's :py:class:`~swift.common.utils.LogAdaptor`
-    """
-
-    def __init__(self, servers_per_port, logger):
-        self.servers_per_port = servers_per_port
-        self.logger = logger
-        self.sock_data_by_port = {}
-
-    def sock_for_port(self, port):
-        """
-        :param int port: The port whose socket is desired.
-        :returns: The bound listen socket for the given port.
-        """
-
-        return self.sock_data_by_port[port]['sock']
-
-    def port_for_sock(self, sock):
-        """
-        :param socket sock: A tracked bound listen socket
-        :returns: The port the socket is bound to.
-        """
-
-        for port, sock_data in self.sock_data_by_port.items():
-            if sock_data['sock'] == sock:
-                return port
-
-    def _pid_to_port_and_index(self, pid):
-        for port, sock_data in self.sock_data_by_port.items():
-            for server_idx, a_pid in enumerate(sock_data['pids']):
-                if pid == a_pid:
-                    return port, server_idx
-
-    def port_index_pairs(self):
-        """
-        Returns current (port, server index) pairs.
-
-        :returns: A set of (port, server_idx) tuples for currently-tracked
-            ports, sockets, and PIDs.
-        """
-
-        current_port_index_pairs = set()
-        for port, pid_state in self.sock_data_by_port.items():
-            current_port_index_pairs |= set(
-                (port, i)
-                for i, pid in enumerate(pid_state['pids'])
-                if pid is not None)
-        return current_port_index_pairs
-
-    def track_port(self, port, sock):
-        """
-        Start tracking servers for the given port and listen socket.
-
-        :param int port: The port to start tracking
-        :param socket sock: The bound listen socket for the port.
-        """
-
-        self.sock_data_by_port[port] = {
-            'sock': sock,
-            'pids': [None] * self.servers_per_port,
-        }
-
-    def not_tracking(self, port):
-        """
-        Return True if the specified port is not being tracked.
-
-        :param int port: A port to check.
-        """
-
-        return port not in self.sock_data_by_port
-
-    def all_socks(self):
-        """
-        Yield all current listen sockets.
-        """
-
-        for orphan_data in self.sock_data_by_port.values():
-            yield orphan_data['sock']
-
-    def forget_port(self, port):
-        """
-        Idempotently forget a port, closing the listen socket at most once.
-        """
-
-        orphan_data = self.sock_data_by_port.pop(port, None)
-        if orphan_data:
-            greenio.shutdown_safe(orphan_data['sock'])
-            orphan_data['sock'].close()
-            self.logger.notice('Closing unnecessary sock for port %d', port)
-
-    def add_pid(self, port, index, pid):
-        self.sock_data_by_port[port]['pids'][index] = pid
-
-    def forget_pid(self, pid):
-        """
-        Idempotently forget a PID.  It's okay if the PID is no longer in our
-        data structure (it could have been removed by the "orphan port" removal
-        in :py:meth:`new_worker_socks`).
-
-        :param int pid: The PID which exited.
-        """
-
-        port_server_idx = self._pid_to_port_and_index(pid)
-        if port_server_idx is None:
-            # This method can lose a race with the "orphan port" removal, when
-            # a ring reload no longer contains a port.  So it's okay if we were
-            # unable to find a (port, server_idx) pair.
-            return
-        dead_port, server_idx = port_server_idx
-        self.logger.error('Removing dead child %d (PID: %s) for port %s',
-                          server_idx, pid, dead_port)
-        self.sock_data_by_port[dead_port]['pids'][server_idx] = None
+        for sock in self.tracking_data.values():
+            yield sock
 
 
 class ServersPerPortStrategy(StrategyBase):
@@ -975,6 +875,8 @@ class ServersPerPortStrategy(StrategyBas
     `servers_per_port` integer config setting determines how many workers are
     run per port.
 
+    Tracking data is a map like ``port -> [(pid, socket), ...]``.
+
     Used in :py:func:`run_wsgi`.
 
     :param dict conf: Server configuration dictionary.
@@ -984,12 +886,10 @@ class ServersPerPortStrategy(StrategyBas
     """
 
     def __init__(self, conf, logger, servers_per_port):
-        self.conf = conf
-        self.logger = logger
+        super(ServersPerPortStrategy, self).__init__(conf, logger)
         self.servers_per_port = servers_per_port
         self.swift_dir = conf.get('swift_dir', '/etc/swift')
         self.ring_check_interval = int(conf.get('ring_check_interval', 15))
-        self.port_pid_state = PortPidState(servers_per_port, logger)
 
         bind_ip = conf.get('bind_ip', '0.0.0.0')
         self.cache = BindPortsCache(self.swift_dir, bind_ip)
@@ -1000,8 +900,7 @@ class ServersPerPortStrategy(StrategyBas
     def _bind_port(self, port):
         new_conf = self.conf.copy()
         new_conf['bind_port'] = port
-        sock = get_socket(new_conf)
-        self.port_pid_state.track_port(port, sock)
+        return get_socket(new_conf)
 
     def loop_timeout(self):
         """
@@ -1013,15 +912,6 @@ class ServersPerPortStrategy(StrategyBas
 
         return self.ring_check_interval
 
-    def do_bind_ports(self):
-        """
-        Bind one listen socket per unique local storage policy ring port.
-        """
-
-        self._reload_bind_ports()
-        for port in self.bind_ports:
-            self._bind_port(port)
-
     def no_fork_sock(self):
         """
         This strategy does not support running in the foreground.
@@ -1031,8 +921,8 @@ class ServersPerPortStrategy(StrategyBas
 
     def new_worker_socks(self):
         """
-        Yield a sequence of (socket, server_idx) tuples for each server which
-        should be forked-off and started.
+        Yield a sequence of (socket, (port, server_idx)) tuples for each server
+        which should be forked-off and started.
 
         Any sockets for "orphaned" ports no longer in any ring will be closed
         (causing their associated workers to gracefully exit) after all new
@@ -1043,11 +933,15 @@ class ServersPerPortStrategy(StrategyBas
         """
 
         self._reload_bind_ports()
-        desired_port_index_pairs = set(
+        desired_port_index_pairs = {
             (p, i) for p in self.bind_ports
-            for i in range(self.servers_per_port))
+            for i in range(self.servers_per_port)}
 
-        current_port_index_pairs = self.port_pid_state.port_index_pairs()
+        current_port_index_pairs = {
+            (p, i)
+            for p, port_data in self.tracking_data.items()
+            for i, (pid, sock) in enumerate(port_data)
+            if pid is not None}
 
         if desired_port_index_pairs != current_port_index_pairs:
             # Orphan ports are ports which had object-server processes running,
@@ -1056,36 +950,44 @@ class ServersPerPortStrategy(StrategyBas
             orphan_port_index_pairs = current_port_index_pairs - \
                 desired_port_index_pairs
 
-            # Fork off worker(s) for every port who's supposed to have
+            # Fork off worker(s) for every port that's supposed to have
             # worker(s) but doesn't
             missing_port_index_pairs = desired_port_index_pairs - \
                 current_port_index_pairs
             for port, server_idx in sorted(missing_port_index_pairs):
-                if self.port_pid_state.not_tracking(port):
-                    try:
-                        self._bind_port(port)
-                    except Exception as e:
-                        self.logger.critical('Unable to bind to port %d: %s',
-                                             port, e)
-                        continue
-                yield self.port_pid_state.sock_for_port(port), server_idx
+                try:
+                    sock = self._bind_port(port)
+                except Exception as e:
+                    self.logger.critical('Unable to bind to port %d: %s',
+                                         port, e)
+                    continue
+                yield sock, (port, server_idx)
 
-            for orphan_pair in orphan_port_index_pairs:
+            for port, idx in orphan_port_index_pairs:
                 # For any port in orphan_port_index_pairs, it is guaranteed
                 # that there should be no listen socket for that port, so we
                 # can close and forget them.
-                self.port_pid_state.forget_port(orphan_pair[0])
+                pid, sock = self.tracking_data[port][idx]
+                greenio.shutdown_safe(sock)
+                sock.close()
+                self.logger.notice(
+                    'Closing unnecessary sock for port %d (child pid %d)',
+                    port, pid)
+                self.tracking_data[port][idx] = (None, None)
+                if all(sock is None
+                       for _pid, sock in self.tracking_data[port]):
+                    del self.tracking_data[port]
 
-    def log_sock_exit(self, sock, server_idx):
+    def log_sock_exit(self, sock, data):
         """
         Log a server's exit.
         """
 
-        port = self.port_pid_state.port_for_sock(sock)
+        port, server_idx = data
         self.logger.notice('Child %d (PID %d, port %d) exiting normally',
                            server_idx, os.getpid(), port)
 
-    def register_worker_start(self, sock, server_idx, pid):
+    def register_worker_start(self, sock, data, pid):
         """
         Called when a new worker is started.
 
@@ -1095,10 +997,12 @@ class ServersPerPortStrategy(StrategyBas
         :param int pid: The new worker process' PID
         """
 
-        port = self.port_pid_state.port_for_sock(sock)
+        port, server_idx = data
         self.logger.notice('Started child %d (PID %d) for port %d',
                            server_idx, pid, port)
-        self.port_pid_state.add_pid(port, server_idx, pid)
+        if port not in self.tracking_data:
+            self.tracking_data[port] = [(None, None)] * self.servers_per_port
+        self.tracking_data[port][server_idx] = (pid, sock)
 
     def register_worker_exit(self, pid):
         """
@@ -1107,15 +1011,22 @@ class ServersPerPortStrategy(StrategyBas
         :param int pid: The PID of the worker that exited.
         """
 
-        self.port_pid_state.forget_pid(pid)
+        for port_data in self.tracking_data.values():
+            for idx, (child_pid, sock) in enumerate(port_data):
+                if child_pid == pid:
+                    port_data[idx] = (None, None)
+                    greenio.shutdown_safe(sock)
+                    sock.close()
+                    return
 
     def iter_sockets(self):
         """
         Yields all known listen sockets.
         """
 
-        for sock in self.port_pid_state.all_socks():
-            yield sock
+        for port_data in self.tracking_data.values():
+            for _pid, sock in port_data:
+                yield sock
 
 
 def run_wsgi(conf_path, app_section, *args, **kwargs):
@@ -1150,6 +1061,15 @@ def run_wsgi(conf_path, app_section, *ar
             conf, logger, servers_per_port=servers_per_port)
     else:
         strategy = WorkersStrategy(conf, logger)
+        try:
+            # Quick sanity check
+            int(conf['bind_port'])
+        except (ValueError, KeyError, TypeError):
+            error_msg = 'bind_port wasn\'t properly set in the config file. ' \
+                'It must be explicitly set to a valid port number.'
+            logger.error(error_msg)
+            print(error_msg)
+            return 1
 
     # patch event before loadapp
     utils.eventlet_monkey_patch()
@@ -1164,35 +1084,14 @@ def run_wsgi(conf_path, app_section, *ar
     utils.FALLOCATE_RESERVE, utils.FALLOCATE_IS_PERCENT = \
         utils.config_fallocate_value(conf.get('fallocate_reserve', '1%'))
 
-    # Start listening on bind_addr/port
-    error_msg = strategy.do_bind_ports()
-    if error_msg:
-        logger.error(error_msg)
-        print(error_msg)
-        return 1
-
     # Do some daemonization process hygene before we fork any children or run a
     # server without forking.
     clean_up_daemon_hygiene()
 
-    # Redirect errors to logger and close stdio. Do this *after* binding ports;
-    # we use this to signal that the service is ready to accept connections.
-    capture_stdio(logger)
-
-    # If necessary, signal an old copy of us that it's okay to shutdown its
-    # listen sockets now because ours are up and ready to receive connections.
-    reexec_signal_fd = os.getenv(NOTIFY_FD_ENV_KEY)
-    if reexec_signal_fd:
-        reexec_signal_fd = int(reexec_signal_fd)
-        os.write(reexec_signal_fd, str(os.getpid()).encode('utf8'))
-        os.close(reexec_signal_fd)
-
-    # Finally, signal systemd (if appropriate) that process started properly.
-    systemd_notify(logger=logger)
-
     no_fork_sock = strategy.no_fork_sock()
     if no_fork_sock:
-        run_server(conf, logger, no_fork_sock, global_conf=global_conf)
+        run_server(conf, logger, no_fork_sock, global_conf=global_conf,
+                   ready_callback=strategy.signal_ready)
         return 0
 
     def stop_with_signal(signum, *args):
@@ -1208,17 +1107,42 @@ def run_wsgi(conf_path, app_section, *ar
 
     while running_context[0]:
         for sock, sock_info in strategy.new_worker_socks():
+            read_fd, write_fd = os.pipe()
             pid = os.fork()
             if pid == 0:
-                signal.signal(signal.SIGHUP, signal.SIG_DFL)
+                os.close(read_fd)
                 signal.signal(signal.SIGTERM, signal.SIG_DFL)
-                signal.signal(signal.SIGUSR1, signal.SIG_DFL)
+
+                def shutdown_my_listen_sock(signum, *args):
+                    greenio.shutdown_safe(sock)
+
+                signal.signal(signal.SIGHUP, shutdown_my_listen_sock)
+                signal.signal(signal.SIGUSR1, shutdown_my_listen_sock)
                 strategy.post_fork_hook()
-                run_server(conf, logger, sock)
+
+                def notify():
+                    os.write(write_fd, b'ready')
+                    os.close(write_fd)
+
+                run_server(conf, logger, sock, ready_callback=notify)
                 strategy.log_sock_exit(sock, sock_info)
                 return 0
             else:
-                strategy.register_worker_start(sock, sock_info, pid)
+                os.close(write_fd)
+                worker_status = os.read(read_fd, 30)
+                os.close(read_fd)
+                # TODO: delay this status checking until after we've tried
+                # to start all workers. But, we currently use the register
+                # event to know when we've got enough workers :-/
+                if worker_status == b'ready':
+                    strategy.register_worker_start(sock, sock_info, pid)
+                else:
+                    raise Exception(
+                        'worker did not start normally: %r' % worker_status)
+
+        # TODO: signal_ready() as soon as we have at least one new worker for
+        # each port, instead of waiting for all of them
+        strategy.signal_ready()
 
         # The strategy may need to pay attention to something in addition to
         # child process exits (like new ports showing up in a ring).
diff -pruN 2.25.0-3/swift/container/backend.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/container/backend.py
--- 2.25.0-3/swift/container/backend.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/container/backend.py	2020-09-15 21:13:36.000000000 +0000
@@ -34,9 +34,7 @@ from swift.common.utils import Timestamp
     get_db_files, parse_db_filename, make_db_file_path, split_path, \
     RESERVED_BYTE
 from swift.common.db import DatabaseBroker, utf8encode, BROKER_TIMEOUT, \
-    zero_like, DatabaseAlreadyExists
-
-SQLITE_ARG_LIMIT = 999
+    zero_like, DatabaseAlreadyExists, SQLITE_ARG_LIMIT
 
 DATADIR = 'containers'
 
@@ -62,7 +60,7 @@ SHARD_UPDATE_STATES = [ShardRange.CREATE
 # tuples and vice-versa
 SHARD_RANGE_KEYS = ('name', 'timestamp', 'lower', 'upper', 'object_count',
                     'bytes_used', 'meta_timestamp', 'deleted', 'state',
-                    'state_timestamp', 'epoch')
+                    'state_timestamp', 'epoch', 'reported')
 
 POLICY_STAT_TABLE_CREATE = '''
     CREATE TABLE policy_stat (
@@ -269,6 +267,7 @@ def merge_shards(shard_data, existing):
     if existing['timestamp'] < shard_data['timestamp']:
         # note that currently we do not roll forward any meta or state from
         # an item that was created at older time, newer created time trumps
+        shard_data['reported'] = 0  # reset the latch
         return True
     elif existing['timestamp'] > shard_data['timestamp']:
         return False
@@ -285,6 +284,18 @@ def merge_shards(shard_data, existing):
     else:
         new_content = True
 
+    # We can latch the reported flag
+    if existing['reported'] and \
+            existing['object_count'] == shard_data['object_count'] and \
+            existing['bytes_used'] == shard_data['bytes_used'] and \
+            existing['state'] == shard_data['state'] and \
+            existing['epoch'] == shard_data['epoch']:
+        shard_data['reported'] = 1
+    else:
+        shard_data.setdefault('reported', 0)
+        if shard_data['reported'] and not existing['reported']:
+            new_content = True
+
     if (existing['state_timestamp'] == shard_data['state_timestamp']
             and shard_data['state'] > existing['state']):
         new_content = True
@@ -597,7 +608,8 @@ class ContainerBroker(DatabaseBroker):
                 deleted INTEGER DEFAULT 0,
                 state INTEGER,
                 state_timestamp TEXT,
-                epoch TEXT
+                epoch TEXT,
+                reported INTEGER DEFAULT 0
             );
         """ % SHARD_RANGE_TABLE)
 
@@ -1430,10 +1442,13 @@ class ContainerBroker(DatabaseBroker):
                 #   sqlite3.OperationalError: cannot start a transaction
                 #   within a transaction
                 conn.rollback()
-                if ('no such table: %s' % SHARD_RANGE_TABLE) not in str(err):
-                    raise
-                self.create_shard_range_table(conn)
-                return _really_merge_items(conn)
+                if 'no such column: reported' in str(err):
+                    self._migrate_add_shard_range_reported(conn)
+                    return _really_merge_items(conn)
+                if ('no such table: %s' % SHARD_RANGE_TABLE) in str(err):
+                    self.create_shard_range_table(conn)
+                    return _really_merge_items(conn)
+                raise
 
     def get_reconciler_sync(self):
         with self.get() as conn:
@@ -1581,9 +1596,20 @@ class ContainerBroker(DatabaseBroker):
             CONTAINER_STAT_VIEW_SCRIPT +
             'COMMIT;')
 
-    def _reclaim(self, conn, age_timestamp, sync_timestamp):
-        super(ContainerBroker, self)._reclaim(conn, age_timestamp,
-                                              sync_timestamp)
+    def _migrate_add_shard_range_reported(self, conn):
+        """
+        Add the reported column to the 'shard_range' table.
+        """
+        conn.executescript('''
+            BEGIN;
+            ALTER TABLE %s
+            ADD COLUMN reported INTEGER DEFAULT 0;
+            COMMIT;
+        ''' % SHARD_RANGE_TABLE)
+
+    def _reclaim_other_stuff(self, conn, age_timestamp, sync_timestamp):
+        super(ContainerBroker, self)._reclaim_other_stuff(
+            conn, age_timestamp, sync_timestamp)
         # populate instance cache, but use existing conn to avoid deadlock
         # when it has a pending update
         self._populate_instance_cache(conn=conn)
@@ -1630,7 +1656,7 @@ class ContainerBroker(DatabaseBroker):
         elif states is not None:
             included_states.add(states)
 
-        def do_query(conn):
+        def do_query(conn, use_reported_column=True):
             condition = ''
             conditions = []
             params = []
@@ -1648,21 +1674,27 @@ class ContainerBroker(DatabaseBroker):
                 params.append(self.path)
             if conditions:
                 condition = ' WHERE ' + ' AND '.join(conditions)
+            if use_reported_column:
+                columns = SHARD_RANGE_KEYS
+            else:
+                columns = SHARD_RANGE_KEYS[:-1] + ('0 as reported', )
             sql = '''
             SELECT %s
             FROM %s%s;
-            ''' % (', '.join(SHARD_RANGE_KEYS), SHARD_RANGE_TABLE, condition)
+            ''' % (', '.join(columns), SHARD_RANGE_TABLE, condition)
             data = conn.execute(sql, params)
             data.row_factory = None
             return [row for row in data]
 
-        try:
-            with self.maybe_get(connection) as conn:
+        with self.maybe_get(connection) as conn:
+            try:
                 return do_query(conn)
-        except sqlite3.OperationalError as err:
-            if ('no such table: %s' % SHARD_RANGE_TABLE) not in str(err):
+            except sqlite3.OperationalError as err:
+                if ('no such table: %s' % SHARD_RANGE_TABLE) in str(err):
+                    return []
+                if 'no such column: reported' in str(err):
+                    return do_query(conn, use_reported_column=False)
                 raise
-            return []
 
     @classmethod
     def resolve_shard_range_states(cls, states):
@@ -1745,7 +1777,8 @@ class ContainerBroker(DatabaseBroker):
                 exclude_others=exclude_others)]
         # note if this ever changes to *not* sort by upper first then it breaks
         # a key assumption for bisect, which is used by utils.find_shard_ranges
-        shard_ranges.sort(key=lambda sr: (sr.upper, sr.state, sr.lower))
+        shard_ranges.sort(key=lambda sr: (
+            sr.upper, sr.state, sr.lower, sr.name))
         if includes:
             shard_range = find_shard_range(includes, shard_ranges)
             return [shard_range] if shard_range else []
@@ -2029,6 +2062,21 @@ class ContainerBroker(DatabaseBroker):
         else:
             return {k: v[0] for k, v in info.items()}
 
+    def _get_root_meta(self):
+        """
+        Get the (unquoted) root path, plus the header the info came from.
+        If no info available, returns ``(None, None)``
+        """
+        path = self.get_sharding_sysmeta('Quoted-Root')
+        if path:
+            return 'X-Container-Sysmeta-Shard-Quoted-Root', unquote(path)
+
+        path = self.get_sharding_sysmeta('Root')
+        if path:
+            return 'X-Container-Sysmeta-Shard-Root', path
+
+        return None, None
+
     def _load_root_info(self):
         """
         Load the root container name and account for the container represented
@@ -2041,13 +2089,7 @@ class ContainerBroker(DatabaseBroker):
         ``container`` attributes respectively.
 
         """
-        path = self.get_sharding_sysmeta('Quoted-Root')
-        hdr = 'X-Container-Sysmeta-Shard-Quoted-Root'
-        if path:
-            path = unquote(path)
-        else:
-            path = self.get_sharding_sysmeta('Root')
-            hdr = 'X-Container-Sysmeta-Shard-Root'
+        hdr, path = self._get_root_meta()
 
         if not path:
             # Ensure account/container get populated
@@ -2086,9 +2128,25 @@ class ContainerBroker(DatabaseBroker):
         A root container is a container that is not a shard of another
         container.
         """
-        self._populate_instance_cache()
-        return (self.root_account == self.account and
-                self.root_container == self.container)
+        _, path = self._get_root_meta()
+        if path is not None:
+            # We have metadata telling us where the root is; it's authoritative
+            return self.path == path
+
+        # Else, we're either a root or a deleted shard.
+
+        # Use internal method so we don't try to update stats.
+        own_shard_range = self._own_shard_range(no_default=True)
+        if not own_shard_range:
+            return True  # Never been sharded
+
+        if own_shard_range.deleted:
+            # When shard ranges shrink, they get marked deleted
+            return False
+        else:
+            # But even when a root collapses, empties, and gets deleted, its
+            # own_shard_range is left alive
+            return True
 
     def _get_next_shard_range_upper(self, shard_size, last_upper=None):
         """
diff -pruN 2.25.0-3/swift/container/reconciler.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/container/reconciler.py
--- 2.25.0-3/swift/container/reconciler.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/container/reconciler.py	2020-09-15 21:13:36.000000000 +0000
@@ -27,11 +27,12 @@ from swift.common.direct_client import (
     direct_head_container, direct_delete_container_object,
     direct_put_container_object, ClientException)
 from swift.common.internal_client import InternalClient, UnexpectedResponse
+from swift.common.request_helpers import MISPLACED_OBJECTS_ACCOUNT, \
+    USE_REPLICATION_NETWORK_HEADER
 from swift.common.utils import get_logger, split_path, majority_size, \
     FileLikeIter, Timestamp, last_modified_date_to_timestamp, \
     LRUCache, decode_timestamps
 
-MISPLACED_OBJECTS_ACCOUNT = '.misplaced_objects'
 MISPLACED_OBJECTS_CONTAINER_DIVISOR = 3600  # 1 hour
 CONTAINER_POLICY_TTL = 30
 
@@ -224,6 +225,7 @@ def add_to_reconciler_queue(container_ri
         'X-Etag': obj_timestamp,
         'X-Timestamp': x_timestamp,
         'X-Content-Type': q_op_type,
+        USE_REPLICATION_NETWORK_HEADER: 'true',
     }
 
     def _check_success(*args, **kwargs):
@@ -307,7 +309,8 @@ def direct_get_container_policy_index(co
     """
     def _eat_client_exception(*args):
         try:
-            return direct_head_container(*args)
+            return direct_head_container(*args, headers={
+                USE_REPLICATION_NETWORK_HEADER: 'true'})
         except ClientException as err:
             if err.http_status == 404:
                 return err.http_headers
@@ -333,6 +336,10 @@ def direct_delete_container_entry(contai
     object listing. Does not talk to object servers; use this only when a
     container entry does not actually have a corresponding object.
     """
+    if headers is None:
+        headers = {}
+    headers[USE_REPLICATION_NETWORK_HEADER] = 'true'
+
     pool = GreenPool()
     part, nodes = container_ring.get_nodes(account_name, container_name)
     for node in nodes:
@@ -360,9 +367,11 @@ class ContainerReconciler(Daemon):
             '/etc/swift/container-reconciler.conf'
         self.logger = get_logger(conf, log_route='container-reconciler')
         request_tries = int(conf.get('request_tries') or 3)
-        self.swift = InternalClient(conf_path,
-                                    'Swift Container Reconciler',
-                                    request_tries)
+        self.swift = InternalClient(
+            conf_path,
+            'Swift Container Reconciler',
+            request_tries,
+            use_replication_network=True)
         self.stats = defaultdict(int)
         self.last_stat_time = time.time()
 
diff -pruN 2.25.0-3/swift/container/server.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/container/server.py
--- 2.25.0-3/swift/container/server.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/container/server.py	2020-09-15 21:13:36.000000000 +0000
@@ -155,6 +155,8 @@ class ContainerController(BaseStorageSer
                 conf['auto_create_account_prefix']
         else:
             self.auto_create_account_prefix = AUTO_CREATE_ACCOUNT_PREFIX
+        self.shards_account_prefix = (
+            self.auto_create_account_prefix + 'shards_')
         if config_true_value(conf.get('allow_versions', 'f')):
             self.save_headers.append('x-versions-location')
         if 'allow_versions' in conf:
@@ -375,14 +377,12 @@ class ContainerController(BaseStorageSer
         # auto create accounts)
         obj_policy_index = self.get_and_validate_policy_index(req) or 0
         broker = self._get_container_broker(drive, part, account, container)
-        if account.startswith(self.auto_create_account_prefix) and obj and \
-                not os.path.exists(broker.db_file):
-            try:
-                broker.initialize(req_timestamp.internal, obj_policy_index)
-            except DatabaseAlreadyExists:
-                pass
-        if not os.path.exists(broker.db_file):
+        if obj:
+            self._maybe_autocreate(broker, req_timestamp, account,
+                                   obj_policy_index, req)
+        elif not os.path.exists(broker.db_file):
             return HTTPNotFound()
+
         if obj:     # delete object
             # redirect if a shard range exists for the object name
             redirect = self._redirect_to_shard(req, broker, obj)
@@ -449,11 +449,25 @@ class ContainerController(BaseStorageSer
             broker.update_status_changed_at(timestamp)
         return recreated
 
+    def _should_autocreate(self, account, req):
+        auto_create_header = req.headers.get('X-Backend-Auto-Create')
+        if auto_create_header:
+            # If the caller included an explicit X-Backend-Auto-Create header,
+            # assume they know the behavior they want
+            return config_true_value(auto_create_header)
+        if account.startswith(self.shards_account_prefix):
+            # we have to specical case this subset of the
+            # auto_create_account_prefix because we don't want the updater
+            # accidently auto-creating shards; only the sharder creates
+            # shards and it will explicitly tell the server to do so
+            return False
+        return account.startswith(self.auto_create_account_prefix)
+
     def _maybe_autocreate(self, broker, req_timestamp, account,
-                          policy_index):
+                          policy_index, req):
         created = False
-        if account.startswith(self.auto_create_account_prefix) and \
-                not os.path.exists(broker.db_file):
+        should_autocreate = self._should_autocreate(account, req)
+        if should_autocreate and not os.path.exists(broker.db_file):
             if policy_index is None:
                 raise HTTPBadRequest(
                     'X-Backend-Storage-Policy-Index header is required')
@@ -506,8 +520,8 @@ class ContainerController(BaseStorageSer
             # obj put expects the policy_index header, default is for
             # legacy support during upgrade.
             obj_policy_index = requested_policy_index or 0
-            self._maybe_autocreate(broker, req_timestamp, account,
-                                   obj_policy_index)
+            self._maybe_autocreate(
+                broker, req_timestamp, account, obj_policy_index, req)
             # redirect if a shard exists for this object name
             response = self._redirect_to_shard(req, broker, obj)
             if response:
@@ -531,8 +545,8 @@ class ContainerController(BaseStorageSer
                                 for sr in json.loads(req.body)]
             except (ValueError, KeyError, TypeError) as err:
                 return HTTPBadRequest('Invalid body: %r' % err)
-            created = self._maybe_autocreate(broker, req_timestamp, account,
-                                             requested_policy_index)
+            created = self._maybe_autocreate(
+                broker, req_timestamp, account, requested_policy_index, req)
             self._update_metadata(req, broker, req_timestamp, 'PUT')
             if shard_ranges:
                 # TODO: consider writing the shard ranges into the pending
@@ -805,7 +819,7 @@ class ContainerController(BaseStorageSer
         requested_policy_index = self.get_and_validate_policy_index(req)
         broker = self._get_container_broker(drive, part, account, container)
         self._maybe_autocreate(broker, req_timestamp, account,
-                               requested_policy_index)
+                               requested_policy_index, req)
         try:
             objs = json.load(req.environ['wsgi.input'])
         except ValueError as err:
diff -pruN 2.25.0-3/swift/container/sharder.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/container/sharder.py
--- 2.25.0-3/swift/container/sharder.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/container/sharder.py	2020-09-15 21:13:36.000000000 +0000
@@ -29,6 +29,7 @@ from swift.common.constraints import che
 from swift.common.direct_client import (direct_put_container,
                                         DirectClientException)
 from swift.common.exceptions import DeviceUnavailable
+from swift.common.request_helpers import USE_REPLICATION_NETWORK_HEADER
 from swift.common.ring.utils import is_local_device
 from swift.common.swob import str_to_wsgi
 from swift.common.utils import get_logger, config_true_value, \
@@ -409,7 +410,8 @@ class ContainerSharder(ContainerReplicat
                 internal_client_conf_path,
                 'Swift Container Sharder',
                 request_tries,
-                allow_modify_pipeline=False)
+                allow_modify_pipeline=False,
+                use_replication_network=True)
         except (OSError, IOError) as err:
             if err.errno != errno.ENOENT and \
                     not str(err).endswith(' not found'):
@@ -618,10 +620,12 @@ class ContainerSharder(ContainerReplicat
 
     def _send_shard_ranges(self, account, container, shard_ranges,
                            headers=None):
-        body = json.dumps([dict(sr) for sr in shard_ranges]).encode('ascii')
+        body = json.dumps([dict(sr, reported=0)
+                           for sr in shard_ranges]).encode('ascii')
         part, nodes = self.ring.get_nodes(account, container)
         headers = headers or {}
         headers.update({'X-Backend-Record-Type': RECORD_TYPE_SHARD,
+                        USE_REPLICATION_NETWORK_HEADER: 'True',
                         'User-Agent': 'container-sharder %s' % os.getpid(),
                         'X-Timestamp': Timestamp.now().normal,
                         'Content-Length': len(body),
@@ -745,8 +749,9 @@ class ContainerSharder(ContainerReplicat
                     # root may not yet know about this shard container
                     warnings.append('root has no matching shard range')
                     shard_range = None
-            else:
+            elif not own_shard_range.deleted:
                 warnings.append('unable to get shard ranges from root')
+            # else, our shard range is deleted, so root may have reclaimed it
         else:
             errors.append('missing own shard range')
 
@@ -766,14 +771,16 @@ class ContainerSharder(ContainerReplicat
             self.logger.debug('Updating shard from root %s', dict(shard_range))
             broker.merge_shard_ranges(shard_range)
             own_shard_range = broker.get_own_shard_range()
-            delete_age = time.time() - self.reclaim_age
-            if (own_shard_range.state == ShardRange.SHARDED and
-                    own_shard_range.deleted and
-                    own_shard_range.timestamp < delete_age and
-                    broker.empty()):
-                broker.delete_db(Timestamp.now().internal)
-                self.logger.debug('Deleted shard container %s (%s)',
-                                  broker.db_file, quote(broker.path))
+
+        delete_age = time.time() - self.reclaim_age
+        if (own_shard_range.state == ShardRange.SHARDED and
+                own_shard_range.deleted and
+                own_shard_range.timestamp < delete_age and
+                broker.empty()):
+            broker.delete_db(Timestamp.now().internal)
+            self.logger.debug('Deleted shard container %s (%s)',
+                              broker.db_file, quote(broker.path))
+
         self._increment_stat('audit_shard', 'success', statsd=True)
         return True
 
@@ -1148,7 +1155,8 @@ class ContainerSharder(ContainerReplicat
                 'X-Backend-Storage-Policy-Index': broker.storage_policy_index,
                 'X-Container-Sysmeta-Shard-Quoted-Root': quote(
                     broker.root_path),
-                'X-Container-Sysmeta-Sharding': True}
+                'X-Container-Sysmeta-Sharding': 'True',
+                'X-Backend-Auto-Create': 'True'}
             # NB: we *used* to send along
             #    'X-Container-Sysmeta-Shard-Root': broker.root_path
             # but that isn't safe for container names with nulls or newlines
@@ -1468,7 +1476,7 @@ class ContainerSharder(ContainerReplicat
 
     def _update_root_container(self, broker):
         own_shard_range = broker.get_own_shard_range(no_default=True)
-        if not own_shard_range:
+        if not own_shard_range or own_shard_range.reported:
             return
 
         # persist the reported shard metadata
@@ -1478,9 +1486,12 @@ class ContainerSharder(ContainerReplicat
             include_own=True,
             include_deleted=True)
         # send everything
-        self._send_shard_ranges(
-            broker.root_account, broker.root_container,
-            shard_ranges)
+        if self._send_shard_ranges(
+                broker.root_account, broker.root_container, shard_ranges):
+            # on success, mark ourselves as reported so we don't keep
+            # hammering the root
+            own_shard_range.reported = True
+            broker.merge_shard_ranges(own_shard_range)
 
     def _process_broker(self, broker, node, part):
         broker.get_info()  # make sure account/container are populated
diff -pruN 2.25.0-3/swift/container/sync.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/container/sync.py
--- 2.25.0-3/swift/container/sync.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/container/sync.py	2020-09-15 21:13:36.000000000 +0000
@@ -241,7 +241,8 @@ class ContainerSync(Daemon):
             internal_client_conf = internal_client_conf_path
         try:
             self.swift = InternalClient(
-                internal_client_conf, 'Swift Container Sync', request_tries)
+                internal_client_conf, 'Swift Container Sync', request_tries,
+                use_replication_network=True)
         except (OSError, IOError) as err:
             if err.errno != errno.ENOENT and \
                     not str(err).endswith(' not found'):
@@ -619,8 +620,8 @@ class ContainerSync(Daemon):
                     if exc:
                         raise exc
                     raise Exception(
-                        _('Unknown exception trying to GET: '
-                          '%(account)r %(container)r %(object)r'),
+                        'Unknown exception trying to GET: '
+                        '%(account)r %(container)r %(object)r' %
                         {'account': info['account'],
                          'container': info['container'],
                          'object': row['name']})
diff -pruN 2.25.0-3/swift/__init__.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/__init__.py
--- 2.25.0-3/swift/__init__.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/__init__.py	2020-09-15 21:13:36.000000000 +0000
@@ -16,6 +16,7 @@
 import os
 import sys
 import gettext
+import warnings
 
 import pkg_resources
 
@@ -74,3 +75,9 @@ if (3, 0) <= sys.version_info[:2] <= (3,
 
         json.loads = JsonLoadsPatcher(json.loads)
         del JsonLoadsPatcher
+
+
+warnings.filterwarnings('ignore', module='cryptography', message=(
+    'Python 2 is no longer supported by the Python core team. '
+    'Support for it is now deprecated in cryptography, '
+    'and will be removed in a future release.'))
diff -pruN 2.25.0-3/swift/locale/de/LC_MESSAGES/swift.po 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/locale/de/LC_MESSAGES/swift.po
--- 2.25.0-3/swift/locale/de/LC_MESSAGES/swift.po	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/locale/de/LC_MESSAGES/swift.po	2020-09-15 21:13:36.000000000 +0000
@@ -8,15 +8,16 @@
 # Jonas John <jonas.john@e-werkzeug.eu>, 2015
 # Andreas Jaeger <jaegerandi@gmail.com>, 2016. #zanata
 # Andreas Jaeger <jaegerandi@gmail.com>, 2019. #zanata
+# Andreas Jaeger <jaegerandi@gmail.com>, 2020. #zanata
 msgid ""
 msgstr ""
 "Project-Id-Version: swift VERSION\n"
 "Report-Msgid-Bugs-To: https://bugs.launchpad.net/openstack-i18n/\n"
-"POT-Creation-Date: 2020-04-10 12:00+0000\n"
+"POT-Creation-Date: 2020-04-24 07:01+0000\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"PO-Revision-Date: 2019-10-03 06:49+0000\n"
+"PO-Revision-Date: 2020-04-25 11:39+0000\n"
 "Last-Translator: Andreas Jaeger <jaegerandi@gmail.com>\n"
 "Language: de\n"
 "Plural-Forms: nplurals=2; plural=(n != 1);\n"
@@ -846,6 +847,10 @@ msgstr ""
 "Partitionszeiten: max. %(max).4fs, min. %(min).4fs, durchschnittl. %(med).4fs"
 
 #, python-format
+msgid "Pass completed in %(time)ds; %(objects)d objects expired"
+msgstr "Durchgänge abgeschlossen in %(time)ds; %(objects)d Objekte abgelaufen"
+
+#, python-format
 msgid "Pass so far %(time)ds; %(objects)d objects expired"
 msgstr "Bisherige Durchgänge %(time)ds; %(objects)d Objekte abgelaufen"
 
diff -pruN 2.25.0-3/swift/obj/diskfile.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/obj/diskfile.py
--- 2.25.0-3/swift/obj/diskfile.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/obj/diskfile.py	2020-09-15 21:13:36.000000000 +0000
@@ -3031,7 +3031,8 @@ class ECDiskFileReader(BaseDiskFileReade
 
 class ECDiskFileWriter(BaseDiskFileWriter):
 
-    def _finalize_durable(self, data_file_path, durable_data_file_path):
+    def _finalize_durable(self, data_file_path, durable_data_file_path,
+                          timestamp):
         exc = None
         new_data_file_path = new_durable_data_file_path = None
         if self.next_part_power:
@@ -3055,6 +3056,21 @@ class ECDiskFileWriter(BaseDiskFileWrite
                             exc)
 
             except (OSError, IOError) as err:
+                if err.errno == errno.ENOENT:
+                    files = os.listdir(self._datadir)
+                    results = self.manager.get_ondisk_files(
+                        files, self._datadir,
+                        frag_index=self._diskfile._frag_index,
+                        policy=self._diskfile.policy)
+                    # We "succeeded" if another writer cleaned up our data
+                    ts_info = results.get('ts_info')
+                    durables = results.get('durable_frag_set', [])
+                    if ts_info and ts_info['timestamp'] > timestamp:
+                        return
+                    elif any(frag_set['timestamp'] > timestamp
+                             for frag_set in durables):
+                        return
+
                 if err.errno not in (errno.ENOSPC, errno.EDQUOT):
                     # re-raise to catch all handler
                     raise
@@ -3102,7 +3118,8 @@ class ECDiskFileWriter(BaseDiskFileWrite
             self._datadir, self.manager.make_on_disk_filename(
                 timestamp, '.data', self._diskfile._frag_index, durable=True))
         tpool.execute(
-            self._finalize_durable, data_file_path, durable_data_file_path)
+            self._finalize_durable, data_file_path, durable_data_file_path,
+            timestamp)
 
     def put(self, metadata):
         """
diff -pruN 2.25.0-3/swift/obj/expirer.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/obj/expirer.py
--- 2.25.0-3/swift/obj/expirer.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/obj/expirer.py	2020-09-15 21:13:36.000000000 +0000
@@ -134,7 +134,8 @@ class ObjectExpirer(Daemon):
 
         request_tries = int(self.conf.get('request_tries') or 3)
         self.swift = swift or InternalClient(
-            self.ic_conf_path, 'Swift Object Expirer', request_tries)
+            self.ic_conf_path, 'Swift Object Expirer', request_tries,
+            use_replication_network=True)
 
         self.processes = int(self.conf.get('processes', 0))
         self.process = int(self.conf.get('process', 0))
diff -pruN 2.25.0-3/swift/obj/replicator.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/obj/replicator.py
--- 2.25.0-3/swift/obj/replicator.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/obj/replicator.py	2020-09-15 21:13:36.000000000 +0000
@@ -687,6 +687,9 @@ class ObjectReplicator(Daemon):
                     suffixes = [suffix for suffix in local_hash if
                                 local_hash[suffix] !=
                                 remote_hash.get(suffix, -1)]
+                    if not suffixes:
+                        stats.hashmatch += 1
+                        continue
                     stats.rsync += 1
                     success, _junk = self.sync(node, job, suffixes)
                     with Timeout(self.http_timeout):
diff -pruN 2.25.0-3/swift/obj/updater.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/obj/updater.py
--- 2.25.0-3/swift/obj/updater.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/obj/updater.py	2020-09-15 21:13:36.000000000 +0000
@@ -14,12 +14,13 @@
 # limitations under the License.
 
 import six.moves.cPickle as pickle
+import errno
 import os
 import signal
 import sys
 import time
 from swift import gettext_ as _
-from random import random
+from random import random, shuffle
 
 from eventlet import spawn, Timeout
 
@@ -230,7 +231,9 @@ class ObjectUpdater(Daemon):
                                       'to a valid policy (%(error)s)') % {
                                     'directory': asyncdir, 'error': e})
                 continue
-            for prefix in self._listdir(async_pending):
+            prefix_dirs = self._listdir(async_pending)
+            shuffle(prefix_dirs)
+            for prefix in prefix_dirs:
                 prefix_path = os.path.join(async_pending, prefix)
                 if not os.path.isdir(prefix_path):
                     continue
@@ -271,7 +274,11 @@ class ObjectUpdater(Daemon):
                     if obj_hash == last_obj_hash:
                         self.stats.unlinks += 1
                         self.logger.increment('unlinks')
-                        os.unlink(update_path)
+                        try:
+                            os.unlink(update_path)
+                        except OSError as e:
+                            if e.errno != errno.ENOENT:
+                                raise
                     else:
                         last_obj_hash = obj_hash
                         yield {'device': device, 'policy': policy,
diff -pruN 2.25.0-3/swift/proxy/controllers/account.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/proxy/controllers/account.py
--- 2.25.0-3/swift/proxy/controllers/account.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/proxy/controllers/account.py	2020-09-15 21:13:36.000000000 +0000
@@ -64,7 +64,7 @@ class AccountController(Controller):
 
         partition = self.app.account_ring.get_part(self.account_name)
         concurrency = self.app.account_ring.replica_count \
-            if self.app.concurrent_gets else 1
+            if self.app.get_policy_options(None).concurrent_gets else 1
         node_iter = self.app.iter_nodes(self.app.account_ring, partition)
         params = req.params
         params['format'] = 'json'
diff -pruN 2.25.0-3/swift/proxy/controllers/base.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/proxy/controllers/base.py
--- 2.25.0-3/swift/proxy/controllers/base.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/proxy/controllers/base.py	2020-09-15 21:13:36.000000000 +0000
@@ -45,7 +45,8 @@ from swift.common.wsgi import make_pre_a
 from swift.common.utils import Timestamp, WatchdogTimeout, config_true_value, \
     public, split_path, list_from_csv, GreenthreadSafeIterator, \
     GreenAsyncPile, quorum_size, parse_content_type, drain_and_close, \
-    document_iters_to_http_response_body, ShardRange, find_shard_range
+    document_iters_to_http_response_body, ShardRange, find_shard_range, \
+    cache_from_env
 from swift.common.bufferedhttp import http_connect
 from swift.common import constraints
 from swift.common.exceptions import ChunkReadTimeout, ChunkWriteTimeout, \
@@ -62,7 +63,7 @@ from swift.common.swob import Request, R
 from swift.common.request_helpers import strip_sys_meta_prefix, \
     strip_user_meta_prefix, is_user_meta, is_sys_meta, is_sys_or_user_meta, \
     http_response_to_document_iters, is_object_transient_sysmeta, \
-    strip_object_transient_sysmeta_prefix
+    strip_object_transient_sysmeta_prefix, get_ip_port
 from swift.common.storage_policy import POLICIES
 
 
@@ -539,31 +540,29 @@ def set_info_cache(app, env, account, co
     :returns: the info that was placed into the cache, or None if the
               request status was not in (404, 410, 2xx).
     """
+    cache_key = get_cache_key(account, container)
     infocache = env.setdefault('swift.infocache', {})
+    memcache = cache_from_env(env, True)
+    if resp is None:
+        infocache.pop(cache_key, None)
+        if memcache:
+            memcache.delete(cache_key)
+        return
 
-    cache_time = None
-    if container and resp:
+    if container:
         cache_time = int(resp.headers.get(
             'X-Backend-Recheck-Container-Existence',
             DEFAULT_RECHECK_CONTAINER_EXISTENCE))
-    elif resp:
+    else:
         cache_time = int(resp.headers.get(
             'X-Backend-Recheck-Account-Existence',
             DEFAULT_RECHECK_ACCOUNT_EXISTENCE))
-    cache_key = get_cache_key(account, container)
 
-    if resp:
-        if resp.status_int in (HTTP_NOT_FOUND, HTTP_GONE):
-            cache_time *= 0.1
-        elif not is_success(resp.status_int):
-            cache_time = None
-
-    # Next actually set both memcache and the env cache
-    memcache = getattr(app, 'memcache', None) or env.get('swift.cache')
-    if cache_time is None:
-        infocache.pop(cache_key, None)
-        if memcache:
-            memcache.delete(cache_key)
+    if resp.status_int in (HTTP_NOT_FOUND, HTTP_GONE):
+        cache_time *= 0.1
+    elif not is_success(resp.status_int):
+        # If we got a response, it was unsuccessful, and it wasn't an
+        # "authoritative" failure, bail without touching caches.
         return
 
     if container:
@@ -646,7 +645,7 @@ def _get_info_from_memcache(app, env, ac
       returns None if memcache is not in use.
     """
     cache_key = get_cache_key(account, container)
-    memcache = getattr(app, 'memcache', None) or env.get('swift.cache')
+    memcache = cache_from_env(env, True)
     if memcache:
         info = memcache.get(cache_key)
         if info and six.PY2:
@@ -855,10 +854,10 @@ class ByteCountEnforcer(object):
             return chunk
 
 
-class ResumingGetter(object):
+class GetOrHeadHandler(object):
     def __init__(self, app, req, server_type, node_iter, partition, path,
-                 backend_headers, concurrency=1, client_chunk_size=None,
-                 newest=None, header_provider=None):
+                 backend_headers, concurrency=1, policy=None,
+                 client_chunk_size=None, newest=None):
         self.app = app
         self.node_iter = node_iter
         self.server_type = server_type
@@ -871,9 +870,13 @@ class ResumingGetter(object):
         self.used_nodes = []
         self.used_source_etag = ''
         self.concurrency = concurrency
+        self.policy = policy
         self.node = None
-        self.header_provider = header_provider
         self.latest_404_timestamp = Timestamp(0)
+        policy_options = self.app.get_policy_options(self.policy)
+        self.rebalance_missing_suppression_count = min(
+            policy_options.rebalance_missing_suppression_count,
+            node_iter.num_primary_nodes - 1)
 
         # stuff from request
         self.req_method = req.method
@@ -1012,13 +1015,6 @@ class ResumingGetter(object):
             return True
         return is_success(src.status) or is_redirection(src.status)
 
-    def response_parts_iter(self, req):
-        source, node = self._get_source_and_node()
-        it = None
-        if source:
-            it = self._get_response_parts_iter(req, node, source)
-        return it
-
     def _get_response_parts_iter(self, req, node, source):
         # Someday we can replace this [mess] with python 3's "nonlocal"
         source = [source]
@@ -1262,14 +1258,12 @@ class ResumingGetter(object):
         if node in self.used_nodes:
             return False
         req_headers = dict(self.backend_headers)
-        # a request may be specialised with specific backend headers
-        if self.header_provider:
-            req_headers.update(self.header_provider())
+        ip, port = get_ip_port(node, req_headers)
         start_node_timing = time.time()
         try:
             with ConnectionTimeout(self.app.conn_timeout):
                 conn = http_connect(
-                    node['ip'], node['port'], node['device'],
+                    ip, port, node['device'],
                     self.partition, self.req_method, self.path,
                     headers=req_headers,
                     query_string=self.req_query_string)
@@ -1299,9 +1293,8 @@ class ResumingGetter(object):
                 close_swift_conn(possible_source)
             else:
                 if self.used_source_etag and \
-                    self.used_source_etag != normalize_etag(src_headers.get(
-                        'x-object-sysmeta-ec-etag',
-                        src_headers.get('etag', ''))):
+                        self.used_source_etag != normalize_etag(
+                            src_headers.get('etag', '')):
                     self.statuses.append(HTTP_NOT_FOUND)
                     self.reasons.append('')
                     self.bodies.append('')
@@ -1331,6 +1324,13 @@ class ResumingGetter(object):
                 # throw out 5XX and 404s from handoff nodes unless the data is
                 # really on disk and had been DELETEd
                 return False
+
+            if self.rebalance_missing_suppression_count > 0 and \
+                    possible_source.status == HTTP_NOT_FOUND and \
+                    not Timestamp(src_headers.get('x-backend-timestamp', 0)):
+                self.rebalance_missing_suppression_count -= 1
+                return False
+
             self.statuses.append(possible_source.status)
             self.reasons.append(possible_source.reason)
             self.bodies.append(possible_source.read())
@@ -1375,7 +1375,8 @@ class ResumingGetter(object):
         for node in nodes:
             pile.spawn(self._make_node_request, node, node_timeout,
                        self.app.logger.thread_locals)
-            _timeout = self.app.concurrency_timeout \
+            _timeout = self.app.get_policy_options(
+                self.policy).concurrency_timeout \
                 if pile.inflight < self.concurrency else None
             if pile.waitfirst(_timeout):
                 break
@@ -1401,18 +1402,14 @@ class ResumingGetter(object):
 
             # Save off the source etag so that, if we lose the connection
             # and have to resume from a different node, we can be sure that
-            # we have the same object (replication) or a fragment archive
-            # from the same object (EC). Otherwise, if the cluster has two
-            # versions of the same object, we might end up switching between
-            # old and new mid-stream and giving garbage to the client.
-            self.used_source_etag = normalize_etag(src_headers.get(
-                'x-object-sysmeta-ec-etag', src_headers.get('etag', '')))
+            # we have the same object (replication). Otherwise, if the cluster
+            # has two versions of the same object, we might end up switching
+            # between old and new mid-stream and giving garbage to the client.
+            self.used_source_etag = normalize_etag(src_headers.get('etag', ''))
             self.node = node
             return source, node
         return None, None
 
-
-class GetOrHeadHandler(ResumingGetter):
     def _make_app_iter(self, req, node, source):
         """
         Returns an iterator over the contents of the source (via its read
@@ -1504,18 +1501,22 @@ class NodeIter(object):
         if node_iter is None:
             node_iter = itertools.chain(
                 part_nodes, ring.get_more_nodes(partition))
-        num_primary_nodes = len(part_nodes)
-        self.nodes_left = self.app.request_node_count(num_primary_nodes)
-        self.expected_handoffs = self.nodes_left - num_primary_nodes
+        self.num_primary_nodes = len(part_nodes)
+        self.nodes_left = self.app.request_node_count(self.num_primary_nodes)
+        self.expected_handoffs = self.nodes_left - self.num_primary_nodes
 
         # Use of list() here forcibly yanks the first N nodes (the primary
         # nodes) from node_iter, so the rest of its values are handoffs.
         self.primary_nodes = self.app.sort_nodes(
-            list(itertools.islice(node_iter, num_primary_nodes)),
+            list(itertools.islice(node_iter, self.num_primary_nodes)),
             policy=policy)
         self.handoff_iter = node_iter
         self._node_provider = None
 
+    @property
+    def primaries_left(self):
+        return len(self.primary_nodes)
+
     def __iter__(self):
         self._node_iter = self._node_gen()
         return self
@@ -1539,7 +1540,7 @@ class NodeIter(object):
             self.app.logger.increment('handoff_count')
             self.app.logger.warning(
                 'Handoff requested (%d)' % handoffs)
-            if (extra_handoffs == len(self.primary_nodes)):
+            if (extra_handoffs == self.num_primary_nodes):
                 # all the primaries were skipped, and handoffs didn't help
                 self.app.logger.increment('handoff_all_count')
 
@@ -1555,7 +1556,8 @@ class NodeIter(object):
         self._node_provider = callback
 
     def _node_gen(self):
-        for node in self.primary_nodes:
+        while self.primary_nodes:
+            node = self.primary_nodes.pop(0)
             if not self.app.error_limited(node):
                 yield node
                 if not self.app.error_limited(node):
@@ -1679,12 +1681,12 @@ class Controller(object):
         headers['referer'] = referer
         return headers
 
-    def account_info(self, account, req=None):
+    def account_info(self, account, req):
         """
         Get account information, and also verify that the account exists.
 
         :param account: native str name of the account to get the info for
-        :param req: caller's HTTP request context object (optional)
+        :param req: caller's HTTP request context object
         :returns: tuple of (account partition, account nodes, container_count)
                   or (None, None, None) if it does not exist
         """
@@ -1705,14 +1707,14 @@ class Controller(object):
         partition, nodes = self.app.account_ring.get_nodes(account)
         return partition, nodes, container_count
 
-    def container_info(self, account, container, req=None):
+    def container_info(self, account, container, req):
         """
         Get container information and thusly verify container existence.
         This will also verify account existence.
 
         :param account: native-str account name for the container
         :param container: native-str container name to look up
-        :param req: caller's HTTP request context object (optional)
+        :param req: caller's HTTP request context object
         :returns: dict containing at least container partition ('partition'),
                   container nodes ('containers'), container read
                   acl ('read_acl'), container write acl ('write_acl'),
@@ -1767,11 +1769,12 @@ class Controller(object):
             headers['Content-Length'] = str(len(body))
         for node in nodes:
             try:
+                ip, port = get_ip_port(node, headers)
                 start_node_timing = time.time()
                 with ConnectionTimeout(self.app.conn_timeout):
-                    conn = http_connect(node['ip'], node['port'],
-                                        node['device'], part, method, path,
-                                        headers=headers, query_string=query)
+                    conn = http_connect(
+                        ip, port, node['device'], part, method, path,
+                        headers=headers, query_string=query)
                     conn.node = node
                 self.app.set_node_timing(node, time.time() - start_node_timing)
                 if body:
@@ -2008,7 +2011,7 @@ class Controller(object):
             return False
 
     def GETorHEAD_base(self, req, server_type, node_iter, partition, path,
-                       concurrency=1, client_chunk_size=None):
+                       concurrency=1, policy=None, client_chunk_size=None):
         """
         Base handler for HTTP GET or HEAD requests.
 
@@ -2018,6 +2021,7 @@ class Controller(object):
         :param partition: partition
         :param path: path for the request
         :param concurrency: number of requests to run concurrently
+        :param policy: the policy instance, or None if Account or Container
         :param client_chunk_size: chunk size for response body iterator
         :returns: swob.Response object
         """
@@ -2026,7 +2030,7 @@ class Controller(object):
 
         handler = GetOrHeadHandler(self.app, req, self.server_type, node_iter,
                                    partition, path, backend_headers,
-                                   concurrency,
+                                   concurrency, policy=policy,
                                    client_chunk_size=client_chunk_size)
         res = handler.get_working_response(req)
 
@@ -2269,8 +2273,7 @@ class Controller(object):
 
         cache_key = get_cache_key(account, container, shard='updating')
         infocache = req.environ.setdefault('swift.infocache', {})
-        memcache = getattr(self.app, 'memcache', None) or req.environ.get(
-            'swift.cache')
+        memcache = cache_from_env(req.environ, True)
 
         cached_ranges = infocache.get(cache_key)
         if cached_ranges is None and memcache:
diff -pruN 2.25.0-3/swift/proxy/controllers/container.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/proxy/controllers/container.py
--- 2.25.0-3/swift/proxy/controllers/container.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/proxy/controllers/container.py	2020-09-15 21:13:36.000000000 +0000
@@ -105,7 +105,7 @@ class ContainerController(Controller):
         part = self.app.container_ring.get_part(
             self.account_name, self.container_name)
         concurrency = self.app.container_ring.replica_count \
-            if self.app.concurrent_gets else 1
+            if self.app.get_policy_options(None).concurrent_gets else 1
         node_iter = self.app.iter_nodes(self.app.container_ring, part)
         params = req.params
         params['format'] = 'json'
diff -pruN 2.25.0-3/swift/proxy/controllers/obj.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/proxy/controllers/obj.py
--- 2.25.0-3/swift/proxy/controllers/obj.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/proxy/controllers/obj.py	2020-09-15 21:13:36.000000000 +0000
@@ -24,6 +24,7 @@
 #   These shenanigans are to ensure all related objects can be garbage
 # collected. We've seen objects hang around forever otherwise.
 
+import six
 from six.moves.urllib.parse import quote, unquote
 from six.moves import zip
 
@@ -35,13 +36,14 @@ import time
 import math
 import random
 from hashlib import md5
-from swift import gettext_ as _
+import sys
 
 from greenlet import GreenletExit
 from eventlet import GreenPile, sleep
-from eventlet.queue import Queue
+from eventlet.queue import Queue, Empty
 from eventlet.timeout import Timeout
 
+from swift import gettext_ as _
 from swift.common.utils import (
     clean_content_type, config_true_value, ContextPool, csv_append,
     GreenAsyncPile, GreenthreadSafeIterator, Timestamp, WatchdogTimeout,
@@ -54,18 +56,19 @@ from swift.common import constraints
 from swift.common.exceptions import ChunkReadTimeout, \
     ChunkWriteTimeout, ConnectionTimeout, ResponseTimeout, \
     InsufficientStorage, FooterNotSupported, MultiphasePUTNotSupported, \
-    PutterConnectError, ChunkReadError
+    PutterConnectError, ChunkReadError, RangeAlreadyComplete, ShortReadError
 from swift.common.header_key_dict import HeaderKeyDict
 from swift.common.http import (
     is_informational, is_success, is_client_error, is_server_error,
     is_redirection, HTTP_CONTINUE, HTTP_INTERNAL_SERVER_ERROR,
     HTTP_SERVICE_UNAVAILABLE, HTTP_INSUFFICIENT_STORAGE,
     HTTP_PRECONDITION_FAILED, HTTP_CONFLICT, HTTP_UNPROCESSABLE_ENTITY,
-    HTTP_REQUESTED_RANGE_NOT_SATISFIABLE)
+    HTTP_REQUESTED_RANGE_NOT_SATISFIABLE, HTTP_NOT_FOUND)
 from swift.common.storage_policy import (POLICIES, REPL_POLICY, EC_POLICY,
                                          ECDriverError, PolicyError)
 from swift.proxy.controllers.base import Controller, delay_denial, \
-    cors_validation, ResumingGetter, update_headers
+    cors_validation, update_headers, bytes_to_skip, close_swift_conn, \
+    ByteCountEnforcer
 from swift.common.swob import HTTPAccepted, HTTPBadRequest, HTTPNotFound, \
     HTTPPreconditionFailed, HTTPRequestEntityTooLarge, HTTPRequestTimeout, \
     HTTPServerError, HTTPServiceUnavailable, HTTPClientDisconnect, \
@@ -73,7 +76,8 @@ from swift.common.swob import HTTPAccept
     HTTPRequestedRangeNotSatisfiable, Range, HTTPInternalServerError, \
     normalize_etag
 from swift.common.request_helpers import update_etag_is_at_header, \
-    resolve_etag_is_at_header, validate_internal_obj
+    resolve_etag_is_at_header, validate_internal_obj, get_ip_port, \
+    http_response_to_document_iters
 
 
 def check_content_type(req):
@@ -860,10 +864,10 @@ class ReplicatedObjectController(BaseObj
 
     def _get_or_head_response(self, req, node_iter, partition, policy):
         concurrency = self.app.get_object_ring(policy.idx).replica_count \
-            if self.app.concurrent_gets else 1
+            if self.app.get_policy_options(policy).concurrent_gets else 1
         resp = self.GETorHEAD_base(
             req, _('Object'), node_iter, partition,
-            req.swift_entity_path, concurrency)
+            req.swift_entity_path, concurrency, policy)
         return resp
 
     def _make_putter(self, node, part, req, headers):
@@ -927,7 +931,6 @@ class ReplicatedObjectController(BaseObj
 
             ml = req.message_length()
             if ml and bytes_transferred < ml:
-                req.client_disconnect = True
                 self.app.logger.warning(
                     _('Client disconnected without sending enough data'))
                 self.app.logger.increment('client_disconnects')
@@ -950,7 +953,6 @@ class ReplicatedObjectController(BaseObj
         except HTTPException:
             raise
         except ChunkReadError:
-            req.client_disconnect = True
             self.app.logger.warning(
                 _('Client disconnected without sending last chunk'))
             self.app.logger.increment('client_disconnects')
@@ -1396,7 +1398,7 @@ class ECAppIter(object):
                 # killed by contextpool
                 pass
             except ChunkReadTimeout:
-                # unable to resume in GetOrHeadHandler
+                # unable to resume in ECFragGetter
                 self.logger.exception(_("Timeout fetching fragments for %r"),
                                       quote(self.path))
             except:  # noqa
@@ -1683,9 +1685,10 @@ class Putter(object):
     @classmethod
     def _make_connection(cls, node, part, path, headers, conn_timeout,
                          node_timeout):
+        ip, port = get_ip_port(node, headers)
         start_time = time.time()
         with ConnectionTimeout(conn_timeout):
-            conn = http_connect(node['ip'], node['port'], node['device'],
+            conn = http_connect(ip, port, node['device'],
                                 part, 'PUT', path, headers)
         connect_duration = time.time() - start_time
 
@@ -1979,13 +1982,13 @@ class ECGetResponseBucket(object):
     A helper class to encapsulate the properties of buckets in which fragment
     getters and alternate nodes are collected.
     """
-    def __init__(self, policy, timestamp_str):
+    def __init__(self, policy, timestamp):
         """
         :param policy: an instance of ECStoragePolicy
-        :param timestamp_str: a string representation of a timestamp
+        :param timestamp: a Timestamp, or None for a bucket of error reponses
         """
         self.policy = policy
-        self.timestamp_str = timestamp_str
+        self.timestamp = timestamp
         self.gets = collections.defaultdict(list)
         self.alt_nodes = collections.defaultdict(list)
         self._durable = False
@@ -1999,10 +2002,20 @@ class ECGetResponseBucket(object):
         return self._durable
 
     def add_response(self, getter, parts_iter):
+        """
+        Add another response to this bucket.  Response buckets can be for
+        fragments with the same timestamp, or for errors with the same status.
+        """
+        headers = getter.last_headers
+        timestamp_str = headers.get('X-Backend-Timestamp',
+                                    headers.get('X-Timestamp'))
+        if timestamp_str:
+            # 404s will keep the most recent timestamp
+            self.timestamp = max(Timestamp(timestamp_str), self.timestamp)
         if not self.gets:
-            self.status = getter.last_status
             # stash first set of backend headers, which will be used to
             # populate a client response
+            self.status = getter.last_status
             # TODO: each bucket is for a single *data* timestamp, but sources
             # in the same bucket may have different *metadata* timestamps if
             # some backends have more recent .meta files than others. Currently
@@ -2012,18 +2025,17 @@ class ECGetResponseBucket(object):
             # recent metadata. We could alternatively choose to the *newest*
             # metadata headers for self.headers by selecting the source with
             # the latest X-Timestamp.
-            self.headers = getter.last_headers
-        elif (self.timestamp_str is not None and  # ie, not bad_bucket
-              getter.last_headers.get('X-Object-Sysmeta-Ec-Etag') !=
-              self.headers.get('X-Object-Sysmeta-Ec-Etag')):
+            self.headers = headers
+        elif headers.get('X-Object-Sysmeta-Ec-Etag') != \
+                self.headers.get('X-Object-Sysmeta-Ec-Etag'):
             # Fragments at the same timestamp with different etags are never
-            # expected. If somehow it happens then ignore those fragments
-            # to avoid mixing fragments that will not reconstruct otherwise
-            # an exception from pyeclib is almost certain. This strategy leaves
-            # a possibility that a set of consistent frags will be gathered.
+            # expected and error buckets shouldn't have this header. If somehow
+            # this happens then ignore those responses to avoid mixing
+            # fragments that will not reconstruct otherwise an exception from
+            # pyeclib is almost certain.
             raise ValueError("ETag mismatch")
 
-        frag_index = getter.last_headers.get('X-Object-Sysmeta-Ec-Frag-Index')
+        frag_index = headers.get('X-Object-Sysmeta-Ec-Frag-Index')
         frag_index = int(frag_index) if frag_index is not None else None
         self.gets[frag_index].append((getter, parts_iter))
 
@@ -2033,7 +2045,7 @@ class ECGetResponseBucket(object):
         associated with the same frag_index then only one is included.
 
         :return: a list of sources, each source being a tuple of form
-                (ResumingGetter, iter)
+                (ECFragGetter, iter)
         """
         all_sources = []
         for frag_index, sources in self.gets.items():
@@ -2051,8 +2063,19 @@ class ECGetResponseBucket(object):
 
     @property
     def shortfall(self):
-        result = self.policy.ec_ndata - len(self.get_responses())
-        return max(result, 0)
+        """
+        The number of additional responses needed to complete this bucket;
+        typically (ndata - resp_count).
+
+        If the bucket has no durable responses, shortfall is extended out to
+        replica count to ensure the proxy makes additional primary requests.
+        """
+        resp_count = len(self.get_responses())
+        if self.durable or self.status == HTTP_REQUESTED_RANGE_NOT_SATISFIABLE:
+            return max(self.policy.ec_ndata - resp_count, 0)
+        alt_count = min(self.policy.object_ring.replica_count - resp_count,
+                        self.policy.ec_nparity)
+        return max([1, self.policy.ec_ndata - resp_count, alt_count])
 
     @property
     def shortfall_with_alts(self):
@@ -2062,16 +2085,24 @@ class ECGetResponseBucket(object):
         result = self.policy.ec_ndata - (len(self.get_responses()) + len(alts))
         return max(result, 0)
 
+    def close_conns(self):
+        """
+        Close bucket's responses; they won't be used for a client response.
+        """
+        for getter, frag_iter in self.get_responses():
+            if getattr(getter.source, 'swift_conn', None):
+                close_swift_conn(getter.source)
+
     def __str__(self):
         # return a string summarising bucket state, useful for debugging.
         return '<%s, %s, %s, %s(%s), %s>' \
-               % (self.timestamp_str, self.status, self._durable,
+               % (self.timestamp.internal, self.status, self._durable,
                   self.shortfall, self.shortfall_with_alts, len(self.gets))
 
 
 class ECGetResponseCollection(object):
     """
-    Manages all successful EC GET responses gathered by ResumingGetters.
+    Manages all successful EC GET responses gathered by ECFragGetters.
 
     A response comprises a tuple of (<getter instance>, <parts iterator>). All
     responses having the same data timestamp are placed in an
@@ -2087,33 +2118,60 @@ class ECGetResponseCollection(object):
         """
         self.policy = policy
         self.buckets = {}
+        self.bad_buckets = {None: ECGetResponseBucket(self.policy, None)}
         self.node_iter_count = 0
 
-    def _get_bucket(self, timestamp_str):
+    def _get_bucket(self, timestamp):
         """
-        :param timestamp_str: a string representation of a timestamp
+        :param timestamp: a Timestamp
         :return: ECGetResponseBucket for given timestamp
         """
         return self.buckets.setdefault(
-            timestamp_str, ECGetResponseBucket(self.policy, timestamp_str))
+            timestamp, ECGetResponseBucket(self.policy, timestamp))
+
+    def _get_bad_bucket(self, status):
+        """
+        :param status: a representation of status
+        :return: ECGetResponseBucket for given status
+        """
+        return self.bad_buckets.setdefault(
+            status, ECGetResponseBucket(self.policy, None))
 
     def add_response(self, get, parts_iter):
         """
         Add a response to the collection.
 
         :param get: An instance of
-                    :class:`~swift.proxy.controllers.base.ResumingGetter`
+                    :class:`~swift.proxy.controllers.obj.ECFragGetter`
         :param parts_iter: An iterator over response body parts
         :raises ValueError: if the response etag or status code values do not
             match any values previously received for the same timestamp
         """
+        if is_success(get.last_status):
+            self.add_good_response(get, parts_iter)
+        else:
+            self.add_bad_resp(get, parts_iter)
+
+    def add_bad_resp(self, get, parts_iter):
+        bad_bucket = self._get_bad_bucket(get.last_status)
+        bad_bucket.add_response(get, parts_iter)
+
+    def add_good_response(self, get, parts_iter):
         headers = get.last_headers
         # Add the response to the appropriate bucket keyed by data file
         # timestamp. Fall back to using X-Backend-Timestamp as key for object
         # servers that have not been upgraded.
         t_data_file = headers.get('X-Backend-Data-Timestamp')
         t_obj = headers.get('X-Backend-Timestamp', headers.get('X-Timestamp'))
-        self._get_bucket(t_data_file or t_obj).add_response(get, parts_iter)
+        if t_data_file:
+            timestamp = Timestamp(t_data_file)
+        elif t_obj:
+            timestamp = Timestamp(t_obj)
+        else:
+            # Don't think this should ever come up in practice,
+            # but tests cover it
+            timestamp = None
+        self._get_bucket(timestamp).add_response(get, parts_iter)
 
         # The node may also have alternate fragments indexes (possibly at
         # different timestamps). For each list of alternate fragments indexes,
@@ -2121,6 +2179,7 @@ class ECGetResponseCollection(object):
         # list to that bucket's alternate nodes.
         frag_sets = safe_json_loads(headers.get('X-Backend-Fragments')) or {}
         for t_frag, frag_set in frag_sets.items():
+            t_frag = Timestamp(t_frag)
             self._get_bucket(t_frag).add_alternate_nodes(get.node, frag_set)
         # If the response includes a durable timestamp then mark that bucket as
         # durable. Note that this may be a different bucket than the one this
@@ -2132,7 +2191,7 @@ class ECGetResponseCollection(object):
             # obj server not upgraded so assume this response's frag is durable
             t_durable = t_obj
         if t_durable:
-            self._get_bucket(t_durable).set_durable()
+            self._get_bucket(Timestamp(t_durable)).set_durable()
 
     def _sort_buckets(self):
         def key_fn(bucket):
@@ -2145,35 +2204,74 @@ class ECGetResponseCollection(object):
             return (bucket.durable,
                     bucket.shortfall <= 0,
                     -1 * bucket.shortfall_with_alts,
-                    bucket.timestamp_str)
+                    bucket.timestamp)
 
         return sorted(self.buckets.values(), key=key_fn, reverse=True)
 
     @property
     def best_bucket(self):
         """
-        Return the best bucket in the collection.
+        Return the "best" bucket in the collection.
 
         The "best" bucket is the newest timestamp with sufficient getters, or
         the closest to having sufficient getters, unless it is bettered by a
         bucket with potential alternate nodes.
 
+        If there are no good buckets we return the "least_bad" bucket.
+
         :return: An instance of :class:`~ECGetResponseBucket` or None if there
                  are no buckets in the collection.
         """
         sorted_buckets = self._sort_buckets()
-        if sorted_buckets:
-            return sorted_buckets[0]
-        return None
+        for bucket in sorted_buckets:
+            # tombstones will set bad_bucket.timestamp
+            not_found_bucket = self.bad_buckets.get(404)
+            if not_found_bucket and not_found_bucket.timestamp and \
+                    bucket.timestamp < not_found_bucket.timestamp:
+                # "good bucket" is trumped by newer tombstone
+                continue
+            return bucket
+        return self.least_bad_bucket
+
+    def choose_best_bucket(self):
+        best_bucket = self.best_bucket
+        # it's now or never -- close down any other requests
+        for bucket in self.buckets.values():
+            if bucket is best_bucket:
+                continue
+            bucket.close_conns()
+        return best_bucket
+
+    @property
+    def least_bad_bucket(self):
+        """
+        Return the bad_bucket with the smallest shortfall
+        """
+        # we want "enough" 416s to prevent "extra" requests - but we keep
+        # digging on 404s
+        short, status = min((bucket.shortfall, status)
+                            for status, bucket in self.bad_buckets.items()
+                            if status != 404)
+        return self.bad_buckets[status]
+
+    @property
+    def shortfall(self):
+        best_bucket = self.best_bucket
+        shortfall = best_bucket.shortfall
+        return min(shortfall, self.least_bad_bucket.shortfall)
+
+    @property
+    def durable(self):
+        return self.best_bucket.durable
 
     def _get_frag_prefs(self):
         # Construct the current frag_prefs list, with best_bucket prefs first.
         frag_prefs = []
 
         for bucket in self._sort_buckets():
-            if bucket.timestamp_str:
+            if bucket.timestamp:
                 exclusions = [fi for fi in bucket.gets if fi is not None]
-                prefs = {'timestamp': bucket.timestamp_str,
+                prefs = {'timestamp': bucket.timestamp.internal,
                          'exclude': exclusions}
                 frag_prefs.append(prefs)
 
@@ -2232,6 +2330,468 @@ class ECGetResponseCollection(object):
             return nodes.pop(0).copy()
 
 
+def is_good_source(status):
+    """
+    Indicates whether or not the request made to the backend found
+    what it was looking for.
+
+    :param status: the response from the backend
+    :returns: True if found, False if not
+    """
+    if status == HTTP_REQUESTED_RANGE_NOT_SATISFIABLE:
+        return True
+    return is_success(status) or is_redirection(status)
+
+
+class ECFragGetter(object):
+
+    def __init__(self, app, req, node_iter, partition, policy, path,
+                 backend_headers, header_provider=None):
+        self.app = app
+        self.req = req
+        self.node_iter = node_iter
+        self.partition = partition
+        self.path = path
+        self.backend_headers = backend_headers
+        self.header_provider = header_provider
+        self.req_query_string = req.query_string
+        self.client_chunk_size = policy.fragment_size
+        self.skip_bytes = 0
+        self.bytes_used_from_backend = 0
+        self.source = None
+
+    def fast_forward(self, num_bytes):
+        """
+        Will skip num_bytes into the current ranges.
+
+        :params num_bytes: the number of bytes that have already been read on
+                           this request. This will change the Range header
+                           so that the next req will start where it left off.
+
+        :raises HTTPRequestedRangeNotSatisfiable: if begin + num_bytes
+                                                  > end of range + 1
+        :raises RangeAlreadyComplete: if begin + num_bytes == end of range + 1
+        """
+        try:
+            req_range = Range(self.backend_headers.get('Range'))
+        except ValueError:
+            req_range = None
+
+        if req_range:
+            begin, end = req_range.ranges[0]
+            if begin is None:
+                # this is a -50 range req (last 50 bytes of file)
+                end -= num_bytes
+                if end == 0:
+                    # we sent out exactly the first range's worth of bytes, so
+                    # we're done with it
+                    raise RangeAlreadyComplete()
+
+                if end < 0:
+                    raise HTTPRequestedRangeNotSatisfiable()
+
+            else:
+                begin += num_bytes
+                if end is not None and begin == end + 1:
+                    # we sent out exactly the first range's worth of bytes, so
+                    # we're done with it
+                    raise RangeAlreadyComplete()
+
+                if end is not None and begin > end:
+                    raise HTTPRequestedRangeNotSatisfiable()
+
+            req_range.ranges = [(begin, end)] + req_range.ranges[1:]
+            self.backend_headers['Range'] = str(req_range)
+        else:
+            self.backend_headers['Range'] = 'bytes=%d-' % num_bytes
+
+        # Reset so if we need to do this more than once, we don't double-up
+        self.bytes_used_from_backend = 0
+
+    def pop_range(self):
+        """
+        Remove the first byterange from our Range header.
+
+        This is used after a byterange has been completely sent to the
+        client; this way, should we need to resume the download from another
+        object server, we do not re-fetch byteranges that the client already
+        has.
+
+        If we have no Range header, this is a no-op.
+        """
+        if 'Range' in self.backend_headers:
+            try:
+                req_range = Range(self.backend_headers['Range'])
+            except ValueError:
+                # there's a Range header, but it's garbage, so get rid of it
+                self.backend_headers.pop('Range')
+                return
+            begin, end = req_range.ranges.pop(0)
+            if len(req_range.ranges) > 0:
+                self.backend_headers['Range'] = str(req_range)
+            else:
+                self.backend_headers.pop('Range')
+
+    def learn_size_from_content_range(self, start, end, length):
+        """
+        If client_chunk_size is set, makes sure we yield things starting on
+        chunk boundaries based on the Content-Range header in the response.
+
+        Sets our Range header's first byterange to the value learned from
+        the Content-Range header in the response; if we were given a
+        fully-specified range (e.g. "bytes=123-456"), this is a no-op.
+
+        If we were given a half-specified range (e.g. "bytes=123-" or
+        "bytes=-456"), then this changes the Range header to a
+        semantically-equivalent one *and* it lets us resume on a proper
+        boundary instead of just in the middle of a piece somewhere.
+        """
+        if length == 0:
+            return
+
+        if self.client_chunk_size:
+            self.skip_bytes = bytes_to_skip(self.client_chunk_size, start)
+
+        if 'Range' in self.backend_headers:
+            try:
+                req_range = Range(self.backend_headers['Range'])
+                new_ranges = [(start, end)] + req_range.ranges[1:]
+            except ValueError:
+                new_ranges = [(start, end)]
+        else:
+            new_ranges = [(start, end)]
+
+        self.backend_headers['Range'] = (
+            "bytes=" + (",".join("%s-%s" % (s if s is not None else '',
+                                            e if e is not None else '')
+                                 for s, e in new_ranges)))
+
+    def response_parts_iter(self, req):
+        try:
+            self.source, self.node = next(self.source_and_node_iter)
+        except StopIteration:
+            return
+        it = None
+        if self.source:
+            it = self._get_response_parts_iter(req)
+        return it
+
+    def _get_response_parts_iter(self, req):
+        try:
+            client_chunk_size = self.client_chunk_size
+            node_timeout = self.app.recoverable_node_timeout
+
+            # This is safe; it sets up a generator but does not call next()
+            # on it, so no IO is performed.
+            parts_iter = [
+                http_response_to_document_iters(
+                    self.source, read_chunk_size=self.app.object_chunk_size)]
+
+            def get_next_doc_part():
+                while True:
+                    try:
+                        # This call to next() performs IO when we have a
+                        # multipart/byteranges response; it reads the MIME
+                        # boundary and part headers.
+                        #
+                        # If we don't have a multipart/byteranges response,
+                        # but just a 200 or a single-range 206, then this
+                        # performs no IO, and either just returns source or
+                        # raises StopIteration.
+                        with WatchdogTimeout(self.app.watchdog, node_timeout,
+                                             ChunkReadTimeout):
+                            # if StopIteration is raised, it escapes and is
+                            # handled elsewhere
+                            start_byte, end_byte, length, headers, part = next(
+                                parts_iter[0])
+                        return (start_byte, end_byte, length, headers, part)
+                    except ChunkReadTimeout:
+                        new_source, new_node = self._dig_for_source_and_node()
+                        if new_source:
+                            self.app.error_occurred(
+                                self.node, _('Trying to read object during '
+                                             'GET (retrying)'))
+                            # Close-out the connection as best as possible.
+                            if getattr(self.source, 'swift_conn', None):
+                                close_swift_conn(self.source)
+                            self.source = new_source
+                            self.node = new_node
+                            # This is safe; it sets up a generator but does
+                            # not call next() on it, so no IO is performed.
+                            parts_iter[0] = http_response_to_document_iters(
+                                new_source,
+                                read_chunk_size=self.app.object_chunk_size)
+                        else:
+                            raise StopIteration()
+
+            def iter_bytes_from_response_part(part_file, nbytes):
+                nchunks = 0
+                buf = b''
+                part_file = ByteCountEnforcer(part_file, nbytes)
+                while True:
+                    try:
+                        with WatchdogTimeout(self.app.watchdog, node_timeout,
+                                             ChunkReadTimeout):
+                            chunk = part_file.read(self.app.object_chunk_size)
+                            nchunks += 1
+                            # NB: this append must be *inside* the context
+                            # manager for test.unit.SlowBody to do its thing
+                            buf += chunk
+                            if nbytes is not None:
+                                nbytes -= len(chunk)
+                    except (ChunkReadTimeout, ShortReadError):
+                        exc_type, exc_value, exc_traceback = sys.exc_info()
+                        try:
+                            self.fast_forward(self.bytes_used_from_backend)
+                        except (HTTPException, ValueError):
+                            six.reraise(exc_type, exc_value, exc_traceback)
+                        except RangeAlreadyComplete:
+                            break
+                        buf = b''
+                        new_source, new_node = self._dig_for_source_and_node()
+                        if new_source:
+                            self.app.error_occurred(
+                                self.node, _('Trying to read object during '
+                                             'GET (retrying)'))
+                            # Close-out the connection as best as possible.
+                            if getattr(self.source, 'swift_conn', None):
+                                close_swift_conn(self.source)
+                            self.source = new_source
+                            self.node = new_node
+                            # This is safe; it just sets up a generator but
+                            # does not call next() on it, so no IO is
+                            # performed.
+                            parts_iter[0] = http_response_to_document_iters(
+                                new_source,
+                                read_chunk_size=self.app.object_chunk_size)
+
+                            try:
+                                _junk, _junk, _junk, _junk, part_file = \
+                                    get_next_doc_part()
+                            except StopIteration:
+                                # Tried to find a new node from which to
+                                # finish the GET, but failed. There's
+                                # nothing more we can do here.
+                                six.reraise(exc_type, exc_value, exc_traceback)
+                            part_file = ByteCountEnforcer(part_file, nbytes)
+                        else:
+                            six.reraise(exc_type, exc_value, exc_traceback)
+                    else:
+                        if buf and self.skip_bytes:
+                            if self.skip_bytes < len(buf):
+                                buf = buf[self.skip_bytes:]
+                                self.bytes_used_from_backend += self.skip_bytes
+                                self.skip_bytes = 0
+                            else:
+                                self.skip_bytes -= len(buf)
+                                self.bytes_used_from_backend += len(buf)
+                                buf = b''
+
+                        if not chunk:
+                            if buf:
+                                with WatchdogTimeout(self.app.watchdog,
+                                                     self.app.client_timeout,
+                                                     ChunkWriteTimeout):
+                                    self.bytes_used_from_backend += len(buf)
+                                    yield buf
+                                buf = b''
+                            break
+
+                        if client_chunk_size is not None:
+                            while len(buf) >= client_chunk_size:
+                                client_chunk = buf[:client_chunk_size]
+                                buf = buf[client_chunk_size:]
+                                with WatchdogTimeout(self.app.watchdog,
+                                                     self.app.client_timeout,
+                                                     ChunkWriteTimeout):
+                                    self.bytes_used_from_backend += \
+                                        len(client_chunk)
+                                    yield client_chunk
+                        else:
+                            with WatchdogTimeout(self.app.watchdog,
+                                                 self.app.client_timeout,
+                                                 ChunkWriteTimeout):
+                                self.bytes_used_from_backend += len(buf)
+                                yield buf
+                            buf = b''
+
+                        # This is for fairness; if the network is outpacing
+                        # the CPU, we'll always be able to read and write
+                        # data without encountering an EWOULDBLOCK, and so
+                        # eventlet will not switch greenthreads on its own.
+                        # We do it manually so that clients don't starve.
+                        #
+                        # The number 5 here was chosen by making stuff up.
+                        # It's not every single chunk, but it's not too big
+                        # either, so it seemed like it would probably be an
+                        # okay choice.
+                        #
+                        # Note that we may trampoline to other greenthreads
+                        # more often than once every 5 chunks, depending on
+                        # how blocking our network IO is; the explicit sleep
+                        # here simply provides a lower bound on the rate of
+                        # trampolining.
+                        if nchunks % 5 == 0:
+                            sleep()
+
+            part_iter = None
+            try:
+                while True:
+                    start_byte, end_byte, length, headers, part = \
+                        get_next_doc_part()
+                    # note: learn_size_from_content_range() sets
+                    # self.skip_bytes
+                    self.learn_size_from_content_range(
+                        start_byte, end_byte, length)
+                    self.bytes_used_from_backend = 0
+                    # not length; that refers to the whole object, so is the
+                    # wrong value to use for GET-range responses
+                    byte_count = ((end_byte - start_byte + 1) - self.skip_bytes
+                                  if (end_byte is not None
+                                      and start_byte is not None)
+                                  else None)
+                    part_iter = iter_bytes_from_response_part(part, byte_count)
+                    yield {'start_byte': start_byte, 'end_byte': end_byte,
+                           'entity_length': length, 'headers': headers,
+                           'part_iter': part_iter}
+                    self.pop_range()
+            except StopIteration:
+                req.environ['swift.non_client_disconnect'] = True
+            finally:
+                if part_iter:
+                    part_iter.close()
+
+        except ChunkReadTimeout:
+            self.app.exception_occurred(self.node, _('Object'),
+                                        _('Trying to read during GET'))
+            raise
+        except ChunkWriteTimeout:
+            self.app.logger.warning(
+                _('Client did not read from proxy within %ss') %
+                self.app.client_timeout)
+            self.app.logger.increment('client_timeouts')
+        except GeneratorExit:
+            warn = True
+            req_range = self.backend_headers['Range']
+            if req_range:
+                req_range = Range(req_range)
+                if len(req_range.ranges) == 1:
+                    begin, end = req_range.ranges[0]
+                    if end is not None and begin is not None:
+                        if end - begin + 1 == self.bytes_used_from_backend:
+                            warn = False
+            if not req.environ.get('swift.non_client_disconnect') and warn:
+                self.app.logger.warning('Client disconnected on read of %r',
+                                        self.path)
+            raise
+        except Exception:
+            self.app.logger.exception(_('Trying to send to client'))
+            raise
+        finally:
+            # Close-out the connection as best as possible.
+            if getattr(self.source, 'swift_conn', None):
+                close_swift_conn(self.source)
+
+    @property
+    def last_status(self):
+        return self.status or HTTP_INTERNAL_SERVER_ERROR
+
+    @property
+    def last_headers(self):
+        if self.source_headers:
+            return HeaderKeyDict(self.source_headers)
+        else:
+            return HeaderKeyDict()
+
+    def _make_node_request(self, node, node_timeout, logger_thread_locals):
+        self.app.logger.thread_locals = logger_thread_locals
+        req_headers = dict(self.backend_headers)
+        ip, port = get_ip_port(node, req_headers)
+        req_headers.update(self.header_provider())
+        start_node_timing = time.time()
+        try:
+            with ConnectionTimeout(self.app.conn_timeout):
+                conn = http_connect(
+                    ip, port, node['device'],
+                    self.partition, 'GET', self.path,
+                    headers=req_headers,
+                    query_string=self.req_query_string)
+            self.app.set_node_timing(node, time.time() - start_node_timing)
+
+            with Timeout(node_timeout):
+                possible_source = conn.getresponse()
+                # See NOTE: swift_conn at top of file about this.
+                possible_source.swift_conn = conn
+        except (Exception, Timeout):
+            self.app.exception_occurred(
+                node, 'Object',
+                _('Trying to %(method)s %(path)s') %
+                {'method': self.req.method, 'path': self.req.path})
+            return None
+
+        src_headers = dict(
+            (k.lower(), v) for k, v in
+            possible_source.getheaders())
+
+        if 'handoff_index' in node and \
+                (is_server_error(possible_source.status) or
+                 possible_source.status == HTTP_NOT_FOUND) and \
+                not Timestamp(src_headers.get('x-backend-timestamp', 0)):
+            # throw out 5XX and 404s from handoff nodes unless the data is
+            # really on disk and had been DELETEd
+            conn.close()
+            return None
+
+        self.status = possible_source.status
+        self.reason = possible_source.reason
+        self.source_headers = possible_source.getheaders()
+        if is_good_source(possible_source.status):
+            self.body = None
+            return possible_source
+        else:
+            self.body = possible_source.read()
+            conn.close()
+
+            if possible_source.status == HTTP_INSUFFICIENT_STORAGE:
+                self.app.error_limit(node, _('ERROR Insufficient Storage'))
+            elif is_server_error(possible_source.status):
+                self.app.error_occurred(
+                    node, _('ERROR %(status)d %(body)s '
+                            'From Object Server') %
+                    {'status': possible_source.status,
+                     'body': self.body[:1024]})
+            return None
+
+    @property
+    def source_and_node_iter(self):
+        if not hasattr(self, '_source_and_node_iter'):
+            self._source_and_node_iter = self._source_and_node_gen()
+        return self._source_and_node_iter
+
+    def _source_and_node_gen(self):
+        self.status = self.reason = self.body = self.source_headers = None
+        for node in self.node_iter:
+            source = self._make_node_request(
+                node, self.app.recoverable_node_timeout,
+                self.app.logger.thread_locals)
+
+            if source:
+                self.node = node
+                yield source, node
+            else:
+                yield None, None
+            self.status = self.reason = self.body = self.source_headers = None
+
+    def _dig_for_source_and_node(self):
+        # capture last used etag before continuation
+        used_etag = self.last_headers.get('X-Object-Sysmeta-EC-ETag')
+        for source, node in self.source_and_node_iter:
+            if source and is_good_source(source.status) and \
+                    source.getheader('X-Object-Sysmeta-EC-ETag') == used_etag:
+                return source, node
+        return None, None
+
+
 @ObjectControllerRouter.register(EC_POLICY)
 class ECObjectController(BaseObjectController):
     def _fragment_GET_request(self, req, node_iter, partition, policy,
@@ -2242,11 +2802,9 @@ class ECObjectController(BaseObjectContr
         backend_headers = self.generate_request_headers(
             req, additional=req.headers)
 
-        getter = ResumingGetter(self.app, req, 'Object', node_iter,
-                                partition, req.swift_entity_path,
-                                backend_headers,
-                                client_chunk_size=policy.fragment_size,
-                                newest=False, header_provider=header_provider)
+        getter = ECFragGetter(self.app, req, node_iter, partition,
+                              policy, req.swift_entity_path, backend_headers,
+                              header_provider=header_provider)
         return (getter, getter.response_parts_iter(req))
 
     def _convert_range(self, req, policy):
@@ -2301,6 +2859,26 @@ class ECObjectController(BaseObjectContr
             for s, e in new_ranges)
         return range_specs
 
+    def feed_remaining_primaries(self, safe_iter, pile, req, partition, policy,
+                                 buckets, feeder_q):
+        timeout = self.app.get_policy_options(policy).concurrency_timeout
+        while True:
+            try:
+                feeder_q.get(timeout=timeout)
+            except Empty:
+                if safe_iter.unsafe_iter.primaries_left:
+                    # this will run async, if it ends up taking the last
+                    # primary we won't find out until the next pass
+                    pile.spawn(self._fragment_GET_request,
+                               req, safe_iter, partition,
+                               policy, buckets.get_extra_headers)
+                else:
+                    # ran out of primaries
+                    break
+            else:
+                # got a stop
+                break
+
     def _get_or_head_response(self, req, node_iter, partition, policy):
         update_etag_is_at_header(req, "X-Object-Sysmeta-Ec-Etag")
 
@@ -2308,10 +2886,11 @@ class ECObjectController(BaseObjectContr
             # no fancy EC decoding here, just one plain old HEAD request to
             # one object server because all fragments hold all metadata
             # information about the object.
-            concurrency = policy.ec_ndata if self.app.concurrent_gets else 1
+            concurrency = policy.ec_ndata \
+                if self.app.get_policy_options(policy).concurrent_gets else 1
             resp = self.GETorHEAD_base(
                 req, _('Object'), node_iter, partition,
-                req.swift_entity_path, concurrency)
+                req.swift_entity_path, concurrency, policy)
             self._fix_response(req, resp)
             return resp
 
@@ -2324,27 +2903,25 @@ class ECObjectController(BaseObjectContr
 
         safe_iter = GreenthreadSafeIterator(node_iter)
 
-        # Sending the request concurrently to all nodes, and responding
-        # with the first response isn't something useful for EC as all
-        # nodes contain different fragments. Also EC has implemented it's
-        # own specific implementation of concurrent gets to ec_ndata nodes.
-        # So we don't need to  worry about plumbing and sending a
-        # concurrency value to ResumingGetter.
-        with ContextPool(policy.ec_ndata) as pool:
+        policy_options = self.app.get_policy_options(policy)
+        ec_request_count = policy.ec_ndata + \
+            policy_options.concurrent_ec_extra_requests
+        with ContextPool(ec_request_count) as pool:
             pile = GreenAsyncPile(pool)
             buckets = ECGetResponseCollection(policy)
             node_iter.set_node_provider(buckets.provide_alternate_node)
-            # include what may well be an empty X-Backend-Fragment-Preferences
-            # header from the buckets.get_extra_headers to let the object
-            # server know that it is ok to return non-durable fragments
-            for _junk in range(policy.ec_ndata):
+
+            for node_count in range(ec_request_count):
                 pile.spawn(self._fragment_GET_request,
                            req, safe_iter, partition,
                            policy, buckets.get_extra_headers)
 
-            bad_bucket = ECGetResponseBucket(policy, None)
-            bad_bucket.set_durable()
-            best_bucket = None
+            feeder_q = None
+            if self.app.get_policy_options(policy).concurrent_gets:
+                feeder_q = Queue()
+                pool.spawn(self.feed_remaining_primaries, safe_iter, pile, req,
+                           partition, policy, buckets, feeder_q)
+
             extra_requests = 0
             # max_extra_requests is an arbitrary hard limit for spawning extra
             # getters in case some unforeseen scenario, or a misbehaving object
@@ -2354,52 +2931,33 @@ class ECObjectController(BaseObjectContr
             # be limit at most 2 * replicas.
             max_extra_requests = (
                 (policy.object_ring.replica_count * 2) - policy.ec_ndata)
-
             for get, parts_iter in pile:
-                if get.last_status is None:
-                    # We may have spawned getters that find the node iterator
-                    # has been exhausted. Ignore them.
-                    # TODO: turns out that node_iter.nodes_left can bottom
-                    # out at >0 when number of devs in ring is < 2* replicas,
-                    # which definitely happens in tests and results in status
-                    # of None. We should fix that but keep this guard because
-                    # there is also a race between testing nodes_left/spawning
-                    # a getter and an existing getter calling next(node_iter).
-                    continue
                 try:
-                    if is_success(get.last_status):
-                        # 2xx responses are managed by a response collection
-                        buckets.add_response(get, parts_iter)
-                    else:
-                        # all other responses are lumped into a single bucket
-                        bad_bucket.add_response(get, parts_iter)
+                    buckets.add_response(get, parts_iter)
                 except ValueError as err:
                     self.app.logger.error(
                         _("Problem with fragment response: %s"), err)
-                shortfall = bad_bucket.shortfall
                 best_bucket = buckets.best_bucket
-                if best_bucket:
-                    shortfall = best_bucket.shortfall
-                    if not best_bucket.durable and shortfall <= 0:
-                        # be willing to go a *little* deeper, slowly
-                        shortfall = 1
-                    shortfall = min(shortfall, bad_bucket.shortfall)
-                if (extra_requests < max_extra_requests and
-                        shortfall > pile._pending and
-                        (node_iter.nodes_left > 0 or
-                         buckets.has_alternate_node())):
-                    # we need more matching responses to reach ec_ndata
-                    # than we have pending gets, as long as we still have
-                    # nodes in node_iter we can spawn another
+                if best_bucket.durable and best_bucket.shortfall <= 0:
+                    # good enough!
+                    break
+                requests_available = extra_requests < max_extra_requests and (
+                    node_iter.nodes_left > 0 or buckets.has_alternate_node())
+                bad_resp = not is_good_source(get.last_status)
+                if requests_available and (
+                        buckets.shortfall > pile._pending or bad_resp):
                     extra_requests += 1
-                    pile.spawn(self._fragment_GET_request, req,
-                               safe_iter, partition, policy,
-                               buckets.get_extra_headers)
+                    pile.spawn(self._fragment_GET_request,
+                               req, safe_iter, partition,
+                               policy, buckets.get_extra_headers)
+            if feeder_q:
+                feeder_q.put('stop')
 
         # Put this back, since we *may* need it for kickoff()/_fix_response()
         # (but note that _fix_ranges() may also pop it back off before then)
         req.range = orig_range
-        if best_bucket and best_bucket.shortfall <= 0 and best_bucket.durable:
+        best_bucket = buckets.choose_best_bucket()
+        if best_bucket.shortfall <= 0 and best_bucket.durable:
             # headers can come from any of the getters
             resp_headers = best_bucket.headers
             resp_headers.pop('Content-Range', None)
@@ -2412,8 +2970,7 @@ class ECObjectController(BaseObjectContr
             app_iter = ECAppIter(
                 req.swift_entity_path,
                 policy,
-                [parts_iter for
-                 _getter, parts_iter in best_bucket.get_responses()],
+                [p_iter for _getter, p_iter in best_bucket.get_responses()],
                 range_specs, fa_length, obj_length,
                 self.app.logger)
             resp = Response(
@@ -2439,23 +2996,40 @@ class ECObjectController(BaseObjectContr
             reasons = []
             bodies = []
             headers = []
-            for getter, _parts_iter in bad_bucket.get_responses():
-                if best_bucket and best_bucket.durable:
-                    headers = HeaderKeyDict(getter.last_headers)
-                    t_data_file = headers.get('X-Backend-Data-Timestamp')
-                    t_obj = headers.get('X-Backend-Timestamp',
-                                        headers.get('X-Timestamp'))
-                    bad_ts = Timestamp(t_data_file or t_obj or '0')
-                    if bad_ts <= Timestamp(best_bucket.timestamp_str):
-                        # We have reason to believe there's still good data
-                        # out there, it's just currently unavailable
-                        continue
-                statuses.extend(getter.statuses)
-                reasons.extend(getter.reasons)
-                bodies.extend(getter.bodies)
-                headers.extend(getter.source_headers)
+            best_bucket.close_conns()
+            rebalance_missing_suppression_count = min(
+                policy_options.rebalance_missing_suppression_count,
+                node_iter.num_primary_nodes - 1)
+            for status, bad_bucket in buckets.bad_buckets.items():
+                for getter, _parts_iter in bad_bucket.get_responses():
+                    if best_bucket.durable:
+                        bad_resp_headers = getter.last_headers
+                        t_data_file = bad_resp_headers.get(
+                            'X-Backend-Data-Timestamp')
+                        t_obj = bad_resp_headers.get(
+                            'X-Backend-Timestamp',
+                            bad_resp_headers.get('X-Timestamp'))
+                        bad_ts = Timestamp(t_data_file or t_obj or '0')
+                        if bad_ts <= best_bucket.timestamp:
+                            # We have reason to believe there's still good data
+                            # out there, it's just currently unavailable
+                            continue
+                    if getter.status:
+                        timestamp = Timestamp(getter.last_headers.get(
+                            'X-Backend-Timestamp',
+                            getter.last_headers.get('X-Timestamp', 0)))
+                        if (rebalance_missing_suppression_count > 0 and
+                                getter.status == HTTP_NOT_FOUND and
+                                not timestamp):
+                            rebalance_missing_suppression_count -= 1
+                            continue
+                        statuses.append(getter.status)
+                        reasons.append(getter.reason)
+                        bodies.append(getter.body)
+                        headers.append(getter.source_headers)
 
-            if not statuses and best_bucket and not best_bucket.durable:
+            if not statuses and is_success(best_bucket.status) and \
+                    not best_bucket.durable:
                 # pretend that non-durable bucket was 404s
                 statuses.append(404)
                 reasons.append('404 Not Found')
@@ -2652,7 +3226,6 @@ class ECObjectController(BaseObjectContr
 
             ml = req.message_length()
             if ml and bytes_transferred < ml:
-                req.client_disconnect = True
                 self.app.logger.warning(
                     _('Client disconnected without sending enough data'))
                 self.app.logger.increment('client_disconnects')
@@ -2728,7 +3301,6 @@ class ECObjectController(BaseObjectContr
             self.app.logger.increment('client_timeouts')
             raise HTTPRequestTimeout(request=req)
         except ChunkReadError:
-            req.client_disconnect = True
             self.app.logger.warning(
                 _('Client disconnected without sending last chunk'))
             self.app.logger.increment('client_disconnects')
diff -pruN 2.25.0-3/swift/proxy/server.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/proxy/server.py
--- 2.25.0-3/swift/proxy/server.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift/proxy/server.py	2020-09-15 21:13:36.000000000 +0000
@@ -32,7 +32,7 @@ from swift.common import constraints
 from swift.common.http import is_server_error
 from swift.common.storage_policy import POLICIES
 from swift.common.ring import Ring
-from swift.common.utils import Watchdog, cache_from_env, get_logger, \
+from swift.common.utils import Watchdog, get_logger, \
     get_remote_client, split_path, config_true_value, generate_trans_id, \
     affinity_key_function, affinity_locality_predicate, list_from_csv, \
     register_swift_info, readconf, config_auto_int_value
@@ -101,7 +101,8 @@ class ProxyOverrideOptions(object):
     :param conf: the proxy-server config dict.
     :param override_conf: a dict of overriding configuration options.
     """
-    def __init__(self, base_conf, override_conf):
+    def __init__(self, base_conf, override_conf, app):
+
         def get(key, default):
             return override_conf.get(key, base_conf.get(key, default))
 
@@ -147,14 +148,28 @@ class ProxyOverrideOptions(object):
             get('write_affinity_handoff_delete_count', 'auto'), None
         )
 
+        self.rebalance_missing_suppression_count = int(get(
+            'rebalance_missing_suppression_count', 1))
+        self.concurrent_gets = config_true_value(get('concurrent_gets', False))
+        self.concurrency_timeout = float(get(
+            'concurrency_timeout', app.conn_timeout))
+        self.concurrent_ec_extra_requests = int(get(
+            'concurrent_ec_extra_requests', 0))
+
     def __repr__(self):
-        return '%s({}, {%s})' % (self.__class__.__name__, ', '.join(
-            '%r: %r' % (k, getattr(self, k)) for k in (
-                'sorting_method',
-                'read_affinity',
-                'write_affinity',
-                'write_affinity_node_count',
-                'write_affinity_handoff_delete_count')))
+        return '%s({}, {%s}, app)' % (
+            self.__class__.__name__, ', '.join(
+                '%r: %r' % (k, getattr(self, k)) for k in (
+                    'sorting_method',
+                    'read_affinity',
+                    'write_affinity',
+                    'write_affinity_node_count',
+                    'write_affinity_handoff_delete_count',
+                    'rebalance_missing_suppression_count',
+                    'concurrent_gets',
+                    'concurrency_timeout',
+                    'concurrent_ec_extra_requests',
+                )))
 
     def __eq__(self, other):
         if not isinstance(other, ProxyOverrideOptions):
@@ -164,13 +179,18 @@ class ProxyOverrideOptions(object):
             'read_affinity',
             'write_affinity',
             'write_affinity_node_count',
-            'write_affinity_handoff_delete_count'))
+            'write_affinity_handoff_delete_count',
+            'rebalance_missing_suppression_count',
+            'concurrent_gets',
+            'concurrency_timeout',
+            'concurrent_ec_extra_requests',
+        ))
 
 
 class Application(object):
     """WSGI application for the proxy server."""
 
-    def __init__(self, conf, memcache=None, logger=None, account_ring=None,
+    def __init__(self, conf, logger=None, account_ring=None,
                  container_ring=None):
         if conf is None:
             conf = {}
@@ -178,10 +198,6 @@ class Application(object):
             self.logger = get_logger(conf, log_route='proxy-server')
         else:
             self.logger = logger
-        self._override_options = self._load_per_policy_config(conf)
-        self.sorts_by_timing = any(pc.sorting_method == 'timing'
-                                   for pc in self._override_options.values())
-
         self._error_limiting = {}
 
         swift_dir = conf.get('swift_dir', '/etc/swift')
@@ -218,7 +234,6 @@ class Application(object):
         for policy in POLICIES:
             policy.load_ring(swift_dir)
         self.obj_controller_router = ObjectControllerRouter()
-        self.memcache = memcache
         mimetypes.init(mimetypes.knownfiles +
                        [os.path.join(swift_dir, 'mime.types')])
         self.account_autocreate = \
@@ -261,9 +276,6 @@ class Application(object):
             conf.get('strict_cors_mode', 't'))
         self.node_timings = {}
         self.timing_expiry = int(conf.get('timing_expiry', 300))
-        self.concurrent_gets = config_true_value(conf.get('concurrent_gets'))
-        self.concurrency_timeout = float(conf.get('concurrency_timeout',
-                                                  self.conn_timeout))
         value = conf.get('request_node_count', '2 * replicas').lower().split()
         if len(value) == 1:
             rnc_value = int(value[0])
@@ -310,6 +322,10 @@ class Application(object):
                 'swift.valid_api_versions',
             ])))
         self.admin_key = conf.get('admin_key', None)
+        self._override_options = self._load_per_policy_config(conf)
+        self.sorts_by_timing = any(pc.sorting_method == 'timing'
+                                   for pc in self._override_options.values())
+
         register_swift_info(
             version=swift_version,
             strict_cors_mode=self.strict_cors_mode,
@@ -323,7 +339,7 @@ class Application(object):
     def _make_policy_override(self, policy, conf, override_conf):
         label_for_policy = _label_for_policy(policy)
         try:
-            override = ProxyOverrideOptions(conf, override_conf)
+            override = ProxyOverrideOptions(conf, override_conf, self)
             self.logger.debug("Loaded override config for %s: %r" %
                               (label_for_policy, override))
             return override
@@ -454,8 +470,6 @@ class Application(object):
         :param start_response: WSGI callable
         """
         try:
-            if self.memcache is None:
-                self.memcache = cache_from_env(env, True)
             req = self.update_request(Request(env))
             return self.handle_request(req)(env, start_response)
         except UnicodeError:
diff -pruN 2.25.0-3/swift.egg-info/dependency_links.txt 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift.egg-info/dependency_links.txt
--- 2.25.0-3/swift.egg-info/dependency_links.txt	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift.egg-info/dependency_links.txt	2020-09-15 21:13:40.000000000 +0000
@@ -0,0 +1 @@
+
diff -pruN 2.25.0-3/swift.egg-info/entry_points.txt 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift.egg-info/entry_points.txt
--- 2.25.0-3/swift.egg-info/entry_points.txt	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift.egg-info/entry_points.txt	2020-09-15 21:13:40.000000000 +0000
@@ -0,0 +1,53 @@
+[console_scripts]
+swift-container-deleter = swift.cli.container_deleter:main
+swift-manage-shard-ranges = swift.cli.manage_shard_ranges:main
+
+[paste.app_factory]
+account = swift.account.server:app_factory
+container = swift.container.server:app_factory
+mem_object = swift.obj.mem_server:app_factory
+object = swift.obj.server:app_factory
+proxy = swift.proxy.server:app_factory
+
+[paste.filter_factory]
+account_quotas = swift.common.middleware.account_quotas:filter_factory
+bulk = swift.common.middleware.bulk:filter_factory
+catch_errors = swift.common.middleware.catch_errors:filter_factory
+cname_lookup = swift.common.middleware.cname_lookup:filter_factory
+container_quotas = swift.common.middleware.container_quotas:filter_factory
+container_sync = swift.common.middleware.container_sync:filter_factory
+copy = swift.common.middleware.copy:filter_factory
+crossdomain = swift.common.middleware.crossdomain:filter_factory
+dlo = swift.common.middleware.dlo:filter_factory
+domain_remap = swift.common.middleware.domain_remap:filter_factory
+encryption = swift.common.middleware.crypto:filter_factory
+etag_quoter = swift.common.middleware.etag_quoter:filter_factory
+formpost = swift.common.middleware.formpost:filter_factory
+gatekeeper = swift.common.middleware.gatekeeper:filter_factory
+healthcheck = swift.common.middleware.healthcheck:filter_factory
+keymaster = swift.common.middleware.crypto.keymaster:filter_factory
+keystoneauth = swift.common.middleware.keystoneauth:filter_factory
+kmip_keymaster = swift.common.middleware.crypto.kmip_keymaster:filter_factory
+kms_keymaster = swift.common.middleware.crypto.kms_keymaster:filter_factory
+list_endpoints = swift.common.middleware.list_endpoints:filter_factory
+listing_formats = swift.common.middleware.listing_formats:filter_factory
+memcache = swift.common.middleware.memcache:filter_factory
+name_check = swift.common.middleware.name_check:filter_factory
+proxy_logging = swift.common.middleware.proxy_logging:filter_factory
+ratelimit = swift.common.middleware.ratelimit:filter_factory
+read_only = swift.common.middleware.read_only:filter_factory
+recon = swift.common.middleware.recon:filter_factory
+s3api = swift.common.middleware.s3api.s3api:filter_factory
+s3token = swift.common.middleware.s3api.s3token:filter_factory
+slo = swift.common.middleware.slo:filter_factory
+staticweb = swift.common.middleware.staticweb:filter_factory
+symlink = swift.common.middleware.symlink:filter_factory
+tempauth = swift.common.middleware.tempauth:filter_factory
+tempurl = swift.common.middleware.tempurl:filter_factory
+versioned_writes = swift.common.middleware.versioned_writes:filter_factory
+xprofile = swift.common.middleware.xprofile:filter_factory
+
+[swift.diskfile]
+erasure_coding.fs = swift.obj.diskfile:ECDiskFileManager
+replication.fs = swift.obj.diskfile:DiskFileManager
+
diff -pruN 2.25.0-3/swift.egg-info/not-zip-safe 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift.egg-info/not-zip-safe
--- 2.25.0-3/swift.egg-info/not-zip-safe	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift.egg-info/not-zip-safe	2020-09-15 21:13:40.000000000 +0000
@@ -0,0 +1 @@
+
diff -pruN 2.25.0-3/swift.egg-info/pbr.json 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift.egg-info/pbr.json
--- 2.25.0-3/swift.egg-info/pbr.json	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift.egg-info/pbr.json	2020-09-15 21:13:40.000000000 +0000
@@ -0,0 +1 @@
+{"git_version": "f8a9a6e11", "is_release": false}
\ No newline at end of file
diff -pruN 2.25.0-3/swift.egg-info/PKG-INFO 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift.egg-info/PKG-INFO
--- 2.25.0-3/swift.egg-info/PKG-INFO	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift.egg-info/PKG-INFO	2020-09-15 21:13:40.000000000 +0000
@@ -0,0 +1,188 @@
+Metadata-Version: 2.1
+Name: swift
+Version: 2.26.0.dev186
+Summary: OpenStack Object Storage
+Home-page: https://docs.openstack.org/swift/latest/
+Author: OpenStack
+Author-email: openstack-discuss@lists.openstack.org
+License: UNKNOWN
+Description: ===============
+        OpenStack Swift
+        ===============
+        
+        .. image:: https://governance.openstack.org/tc/badges/swift.svg
+            :target: https://governance.openstack.org/tc/reference/tags/index.html
+        
+        .. Change things from this point on
+        
+        OpenStack Swift is a distributed object storage system designed to scale
+        from a single machine to thousands of servers. Swift is optimized for
+        multi-tenancy and high concurrency. Swift is ideal for backups, web and mobile
+        content, and any other unstructured data that can grow without bound.
+        
+        Swift provides a simple, REST-based API fully documented at
+        https://docs.openstack.org/swift/latest/.
+        
+        Swift was originally developed as the basis for Rackspace's Cloud Files
+        and was open-sourced in 2010 as part of the OpenStack project. It has
+        since grown to include contributions from many companies and has spawned
+        a thriving ecosystem of 3rd party tools. Swift's contributors are listed
+        in the AUTHORS file.
+        
+        Docs
+        ----
+        
+        To build documentation run::
+        
+            pip install -r requirements.txt -r doc/requirements.txt
+            sphinx-build -W -b html doc/source doc/build/html
+        
+        and then browse to doc/build/html/index.html. These docs are auto-generated
+        after every commit and available online at
+        https://docs.openstack.org/swift/latest/.
+        
+        For Developers
+        --------------
+        
+        Getting Started
+        ~~~~~~~~~~~~~~~
+        
+        Swift is part of OpenStack and follows the code contribution, review, and
+        testing processes common to all OpenStack projects.
+        
+        If you would like to start contributing, check out these
+        `notes <CONTRIBUTING.rst>`__ to help you get started.
+        
+        The best place to get started is the
+        `"SAIO - Swift All In One" <https://docs.openstack.org/swift/latest/development_saio.html>`__.
+        This document will walk you through setting up a development cluster of
+        Swift in a VM. The SAIO environment is ideal for running small-scale
+        tests against Swift and trying out new features and bug fixes.
+        
+        Tests
+        ~~~~~
+        
+        There are three types of tests included in Swift's source tree.
+        
+        #. Unit tests
+        #. Functional tests
+        #. Probe tests
+        
+        Unit tests check that small sections of the code behave properly. For example,
+        a unit test may test a single function to ensure that various input gives the
+        expected output. This validates that the code is correct and regressions are
+        not introduced.
+        
+        Functional tests check that the client API is working as expected. These can
+        be run against any endpoint claiming to support the Swift API (although some
+        tests require multiple accounts with different privilege levels). These are
+        "black box" tests that ensure that client apps written against Swift will
+        continue to work.
+        
+        Probe tests are "white box" tests that validate the internal workings of a
+        Swift cluster. They are written to work against the
+        `"SAIO - Swift All In One" <https://docs.openstack.org/swift/latest/development_saio.html>`__
+        dev environment. For example, a probe test may create an object, delete one
+        replica, and ensure that the background consistency processes find and correct
+        the error.
+        
+        You can run unit tests with ``.unittests``, functional tests with
+        ``.functests``, and probe tests with ``.probetests``. There is an
+        additional ``.alltests`` script that wraps the other three.
+        
+        To fully run the tests, the target environment must use a filesystem that
+        supports large xattrs. XFS is strongly recommended. For unit tests and in-
+        process functional tests, either mount ``/tmp`` with XFS or provide another
+        XFS filesystem via the ``TMPDIR`` environment variable. Without this setting,
+        tests should still pass, but a very large number will be skipped.
+        
+        Code Organization
+        ~~~~~~~~~~~~~~~~~
+        
+        -  bin/: Executable scripts that are the processes run by the deployer
+        -  doc/: Documentation
+        -  etc/: Sample config files
+        -  examples/: Config snippets used in the docs
+        -  swift/: Core code
+        
+           -  account/: account server
+           -  cli/: code that backs some of the CLI tools in bin/
+           -  common/: code shared by different modules
+        
+              -  middleware/: "standard", officially-supported middleware
+              -  ring/: code implementing Swift's ring
+        
+           -  container/: container server
+           -  locale/: internationalization (translation) data
+           -  obj/: object server
+           -  proxy/: proxy server
+        
+        -  test/: Unit, functional, and probe tests
+        
+        Data Flow
+        ~~~~~~~~~
+        
+        Swift is a WSGI application and uses eventlet's WSGI server. After the
+        processes are running, the entry point for new requests is the
+        ``Application`` class in ``swift/proxy/server.py``. From there, a
+        controller is chosen, and the request is processed. The proxy may choose
+        to forward the request to a back-end server. For example, the entry
+        point for requests to the object server is the ``ObjectController``
+        class in ``swift/obj/server.py``.
+        
+        For Deployers
+        -------------
+        
+        Deployer docs are also available at
+        https://docs.openstack.org/swift/latest/. A good starting point is at
+        https://docs.openstack.org/swift/latest/deployment_guide.html
+        There is an `ops runbook <https://docs.openstack.org/swift/latest/ops_runbook/index.html>`__
+        that gives information about how to diagnose and troubleshoot common issues
+        when running a Swift cluster.
+        
+        You can run functional tests against a Swift cluster with
+        ``.functests``. These functional tests require ``/etc/swift/test.conf``
+        to run. A sample config file can be found in this source tree in
+        ``test/sample.conf``.
+        
+        For Client Apps
+        ---------------
+        
+        For client applications, official Python language bindings are provided
+        at https://github.com/openstack/python-swiftclient.
+        
+        Complete API documentation at
+        https://docs.openstack.org/api-ref/object-store/
+        
+        There is a large ecosystem of applications and libraries that support and
+        work with OpenStack Swift. Several are listed on the
+        `associated projects <https://docs.openstack.org/swift/latest/associated_projects.html>`__
+        page.
+        
+        --------------
+        
+        For more information come hang out in #openstack-swift on freenode.
+        
+        Thanks,
+        
+        The Swift Development Team
+        
+        
+Platform: UNKNOWN
+Classifier: Development Status :: 5 - Production/Stable
+Classifier: Environment :: OpenStack
+Classifier: Intended Audience :: Information Technology
+Classifier: Intended Audience :: System Administrators
+Classifier: License :: OSI Approved :: Apache Software License
+Classifier: Operating System :: POSIX :: Linux
+Classifier: Programming Language :: Python
+Classifier: Programming Language :: Python :: 2
+Classifier: Programming Language :: Python :: 2.7
+Classifier: Programming Language :: Python :: 3
+Classifier: Programming Language :: Python :: 3.6
+Classifier: Programming Language :: Python :: 3.7
+Classifier: Programming Language :: Python :: 3.8
+Provides-Extra: keystone
+Provides-Extra: kmip_keymaster
+Provides-Extra: kms_keymaster
+Provides-Extra: test
diff -pruN 2.25.0-3/swift.egg-info/requires.txt 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift.egg-info/requires.txt
--- 2.25.0-3/swift.egg-info/requires.txt	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift.egg-info/requires.txt	2020-09-15 21:13:40.000000000 +0000
@@ -0,0 +1,40 @@
+PasteDeploy>=1.3.3
+PyECLib>=1.3.1
+cryptography>=2.0.2
+eventlet>=0.25.0
+greenlet>=0.3.2
+lxml>=3.4.1
+netifaces!=0.10.0,!=0.10.1,>=0.8
+requests>=2.14.2
+six>=1.10.0
+xattr>=0.4
+
+[keystone]
+keystonemiddleware>=4.17.0
+
+[kmip_keymaster]
+pykmip>=0.7.0
+
+[kms_keymaster]
+castellan>=0.13.0
+oslo.config!=4.3.0,!=4.4.0,>=4.0.0
+
+[test]
+bandit>=1.1.0
+boto3>=1.9
+boto>=2.32.1
+botocore>=1.12
+coverage>=3.6
+docutils>=0.11
+fixtures>=3.0.0
+hacking<2.1.0,>=2.0
+keystonemiddleware>=4.17.0
+mock>=2.0
+nose>=1.3.7
+nosehtmloutput>=0.0.3
+nosexcover>=1.0.10
+os-testr>=0.8.0
+python-keystoneclient!=2.1.0,>=2.0.0
+python-openstackclient>=3.12.0
+python-swiftclient>=3.2.0
+requests-mock>=1.2.0
diff -pruN 2.25.0-3/swift.egg-info/SOURCES.txt 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift.egg-info/SOURCES.txt
--- 2.25.0-3/swift.egg-info/SOURCES.txt	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift.egg-info/SOURCES.txt	2020-09-15 21:13:40.000000000 +0000
@@ -0,0 +1,846 @@
+.alltests
+.coveragerc
+.dockerignore
+.functests
+.mailmap
+.manpages
+.probetests
+.testr.conf
+.unittests
+.zuul.yaml
+AUTHORS
+CHANGELOG
+CONTRIBUTING.rst
+Dockerfile
+Dockerfile-py3
+LICENSE
+MANIFEST.in
+README.rst
+REVIEW_GUIDELINES.rst
+babel.cfg
+bandit.yaml
+bindep.txt
+lower-constraints.txt
+py2-constraints.txt
+requirements.txt
+setup.cfg
+setup.py
+test-requirements.txt
+tox.ini
+api-ref/source/conf.py
+api-ref/source/index.rst
+api-ref/source/metadata_header_encoding.inc
+api-ref/source/metadata_header_syntax.inc
+api-ref/source/parameters.yaml
+api-ref/source/storage-account-services.inc
+api-ref/source/storage-container-services.inc
+api-ref/source/storage-object-services.inc
+api-ref/source/storage_endpoints.inc
+api-ref/source/storage_info.inc
+api-ref/source/samples/account-containers-list-http-request-json.txt
+api-ref/source/samples/account-containers-list-http-request-xml.txt
+api-ref/source/samples/account-containers-list-http-response-json.txt
+api-ref/source/samples/account-containers-list-http-response-xml.txt
+api-ref/source/samples/account-containers-list-response.json
+api-ref/source/samples/account-containers-list-response.xml
+api-ref/source/samples/capabilities-list-response.json
+api-ref/source/samples/containers-list-http-request.txt
+api-ref/source/samples/containers-list-http-response.txt
+api-ref/source/samples/endpoints-list-response-headers.json
+api-ref/source/samples/endpoints-list-response.json
+api-ref/source/samples/goodbyeworld.txt
+api-ref/source/samples/helloworld.txt
+api-ref/source/samples/objects-list-http-response-json.txt
+api-ref/source/samples/objects-list-http-response-xml.txt
+api-ref/source/samples/objects-list-response.json
+api-ref/source/samples/objects-list-response.xml
+bin/swift-account-audit
+bin/swift-account-auditor
+bin/swift-account-info
+bin/swift-account-reaper
+bin/swift-account-replicator
+bin/swift-account-server
+bin/swift-config
+bin/swift-container-auditor
+bin/swift-container-info
+bin/swift-container-reconciler
+bin/swift-container-replicator
+bin/swift-container-server
+bin/swift-container-sharder
+bin/swift-container-sync
+bin/swift-container-updater
+bin/swift-dispersion-populate
+bin/swift-dispersion-report
+bin/swift-drive-audit
+bin/swift-form-signature
+bin/swift-get-nodes
+bin/swift-init
+bin/swift-object-auditor
+bin/swift-object-expirer
+bin/swift-object-info
+bin/swift-object-reconstructor
+bin/swift-object-relinker
+bin/swift-object-replicator
+bin/swift-object-server
+bin/swift-object-updater
+bin/swift-oldies
+bin/swift-orphans
+bin/swift-proxy-server
+bin/swift-recon
+bin/swift-recon-cron
+bin/swift-reconciler-enqueue
+bin/swift-ring-builder
+bin/swift-ring-builder-analyzer
+bin/swift-ring-composer
+doc/requirements.txt
+doc/manpages/account-server.conf.5
+doc/manpages/container-reconciler.conf.5
+doc/manpages/container-server.conf.5
+doc/manpages/container-sync-realms.conf.5
+doc/manpages/dispersion.conf.5
+doc/manpages/object-expirer.conf.5
+doc/manpages/object-server.conf.5
+doc/manpages/proxy-server.conf.5
+doc/manpages/swift-account-audit.1
+doc/manpages/swift-account-auditor.1
+doc/manpages/swift-account-info.1
+doc/manpages/swift-account-reaper.1
+doc/manpages/swift-account-replicator.1
+doc/manpages/swift-account-server.1
+doc/manpages/swift-config.1
+doc/manpages/swift-container-auditor.1
+doc/manpages/swift-container-info.1
+doc/manpages/swift-container-reconciler.1
+doc/manpages/swift-container-replicator.1
+doc/manpages/swift-container-server.1
+doc/manpages/swift-container-sync.1
+doc/manpages/swift-container-updater.1
+doc/manpages/swift-dispersion-populate.1
+doc/manpages/swift-dispersion-report.1
+doc/manpages/swift-drive-audit.1
+doc/manpages/swift-form-signature.1
+doc/manpages/swift-get-nodes.1
+doc/manpages/swift-init.1
+doc/manpages/swift-object-auditor.1
+doc/manpages/swift-object-expirer.1
+doc/manpages/swift-object-info.1
+doc/manpages/swift-object-reconstructor.1
+doc/manpages/swift-object-relinker.1
+doc/manpages/swift-object-replicator.1
+doc/manpages/swift-object-server.1
+doc/manpages/swift-object-updater.1
+doc/manpages/swift-oldies.1
+doc/manpages/swift-orphans.1
+doc/manpages/swift-proxy-server.1
+doc/manpages/swift-recon-cron.1
+doc/manpages/swift-recon.1
+doc/manpages/swift-reconciler-enqueue.1
+doc/manpages/swift-ring-builder-analyzer.1
+doc/manpages/swift-ring-builder.1
+doc/manpages/swift-ring-composer.1
+doc/manpages/swift.conf.5
+doc/s3api/conf/ceph-known-failures-keystone.yaml
+doc/s3api/conf/ceph-known-failures-tempauth.yaml
+doc/s3api/rnc/access_control_policy.rnc
+doc/s3api/rnc/bucket_logging_status.rnc
+doc/s3api/rnc/common.rnc
+doc/s3api/rnc/complete_multipart_upload.rnc
+doc/s3api/rnc/complete_multipart_upload_result.rnc
+doc/s3api/rnc/copy_object_result.rnc
+doc/s3api/rnc/copy_part_result.rnc
+doc/s3api/rnc/create_bucket_configuration.rnc
+doc/s3api/rnc/delete.rnc
+doc/s3api/rnc/delete_result.rnc
+doc/s3api/rnc/error.rnc
+doc/s3api/rnc/initiate_multipart_upload_result.rnc
+doc/s3api/rnc/lifecycle_configuration.rnc
+doc/s3api/rnc/list_all_my_buckets_result.rnc
+doc/s3api/rnc/list_bucket_result.rnc
+doc/s3api/rnc/list_multipart_uploads_result.rnc
+doc/s3api/rnc/list_parts_result.rnc
+doc/s3api/rnc/list_versions_result.rnc
+doc/s3api/rnc/location_constraint.rnc
+doc/s3api/rnc/versioning_configuration.rnc
+doc/saio/rsyncd.conf
+doc/saio/bin/remakerings
+doc/saio/bin/resetswift
+doc/saio/bin/startmain
+doc/saio/bin/startrest
+doc/saio/rsyslog.d/10-swift.conf
+doc/saio/swift/container-reconciler.conf
+doc/saio/swift/container-sync-realms.conf
+doc/saio/swift/internal-client.conf
+doc/saio/swift/object-expirer.conf
+doc/saio/swift/proxy-server.conf
+doc/saio/swift/swift.conf
+doc/saio/swift/account-server/1.conf
+doc/saio/swift/account-server/2.conf
+doc/saio/swift/account-server/3.conf
+doc/saio/swift/account-server/4.conf
+doc/saio/swift/container-server/1.conf
+doc/saio/swift/container-server/2.conf
+doc/saio/swift/container-server/3.conf
+doc/saio/swift/container-server/4.conf
+doc/saio/swift/object-server/1.conf
+doc/saio/swift/object-server/2.conf
+doc/saio/swift/object-server/3.conf
+doc/saio/swift/object-server/4.conf
+doc/source/account.rst
+doc/source/admin_guide.rst
+doc/source/apache_deployment_guide.rst
+doc/source/associated_projects.rst
+doc/source/conf.py
+doc/source/container.rst
+doc/source/cors.rst
+doc/source/crossdomain.rst
+doc/source/db.rst
+doc/source/deployment_guide.rst
+doc/source/development_auth.rst
+doc/source/development_guidelines.rst
+doc/source/development_middleware.rst
+doc/source/development_ondisk_backends.rst
+doc/source/development_saio.rst
+doc/source/first_contribution_swift.rst
+doc/source/getting_started.rst
+doc/source/howto_installmultinode.rst
+doc/source/index.rst
+doc/source/logs.rst
+doc/source/middleware.rst
+doc/source/misc.rst
+doc/source/object.rst
+doc/source/overview_acl.rst
+doc/source/overview_architecture.rst
+doc/source/overview_auth.rst
+doc/source/overview_backing_store.rst
+doc/source/overview_container_sharding.rst
+doc/source/overview_container_sync.rst
+doc/source/overview_encryption.rst
+doc/source/overview_erasure_code.rst
+doc/source/overview_expiring_objects.rst
+doc/source/overview_global_cluster.rst
+doc/source/overview_large_objects.rst
+doc/source/overview_policies.rst
+doc/source/overview_reaper.rst
+doc/source/overview_replication.rst
+doc/source/overview_ring.rst
+doc/source/policies_saio.rst
+doc/source/proxy.rst
+doc/source/ratelimit.rst
+doc/source/replication_network.rst
+doc/source/ring.rst
+doc/source/ring_background.rst
+doc/source/ring_partpower.rst
+doc/source/s3_compat.rst
+doc/source/test-cors.html
+doc/source/_extra/.htaccess
+doc/source/admin/index.rst
+doc/source/admin/objectstorage-EC.rst
+doc/source/admin/objectstorage-account-reaper.rst
+doc/source/admin/objectstorage-admin.rst
+doc/source/admin/objectstorage-arch.rst
+doc/source/admin/objectstorage-auditors.rst
+doc/source/admin/objectstorage-characteristics.rst
+doc/source/admin/objectstorage-components.rst
+doc/source/admin/objectstorage-features.rst
+doc/source/admin/objectstorage-intro.rst
+doc/source/admin/objectstorage-large-objects.rst
+doc/source/admin/objectstorage-monitoring.rst
+doc/source/admin/objectstorage-replication.rst
+doc/source/admin/objectstorage-ringbuilder.rst
+doc/source/admin/objectstorage-tenant-specific-image-storage.rst
+doc/source/admin/objectstorage-troubleshoot.rst
+doc/source/admin/figures/objectstorage-accountscontainers.png
+doc/source/admin/figures/objectstorage-arch.png
+doc/source/admin/figures/objectstorage-buildingblocks.png
+doc/source/admin/figures/objectstorage-nodes.png
+doc/source/admin/figures/objectstorage-partitions.png
+doc/source/admin/figures/objectstorage-replication.png
+doc/source/admin/figures/objectstorage-ring.png
+doc/source/admin/figures/objectstorage-usecase.png
+doc/source/admin/figures/objectstorage-zones.png
+doc/source/admin/figures/objectstorage.png
+doc/source/api/authentication.rst
+doc/source/api/bulk-delete.rst
+doc/source/api/container_quotas.rst
+doc/source/api/discoverability.rst
+doc/source/api/form_post_middleware.rst
+doc/source/api/large_objects.rst
+doc/source/api/object-expiration.rst
+doc/source/api/object_api_v1_overview.rst
+doc/source/api/object_versioning.rst
+doc/source/api/pagination.rst
+doc/source/api/pseudo-hierarchical-folders-directories.rst
+doc/source/api/serialized-response-formats.rst
+doc/source/api/static-website.rst
+doc/source/api/temporary_url_middleware.rst
+doc/source/api/use_content-encoding_metadata.rst
+doc/source/api/use_the_content-disposition_metadata.rst
+doc/source/contributor/contributing.rst
+doc/source/contributor/review_guidelines.rst
+doc/source/images/ec_overview.png
+doc/source/images/sharded_GET.svg
+doc/source/images/sharding_GET.svg
+doc/source/images/sharding_cleave1_load.svg
+doc/source/images/sharding_cleave2_load.svg
+doc/source/images/sharding_cleave_basic.svg
+doc/source/images/sharding_db_states.svg
+doc/source/images/sharding_scan_basic.svg
+doc/source/images/sharding_scan_load.svg
+doc/source/images/sharding_sharded_load.svg
+doc/source/images/sharding_unsharded.svg
+doc/source/images/sharding_unsharded_load.svg
+doc/source/install/controller-common_prerequisites.txt
+doc/source/install/controller-include.txt
+doc/source/install/controller-install-debian.rst
+doc/source/install/controller-install-obs.rst
+doc/source/install/controller-install-rdo.rst
+doc/source/install/controller-install-ubuntu.rst
+doc/source/install/controller-install.rst
+doc/source/install/edit_hosts_file.txt
+doc/source/install/environment-networking.rst
+doc/source/install/finalize-installation-obs.rst
+doc/source/install/finalize-installation-rdo.rst
+doc/source/install/finalize-installation-ubuntu-debian.rst
+doc/source/install/finalize-installation.rst
+doc/source/install/get_started.rst
+doc/source/install/index.rst
+doc/source/install/initial-rings.rst
+doc/source/install/next-steps.rst
+doc/source/install/storage-include1.txt
+doc/source/install/storage-include2.txt
+doc/source/install/storage-include3.txt
+doc/source/install/storage-install-obs.rst
+doc/source/install/storage-install-rdo.rst
+doc/source/install/storage-install-ubuntu-debian.rst
+doc/source/install/storage-install.rst
+doc/source/install/verify.rst
+doc/source/ops_runbook/diagnose.rst
+doc/source/ops_runbook/index.rst
+doc/source/ops_runbook/maintenance.rst
+doc/source/ops_runbook/procedures.rst
+doc/source/ops_runbook/troubleshooting.rst
+docker/dockerhub_description.md
+docker/install_scripts/00_swift_needs.sh
+docker/install_scripts/10_apk_install_prereqs.sh
+docker/install_scripts/20_apk_install_py2.sh
+docker/install_scripts/21_apk_install_py3.sh
+docker/install_scripts/50_swift_install.sh
+docker/install_scripts/60_pip_uninstall_dev.sh
+docker/install_scripts/99_apk_uninstall_dev.sh
+docker/install_scripts/python_test_dirs
+docker/rootfs/etc/profile
+docker/rootfs/etc/rsyncd.conf
+docker/rootfs/etc/rsyslog.conf
+docker/rootfs/etc/cont-init.d/01_swift_logs
+docker/rootfs/etc/cont-init.d/02_build_remakerings
+docker/rootfs/etc/fix-attrs.d/logging
+docker/rootfs/etc/fix-attrs.d/srv_node
+docker/rootfs/etc/fix-attrs.d/swift
+docker/rootfs/etc/fix-attrs.d/tmp
+docker/rootfs/etc/rsyslog.d/00-swift.conf
+docker/rootfs/etc/rsyslog.d/50-default.conf
+docker/rootfs/etc/services.d/memcached/run
+docker/rootfs/etc/services.d/swift-account/run
+docker/rootfs/etc/services.d/swift-container/run
+docker/rootfs/etc/services.d/swift-object/run
+docker/rootfs/etc/services.d/swift-proxy/run
+docker/rootfs/etc/socklog.rules/swift_account_server
+docker/rootfs/etc/socklog.rules/swift_all
+docker/rootfs/etc/socklog.rules/swift_container_server
+docker/rootfs/etc/socklog.rules/swift_object_server
+docker/rootfs/etc/socklog.rules/swift_proxy_server
+docker/rootfs/etc/swift/account-server.conf
+docker/rootfs/etc/swift/container-server.conf
+docker/rootfs/etc/swift/object-server.conf
+docker/rootfs/etc/swift/proxy-server.conf
+docker/rootfs/etc/swift/swift.conf
+docker/rootfs/etc/swift_build/build_devices
+docker/rootfs/etc/swift_build/build_remakerings
+docker/rootfs/etc/swift_build/prepare_rings
+etc/account-server.conf-sample
+etc/container-reconciler.conf-sample
+etc/container-server.conf-sample
+etc/container-sync-realms.conf-sample
+etc/dispersion.conf-sample
+etc/drive-audit.conf-sample
+etc/internal-client.conf-sample
+etc/keymaster.conf-sample
+etc/memcache.conf-sample
+etc/mime.types-sample
+etc/object-expirer.conf-sample
+etc/object-server.conf-sample
+etc/proxy-server.conf-sample
+etc/rsyncd.conf-sample
+etc/swift-rsyslog.conf-sample
+etc/swift.conf-sample
+examples/apache2/account-server.template
+examples/apache2/container-server.template
+examples/apache2/object-server.template
+examples/apache2/proxy-server.template
+examples/wsgi/account-server.wsgi.template
+examples/wsgi/container-server.wsgi.template
+examples/wsgi/object-server.wsgi.template
+examples/wsgi/proxy-server.wsgi.template
+releasenotes/notes/2_10_0_release-666a76f4975657a5.yaml
+releasenotes/notes/2_11_0_release-ac1d256e455d347e.yaml
+releasenotes/notes/2_12_0_release-06af226abc7b91ef.yaml
+releasenotes/notes/2_13_0_release-875e1fb1ef59f015.yaml
+releasenotes/notes/2_14_0_release-7c3ef515ebded888.yaml
+releasenotes/notes/2_15_0_release-0a05a011fb85a9c9.yaml
+releasenotes/notes/2_15_1_release-be25e67bfc5e886a.yaml
+releasenotes/notes/2_15_2_release-6996eccabba558b4.yaml
+releasenotes/notes/2_16_0_release-d48cb9b2629df8ab.yaml
+releasenotes/notes/2_17_0_release-bd35f18c41c5ef18.yaml
+releasenotes/notes/2_17_1_release-dd6e6879cbb94f85.yaml
+releasenotes/notes/2_18_0_release-3acf63cfe2475c65.yaml
+releasenotes/notes/2_19_0_release-3e6ee3e6a1fcc6bb.yaml
+releasenotes/notes/2_19_1_release-5072dd72557f5708.yaml
+releasenotes/notes/2_20_0_release-7b090a5f4bd916e4.yaml
+releasenotes/notes/2_21_0_release-d8ae33ef18b7be3a.yaml
+releasenotes/notes/2_22_0_release-f60d29508b3c1283.yaml
+releasenotes/notes/2_23_0_release-2a2d11c1934f0b61.yaml
+releasenotes/notes/2_24_0_release-1ca244cc959922fc.yaml
+releasenotes/notes/2_25_0_release-09410c808881bf21.yaml
+releasenotes/source/conf.py
+releasenotes/source/current.rst
+releasenotes/source/index.rst
+releasenotes/source/newton.rst
+releasenotes/source/ocata.rst
+releasenotes/source/pike.rst
+releasenotes/source/queens.rst
+releasenotes/source/rocky.rst
+releasenotes/source/stein.rst
+releasenotes/source/train.rst
+releasenotes/source/ussuri.rst
+releasenotes/source/locale/en_GB/LC_MESSAGES/releasenotes.po
+releasenotes/source/locale/ja/LC_MESSAGES/releasenotes.po
+roles/additional-keystone-users/tasks/main.yaml
+roles/additional-tempauth-users/tasks/main.yaml
+roles/dsvm-additional-middlewares/tasks/main.yaml
+swift/__init__.py
+swift.egg-info/PKG-INFO
+swift.egg-info/SOURCES.txt
+swift.egg-info/dependency_links.txt
+swift.egg-info/entry_points.txt
+swift.egg-info/not-zip-safe
+swift.egg-info/pbr.json
+swift.egg-info/requires.txt
+swift.egg-info/top_level.txt
+swift/account/__init__.py
+swift/account/auditor.py
+swift/account/backend.py
+swift/account/reaper.py
+swift/account/replicator.py
+swift/account/server.py
+swift/account/utils.py
+swift/cli/__init__.py
+swift/cli/container_deleter.py
+swift/cli/dispersion_report.py
+swift/cli/form_signature.py
+swift/cli/info.py
+swift/cli/manage_shard_ranges.py
+swift/cli/recon.py
+swift/cli/relinker.py
+swift/cli/ring_builder_analyzer.py
+swift/cli/ringbuilder.py
+swift/cli/ringcomposer.py
+swift/cli/shard-info.py
+swift/common/__init__.py
+swift/common/base_storage_server.py
+swift/common/bufferedhttp.py
+swift/common/constraints.py
+swift/common/container_sync_realms.py
+swift/common/daemon.py
+swift/common/db.py
+swift/common/db_replicator.py
+swift/common/direct_client.py
+swift/common/exceptions.py
+swift/common/header_key_dict.py
+swift/common/http.py
+swift/common/internal_client.py
+swift/common/linkat.py
+swift/common/manager.py
+swift/common/memcached.py
+swift/common/request_helpers.py
+swift/common/splice.py
+swift/common/storage_policy.py
+swift/common/swob.py
+swift/common/utils.py
+swift/common/wsgi.py
+swift/common/middleware/__init__.py
+swift/common/middleware/account_quotas.py
+swift/common/middleware/acl.py
+swift/common/middleware/bulk.py
+swift/common/middleware/catch_errors.py
+swift/common/middleware/cname_lookup.py
+swift/common/middleware/container_quotas.py
+swift/common/middleware/container_sync.py
+swift/common/middleware/copy.py
+swift/common/middleware/crossdomain.py
+swift/common/middleware/dlo.py
+swift/common/middleware/domain_remap.py
+swift/common/middleware/etag_quoter.py
+swift/common/middleware/formpost.py
+swift/common/middleware/gatekeeper.py
+swift/common/middleware/healthcheck.py
+swift/common/middleware/keystoneauth.py
+swift/common/middleware/list_endpoints.py
+swift/common/middleware/listing_formats.py
+swift/common/middleware/memcache.py
+swift/common/middleware/name_check.py
+swift/common/middleware/proxy_logging.py
+swift/common/middleware/ratelimit.py
+swift/common/middleware/read_only.py
+swift/common/middleware/recon.py
+swift/common/middleware/slo.py
+swift/common/middleware/staticweb.py
+swift/common/middleware/symlink.py
+swift/common/middleware/tempauth.py
+swift/common/middleware/tempurl.py
+swift/common/middleware/xprofile.py
+swift/common/middleware/crypto/__init__.py
+swift/common/middleware/crypto/crypto_utils.py
+swift/common/middleware/crypto/decrypter.py
+swift/common/middleware/crypto/encrypter.py
+swift/common/middleware/crypto/keymaster.py
+swift/common/middleware/crypto/kmip_keymaster.py
+swift/common/middleware/crypto/kms_keymaster.py
+swift/common/middleware/s3api/__init__.py
+swift/common/middleware/s3api/acl_handlers.py
+swift/common/middleware/s3api/acl_utils.py
+swift/common/middleware/s3api/etree.py
+swift/common/middleware/s3api/exception.py
+swift/common/middleware/s3api/s3api.py
+swift/common/middleware/s3api/s3request.py
+swift/common/middleware/s3api/s3response.py
+swift/common/middleware/s3api/s3token.py
+swift/common/middleware/s3api/subresource.py
+swift/common/middleware/s3api/utils.py
+swift/common/middleware/s3api/controllers/__init__.py
+swift/common/middleware/s3api/controllers/acl.py
+swift/common/middleware/s3api/controllers/base.py
+swift/common/middleware/s3api/controllers/bucket.py
+swift/common/middleware/s3api/controllers/location.py
+swift/common/middleware/s3api/controllers/logging.py
+swift/common/middleware/s3api/controllers/multi_delete.py
+swift/common/middleware/s3api/controllers/multi_upload.py
+swift/common/middleware/s3api/controllers/obj.py
+swift/common/middleware/s3api/controllers/s3_acl.py
+swift/common/middleware/s3api/controllers/service.py
+swift/common/middleware/s3api/controllers/tagging.py
+swift/common/middleware/s3api/controllers/versioning.py
+swift/common/middleware/s3api/schema/access_control_policy.rng
+swift/common/middleware/s3api/schema/bucket_logging_status.rng
+swift/common/middleware/s3api/schema/common.rng
+swift/common/middleware/s3api/schema/complete_multipart_upload.rng
+swift/common/middleware/s3api/schema/complete_multipart_upload_result.rng
+swift/common/middleware/s3api/schema/copy_object_result.rng
+swift/common/middleware/s3api/schema/copy_part_result.rng
+swift/common/middleware/s3api/schema/create_bucket_configuration.rng
+swift/common/middleware/s3api/schema/delete.rng
+swift/common/middleware/s3api/schema/delete_result.rng
+swift/common/middleware/s3api/schema/error.rng
+swift/common/middleware/s3api/schema/initiate_multipart_upload_result.rng
+swift/common/middleware/s3api/schema/lifecycle_configuration.rng
+swift/common/middleware/s3api/schema/list_all_my_buckets_result.rng
+swift/common/middleware/s3api/schema/list_bucket_result.rng
+swift/common/middleware/s3api/schema/list_multipart_uploads_result.rng
+swift/common/middleware/s3api/schema/list_parts_result.rng
+swift/common/middleware/s3api/schema/list_versions_result.rng
+swift/common/middleware/s3api/schema/location_constraint.rng
+swift/common/middleware/s3api/schema/versioning_configuration.rng
+swift/common/middleware/versioned_writes/__init__.py
+swift/common/middleware/versioned_writes/legacy.py
+swift/common/middleware/versioned_writes/object_versioning.py
+swift/common/middleware/x_profile/__init__.py
+swift/common/middleware/x_profile/exceptions.py
+swift/common/middleware/x_profile/html_viewer.py
+swift/common/middleware/x_profile/profile_model.py
+swift/common/ring/__init__.py
+swift/common/ring/builder.py
+swift/common/ring/composite_builder.py
+swift/common/ring/ring.py
+swift/common/ring/utils.py
+swift/container/__init__.py
+swift/container/auditor.py
+swift/container/backend.py
+swift/container/reconciler.py
+swift/container/replicator.py
+swift/container/server.py
+swift/container/sharder.py
+swift/container/sync.py
+swift/container/sync_store.py
+swift/container/updater.py
+swift/locale/de/LC_MESSAGES/swift.po
+swift/locale/en_GB/LC_MESSAGES/swift.po
+swift/locale/es/LC_MESSAGES/swift.po
+swift/locale/fr/LC_MESSAGES/swift.po
+swift/locale/it/LC_MESSAGES/swift.po
+swift/locale/ja/LC_MESSAGES/swift.po
+swift/locale/ko_KR/LC_MESSAGES/swift.po
+swift/locale/pt_BR/LC_MESSAGES/swift.po
+swift/locale/ru/LC_MESSAGES/swift.po
+swift/locale/tr_TR/LC_MESSAGES/swift.po
+swift/locale/zh_CN/LC_MESSAGES/swift.po
+swift/locale/zh_TW/LC_MESSAGES/swift.po
+swift/obj/__init__.py
+swift/obj/auditor.py
+swift/obj/diskfile.py
+swift/obj/expirer.py
+swift/obj/mem_diskfile.py
+swift/obj/mem_server.py
+swift/obj/reconstructor.py
+swift/obj/replicator.py
+swift/obj/server.py
+swift/obj/ssync_receiver.py
+swift/obj/ssync_sender.py
+swift/obj/updater.py
+swift/proxy/__init__.py
+swift/proxy/server.py
+swift/proxy/controllers/__init__.py
+swift/proxy/controllers/account.py
+swift/proxy/controllers/base.py
+swift/proxy/controllers/container.py
+swift/proxy/controllers/info.py
+swift/proxy/controllers/obj.py
+test/__init__.py
+test/sample.conf
+test/functional/__init__.py
+test/functional/mock_swift_key_manager.py
+test/functional/swift_test_client.py
+test/functional/test_access_control.py
+test/functional/test_account.py
+test/functional/test_container.py
+test/functional/test_dlo.py
+test/functional/test_domain_remap.py
+test/functional/test_object.py
+test/functional/test_object_versioning.py
+test/functional/test_slo.py
+test/functional/test_staticweb.py
+test/functional/test_symlink.py
+test/functional/test_tempurl.py
+test/functional/test_versioned_writes.py
+test/functional/tests.py
+test/functional/s3api/__init__.py
+test/functional/s3api/s3_test_client.py
+test/functional/s3api/test_acl.py
+test/functional/s3api/test_bucket.py
+test/functional/s3api/test_multi_delete.py
+test/functional/s3api/test_multi_upload.py
+test/functional/s3api/test_object.py
+test/functional/s3api/test_presigned.py
+test/functional/s3api/test_service.py
+test/functional/s3api/test_versioning.py
+test/functional/s3api/utils.py
+test/probe/__init__.py
+test/probe/brain.py
+test/probe/common.py
+test/probe/test_account_failures.py
+test/probe/test_account_get_fake_responses_match.py
+test/probe/test_account_reaper.py
+test/probe/test_container_failures.py
+test/probe/test_container_merge_policy_index.py
+test/probe/test_container_sync.py
+test/probe/test_db_replicator.py
+test/probe/test_empty_device_handoff.py
+test/probe/test_object_async_update.py
+test/probe/test_object_conditional_requests.py
+test/probe/test_object_expirer.py
+test/probe/test_object_failures.py
+test/probe/test_object_handoff.py
+test/probe/test_object_metadata_replication.py
+test/probe/test_object_partpower_increase.py
+test/probe/test_object_versioning.py
+test/probe/test_reconstructor_rebuild.py
+test/probe/test_reconstructor_revert.py
+test/probe/test_replication_servers_working.py
+test/probe/test_reserved_name.py
+test/probe/test_sharder.py
+test/probe/test_signals.py
+test/s3api/__init__.py
+test/s3api/test_service.py
+test/s3api/test_versioning.py
+test/unit/__init__.py
+test/unit/helpers.py
+test/unit/account/__init__.py
+test/unit/account/test_auditor.py
+test/unit/account/test_backend.py
+test/unit/account/test_reaper.py
+test/unit/account/test_replicator.py
+test/unit/account/test_server.py
+test/unit/account/test_utils.py
+test/unit/cli/__init__.py
+test/unit/cli/test_container_deleter.py
+test/unit/cli/test_default_output.stub
+test/unit/cli/test_default_output_id_assigned.stub
+test/unit/cli/test_default_sorted_output.stub
+test/unit/cli/test_dispersion_report.py
+test/unit/cli/test_form_signature.py
+test/unit/cli/test_info.py
+test/unit/cli/test_ipv6_output.stub
+test/unit/cli/test_manage_shard_ranges.py
+test/unit/cli/test_recon.py
+test/unit/cli/test_relinker.py
+test/unit/cli/test_ring_builder_analyzer.py
+test/unit/cli/test_ringbuilder.py
+test/unit/cli/test_ringcomposer.py
+test/unit/common/__init__.py
+test/unit/common/corrupted_example.db
+test/unit/common/malformed_example.db
+test/unit/common/malformed_schema_example.db
+test/unit/common/missing_container_info.db
+test/unit/common/test_base_storage_server.py
+test/unit/common/test_bufferedhttp.py
+test/unit/common/test_constraints.py
+test/unit/common/test_container_sync_realms.py
+test/unit/common/test_daemon.py
+test/unit/common/test_db.py
+test/unit/common/test_db_replicator.py
+test/unit/common/test_direct_client.py
+test/unit/common/test_exceptions.py
+test/unit/common/test_header_key_dict.py
+test/unit/common/test_internal_client.py
+test/unit/common/test_linkat.py
+test/unit/common/test_manager.py
+test/unit/common/test_memcached.py
+test/unit/common/test_request_helpers.py
+test/unit/common/test_splice.py
+test/unit/common/test_storage_policy.py
+test/unit/common/test_swob.py
+test/unit/common/test_utils.py
+test/unit/common/test_wsgi.py
+test/unit/common/middleware/__init__.py
+test/unit/common/middleware/helpers.py
+test/unit/common/middleware/test_account_quotas.py
+test/unit/common/middleware/test_acl.py
+test/unit/common/middleware/test_bulk.py
+test/unit/common/middleware/test_catch_errors.py
+test/unit/common/middleware/test_cname_lookup.py
+test/unit/common/middleware/test_container_sync.py
+test/unit/common/middleware/test_copy.py
+test/unit/common/middleware/test_crossdomain.py
+test/unit/common/middleware/test_dlo.py
+test/unit/common/middleware/test_domain_remap.py
+test/unit/common/middleware/test_etag_quoter.py
+test/unit/common/middleware/test_formpost.py
+test/unit/common/middleware/test_gatekeeper.py
+test/unit/common/middleware/test_healthcheck.py
+test/unit/common/middleware/test_keystoneauth.py
+test/unit/common/middleware/test_list_endpoints.py
+test/unit/common/middleware/test_listing_formats.py
+test/unit/common/middleware/test_memcache.py
+test/unit/common/middleware/test_name_check.py
+test/unit/common/middleware/test_object_versioning.py
+test/unit/common/middleware/test_proxy_logging.py
+test/unit/common/middleware/test_quotas.py
+test/unit/common/middleware/test_ratelimit.py
+test/unit/common/middleware/test_read_only.py
+test/unit/common/middleware/test_recon.py
+test/unit/common/middleware/test_slo.py
+test/unit/common/middleware/test_staticweb.py
+test/unit/common/middleware/test_subrequest_logging.py
+test/unit/common/middleware/test_symlink.py
+test/unit/common/middleware/test_tempauth.py
+test/unit/common/middleware/test_tempurl.py
+test/unit/common/middleware/test_versioned_writes.py
+test/unit/common/middleware/test_xprofile.py
+test/unit/common/middleware/crypto/__init__.py
+test/unit/common/middleware/crypto/crypto_helpers.py
+test/unit/common/middleware/crypto/test_crypto.py
+test/unit/common/middleware/crypto/test_crypto_utils.py
+test/unit/common/middleware/crypto/test_decrypter.py
+test/unit/common/middleware/crypto/test_encrypter.py
+test/unit/common/middleware/crypto/test_encryption.py
+test/unit/common/middleware/crypto/test_keymaster.py
+test/unit/common/middleware/crypto/test_kmip_keymaster.py
+test/unit/common/middleware/crypto/test_kms_keymaster.py
+test/unit/common/middleware/s3api/__init__.py
+test/unit/common/middleware/s3api/exceptions.py
+test/unit/common/middleware/s3api/helpers.py
+test/unit/common/middleware/s3api/test_acl.py
+test/unit/common/middleware/s3api/test_acl_handlers.py
+test/unit/common/middleware/s3api/test_acl_utils.py
+test/unit/common/middleware/s3api/test_bucket.py
+test/unit/common/middleware/s3api/test_cfg.py
+test/unit/common/middleware/s3api/test_etree.py
+test/unit/common/middleware/s3api/test_helpers.py
+test/unit/common/middleware/s3api/test_location.py
+test/unit/common/middleware/s3api/test_logging.py
+test/unit/common/middleware/s3api/test_multi_delete.py
+test/unit/common/middleware/s3api/test_multi_upload.py
+test/unit/common/middleware/s3api/test_obj.py
+test/unit/common/middleware/s3api/test_s3_acl.py
+test/unit/common/middleware/s3api/test_s3api.py
+test/unit/common/middleware/s3api/test_s3request.py
+test/unit/common/middleware/s3api/test_s3response.py
+test/unit/common/middleware/s3api/test_s3token.py
+test/unit/common/middleware/s3api/test_service.py
+test/unit/common/middleware/s3api/test_subresource.py
+test/unit/common/middleware/s3api/test_utils.py
+test/unit/common/middleware/s3api/test_versioning.py
+test/unit/common/ring/__init__.py
+test/unit/common/ring/test_builder.py
+test/unit/common/ring/test_composite_builder.py
+test/unit/common/ring/test_ring.py
+test/unit/common/ring/test_utils.py
+test/unit/container/__init__.py
+test/unit/container/test_auditor.py
+test/unit/container/test_backend.py
+test/unit/container/test_reconciler.py
+test/unit/container/test_replicator.py
+test/unit/container/test_server.py
+test/unit/container/test_sharder.py
+test/unit/container/test_sync.py
+test/unit/container/test_sync_store.py
+test/unit/container/test_updater.py
+test/unit/obj/__init__.py
+test/unit/obj/common.py
+test/unit/obj/test_auditor.py
+test/unit/obj/test_diskfile.py
+test/unit/obj/test_expirer.py
+test/unit/obj/test_reconstructor.py
+test/unit/obj/test_replicator.py
+test/unit/obj/test_server.py
+test/unit/obj/test_ssync.py
+test/unit/obj/test_ssync_receiver.py
+test/unit/obj/test_ssync_sender.py
+test/unit/obj/test_updater.py
+test/unit/proxy/__init__.py
+test/unit/proxy/test_mem_server.py
+test/unit/proxy/test_server.py
+test/unit/proxy/test_sysmeta.py
+test/unit/proxy/controllers/__init__.py
+test/unit/proxy/controllers/test_account.py
+test/unit/proxy/controllers/test_base.py
+test/unit/proxy/controllers/test_container.py
+test/unit/proxy/controllers/test_info.py
+test/unit/proxy/controllers/test_obj.py
+test/unit/test_locale/README
+test/unit/test_locale/__init__.py
+test/unit/test_locale/eo.po
+test/unit/test_locale/messages.mo
+test/unit/test_locale/test_locale.py
+test/unit/test_locale/eo/LC_MESSAGES/swift.mo
+tools/test-setup.sh
+tools/playbooks/ceph-s3tests/ceph-s3.conf
+tools/playbooks/ceph-s3tests/post.yaml
+tools/playbooks/ceph-s3tests/run.yaml
+tools/playbooks/common/cover-post.yaml
+tools/playbooks/common/install_dependencies.yaml
+tools/playbooks/dsvm/post.yaml
+tools/playbooks/dsvm/pre.yaml
+tools/playbooks/dsvm/run.yaml
+tools/playbooks/multinode_setup/common_config.yaml
+tools/playbooks/multinode_setup/configure_loopback.yaml
+tools/playbooks/multinode_setup/make_rings.yaml
+tools/playbooks/multinode_setup/pre.yaml
+tools/playbooks/multinode_setup/run.yaml
+tools/playbooks/multinode_setup/templates/make_multinode_rings.j2
+tools/playbooks/multinode_setup/templates/rc.local.j2
+tools/playbooks/multinode_setup/templates/test.conf.j2
+tools/playbooks/probetests/post.yaml
+tools/playbooks/probetests/run.yaml
+tools/playbooks/saio_single_node_setup/add_s3api.yaml
+tools/playbooks/saio_single_node_setup/make_rings.yaml
+tools/playbooks/saio_single_node_setup/setup_saio.yaml
+tools/playbooks/saio_single_node_setup/templates/rc.local.j2
\ No newline at end of file
diff -pruN 2.25.0-3/swift.egg-info/top_level.txt 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift.egg-info/top_level.txt
--- 2.25.0-3/swift.egg-info/top_level.txt	1970-01-01 00:00:00.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/swift.egg-info/top_level.txt	2020-09-15 21:13:40.000000000 +0000
@@ -0,0 +1 @@
+swift
diff -pruN 2.25.0-3/test/functional/__init__.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/__init__.py
--- 2.25.0-3/test/functional/__init__.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/__init__.py	2020-09-15 21:13:36.000000000 +0000
@@ -322,12 +322,16 @@ def _load_encryption(proxy_conf_file, sw
         pipeline = pipeline.replace(
             "proxy-logging proxy-server",
             "keymaster encryption proxy-logging proxy-server")
+        pipeline = pipeline.replace(
+            "cache listing_formats",
+            "cache etag-quoter listing_formats")
         conf.set(section, 'pipeline', pipeline)
         root_secret = base64.b64encode(os.urandom(32))
         if not six.PY2:
             root_secret = root_secret.decode('ascii')
         conf.set('filter:keymaster', 'encryption_root_secret', root_secret)
         conf.set('filter:versioned_writes', 'allow_object_versioning', 'true')
+        conf.set('filter:etag-quoter', 'enable_by_default', 'true')
     except NoSectionError as err:
         msg = 'Error problem with proxy conf file %s: %s' % \
               (proxy_conf_file, err)
@@ -479,8 +483,6 @@ def _load_s3api(proxy_conf_file, swift_c
 conf_loaders = {
     'encryption': _load_encryption,
     'ec': _load_ec_as_default_policy,
-    'domain_remap_staticweb': _load_domain_remap_staticweb,
-    's3api': _load_s3api,
 }
 
 
@@ -518,6 +520,11 @@ def in_process_setup(the_object_server=o
     swift_conf = _in_process_setup_swift_conf(swift_conf_src, _testdir)
     _info('prepared swift.conf: %s' % swift_conf)
 
+    # load s3api and staticweb configs
+    proxy_conf, swift_conf = _load_s3api(proxy_conf, swift_conf)
+    proxy_conf, swift_conf = _load_domain_remap_staticweb(proxy_conf,
+                                                          swift_conf)
+
     # Call the associated method for the value of
     # 'SWIFT_TEST_IN_PROCESS_CONF_LOADER', if one exists
     conf_loader_label = os.environ.get(
@@ -587,6 +594,7 @@ def in_process_setup(the_object_server=o
         # Below are values used by the functional test framework, as well as
         # by the various in-process swift servers
         'auth_uri': 'http://127.0.0.1:%d/auth/v1.0/' % prolis.getsockname()[1],
+        's3_storage_url': 'http://%s:%d/' % prolis.getsockname(),
         # Primary functional test account (needs admin access to the
         # account)
         'account': 'test',
@@ -868,6 +876,8 @@ def setup_package():
                     443 if parsed.scheme == 'https' else 80),
                 'auth_prefix': parsed.path,
             })
+            config.setdefault('s3_storage_url',
+                              urlunsplit(parsed[:2] + ('', None, None)))
         elif 'auth_host' in config:
             scheme = 'http'
             if config_true_value(config.get('auth_ssl', 'no')):
@@ -880,6 +890,8 @@ def setup_package():
                 auth_prefix += 'v1.0'
             config['auth_uri'] = swift_test_auth = urlunsplit(
                 (scheme, netloc, auth_prefix, None, None))
+            config.setdefault('s3_storage_url', urlunsplit(
+                (scheme, netloc, '', None, None)))
         # else, neither auth_uri nor auth_host; swift_test_auth will be unset
         # and we'll skip everything later
 
@@ -1121,10 +1133,15 @@ def get_url_token(user_index, os_options
                     auth_version=swift_test_auth_version,
                     os_options=os_options,
                     insecure=insecure)
-    return get_auth(swift_test_auth,
-                    swift_test_user[user_index],
-                    swift_test_key[user_index],
-                    **authargs)
+    url, token = get_auth(swift_test_auth,
+                          swift_test_user[user_index],
+                          swift_test_key[user_index],
+                          **authargs)
+    if six.PY2 and not isinstance(url, bytes):
+        url = url.encode('utf-8')
+    if six.PY2 and not isinstance(token, bytes):
+        token = token.encode('utf-8')
+    return url, token
 
 
 def retry(func, *args, **kwargs):
diff -pruN 2.25.0-3/test/functional/s3api/__init__.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/s3api/__init__.py
--- 2.25.0-3/test/functional/s3api/__init__.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/s3api/__init__.py	2020-09-15 21:13:36.000000000 +0000
@@ -15,6 +15,8 @@
 
 import unittest
 import traceback
+from contextlib import contextmanager
+import logging
 import test.functional as tf
 from test.functional.s3api.s3_test_client import (
     Connection, get_boto3_conn, tear_down_s3)
@@ -33,11 +35,23 @@ class S3ApiBase(unittest.TestCase):
         super(S3ApiBase, self).__init__(method_name)
         self.method_name = method_name
 
+    @contextmanager
+    def quiet_boto_logging(self):
+        try:
+            logging.getLogger('boto').setLevel(logging.INFO)
+            yield
+        finally:
+            logging.getLogger('boto').setLevel(logging.DEBUG)
+
     def setUp(self):
         if 's3api' not in tf.cluster_info:
             raise tf.SkipTest('s3api middleware is not enabled')
         try:
-            self.conn = Connection()
+            self.conn = Connection(
+                tf.config['s3_access_key'], tf.config['s3_secret_key'],
+                user_id='%s:%s' % (tf.config['account'],
+                                   tf.config['username']))
+
             self.conn.reset()
         except Exception:
             message = '%s got an error during initialize process.\n\n%s' % \
@@ -67,7 +81,8 @@ class S3ApiBaseBoto3(S3ApiBase):
         if 's3api' not in tf.cluster_info:
             raise tf.SkipTest('s3api middleware is not enabled')
         try:
-            self.conn = get_boto3_conn()
+            self.conn = get_boto3_conn(
+                tf.config['s3_access_key'], tf.config['s3_secret_key'])
             self.endpoint_url = self.conn._endpoint.host
             self.access_key = self.conn._request_signer._credentials.access_key
             self.region = self.conn._client_config.region_name
diff -pruN 2.25.0-3/test/functional/s3api/s3_test_client.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/s3api/s3_test_client.py
--- 2.25.0-3/test/functional/s3api/s3_test_client.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/s3api/s3_test_client.py	2020-09-15 21:13:36.000000000 +0000
@@ -15,6 +15,7 @@
 
 import logging
 import os
+from six.moves.urllib.parse import urlparse
 import test.functional as tf
 import boto3
 from botocore.exceptions import ClientError
@@ -46,9 +47,9 @@ class Connection(object):
     """
     Connection class used for S3 functional testing.
     """
-    def __init__(self, aws_access_key='test:tester',
-                 aws_secret_key='testing',
-                 user_id='test:tester'):
+    def __init__(self, aws_access_key,
+                 aws_secret_key,
+                 user_id=None):
         """
         Initialize method.
 
@@ -64,15 +65,16 @@ class Connection(object):
         """
         self.aws_access_key = aws_access_key
         self.aws_secret_key = aws_secret_key
-        self.user_id = user_id
-        # NOTE: auth_host and auth_port can be different from storage location
-        self.host = tf.config['auth_host']
-        self.port = int(tf.config['auth_port'])
+        self.user_id = user_id or aws_access_key
+        parsed = urlparse(tf.config['s3_storage_url'])
+        self.host = parsed.hostname
+        self.port = parsed.port
         self.conn = \
-            S3Connection(aws_access_key, aws_secret_key, is_secure=False,
+            S3Connection(aws_access_key, aws_secret_key,
+                         is_secure=(parsed.scheme == 'https'),
                          host=self.host, port=self.port,
                          calling_format=OrdinaryCallingFormat())
-        self.conn.auth_region_name = 'us-east-1'
+        self.conn.auth_region_name = tf.config.get('s3_region', 'us-east-1')
 
     def reset(self):
         """
@@ -140,22 +142,26 @@ class Connection(object):
         url = self.conn.generate_url(expires_in, method, bucket, obj)
         if os.environ.get('S3_USE_SIGV4') == "True":
             # V4 signatures are known-broken in boto, but we can work around it
-            if url.startswith('https://'):
+            if url.startswith('https://') and not tf.config[
+                    's3_storage_url'].startswith('https://'):
                 url = 'http://' + url[8:]
-            return url, {'Host': '%(host)s:%(port)d:%(port)d' % {
-                'host': self.host, 'port': self.port}}
+            if self.port is None:
+                return url, {}
+            else:
+                return url, {'Host': '%(host)s:%(port)d:%(port)d' % {
+                    'host': self.host, 'port': self.port}}
         return url, {}
 
 
-def get_boto3_conn(aws_access_key='test:tester', aws_secret_key='testing'):
-    host = tf.config['auth_host']
-    port = int(tf.config['auth_port'])
+def get_boto3_conn(aws_access_key, aws_secret_key):
+    endpoint_url = tf.config['s3_storage_url']
     config = boto3.session.Config(s3={'addressing_style': 'path'})
     return boto3.client(
         's3', aws_access_key_id=aws_access_key,
         aws_secret_access_key=aws_secret_key,
-        config=config, region_name='us-east-1', use_ssl=False,
-        endpoint_url='http://{}:{}'.format(host, port))
+        config=config, region_name=tf.config.get('s3_region', 'us-east-1'),
+        use_ssl=endpoint_url.startswith('https:'),
+        endpoint_url=endpoint_url)
 
 
 def tear_down_s3(conn):
diff -pruN 2.25.0-3/test/functional/s3api/test_acl.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/s3api/test_acl.py
--- 2.25.0-3/test/functional/s3api/test_acl.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/s3api/test_acl.py	2020-09-15 21:13:36.000000000 +0000
@@ -93,7 +93,7 @@ class TestS3Acl(S3ApiBase):
 
     def test_put_bucket_acl_error(self):
         req_headers = {'x-amz-acl': 'public-read'}
-        aws_error_conn = Connection(aws_secret_key='invalid')
+        aws_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             aws_error_conn.make_request('PUT', self.bucket,
                                         headers=req_headers, query='acl')
@@ -110,7 +110,7 @@ class TestS3Acl(S3ApiBase):
         self.assertEqual(get_error_code(body), 'AccessDenied')
 
     def test_get_bucket_acl_error(self):
-        aws_error_conn = Connection(aws_secret_key='invalid')
+        aws_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             aws_error_conn.make_request('GET', self.bucket, query='acl')
         self.assertEqual(get_error_code(body), 'SignatureDoesNotMatch')
@@ -126,7 +126,7 @@ class TestS3Acl(S3ApiBase):
     def test_get_object_acl_error(self):
         self.conn.make_request('PUT', self.bucket, self.obj)
 
-        aws_error_conn = Connection(aws_secret_key='invalid')
+        aws_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             aws_error_conn.make_request('GET', self.bucket, self.obj,
                                         query='acl')
diff -pruN 2.25.0-3/test/functional/s3api/test_bucket.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/s3api/test_bucket.py
--- 2.25.0-3/test/functional/s3api/test_bucket.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/s3api/test_bucket.py	2020-09-15 21:13:36.000000000 +0000
@@ -42,11 +42,15 @@ class TestS3ApiBucket(S3ApiBaseBoto3):
             self.assertIn('ETag', obj)
             self.assertIn('Size', obj)
             self.assertEqual(obj['StorageClass'], 'STANDARD')
-            if expect_owner:
+            if not expect_owner:
+                self.assertNotIn('Owner', obj)
+            elif tf.cluster_info['s3api'].get('s3_acl'):
                 self.assertEqual(obj['Owner']['ID'], self.access_key)
                 self.assertEqual(obj['Owner']['DisplayName'], self.access_key)
             else:
-                self.assertNotIn('Owner', obj)
+                self.assertIn('Owner', obj)
+                self.assertIn('ID', obj['Owner'])
+                self.assertIn('DisplayName', obj['Owner'])
 
     def test_bucket(self):
         bucket = 'bucket'
@@ -128,7 +132,7 @@ class TestS3ApiBucket(S3ApiBaseBoto3):
         self.assertEqual(
             ctx.exception.response['Error']['Code'], 'InvalidBucketName')
 
-        auth_error_conn = get_boto3_conn(aws_secret_key='invalid')
+        auth_error_conn = get_boto3_conn(tf.config['s3_access_key'], 'invalid')
         with self.assertRaises(botocore.exceptions.ClientError) as ctx:
             auth_error_conn.create_bucket(Bucket='bucket')
         self.assertEqual(
@@ -201,7 +205,7 @@ class TestS3ApiBucket(S3ApiBaseBoto3):
         self.assertEqual(
             ctx.exception.response['Error']['Code'], 'InvalidBucketName')
 
-        auth_error_conn = get_boto3_conn(aws_secret_key='invalid')
+        auth_error_conn = get_boto3_conn(tf.config['s3_access_key'], 'invalid')
         with self.assertRaises(botocore.exceptions.ClientError) as ctx:
             auth_error_conn.list_objects(Bucket='bucket')
         self.assertEqual(
@@ -388,7 +392,7 @@ class TestS3ApiBucket(S3ApiBaseBoto3):
             ctx.exception.response[
                 'ResponseMetadata']['HTTPHeaders']['content-length'], '0')
 
-        auth_error_conn = get_boto3_conn(aws_secret_key='invalid')
+        auth_error_conn = get_boto3_conn(tf.config['s3_access_key'], 'invalid')
         with self.assertRaises(botocore.exceptions.ClientError) as ctx:
             auth_error_conn.head_bucket(Bucket='bucket')
         self.assertEqual(
@@ -419,7 +423,7 @@ class TestS3ApiBucket(S3ApiBaseBoto3):
         self.assertEqual(
             ctx.exception.response['Error']['Code'], 'InvalidBucketName')
 
-        auth_error_conn = get_boto3_conn(aws_secret_key='invalid')
+        auth_error_conn = get_boto3_conn(tf.config['s3_access_key'], 'invalid')
         with self.assertRaises(botocore.exceptions.ClientError) as ctx:
             auth_error_conn.delete_bucket(Bucket='bucket')
         self.assertEqual(
diff -pruN 2.25.0-3/test/functional/s3api/test_multi_delete.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/s3api/test_multi_delete.py
--- 2.25.0-3/test/functional/s3api/test_multi_delete.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/s3api/test_multi_delete.py	2020-09-15 21:13:36.000000000 +0000
@@ -134,7 +134,7 @@ class TestS3ApiMultiDelete(S3ApiBase):
         content_md5 = calculate_md5(xml)
         query = 'delete'
 
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('POST', bucket, body=xml,
                                          headers={
diff -pruN 2.25.0-3/test/functional/s3api/test_multi_upload.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/s3api/test_multi_upload.py
--- 2.25.0-3/test/functional/s3api/test_multi_upload.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/s3api/test_multi_upload.py	2020-09-15 21:13:36.000000000 +0000
@@ -78,9 +78,9 @@ class TestS3ApiMultiUpload(S3ApiBase):
     def _upload_part(self, bucket, key, upload_id, content=None, part_num=1):
         query = 'partNumber=%s&uploadId=%s' % (part_num, upload_id)
         content = content if content else b'a' * self.min_segment_size
-        status, headers, body = \
-            self.conn.make_request('PUT', bucket, key, body=content,
-                                   query=query)
+        with self.quiet_boto_logging():
+            status, headers, body = self.conn.make_request(
+                'PUT', bucket, key, body=content, query=query)
         return status, headers, body
 
     def _upload_part_copy(self, src_bucket, src_obj, dst_bucket, dst_key,
@@ -113,7 +113,7 @@ class TestS3ApiMultiUpload(S3ApiBase):
         bucket = 'bucket'
         keys = ['obj1', 'obj2', 'obj3']
         bad_content_md5 = base64.b64encode(b'a' * 16).strip().decode('ascii')
-        headers = [None,
+        headers = [{'Content-Type': 'foo/bar', 'x-amz-meta-baz': 'quux'},
                    {'Content-MD5': bad_content_md5},
                    {'Etag': 'nonsense'}]
         uploads = []
@@ -293,7 +293,7 @@ class TestS3ApiMultiUpload(S3ApiBase):
             self._complete_multi_upload(bucket, key, upload_id, xml)
         self.assertEqual(status, 200)
         self.assertCommonResponseHeaders(headers)
-        self.assertTrue('content-type' in headers)
+        self.assertIn('content-type', headers)
         self.assertEqual(headers['content-type'], 'application/xml')
         if 'content-length' in headers:
             self.assertEqual(headers['content-length'], str(len(body)))
@@ -304,9 +304,8 @@ class TestS3ApiMultiUpload(S3ApiBase):
         self.assertTrue(lines[0].startswith(b'<?xml'), body)
         self.assertTrue(lines[0].endswith(b'?>'), body)
         elem = fromstring(body, 'CompleteMultipartUploadResult')
-        # TODO: use tf.config value
         self.assertEqual(
-            'http://%s:%s/bucket/obj1' % (self.conn.host, self.conn.port),
+            '%s/bucket/obj1' % tf.config['s3_storage_url'].rstrip('/'),
             elem.find('Location').text)
         self.assertEqual(elem.find('Bucket').text, bucket)
         self.assertEqual(elem.find('Key').text, key)
@@ -318,9 +317,46 @@ class TestS3ApiMultiUpload(S3ApiBase):
         self.assertEqual(etag, exp_etag)
 
         exp_size = self.min_segment_size * len(etags)
+        status, headers, body = \
+            self.conn.make_request('HEAD', bucket, key)
+        self.assertEqual(status, 200)
+        self.assertEqual(headers['content-length'], str(exp_size))
+        self.assertEqual(headers['content-type'], 'foo/bar')
+        self.assertEqual(headers['x-amz-meta-baz'], 'quux')
+
         swift_etag = '"%s"' % md5(concatted_etags).hexdigest()
         # TODO: GET via swift api, check against swift_etag
 
+        # Should be safe to retry
+        status, headers, body = \
+            self._complete_multi_upload(bucket, key, upload_id, xml)
+        self.assertEqual(status, 200)
+        self.assertCommonResponseHeaders(headers)
+        self.assertIn('content-type', headers)
+        self.assertEqual(headers['content-type'], 'application/xml')
+        if 'content-length' in headers:
+            self.assertEqual(headers['content-length'], str(len(body)))
+        else:
+            self.assertIn('transfer-encoding', headers)
+            self.assertEqual(headers['transfer-encoding'], 'chunked')
+        lines = body.split(b'\n')
+        self.assertTrue(lines[0].startswith(b'<?xml'), body)
+        self.assertTrue(lines[0].endswith(b'?>'), body)
+        elem = fromstring(body, 'CompleteMultipartUploadResult')
+        self.assertEqual(
+            '%s/bucket/obj1' % tf.config['s3_storage_url'].rstrip('/'),
+            elem.find('Location').text)
+        self.assertEqual(elem.find('Bucket').text, bucket)
+        self.assertEqual(elem.find('Key').text, key)
+        self.assertEqual(elem.find('ETag').text, exp_etag)
+
+        status, headers, body = \
+            self.conn.make_request('HEAD', bucket, key)
+        self.assertEqual(status, 200)
+        self.assertEqual(headers['content-length'], str(exp_size))
+        self.assertEqual(headers['content-type'], 'foo/bar')
+        self.assertEqual(headers['x-amz-meta-baz'], 'quux')
+
         # Upload Part Copy -- MU as source
         key, upload_id = uploads[1]
         status, headers, body, resp_etag = \
@@ -428,7 +464,7 @@ class TestS3ApiMultiUpload(S3ApiBase):
         self.conn.make_request('PUT', bucket)
         query = 'uploads'
 
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('POST', bucket, key, query=query)
         self.assertEqual(get_error_code(body), 'SignatureDoesNotMatch')
@@ -442,7 +478,7 @@ class TestS3ApiMultiUpload(S3ApiBase):
         self.conn.make_request('PUT', bucket)
         query = 'uploads'
 
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('GET', bucket, query=query)
         self.assertEqual(get_error_code(body), 'SignatureDoesNotMatch')
@@ -462,7 +498,7 @@ class TestS3ApiMultiUpload(S3ApiBase):
         upload_id = elem.find('UploadId').text
 
         query = 'partNumber=%s&uploadId=%s' % (1, upload_id)
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('PUT', bucket, key, query=query)
         self.assertEqual(get_error_code(body), 'SignatureDoesNotMatch')
@@ -500,7 +536,7 @@ class TestS3ApiMultiUpload(S3ApiBase):
         upload_id = elem.find('UploadId').text
 
         query = 'partNumber=%s&uploadId=%s' % (1, upload_id)
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('PUT', bucket, key,
                                          headers={
@@ -541,7 +577,7 @@ class TestS3ApiMultiUpload(S3ApiBase):
         upload_id = elem.find('UploadId').text
 
         query = 'uploadId=%s' % upload_id
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
 
         status, headers, body = \
             auth_error_conn.make_request('GET', bucket, key, query=query)
@@ -568,7 +604,7 @@ class TestS3ApiMultiUpload(S3ApiBase):
         self._upload_part(bucket, key, upload_id)
 
         query = 'uploadId=%s' % upload_id
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('DELETE', bucket, key, query=query)
         self.assertEqual(get_error_code(body), 'SignatureDoesNotMatch')
@@ -612,7 +648,7 @@ class TestS3ApiMultiUpload(S3ApiBase):
         self.assertEqual(get_error_code(body), 'EntityTooSmall')
 
         # invalid credentials
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('POST', bucket, keys[0], body=xml,
                                          query=query)
@@ -881,6 +917,8 @@ class TestS3ApiMultiUpload(S3ApiBase):
         self.assertEqual(headers['content-length'], '0')
 
     def test_object_multi_upload_part_copy_version(self):
+        if 'object_versioning' not in tf.cluster_info:
+            self.skipTest('Object Versioning not enabled')
         bucket = 'bucket'
         keys = ['obj1']
         uploads = []
diff -pruN 2.25.0-3/test/functional/s3api/test_object.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/s3api/test_object.py
--- 2.25.0-3/test/functional/s3api/test_object.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/s3api/test_object.py	2020-09-15 21:13:36.000000000 +0000
@@ -147,7 +147,7 @@ class TestS3ApiObject(S3ApiBase):
         self.assertCommonResponseHeaders(headers)
 
     def test_put_object_error(self):
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('PUT', self.bucket, 'object')
         self.assertEqual(get_error_code(body), 'SignatureDoesNotMatch')
@@ -166,7 +166,7 @@ class TestS3ApiObject(S3ApiBase):
         dst_obj = 'dst_object'
 
         headers = {'x-amz-copy-source': '/%s/%s' % (self.bucket, obj)}
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('PUT', dst_bucket, dst_obj, headers)
         self.assertEqual(get_error_code(body), 'SignatureDoesNotMatch')
@@ -197,7 +197,7 @@ class TestS3ApiObject(S3ApiBase):
         obj = 'object'
         self.conn.make_request('PUT', self.bucket, obj)
 
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('GET', self.bucket, obj)
         self.assertEqual(get_error_code(body), 'SignatureDoesNotMatch')
@@ -216,7 +216,7 @@ class TestS3ApiObject(S3ApiBase):
         obj = 'object'
         self.conn.make_request('PUT', self.bucket, obj)
 
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('HEAD', self.bucket, obj)
         self.assertEqual(status, 403)
@@ -239,7 +239,7 @@ class TestS3ApiObject(S3ApiBase):
         obj = 'object'
         self.conn.make_request('PUT', self.bucket, obj)
 
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = \
             auth_error_conn.make_request('DELETE', self.bucket, obj)
         self.assertEqual(get_error_code(body), 'SignatureDoesNotMatch')
diff -pruN 2.25.0-3/test/functional/s3api/test_service.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/s3api/test_service.py
--- 2.25.0-3/test/functional/s3api/test_service.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/s3api/test_service.py	2020-09-15 21:13:36.000000000 +0000
@@ -69,7 +69,7 @@ class TestS3ApiService(S3ApiBase):
             self.assertTrue(b.find('CreationDate') is not None)
 
     def test_service_error_signature_not_match(self):
-        auth_error_conn = Connection(aws_secret_key='invalid')
+        auth_error_conn = Connection(tf.config['s3_access_key'], 'invalid')
         status, headers, body = auth_error_conn.make_request('GET')
         self.assertEqual(get_error_code(body), 'SignatureDoesNotMatch')
         self.assertEqual(headers['content-type'], 'application/xml')
diff -pruN 2.25.0-3/test/functional/s3api/test_versioning.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/s3api/test_versioning.py
--- 2.25.0-3/test/functional/s3api/test_versioning.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/s3api/test_versioning.py	2020-09-15 21:13:36.000000000 +0000
@@ -58,7 +58,7 @@ class TestS3ApiVersioning(S3ApiBase):
             'GET', 'bucket', query='versioning')
         self.assertEqual(status, 200)
         elem = fromstring(body)
-        self.assertEqual(elem.getchildren(), [])
+        self.assertEqual(list(elem), [])
 
         # Enable versioning
         elem = Element('VersioningConfiguration')
@@ -108,7 +108,7 @@ class TestS3ApiVersioning(S3ApiBase):
             'GET', 'bucket', query='versioning')
         self.assertEqual(status, 200)
         elem = fromstring(body)
-        self.assertEqual(elem.getchildren(), [])
+        self.assertEqual(list(elem), [])
 
         # Suspend versioning
         elem = Element('VersioningConfiguration')
diff -pruN 2.25.0-3/test/functional/swift_test_client.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/swift_test_client.py
--- 2.25.0-3/test/functional/swift_test_client.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/swift_test_client.py	2020-09-15 21:13:36.000000000 +0000
@@ -225,6 +225,9 @@ class Connection(object):
 
     @storage_url.setter
     def storage_url(self, value):
+        if six.PY2 and not isinstance(value, bytes):
+            value = value.encode('utf-8')
+
         url = urllib.parse.urlparse(value)
 
         if url.scheme == 'http':
diff -pruN 2.25.0-3/test/functional/test_object.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/test_object.py
--- 2.25.0-3/test/functional/test_object.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/test_object.py	2020-09-15 21:13:36.000000000 +0000
@@ -1726,7 +1726,7 @@ class TestObject(unittest.TestCase):
         if 'etag_quoter' not in tf.cluster_info:
             raise SkipTest("etag-quoter middleware is not enabled")
 
-        def do_head(expect_quoted=False):
+        def do_head(expect_quoted=None):
             def head(url, token, parsed, conn):
                 conn.request('HEAD', '%s/%s/%s' % (
                     parsed.path, self.container, self.obj), '',
@@ -1736,6 +1736,11 @@ class TestObject(unittest.TestCase):
             resp = retry(head)
             resp.read()
             self.assertEqual(resp.status, 200)
+
+            if expect_quoted is None:
+                expect_quoted = tf.cluster_info.get('etag_quoter', {}).get(
+                    'enable_by_default', False)
+
             expected_etag = hashlib.md5(b'test').hexdigest()
             if expect_quoted:
                 expected_etag = '"%s"' % expected_etag
@@ -1766,11 +1771,15 @@ class TestObject(unittest.TestCase):
         do_head()
         post_container('t')
         do_head(expect_quoted=True)
-        post_account('t')
-        post_container('')
-        do_head(expect_quoted=True)
-        post_container('f')
-        do_head()
+        try:
+            post_account('t')
+            post_container('')
+            do_head(expect_quoted=True)
+            post_container('f')
+            do_head(expect_quoted=False)
+        finally:
+            # Don't leave a dirty account
+            post_account('')
 
 
 if __name__ == '__main__':
diff -pruN 2.25.0-3/test/functional/test_object_versioning.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/test_object_versioning.py
--- 2.25.0-3/test/functional/test_object_versioning.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/test_object_versioning.py	2020-09-15 21:13:36.000000000 +0000
@@ -26,6 +26,7 @@ from six.moves.urllib.parse import quote
 
 import test.functional as tf
 
+from swift.common.swob import normalize_etag
 from swift.common.utils import MD5_OF_EMPTY_STRING, config_true_value
 from swift.common.middleware.versioned_writes.object_versioning import \
     DELETE_MARKER_CONTENT_TYPE
@@ -293,7 +294,7 @@ class TestObjectVersioning(TestObjectVer
 
         # swift_test_client's File API doesn't really allow for POSTing
         # arbitrary headers, so...
-        def put(url, token, parsed, conn):
+        def post(url, token, parsed, conn):
             conn.request('POST', '%s/%s/%s' % (parsed.path, container,
                                                versioned_obj2.name),
                          '', {'X-Auth-Token': token,
@@ -301,7 +302,7 @@ class TestObjectVersioning(TestObjectVer
                               'X-Object-Meta-Color': 'red',
                               'X-Delete-After': '1'})
             return tf.check_response(conn)
-        resp = tf.retry(put)
+        resp = tf.retry(post)
         resp.read()
         self.assertEqual(resp.status, 202)
 
@@ -331,6 +332,80 @@ class TestObjectVersioning(TestObjectVer
         # listing, though, we'll only ever have the two entries.
         self.assertTotalVersions(container, 2)
 
+    def test_get_if_match(self):
+        body = b'data'
+        oname = Utils.create_name()
+        obj = self.env.unversioned_container.file(oname)
+        resp = obj.write(body, return_resp=True)
+        etag = resp.getheader('etag')
+        self.assertEqual(md5(body).hexdigest(), normalize_etag(etag))
+
+        # un-versioned object is cool with with if-match
+        self.assertEqual(body, obj.read(hdrs={'if-match': etag}))
+        with self.assertRaises(ResponseError) as cm:
+            obj.read(hdrs={'if-match': 'not-the-etag'})
+        self.assertEqual(412, cm.exception.status)
+
+        v_obj = self.env.container.file(oname)
+        resp = v_obj.write(body, return_resp=True)
+        self.assertEqual(resp.getheader('etag'), etag)
+
+        # versioned object is too with with if-match
+        self.assertEqual(body, v_obj.read(hdrs={
+            'if-match': normalize_etag(etag)}))
+        # works quoted, too
+        self.assertEqual(body, v_obj.read(hdrs={
+            'if-match': '"%s"' % normalize_etag(etag)}))
+        with self.assertRaises(ResponseError) as cm:
+            v_obj.read(hdrs={'if-match': 'not-the-etag'})
+        self.assertEqual(412, cm.exception.status)
+
+    def test_container_acls(self):
+        if tf.skip3:
+            raise SkipTest('Username3 not set')
+
+        obj = self.env.container.file(Utils.create_name())
+        resp = obj.write(b"data", return_resp=True)
+        version_id = resp.getheader('x-object-version-id')
+        self.assertIsNotNone(version_id)
+
+        with self.assertRaises(ResponseError) as cm:
+            obj.read(hdrs={'X-Auth-Token': self.env.conn3.storage_token})
+        self.assertEqual(403, cm.exception.status)
+
+        # Container ACLs work more or less like they always have
+        self.env.container.update_metadata(
+            hdrs={'X-Container-Read': self.env.conn3.user_acl})
+        self.assertEqual(b"data", obj.read(hdrs={
+            'X-Auth-Token': self.env.conn3.storage_token}))
+
+        # But the version-specifc GET still requires a swift owner
+        with self.assertRaises(ResponseError) as cm:
+            obj.read(hdrs={'X-Auth-Token': self.env.conn3.storage_token},
+                     parms={'version-id': version_id})
+        self.assertEqual(403, cm.exception.status)
+
+        # If it's pointing to a symlink that points elsewhere, that still needs
+        # to be authed
+        tgt_name = Utils.create_name()
+        self.env.unversioned_container.file(tgt_name).write(b'link')
+        sym_tgt_header = quote(unquote('%s/%s' % (
+            self.env.unversioned_container.name, tgt_name)))
+        obj.write(hdrs={'X-Symlink-Target': sym_tgt_header})
+
+        # So, user1's good...
+        self.assertEqual(b'link', obj.read())
+        # ...but user3 can't
+        with self.assertRaises(ResponseError) as cm:
+            obj.read(hdrs={'X-Auth-Token': self.env.conn3.storage_token})
+        self.assertEqual(403, cm.exception.status)
+
+        # unless we add the acl to the unversioned_container
+        self.env.unversioned_container.update_metadata(
+            hdrs={'X-Container-Read': self.env.conn3.user_acl})
+        self.assertEqual(b'link', obj.read(
+            hdrs={'X-Auth-Token': self.env.conn3.storage_token}))
+
     def _test_overwriting_setup(self, obj_name=None):
         # sanity
         container = self.env.container
@@ -919,13 +994,13 @@ class TestObjectVersioning(TestObjectVer
             'Content-Type': 'text/jibberish32'
         }, return_resp=True)
         v1_version_id = resp.getheader('x-object-version-id')
-        v1_etag = resp.getheader('etag')
+        v1_etag = normalize_etag(resp.getheader('etag'))
 
         resp = obj.write(b'version2', hdrs={
             'Content-Type': 'text/jibberish33'
         }, return_resp=True)
         v2_version_id = resp.getheader('x-object-version-id')
-        v2_etag = resp.getheader('etag')
+        v2_etag = normalize_etag(resp.getheader('etag'))
 
         # sanity
         self.assertEqual(b'version2', obj.read())
@@ -992,7 +1067,7 @@ class TestObjectVersioning(TestObjectVer
         self.assertEqual(b'version1', obj.read())
         obj_info = obj.info()
         self.assertEqual('text/jibberish32', obj_info['content_type'])
-        self.assertEqual(v1_etag, obj_info['etag'])
+        self.assertEqual(v1_etag, normalize_etag(obj_info['etag']))
 
     def test_delete_with_version_api_old_object(self):
         versioned_obj_name = Utils.create_name()
@@ -2308,7 +2383,7 @@ class TestSloWithVersioning(TestObjectVe
         expected = {
             'bytes': file_info['content_length'],
             'content_type': 'application/octet-stream',
-            'hash': manifest_info['etag'],
+            'hash': normalize_etag(manifest_info['etag']),
             'name': 'my-slo-manifest',
             'slo_etag': file_info['etag'],
             'version_symlink': True,
@@ -2340,7 +2415,7 @@ class TestSloWithVersioning(TestObjectVe
         expected = {
             'bytes': file_info['content_length'],
             'content_type': 'application/octet-stream',
-            'hash': manifest_info['etag'],
+            'hash': normalize_etag(manifest_info['etag']),
             'name': 'my-slo-manifest',
             'slo_etag': file_info['etag'],
             'version_symlink': True,
@@ -2688,16 +2763,11 @@ class TestVersioningContainerTempurl(Tes
         obj.write(b"version2")
 
         # get v2 object (reading from versions container)
-        # cross container tempurl does not work for container tempurl key
-        try:
-            obj.read(parms=get_parms, cfg={'no_auth_token': True})
-        except ResponseError as e:
-            self.assertEqual(e.status, 401)
-        else:
-            self.fail('request did not error')
-        try:
-            obj.info(parms=get_parms, cfg={'no_auth_token': True})
-        except ResponseError as e:
-            self.assertEqual(e.status, 401)
-        else:
-            self.fail('request did not error')
+        # versioning symlink allows us to bypass the normal
+        # container-tempurl-key scoping
+        contents = obj.read(parms=get_parms, cfg={'no_auth_token': True})
+        self.assert_status([200])
+        self.assertEqual(contents, b"version2")
+        # HEAD works, too
+        obj.info(parms=get_parms, cfg={'no_auth_token': True})
+        self.assert_status([200])
diff -pruN 2.25.0-3/test/functional/test_slo.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/test_slo.py
--- 2.25.0-3/test/functional/test_slo.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/test_slo.py	2020-09-15 21:13:36.000000000 +0000
@@ -23,6 +23,8 @@ from copy import deepcopy
 
 import six
 
+from swift.common.swob import normalize_etag
+
 import test.functional as tf
 from test.functional import cluster_info, SkipTest
 from test.functional.tests import Utils, Base, Base2, BaseEnv
@@ -299,8 +301,14 @@ class TestSlo(Base):
         # a POST.
         file_item.initialize(parms={'multipart-manifest': 'get'})
         manifest_etag = file_item.etag
-        self.assertFalse(manifest_etag.startswith('"'))
-        self.assertFalse(manifest_etag.endswith('"'))
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            self.assertTrue(manifest_etag.startswith('"'))
+            self.assertTrue(manifest_etag.endswith('"'))
+            # ...but in the listing, it'll be stripped
+            manifest_etag = manifest_etag[1:-1]
+        else:
+            self.assertFalse(manifest_etag.startswith('"'))
+            self.assertFalse(manifest_etag.endswith('"'))
 
         file_item.initialize()
         slo_etag = file_item.etag
@@ -715,6 +723,8 @@ class TestSlo(Base):
         source_contents = source.read(parms={'multipart-manifest': 'get'})
         source_json = json.loads(source_contents)
         manifest_etag = hashlib.md5(source_contents).hexdigest()
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            manifest_etag = '"%s"' % manifest_etag
         self.assertEqual(manifest_etag, source.etag)
 
         source.initialize()
@@ -752,14 +762,14 @@ class TestSlo(Base):
         actual = names['manifest-abcde']
         self.assertEqual(4 * 1024 * 1024 + 1, actual['bytes'])
         self.assertEqual('application/octet-stream', actual['content_type'])
-        self.assertEqual(manifest_etag, actual['hash'])
+        self.assertEqual(normalize_etag(manifest_etag), actual['hash'])
         self.assertEqual(slo_etag, actual['slo_etag'])
 
         self.assertIn('copied-abcde-manifest-only', names)
         actual = names['copied-abcde-manifest-only']
         self.assertEqual(4 * 1024 * 1024 + 1, actual['bytes'])
         self.assertEqual('application/octet-stream', actual['content_type'])
-        self.assertEqual(manifest_etag, actual['hash'])
+        self.assertEqual(normalize_etag(manifest_etag), actual['hash'])
         self.assertEqual(slo_etag, actual['slo_etag'])
 
         # Test copy manifest including data segments
@@ -789,6 +799,8 @@ class TestSlo(Base):
         source_contents = source.read(parms={'multipart-manifest': 'get'})
         source_json = json.loads(source_contents)
         manifest_etag = hashlib.md5(source_contents).hexdigest()
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            manifest_etag = '"%s"' % manifest_etag
         self.assertEqual(manifest_etag, source.etag)
 
         source.initialize()
@@ -831,14 +843,14 @@ class TestSlo(Base):
         self.assertEqual(4 * 1024 * 1024 + 1, actual['bytes'])
         self.assertEqual('application/octet-stream', actual['content_type'])
         # the container listing should have the etag of the manifest contents
-        self.assertEqual(manifest_etag, actual['hash'])
+        self.assertEqual(normalize_etag(manifest_etag), actual['hash'])
         self.assertEqual(slo_etag, actual['slo_etag'])
 
         self.assertIn('copied-abcde-manifest-only', names)
         actual = names['copied-abcde-manifest-only']
         self.assertEqual(4 * 1024 * 1024 + 1, actual['bytes'])
         self.assertEqual('image/jpeg', actual['content_type'])
-        self.assertEqual(manifest_etag, actual['hash'])
+        self.assertEqual(normalize_etag(manifest_etag), actual['hash'])
         self.assertEqual(slo_etag, actual['slo_etag'])
 
     def test_slo_copy_the_manifest_account(self):
@@ -1098,12 +1110,7 @@ class TestSlo(Base):
         manifest = self.env.container.file("manifest-db")
         got_body = manifest.read(parms={'multipart-manifest': 'get',
                                         'format': 'raw'})
-        body_md5 = hashlib.md5(got_body).hexdigest()
-        headers = dict(
-            (h.lower(), v)
-            for h, v in manifest.conn.response.getheaders())
-        self.assertIn('etag', headers)
-        self.assertEqual(headers['etag'], body_md5)
+        self.assert_etag(hashlib.md5(got_body).hexdigest())
 
         # raw format should have the actual manifest object content-type
         self.assertEqual('application/octet-stream', manifest.content_type)
diff -pruN 2.25.0-3/test/functional/tests.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/tests.py
--- 2.25.0-3/test/functional/tests.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/tests.py	2020-09-15 21:13:36.000000000 +0000
@@ -27,6 +27,7 @@ import uuid
 from copy import deepcopy
 import eventlet
 from swift.common.http import is_success, is_client_error
+from swift.common.swob import normalize_etag
 from email.utils import parsedate
 
 if six.PY2:
@@ -131,6 +132,13 @@ class Base(unittest.TestCase):
                 'Expected header name %r not found in response.' % header_name)
         self.assertEqual(expected_value, actual_value)
 
+    def assert_etag(self, unquoted_value):
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            expected = '"%s"' % unquoted_value
+        else:
+            expected = unquoted_value
+        self.assert_header('etag', expected)
+
 
 class Base2(object):
     @classmethod
@@ -874,7 +882,11 @@ class TestContainer(Base):
         for actual in file_list:
             name = actual['name']
             self.assertIn(name, expected)
-            self.assertEqual(expected[name]['etag'], actual['hash'])
+            if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+                self.assertEqual(expected[name]['etag'],
+                                 '"%s"' % actual['hash'])
+            else:
+                self.assertEqual(expected[name]['etag'], actual['hash'])
             self.assertEqual(
                 expected[name]['content_type'], actual['content_type'])
             self.assertEqual(
@@ -1365,6 +1377,8 @@ class TestFile(Base):
                             'x-delete-at': mock.ANY,
                             'x-trans-id': mock.ANY,
                             'x-openstack-request-id': mock.ANY}
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            expected_headers['etag'] = '"%s"' % expected_headers['etag']
         unexpected_headers = ['connection', 'x-delete-after']
         do_test(put_headers, {}, expected_headers, unexpected_headers)
 
@@ -1420,7 +1434,7 @@ class TestFile(Base):
                     self.fail('Failed to find %s in listing' % dest_filename)
 
                 self.assertEqual(file_item.size, obj['bytes'])
-                self.assertEqual(file_item.etag, obj['hash'])
+                self.assertEqual(normalize_etag(file_item.etag), obj['hash'])
                 self.assertEqual(file_item.content_type, obj['content_type'])
 
                 file_copy = cont.file(dest_filename)
@@ -1470,7 +1484,7 @@ class TestFile(Base):
                     self.fail('Failed to find %s in listing' % dest_filename)
 
                 self.assertEqual(file_item.size, obj['bytes'])
-                self.assertEqual(file_item.etag, obj['hash'])
+                self.assertEqual(normalize_etag(file_item.etag), obj['hash'])
                 self.assertEqual(
                     'application/test-changed', obj['content_type'])
 
@@ -1505,7 +1519,7 @@ class TestFile(Base):
                     self.fail('Failed to find %s in listing' % dest_filename)
 
                 self.assertEqual(file_item.size, obj['bytes'])
-                self.assertEqual(file_item.etag, obj['hash'])
+                self.assertEqual(normalize_etag(file_item.etag), obj['hash'])
                 self.assertEqual(
                     'application/test-updated', obj['content_type'])
 
@@ -2088,7 +2102,7 @@ class TestFile(Base):
                 self.assertEqual(file_item.read(hdrs=hdrs), data[-i:])
                 self.assert_header('content-range', 'bytes %d-%d/%d' % (
                     file_length - i, file_length - 1, file_length))
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
             self.assert_header('accept-ranges', 'bytes')
 
             range_string = 'bytes=%d-' % (i)
@@ -2102,7 +2116,7 @@ class TestFile(Base):
         self.assertRaises(ResponseError, file_item.read, hdrs=hdrs)
         self.assert_status(416)
         self.assert_header('content-range', 'bytes */%d' % file_length)
-        self.assert_header('etag', file_item.md5)
+        self.assert_etag(file_item.md5)
         self.assert_header('accept-ranges', 'bytes')
 
         range_string = 'bytes=%d-%d' % (file_length - 1000, file_length + 2000)
@@ -2416,14 +2430,16 @@ class TestFile(Base):
         file_item.content_type = content_type
         file_item.write_random(self.env.file_size)
 
-        md5 = file_item.md5
+        expected_etag = file_item.md5
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            expected_etag = '"%s"' % expected_etag
 
         file_item = self.env.container.file(file_name)
         info = file_item.info()
 
         self.assert_status(200)
         self.assertEqual(info['content_length'], self.env.file_size)
-        self.assertEqual(info['etag'], md5)
+        self.assertEqual(info['etag'], expected_etag)
         self.assertEqual(info['content_type'], content_type)
         self.assertIn('last_modified', info)
 
@@ -2612,14 +2628,7 @@ class TestFile(Base):
         file_item = self.env.container.file(Utils.create_name())
 
         data = io.BytesIO(file_item.write_random(512))
-        etag = File.compute_md5sum(data)
-
-        headers = dict((h.lower(), v)
-                       for h, v in self.env.conn.response.getheaders())
-        self.assertIn('etag', headers.keys())
-
-        header_etag = headers['etag'].strip('"')
-        self.assertEqual(etag, header_etag)
+        self.assert_etag(File.compute_md5sum(data))
 
     def testChunkedPut(self):
         if (tf.web_front_end == 'apache2'):
@@ -2645,7 +2654,7 @@ class TestFile(Base):
             self.assertEqual(data, file_item.read())
 
             info = file_item.info()
-            self.assertEqual(etag, info['etag'])
+            self.assertEqual(normalize_etag(info['etag']), etag)
 
     def test_POST(self):
         # verify consistency between object and container listing metadata
@@ -2670,7 +2679,10 @@ class TestFile(Base):
             self.fail('Failed to find file %r in listing' % file_name)
         self.assertEqual(1024, f_dict['bytes'])
         self.assertEqual('text/foobar', f_dict['content_type'])
-        self.assertEqual(etag, f_dict['hash'])
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            self.assertEqual(etag, '"%s"' % f_dict['hash'])
+        else:
+            self.assertEqual(etag, f_dict['hash'])
         put_last_modified = f_dict['last_modified']
 
         # now POST updated content-type to each file
@@ -2697,7 +2709,10 @@ class TestFile(Base):
         self.assertEqual(1024, f_dict['bytes'])
         self.assertEqual('image/foobarbaz', f_dict['content_type'])
         self.assertLess(put_last_modified, f_dict['last_modified'])
-        self.assertEqual(etag, f_dict['hash'])
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            self.assertEqual(etag, '"%s"' % f_dict['hash'])
+        else:
+            self.assertEqual(etag, f_dict['hash'])
 
 
 class TestFileUTF8(Base2, TestFile):
@@ -2742,7 +2757,7 @@ class TestFileComparison(Base):
             hdrs = {'If-Match': 'bogus'}
             self.assertRaises(ResponseError, file_item.read, hdrs=hdrs)
             self.assert_status(412)
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
 
     def testIfMatchMultipleEtags(self):
         for file_item in self.env.files:
@@ -2752,7 +2767,7 @@ class TestFileComparison(Base):
             hdrs = {'If-Match': '"bogus1", "bogus2", "bogus3"'}
             self.assertRaises(ResponseError, file_item.read, hdrs=hdrs)
             self.assert_status(412)
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
 
     def testIfNoneMatch(self):
         for file_item in self.env.files:
@@ -2762,7 +2777,7 @@ class TestFileComparison(Base):
             hdrs = {'If-None-Match': file_item.md5}
             self.assertRaises(ResponseError, file_item.read, hdrs=hdrs)
             self.assert_status(304)
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
             self.assert_header('accept-ranges', 'bytes')
 
     def testIfNoneMatchMultipleEtags(self):
@@ -2774,7 +2789,7 @@ class TestFileComparison(Base):
                     '"bogus1", "bogus2", "%s"' % file_item.md5}
             self.assertRaises(ResponseError, file_item.read, hdrs=hdrs)
             self.assert_status(304)
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
             self.assert_header('accept-ranges', 'bytes')
 
     def testIfModifiedSince(self):
@@ -2786,11 +2801,11 @@ class TestFileComparison(Base):
             hdrs = {'If-Modified-Since': self.env.time_new}
             self.assertRaises(ResponseError, file_item.read, hdrs=hdrs)
             self.assert_status(304)
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
             self.assert_header('accept-ranges', 'bytes')
             self.assertRaises(ResponseError, file_item.info, hdrs=hdrs)
             self.assert_status(304)
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
             self.assert_header('accept-ranges', 'bytes')
 
     def testIfUnmodifiedSince(self):
@@ -2802,10 +2817,10 @@ class TestFileComparison(Base):
             hdrs = {'If-Unmodified-Since': self.env.time_old_f2}
             self.assertRaises(ResponseError, file_item.read, hdrs=hdrs)
             self.assert_status(412)
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
             self.assertRaises(ResponseError, file_item.info, hdrs=hdrs)
             self.assert_status(412)
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
 
     def testIfMatchAndUnmodified(self):
         for file_item in self.env.files:
@@ -2817,13 +2832,13 @@ class TestFileComparison(Base):
                     'If-Unmodified-Since': self.env.time_new}
             self.assertRaises(ResponseError, file_item.read, hdrs=hdrs)
             self.assert_status(412)
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
 
             hdrs = {'If-Match': file_item.md5,
                     'If-Unmodified-Since': self.env.time_old_f3}
             self.assertRaises(ResponseError, file_item.read, hdrs=hdrs)
             self.assert_status(412)
-            self.assert_header('etag', file_item.md5)
+            self.assert_etag(file_item.md5)
 
     def testLastModified(self):
         file_name = Utils.create_name()
@@ -2844,7 +2859,7 @@ class TestFileComparison(Base):
         hdrs = {'If-Modified-Since': last_modified}
         self.assertRaises(ResponseError, file_item.read, hdrs=hdrs)
         self.assert_status(304)
-        self.assert_header('etag', etag)
+        self.assert_etag(etag)
         self.assert_header('accept-ranges', 'bytes')
 
         hdrs = {'If-Unmodified-Since': last_modified}
diff -pruN 2.25.0-3/test/functional/test_symlink.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/test_symlink.py
--- 2.25.0-3/test/functional/test_symlink.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/test_symlink.py	2020-09-15 21:13:36.000000000 +0000
@@ -25,6 +25,7 @@ from six.moves import urllib
 from uuid import uuid4
 
 from swift.common.http import is_success
+from swift.common.swob import normalize_etag
 from swift.common.utils import json, MD5_OF_EMPTY_STRING
 from swift.common.middleware.slo import SloGetContext
 from test.functional import check_response, retry, requires_acls, \
@@ -1135,7 +1136,7 @@ class TestSymlink(Base):
                                          etag=self.env.tgt_etag)
 
         # overwrite tgt object
-        old_tgt_etag = self.env.tgt_etag
+        old_tgt_etag = normalize_etag(self.env.tgt_etag)
         self.env._create_tgt_object(body='updated target body')
 
         # sanity
@@ -1380,7 +1381,7 @@ class TestSymlink(Base):
                          object_list[0]['symlink_path'])
         obj_info = object_list[0]
         self.assertIn('symlink_etag', obj_info)
-        self.assertEqual(self.env.tgt_etag,
+        self.assertEqual(normalize_etag(self.env.tgt_etag),
                          obj_info['symlink_etag'])
         self.assertEqual(int(self.env.tgt_length),
                          obj_info['symlink_bytes'])
@@ -1550,7 +1551,7 @@ class TestSymlinkSlo(Base):
             'symlink_path': '/v1/%s/%s/manifest-abcde' % (
                 self.account_name, self.env.container2.name),
             'symlink_bytes': 4 * 2 ** 20 + 1,
-            'symlink_etag': manifest_etag,
+            'symlink_etag': normalize_etag(manifest_etag),
         })
 
     def test_static_link_target_slo_manifest_wrong_etag(self):
@@ -1740,7 +1741,11 @@ class TestSymlinkToSloSegments(Base):
                 self.assertEqual(1024 * 1024, f_dict['bytes'])
                 self.assertEqual('application/octet-stream',
                                  f_dict['content_type'])
-                self.assertEqual(manifest_etag, f_dict['hash'])
+                if tf.cluster_info.get('etag_quoter', {}).get(
+                        'enable_by_default'):
+                    self.assertEqual(manifest_etag, '"%s"' % f_dict['hash'])
+                else:
+                    self.assertEqual(manifest_etag, f_dict['hash'])
                 self.assertEqual(slo_etag, f_dict['slo_etag'])
                 break
         else:
@@ -1759,7 +1764,11 @@ class TestSymlinkToSloSegments(Base):
                 self.assertEqual(1024 * 1024, f_dict['bytes'])
                 self.assertEqual(file_item.content_type,
                                  f_dict['content_type'])
-                self.assertEqual(manifest_etag, f_dict['hash'])
+                if tf.cluster_info.get('etag_quoter', {}).get(
+                        'enable_by_default'):
+                    self.assertEqual(manifest_etag, '"%s"' % f_dict['hash'])
+                else:
+                    self.assertEqual(manifest_etag, f_dict['hash'])
                 self.assertEqual(slo_etag, f_dict['slo_etag'])
                 break
         else:
@@ -1778,7 +1787,11 @@ class TestSymlinkToSloSegments(Base):
                 self.assertEqual(1024 * 1024, f_dict['bytes'])
                 self.assertEqual(file_item.content_type,
                                  f_dict['content_type'])
-                self.assertEqual(manifest_etag, f_dict['hash'])
+                if tf.cluster_info.get('etag_quoter', {}).get(
+                        'enable_by_default'):
+                    self.assertEqual(manifest_etag, '"%s"' % f_dict['hash'])
+                else:
+                    self.assertEqual(manifest_etag, f_dict['hash'])
                 self.assertEqual(slo_etag, f_dict['slo_etag'])
                 break
         else:
@@ -1811,6 +1824,8 @@ class TestSymlinkToSloSegments(Base):
         source_contents = source.read(parms={'multipart-manifest': 'get'})
         source_json = json.loads(source_contents)
         manifest_etag = hashlib.md5(source_contents).hexdigest()
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            manifest_etag = '"%s"' % manifest_etag
 
         source.initialize()
         slo_etag = source.etag
@@ -1857,14 +1872,20 @@ class TestSymlinkToSloSegments(Base):
         actual = names['manifest-linkto-ab']
         self.assertEqual(2 * 1024 * 1024, actual['bytes'])
         self.assertEqual('application/octet-stream', actual['content_type'])
-        self.assertEqual(manifest_etag, actual['hash'])
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            self.assertEqual(manifest_etag, '"%s"' % actual['hash'])
+        else:
+            self.assertEqual(manifest_etag, actual['hash'])
         self.assertEqual(slo_etag, actual['slo_etag'])
 
         self.assertIn('copied-ab-manifest-only', names)
         actual = names['copied-ab-manifest-only']
         self.assertEqual(2 * 1024 * 1024, actual['bytes'])
         self.assertEqual('application/octet-stream', actual['content_type'])
-        self.assertEqual(manifest_etag, actual['hash'])
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            self.assertEqual(manifest_etag, '"%s"' % actual['hash'])
+        else:
+            self.assertEqual(manifest_etag, actual['hash'])
         self.assertEqual(slo_etag, actual['slo_etag'])
 
 
@@ -2000,13 +2021,13 @@ class TestSymlinkTargetObjectComparison(
             else:
                 self.assertEqual(b'', body)
             self.assert_status(200)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
 
             hdrs = {'If-Match': 'bogus'}
             self.assertRaises(ResponseError, file_symlink.read, hdrs=hdrs,
                               parms=self.env.parms)
             self.assert_status(412)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
 
     def testIfMatchMultipleEtags(self):
         for file_item in self.env.files:
@@ -2022,13 +2043,13 @@ class TestSymlinkTargetObjectComparison(
             else:
                 self.assertEqual(b'', body)
             self.assert_status(200)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
 
             hdrs = {'If-Match': '"bogus1", "bogus2", "bogus3"'}
             self.assertRaises(ResponseError, file_symlink.read, hdrs=hdrs,
                               parms=self.env.parms)
             self.assert_status(412)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
 
     def testIfNoneMatch(self):
         for file_item in self.env.files:
@@ -2044,13 +2065,13 @@ class TestSymlinkTargetObjectComparison(
             else:
                 self.assertEqual(b'', body)
             self.assert_status(200)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
 
             hdrs = {'If-None-Match': md5}
             self.assertRaises(ResponseError, file_symlink.read, hdrs=hdrs,
                               parms=self.env.parms)
             self.assert_status(304)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
             self.assert_header('accept-ranges', 'bytes')
 
     def testIfNoneMatchMultipleEtags(self):
@@ -2067,14 +2088,14 @@ class TestSymlinkTargetObjectComparison(
             else:
                 self.assertEqual(b'', body)
             self.assert_status(200)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
 
             hdrs = {'If-None-Match':
                     '"bogus1", "bogus2", "%s"' % md5}
             self.assertRaises(ResponseError, file_symlink.read, hdrs=hdrs,
                               parms=self.env.parms)
             self.assert_status(304)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
             self.assert_header('accept-ranges', 'bytes')
 
     def testIfModifiedSince(self):
@@ -2091,19 +2112,19 @@ class TestSymlinkTargetObjectComparison(
             else:
                 self.assertEqual(b'', body)
             self.assert_status(200)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
             self.assertTrue(file_symlink.info(hdrs=hdrs, parms=self.env.parms))
 
             hdrs = {'If-Modified-Since': self.env.time_new}
             self.assertRaises(ResponseError, file_symlink.read, hdrs=hdrs,
                               parms=self.env.parms)
             self.assert_status(304)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
             self.assert_header('accept-ranges', 'bytes')
             self.assertRaises(ResponseError, file_symlink.info, hdrs=hdrs,
                               parms=self.env.parms)
             self.assert_status(304)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
             self.assert_header('accept-ranges', 'bytes')
 
     def testIfUnmodifiedSince(self):
@@ -2120,18 +2141,18 @@ class TestSymlinkTargetObjectComparison(
             else:
                 self.assertEqual(b'', body)
             self.assert_status(200)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
             self.assertTrue(file_symlink.info(hdrs=hdrs, parms=self.env.parms))
 
             hdrs = {'If-Unmodified-Since': self.env.time_old_f2}
             self.assertRaises(ResponseError, file_symlink.read, hdrs=hdrs,
                               parms=self.env.parms)
             self.assert_status(412)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
             self.assertRaises(ResponseError, file_symlink.info, hdrs=hdrs,
                               parms=self.env.parms)
             self.assert_status(412)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
 
     def testIfMatchAndUnmodified(self):
         for file_item in self.env.files:
@@ -2148,21 +2169,21 @@ class TestSymlinkTargetObjectComparison(
             else:
                 self.assertEqual(b'', body)
             self.assert_status(200)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
 
             hdrs = {'If-Match': 'bogus',
                     'If-Unmodified-Since': self.env.time_new}
             self.assertRaises(ResponseError, file_symlink.read, hdrs=hdrs,
                               parms=self.env.parms)
             self.assert_status(412)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
 
             hdrs = {'If-Match': md5,
                     'If-Unmodified-Since': self.env.time_old_f3}
             self.assertRaises(ResponseError, file_symlink.read, hdrs=hdrs,
                               parms=self.env.parms)
             self.assert_status(412)
-            self.assert_header('etag', md5)
+            self.assert_etag(md5)
 
     def testLastModified(self):
         file_item = self.env.container.file(Utils.create_name())
@@ -2186,7 +2207,7 @@ class TestSymlinkTargetObjectComparison(
         hdrs = {'If-Modified-Since': last_modified}
         self.assertRaises(ResponseError, file_symlink.read, hdrs=hdrs)
         self.assert_status(304)
-        self.assert_header('etag', md5)
+        self.assert_etag(md5)
         self.assert_header('accept-ranges', 'bytes')
 
         hdrs = {'If-Unmodified-Since': last_modified}
@@ -2227,20 +2248,20 @@ class TestSymlinkComparison(TestSymlinkT
         body = file_symlink.read(hdrs=hdrs, parms=self.env.parms)
         self.assertEqual(b'', body)
         self.assert_status(200)
-        self.assert_header('etag', md5)
+        self.assert_etag(md5)
 
         hdrs = {'If-Modified-Since': last_modified}
         self.assertRaises(ResponseError, file_symlink.read, hdrs=hdrs,
                           parms=self.env.parms)
         self.assert_status(304)
-        self.assert_header('etag', md5)
+        self.assert_etag(md5)
         self.assert_header('accept-ranges', 'bytes')
 
         hdrs = {'If-Unmodified-Since': last_modified}
         body = file_symlink.read(hdrs=hdrs, parms=self.env.parms)
         self.assertEqual(b'', body)
         self.assert_status(200)
-        self.assert_header('etag', md5)
+        self.assert_etag(md5)
 
 
 class TestSymlinkAccountTempurl(Base):
diff -pruN 2.25.0-3/test/functional/test_versioned_writes.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/test_versioned_writes.py
--- 2.25.0-3/test/functional/test_versioned_writes.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/functional/test_versioned_writes.py	2020-09-15 21:13:36.000000000 +0000
@@ -684,7 +684,11 @@ class TestObjectVersioning(Base):
         prev_version = versions_container.file(versioned_obj_name)
         prev_version_info = prev_version.info(parms={'symlink': 'get'})
         self.assertEqual(b"aaaaa", prev_version.read())
-        self.assertEqual(MD5_OF_EMPTY_STRING, prev_version_info['etag'])
+        symlink_etag = prev_version_info['etag']
+        if symlink_etag.startswith('"') and symlink_etag.endswith('"') and \
+                symlink_etag[1:-1]:
+            symlink_etag = symlink_etag[1:-1]
+        self.assertEqual(MD5_OF_EMPTY_STRING, symlink_etag)
         self.assertEqual(sym_tgt_header,
                          prev_version_info['x_symlink_target'])
         return symlink, tgt_a
@@ -698,7 +702,10 @@ class TestObjectVersioning(Base):
         symlink.delete()
         sym_info = symlink.info(parms={'symlink': 'get'})
         self.assertEqual(b"aaaaa", symlink.read())
-        self.assertEqual(MD5_OF_EMPTY_STRING, sym_info['etag'])
+        if tf.cluster_info.get('etag_quoter', {}).get('enable_by_default'):
+            self.assertEqual('"%s"' % MD5_OF_EMPTY_STRING, sym_info['etag'])
+        else:
+            self.assertEqual(MD5_OF_EMPTY_STRING, sym_info['etag'])
         self.assertEqual(
             quote(unquote('%s/%s' % (self.env.container.name, target.name))),
             sym_info['x_symlink_target'])
diff -pruN 2.25.0-3/test/__init__.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/__init__.py
--- 2.25.0-3/test/__init__.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/__init__.py	2020-09-15 21:13:36.000000000 +0000
@@ -37,6 +37,12 @@ except ImportError:
             return result
         return result[:_MAX_LENGTH] + ' [truncated]...'
 
+import warnings
+warnings.filterwarnings('ignore', module='cryptography', message=(
+    'Python 2 is no longer supported by the Python core team. '
+    'Support for it is now deprecated in cryptography, '
+    'and will be removed in a future release.'))
+
 from eventlet.green import socket
 
 # make unittests pass on all locale
diff -pruN 2.25.0-3/test/probe/brain.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/brain.py
--- 2.25.0-3/test/probe/brain.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/brain.py	2020-09-15 21:13:36.000000000 +0000
@@ -31,6 +31,7 @@ from swift.common.http import HTTP_NOT_F
 
 from swiftclient import client, get_auth, ClientException
 
+from test.probe import PROXY_BASE_URL
 from test.probe.common import ENABLED_POLICIES
 
 TIMEOUT = 60
@@ -340,7 +341,7 @@ def main():
         if cmd not in BrainSplitter.__commands__:
             parser.print_help()
             return 'ERROR: unknown command %s' % cmd
-    url, token = get_auth('http://127.0.0.1:8080/auth/v1.0',
+    url, token = get_auth(PROXY_BASE_URL + '/auth/v1.0',
                           'test:tester', 'testing')
     if options.server_type == 'object' and not options.policy_name:
         options.policy_name = POLICIES.default.name
diff -pruN 2.25.0-3/test/probe/common.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/common.py
--- 2.25.0-3/test/probe/common.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/common.py	2020-09-15 21:13:36.000000000 +0000
@@ -39,7 +39,7 @@ from swift.common.manager import Manager
 from swift.common.storage_policy import POLICIES, EC_POLICY, REPL_POLICY
 from swift.obj.diskfile import get_data_dir
 
-from test.probe import CHECK_SERVER_TIMEOUT, VALIDATE_RSYNC
+from test.probe import CHECK_SERVER_TIMEOUT, VALIDATE_RSYNC, PROXY_BASE_URL
 
 
 ENABLED_POLICIES = [p for p in POLICIES if not p.is_deprecated]
@@ -80,8 +80,8 @@ def _check_storage(ipport, path):
     return resp
 
 
-def _check_proxy(ipport, user, key):
-    url, token = get_auth('http://%s:%d/auth/v1.0' % ipport,
+def _check_proxy(user, key):
+    url, token = get_auth(PROXY_BASE_URL + '/auth/v1.0',
                           user, key)
     account = url.split('/')[-1]
     head_account(url, token)
@@ -118,7 +118,7 @@ def check_server(ipport, ipport2server):
         rv = _retry_timeout(_check_storage, args=(ipport, path))
     else:
         rv = _retry_timeout(_check_proxy, args=(
-            ipport, 'test:tester', 'testing'))
+            'test:tester', 'testing'))
     return rv
 
 
@@ -392,7 +392,7 @@ class ProbeTest(unittest.TestCase):
                 'url': self.url, 'token': self.token, 'account': self.account}
 
             rv = _retry_timeout(_check_proxy, args=(
-                proxy_ipport, 'test2:tester2', 'testing2'))
+                'test2:tester2', 'testing2'))
             self.account_2 = {
                 k: v for (k, v) in zip(('url', 'token', 'account'), rv)}
 
@@ -416,7 +416,7 @@ class ProbeTest(unittest.TestCase):
     def tearDown(self):
         Manager(['all']).kill()
 
-    def device_dir(self, server, node):
+    def device_dir(self, node):
         server_type, config_number = get_server_number(
             (node['ip'], node['port']), self.ipport2server)
         repl_server = '%s-replicator' % server_type
@@ -424,9 +424,9 @@ class ProbeTest(unittest.TestCase):
                         section_name=repl_server)
         return os.path.join(conf['devices'], node['device'])
 
-    def storage_dir(self, server, node, part=None, policy=None):
+    def storage_dir(self, node, part=None, policy=None):
         policy = policy or self.policy
-        device_path = self.device_dir(server, node)
+        device_path = self.device_dir(node)
         path_parts = [device_path, get_data_dir(policy)]
         if part is not None:
             path_parts.append(str(part))
@@ -526,7 +526,7 @@ class ProbeTest(unittest.TestCase):
         """
         async_pendings = []
         for onode in onodes:
-            device_dir = self.device_dir('', onode)
+            device_dir = self.device_dir(onode)
             for ap_pol_dir in os.listdir(device_dir):
                 if not ap_pol_dir.startswith('async_pending'):
                     # skip 'objects', 'containers', etc.
diff -pruN 2.25.0-3/test/probe/__init__.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/__init__.py
--- 2.25.0-3/test/probe/__init__.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/__init__.py	2020-09-15 21:13:36.000000000 +0000
@@ -14,6 +14,9 @@
 # limitations under the License.
 
 
+import eventlet
+eventlet.monkey_patch()
+
 from test import get_config
 from swift.common.utils import config_true_value
 
@@ -21,3 +24,8 @@ from swift.common.utils import config_tr
 config = get_config('probe_test')
 CHECK_SERVER_TIMEOUT = int(config.get('check_server_timeout', 30))
 VALIDATE_RSYNC = config_true_value(config.get('validate_rsync', False))
+PROXY_BASE_URL = config.get('proxy_base_url')
+if PROXY_BASE_URL is None:
+    # TODO: find and load an "appropriate" proxy-server.conf(.d), piece
+    # something together from bind_ip, bind_port, and cert_file
+    PROXY_BASE_URL = 'http://127.0.0.1:8080'
diff -pruN 2.25.0-3/test/probe/test_account_get_fake_responses_match.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_account_get_fake_responses_match.py
--- 2.25.0-3/test/probe/test_account_get_fake_responses_match.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_account_get_fake_responses_match.py	2020-09-15 21:13:36.000000000 +0000
@@ -20,6 +20,7 @@ import unittest
 from six.moves import http_client
 from six.moves.urllib.parse import urlparse
 from swiftclient import get_auth
+from test.probe import PROXY_BASE_URL
 from test.probe.common import ReplProbeTest
 
 
@@ -28,7 +29,7 @@ class TestAccountGetFakeResponsesMatch(R
     def setUp(self):
         super(TestAccountGetFakeResponsesMatch, self).setUp()
         self.url, self.token = get_auth(
-            'http://127.0.0.1:8080/auth/v1.0', 'admin:admin', 'admin')
+            PROXY_BASE_URL + '/auth/v1.0', 'admin:admin', 'admin')
 
     def _account_path(self, account):
         _, _, path, _, _, _ = urlparse(self.url)
@@ -46,10 +47,15 @@ class TestAccountGetFakeResponsesMatch(R
         headers['X-Auth-Token'] = self.token
 
         scheme, netloc, path, _, _, _ = urlparse(self.url)
-        host, port = netloc.split(':')
+        host, port = netloc.partition(':')[::2]
+        if not port:
+            port = '443' if scheme == 'https' else '80'
         port = int(port)
 
-        conn = http_client.HTTPConnection(host, port)
+        if scheme == 'https':
+            conn = http_client.HTTPSConnection(host, port)
+        else:
+            conn = http_client.HTTPConnection(host, port)
         conn.request(method, self._account_path(account), headers=headers)
         resp = conn.getresponse()
         if resp.status // 100 != 2:
diff -pruN 2.25.0-3/test/probe/test_container_failures.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_container_failures.py
--- 2.25.0-3/test/probe/test_container_failures.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_container_failures.py	2020-09-15 21:13:36.000000000 +0000
@@ -125,12 +125,41 @@ class TestContainerFailures(ReplProbeTes
         self.assertEqual(headers['x-account-object-count'], '0')
         self.assertEqual(headers['x-account-bytes-used'], '0')
 
+    def test_all_nodes_fail(self):
+        # Create container1
+        container1 = 'container-%s' % uuid4()
+        cpart, cnodes = self.container_ring.get_nodes(self.account, container1)
+        client.put_container(self.url, self.token, container1)
+        client.put_object(self.url, self.token, container1, 'obj1', 'data1')
+
+        # All primaries go down
+        for cnode in cnodes:
+            kill_server((cnode['ip'], cnode['port']), self.ipport2server)
+
+        # Can't GET the container
+        with self.assertRaises(client.ClientException) as caught:
+            client.get_container(self.url, self.token, container1)
+        self.assertEqual(caught.exception.http_status, 503)
+
+        # But we can still write objects! The old info is still in memcache
+        client.put_object(self.url, self.token, container1, 'obj2', 'data2')
+
+        # Can't POST the container, either
+        with self.assertRaises(client.ClientException) as caught:
+            client.post_container(self.url, self.token, container1, {})
+        self.assertEqual(caught.exception.http_status, 503)
+
+        # Though it *does* evict the cache
+        with self.assertRaises(client.ClientException) as caught:
+            client.put_object(self.url, self.token, container1, 'obj3', 'x')
+        self.assertEqual(caught.exception.http_status, 503)
+
     def _get_container_db_files(self, container):
         opart, onodes = self.container_ring.get_nodes(self.account, container)
         onode = onodes[0]
         db_files = []
         for onode in onodes:
-            node_id = (onode['port'] - 6000) // 10
+            node_id = (onode['port'] % 100) // 10
             device = onode['device']
             hash_str = hash_path(self.account, container)
             server_conf = readconf(self.configs['container-server'][node_id])
diff -pruN 2.25.0-3/test/probe/test_object_async_update.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_object_async_update.py
--- 2.25.0-3/test/probe/test_object_async_update.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_object_async_update.py	2020-09-15 21:13:36.000000000 +0000
@@ -23,6 +23,7 @@ from swiftclient.exceptions import Clien
 
 from swift.common import direct_client
 from swift.common.manager import Manager
+from swift.common.swob import normalize_etag
 from test.probe.common import kill_nonprimary_server, \
     kill_server, ReplProbeTest, start_server, ECProbeTest
 
@@ -210,7 +211,7 @@ class TestUpdateOverridesEC(ECProbeTest)
         self.assertEqual(1, len(listing))
         self.assertEqual('o1', listing[0]['name'])
         self.assertEqual(len(content), listing[0]['bytes'])
-        self.assertEqual(meta['etag'], listing[0]['hash'])
+        self.assertEqual(normalize_etag(meta['etag']), listing[0]['hash'])
         self.assertEqual('test/ctype', listing[0]['content_type'])
 
     def test_update_during_POST_only(self):
@@ -261,7 +262,7 @@ class TestUpdateOverridesEC(ECProbeTest)
         self.assertEqual(1, len(listing))
         self.assertEqual('o1', listing[0]['name'])
         self.assertEqual(len(content), listing[0]['bytes'])
-        self.assertEqual(meta['etag'], listing[0]['hash'])
+        self.assertEqual(normalize_etag(meta['etag']), listing[0]['hash'])
         self.assertEqual('test/ctype', listing[0]['content_type'])
 
         # Run the object-updaters to send the async pending from the PUT
@@ -328,7 +329,7 @@ class TestUpdateOverridesEC(ECProbeTest)
         self.assertEqual(1, len(listing))
         self.assertEqual('o1', listing[0]['name'])
         self.assertEqual(len(content), listing[0]['bytes'])
-        self.assertEqual(meta['etag'], listing[0]['hash'])
+        self.assertEqual(normalize_etag(meta['etag']), listing[0]['hash'])
         self.assertEqual('test/ctype', listing[0]['content_type'])
 
 
diff -pruN 2.25.0-3/test/probe/test_object_failures.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_object_failures.py
--- 2.25.0-3/test/probe/test_object_failures.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_object_failures.py	2020-09-15 21:13:36.000000000 +0000
@@ -63,7 +63,7 @@ class TestObjectFailures(ReplProbeTest):
         opart, onodes = self.object_ring.get_nodes(
             self.account, container, obj)
         onode = onodes[0]
-        node_id = (onode['port'] - 6000) / 10
+        node_id = (onode['port'] % 100) / 10
         device = onode['device']
         hash_str = hash_path(self.account, container, obj)
         obj_server_conf = readconf(self.configs['object-server'][node_id])
@@ -233,7 +233,7 @@ class TestECObjectFailures(ECProbeTest):
 
         # make all fragments non-durable
         for node in onodes:
-            part_dir = self.storage_dir('object', node, part=opart)
+            part_dir = self.storage_dir(node, part=opart)
             for dirs, subdirs, files in os.walk(part_dir):
                 for fname in files:
                     if fname.endswith('.data'):
diff -pruN 2.25.0-3/test/probe/test_object_handoff.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_object_handoff.py
--- 2.25.0-3/test/probe/test_object_handoff.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_object_handoff.py	2020-09-15 21:13:36.000000000 +0000
@@ -92,7 +92,7 @@ class TestObjectHandoff(ReplProbeTest):
         # drop a tempfile in the handoff's datadir, like it might have
         # had if there was an rsync failure while it was previously a
         # primary
-        handoff_device_path = self.device_dir('object', another_onode)
+        handoff_device_path = self.device_dir(another_onode)
         data_filename = None
         for root, dirs, files in os.walk(handoff_device_path):
             for filename in files:
@@ -139,13 +139,13 @@ class TestObjectHandoff(ReplProbeTest):
                 port_num = node['replication_port']
             except KeyError:
                 port_num = node['port']
-            node_id = (port_num - 6000) // 10
+            node_id = (port_num % 100) // 10
             Manager(['object-replicator']).once(number=node_id)
         try:
             another_port_num = another_onode['replication_port']
         except KeyError:
             another_port_num = another_onode['port']
-        another_num = (another_port_num - 6000) // 10
+        another_num = (another_port_num % 100) // 10
         Manager(['object-replicator']).once(number=another_num)
 
         # Assert the first container/obj primary server now has container/obj
@@ -156,7 +156,7 @@ class TestObjectHandoff(ReplProbeTest):
 
         # and that it does *not* have a temporary rsync dropping!
         found_data_filename = False
-        primary_device_path = self.device_dir('object', onode)
+        primary_device_path = self.device_dir(onode)
         for root, dirs, files in os.walk(primary_device_path):
             for filename in files:
                 if filename.endswith('.6MbL6r'):
@@ -231,9 +231,9 @@ class TestObjectHandoff(ReplProbeTest):
                 port_num = node['replication_port']
             except KeyError:
                 port_num = node['port']
-            node_id = (port_num - 6000) // 10
+            node_id = (port_num % 100) // 10
             Manager(['object-replicator']).once(number=node_id)
-        another_node_id = (another_port_num - 6000) // 10
+        another_node_id = (another_port_num % 100) // 10
         Manager(['object-replicator']).once(number=another_node_id)
 
         # Assert primary node no longer has container/obj
@@ -398,7 +398,7 @@ class TestECObjectHandoff(ECProbeTest):
 
         # shutdown one of the primary data nodes
         failed_primary = random.choice(onodes)
-        failed_primary_device_path = self.device_dir('object', failed_primary)
+        failed_primary_device_path = self.device_dir(failed_primary)
         # first read its ec etag value for future reference - this may not
         # equal old_contents.etag if for example the proxy has crypto enabled
         req_headers = {'X-Backend-Storage-Policy-Index': int(self.policy)}
@@ -437,7 +437,7 @@ class TestECObjectHandoff(ECProbeTest):
             object_name, headers=req_headers)
         new_backend_etag = headers['X-Object-Sysmeta-EC-Etag']
         for node in other_nodes[:2]:
-            self.kill_drive(self.device_dir('object', node))
+            self.kill_drive(self.device_dir(node))
 
         # sanity, after taking out two primaries we should be down to
         # only four primaries, one of which has the old etag - but we
@@ -600,8 +600,7 @@ class TestECObjectHandoff(ECProbeTest):
         # shutdown three of the primary data nodes
         for i in range(3):
             failed_primary = onodes[i]
-            failed_primary_device_path = self.device_dir('object',
-                                                         failed_primary)
+            failed_primary_device_path = self.device_dir(failed_primary)
             self.kill_drive(failed_primary_device_path)
 
         # Indirectly (i.e., through proxy) try to GET object, it should return
diff -pruN 2.25.0-3/test/probe/test_object_metadata_replication.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_object_metadata_replication.py
--- 2.25.0-3/test/probe/test_object_metadata_replication.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_object_metadata_replication.py	2020-09-15 21:13:36.000000000 +0000
@@ -22,6 +22,7 @@ import uuid
 from swift.common.direct_client import direct_get_suffix_hashes
 from swift.common.exceptions import DiskFileDeleted
 from swift.common.internal_client import UnexpectedResponse
+from swift.common.swob import normalize_etag
 from swift.container.backend import ContainerBroker
 from swift.common import utils
 from swiftclient import client
@@ -129,7 +130,7 @@ class Test(ReplProbeTest):
 
     def _assert_object_metadata_matches_listing(self, listing, metadata):
         self.assertEqual(listing['bytes'], int(metadata['content-length']))
-        self.assertEqual(listing['hash'], metadata['etag'])
+        self.assertEqual(listing['hash'], normalize_etag(metadata['etag']))
         self.assertEqual(listing['content_type'], metadata['content-type'])
         modified = Timestamp(metadata['x-timestamp']).isoformat
         self.assertEqual(listing['last_modified'], modified)
diff -pruN 2.25.0-3/test/probe/test_object_partpower_increase.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_object_partpower_increase.py
--- 2.25.0-3/test/probe/test_object_partpower_increase.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_object_partpower_increase.py	2020-09-15 21:13:36.000000000 +0000
@@ -50,7 +50,7 @@ class TestPartPowerIncrease(ProbeTest):
         self.data = ' ' * getattr(self.policy, 'ec_segment_size', 1)
 
         self.devices = [
-            self.device_dir('object', {'ip': ip, 'port': port, 'device': ''})
+            self.device_dir({'ip': ip, 'port': port, 'device': ''})
             for ip, port in {(dev['ip'], dev['port'])
                              for dev in self.object_ring.devs}]
 
@@ -80,7 +80,7 @@ class TestPartPowerIncrease(ProbeTest):
             self.account, container, obj)
         for node in onodes:
             start_dir = os.path.join(
-                self.device_dir('object', node),
+                self.device_dir(node),
                 get_data_dir(self.policy),
                 str(opart))
             for root, dirs, files in os.walk(start_dir):
diff -pruN 2.25.0-3/test/probe/test_reconstructor_rebuild.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_reconstructor_rebuild.py
--- 2.25.0-3/test/probe/test_reconstructor_rebuild.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_reconstructor_rebuild.py	2020-09-15 21:13:36.000000000 +0000
@@ -149,7 +149,7 @@ class TestReconstructorRebuild(ECProbeTe
         # delete partitions on the failed nodes and remove durable marker from
         # non-durable nodes
         for i, node in enumerate(self.onodes):
-            part_dir = self.storage_dir('object', node, part=self.opart)
+            part_dir = self.storage_dir(node, part=self.opart)
             if i in failed:
                 shutil.rmtree(part_dir, True)
                 try:
@@ -312,7 +312,7 @@ class TestReconstructorRebuild(ECProbeTe
             partner_node, self.opart)
 
         # and 507 the failed partner device
-        device_path = self.device_dir('object', partner_node)
+        device_path = self.device_dir(partner_node)
         self.kill_drive(device_path)
 
         # reconstruct from the primary, while one of it's partners is 507'd
@@ -412,7 +412,7 @@ class TestReconstructorRebuild(ECProbeTe
                           self.object_name, headers=headers, contents=contents)
         # fail a primary
         post_fail_node = random.choice(onodes)
-        post_fail_path = self.device_dir('object', post_fail_node)
+        post_fail_path = self.device_dir(post_fail_node)
         self.kill_drive(post_fail_path)
         # post over w/o x-delete-at
         client.post_object(self.url, self.token, self.container_name,
diff -pruN 2.25.0-3/test/probe/test_reconstructor_revert.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_reconstructor_revert.py
--- 2.25.0-3/test/probe/test_reconstructor_revert.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_reconstructor_revert.py	2020-09-15 21:13:36.000000000 +0000
@@ -79,8 +79,8 @@ class TestReconstructorRevert(ECProbeTes
         # kill 2 a parity count number of primary nodes so we can
         # force data onto handoffs, we do that by renaming dev dirs
         # to induce 507
-        p_dev1 = self.device_dir('object', onodes[0])
-        p_dev2 = self.device_dir('object', onodes[1])
+        p_dev1 = self.device_dir(onodes[0])
+        p_dev2 = self.device_dir(onodes[1])
         self.kill_drive(p_dev1)
         self.kill_drive(p_dev2)
 
@@ -108,7 +108,7 @@ class TestReconstructorRevert(ECProbeTes
                           (onode,))
 
         # now take out another primary
-        p_dev3 = self.device_dir('object', onodes[2])
+        p_dev3 = self.device_dir(onodes[2])
         self.kill_drive(p_dev3)
 
         # this node can't servce the data any more
@@ -132,7 +132,7 @@ class TestReconstructorRevert(ECProbeTes
 
         # fire up reconstructor on handoff nodes only
         for hnode in hnodes:
-            hnode_id = (hnode['port'] - 6000) // 10
+            hnode_id = (hnode['port'] % 100) // 10
             self.reconstructor.once(number=hnode_id)
 
         # first three primaries have data again
@@ -177,7 +177,7 @@ class TestReconstructorRevert(ECProbeTes
         # now lets shut down a couple of primaries
         failed_nodes = random.sample(onodes, 2)
         for node in failed_nodes:
-            self.kill_drive(self.device_dir('object', node))
+            self.kill_drive(self.device_dir(node))
 
         # Write tombstones over the nodes that are still online
         client.delete_object(self.url, self.token,
@@ -228,8 +228,8 @@ class TestReconstructorRevert(ECProbeTes
             self.fail('Found obj data on %r' % hnodes[1])
 
         # repair the primaries
-        self.revive_drive(self.device_dir('object', failed_nodes[0]))
-        self.revive_drive(self.device_dir('object', failed_nodes[1]))
+        self.revive_drive(self.device_dir(failed_nodes[0]))
+        self.revive_drive(self.device_dir(failed_nodes[1]))
 
         # run reconstructor on second handoff
         self.reconstructor.once(number=self.config_number(hnodes[1]))
@@ -274,7 +274,7 @@ class TestReconstructorRevert(ECProbeTes
         primary_node = node_list[0]
 
         # ... and 507 it's device
-        primary_device = self.device_dir('object', primary_node)
+        primary_device = self.device_dir(primary_node)
         self.kill_drive(primary_device)
 
         # PUT object
@@ -316,7 +316,7 @@ class TestReconstructorRevert(ECProbeTes
                     # machine as the primary!
                     continue
                 # use the primary nodes device - not the hnode device
-                part_dir = self.storage_dir('object', node, part=opart)
+                part_dir = self.storage_dir(node, part=opart)
                 shutil.rmtree(part_dir, True)
 
         # revert from handoff device with reconstructor
@@ -343,7 +343,7 @@ class TestReconstructorRevert(ECProbeTes
             else:
                 # I wonder what happened?
                 self.fail('Partner inexplicably missing fragment!')
-        part_dir = self.storage_dir('object', partner, part=opart)
+        part_dir = self.storage_dir(partner, part=opart)
         shutil.rmtree(part_dir, True)
 
         # sanity, it's gone
diff -pruN 2.25.0-3/test/probe/test_sharder.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_sharder.py
--- 2.25.0-3/test/probe/test_sharder.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_sharder.py	2020-09-15 21:13:36.000000000 +0000
@@ -16,6 +16,7 @@ import hashlib
 import json
 import os
 import shutil
+import subprocess
 import uuid
 
 from nose import SkipTest
@@ -34,6 +35,7 @@ from swiftclient import client, get_auth
 from swift.proxy.controllers.base import get_cache_key
 from swift.proxy.controllers.obj import num_container_updates
 from test import annotate_failure
+from test.probe import PROXY_BASE_URL
 from test.probe.brain import BrainSplitter
 from test.probe.common import ReplProbeTest, get_server_number, \
     wait_for_server_to_hangup
@@ -115,7 +117,7 @@ class BaseTestContainerSharding(ReplProb
             client.requests.logging.WARNING)
         super(BaseTestContainerSharding, self).setUp()
         _, self.admin_token = get_auth(
-            'http://127.0.0.1:8080/auth/v1.0', 'admin:admin', 'admin')
+            PROXY_BASE_URL + '/auth/v1.0', 'admin:admin', 'admin')
         self._setup_container_name()
         self.init_brain(self.container_name)
         self.sharders = Manager(['container-sharder'])
@@ -195,12 +197,16 @@ class BaseTestContainerSharding(ReplProb
         return (utils.storage_directory(datadir, part, container_hash),
                 container_hash)
 
-    def get_broker(self, part, node, account=None, container=None):
+    def get_db_file(self, part, node, account=None, container=None):
         container_dir, container_hash = self.get_storage_dir(
             part, node, account=account, container=container)
         db_file = os.path.join(container_dir, container_hash + '.db')
         self.assertTrue(get_db_files(db_file))  # sanity check
-        return ContainerBroker(db_file)
+        return db_file
+
+    def get_broker(self, part, node, account=None, container=None):
+        return ContainerBroker(
+            self.get_db_file(part, node, account, container))
 
     def categorize_container_dir_content(self, account=None, container=None):
         account = account or self.brain.account
@@ -2409,3 +2415,87 @@ class TestContainerShardingMoreUTF8(Test
         self.container_name = cont_name.encode('utf8').ljust(name_length, b'x')
         if not six.PY2:
             self.container_name = self.container_name.decode('utf8')
+
+
+class TestManagedContainerSharding(BaseTestContainerSharding):
+    '''Test sharding using swift-manage-shard-ranges'''
+    def test_manage_shard_ranges(self):
+        obj_names = self._make_object_names(4)
+        self.put_objects(obj_names)
+
+        client.post_container(self.url, self.admin_token, self.container_name,
+                              headers={'X-Container-Sharding': 'on'})
+
+        # run replicators first time to get sync points set
+        self.replicators.once()
+
+        # sanity check: we don't have nearly enough objects for this to shard
+        # automatically
+        self.sharders.once(number=self.brain.node_numbers[0],
+                           additional_args='--partitions=%s' % self.brain.part)
+        self.assert_container_state(self.brain.nodes[0], 'unsharded', 0)
+
+        subprocess.check_output([
+            'swift-manage-shard-ranges',
+            self.get_db_file(self.brain.part, self.brain.nodes[0]),
+            'find_and_replace', '2', '--enable'], stderr=subprocess.STDOUT)
+        self.assert_container_state(self.brain.nodes[0], 'unsharded', 2)
+
+        # "Run container-replicator to replicate them to other nodes."
+        self.replicators.once()
+        # "Run container-sharder on all nodes to shard the container."
+        self.sharders.once(additional_args='--partitions=%s' % self.brain.part)
+
+        # Everybody's settled
+        self.assert_container_state(self.brain.nodes[0], 'sharded', 2)
+        self.assert_container_state(self.brain.nodes[1], 'sharded', 2)
+        self.assert_container_state(self.brain.nodes[2], 'sharded', 2)
+        self.assert_container_listing(obj_names)
+
+    def test_manage_shard_ranges_used_poorly(self):
+        obj_names = self._make_object_names(8)
+        self.put_objects(obj_names)
+
+        client.post_container(self.url, self.admin_token, self.container_name,
+                              headers={'X-Container-Sharding': 'on'})
+
+        # run replicators first time to get sync points set
+        self.replicators.once()
+
+        subprocess.check_output([
+            'swift-manage-shard-ranges',
+            self.get_db_file(self.brain.part, self.brain.nodes[0]),
+            'find_and_replace', '2', '--enable'], stderr=subprocess.STDOUT)
+        self.assert_container_state(self.brain.nodes[0], 'unsharded', 4)
+
+        # *Also* go find shard ranges on *another node*, like a dumb-dumb
+        subprocess.check_output([
+            'swift-manage-shard-ranges',
+            self.get_db_file(self.brain.part, self.brain.nodes[1]),
+            'find_and_replace', '3', '--enable'], stderr=subprocess.STDOUT)
+        self.assert_container_state(self.brain.nodes[1], 'unsharded', 3)
+
+        # Run things out of order (they were likely running as daemons anyway)
+        self.sharders.once(number=self.brain.node_numbers[0],
+                           additional_args='--partitions=%s' % self.brain.part)
+        self.sharders.once(number=self.brain.node_numbers[1],
+                           additional_args='--partitions=%s' % self.brain.part)
+        self.replicators.once()
+
+        # Uh-oh
+        self.assert_container_state(self.brain.nodes[0], 'sharding', 7)
+        self.assert_container_state(self.brain.nodes[1], 'sharding', 7)
+        # There's a race: the third replica may be sharding, may be unsharded
+
+        # Try it again a few times
+        self.sharders.once(additional_args='--partitions=%s' % self.brain.part)
+        self.replicators.once()
+        self.sharders.once(additional_args='--partitions=%s' % self.brain.part)
+
+        # It's not really fixing itself...
+        self.assert_container_state(self.brain.nodes[0], 'sharding', 7)
+        self.assert_container_state(self.brain.nodes[1], 'sharding', 7)
+
+        # But hey, at least listings still work! They're just going to get
+        # horribly out of date as more objects are added
+        self.assert_container_listing(obj_names)
diff -pruN 2.25.0-3/test/probe/test_signals.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_signals.py
--- 2.25.0-3/test/probe/test_signals.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/probe/test_signals.py	2020-09-15 21:13:36.000000000 +0000
@@ -26,10 +26,12 @@ import time
 from uuid import uuid4
 
 from six.moves import http_client as httplib
+from six.moves.urllib.parse import urlparse
 
 from swift.common.ring import Ring
 from swift.common.manager import Manager
 
+from test.probe import PROXY_BASE_URL
 from test.probe.common import resetswift, ReplProbeTest, client
 
 
@@ -109,7 +111,9 @@ class TestWSGIServerProcessHandling(Repl
             self.assertIn('Invalid path: blah', got_body)
 
     def get_conn(self):
-        ip, port = self.get_ip_port()
+        scheme, ip, port = self.get_scheme_ip_port()
+        if scheme == 'https':
+            return httplib.HTTPSConnection('%s:%s' % (ip, port))
         return httplib.HTTPConnection('%s:%s' % (ip, port))
 
     def _check_reload(self):
@@ -224,15 +228,51 @@ class SeamlessReloadMixin(object):
         self.manager.reload_seamless()
 
 
+class ChildReloadMixin(object):
+    def make_post_reload_pid_cb(self):
+        def _cb(post_reload_pids):
+            # We expect all orig server PIDs to STILL BE PRESENT, no new server
+            # present, and for there to be exactly 1 old worker PID plus
+            # all but one additional new worker PIDs.
+            num_workers = len(self.starting_pids['worker'])
+            same_servers = (self.starting_pids['server'] ==
+                            post_reload_pids['server'])
+            one_old_worker = 1 == len(self.starting_pids['worker'] &
+                                      post_reload_pids['worker'])
+            new_workers_present = (post_reload_pids['worker'] -
+                                   self.starting_pids['worker'])
+            return (post_reload_pids['server'] and same_servers and
+                    one_old_worker and
+                    len(new_workers_present) == num_workers - 1)
+        return _cb
+
+    def make_post_close_pid_cb(self):
+        def _cb(post_close_pids):
+            # We expect all orig server PIDs to STILL BE PRESENT, no new server
+            # present, no old worker PIDs, and all new worker PIDs.
+            same_servers = (self.starting_pids['server'] ==
+                            post_close_pids['server'])
+            old_workers_dead = not (self.starting_pids['worker'] &
+                                    post_close_pids['worker'])
+            new_workers_present = (post_close_pids['worker'] -
+                                   self.starting_pids['worker'])
+            return (post_close_pids['server'] and same_servers and
+                    old_workers_dead and new_workers_present)
+        return _cb
+
+    def do_reload(self):
+        self.manager.kill_child_pids(seamless=True)
+
+
 class TestObjectServerReloadBase(TestWSGIServerProcessHandling):
     SERVER_NAME = 'object'
     PID_TIMEOUT = 35
 
-    def get_ip_port(self):
+    def get_scheme_ip_port(self):
         self.policy.load_ring('/etc/swift')
         self.ring_node = random.choice(
             self.policy.object_ring.get_part_nodes(1))
-        return self.ring_node['ip'], self.ring_node['port']
+        return 'http', self.ring_node['ip'], self.ring_node['port']
 
     def start_write_req(self, conn, suffix):
         putrequest(conn, 'PUT', '/%s/123/%s/%s/blah-%s' % (
@@ -269,6 +309,14 @@ class TestObjectServerReloadSeamless(Sea
         self._check_reload()
 
 
+class TestObjectServerReloadChild(ChildReloadMixin,
+                                  TestObjectServerReloadBase):
+    BODY = b'test-object' * 10
+
+    def test_object_reload_child(self):
+        self._check_reload()
+
+
 class TestProxyServerReloadBase(TestWSGIServerProcessHandling):
     SERVER_NAME = 'proxy-server'
     HAS_INFO = True
@@ -296,8 +344,12 @@ class TestProxyServerReloadBase(TestWSGI
     def swap_configs(self):
         shutil.copy(self.new_swift_conf_path, self.swift_conf_path)
 
-    def get_ip_port(self):
-        return 'localhost', 8080
+    def get_scheme_ip_port(self):
+        parsed = urlparse(PROXY_BASE_URL)
+        host, port = parsed.netloc.partition(':')[::2]
+        if not port:
+            port = '443' if parsed.scheme == 'https' else '80'
+        return parsed.scheme, host, int(port)
 
     def assertMaxHeaderSize(self, resp, exp_max_header_size):
         self.assertEqual(resp.status // 100, 2)
@@ -350,6 +402,16 @@ class TestProxyServerReloadSeamless(Seam
         self._check_reload()
 
 
+class TestProxyServerReloadChild(ChildReloadMixin,
+                                 TestProxyServerReloadBase):
+    BODY = b'proxy-seamless' * 10
+    # A bit of a lie, but the respawned child won't pick up the updated config
+    HAS_INFO = False
+
+    def test_proxy_reload_child(self):
+        self._check_reload()
+
+
 @contextmanager
 def spawn_services(ip_ports, timeout=10):
     q = eventlet.Queue()
diff -pruN 2.25.0-3/test/sample.conf 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/sample.conf
--- 2.25.0-3/test/sample.conf	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/sample.conf	2020-09-15 21:13:36.000000000 +0000
@@ -24,6 +24,10 @@ auth_uri = http://127.0.0.1:8080/auth/v1
 #auth_version = 3
 #auth_uri = http://localhost:5000/v3/
 
+# Used by s3api functional tests, which don't contact auth directly
+#s3_storage_url = http://127.0.0.1:8080/
+#s3_region = us-east-1
+
 # Primary functional test account (needs admin access to the account)
 account = test
 username = tester
@@ -101,6 +105,7 @@ fake_syslog = False
 [probe_test]
 # check_server_timeout = 30
 # validate_rsync = false
+# proxy_base_url = http://localhost:8080
 
 [swift-constraints]
 # The functional test runner will try to use the constraint values provided in
diff -pruN 2.25.0-3/test/unit/account/test_backend.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/account/test_backend.py
--- 2.25.0-3/test/unit/account/test_backend.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/account/test_backend.py	2020-09-15 21:13:36.000000000 +0000
@@ -180,6 +180,72 @@ class TestAccountBroker(unittest.TestCas
         broker.delete_db(Timestamp.now().internal)
         broker.reclaim(Timestamp.now().internal, time())
 
+    def test_batched_reclaim(self):
+        num_of_containers = 60
+        container_specs = []
+        now = time()
+        top_of_the_minute = now - (now % 60)
+        c = itertools.cycle([True, False])
+        for m, is_deleted in six.moves.zip(range(num_of_containers), c):
+            offset = top_of_the_minute - (m * 60)
+            container_specs.append((Timestamp(offset), is_deleted))
+        random.seed(now)
+        random.shuffle(container_specs)
+        policy_indexes = list(p.idx for p in POLICIES)
+        broker = AccountBroker(':memory:', account='test_account')
+        broker.initialize(Timestamp('1').internal)
+        for i, container_spec in enumerate(container_specs):
+            # with container12 before container2 and shuffled ts.internal we
+            # shouldn't be able to accidently rely on any implicit ordering
+            name = 'container%s' % i
+            pidx = random.choice(policy_indexes)
+            ts, is_deleted = container_spec
+            if is_deleted:
+                broker.put_container(name, 0, ts.internal, 0, 0, pidx)
+            else:
+                broker.put_container(name, ts.internal, 0, 0, 0, pidx)
+
+        def count_reclaimable(conn, reclaim_age):
+            return conn.execute(
+                "SELECT count(*) FROM container "
+                "WHERE deleted = 1 AND delete_timestamp < ?", (reclaim_age,)
+            ).fetchone()[0]
+
+        # This is intended to divide the set of timestamps exactly in half
+        # regardless of the value of now
+        reclaim_age = top_of_the_minute + 1 - (num_of_containers / 2 * 60)
+        with broker.get() as conn:
+            self.assertEqual(count_reclaimable(conn, reclaim_age),
+                             num_of_containers / 4)
+
+        orig__reclaim = broker._reclaim
+        trace = []
+
+        def tracing_reclaim(conn, age_timestamp, marker):
+            trace.append((age_timestamp, marker,
+                          count_reclaimable(conn, age_timestamp)))
+            return orig__reclaim(conn, age_timestamp, marker)
+
+        with mock.patch.object(broker, '_reclaim', new=tracing_reclaim), \
+                mock.patch('swift.common.db.RECLAIM_PAGE_SIZE', 10):
+            broker.reclaim(reclaim_age, reclaim_age)
+        with broker.get() as conn:
+            self.assertEqual(count_reclaimable(conn, reclaim_age), 0)
+        self.assertEqual(3, len(trace), trace)
+        self.assertEqual([age for age, marker, reclaimable in trace],
+                         [reclaim_age] * 3)
+        # markers are in-order
+        self.assertLess(trace[0][1], trace[1][1])
+        self.assertLess(trace[1][1], trace[2][1])
+        # reclaimable count gradually decreases
+        # generally, count1 > count2 > count3, but because of the randomness
+        # we may occassionally have count1 == count2 or count2 == count3
+        self.assertGreaterEqual(trace[0][2], trace[1][2])
+        self.assertGreaterEqual(trace[1][2], trace[2][2])
+        # technically, this might happen occasionally, but *really* rarely
+        self.assertTrue(trace[0][2] > trace[1][2] or
+                        trace[1][2] > trace[2][2])
+
     def test_delete_db_status(self):
         start = next(self.ts)
         broker = AccountBroker(':memory:', account='a')
diff -pruN 2.25.0-3/test/unit/account/test_reaper.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/account/test_reaper.py
--- 2.25.0-3/test/unit/account/test_reaper.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/account/test_reaper.py	2020-09-15 21:13:36.000000000 +0000
@@ -322,7 +322,8 @@ class TestReaper(unittest.TestCase):
                             'X-Container-Partition': 'partition',
                             'X-Container-Device': device,
                             'X-Backend-Storage-Policy-Index': policy.idx,
-                            'X-Timestamp': '1429117638.86767'
+                            'X-Timestamp': '1429117638.86767',
+                            'x-backend-use-replication-network': 'true',
                         }
                         ring = r.get_object_ring(policy.idx)
                         expected = call(dict(ring.devs[i], index=i), 0,
@@ -442,7 +443,8 @@ class TestReaper(unittest.TestCase):
                     'X-Account-Partition': 'partition',
                     'X-Account-Device': device,
                     'X-Account-Override-Deleted': 'yes',
-                    'X-Timestamp': '1429117639.67676'
+                    'X-Timestamp': '1429117639.67676',
+                    'x-backend-use-replication-network': 'true',
                 }
                 ring = r.get_object_ring(policy.idx)
                 expected = call(dict(ring.devs[i], index=i), 0, 'a', 'c',
diff -pruN 2.25.0-3/test/unit/account/test_server.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/account/test_server.py
--- 2.25.0-3/test/unit/account/test_server.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/account/test_server.py	2020-09-15 21:13:36.000000000 +0000
@@ -2456,7 +2456,7 @@ class TestAccountController(unittest.Tes
     def test_serv_reserv(self):
         # Test replication_server flag was set from configuration file.
         conf = {'devices': self.testdir, 'mount_check': 'false'}
-        self.assertIsNone(AccountController(conf).replication_server)
+        self.assertTrue(AccountController(conf).replication_server)
         for val in [True, '1', 'True', 'true']:
             conf['replication_server'] = val
             self.assertTrue(AccountController(conf).replication_server)
@@ -2549,7 +2549,7 @@ class TestAccountController(unittest.Tes
             response = self.controller.__call__(env, start_response)
             self.assertEqual(response, answer)
 
-    def test_call_incorrect_replication_method(self):
+    def test_replicaiton_server_call_all_methods(self):
         inbuf = BytesIO()
         errbuf = StringIO()
         outbuf = StringIO()
@@ -2560,14 +2560,15 @@ class TestAccountController(unittest.Tes
         def start_response(*args):
             outbuf.write(args[0])
 
-        obj_methods = ['DELETE', 'PUT', 'HEAD', 'GET', 'POST', 'OPTIONS']
+        obj_methods = ['PUT', 'HEAD', 'GET', 'POST', 'DELETE', 'OPTIONS']
         for method in obj_methods:
             env = {'REQUEST_METHOD': method,
                    'SCRIPT_NAME': '',
-                   'PATH_INFO': '/sda1/p/a/c',
+                   'PATH_INFO': '/sda1/p/a',
                    'SERVER_NAME': '127.0.0.1',
                    'SERVER_PORT': '8080',
                    'SERVER_PROTOCOL': 'HTTP/1.0',
+                   'HTTP_X_TIMESTAMP': next(self.ts).internal,
                    'CONTENT_LENGTH': '0',
                    'wsgi.version': (1, 0),
                    'wsgi.url_scheme': 'http',
@@ -2578,7 +2579,7 @@ class TestAccountController(unittest.Tes
                    'wsgi.run_once': False}
             self.controller(env, start_response)
             self.assertEqual(errbuf.getvalue(), '')
-            self.assertEqual(outbuf.getvalue()[:4], '405 ')
+            self.assertIn(outbuf.getvalue()[:4], ('200 ', '201 ', '204 '))
 
     def test__call__raise_timeout(self):
         inbuf = WsgiBytesIO()
diff -pruN 2.25.0-3/test/unit/cli/test_info.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/cli/test_info.py
--- 2.25.0-3/test/unit/cli/test_info.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/cli/test_info.py	2020-09-15 21:13:36.000000000 +0000
@@ -141,8 +141,8 @@ Metadata:
 No system metadata found in db file
   User Metadata: {'x-account-meta-mydata': 'swift'}'''
 
-        self.assertEqual(sorted(out.getvalue().strip().split('\n')),
-                         sorted(exp_out.split('\n')))
+        self.assertEqual(out.getvalue().strip().split('\n'),
+                         exp_out.split('\n'))
 
         info = dict(
             account='acct',
@@ -269,7 +269,7 @@ No system metadata found in db file
             id='abadf100d0ddba11')
         out = StringIO()
         with mock.patch('sys.stdout', out):
-            print_db_info_metadata('container', info, {})
+            print_db_info_metadata('container', info, {}, verbose=True)
         exp_out = '''Path: /acct/cont
   Account: acct
   Container: cont
@@ -295,6 +295,10 @@ Sharding Metadata:
   Type: root
   State: sharded
 Shard Ranges (3):
+  States:
+        found: 1
+      created: 1
+      cleaved: 1
   Name: .sharded_a/shard_range_1
     lower: '1a', upper: '1z'
     Object Count: 1, Bytes Used: 1, State: cleaved (30)
@@ -311,8 +315,77 @@ Shard Ranges (3):
     Created at: 1970-01-01T00:00:03.000000 (0000000003.00000)
     Meta Timestamp: 1970-01-01T00:00:03.000000 (0000000003.00000)''' %\
                   POLICIES[0].name
-        self.assertEqual(sorted(out.getvalue().strip().split('\n')),
-                         sorted(exp_out.strip().split('\n')))
+        self.assertEqual(out.getvalue().strip().split('\n'),
+                         exp_out.strip().split('\n'))
+
+    def test_print_db_info_metadata_with_many_shard_ranges(self):
+
+        shard_ranges = [utils.ShardRange(
+            name='.sharded_a/shard_range_%s' % i,
+            timestamp=utils.Timestamp(i), lower='%02da' % i,
+            upper='%02dz' % i, object_count=i, bytes_used=i,
+            meta_timestamp=utils.Timestamp(i)) for i in range(1, 20)]
+        shard_ranges[0].state = utils.ShardRange.CLEAVED
+        shard_ranges[1].state = utils.ShardRange.CREATED
+
+        info = dict(
+            account='acct',
+            container='cont',
+            storage_policy_index=0,
+            created_at='0000000100.10000',
+            put_timestamp='0000000106.30000',
+            delete_timestamp='0000000107.90000',
+            status_changed_at='0000000108.30000',
+            object_count='20',
+            bytes_used='42',
+            reported_put_timestamp='0000010106.30000',
+            reported_delete_timestamp='0000010107.90000',
+            reported_object_count='20',
+            reported_bytes_used='42',
+            db_state=SHARDED,
+            is_root=True,
+            shard_ranges=shard_ranges,
+            is_deleted=False,
+            hash='abaddeadbeefcafe',
+            id='abadf100d0ddba11')
+        out = StringIO()
+        with mock.patch('sys.stdout', out):
+            print_db_info_metadata('container', info, {})
+        exp_out = '''
+Path: /acct/cont
+  Account: acct
+  Container: cont
+  Deleted: False
+  Container Hash: d49d0ecbb53be1fcc49624f2f7c7ccae
+Metadata:
+  Created at: 1970-01-01T00:01:40.100000 (0000000100.10000)
+  Put Timestamp: 1970-01-01T00:01:46.300000 (0000000106.30000)
+  Delete Timestamp: 1970-01-01T00:01:47.900000 (0000000107.90000)
+  Status Timestamp: 1970-01-01T00:01:48.300000 (0000000108.30000)
+  Object Count: 20
+  Bytes Used: 42
+  Storage Policy: %s (0)
+  Reported Put Timestamp: 1970-01-01T02:48:26.300000 (0000010106.30000)
+  Reported Delete Timestamp: 1970-01-01T02:48:27.900000 (0000010107.90000)
+  Reported Object Count: 20
+  Reported Bytes Used: 42
+  Chexor: abaddeadbeefcafe
+  UUID: abadf100d0ddba11
+No system metadata found in db file
+No user metadata found in db file
+Sharding Metadata:
+  Type: root
+  State: sharded
+Shard Ranges (19):
+  States:
+        found: 17
+      created: 1
+      cleaved: 1
+(Use -v/--verbose to show more Shard Ranges details)
+''' %\
+                  POLICIES[0].name
+        self.assertEqual(out.getvalue().strip().split('\n'),
+                         exp_out.strip().split('\n'))
 
     def test_print_db_info_metadata_with_shard_ranges_bis(self):
 
@@ -346,7 +419,7 @@ Shard Ranges (3):
         info['is_deleted'] = False
         out = StringIO()
         with mock.patch('sys.stdout', out):
-            print_db_info_metadata('container', info, {})
+            print_db_info_metadata('container', info, {}, verbose=True)
         if six.PY2:
             s_a = '\\xe3\\x82\\xa2'
             s_ya = '\\xe3\\x83\\xa4'
@@ -378,6 +451,10 @@ Sharding Metadata:
   Type: root
   State: sharded
 Shard Ranges (3):
+  States:
+        found: 1
+      created: 1
+      cleaved: 1
   Name: .sharded_a/shard_range_1
     lower: '1%s', upper: '1%s'
     Object Count: 1, Bytes Used: 1, State: cleaved (30)
@@ -497,13 +574,10 @@ Shard Ranges (3):
             print_item_locations(None, partition=part, policy_name='zero',
                                  swift_dir=self.testdir)
         exp_part_msg = 'Partition\t%s' % part
-        exp_acct_msg = 'Account  \tNone'
-        exp_cont_msg = 'Container\tNone'
-        exp_obj_msg = 'Object   \tNone'
         self.assertIn(exp_part_msg, out.getvalue())
-        self.assertIn(exp_acct_msg, out.getvalue())
-        self.assertIn(exp_cont_msg, out.getvalue())
-        self.assertIn(exp_obj_msg, out.getvalue())
+        self.assertNotIn('Account', out.getvalue())
+        self.assertNotIn('Container', out.getvalue())
+        self.assertNotIn('Object', out.getvalue())
 
     def test_print_item_locations_dashed_ring_name_partition(self):
         out = StringIO()
@@ -513,13 +587,10 @@ Shard Ranges (3):
                                  ring_name='foo-bar', partition=part,
                                  swift_dir=self.testdir)
         exp_part_msg = 'Partition\t%s' % part
-        exp_acct_msg = 'Account  \tNone'
-        exp_cont_msg = 'Container\tNone'
-        exp_obj_msg = 'Object   \tNone'
         self.assertIn(exp_part_msg, out.getvalue())
-        self.assertIn(exp_acct_msg, out.getvalue())
-        self.assertIn(exp_cont_msg, out.getvalue())
-        self.assertIn(exp_obj_msg, out.getvalue())
+        self.assertNotIn('Account', out.getvalue())
+        self.assertNotIn('Container', out.getvalue())
+        self.assertNotIn('Object', out.getvalue())
 
     def test_print_item_locations_account_with_ring(self):
         out = StringIO()
@@ -533,11 +604,9 @@ Shard Ranges (3):
                       'but ring not named "account"'
         self.assertIn(exp_warning, out.getvalue())
         exp_acct_msg = 'Account  \t%s' % account
-        exp_cont_msg = 'Container\tNone'
-        exp_obj_msg = 'Object   \tNone'
         self.assertIn(exp_acct_msg, out.getvalue())
-        self.assertIn(exp_cont_msg, out.getvalue())
-        self.assertIn(exp_obj_msg, out.getvalue())
+        self.assertNotIn('Container', out.getvalue())
+        self.assertNotIn('Object', out.getvalue())
 
     def test_print_item_locations_account_no_ring(self):
         out = StringIO()
@@ -546,11 +615,9 @@ Shard Ranges (3):
             print_item_locations(None, account=account,
                                  swift_dir=self.testdir)
         exp_acct_msg = 'Account  \t%s' % account
-        exp_cont_msg = 'Container\tNone'
-        exp_obj_msg = 'Object   \tNone'
         self.assertIn(exp_acct_msg, out.getvalue())
-        self.assertIn(exp_cont_msg, out.getvalue())
-        self.assertIn(exp_obj_msg, out.getvalue())
+        self.assertNotIn('Container', out.getvalue())
+        self.assertNotIn('Object', out.getvalue())
 
     def test_print_item_locations_account_container_ring(self):
         out = StringIO()
@@ -562,10 +629,9 @@ Shard Ranges (3):
                                  container=container)
         exp_acct_msg = 'Account  \t%s' % account
         exp_cont_msg = 'Container\t%s' % container
-        exp_obj_msg = 'Object   \tNone'
         self.assertIn(exp_acct_msg, out.getvalue())
         self.assertIn(exp_cont_msg, out.getvalue())
-        self.assertIn(exp_obj_msg, out.getvalue())
+        self.assertNotIn('Object', out.getvalue())
 
     def test_print_item_locations_account_container_no_ring(self):
         out = StringIO()
@@ -576,10 +642,9 @@ Shard Ranges (3):
                                  container=container, swift_dir=self.testdir)
         exp_acct_msg = 'Account  \t%s' % account
         exp_cont_msg = 'Container\t%s' % container
-        exp_obj_msg = 'Object   \tNone'
         self.assertIn(exp_acct_msg, out.getvalue())
         self.assertIn(exp_cont_msg, out.getvalue())
-        self.assertIn(exp_obj_msg, out.getvalue())
+        self.assertNotIn('Object', out.getvalue())
 
     def test_print_item_locations_account_container_object_ring(self):
         out = StringIO()
@@ -691,59 +756,59 @@ Shard Ranges (3):
     def test_parse_get_node_args(self):
         # Capture error messages
         # (without any parameters)
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = ''
         self.assertRaisesMessage(InfoSystemExit,
                                  'Need to specify policy_name or <ring.gz>',
                                  parse_get_node_args, options, args.split())
         # a
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'a'
         self.assertRaisesMessage(InfoSystemExit,
                                  'Need to specify policy_name or <ring.gz>',
                                  parse_get_node_args, options, args.split())
         # a c
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'a c'
         self.assertRaisesMessage(InfoSystemExit,
                                  'Need to specify policy_name or <ring.gz>',
                                  parse_get_node_args, options, args.split())
         # a c o
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'a c o'
         self.assertRaisesMessage(InfoSystemExit,
                                  'Need to specify policy_name or <ring.gz>',
                                  parse_get_node_args, options, args.split())
 
         # a/c
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'a/c'
         self.assertRaisesMessage(InfoSystemExit,
                                  'Need to specify policy_name or <ring.gz>',
                                  parse_get_node_args, options, args.split())
         # a/c/o
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'a/c/o'
         self.assertRaisesMessage(InfoSystemExit,
                                  'Need to specify policy_name or <ring.gz>',
                                  parse_get_node_args, options, args.split())
 
         # account container junk/test.ring.gz
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'account container junk/test.ring.gz'
         self.assertRaisesMessage(InfoSystemExit,
                                  'Need to specify policy_name or <ring.gz>',
                                  parse_get_node_args, options, args.split())
 
         # account container object junk/test.ring.gz
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'account container object junk/test.ring.gz'
         self.assertRaisesMessage(InfoSystemExit,
                                  'Need to specify policy_name or <ring.gz>',
                                  parse_get_node_args, options, args.split())
 
         # object.ring.gz(without any arguments i.e. a c o)
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'object.ring.gz'
         self.assertRaisesMessage(InfoSystemExit,
                                  'Ring file does not exist',
@@ -751,55 +816,55 @@ Shard Ranges (3):
 
         # Valid policy
         # -P zero
-        options = Namespace(policy_name='zero', partition=None)
+        options = Namespace(policy_name='zero', partition=None, quoted=None)
         args = ''
         self.assertRaisesMessage(InfoSystemExit,
                                  'No target specified',
                                  parse_get_node_args, options, args.split())
         # -P one a/c/o
-        options = Namespace(policy_name='one', partition=None)
+        options = Namespace(policy_name='one', partition=None, quoted=None)
         args = 'a/c/o'
         ring_path, args = parse_get_node_args(options, args.split())
         self.assertIsNone(ring_path)
         self.assertEqual(args, ['a', 'c', 'o'])
         # -P one account container photos/cat.jpg
-        options = Namespace(policy_name='one', partition=None)
+        options = Namespace(policy_name='one', partition=None, quoted=None)
         args = 'account container photos/cat.jpg'
         ring_path, args = parse_get_node_args(options, args.split())
         self.assertIsNone(ring_path)
         self.assertEqual(args, ['account', 'container', 'photos/cat.jpg'])
         # -P one account/container/photos/cat.jpg
-        options = Namespace(policy_name='one', partition=None)
+        options = Namespace(policy_name='one', partition=None, quoted=None)
         args = 'account/container/photos/cat.jpg'
         ring_path, args = parse_get_node_args(options, args.split())
         self.assertIsNone(ring_path)
         self.assertEqual(args, ['account', 'container', 'photos/cat.jpg'])
         # -P one account/container/junk/test.ring.gz(object endswith 'ring.gz')
-        options = Namespace(policy_name='one', partition=None)
+        options = Namespace(policy_name='one', partition=None, quoted=None)
         args = 'account/container/junk/test.ring.gz'
         ring_path, args = parse_get_node_args(options, args.split())
         self.assertIsNone(ring_path)
         self.assertEqual(args, ['account', 'container', 'junk/test.ring.gz'])
         # -P two a c o hooya
-        options = Namespace(policy_name='two', partition=None)
+        options = Namespace(policy_name='two', partition=None, quoted=None)
         args = 'a c o hooya'
         self.assertRaisesMessage(InfoSystemExit,
                                  'Invalid arguments',
                                  parse_get_node_args, options, args.split())
         # -P zero -p 1
-        options = Namespace(policy_name='zero', partition='1')
+        options = Namespace(policy_name='zero', partition='1', quoted=None)
         args = ''
         ring_path, args = parse_get_node_args(options, args.split())
         self.assertIsNone(ring_path)
         self.assertFalse(args)
         # -P one -p 1 a/c/o
-        options = Namespace(policy_name='one', partition='1')
+        options = Namespace(policy_name='one', partition='1', quoted=None)
         args = 'a/c/o'
         ring_path, args = parse_get_node_args(options, args.split())
         self.assertIsNone(ring_path)
         self.assertEqual(args, ['a', 'c', 'o'])
         # -P two -p 1 a c o hooya
-        options = Namespace(policy_name='two', partition='1')
+        options = Namespace(policy_name='two', partition='1', quoted=None)
         args = 'a c o hooya'
         self.assertRaisesMessage(InfoSystemExit,
                                  'Invalid arguments',
@@ -853,7 +918,7 @@ Shard Ranges (3):
 
         # Mock tests
         # /etc/swift/object.ring.gz(without any arguments i.e. a c o)
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = '/etc/swift/object.ring.gz'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -863,7 +928,7 @@ Shard Ranges (3):
                 parse_get_node_args, options, args.split())
         # Similar ring_path and arguments
         # /etc/swift/object.ring.gz /etc/swift/object.ring.gz
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = '/etc/swift/object.ring.gz /etc/swift/object.ring.gz'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -871,7 +936,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, '/etc/swift/object.ring.gz')
         self.assertEqual(args, ['etc', 'swift', 'object.ring.gz'])
         # /etc/swift/object.ring.gz a/c/etc/swift/object.ring.gz
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = '/etc/swift/object.ring.gz a/c/etc/swift/object.ring.gz'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -880,7 +945,7 @@ Shard Ranges (3):
         self.assertEqual(args, ['a', 'c', 'etc/swift/object.ring.gz'])
         # Invalid path as mentioned in BUG#1539275
         # /etc/swift/object.tar.gz account container object
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = '/etc/swift/object.tar.gz account container object'
         self.assertRaisesMessage(
             InfoSystemExit,
@@ -888,7 +953,7 @@ Shard Ranges (3):
             parse_get_node_args, options, args.split())
 
         # object.ring.gz a/
-        options = Namespace(policy_name=None)
+        options = Namespace(policy_name=None, quoted=None)
         args = 'object.ring.gz a/'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -896,7 +961,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a'])
         # object.ring.gz a/c
-        options = Namespace(policy_name=None)
+        options = Namespace(policy_name=None, quoted=None)
         args = 'object.ring.gz a/c'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -904,7 +969,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a', 'c'])
         # object.ring.gz a/c/o
-        options = Namespace(policy_name=None)
+        options = Namespace(policy_name=None, quoted=None)
         args = 'object.ring.gz a/c/o'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -912,7 +977,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a', 'c', 'o'])
         # object.ring.gz a/c/o/junk/test.ring.gz
-        options = Namespace(policy_name=None)
+        options = Namespace(policy_name=None, quoted=None)
         args = 'object.ring.gz a/c/o/junk/test.ring.gz'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -920,7 +985,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a', 'c', 'o/junk/test.ring.gz'])
         # object.ring.gz a
-        options = Namespace(policy_name=None)
+        options = Namespace(policy_name=None, quoted=None)
         args = 'object.ring.gz a'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -928,7 +993,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a'])
         # object.ring.gz a c
-        options = Namespace(policy_name=None)
+        options = Namespace(policy_name=None, quoted=None)
         args = 'object.ring.gz a c'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -936,7 +1001,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a', 'c'])
         # object.ring.gz a c o
-        options = Namespace(policy_name=None)
+        options = Namespace(policy_name=None, quoted=None)
         args = 'object.ring.gz a c o'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -944,7 +1009,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a', 'c', 'o'])
         # object.ring.gz a c o blah blah
-        options = Namespace(policy_name=None)
+        options = Namespace(policy_name=None, quoted=None)
         args = 'object.ring.gz a c o blah blah'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -953,7 +1018,7 @@ Shard Ranges (3):
                 'Invalid arguments',
                 parse_get_node_args, options, args.split())
         # object.ring.gz a/c/o/blah/blah
-        options = Namespace(policy_name=None)
+        options = Namespace(policy_name=None, quoted=None)
         args = 'object.ring.gz a/c/o/blah/blah'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -962,7 +1027,7 @@ Shard Ranges (3):
         self.assertEqual(args, ['a', 'c', 'o/blah/blah'])
 
         # object.ring.gz -p 1
-        options = Namespace(policy_name=None, partition='1')
+        options = Namespace(policy_name=None, partition='1', quoted=None)
         args = 'object.ring.gz'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -970,7 +1035,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertFalse(args)
         # object.ring.gz -p 1 a c o
-        options = Namespace(policy_name=None, partition='1')
+        options = Namespace(policy_name=None, partition='1', quoted=None)
         args = 'object.ring.gz a c o'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -978,7 +1043,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a', 'c', 'o'])
         # object.ring.gz -p 1 a c o forth_arg
-        options = Namespace(policy_name=None, partition='1')
+        options = Namespace(policy_name=None, partition='1', quoted=None)
         args = 'object.ring.gz a c o forth_arg'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -987,7 +1052,7 @@ Shard Ranges (3):
                 'Invalid arguments',
                 parse_get_node_args, options, args.split())
         # object.ring.gz -p 1 a/c/o
-        options = Namespace(policy_name=None, partition='1')
+        options = Namespace(policy_name=None, partition='1', quoted=None)
         args = 'object.ring.gz a/c/o'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -995,7 +1060,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a', 'c', 'o'])
         # object.ring.gz -p 1 a/c/junk/test.ring.gz
-        options = Namespace(policy_name=None, partition='1')
+        options = Namespace(policy_name=None, partition='1', quoted=None)
         args = 'object.ring.gz a/c/junk/test.ring.gz'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -1003,7 +1068,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a', 'c', 'junk/test.ring.gz'])
         # object.ring.gz -p 1 a/c/photos/cat.jpg
-        options = Namespace(policy_name=None, partition='1')
+        options = Namespace(policy_name=None, partition='1', quoted=None)
         args = 'object.ring.gz a/c/photos/cat.jpg'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -1012,7 +1077,7 @@ Shard Ranges (3):
         self.assertEqual(args, ['a', 'c', 'photos/cat.jpg'])
 
         # --all object.ring.gz a
-        options = Namespace(all=True, policy_name=None)
+        options = Namespace(all=True, policy_name=None, quoted=None)
         args = 'object.ring.gz a'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -1020,7 +1085,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a'])
         # --all object.ring.gz a c
-        options = Namespace(all=True, policy_name=None)
+        options = Namespace(all=True, policy_name=None, quoted=None)
         args = 'object.ring.gz a c'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -1028,7 +1093,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a', 'c'])
         # --all object.ring.gz a c o
-        options = Namespace(all=True, policy_name=None)
+        options = Namespace(all=True, policy_name=None, quoted=None)
         args = 'object.ring.gz a c o'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -1036,7 +1101,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['a', 'c', 'o'])
         # object.ring.gz account container photos/cat.jpg
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'object.ring.gz account container photos/cat.jpg'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -1044,7 +1109,7 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['account', 'container', 'photos/cat.jpg'])
         # object.ring.gz /account/container/photos/cat.jpg
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'object.ring.gz account/container/photos/cat.jpg'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -1053,7 +1118,7 @@ Shard Ranges (3):
         self.assertEqual(args, ['account', 'container', 'photos/cat.jpg'])
         # Object name ends with 'ring.gz'
         # object.ring.gz /account/container/junk/test.ring.gz
-        options = Namespace(policy_name=None, partition=None)
+        options = Namespace(policy_name=None, partition=None, quoted=None)
         args = 'object.ring.gz account/container/junk/test.ring.gz'
         with mock.patch('swift.cli.info.os.path.exists') as exists:
             exists.return_value = True
@@ -1061,6 +1126,32 @@ Shard Ranges (3):
         self.assertEqual(ring_path, 'object.ring.gz')
         self.assertEqual(args, ['account', 'container', 'junk/test.ring.gz'])
 
+        # Object name has special characters
+        # object.ring.gz /account/container/obj\nwith%0anewline
+        options = Namespace(policy_name=None, partition=None, quoted=None)
+        args = ['object.ring.gz', 'account/container/obj\nwith%0anewline']
+        with mock.patch('swift.cli.info.os.path.exists') as exists:
+            exists.return_value = True
+            ring_path, args = parse_get_node_args(options, args)
+        self.assertEqual(ring_path, 'object.ring.gz')
+        self.assertEqual(args, ['account', 'container', 'obj\nwith%0anewline'])
+
+        options = Namespace(policy_name=None, partition=None, quoted=True)
+        args = ['object.ring.gz', 'account/container/obj\nwith%0anewline']
+        with mock.patch('swift.cli.info.os.path.exists') as exists:
+            exists.return_value = True
+            ring_path, args = parse_get_node_args(options, args)
+        self.assertEqual(ring_path, 'object.ring.gz')
+        self.assertEqual(args, ['account', 'container', 'obj\nwith\nnewline'])
+
+        options = Namespace(policy_name=None, partition=None, quoted=False)
+        args = ['object.ring.gz', 'account/container/obj\nwith%0anewline']
+        with mock.patch('swift.cli.info.os.path.exists') as exists:
+            exists.return_value = True
+            ring_path, args = parse_get_node_args(options, args)
+        self.assertEqual(ring_path, 'object.ring.gz')
+        self.assertEqual(args, ['account', 'container', 'obj\nwith%0anewline'])
+
 
 class TestPrintObj(TestCliInfoBase):
 
@@ -1186,7 +1277,7 @@ class TestPrintObjFullMeta(TestCliInfoBa
             os.chdir(cwd)
 
         exp_curl = (
-            'curl -g -I -XHEAD '
+            'curl --path-as-is -g -I -XHEAD '
             '"http://{host}:{port}/{device}/{part}/AUTH_admin/c/obj" '
             '-H "X-Backend-Storage-Policy-Index: 2"').format(
                 host=node['ip'],
@@ -1227,7 +1318,7 @@ class TestPrintObjFullMeta(TestCliInfoBa
             os.chdir(cwd)
 
         exp_curl = (
-            'curl -g -I -XHEAD '
+            'curl --path-as-is -g -I -XHEAD '
             '"http://[{host}]:{port}'
             '/{device}/{part}/AUTH_admin/c/obj" ').format(
                 host=node['ip'],
diff -pruN 2.25.0-3/test/unit/cli/test_manage_shard_ranges.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/cli/test_manage_shard_ranges.py
--- 2.25.0-3/test/unit/cli/test_manage_shard_ranges.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/cli/test_manage_shard_ranges.py	2020-09-15 21:13:36.000000000 +0000
@@ -189,6 +189,7 @@ class TestManageShardRanges(unittest.Tes
                     '  "meta_timestamp": "%s",' % now.internal,
                     '  "name": "a/c",',
                     '  "object_count": 0,',
+                    '  "reported": 0,',
                     '  "state": "sharding",',
                     '  "state_timestamp": "%s",' % now.internal,
                     '  "timestamp": "%s",' % now.internal,
@@ -230,6 +231,7 @@ class TestManageShardRanges(unittest.Tes
                     '  "meta_timestamp": "%s",' % now.internal,
                     '  "name": "a/c",',
                     '  "object_count": 0,',
+                    '  "reported": 0,',
                     '  "state": "sharding",',
                     '  "state_timestamp": "%s",' % now.internal,
                     '  "timestamp": "%s",' % now.internal,
@@ -358,6 +360,23 @@ class TestManageShardRanges(unittest.Tes
         self.assertEqual(['Loaded db broker for a/c.'],
                          err.getvalue().splitlines())
         self._assert_enabled(broker, now)
+        found_shard_ranges = broker.get_shard_ranges()
         self.assertEqual(
             [(data['lower'], data['upper']) for data in self.shard_data],
-            [(sr.lower_str, sr.upper_str) for sr in broker.get_shard_ranges()])
+            [(sr.lower_str, sr.upper_str) for sr in found_shard_ranges])
+
+        # Do another find & replace but quit when prompted about existing
+        # shard ranges
+        out = StringIO()
+        err = StringIO()
+        to_patch = 'swift.cli.manage_shard_ranges.input'
+        with mock.patch('sys.stdout', out), mock.patch('sys.stderr', err), \
+                mock_timestamp_now() as now, \
+                mock.patch(to_patch, return_value='q'):
+            main([broker.db_file, 'find_and_replace', '10'])
+        # Shard ranges haven't changed at all
+        self.assertEqual(found_shard_ranges, broker.get_shard_ranges())
+        expected = ['This will delete existing 10 shard ranges.']
+        self.assertEqual(expected, out.getvalue().splitlines())
+        self.assertEqual(['Loaded db broker for a/c.'],
+                         err.getvalue().splitlines())
diff -pruN 2.25.0-3/test/unit/cli/test_relinker.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/cli/test_relinker.py
--- 2.25.0-3/test/unit/cli/test_relinker.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/cli/test_relinker.py	2020-09-15 21:13:36.000000000 +0000
@@ -12,6 +12,9 @@
 # limitations under the License.
 
 import binascii
+import errno
+import fcntl
+import json
 import os
 import shutil
 import struct
@@ -30,6 +33,9 @@ from test.unit import FakeLogger, skip_i
     patch_policies
 
 
+PART_POWER = 8
+
+
 class TestRelinker(unittest.TestCase):
     def setUp(self):
         skip_if_no_xattrs()
@@ -40,7 +46,7 @@ class TestRelinker(unittest.TestCase):
         os.mkdir(self.testdir)
         os.mkdir(self.devices)
 
-        self.rb = ring.RingBuilder(8, 6.0, 1)
+        self.rb = ring.RingBuilder(PART_POWER, 6.0, 1)
 
         for i in range(6):
             ip = "127.0.0.%s" % i
@@ -55,10 +61,10 @@ class TestRelinker(unittest.TestCase):
         os.mkdir(self.objects)
         self._hash = utils.hash_path('a/c/o')
         digest = binascii.unhexlify(self._hash)
-        part = struct.unpack_from('>I', digest)[0] >> 24
+        self.part = struct.unpack_from('>I', digest)[0] >> 24
         self.next_part = struct.unpack_from('>I', digest)[0] >> 23
         self.objdir = os.path.join(
-            self.objects, str(part), self._hash[-3:], self._hash)
+            self.objects, str(self.part), self._hash[-3:], self._hash)
         os.makedirs(self.objdir)
         self.object_fname = "1278553064.00000.data"
         self.objname = os.path.join(self.objdir, self.object_fname)
@@ -97,6 +103,27 @@ class TestRelinker(unittest.TestCase):
         stat_new = os.stat(self.expected_file)
         self.assertEqual(stat_old.st_ino, stat_new.st_ino)
 
+    def test_relink_device_filter(self):
+        self.rb.prepare_increase_partition_power()
+        self._save_ring()
+        relinker.relink(self.testdir, self.devices, True,
+                        device=self.existing_device)
+
+        self.assertTrue(os.path.isdir(self.expected_dir))
+        self.assertTrue(os.path.isfile(self.expected_file))
+
+        stat_old = os.stat(os.path.join(self.objdir, self.object_fname))
+        stat_new = os.stat(self.expected_file)
+        self.assertEqual(stat_old.st_ino, stat_new.st_ino)
+
+    def test_relink_device_filter_invalid(self):
+        self.rb.prepare_increase_partition_power()
+        self._save_ring()
+        relinker.relink(self.testdir, self.devices, True, device='none')
+
+        self.assertFalse(os.path.isdir(self.expected_dir))
+        self.assertFalse(os.path.isfile(self.expected_file))
+
     def _common_test_cleanup(self, relink=True):
         # Create a ring that has prev_part_power set
         self.rb.prepare_increase_partition_power()
@@ -121,6 +148,187 @@ class TestRelinker(unittest.TestCase):
         self.assertFalse(os.path.isfile(
             os.path.join(self.objdir, self.object_fname)))
 
+    def test_cleanup_device_filter(self):
+        self._common_test_cleanup()
+        self.assertEqual(0, relinker.cleanup(self.testdir, self.devices, True,
+                                             device=self.existing_device))
+
+        # Old objectname should be removed, new should still exist
+        self.assertTrue(os.path.isdir(self.expected_dir))
+        self.assertTrue(os.path.isfile(self.expected_file))
+        self.assertFalse(os.path.isfile(
+            os.path.join(self.objdir, self.object_fname)))
+
+    def test_cleanup_device_filter_invalid(self):
+        self._common_test_cleanup()
+        self.assertEqual(0, relinker.cleanup(self.testdir, self.devices, True,
+                                             device='none'))
+
+        # Old objectname should still exist, new should still exist
+        self.assertTrue(os.path.isdir(self.expected_dir))
+        self.assertTrue(os.path.isfile(self.expected_file))
+        self.assertTrue(os.path.isfile(
+            os.path.join(self.objdir, self.object_fname)))
+
+    def test_relink_cleanup(self):
+        state_file = os.path.join(self.devices, self.existing_device,
+                                  'relink.objects.json')
+
+        self.rb.prepare_increase_partition_power()
+        self._save_ring()
+        relinker.relink(self.testdir, self.devices, True)
+        with open(state_file, 'rt') as f:
+            self.assertEqual(json.load(f), {str(self.part): [True, False]})
+
+        self.rb.increase_partition_power()
+        self.rb._ring = None  # Force builder to reload ring
+        self._save_ring()
+        relinker.cleanup(self.testdir, self.devices, True)
+        with open(state_file, 'rt') as f:
+            self.assertEqual(json.load(f),
+                             {str(self.part): [True, True],
+                              str(self.next_part): [True, True]})
+
+    def test_devices_filter_filtering(self):
+        # With no filtering, returns all devices
+        devices = relinker.devices_filter(None, "", [self.existing_device])
+        self.assertEqual(set([self.existing_device]), devices)
+
+        # With a matching filter, returns what is matching
+        devices = relinker.devices_filter(self.existing_device, "",
+                                          [self.existing_device, 'sda2'])
+        self.assertEqual(set([self.existing_device]), devices)
+
+        # With a non matching filter, returns nothing
+        devices = relinker.devices_filter('none', "", [self.existing_device])
+        self.assertEqual(set(), devices)
+
+    def test_hook_pre_post_device_locking(self):
+        locks = [None]
+        device_path = os.path.join(self.devices, self.existing_device)
+        datadir = 'object'
+        lock_file = os.path.join(device_path, '.relink.%s.lock' % datadir)
+
+        # The first run gets the lock
+        relinker.hook_pre_device(locks, {}, datadir, device_path)
+        self.assertNotEqual([None], locks)
+
+        # A following run would block
+        with self.assertRaises(IOError) as raised:
+            with open(lock_file, 'a') as f:
+                fcntl.flock(f.fileno(), fcntl.LOCK_EX | fcntl.LOCK_NB)
+        self.assertEqual(errno.EAGAIN, raised.exception.errno)
+
+        # Another must not get the lock, so it must return an empty list
+        relinker.hook_post_device(locks, "")
+        self.assertEqual([None], locks)
+
+        with open(lock_file, 'a') as f:
+            fcntl.flock(f.fileno(), fcntl.LOCK_EX | fcntl.LOCK_NB)
+
+    def test_state_file(self):
+        device_path = os.path.join(self.devices, self.existing_device)
+        datadir = 'objects'
+        datadir_path = os.path.join(device_path, datadir)
+        state_file = os.path.join(device_path, 'relink.%s.json' % datadir)
+
+        def call_partition_filter(step, parts):
+            # Partition 312 will be ignored because it must have been created
+            # by the relinker
+            return relinker.partitions_filter(states, step,
+                                              PART_POWER, PART_POWER + 1,
+                                              datadir_path, parts)
+
+        # Start relinking
+        states = {}
+
+        # Load the states: As it starts, it must be empty
+        locks = [None]
+        relinker.hook_pre_device(locks, states, datadir, device_path)
+        self.assertEqual({}, states)
+        os.close(locks[0])  # Release the lock
+
+        # Partition 312 is ignored because it must have been created with the
+        # next_part_power, so it does not need to be relinked
+        # 96 and 227 are reverse ordered
+        # auditor_status_ALL.json is ignored because it's not a partition
+        self.assertEqual(['227', '96'],
+                         call_partition_filter(relinker.STEP_RELINK,
+                                               ['96', '227', '312',
+                                                'auditor_status.json']))
+        self.assertEqual(states, {'96': [False, False], '227': [False, False]})
+
+        # Ack partition 96
+        relinker.hook_post_partition(states, relinker.STEP_RELINK,
+                                     os.path.join(datadir_path, '96'))
+        self.assertEqual(states, {'96': [True, False], '227': [False, False]})
+        with open(state_file, 'rt') as f:
+            self.assertEqual(json.load(f), {'96': [True, False],
+                                            '227': [False, False]})
+
+        # Restart relinking after only part 96 was done
+        self.assertEqual(['227'],
+                         call_partition_filter(relinker.STEP_RELINK,
+                                               ['96', '227', '312']))
+        self.assertEqual(states, {'96': [True, False], '227': [False, False]})
+
+        # Ack partition 227
+        relinker.hook_post_partition(states, relinker.STEP_RELINK,
+                                     os.path.join(datadir_path, '227'))
+        self.assertEqual(states, {'96': [True, False], '227': [True, False]})
+        with open(state_file, 'rt') as f:
+            self.assertEqual(json.load(f), {'96': [True, False],
+                                            '227': [True, False]})
+
+        # If the process restarts, it reload the state
+        locks = [None]
+        states = {}
+        relinker.hook_pre_device(locks, states, datadir, device_path)
+        self.assertEqual(states, {'96': [True, False], '227': [True, False]})
+        os.close(locks[0])  # Release the lock
+
+        # Start cleanup
+        self.assertEqual(['227', '96'],
+                         call_partition_filter(relinker.STEP_CLEANUP,
+                                               ['96', '227', '312']))
+        # Ack partition 227
+        relinker.hook_post_partition(states, relinker.STEP_CLEANUP,
+                                     os.path.join(datadir_path, '227'))
+        self.assertEqual(states, {'96': [True, False], '227': [True, True]})
+        with open(state_file, 'rt') as f:
+            self.assertEqual(json.load(f), {'96': [True, False],
+                                            '227': [True, True]})
+
+        # Restart cleanup after only part 227 was done
+        self.assertEqual(['96'],
+                         call_partition_filter(relinker.STEP_CLEANUP,
+                                               ['96', '227', '312']))
+        self.assertEqual(states, {'96': [True, False], '227': [True, True]})
+
+        # Ack partition 96
+        relinker.hook_post_partition(states, relinker.STEP_CLEANUP,
+                                     os.path.join(datadir_path, '96'))
+        self.assertEqual(states, {'96': [True, True], '227': [True, True]})
+        with open(state_file, 'rt') as f:
+            self.assertEqual(json.load(f), {'96': [True, True],
+                                            '227': [True, True]})
+
+        # At the end, the state is still accurate
+        locks = [None]
+        states = {}
+        relinker.hook_pre_device(locks, states, datadir, device_path)
+        self.assertEqual(states, {'96': [True, True], '227': [True, True]})
+        os.close(locks[0])  # Release the lock
+
+        # If the file gets corrupted, restart from scratch
+        with open(state_file, 'wt') as f:
+            f.write('NOT JSON')
+        locks = [None]
+        states = {}
+        relinker.hook_pre_device(locks, states, datadir, device_path)
+        self.assertEqual(states, {})
+        os.close(locks[0])  # Release the lock
+
     def test_cleanup_not_yet_relinked(self):
         self._common_test_cleanup(relink=False)
         self.assertEqual(1, relinker.cleanup(self.testdir, self.devices, True))
@@ -176,3 +384,7 @@ class TestRelinker(unittest.TestCase):
 
         self.assertIn('failed audit and was quarantined',
                       self.logger.get_lines_for_level('warning')[0])
+
+
+if __name__ == '__main__':
+    unittest.main()
diff -pruN 2.25.0-3/test/unit/cli/test_ringbuilder.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/cli/test_ringbuilder.py
--- 2.25.0-3/test/unit/cli/test_ringbuilder.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/cli/test_ringbuilder.py	2020-09-15 21:13:36.000000000 +0000
@@ -535,7 +535,7 @@ class TestCommands(unittest.TestCase, Ru
 
         argv = ["", self.tmpfile, "add",
                 "r0z0-127.0.1.1:6200/sda1_some meta data", "100"]
-        self.assertSystemExit(EXIT_WARNING, ringbuilder.main, argv)
+        self.assertSystemExit(EXIT_ERROR, ringbuilder.main, argv)
 
     def test_remove_device(self):
         for search_value in self.search_values:
@@ -817,7 +817,7 @@ class TestCommands(unittest.TestCase, Ru
         ring.save(self.tmpfile)
 
         argv = ["", self.tmpfile, "remove", "d0"]
-        self.assertSystemExit(EXIT_WARNING, ringbuilder.main, argv)
+        self.assertSystemExit(EXIT_ERROR, ringbuilder.main, argv)
 
     def test_set_weight(self):
         for search_value in self.search_values:
@@ -2536,7 +2536,7 @@ class TestCommands(unittest.TestCase, Ru
         ring.save(self.tmpfile)
 
         argv = ["", self.tmpfile, "rebalance", "3"]
-        self.assertSystemExit(EXIT_WARNING, ringbuilder.main, argv)
+        self.assertSystemExit(EXIT_ERROR, ringbuilder.main, argv)
 
     def test_write_ring(self):
         self.create_sample_ring()
diff -pruN 2.25.0-3/test/unit/common/middleware/crypto/test_keymaster.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/crypto/test_keymaster.py
--- 2.25.0-3/test/unit/common/middleware/crypto/test_keymaster.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/crypto/test_keymaster.py	2020-09-15 21:13:36.000000000 +0000
@@ -20,6 +20,7 @@ import hmac
 import os
 
 import mock
+import six
 import unittest
 
 from getpass import getuser
@@ -49,17 +50,45 @@ class TestKeymaster(unittest.TestCase):
         self.app = keymaster.KeyMaster(self.swift, TEST_KEYMASTER_CONF)
 
     def test_object_path(self):
-        self.verify_keys_for_path(
+        self.verify_v3_keys_for_path(
             '/a/c/o', expected_keys=('object', 'container'))
+        self.verify_v3_keys_for_path(
+            '/a/c//o', expected_keys=('object', 'container'))
         self.verify_keys_for_path(
             '/a/c//o', expected_keys=('object', 'container'))
+        self.verify_v1_keys_for_path(
+            '/a/c//o', expected_keys=('object', 'container'))
 
     def test_container_path(self):
-        self.verify_keys_for_path(
+        self.verify_v3_keys_for_path(
             '/a/c', expected_keys=('container',))
 
-    def verify_keys_for_path(self, path, expected_keys, key_id=None):
+    def test_unicode_object_path(self):
+        # NB: path is WSGI
+        self.verify_v3_keys_for_path(
+            '/\xe2\x98\x83/\xf0\x9f\x8c\xb4/\xf0\x9f\x8c\x8a',
+            expected_keys=('object', 'container'))
+        self.verify_keys_for_path(
+            '/\xe2\x98\x83/\xf0\x9f\x8c\xb4/\xf0\x9f\x8c\x8a',
+            expected_keys=('object', 'container'))
+        self.verify_v1_keys_for_path(
+            '/\xe2\x98\x83/\xf0\x9f\x8c\xb4/\xf0\x9f\x8c\x8a',
+            expected_keys=('object', 'container'))
+
+        # Double-whammy: *also* hit the os.path.join issue
+        self.verify_v3_keys_for_path(
+            '/\xe2\x98\x83/\xf0\x9f\x8c\xb4//\xf0\x9f\x8c\x8a',
+            expected_keys=('object', 'container'))
+        self.verify_keys_for_path(
+            '/\xe2\x98\x83/\xf0\x9f\x8c\xb4//\xf0\x9f\x8c\x8a',
+            expected_keys=('object', 'container'))
+        self.verify_v1_keys_for_path(
+            '/\xe2\x98\x83/\xf0\x9f\x8c\xb4//\xf0\x9f\x8c\x8a',
+            expected_keys=('object', 'container'))
+
+    def verify_v3_keys_for_path(self, wsgi_path, expected_keys, key_id=None):
         put_keys = None
+        self.app.meta_version_to_write = '3'
         for method, resp_class, status in (
                 ('PUT', swob.HTTPCreated, '201'),
                 ('POST', swob.HTTPAccepted, '202'),
@@ -67,9 +96,9 @@ class TestKeymaster(unittest.TestCase):
                 ('HEAD', swob.HTTPNoContent, '204')):
             resp_headers = {}
             self.swift.register(
-                method, '/v1' + path, resp_class, resp_headers, b'')
+                method, '/v1' + wsgi_path, resp_class, resp_headers, b'')
             req = Request.blank(
-                '/v1' + path, environ={'REQUEST_METHOD': method})
+                '/v1' + wsgi_path, environ={'REQUEST_METHOD': method})
             start_response, calls = capture_start_response()
             self.app(req.environ, start_response)
             self.assertEqual(1, len(calls))
@@ -80,7 +109,48 @@ class TestKeymaster(unittest.TestCase):
             keys = req.environ.get(CRYPTO_KEY_CALLBACK)(key_id=key_id)
             self.assertIn('id', keys)
             id = keys.pop('id')
+            path = swob.wsgi_to_str(wsgi_path)
             self.assertEqual(path, id['path'])
+            self.assertEqual('3', id['v'])
+            keys.pop('all_ids')
+            self.assertListEqual(sorted(expected_keys), sorted(keys.keys()),
+                                 '%s %s got keys %r, but expected %r'
+                                 % (method, path, keys.keys(), expected_keys))
+            if put_keys is not None:
+                # check all key sets were consistent for this path
+                self.assertDictEqual(put_keys, keys)
+            else:
+                put_keys = keys
+        self.app.meta_version_to_write = '2'  # Clean up after ourselves
+        return put_keys
+
+    def verify_keys_for_path(self, wsgi_path, expected_keys, key_id=None):
+        put_keys = None
+        for method, resp_class, status in (
+                ('PUT', swob.HTTPCreated, '201'),
+                ('POST', swob.HTTPAccepted, '202'),
+                ('GET', swob.HTTPOk, '200'),
+                ('HEAD', swob.HTTPNoContent, '204')):
+            resp_headers = {}
+            self.swift.register(
+                method, '/v1' + wsgi_path, resp_class, resp_headers, b'')
+            req = Request.blank(
+                '/v1' + wsgi_path, environ={'REQUEST_METHOD': method})
+            start_response, calls = capture_start_response()
+            self.app(req.environ, start_response)
+            self.assertEqual(1, len(calls))
+            self.assertTrue(calls[0][0].startswith(status))
+            self.assertNotIn('swift.crypto.override', req.environ)
+            self.assertIn(CRYPTO_KEY_CALLBACK, req.environ,
+                          '%s not set in env' % CRYPTO_KEY_CALLBACK)
+            keys = req.environ.get(CRYPTO_KEY_CALLBACK)(key_id=key_id)
+            self.assertIn('id', keys)
+            id = keys.pop('id')
+            path = swob.wsgi_to_str(wsgi_path)
+            if six.PY2:
+                self.assertEqual(path, id['path'])
+            else:
+                self.assertEqual(swob.str_to_wsgi(path), id['path'])
             self.assertEqual('2', id['v'])
             keys.pop('all_ids')
             self.assertListEqual(sorted(expected_keys), sorted(keys.keys()),
@@ -93,6 +163,49 @@ class TestKeymaster(unittest.TestCase):
                 put_keys = keys
         return put_keys
 
+    def verify_v1_keys_for_path(self, wsgi_path, expected_keys, key_id=None):
+        put_keys = None
+        self.app.meta_version_to_write = '1'
+        for method, resp_class, status in (
+                ('PUT', swob.HTTPCreated, '201'),
+                ('POST', swob.HTTPAccepted, '202'),
+                ('GET', swob.HTTPOk, '200'),
+                ('HEAD', swob.HTTPNoContent, '204')):
+            resp_headers = {}
+            self.swift.register(
+                method, '/v1' + wsgi_path, resp_class, resp_headers, b'')
+            req = Request.blank(
+                '/v1' + wsgi_path, environ={'REQUEST_METHOD': method})
+            start_response, calls = capture_start_response()
+            self.app(req.environ, start_response)
+            self.assertEqual(1, len(calls))
+            self.assertTrue(calls[0][0].startswith(status))
+            self.assertNotIn('swift.crypto.override', req.environ)
+            self.assertIn(CRYPTO_KEY_CALLBACK, req.environ,
+                          '%s not set in env' % CRYPTO_KEY_CALLBACK)
+            keys = req.environ.get(CRYPTO_KEY_CALLBACK)(key_id=key_id)
+            self.assertIn('id', keys)
+            id = keys.pop('id')
+            path = swob.wsgi_to_str(wsgi_path)
+            if '//' in path:
+                path = path[path.index('//') + 1:]
+            if six.PY2:
+                self.assertEqual(path, id['path'])
+            else:
+                self.assertEqual(swob.str_to_wsgi(path), id['path'])
+            self.assertEqual('1', id['v'])
+            keys.pop('all_ids')
+            self.assertListEqual(sorted(expected_keys), sorted(keys.keys()),
+                                 '%s %s got keys %r, but expected %r'
+                                 % (method, path, keys.keys(), expected_keys))
+            if put_keys is not None:
+                # check all key sets were consistent for this path
+                self.assertDictEqual(put_keys, keys)
+            else:
+                put_keys = keys
+        self.app.meta_version_to_write = '2'  # Clean up after ourselves
+        return put_keys
+
     def test_key_uniqueness(self):
         # a rudimentary check that different keys are made for different paths
         ref_path_parts = ('a1', 'c1', 'o1')
@@ -432,7 +545,7 @@ class TestKeymaster(unittest.TestCase):
             return orig_create_key(path, secret_id)
 
         context = keymaster.KeyMasterContext(self.app, 'a', 'c', 'o')
-        for version in ('1', '2'):
+        for version in ('1', '2', '3'):
             with mock.patch.object(self.app, 'create_key', mock_create_key):
                 keys = context.fetch_crypto_keys(key_id={
                     'v': version, 'path': '/a/c/o'})
@@ -502,7 +615,7 @@ class TestKeymaster(unittest.TestCase):
         # request path doesn't match stored path -- this could happen if you
         # misconfigured your proxy to have copy right of encryption
         context = keymaster.KeyMasterContext(self.app, 'a', 'not-c', 'not-o')
-        for version in ('1', '2'):
+        for version in ('1', '2', '3'):
             with mock.patch.object(self.app, 'create_key', mock_create_key):
                 keys = context.fetch_crypto_keys(key_id={
                     'v': version, 'path': '/a/c/o'})
@@ -554,6 +667,106 @@ class TestKeymaster(unittest.TestCase):
         self.assertEqual(expected_keys, keys)
         self.assertEqual([('/a/c', None), ('/a/c//o', None)], calls)
 
+    def test_v2_keys(self):
+        secrets = {None: os.urandom(32),
+                   '22': os.urandom(33)}
+        conf = {}
+        for secret_id, secret in secrets.items():
+            opt = ('encryption_root_secret%s' %
+                   (('_%s' % secret_id) if secret_id else ''))
+            conf[opt] = base64.b64encode(secret)
+        conf['active_root_secret_id'] = '22'
+        self.app = keymaster.KeyMaster(self.swift, conf)
+        orig_create_key = self.app.create_key
+        calls = []
+
+        def mock_create_key(path, secret_id=None):
+            calls.append((path, secret_id))
+            return orig_create_key(path, secret_id)
+
+        container = u'\N{SNOWMAN}'
+        obj = u'\N{SNOWFLAKE}'
+        if six.PY2:
+            container = container.encode('utf-8')
+            obj = obj.encode('utf-8')
+        good_con_path = '/a/%s' % container
+        good_path = '/a/%s/%s' % (container, obj)
+
+        if six.PY2:
+            mangled_con_path = ('/a/%s' % container).decode(
+                'latin-1').encode('utf-8')
+            mangled_path = ('/a/%s/%s' % (
+                container, obj)).decode('latin-1').encode('utf-8')
+        else:
+            mangled_con_path = ('/a/%s' % container).encode(
+                'utf-8').decode('latin-1')
+            mangled_path = ('/a/%s/%s' % (
+                container, obj)).encode('utf-8').decode('latin-1')
+
+        context = keymaster.KeyMasterContext(self.app, 'a', container, obj)
+        for version in ('1', '2', '3'):
+            with mock.patch.object(self.app, 'create_key', mock_create_key):
+                keys = context.fetch_crypto_keys(key_id={
+                    'v': version, 'path': good_path})
+            key_id_path = (good_path if version == '3' or six.PY2
+                           else mangled_path)
+            expected_keys = {
+                'container': hmac.new(secrets[None], b'/a/\xe2\x98\x83',
+                                      digestmod=hashlib.sha256).digest(),
+                'object': hmac.new(
+                    secrets[None], b'/a/\xe2\x98\x83/\xe2\x9d\x84',
+                    digestmod=hashlib.sha256).digest(),
+                'id': {'path': key_id_path, 'v': version},
+                'all_ids': [
+                    {'path': key_id_path, 'v': version},
+                    {'path': key_id_path, 'secret_id': '22', 'v': version}]}
+            self.assertEqual(expected_keys, keys)
+            self.assertEqual([(good_con_path, None), (good_path, None)], calls)
+            del calls[:]
+
+        context = keymaster.KeyMasterContext(self.app, 'a', container, obj)
+        for version in ('1', '2'):
+            with mock.patch.object(self.app, 'create_key', mock_create_key):
+                keys = context.fetch_crypto_keys(key_id={
+                    'v': version, 'path': mangled_path})
+            key_id_path = (good_path if six.PY2 else mangled_path)
+            expected_keys = {
+                'container': hmac.new(secrets[None], b'/a/\xe2\x98\x83',
+                                      digestmod=hashlib.sha256).digest(),
+                'object': hmac.new(
+                    secrets[None], b'/a/\xe2\x98\x83/\xe2\x9d\x84',
+                    digestmod=hashlib.sha256).digest(),
+                'id': {'path': key_id_path, 'v': version},
+                'all_ids': [
+                    {'path': key_id_path, 'v': version},
+                    {'path': key_id_path, 'secret_id': '22', 'v': version}]}
+            self.assertEqual(expected_keys, keys)
+            self.assertEqual([(good_con_path, None), (good_path, None)], calls)
+            del calls[:]
+
+        # If v3, we know to trust the meta -- presumably, data was PUT with
+        # the mojibake path then COPYed to the right path (but with bad
+        # pipeline placement for copy)
+        with mock.patch.object(self.app, 'create_key', mock_create_key):
+            keys = context.fetch_crypto_keys(key_id={
+                'v': '3', 'path': mangled_path})
+        expected_keys = {
+            'container': hmac.new(
+                secrets[None], b'/a/\xc3\xa2\xc2\x98\xc2\x83',
+                digestmod=hashlib.sha256).digest(),
+            'object': hmac.new(
+                secrets[None],
+                b'/a/\xc3\xa2\xc2\x98\xc2\x83/\xc3\xa2\xc2\x9d\xc2\x84',
+                digestmod=hashlib.sha256).digest(),
+            'id': {'path': mangled_path, 'v': '3'},
+            'all_ids': [
+                {'path': mangled_path, 'v': '3'},
+                {'path': mangled_path, 'secret_id': '22', 'v': '3'}]}
+        self.assertEqual(expected_keys, keys)
+        self.assertEqual([(mangled_con_path, None), (mangled_path, None)],
+                         calls)
+        del calls[:]
+
     @mock.patch('swift.common.middleware.crypto.keymaster.readconf')
     def test_keymaster_config_path(self, mock_readconf):
         for secret in (os.urandom(32), os.urandom(33), os.urandom(50)):
diff -pruN 2.25.0-3/test/unit/common/middleware/s3api/__init__.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/s3api/__init__.py
--- 2.25.0-3/test/unit/common/middleware/s3api/__init__.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/s3api/__init__.py	2020-09-15 21:13:36.000000000 +0000
@@ -50,6 +50,18 @@ class FakeApp(object):
         if 's3api.auth_details' in env:
             self._update_s3_path_info(env)
 
+        if env['REQUEST_METHOD'] == 'TEST':
+
+            def authorize_cb(req):
+                # Assume swift owner, if not yet set
+                req.environ.setdefault('REMOTE_USER', 'authorized')
+                req.environ.setdefault('swift_owner', True)
+                # But then default to blocking authz, to ensure we've replaced
+                # the default auth system
+                return swob.HTTPForbidden(request=req)
+
+            env['swift.authorize'] = authorize_cb
+
         return self.swift(env, start_response)
 
 
diff -pruN 2.25.0-3/test/unit/common/middleware/s3api/test_multi_upload.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/s3api/test_multi_upload.py
--- 2.25.0-3/test/unit/common/middleware/s3api/test_multi_upload.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/s3api/test_multi_upload.py	2020-09-15 21:13:36.000000000 +0000
@@ -137,6 +137,22 @@ class TestS3ApiMultiUpload(S3ApiTestCase
                                      'Date': self.get_date_header()})
         status, headers, body = self.call_s3api(req)
         self.assertEqual(self._get_error_code(body), 'InvalidRequest')
+        self.assertEqual([], self.swift.calls)
+
+    def test_bucket_upload_part_success(self):
+        req = Request.blank('/bucket/object?partNumber=1&uploadId=X',
+                            method='PUT',
+                            headers={'Authorization': 'AWS test:tester:hmac',
+                                     'Date': self.get_date_header()})
+        with patch('swift.common.middleware.s3api.s3request.'
+                   'get_container_info',
+                   lambda env, app, swift_source: {'status': 204}):
+            status, headers, body = self.call_s3api(req)
+        self.assertEqual(status, '200 OK')
+        self.assertEqual([
+            ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
+            ('PUT', '/v1/AUTH_test/bucket+segments/object/X/1'),
+        ], self.swift.calls)
 
     @s3acl
     def test_object_multipart_uploads_list(self):
@@ -577,12 +593,10 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         self.assertNotIn('Content-MD5', req_headers)
         if bucket_exists:
             self.assertEqual([
-                ('HEAD', '/v1/AUTH_test/bucket'),
                 ('PUT', '/v1/AUTH_test/bucket+segments/object/X'),
             ], self.swift.calls)
         else:
             self.assertEqual([
-                ('HEAD', '/v1/AUTH_test/bucket'),
                 ('PUT', '/v1/AUTH_test/bucket+segments'),
                 ('PUT', '/v1/AUTH_test/bucket+segments/object/X'),
             ], self.swift.calls)
@@ -596,6 +610,8 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         fake_memcache = FakeMemcache()
         fake_memcache.store[get_cache_key(
             'AUTH_test', 'bucket+segments')] = {'status': 204}
+        fake_memcache.store[get_cache_key(
+            'AUTH_test', 'bucket')] = {'status': 204}
         self._test_object_multipart_upload_initiate({}, fake_memcache)
         self._test_object_multipart_upload_initiate({'Etag': 'blahblahblah'},
                                                     fake_memcache)
@@ -826,8 +842,9 @@ class TestS3ApiMultiUpload(S3ApiTestCase
 
         self.assertEqual(self.swift.calls, [
             # Bucket exists
+            ('HEAD', '/v1/AUTH_test'),
             ('HEAD', '/v1/AUTH_test/bucket'),
-            # Segment container exists
+            # Upload marker exists
             ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
             # Create the SLO
             ('PUT', '/v1/AUTH_test/bucket/object'
@@ -843,6 +860,126 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         override_etag = '; s3_etag=%s' % S3_ETAG.strip('"')
         h = 'X-Object-Sysmeta-Container-Update-Override-Etag'
         self.assertEqual(headers.get(h), override_etag)
+        self.assertEqual(headers.get('X-Object-Sysmeta-S3Api-Upload-Id'), 'X')
+
+    def test_object_multipart_upload_retry_complete(self):
+        content_md5 = base64.b64encode(hashlib.md5(
+            XML.encode('ascii')).digest())
+        self.swift.register('HEAD', '/v1/AUTH_test/bucket+segments/object/X',
+                            swob.HTTPNotFound, {}, None)
+        recent_ts = S3Timestamp.now(delta=-1000000).internal  # 10s ago
+        self.swift.register('HEAD', '/v1/AUTH_test/bucket/object',
+                            swob.HTTPOk,
+                            {'x-object-meta-foo': 'bar',
+                             'content-type': 'baz/quux',
+                             'x-object-sysmeta-s3api-upload-id': 'X',
+                             'x-object-sysmeta-s3api-etag': S3_ETAG.strip('"'),
+                             'x-timestamp': recent_ts}, None)
+        req = Request.blank('/bucket/object?uploadId=X',
+                            environ={'REQUEST_METHOD': 'POST'},
+                            headers={'Authorization': 'AWS test:tester:hmac',
+                                     'Date': self.get_date_header(),
+                                     'Content-MD5': content_md5, },
+                            body=XML)
+        status, headers, body = self.call_s3api(req)
+        elem = fromstring(body, 'CompleteMultipartUploadResult')
+        self.assertNotIn('Etag', headers)
+        self.assertEqual(elem.find('ETag').text, S3_ETAG)
+        self.assertEqual(status.split()[0], '200')
+
+        self.assertEqual(self.swift.calls, [
+            # Bucket exists
+            ('HEAD', '/v1/AUTH_test'),
+            ('HEAD', '/v1/AUTH_test/bucket'),
+            # Upload marker does not exist
+            ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
+            # But the object does, and with the same upload ID
+            ('HEAD', '/v1/AUTH_test/bucket/object'),
+            # So no PUT necessary
+        ])
+
+    def test_object_multipart_upload_retry_complete_etag_mismatch(self):
+        content_md5 = base64.b64encode(hashlib.md5(
+            XML.encode('ascii')).digest())
+        self.swift.register('HEAD', '/v1/AUTH_test/bucket+segments/object/X',
+                            swob.HTTPNotFound, {}, None)
+        recent_ts = S3Timestamp.now(delta=-1000000).internal
+        self.swift.register('HEAD', '/v1/AUTH_test/bucket/object',
+                            swob.HTTPOk,
+                            {'x-object-meta-foo': 'bar',
+                             'content-type': 'baz/quux',
+                             'x-object-sysmeta-s3api-upload-id': 'X',
+                             'x-object-sysmeta-s3api-etag': 'not-the-etag',
+                             'x-timestamp': recent_ts}, None)
+        req = Request.blank('/bucket/object?uploadId=X',
+                            environ={'REQUEST_METHOD': 'POST'},
+                            headers={'Authorization': 'AWS test:tester:hmac',
+                                     'Date': self.get_date_header(),
+                                     'Content-MD5': content_md5, },
+                            body=XML)
+        status, headers, body = self.call_s3api(req)
+        elem = fromstring(body, 'CompleteMultipartUploadResult')
+        self.assertNotIn('Etag', headers)
+        self.assertEqual(elem.find('ETag').text, S3_ETAG)
+        self.assertEqual(status.split()[0], '200')
+
+        self.assertEqual(self.swift.calls, [
+            # Bucket exists
+            ('HEAD', '/v1/AUTH_test'),
+            ('HEAD', '/v1/AUTH_test/bucket'),
+            # Upload marker does not exist
+            ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
+            # But the object does, and with the same upload ID
+            ('HEAD', '/v1/AUTH_test/bucket/object'),
+            # Create the SLO
+            ('PUT', '/v1/AUTH_test/bucket/object'
+                    '?heartbeat=on&multipart-manifest=put'),
+            # Retry deleting the marker for the sake of completeness
+            ('DELETE', '/v1/AUTH_test/bucket+segments/object/X')
+        ])
+
+        _, _, headers = self.swift.calls_with_headers[-2]
+        self.assertEqual(headers.get('X-Object-Meta-Foo'), 'bar')
+        self.assertEqual(headers.get('Content-Type'), 'baz/quux')
+        # SLO will provide a base value
+        override_etag = '; s3_etag=%s' % S3_ETAG.strip('"')
+        h = 'X-Object-Sysmeta-Container-Update-Override-Etag'
+        self.assertEqual(headers.get(h), override_etag)
+        self.assertEqual(headers.get('X-Object-Sysmeta-S3Api-Upload-Id'), 'X')
+
+    def test_object_multipart_upload_retry_complete_upload_id_mismatch(self):
+        content_md5 = base64.b64encode(hashlib.md5(
+            XML.encode('ascii')).digest())
+        self.swift.register('HEAD', '/v1/AUTH_test/bucket+segments/object/X',
+                            swob.HTTPNotFound, {}, None)
+        recent_ts = S3Timestamp.now(delta=-1000000).internal
+        self.swift.register('HEAD', '/v1/AUTH_test/bucket/object',
+                            swob.HTTPOk,
+                            {'x-object-meta-foo': 'bar',
+                             'content-type': 'baz/quux',
+                             'x-object-sysmeta-s3api-upload-id': 'Y',
+                             'x-object-sysmeta-s3api-etag': S3_ETAG.strip('"'),
+                             'x-timestamp': recent_ts}, None)
+        req = Request.blank('/bucket/object?uploadId=X',
+                            environ={'REQUEST_METHOD': 'POST'},
+                            headers={'Authorization': 'AWS test:tester:hmac',
+                                     'Date': self.get_date_header(),
+                                     'Content-MD5': content_md5, },
+                            body=XML)
+        status, headers, body = self.call_s3api(req)
+        elem = fromstring(body, 'Error')
+        self.assertEqual(elem.find('Code').text, 'NoSuchUpload')
+        self.assertEqual(status.split()[0], '404')
+
+        self.assertEqual(self.swift.calls, [
+            # Bucket exists
+            ('HEAD', '/v1/AUTH_test'),
+            ('HEAD', '/v1/AUTH_test/bucket'),
+            # Upload marker does not exist
+            ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
+            # But the object does, and with the same upload ID
+            ('HEAD', '/v1/AUTH_test/bucket/object'),
+        ])
 
     def test_object_multipart_upload_invalid_md5(self):
         bad_md5 = base64.b64encode(hashlib.md5(
@@ -902,6 +1039,7 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         # NB: S3_ETAG includes quotes
         self.assertIn(('<ETag>%s</ETag>' % S3_ETAG).encode('ascii'), body)
         self.assertEqual(self.swift.calls, [
+            ('HEAD', '/v1/AUTH_test'),
             ('HEAD', '/v1/AUTH_test/bucket'),
             ('HEAD', '/v1/AUTH_test/bucket+segments/heartbeat-ok/X'),
             ('PUT', '/v1/AUTH_test/bucket/heartbeat-ok?'
@@ -952,6 +1090,7 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         self.assertEqual(self._get_error_message(body),
                          'some/object: 403 Forbidden')
         self.assertEqual(self.swift.calls, [
+            ('HEAD', '/v1/AUTH_test'),
             ('HEAD', '/v1/AUTH_test/bucket'),
             ('HEAD', '/v1/AUTH_test/bucket+segments/heartbeat-fail/X'),
             ('PUT', '/v1/AUTH_test/bucket/heartbeat-fail?'
@@ -1001,6 +1140,7 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         self.assertIn('One or more of the specified parts could not be found',
                       self._get_error_message(body))
         self.assertEqual(self.swift.calls, [
+            ('HEAD', '/v1/AUTH_test'),
             ('HEAD', '/v1/AUTH_test/bucket'),
             ('HEAD', '/v1/AUTH_test/bucket+segments/heartbeat-fail/X'),
             ('PUT', '/v1/AUTH_test/bucket/heartbeat-fail?'
@@ -1091,8 +1231,13 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         self.assertEqual(self._get_error_code(body), 'EntityTooSmall')
         self.assertEqual(self._get_error_message(body), msg)
         # We punt to SLO to do the validation
-        self.assertEqual([method for method, _ in self.swift.calls],
-                         ['HEAD', 'HEAD', 'PUT'])
+        self.assertEqual(self.swift.calls, [
+            ('HEAD', '/v1/AUTH_test'),
+            ('HEAD', '/v1/AUTH_test/bucket'),
+            ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
+            ('PUT', '/v1/AUTH_test/bucket/object'
+             '?heartbeat=on&multipart-manifest=put'),
+        ])
 
         self.swift.clear_calls()
         self.s3api.conf.min_segment_size = 5242880
@@ -1112,8 +1257,13 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         self.assertEqual(self._get_error_code(body), 'EntityTooSmall')
         self.assertEqual(self._get_error_message(body), msg)
         # Again, we punt to SLO to do the validation
-        self.assertEqual([method for method, _ in self.swift.calls],
-                         ['HEAD', 'HEAD', 'PUT'])
+        self.assertEqual(self.swift.calls, [
+            ('HEAD', '/v1/AUTH_test'),
+            ('HEAD', '/v1/AUTH_test/bucket'),
+            ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
+            ('PUT', '/v1/AUTH_test/bucket/object'
+             '?heartbeat=on&multipart-manifest=put'),
+        ])
 
     def test_object_multipart_upload_complete_zero_segments(self):
         segment_bucket = '/v1/AUTH_test/empty-bucket+segments'
@@ -1151,6 +1301,7 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         fromstring(body, 'Error')
 
         self.assertEqual(self.swift.calls, [
+            ('HEAD', '/v1/AUTH_test'),
             ('HEAD', '/v1/AUTH_test/empty-bucket'),
             ('HEAD', '/v1/AUTH_test/empty-bucket+segments/object/X'),
         ])
@@ -1197,6 +1348,7 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         self.assertEqual(status.split()[0], '200')
 
         self.assertEqual(self.swift.calls, [
+            ('HEAD', '/v1/AUTH_test'),
             ('HEAD', '/v1/AUTH_test/empty-bucket'),
             ('HEAD', '/v1/AUTH_test/empty-bucket+segments/object/X'),
             ('PUT', '/v1/AUTH_test/empty-bucket/object?'
@@ -1266,6 +1418,7 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         self.assertEqual(elem.find('ETag').text, expected_etag)
 
         self.assertEqual(self.swift.calls, [
+            ('HEAD', '/v1/AUTH_test'),
             ('HEAD', '/v1/AUTH_test/bucket'),
             ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
             ('PUT', '/v1/AUTH_test/bucket/object?'
@@ -1906,7 +2059,13 @@ class TestS3ApiMultiUpload(S3ApiTestCase
 
         self.assertEqual(status.split()[0], '200')
 
-        self.assertEqual(len(self.swift.calls_with_headers), 4)
+        self.assertEqual(self.swift.calls, [
+            ('HEAD', '/v1/AUTH_test'),
+            ('HEAD', '/v1/AUTH_test/bucket'),
+            ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
+            ('HEAD', '/v1/AUTH_test/src_bucket/src_obj'),
+            ('PUT', '/v1/AUTH_test/bucket+segments/object/X/1'),
+        ])
         _, _, headers = self.swift.calls_with_headers[-2]
         self.assertEqual(headers['If-Match'], etag)
         self.assertEqual(headers['If-Modified-Since'], last_modified_since)
@@ -1957,7 +2116,13 @@ class TestS3ApiMultiUpload(S3ApiTestCase
             self._test_copy_for_s3acl(account, put_header=header)
 
         self.assertEqual(status.split()[0], '200')
-        self.assertEqual(len(self.swift.calls_with_headers), 4)
+        self.assertEqual(self.swift.calls, [
+            ('HEAD', '/v1/AUTH_test'),
+            ('HEAD', '/v1/AUTH_test/bucket'),
+            ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
+            ('HEAD', '/v1/AUTH_test/src_bucket/src_obj'),
+            ('PUT', '/v1/AUTH_test/bucket+segments/object/X/1'),
+        ])
         _, _, headers = self.swift.calls_with_headers[-2]
         self.assertEqual(headers['If-None-Match'], etag)
         self.assertEqual(headers['If-Unmodified-Since'], last_modified_since)
@@ -2009,6 +2174,7 @@ class TestS3ApiMultiUpload(S3ApiTestCase
                       b'source object of size: 10', body)
 
         self.assertEqual([
+            ('HEAD', '/v1/AUTH_test'),
             ('HEAD', '/v1/AUTH_test/bucket'),
             ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
             ('HEAD', '/v1/AUTH_test/src_bucket/src_obj'),
@@ -2039,6 +2205,7 @@ class TestS3ApiMultiUpload(S3ApiTestCase
         self.assertEqual(status.split()[0], '200', body)
 
         self.assertEqual([
+            ('HEAD', '/v1/AUTH_test'),
             ('HEAD', '/v1/AUTH_test/bucket'),
             ('HEAD', '/v1/AUTH_test/bucket+segments/object/X'),
             ('HEAD', '/v1/AUTH_test/src_bucket/src_obj'),
diff -pruN 2.25.0-3/test/unit/common/middleware/s3api/test_obj.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/s3api/test_obj.py
--- 2.25.0-3/test/unit/common/middleware/s3api/test_obj.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/s3api/test_obj.py	2020-09-15 21:13:36.000000000 +0000
@@ -452,6 +452,26 @@ class TestS3ApiObj(S3ApiTestCase):
         status, headers, body = self.call_s3api(req)
         self.assertEqual(status.split()[0], '404')
 
+    @s3acl(versioning_enabled=False)
+    def test_object_GET_with_version_id_but_not_enabled(self):
+        # Version not found
+        self.swift.register(
+            'HEAD', '/v1/AUTH_test/bucket',
+            swob.HTTPNoContent, {}, None)
+        req = Request.blank('/bucket/object?versionId=A',
+                            environ={'REQUEST_METHOD': 'GET'},
+                            headers={'Authorization': 'AWS test:tester:hmac',
+                                     'Date': self.get_date_header()})
+        status, headers, body = self.call_s3api(req)
+        self.assertEqual(status.split()[0], '404')
+        elem = fromstring(body, 'Error')
+        self.assertEqual(elem.find('Code').text, 'NoSuchVersion')
+        self.assertEqual(elem.find('Key').text, 'object')
+        self.assertEqual(elem.find('VersionId').text, 'A')
+        expected_calls = []
+        # NB: No actual backend GET!
+        self.assertEqual(expected_calls, self.swift.calls)
+
     @s3acl
     def test_object_PUT_error(self):
         code = self._test_method_error('PUT', '/bucket/object',
@@ -581,6 +601,31 @@ class TestS3ApiObj(S3ApiTestCase):
         self.assertEqual(headers['etag'], etag)
 
     @s3acl
+    def test_object_PUT_quota_exceeded(self):
+        etag = self.response_headers['etag']
+        content_md5 = binascii.b2a_base64(binascii.a2b_hex(etag)).strip()
+        if not six.PY2:
+            content_md5 = content_md5.decode('ascii')
+
+        self.swift.register(
+            'PUT', '/v1/AUTH_test/bucket/object',
+            swob.HTTPRequestEntityTooLarge, {}, 'Upload exceeds quota.')
+        req = Request.blank(
+            '/bucket/object',
+            environ={'REQUEST_METHOD': 'PUT'},
+            headers={'Authorization': 'AWS test:tester:hmac',
+                     'x-amz-storage-class': 'STANDARD',
+                     'Content-MD5': content_md5,
+                     'Date': self.get_date_header()},
+            body=self.object_body)
+        req.date = datetime.now()
+        req.content_type = 'text/plain'
+        status, headers, body = self.call_s3api(req)
+        self.assertEqual(status.split()[0], '400')
+        self.assertIn(b'<Code>EntityTooLarge</Code>', body)
+        self.assertIn(b'<Message>Upload exceeds quota.</Message', body)
+
+    @s3acl
     def test_object_PUT_v4(self):
         body_sha = hashlib.sha256(self.object_body).hexdigest()
         req = Request.blank(
@@ -1108,7 +1153,15 @@ class TestS3ApiObj(S3ApiTestCase):
                             method='DELETE', headers={
                                 'Authorization': 'AWS test:tester:hmac',
                                 'Date': self.get_date_header()})
-        status, headers, body = self.call_s3api(req)
+        fake_info = {
+            'status': 204,
+            'sysmeta': {
+                'versions-container': '\x00versions\x00bucket',
+            }
+        }
+        with patch('swift.common.middleware.s3api.s3request.'
+                   'get_container_info', return_value=fake_info):
+            status, headers, body = self.call_s3api(req)
         self.assertEqual(status.split()[0], '204')
         self.assertEqual([
             ('HEAD', '/v1/AUTH_test/bucket/object'
@@ -1139,7 +1192,15 @@ class TestS3ApiObj(S3ApiTestCase):
                             method='DELETE', headers={
                                 'Authorization': 'AWS test:tester:hmac',
                                 'Date': self.get_date_header()})
-        status, headers, body = self.call_s3api(req)
+        fake_info = {
+            'status': 204,
+            'sysmeta': {
+                'versions-container': '\x00versions\x00bucket',
+            }
+        }
+        with patch('swift.common.middleware.s3api.s3request.'
+                   'get_container_info', return_value=fake_info):
+            status, headers, body = self.call_s3api(req)
         self.assertEqual(status.split()[0], '204')
         self.assertEqual([
             ('HEAD', '/v1/AUTH_test/bucket/object'
@@ -1152,6 +1213,20 @@ class TestS3ApiObj(S3ApiTestCase):
              '?version-id=1574341899.21751'),
         ], self.swift.calls)
 
+    @s3acl(versioning_enabled=False)
+    def test_object_DELETE_with_version_id_but_not_enabled(self):
+        self.swift.register('HEAD', '/v1/AUTH_test/bucket',
+                            swob.HTTPNoContent, {}, None)
+        req = Request.blank('/bucket/object?versionId=1574358170.12293',
+                            method='DELETE', headers={
+                                'Authorization': 'AWS test:tester:hmac',
+                                'Date': self.get_date_header()})
+        status, headers, body = self.call_s3api(req)
+        self.assertEqual(status.split()[0], '204')
+        expected_calls = []
+        # NB: No actual backend DELETE!
+        self.assertEqual(expected_calls, self.swift.calls)
+
     def test_object_DELETE_version_id_not_implemented(self):
         req = Request.blank('/bucket/object?versionId=1574358170.12293',
                             method='DELETE', headers={
@@ -1181,7 +1256,15 @@ class TestS3ApiObj(S3ApiTestCase):
                             method='DELETE', headers={
                                 'Authorization': 'AWS test:tester:hmac',
                                 'Date': self.get_date_header()})
-        status, headers, body = self.call_s3api(req)
+        fake_info = {
+            'status': 204,
+            'sysmeta': {
+                'versions-container': '\x00versions\x00bucket',
+            }
+        }
+        with patch('swift.common.middleware.s3api.s3request.'
+                   'get_container_info', return_value=fake_info):
+            status, headers, body = self.call_s3api(req)
         self.assertEqual(status.split()[0], '204')
         self.assertEqual([
             ('HEAD', '/v1/AUTH_test/bucket/object'
@@ -1220,7 +1303,15 @@ class TestS3ApiObj(S3ApiTestCase):
                             method='DELETE', headers={
                                 'Authorization': 'AWS test:tester:hmac',
                                 'Date': self.get_date_header()})
-        status, headers, body = self.call_s3api(req)
+        fake_info = {
+            'status': 204,
+            'sysmeta': {
+                'versions-container': '\x00versions\x00bucket',
+            }
+        }
+        with patch('swift.common.middleware.s3api.s3request.'
+                   'get_container_info', return_value=fake_info):
+            status, headers, body = self.call_s3api(req)
         self.assertEqual(status.split()[0], '204')
         self.assertEqual([
             ('HEAD', '/v1/AUTH_test/bucket/object'
@@ -1248,7 +1339,15 @@ class TestS3ApiObj(S3ApiTestCase):
                             method='DELETE', headers={
                                 'Authorization': 'AWS test:tester:hmac',
                                 'Date': self.get_date_header()})
-        status, headers, body = self.call_s3api(req)
+        fake_info = {
+            'status': 204,
+            'sysmeta': {
+                'versions-container': '\x00versions\x00bucket',
+            }
+        }
+        with patch('swift.common.middleware.s3api.s3request.'
+                   'get_container_info', return_value=fake_info):
+            status, headers, body = self.call_s3api(req)
         self.assertEqual(status.split()[0], '500')
         self.assertEqual([
             ('HEAD', '/v1/AUTH_test/bucket/object'
@@ -1280,7 +1379,15 @@ class TestS3ApiObj(S3ApiTestCase):
                             method='DELETE', headers={
                                 'Authorization': 'AWS test:tester:hmac',
                                 'Date': self.get_date_header()})
-        status, headers, body = self.call_s3api(req)
+        fake_info = {
+            'status': 204,
+            'sysmeta': {
+                'versions-container': '\x00versions\x00bucket',
+            }
+        }
+        with patch('swift.common.middleware.s3api.s3request.'
+                   'get_container_info', return_value=fake_info):
+            status, headers, body = self.call_s3api(req)
         self.assertEqual(status.split()[0], '500')
         self.assertEqual([
             ('HEAD', '/v1/AUTH_test/bucket/object'
@@ -1325,23 +1432,25 @@ class TestS3ApiObj(S3ApiTestCase):
             'X-Object-Version-Id': '1574701081.61553'}
         self.swift.register('DELETE', '/v1/AUTH_test/bucket/object',
                             swob.HTTPNoContent, resp_headers, None)
-        self.swift.register('HEAD', '/v1/AUTH_test/bucket',
-                            swob.HTTPNoContent, {
-                                'X-Container-Sysmeta-Versions-Enabled': True},
-                            None)
         self.swift.register('HEAD', '/v1/AUTH_test/bucket/object',
                             swob.HTTPNotFound, self.response_headers, None)
         req = Request.blank('/bucket/object?versionId=1574701081.61553',
                             method='DELETE', headers={
                                 'Authorization': 'AWS test:tester:hmac',
                                 'Date': self.get_date_header()})
-        status, headers, body = self.call_s3api(req)
+        fake_info = {
+            'status': 204,
+            'sysmeta': {
+                'versions-container': '\x00versions\x00bucket',
+            }
+        }
+        with patch('swift.common.middleware.s3api.s3request.'
+                   'get_container_info', return_value=fake_info):
+            status, headers, body = self.call_s3api(req)
         self.assertEqual(status.split()[0], '204')
         self.assertEqual([
             ('HEAD', '/v1/AUTH_test/bucket/object'
              '?symlink=get&version-id=1574701081.61553'),
-            ('HEAD', '/v1/AUTH_test'),
-            ('HEAD', '/v1/AUTH_test/bucket'),
             ('DELETE', '/v1/AUTH_test/bucket/object'
              '?symlink=get&version-id=1574701081.61553'),
         ], self.swift.calls)
diff -pruN 2.25.0-3/test/unit/common/middleware/s3api/test_s3_acl.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/s3api/test_s3_acl.py
--- 2.25.0-3/test/unit/common/middleware/s3api/test_s3_acl.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/s3api/test_s3_acl.py	2020-09-15 21:13:36.000000000 +0000
@@ -34,13 +34,16 @@ from test.unit.common.middleware.s3api i
 XMLNS_XSI = 'http://www.w3.org/2001/XMLSchema-instance'
 
 
-def s3acl(func=None, s3acl_only=False):
+def s3acl(func=None, s3acl_only=False, versioning_enabled=True):
     """
     NOTE: s3acl decorator needs an instance of s3api testing framework.
           (i.e. An instance for first argument is necessary)
     """
     if func is None:
-        return functools.partial(s3acl, s3acl_only=s3acl_only)
+        return functools.partial(
+            s3acl,
+            s3acl_only=s3acl_only,
+            versioning_enabled=versioning_enabled)
 
     @functools.wraps(func)
     def s3acl_decorator(*args, **kwargs):
@@ -57,9 +60,14 @@ def s3acl(func=None, s3acl_only=False):
                 #  @patch(xxx)
                 #  def test_xxxx(self)
 
+                fake_info = {'status': 204}
+                if versioning_enabled:
+                    fake_info['sysmeta'] = {
+                        'versions-container': '\x00versions\x00bucket',
+                    }
+
                 with patch('swift.common.middleware.s3api.s3request.'
-                           'get_container_info',
-                           return_value={'status': 204}):
+                           'get_container_info', return_value=fake_info):
                     func(*args, **kwargs)
             except AssertionError:
                 # Make traceback message to clarify the assertion
diff -pruN 2.25.0-3/test/unit/common/middleware/s3api/test_s3api.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/s3api/test_s3api.py
--- 2.25.0-3/test/unit/common/middleware/s3api/test_s3api.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/s3api/test_s3api.py	2020-09-15 21:13:36.000000000 +0000
@@ -500,8 +500,9 @@ class TestS3ApiMiddleware(S3ApiTestCase)
                         'S3Request.check_signature') as mock_cs:
             status, headers, body = self.call_s3api(req)
             self.assertIn('swift.backend_path', req.environ)
-            self.assertEqual('/v1/AUTH_test/bucket',
-                             req.environ['swift.backend_path'])
+            self.assertEqual(
+                '/v1/AUTH_test/bucket+segments/object/123456789abcdef/1',
+                req.environ['swift.backend_path'])
 
         _, _, headers = self.swift.calls_with_headers[-1]
         self.assertEqual(req.environ['s3api.auth_details'], {
@@ -530,8 +531,9 @@ class TestS3ApiMiddleware(S3ApiTestCase)
                         'S3Request.check_signature') as mock_cs:
             status, headers, body = self.call_s3api(req)
             self.assertIn('swift.backend_path', req.environ)
-            self.assertEqual('/v1/AUTH_test/bucket',
-                             req.environ['swift.backend_path'])
+            self.assertEqual(
+                '/v1/AUTH_test/bucket+segments/object/123456789abcdef/1',
+                req.environ['swift.backend_path'])
 
         _, _, headers = self.swift.calls_with_headers[-1]
         self.assertEqual(req.environ['s3api.auth_details'], {
@@ -705,7 +707,24 @@ class TestS3ApiMiddleware(S3ApiTestCase)
         self._test_unsupported_resource('cors')
 
     def test_tagging(self):
-        self._test_unsupported_resource('tagging')
+        req = Request.blank('/bucket?tagging',
+                            environ={'REQUEST_METHOD': 'GET'},
+                            headers={'Authorization': 'AWS test:tester:hmac',
+                                     'Date': self.get_date_header()})
+        status, headers, body = self.call_s3api(req)
+        self.assertEqual(status.split()[0], '200')
+        req = Request.blank('/bucket?tagging',
+                            environ={'REQUEST_METHOD': 'PUT'},
+                            headers={'Authorization': 'AWS test:tester:hmac',
+                                     'Date': self.get_date_header()})
+        status, headers, body = self.call_s3api(req)
+        self.assertEqual(self._get_error_code(body), 'NotImplemented')
+        req = Request.blank('/bucket?tagging',
+                            environ={'REQUEST_METHOD': 'DELETE'},
+                            headers={'Authorization': 'AWS test:tester:hmac',
+                                     'Date': self.get_date_header()})
+        status, headers, body = self.call_s3api(req)
+        self.assertEqual(self._get_error_code(body), 'NotImplemented')
 
     def test_restore(self):
         self._test_unsupported_resource('restore')
diff -pruN 2.25.0-3/test/unit/common/middleware/s3api/test_s3request.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/s3api/test_s3request.py
--- 2.25.0-3/test/unit/common/middleware/s3api/test_s3request.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/s3api/test_s3request.py	2020-09-15 21:13:36.000000000 +0000
@@ -312,7 +312,7 @@ class TestRequest(S3ApiTestCase):
             '[{"Grantee":"owner","Permission":"FULL_CONTROL"}]}'
         self.swift.register('HEAD', '/v1/AUTH_test/bucket', HTTPNoContent,
                             {'x-container-read': 'foo',
-                             'X-container-object-count': 5,
+                             'X-container-object-count': '5',
                              'x-container-sysmeta-versions-location':
                                 'bucket2',
                              'x-container-sysmeta-s3api-acl': s3api_acl,
@@ -326,7 +326,7 @@ class TestRequest(S3ApiTestCase):
         self.assertTrue('status' in info)  # sanity
         self.assertEqual(204, info['status'])  # sanity
         self.assertEqual('foo', info['read_acl'])  # sanity
-        self.assertEqual('5', info['object_count'])  # sanity
+        self.assertEqual(5, info['object_count'])  # sanity
         self.assertEqual(
             'bucket2', info['sysmeta']['versions-location'])  # sanity
         self.assertEqual(s3api_acl, info['sysmeta']['s3api-acl'])  # sanity
diff -pruN 2.25.0-3/test/unit/common/middleware/s3api/test_versioning.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/s3api/test_versioning.py
--- 2.25.0-3/test/unit/common/middleware/s3api/test_versioning.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/s3api/test_versioning.py	2020-09-15 21:13:36.000000000 +0000
@@ -42,7 +42,7 @@ class TestS3ApiVersioning(S3ApiTestCase)
         status, headers, body = self._versioning_GET(path)
         self.assertEqual(status.split()[0], '200')
         elem = fromstring(body, 'VersioningConfiguration')
-        self.assertEqual(elem.getchildren(), [])
+        self.assertEqual(list(elem), [])
 
     def _versioning_GET_enabled(self, path):
         self.swift.register('HEAD', '/v1/AUTH_test/bucket', HTTPNoContent, {
diff -pruN 2.25.0-3/test/unit/common/middleware/test_copy.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/test_copy.py
--- 2.25.0-3/test/unit/common/middleware/test_copy.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/test_copy.py	2020-09-15 21:13:36.000000000 +0000
@@ -24,7 +24,7 @@ from swift.common.middleware import copy
 from swift.common.storage_policy import POLICIES
 from swift.common.swob import Request, HTTPException
 from swift.common.utils import closing_if_possible
-from test.unit import patch_policies, debug_logger, FakeMemcache, FakeRing
+from test.unit import patch_policies, debug_logger, FakeRing
 from test.unit.common.middleware.helpers import FakeSwift
 from test.unit.proxy.controllers.test_obj import set_http_connect, \
     PatchedObjControllerApp
@@ -1316,7 +1316,7 @@ class TestServerSideCopyMiddlewareWithEC
         self.logger = debug_logger('proxy-server')
         self.logger.thread_locals = ('txn1', '127.0.0.2')
         self.app = PatchedObjControllerApp(
-            None, FakeMemcache(), account_ring=FakeRing(),
+            None, account_ring=FakeRing(),
             container_ring=FakeRing(), logger=self.logger)
         self.ssc = copy.filter_factory({})(self.app)
         self.ssc.logger = self.app.logger
diff -pruN 2.25.0-3/test/unit/common/middleware/test_proxy_logging.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/test_proxy_logging.py
--- 2.25.0-3/test/unit/common/middleware/test_proxy_logging.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/test_proxy_logging.py	2020-09-15 21:13:36.000000000 +0000
@@ -401,9 +401,8 @@ class TestProxyLogging(unittest.TestCase
                         mock.MagicMock(
                             side_effect=[10000000.0, 10000000.5, 10000001.0])):
             resp = app(req.environ, start_response)
+            # exhaust generator
             resp_body = b''.join(resp)
-        # exhaust generator
-        [x for x in resp]
         log_parts = self._log_parts(app)
         self.assertEqual(log_parts[0], 'template')
         self.assertEqual(log_parts[7], 'HTTP/1.0')
@@ -417,6 +416,38 @@ class TestProxyLogging(unittest.TestCase
         self.assertEqual(log_parts[15], '0.5')
         self.assertEqual(resp_body, b'FAKE APP')
 
+    def test_log_msg_template_s3api(self):
+        # Access logs configuration should override the default one
+        app = proxy_logging.ProxyLoggingMiddleware(FakeApp(), {
+            'log_msg_template': (
+                '{protocol} {path} {method} '
+                '{account} {container} {object}')})
+        app.access_logger = FakeLogger()
+        req = Request.blank('/bucket/path/to/key', environ={
+            'REQUEST_METHOD': 'GET',
+            # This would actually get set in the app, but w/e
+            'swift.backend_path': '/v1/AUTH_test/bucket/path/to/key'})
+        with mock.patch("time.time", side_effect=[
+                18.0, 18.5, 20.71828182846]):
+            resp = app(req.environ, start_response)
+            # exhaust generator
+            resp_body = b''.join(resp)
+        log_parts = self._log_parts(app)
+        self.assertEqual(log_parts, [
+            'HTTP/1.0',
+            '/bucket/path/to/key',
+            'GET',
+            'AUTH_test',
+            'bucket',
+            'path/to/key',
+        ])
+        self.assertEqual(resp_body, b'FAKE APP')
+        self.assertTiming('object.policy.0.GET.200.timing',
+                          app, exp_timing=2.71828182846 * 1000)
+        self.assertUpdateStats([('object.GET.200.xfer', 8),
+                                ('object.policy.0.GET.200.xfer', 8)],
+                               app)
+
     def test_invalid_log_config(self):
         with self.assertRaises(ValueError):
             proxy_logging.ProxyLoggingMiddleware(FakeApp(), {
diff -pruN 2.25.0-3/test/unit/common/middleware/test_ratelimit.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/test_ratelimit.py
--- 2.25.0-3/test/unit/common/middleware/test_ratelimit.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/test_ratelimit.py	2020-09-15 21:13:36.000000000 +0000
@@ -72,12 +72,20 @@ class FakeMemcache(object):
 
 
 class FakeApp(object):
+    skip_handled_check = False
 
     def __call__(self, env, start_response):
+        assert self.skip_handled_check or env.get('swift.ratelimit.handled')
         start_response('200 OK', [])
         return [b'Some Content']
 
 
+class FakeReq(object):
+    def __init__(self, method, env=None):
+        self.method = method
+        self.environ = env or {}
+
+
 def start_response(*args):
     pass
 
@@ -160,36 +168,29 @@ class TestRateLimit(unittest.TestCase):
             {'object_count': '5'}
         the_app = ratelimit.filter_factory(conf_dict)(FakeApp())
         the_app.memcache_client = fake_memcache
-        req = lambda: None
-        req.environ = {'swift.cache': fake_memcache, 'PATH_INFO': '/v1/a/c/o'}
+        environ = {'swift.cache': fake_memcache, 'PATH_INFO': '/v1/a/c/o'}
         with mock.patch('swift.common.middleware.ratelimit.get_account_info',
                         lambda *args, **kwargs: {}):
-            req.method = 'DELETE'
             self.assertEqual(len(the_app.get_ratelimitable_key_tuples(
-                req, 'a', None, None)), 0)
-            req.method = 'PUT'
+                FakeReq('DELETE', environ), 'a', None, None)), 0)
             self.assertEqual(len(the_app.get_ratelimitable_key_tuples(
-                req, 'a', 'c', None)), 1)
-            req.method = 'DELETE'
+                FakeReq('PUT', environ), 'a', 'c', None)), 1)
             self.assertEqual(len(the_app.get_ratelimitable_key_tuples(
-                req, 'a', 'c', None)), 1)
-            req.method = 'GET'
+                FakeReq('DELETE', environ), 'a', 'c', None)), 1)
             self.assertEqual(len(the_app.get_ratelimitable_key_tuples(
-                req, 'a', 'c', 'o')), 0)
-            req.method = 'PUT'
+                FakeReq('GET', environ), 'a', 'c', 'o')), 0)
             self.assertEqual(len(the_app.get_ratelimitable_key_tuples(
-                req, 'a', 'c', 'o')), 1)
+                FakeReq('PUT', environ), 'a', 'c', 'o')), 1)
 
-        req.method = 'PUT'
         self.assertEqual(len(the_app.get_ratelimitable_key_tuples(
-            req, 'a', 'c', None, global_ratelimit=10)), 2)
+            FakeReq('PUT', environ), 'a', 'c', None, global_ratelimit=10)), 2)
         self.assertEqual(the_app.get_ratelimitable_key_tuples(
-            req, 'a', 'c', None, global_ratelimit=10)[1],
+            FakeReq('PUT', environ), 'a', 'c', None, global_ratelimit=10)[1],
             ('ratelimit/global-write/a', 10))
 
-        req.method = 'PUT'
         self.assertEqual(len(the_app.get_ratelimitable_key_tuples(
-            req, 'a', 'c', None, global_ratelimit='notafloat')), 1)
+            FakeReq('PUT', environ), 'a', 'c', None,
+            global_ratelimit='notafloat')), 1)
 
     def test_memcached_container_info_dict(self):
         mdict = headers_to_container_info({'x-container-object-count': '45'})
@@ -204,9 +205,8 @@ class TestRateLimit(unittest.TestCase):
             {'container_size': 5}
         the_app = ratelimit.filter_factory(conf_dict)(FakeApp())
         the_app.memcache_client = fake_memcache
-        req = lambda: None
-        req.method = 'PUT'
-        req.environ = {'PATH_INFO': '/v1/a/c/o', 'swift.cache': fake_memcache}
+        req = FakeReq('PUT', {
+            'PATH_INFO': '/v1/a/c/o', 'swift.cache': fake_memcache})
         with mock.patch('swift.common.middleware.ratelimit.get_account_info',
                         lambda *args, **kwargs: {}):
             tuples = the_app.get_ratelimitable_key_tuples(req, 'a', 'c', 'o')
@@ -227,8 +227,8 @@ class TestRateLimit(unittest.TestCase):
                     req = Request.blank('/v1/a%s/c' % meth)
                     req.method = meth
                     req.environ['swift.cache'] = FakeMemcache()
-                    make_app_call = lambda: self.test_ratelimit(req.environ,
-                                                                start_response)
+                    make_app_call = lambda: self.test_ratelimit(
+                        req.environ.copy(), start_response)
                     begin = time.time()
                     self._run(make_app_call, num_calls, current_rate,
                               check_time=bool(exp_time))
@@ -244,7 +244,7 @@ class TestRateLimit(unittest.TestCase):
         req.method = 'PUT'
         req.environ['swift.cache'] = FakeMemcache()
         req.environ['swift.cache'].init_incr_return_neg = True
-        make_app_call = lambda: self.test_ratelimit(req.environ,
+        make_app_call = lambda: self.test_ratelimit(req.environ.copy(),
                                                     start_response)
         begin = time.time()
         with mock.patch('swift.common.middleware.ratelimit.get_account_info',
@@ -260,15 +260,15 @@ class TestRateLimit(unittest.TestCase):
                      'account_whitelist': 'a',
                      'account_blacklist': 'b'}
         self.test_ratelimit = ratelimit.filter_factory(conf_dict)(FakeApp())
-        req = Request.blank('/')
         with mock.patch.object(self.test_ratelimit,
                                'memcache_client', FakeMemcache()):
             self.assertEqual(
-                self.test_ratelimit.handle_ratelimit(req, 'a', 'c', 'o'),
+                self.test_ratelimit.handle_ratelimit(
+                    Request.blank('/'), 'a', 'c', 'o'),
                 None)
             self.assertEqual(
                 self.test_ratelimit.handle_ratelimit(
-                    req, 'b', 'c', 'o').status_int,
+                    Request.blank('/'), 'b', 'c', 'o').status_int,
                 497)
 
     def test_ratelimit_whitelist_sysmeta(self):
@@ -331,7 +331,7 @@ class TestRateLimit(unittest.TestCase):
                 self.parent = parent
 
             def run(self):
-                self.result = self.parent.test_ratelimit(req.environ,
+                self.result = self.parent.test_ratelimit(req.environ.copy(),
                                                          start_response)
 
         def get_fake_ratelimit(*args, **kwargs):
@@ -370,18 +370,17 @@ class TestRateLimit(unittest.TestCase):
         # simulates 4 requests coming in at same time, then sleeping
         with mock.patch('swift.common.middleware.ratelimit.get_account_info',
                         lambda *args, **kwargs: {}):
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             self.assertEqual(r[0], b'Slow down')
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             self.assertEqual(r[0], b'Slow down')
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
-            print(repr(r))
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             self.assertEqual(r[0], b'Some Content')
 
     def test_ratelimit_max_rate_double_container(self):
@@ -404,17 +403,17 @@ class TestRateLimit(unittest.TestCase):
         # simulates 4 requests coming in at same time, then sleeping
         with mock.patch('swift.common.middleware.ratelimit.get_account_info',
                         lambda *args, **kwargs: {}):
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             self.assertEqual(r[0], b'Slow down')
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             self.assertEqual(r[0], b'Slow down')
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             self.assertEqual(r[0], b'Some Content')
 
     def test_ratelimit_max_rate_double_container_listing(self):
@@ -437,17 +436,17 @@ class TestRateLimit(unittest.TestCase):
                         lambda *args, **kwargs: {}):
             time_override = [0, 0, 0, 0, None]
             # simulates 4 requests coming in at same time, then sleeping
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             self.assertEqual(r[0], b'Slow down')
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             self.assertEqual(r[0], b'Slow down')
             mock_sleep(.1)
-            r = self.test_ratelimit(req.environ, start_response)
+            r = self.test_ratelimit(req.environ.copy(), start_response)
             self.assertEqual(r[0], b'Some Content')
             mc = self.test_ratelimit.memcache_client
             try:
@@ -466,9 +465,6 @@ class TestRateLimit(unittest.TestCase):
 
         the_app = ratelimit.filter_factory(conf_dict)(FakeApp())
         the_app.memcache_client = fake_memcache
-        req = lambda: None
-        req.method = 'PUT'
-        req.environ = {}
 
         class rate_caller(threading.Thread):
 
@@ -478,8 +474,8 @@ class TestRateLimit(unittest.TestCase):
 
             def run(self):
                 for j in range(num_calls):
-                    self.result = the_app.handle_ratelimit(req, self.myname,
-                                                           'c', None)
+                    self.result = the_app.handle_ratelimit(
+                        FakeReq('PUT'), self.myname, 'c', None)
 
         with mock.patch('swift.common.middleware.ratelimit.get_account_info',
                         lambda *args, **kwargs: {}):
@@ -541,12 +537,32 @@ class TestRateLimit(unittest.TestCase):
         current_rate = 13
         num_calls = 5
         conf_dict = {'account_ratelimit': current_rate}
-        self.test_ratelimit = ratelimit.filter_factory(conf_dict)(FakeApp())
+        fake_app = FakeApp()
+        fake_app.skip_handled_check = True
+        self.test_ratelimit = ratelimit.filter_factory(conf_dict)(fake_app)
         req = Request.blank('/v1/a')
         req.environ['swift.cache'] = None
         make_app_call = lambda: self.test_ratelimit(req.environ,
                                                     start_response)
         begin = time.time()
+        self._run(make_app_call, num_calls, current_rate, check_time=False)
+        time_took = time.time() - begin
+        self.assertEqual(round(time_took, 1), 0)  # no memcache, no limiting
+
+    def test_already_handled(self):
+        current_rate = 13
+        num_calls = 5
+        conf_dict = {'container_listing_ratelimit_0': current_rate}
+        self.test_ratelimit = ratelimit.filter_factory(conf_dict)(FakeApp())
+        fake_cache = FakeMemcache()
+        fake_cache.set(
+            get_cache_key('a', 'c'),
+            {'object_count': 1})
+        req = Request.blank('/v1/a/c', environ={'swift.cache': fake_cache})
+        req.environ['swift.ratelimit.handled'] = True
+        make_app_call = lambda: self.test_ratelimit(req.environ,
+                                                    start_response)
+        begin = time.time()
         self._run(make_app_call, num_calls, current_rate, check_time=False)
         time_took = time.time() - begin
         self.assertEqual(round(time_took, 1), 0)  # no memcache, no limiting
diff -pruN 2.25.0-3/test/unit/common/middleware/test_symlink.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/test_symlink.py
--- 2.25.0-3/test/unit/common/middleware/test_symlink.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/middleware/test_symlink.py	2020-09-15 21:13:36.000000000 +0000
@@ -24,6 +24,7 @@ from swift.common import swob
 from swift.common.middleware import symlink, copy, versioned_writes, \
     listing_formats
 from swift.common.swob import Request
+from swift.common.request_helpers import get_reserved_name
 from swift.common.utils import MD5_OF_EMPTY_STRING, get_swift_info
 from test.unit.common.middleware.helpers import FakeSwift
 from test.unit.common.middleware.test_versioned_writes import FakeCache
@@ -618,6 +619,55 @@ class TestSymlinkMiddleware(TestSymlinkM
         self.assertEqual(req_headers, calls[1].headers)
         self.assertFalse(calls[2:])
 
+    def test_get_symlink_to_reserved_object(self):
+        cont = get_reserved_name('versioned')
+        obj = get_reserved_name('symlink', '9999998765.99999')
+        symlink_target = "%s/%s" % (cont, obj)
+        version_path = '/v1/a/%s' % symlink_target
+        self.app.register('GET', '/v1/a/versioned/symlink', swob.HTTPOk, {
+            symlink.TGT_OBJ_SYSMETA_SYMLINK_HDR: symlink_target,
+            symlink.ALLOW_RESERVED_NAMES: 'true',
+            'x-object-sysmeta-symlink-target-etag': MD5_OF_EMPTY_STRING,
+            'x-object-sysmeta-symlink-target-bytes': '0',
+        })
+        self.app.register('GET', version_path, swob.HTTPOk, {})
+        req = Request.blank('/v1/a/versioned/symlink', headers={
+            'Range': 'foo', 'If-Match': 'bar'})
+        status, headers, body = self.call_sym(req)
+        self.assertEqual(status, '200 OK')
+        self.assertIn(('Content-Location', version_path), headers)
+        self.assertEqual(len(self.authorized), 1)
+        self.assertNotIn('X-Backend-Allow-Reserved-Names',
+                         self.app.calls_with_headers[0])
+        call_headers = self.app.calls_with_headers[1].headers
+        self.assertEqual('true', call_headers[
+            'X-Backend-Allow-Reserved-Names'])
+        self.assertEqual('foo', call_headers['Range'])
+        self.assertEqual('bar', call_headers['If-Match'])
+
+    def test_get_symlink_to_reserved_symlink(self):
+        cont = get_reserved_name('versioned')
+        obj = get_reserved_name('symlink', '9999998765.99999')
+        symlink_target = "%s/%s" % (cont, obj)
+        version_path = '/v1/a/%s' % symlink_target
+        self.app.register('GET', '/v1/a/versioned/symlink', swob.HTTPOk, {
+            symlink.TGT_OBJ_SYSMETA_SYMLINK_HDR: symlink_target,
+            symlink.ALLOW_RESERVED_NAMES: 'true',
+            'x-object-sysmeta-symlink-target-etag': MD5_OF_EMPTY_STRING,
+            'x-object-sysmeta-symlink-target-bytes': '0',
+        })
+        self.app.register('GET', version_path, swob.HTTPOk, {
+            symlink.TGT_OBJ_SYSMETA_SYMLINK_HDR: 'unversioned/obj',
+            'ETag': MD5_OF_EMPTY_STRING,
+        })
+        self.app.register('GET', '/v1/a/unversioned/obj', swob.HTTPOk, {
+        })
+        req = Request.blank('/v1/a/versioned/symlink')
+        status, headers, body = self.call_sym(req)
+        self.assertEqual(status, '200 OK')
+        self.assertIn(('Content-Location', '/v1/a/unversioned/obj'), headers)
+        self.assertEqual(len(self.authorized), 2)
+
     def test_symlink_too_deep(self):
         self.app.register('GET', '/v1/a/c/symlink', swob.HTTPOk,
                           {'X-Object-Sysmeta-Symlink-Target': 'c/sym1'})
diff -pruN 2.25.0-3/test/unit/common/ring/test_builder.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/ring/test_builder.py
--- 2.25.0-3/test/unit/common/ring/test_builder.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/ring/test_builder.py	2020-09-15 21:13:36.000000000 +0000
@@ -2113,7 +2113,7 @@ class TestRingBuilder(unittest.TestCase)
         orig_rb = ring.RingBuilder(8, 3, 1)
         copy_rb = ring.RingBuilder(8, 3, 1)
         copy_rb.copy_from(orig_rb)
-        for rb in(orig_rb, copy_rb):
+        for rb in (orig_rb, copy_rb):
             with self.assertRaises(AttributeError) as cm:
                 rb.id
             self.assertIn('id attribute has not been initialised',
diff -pruN 2.25.0-3/test/unit/common/test_base_storage_server.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/test_base_storage_server.py
--- 2.25.0-3/test/unit/common/test_base_storage_server.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/test_base_storage_server.py	2020-09-15 21:13:36.000000000 +0000
@@ -20,7 +20,7 @@ from swift.common.base_storage_server im
 from tempfile import mkdtemp
 from swift import __version__ as swift_version
 from swift.common.swob import Request
-from swift.common.utils import get_logger, public
+from swift.common.utils import get_logger, public, replication
 from shutil import rmtree
 
 
@@ -40,6 +40,18 @@ class FakeANOTHER(FakeOPTIONS):
         """this is to test adding to allowed_methods"""
         pass
 
+    @replication
+    @public
+    def REPLICATE(self):
+        """this is to test replication_server"""
+        pass
+
+    @public
+    @replication
+    def REPLICATE2(self):
+        """this is to test replication_server"""
+        pass
+
 
 class TestBaseStorageServer(unittest.TestCase):
     """Test swift.common.base_storage_server"""
@@ -73,18 +85,20 @@ class TestBaseStorageServer(unittest.Tes
         # test that a subclass can add allowed methods
         allowed_methods_test = FakeANOTHER(conf).allowed_methods
         allowed_methods_test.sort()
-        self.assertEqual(allowed_methods_test, ['ANOTHER', 'OPTIONS'])
+        self.assertEqual(allowed_methods_test, [
+            'ANOTHER', 'OPTIONS'])
 
         conf = {'devices': self.testdir, 'mount_check': 'false',
                 'replication_server': 'true'}
 
         # test what's available in the base class
         allowed_methods_test = FakeOPTIONS(conf).allowed_methods
-        self.assertEqual(allowed_methods_test, [])
+        self.assertEqual(allowed_methods_test, ['OPTIONS'])
 
         # test that a subclass can add allowed methods
         allowed_methods_test = FakeANOTHER(conf).allowed_methods
-        self.assertEqual(allowed_methods_test, [])
+        self.assertEqual(allowed_methods_test, [
+            'ANOTHER', 'OPTIONS', 'REPLICATE', 'REPLICATE2'])
 
         conf = {'devices': self.testdir, 'mount_check': 'false'}
 
@@ -95,7 +109,8 @@ class TestBaseStorageServer(unittest.Tes
         # test that a subclass can add allowed methods
         allowed_methods_test = FakeANOTHER(conf).allowed_methods
         allowed_methods_test.sort()
-        self.assertEqual(allowed_methods_test, ['ANOTHER', 'OPTIONS'])
+        self.assertEqual(allowed_methods_test, [
+            'ANOTHER', 'OPTIONS', 'REPLICATE', 'REPLICATE2'])
 
     def test_OPTIONS_error(self):
         msg = 'Storage nodes have not implemented the Server type.'
diff -pruN 2.25.0-3/test/unit/common/test_db.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/test_db.py
--- 2.25.0-3/test/unit/common/test_db.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/test_db.py	2020-09-15 21:13:36.000000000 +0000
@@ -1154,7 +1154,7 @@ class TestDatabaseBroker(unittest.TestCa
         return broker
 
     # only testing _reclaim_metadata here
-    @patch.object(DatabaseBroker, '_reclaim')
+    @patch.object(DatabaseBroker, '_reclaim', return_value='')
     def test_metadata(self, mock_reclaim):
         # Initializes a good broker for us
         broker = self.get_replication_info_tester(metadata=True)
@@ -1289,7 +1289,7 @@ class TestDatabaseBroker(unittest.TestCa
         for c in range(MAX_META_COUNT):
             key = 'X-Account-Meta-F{0}'.format(c)
             metadata[key] = ('B', normalize_timestamp(1))
-        key = 'X-Account-Meta-Foo'.format(c)
+        key = 'X-Account-Meta-Foo'
         metadata[key] = ('', normalize_timestamp(1))
         self.assertIsNone(DatabaseBroker.validate_metadata(metadata))
 
diff -pruN 2.25.0-3/test/unit/common/test_db_replicator.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/test_db_replicator.py
--- 2.25.0-3/test/unit/common/test_db_replicator.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/test_db_replicator.py	2020-09-15 21:13:36.000000000 +0000
@@ -324,7 +324,11 @@ class TestDBReplicator(unittest.TestCase
         # later config should be extended to assert more config options
         replicator = TestReplicator({'node_timeout': '3.5'})
         self.assertEqual(replicator.node_timeout, 3.5)
-        self.assertEqual(replicator.databases_per_second, 50)
+        self.assertEqual(replicator.databases_per_second, 50.0)
+
+        replicator = TestReplicator({'databases_per_second': '0.1'})
+        self.assertEqual(replicator.node_timeout, 10)
+        self.assertEqual(replicator.databases_per_second, 0.1)
 
     def test_repl_connection(self):
         node = {'replication_ip': '127.0.0.1', 'replication_port': 80,
diff -pruN 2.25.0-3/test/unit/common/test_direct_client.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/test_direct_client.py
--- 2.25.0-3/test/unit/common/test_direct_client.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/test_direct_client.py	2020-09-15 21:13:36.000000000 +0000
@@ -316,6 +316,31 @@ class TestDirectClient(unittest.TestCase
             self.assertIn('X-Timestamp', headers)
             self.assertIn('User-Agent', headers)
 
+    def test_direct_delete_account_replication_net(self):
+        part = '0'
+        account = 'a'
+
+        mock_path = 'swift.common.bufferedhttp.http_connect_raw'
+        with mock.patch(mock_path) as fake_connect:
+            fake_connect.return_value.getresponse.return_value.status = 200
+            direct_client.direct_delete_account(
+                self.node, part, account,
+                headers={'X-Backend-Use-Replication-Network': 't'})
+            args, kwargs = fake_connect.call_args
+            ip = args[0]
+            self.assertEqual(self.node['replication_ip'], ip)
+            self.assertNotEqual(self.node['ip'], ip)
+            port = args[1]
+            self.assertEqual(self.node['replication_port'], port)
+            self.assertNotEqual(self.node['port'], port)
+            method = args[2]
+            self.assertEqual('DELETE', method)
+            path = args[3]
+            self.assertEqual('/sda/0/a', path)
+            headers = args[4]
+            self.assertIn('X-Timestamp', headers)
+            self.assertIn('User-Agent', headers)
+
     def test_direct_delete_account_failure(self):
         part = '0'
         account = 'a'
@@ -346,6 +371,24 @@ class TestDirectClient(unittest.TestCase
                          self.user_agent)
         self.assertEqual(headers, resp)
 
+    def test_direct_head_container_replication_net(self):
+        headers = HeaderKeyDict(key='value')
+
+        with mocked_http_conn(200, headers) as conn:
+            resp = direct_client.direct_head_container(
+                self.node, self.part, self.account, self.container,
+                headers={'X-Backend-Use-Replication-Network': 'on'})
+            self.assertEqual(conn.host, self.node['replication_ip'])
+            self.assertEqual(conn.port, self.node['replication_port'])
+            self.assertNotEqual(conn.host, self.node['ip'])
+            self.assertNotEqual(conn.port, self.node['port'])
+            self.assertEqual(conn.method, 'HEAD')
+            self.assertEqual(conn.path, self.container_path)
+
+        self.assertEqual(conn.req_headers['user-agent'],
+                         self.user_agent)
+        self.assertEqual(headers, resp)
+
     def test_direct_head_container_error(self):
         headers = HeaderKeyDict(key='value')
 
@@ -441,6 +484,18 @@ class TestDirectClient(unittest.TestCase
             self.assertEqual(conn.method, 'DELETE')
             self.assertEqual(conn.path, self.container_path)
 
+    def test_direct_delete_container_replication_net(self):
+        with mocked_http_conn(200) as conn:
+            direct_client.direct_delete_container(
+                self.node, self.part, self.account, self.container,
+                headers={'X-Backend-Use-Replication-Network': '1'})
+            self.assertEqual(conn.host, self.node['replication_ip'])
+            self.assertEqual(conn.port, self.node['replication_port'])
+            self.assertNotEqual(conn.host, self.node['ip'])
+            self.assertNotEqual(conn.port, self.node['port'])
+            self.assertEqual(conn.method, 'DELETE')
+            self.assertEqual(conn.path, self.container_path)
+
     def test_direct_delete_container_with_timestamp(self):
         # ensure timestamp is different from any that might be auto-generated
         timestamp = Timestamp(time.time() - 100)
diff -pruN 2.25.0-3/test/unit/common/test_internal_client.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/test_internal_client.py
--- 2.25.0-3/test/unit/common/test_internal_client.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/test_internal_client.py	2020-09-15 21:13:36.000000000 +0000
@@ -25,7 +25,7 @@ from textwrap import dedent
 import six
 from six.moves import range, zip_longest
 from six.moves.urllib.parse import quote, parse_qsl
-from swift.common import exceptions, internal_client, swob
+from swift.common import exceptions, internal_client, request_helpers, swob
 from swift.common.header_key_dict import HeaderKeyDict
 from swift.common.storage_policy import StoragePolicy
 from swift.common.middleware.proxy_logging import ProxyLoggingMiddleware
@@ -303,7 +303,7 @@ class TestInternalClient(unittest.TestCa
         with mock.patch.object(internal_client, 'loadapp', app.load), \
                 self.assertRaises(ValueError):
             # First try with a bad arg
-            client = internal_client.InternalClient(
+            internal_client.InternalClient(
                 conf_path, user_agent, request_tries=0)
         self.assertEqual(0, app.load_called)
 
@@ -315,6 +315,18 @@ class TestInternalClient(unittest.TestCa
         self.assertEqual(app, client.app)
         self.assertEqual(user_agent, client.user_agent)
         self.assertEqual(request_tries, client.request_tries)
+        self.assertFalse(client.use_replication_network)
+
+        with mock.patch.object(internal_client, 'loadapp', app.load):
+            client = internal_client.InternalClient(
+                conf_path, user_agent, request_tries,
+                use_replication_network=True)
+
+        self.assertEqual(2, app.load_called)
+        self.assertEqual(app, client.app)
+        self.assertEqual(user_agent, client.user_agent)
+        self.assertEqual(request_tries, client.request_tries)
+        self.assertTrue(client.use_replication_network)
 
     def test_make_request_sets_user_agent(self):
         class InternalClient(internal_client.InternalClient):
@@ -323,8 +335,11 @@ class TestInternalClient(unittest.TestCa
                 self.app = self.fake_app
                 self.user_agent = 'some_agent'
                 self.request_tries = 1
+                self.use_replication_network = False
 
             def fake_app(self, env, start_response):
+                self.test.assertNotIn(
+                    'HTTP_X_BACKEND_USE_REPLICATION_NETWORK', env)
                 self.test.assertEqual(self.user_agent, env['HTTP_USER_AGENT'])
                 start_response('200 Ok', [('Content-Length', '0')])
                 return []
@@ -332,6 +347,47 @@ class TestInternalClient(unittest.TestCa
         client = InternalClient(self)
         client.make_request('GET', '/', {}, (200,))
 
+    def test_make_request_defaults_replication_network_header(self):
+        class InternalClient(internal_client.InternalClient):
+            def __init__(self, test):
+                self.test = test
+                self.app = self.fake_app
+                self.user_agent = 'some_agent'
+                self.request_tries = 1
+                self.use_replication_network = False
+                self.expected_header_value = None
+
+            def fake_app(self, env, start_response):
+                if self.expected_header_value is None:
+                    self.test.assertNotIn(
+                        'HTTP_X_BACKEND_USE_REPLICATION_NETWORK', env)
+                else:
+                    hdr_val = env['HTTP_X_BACKEND_USE_REPLICATION_NETWORK']
+                    self.test.assertEqual(self.expected_header_value, hdr_val)
+                start_response('200 Ok', [('Content-Length', '0')])
+                return []
+
+        client = InternalClient(self)
+        client.make_request('GET', '/', {}, (200,))
+        # Caller can still override
+        client.expected_header_value = 'false'
+        client.make_request('GET', '/', {
+            request_helpers.USE_REPLICATION_NETWORK_HEADER: 'false'}, (200,))
+        client.expected_header_value = 'true'
+        client.make_request('GET', '/', {
+            request_helpers.USE_REPLICATION_NETWORK_HEADER: 'true'}, (200,))
+
+        # Switch default behavior
+        client.use_replication_network = True
+
+        client.make_request('GET', '/', {}, (200,))
+        client.expected_header_value = 'false'
+        client.make_request('GET', '/', {
+            request_helpers.USE_REPLICATION_NETWORK_HEADER: 'false'}, (200,))
+        client.expected_header_value = 'on'
+        client.make_request('GET', '/', {
+            request_helpers.USE_REPLICATION_NETWORK_HEADER: 'on'}, (200,))
+
     def test_make_request_sets_query_string(self):
         captured_envs = []
 
@@ -341,6 +397,7 @@ class TestInternalClient(unittest.TestCa
                 self.app = self.fake_app
                 self.user_agent = 'some_agent'
                 self.request_tries = 1
+                self.use_replication_network = False
 
             def fake_app(self, env, start_response):
                 captured_envs.append(env)
@@ -362,6 +419,7 @@ class TestInternalClient(unittest.TestCa
                 self.app = self.fake_app
                 self.user_agent = 'some_agent'
                 self.request_tries = 4
+                self.use_replication_network = False
                 self.tries = 0
                 self.sleep_called = 0
 
@@ -441,6 +499,7 @@ class TestInternalClient(unittest.TestCa
                 self.app = self.fake_app
                 self.user_agent = 'some_agent'
                 self.request_tries = 3
+                self.use_replication_network = False
                 self.env = None
 
             def fake_app(self, env, start_response):
@@ -468,6 +527,7 @@ class TestInternalClient(unittest.TestCa
                     self.fake_app, {}, self.logger)
                 self.user_agent = 'some_agent'
                 self.request_tries = 3
+                self.use_replication_network = False
 
             def fake_app(self, env, start_response):
                 body = b'fake error response'
@@ -499,6 +559,7 @@ class TestInternalClient(unittest.TestCa
                 self.user_agent = 'some_agent'
                 self.resp_status = resp_status
                 self.request_tries = 3
+                self.use_replication_network = False
                 self.closed_paths = []
                 self.fully_read_paths = []
 
@@ -557,6 +618,7 @@ class TestInternalClient(unittest.TestCa
                 self.app = self.fake_app
                 self.user_agent = 'some_agent'
                 self.request_tries = 3
+                self.use_replication_network = False
 
             def fake_app(self, env, start_response):
                 start_response('200 Ok', [('Content-Length', '0')])
@@ -607,6 +669,7 @@ class TestInternalClient(unittest.TestCa
                 self.app = self.fake_app
                 self.user_agent = 'some_agent'
                 self.request_tries = 3
+                self.use_replication_network = False
                 self.status = status
                 self.call_count = 0
 
@@ -698,6 +761,7 @@ class TestInternalClient(unittest.TestCa
             def __init__(self):
                 self.user_agent = 'test'
                 self.request_tries = 1
+                self.use_replication_network = False
                 self.app = self.fake_app
 
             def fake_app(self, environ, start_response):
@@ -1217,6 +1281,7 @@ class TestInternalClient(unittest.TestCa
                 self.app = self.fake_app
                 self.user_agent = 'some_agent'
                 self.request_tries = 3
+                self.use_replication_network = False
 
             def fake_app(self, env, start_response):
                 self.req_env = env
@@ -1261,6 +1326,7 @@ class TestInternalClient(unittest.TestCa
                 self.app = self.fake_app
                 self.user_agent = 'some_agent'
                 self.request_tries = 3
+                self.use_replication_network = False
 
             def fake_app(self, env, start_response):
                 start_response('200 Ok', [('Content-Length', '0')])
@@ -1280,6 +1346,7 @@ class TestInternalClient(unittest.TestCa
                 self.app = self.fake_app
                 self.user_agent = 'some_agent'
                 self.request_tries = 3
+                self.use_replication_network = False
 
             def fake_app(self, env, start_response):
                 start_response('200 Ok', [('Content-Length', '0')])
@@ -1300,6 +1367,7 @@ class TestInternalClient(unittest.TestCa
                 self.app = self.fake_app
                 self.user_agent = 'some_agent'
                 self.request_tries = 3
+                self.use_replication_network = False
 
             def fake_app(self, env, start_response):
                 start_response('404 Not Found', [])
@@ -1330,6 +1398,7 @@ class TestInternalClient(unittest.TestCa
         class InternalClient(internal_client.InternalClient):
             def __init__(self, test, path, headers, fobj):
                 self.test = test
+                self.use_replication_network = False
                 self.path = path
                 self.headers = headers
                 self.fobj = fobj
diff -pruN 2.25.0-3/test/unit/common/test_memcached.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/test_memcached.py
--- 2.25.0-3/test/unit/common/test_memcached.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/test_memcached.py	2020-09-15 21:13:36.000000000 +0000
@@ -20,6 +20,7 @@ from collections import defaultdict
 import errno
 from hashlib import md5
 import io
+import logging
 import six
 import socket
 import time
@@ -184,9 +185,14 @@ class TestMemcached(unittest.TestCase):
 
     def setUp(self):
         self.logger = debug_logger()
-        patcher = mock.patch('swift.common.memcached.logging', self.logger)
-        self.addCleanup(patcher.stop)
-        patcher.start()
+
+    def test_logger_kwarg(self):
+        server_socket = '%s:%s' % ('[::1]', 11211)
+        client = memcached.MemcacheRing([server_socket])
+        self.assertIs(client.logger, logging.getLogger())
+
+        client = memcached.MemcacheRing([server_socket], logger=self.logger)
+        self.assertIs(client.logger, self.logger)
 
     def test_get_conns(self):
         sock1 = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
@@ -202,7 +208,8 @@ class TestMemcached(unittest.TestCase):
             sock2ipport = '%s:%s' % (sock2ip, memcached.DEFAULT_MEMCACHED_PORT)
             # We're deliberately using sock2ip (no port) here to test that the
             # default port is used.
-            memcache_client = memcached.MemcacheRing([sock1ipport, sock2ip])
+            memcache_client = memcached.MemcacheRing([sock1ipport, sock2ip],
+                                                     logger=self.logger)
             one = two = True
             while one or two:  # Run until we match hosts one and two
                 key = uuid4().hex.encode('ascii')
@@ -230,7 +237,8 @@ class TestMemcached(unittest.TestCase):
             sock.listen(1)
             sock_addr = sock.getsockname()
             server_socket = '[%s]:%s' % (sock_addr[0], sock_addr[1])
-            memcache_client = memcached.MemcacheRing([server_socket])
+            memcache_client = memcached.MemcacheRing([server_socket],
+                                                     logger=self.logger)
             key = uuid4().hex.encode('ascii')
             for conn in memcache_client._get_conns(key):
                 peer_sockaddr = conn[2].getpeername()
@@ -251,7 +259,8 @@ class TestMemcached(unittest.TestCase):
             server_socket = '[%s]:%s' % (sock_addr[0], sock_addr[1])
             server_host = '[%s]' % sock_addr[0]
             memcached.DEFAULT_MEMCACHED_PORT = sock_addr[1]
-            memcache_client = memcached.MemcacheRing([server_host])
+            memcache_client = memcached.MemcacheRing([server_host],
+                                                     logger=self.logger)
             key = uuid4().hex.encode('ascii')
             for conn in memcache_client._get_conns(key):
                 peer_sockaddr = conn[2].getpeername()
@@ -265,7 +274,7 @@ class TestMemcached(unittest.TestCase):
         with self.assertRaises(ValueError):
             # IPv6 address with missing [] is invalid
             server_socket = '%s:%s' % ('::1', 11211)
-            memcached.MemcacheRing([server_socket])
+            memcached.MemcacheRing([server_socket], logger=self.logger)
 
     def test_get_conns_hostname(self):
         with patch('swift.common.memcached.socket.getaddrinfo') as addrinfo:
@@ -279,7 +288,8 @@ class TestMemcached(unittest.TestCase):
                 addrinfo.return_value = [(socket.AF_INET,
                                           socket.SOCK_STREAM, 0, '',
                                           ('127.0.0.1', sock_addr[1]))]
-                memcache_client = memcached.MemcacheRing([server_socket])
+                memcache_client = memcached.MemcacheRing([server_socket],
+                                                         logger=self.logger)
                 key = uuid4().hex.encode('ascii')
                 for conn in memcache_client._get_conns(key):
                     peer_sockaddr = conn[2].getpeername()
@@ -304,7 +314,8 @@ class TestMemcached(unittest.TestCase):
                 addrinfo.return_value = [(socket.AF_INET6,
                                           socket.SOCK_STREAM, 0, '',
                                           ('::1', sock_addr[1]))]
-                memcache_client = memcached.MemcacheRing([server_socket])
+                memcache_client = memcached.MemcacheRing([server_socket],
+                                                         logger=self.logger)
                 key = uuid4().hex.encode('ascii')
                 for conn in memcache_client._get_conns(key):
                     peer_sockaddr = conn[2].getpeername()
@@ -317,7 +328,8 @@ class TestMemcached(unittest.TestCase):
                 sock.close()
 
     def test_set_get_json(self):
-        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'])
+        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'],
+                                                 logger=self.logger)
         mock = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
             [(mock, mock)] * 2)
@@ -350,7 +362,8 @@ class TestMemcached(unittest.TestCase):
         self.assertAlmostEqual(float(cache_timeout), esttimeout, delta=1)
 
     def test_get_failed_connection_mid_request(self):
-        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'])
+        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'],
+                                                 logger=self.logger)
         mock = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
             [(mock, mock)] * 2)
@@ -365,18 +378,17 @@ class TestMemcached(unittest.TestCase):
         # force the logging through the DebugLogger instead of the nose
         # handler. This will use stdout, so we can assert that no stack trace
         # is logged.
-        logger = debug_logger()
-        with patch("sys.stdout", fake_stdout),\
-                patch('swift.common.memcached.logging', logger):
+        with patch("sys.stdout", fake_stdout):
             mock.read_return_empty_str = True
             self.assertIsNone(memcache_client.get('some_key'))
-        log_lines = logger.get_lines_for_level('error')
+        log_lines = self.logger.get_lines_for_level('error')
         self.assertIn('Error talking to memcached', log_lines[0])
         self.assertFalse(log_lines[1:])
         self.assertNotIn("Traceback", fake_stdout.getvalue())
 
     def test_incr(self):
-        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'])
+        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'],
+                                                 logger=self.logger)
         mock = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
             [(mock, mock)] * 2)
@@ -396,7 +408,8 @@ class TestMemcached(unittest.TestCase):
         self.assertTrue(mock.close_called)
 
     def test_incr_failed_connection_mid_request(self):
-        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'])
+        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'],
+                                                 logger=self.logger)
         mock = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
             [(mock, mock)] * 2)
@@ -411,19 +424,18 @@ class TestMemcached(unittest.TestCase):
         # force the logging through the DebugLogger instead of the nose
         # handler. This will use stdout, so we can assert that no stack trace
         # is logged.
-        logger = debug_logger()
-        with patch("sys.stdout", fake_stdout), \
-                patch('swift.common.memcached.logging', logger):
+        with patch("sys.stdout", fake_stdout):
             mock.read_return_empty_str = True
             self.assertRaises(memcached.MemcacheConnectionError,
                               memcache_client.incr, 'some_key', delta=1)
-        log_lines = logger.get_lines_for_level('error')
+        log_lines = self.logger.get_lines_for_level('error')
         self.assertIn('Error talking to memcached', log_lines[0])
         self.assertFalse(log_lines[1:])
         self.assertNotIn('Traceback', fake_stdout.getvalue())
 
     def test_incr_w_timeout(self):
-        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'])
+        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'],
+                                                 logger=self.logger)
         mock = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
             [(mock, mock)] * 2)
@@ -455,7 +467,8 @@ class TestMemcached(unittest.TestCase):
         self.assertEqual(mock.cache, {cache_key: (b'0', b'0', b'10')})
 
     def test_decr(self):
-        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'])
+        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'],
+                                                 logger=self.logger)
         mock = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
             [(mock, mock)] * 2)
@@ -473,7 +486,7 @@ class TestMemcached(unittest.TestCase):
 
     def test_retry(self):
         memcache_client = memcached.MemcacheRing(
-            ['1.2.3.4:11211', '1.2.3.5:11211'])
+            ['1.2.3.4:11211', '1.2.3.5:11211'], logger=self.logger)
         mock1 = ExplodingMockMemcached()
         mock2 = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
@@ -500,7 +513,8 @@ class TestMemcached(unittest.TestCase):
                          [])
 
     def test_delete(self):
-        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'])
+        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'],
+                                                 logger=self.logger)
         mock = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
             [(mock, mock)] * 2)
@@ -510,7 +524,8 @@ class TestMemcached(unittest.TestCase):
         self.assertIsNone(memcache_client.get('some_key'))
 
     def test_multi(self):
-        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'])
+        memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'],
+                                                 logger=self.logger)
         mock = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
             [(mock, mock)] * 2)
@@ -560,7 +575,8 @@ class TestMemcached(unittest.TestCase):
 
     def test_multi_delete(self):
         memcache_client = memcached.MemcacheRing(['1.2.3.4:11211',
-                                                  '1.2.3.5:11211'])
+                                                  '1.2.3.5:11211'],
+                                                 logger=self.logger)
         mock1 = MockMemcached()
         mock2 = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
@@ -598,7 +614,8 @@ class TestMemcached(unittest.TestCase):
 
     def test_serialization(self):
         memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'],
-                                                 allow_pickle=True)
+                                                 allow_pickle=True,
+                                                 logger=self.logger)
         mock = MockMemcached()
         memcache_client._client_cache['1.2.3.4:11211'] = MockedMemcachePool(
             [(mock, mock)] * 2)
@@ -643,7 +660,8 @@ class TestMemcached(unittest.TestCase):
             mock_sock.connect = wait_connect
 
             memcache_client = memcached.MemcacheRing(['1.2.3.4:11211'],
-                                                     connect_timeout=10)
+                                                     connect_timeout=10,
+                                                     logger=self.logger)
             # sanity
             self.assertEqual(1, len(memcache_client._client_cache))
             for server, pool in memcache_client._client_cache.items():
@@ -702,7 +720,8 @@ class TestMemcached(unittest.TestCase):
             memcache_client = memcached.MemcacheRing(['1.2.3.4:11211',
                                                       '1.2.3.5:11211'],
                                                      io_timeout=0.5,
-                                                     pool_timeout=0.1)
+                                                     pool_timeout=0.1,
+                                                     logger=self.logger)
 
             # Hand out a couple slow connections to 1.2.3.5, leaving 1.2.3.4
             # fast. All ten (10) clients should try to talk to .5 first, and
diff -pruN 2.25.0-3/test/unit/common/test_request_helpers.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/test_request_helpers.py
--- 2.25.0-3/test/unit/common/test_request_helpers.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/test_request_helpers.py	2020-09-15 21:13:36.000000000 +0000
@@ -124,6 +124,19 @@ class TestRequestHelpers(unittest.TestCa
         self.assertFalse('c' in to_req.headers)
         self.assertFalse('C' in to_req.headers)
 
+    def test_get_ip_port(self):
+        node = {
+            'ip': '1.2.3.4',
+            'port': 6000,
+            'replication_ip': '5.6.7.8',
+            'replication_port': 7000,
+        }
+        self.assertEqual(('1.2.3.4', 6000), rh.get_ip_port(node, {}))
+        self.assertEqual(('5.6.7.8', 7000), rh.get_ip_port(node, {
+            rh.USE_REPLICATION_NETWORK_HEADER: 'true'}))
+        self.assertEqual(('1.2.3.4', 6000), rh.get_ip_port(node, {
+            rh.USE_REPLICATION_NETWORK_HEADER: 'false'}))
+
     @patch_policies(with_ec_default=True)
     def test_get_name_and_placement_object_req(self):
         path = '/device/part/account/container/object'
diff -pruN 2.25.0-3/test/unit/common/test_swob.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/test_swob.py
--- 2.25.0-3/test/unit/common/test_swob.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/test_swob.py	2020-09-15 21:13:36.000000000 +0000
@@ -914,6 +914,22 @@ class TestRequest(unittest.TestCase):
         self.assertEqual(used_req[0].path, '/hi/there')
         self.assertEqual(resp.status_int, 200)
 
+    def test_wsgify_method(self):
+        class _wsgi_class(object):
+            def __init__(self):
+                self.used_req = []
+
+            @swob.wsgify
+            def __call__(self, req):
+                self.used_req.append(req)
+                return swob.Response(b'200 OK')
+
+        req = swob.Request.blank('/hi/there')
+        handler = _wsgi_class()
+        resp = req.get_response(handler)
+        self.assertIs(handler.used_req[0].environ, req.environ)
+        self.assertEqual(resp.status_int, 200)
+
     def test_wsgify_raise(self):
         used_req = []
 
diff -pruN 2.25.0-3/test/unit/common/test_utils.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/test_utils.py
--- 2.25.0-3/test/unit/common/test_utils.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/test_utils.py	2020-09-15 21:13:36.000000000 +0000
@@ -44,6 +44,7 @@ import sys
 import json
 import math
 import inspect
+import warnings
 
 import six
 from six import StringIO
@@ -6079,6 +6080,136 @@ class TestAuditLocationGenerator(unittes
             self.assertEqual(list(locations),
                              [(obj_path, "drive", "partition2")])
 
+    def test_hooks(self):
+        with temptree([]) as tmpdir:
+            logger = FakeLogger()
+            data = os.path.join(tmpdir, "drive", "data")
+            os.makedirs(data)
+            partition = os.path.join(data, "partition1")
+            os.makedirs(partition)
+            suffix = os.path.join(partition, "suffix1")
+            os.makedirs(suffix)
+            hash_path = os.path.join(suffix, "hash1")
+            os.makedirs(hash_path)
+            obj_path = os.path.join(hash_path, "obj1.dat")
+            with open(obj_path, "w"):
+                pass
+            meta_path = os.path.join(hash_path, "obj1.meta")
+            with open(meta_path, "w"):
+                pass
+            hook_pre_device = MagicMock()
+            hook_post_device = MagicMock()
+            hook_pre_partition = MagicMock()
+            hook_post_partition = MagicMock()
+            hook_pre_suffix = MagicMock()
+            hook_post_suffix = MagicMock()
+            hook_pre_hash = MagicMock()
+            hook_post_hash = MagicMock()
+            locations = utils.audit_location_generator(
+                tmpdir, "data", ".dat", mount_check=False, logger=logger,
+                hook_pre_device=hook_pre_device,
+                hook_post_device=hook_post_device,
+                hook_pre_partition=hook_pre_partition,
+                hook_post_partition=hook_post_partition,
+                hook_pre_suffix=hook_pre_suffix,
+                hook_post_suffix=hook_post_suffix,
+                hook_pre_hash=hook_pre_hash,
+                hook_post_hash=hook_post_hash
+            )
+            list(locations)
+            hook_pre_device.assert_called_once_with(os.path.join(tmpdir,
+                                                                 "drive"))
+            hook_post_device.assert_called_once_with(os.path.join(tmpdir,
+                                                                  "drive"))
+            hook_pre_partition.assert_called_once_with(partition)
+            hook_post_partition.assert_called_once_with(partition)
+            hook_pre_suffix.assert_called_once_with(suffix)
+            hook_post_suffix.assert_called_once_with(suffix)
+            hook_pre_hash.assert_called_once_with(hash_path)
+            hook_post_hash.assert_called_once_with(hash_path)
+
+    def test_filters(self):
+        with temptree([]) as tmpdir:
+            logger = FakeLogger()
+            data = os.path.join(tmpdir, "drive", "data")
+            os.makedirs(data)
+            partition = os.path.join(data, "partition1")
+            os.makedirs(partition)
+            suffix = os.path.join(partition, "suffix1")
+            os.makedirs(suffix)
+            hash_path = os.path.join(suffix, "hash1")
+            os.makedirs(hash_path)
+            obj_path = os.path.join(hash_path, "obj1.dat")
+            with open(obj_path, "w"):
+                pass
+            meta_path = os.path.join(hash_path, "obj1.meta")
+            with open(meta_path, "w"):
+                pass
+
+            def audit_location_generator(**kwargs):
+                return utils.audit_location_generator(
+                    tmpdir, "data", ".dat", mount_check=False, logger=logger,
+                    **kwargs)
+
+            # Return the list of devices
+
+            with patch('os.listdir', side_effect=os.listdir) as m_listdir:
+                # devices_filter
+                m_listdir.reset_mock()
+                devices_filter = MagicMock(return_value=["drive"])
+                list(audit_location_generator(devices_filter=devices_filter))
+                devices_filter.assert_called_once_with(tmpdir, ["drive"])
+                self.assertIn(((data,),), m_listdir.call_args_list)
+
+                m_listdir.reset_mock()
+                devices_filter = MagicMock(return_value=[])
+                list(audit_location_generator(devices_filter=devices_filter))
+                devices_filter.assert_called_once_with(tmpdir, ["drive"])
+                self.assertNotIn(((data,),), m_listdir.call_args_list)
+
+                # partitions_filter
+                m_listdir.reset_mock()
+                partitions_filter = MagicMock(return_value=["partition1"])
+                list(audit_location_generator(
+                    partitions_filter=partitions_filter))
+                partitions_filter.assert_called_once_with(data,
+                                                          ["partition1"])
+                self.assertIn(((partition,),), m_listdir.call_args_list)
+
+                m_listdir.reset_mock()
+                partitions_filter = MagicMock(return_value=[])
+                list(audit_location_generator(
+                    partitions_filter=partitions_filter))
+                partitions_filter.assert_called_once_with(data,
+                                                          ["partition1"])
+                self.assertNotIn(((partition,),), m_listdir.call_args_list)
+
+                # suffixes_filter
+                m_listdir.reset_mock()
+                suffixes_filter = MagicMock(return_value=["suffix1"])
+                list(audit_location_generator(suffixes_filter=suffixes_filter))
+                suffixes_filter.assert_called_once_with(partition, ["suffix1"])
+                self.assertIn(((suffix,),), m_listdir.call_args_list)
+
+                m_listdir.reset_mock()
+                suffixes_filter = MagicMock(return_value=[])
+                list(audit_location_generator(suffixes_filter=suffixes_filter))
+                suffixes_filter.assert_called_once_with(partition, ["suffix1"])
+                self.assertNotIn(((suffix,),), m_listdir.call_args_list)
+
+                # hashes_filter
+                m_listdir.reset_mock()
+                hashes_filter = MagicMock(return_value=["hash1"])
+                list(audit_location_generator(hashes_filter=hashes_filter))
+                hashes_filter.assert_called_once_with(suffix, ["hash1"])
+                self.assertIn(((hash_path,),), m_listdir.call_args_list)
+
+                m_listdir.reset_mock()
+                hashes_filter = MagicMock(return_value=[])
+                list(audit_location_generator(hashes_filter=hashes_filter))
+                hashes_filter.assert_called_once_with(suffix, ["hash1"])
+                self.assertNotIn(((hash_path,),), m_listdir.call_args_list)
+
 
 class TestGreenAsyncPile(unittest.TestCase):
 
@@ -6476,6 +6607,16 @@ class TestParseContentDisposition(unitte
         self.assertEqual(attrs, {'name': 'somefile', 'filename': 'test.html'})
 
 
+class TestGetExpirerContainer(unittest.TestCase):
+
+    @mock.patch.object(utils, 'hash_path', return_value=hex(101)[2:])
+    def test_get_expirer_container(self, mock_hash_path):
+        container = utils.get_expirer_container(1234, 20, 'a', 'c', 'o')
+        self.assertEqual(container, '0000001219')
+        container = utils.get_expirer_container(1234, 200, 'a', 'c', 'o')
+        self.assertEqual(container, '0000001199')
+
+
 class TestIterMultipartMimeDocuments(unittest.TestCase):
 
     def test_bad_start(self):
@@ -7223,7 +7364,8 @@ class TestShardRange(unittest.TestCase):
                       upper='', object_count=0, bytes_used=0,
                       meta_timestamp=ts_1.internal, deleted=0,
                       state=utils.ShardRange.FOUND,
-                      state_timestamp=ts_1.internal, epoch=None)
+                      state_timestamp=ts_1.internal, epoch=None,
+                      reported=0)
         assert_initialisation_ok(dict(empty_run, name='a/c', timestamp=ts_1),
                                  expect)
         assert_initialisation_ok(dict(name='a/c', timestamp=ts_1), expect)
@@ -7232,11 +7374,13 @@ class TestShardRange(unittest.TestCase):
                         upper='u', object_count=2, bytes_used=10,
                         meta_timestamp=ts_2, deleted=0,
                         state=utils.ShardRange.CREATED,
-                        state_timestamp=ts_3.internal, epoch=ts_4)
+                        state_timestamp=ts_3.internal, epoch=ts_4,
+                        reported=0)
         expect.update({'lower': 'l', 'upper': 'u', 'object_count': 2,
                        'bytes_used': 10, 'meta_timestamp': ts_2.internal,
                        'state': utils.ShardRange.CREATED,
-                       'state_timestamp': ts_3.internal, 'epoch': ts_4})
+                       'state_timestamp': ts_3.internal, 'epoch': ts_4,
+                       'reported': 0})
         assert_initialisation_ok(good_run.copy(), expect)
 
         # obj count and bytes used as int strings
@@ -7254,6 +7398,11 @@ class TestShardRange(unittest.TestCase):
         assert_initialisation_ok(good_deleted,
                                  dict(expect, deleted=1))
 
+        good_reported = good_run.copy()
+        good_reported['reported'] = 1
+        assert_initialisation_ok(good_reported,
+                                 dict(expect, reported=1))
+
         assert_initialisation_fails(dict(good_run, timestamp='water balloon'))
 
         assert_initialisation_fails(
@@ -7292,7 +7441,7 @@ class TestShardRange(unittest.TestCase):
             'upper': upper, 'object_count': 10, 'bytes_used': 100,
             'meta_timestamp': ts_2.internal, 'deleted': 0,
             'state': utils.ShardRange.FOUND, 'state_timestamp': ts_3.internal,
-            'epoch': ts_4}
+            'epoch': ts_4, 'reported': 0}
         self.assertEqual(expected, sr_dict)
         self.assertIsInstance(sr_dict['lower'], six.string_types)
         self.assertIsInstance(sr_dict['upper'], six.string_types)
@@ -7307,6 +7456,14 @@ class TestShardRange(unittest.TestCase):
         for key in sr_dict:
             bad_dict = dict(sr_dict)
             bad_dict.pop(key)
+            if key == 'reported':
+                # This was added after the fact, and we need to be able to eat
+                # data from old servers
+                utils.ShardRange.from_dict(bad_dict)
+                utils.ShardRange(**bad_dict)
+                continue
+
+            # The rest were present from the beginning
             with self.assertRaises(KeyError):
                 utils.ShardRange.from_dict(bad_dict)
             # But __init__ still (generally) works!
@@ -7585,8 +7742,10 @@ class TestShardRange(unittest.TestCase):
         expected = u'\N{SNOWMAN}'
         if six.PY2:
             expected = expected.encode('utf-8')
-        do_test(u'\N{SNOWMAN}', expected)
-        do_test(u'\N{SNOWMAN}'.encode('utf-8'), expected)
+        with warnings.catch_warnings(record=True) as captured_warnings:
+            do_test(u'\N{SNOWMAN}', expected)
+            do_test(u'\N{SNOWMAN}'.encode('utf-8'), expected)
+        self.assertFalse(captured_warnings)
 
         sr = utils.ShardRange('a/c', utils.Timestamp.now(), 'b', 'y')
         sr.lower = ''
@@ -7633,8 +7792,10 @@ class TestShardRange(unittest.TestCase):
         expected = u'\N{SNOWMAN}'
         if six.PY2:
             expected = expected.encode('utf-8')
-        do_test(u'\N{SNOWMAN}', expected)
-        do_test(u'\N{SNOWMAN}'.encode('utf-8'), expected)
+        with warnings.catch_warnings(record=True) as captured_warnings:
+            do_test(u'\N{SNOWMAN}', expected)
+            do_test(u'\N{SNOWMAN}'.encode('utf-8'), expected)
+        self.assertFalse(captured_warnings)
 
         sr = utils.ShardRange('a/c', utils.Timestamp.now(), 'b', 'y')
         sr.upper = ''
diff -pruN 2.25.0-3/test/unit/common/test_wsgi.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/test_wsgi.py
--- 2.25.0-3/test/unit/common/test_wsgi.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/common/test_wsgi.py	2020-09-15 21:13:36.000000000 +0000
@@ -40,7 +40,7 @@ import swift.proxy.server
 import swift.obj.server as obj_server
 import swift.container.server as container_server
 import swift.account.server as account_server
-from swift.common.swob import Request
+from swift.common.swob import Request, wsgi_to_bytes
 from swift.common import wsgi, utils
 from swift.common.storage_policy import POLICIES
 
@@ -778,7 +778,7 @@ class TestWSGI(unittest.TestCase):
 
         def _initrp(conf_file, app_section, *args, **kwargs):
             return (
-                {'__file__': 'test', 'workers': 0},
+                {'__file__': 'test', 'workers': 0, 'bind_port': 12345},
                 'logger',
                 'log_name')
 
@@ -788,7 +788,8 @@ class TestWSGI(unittest.TestCase):
         def _global_conf_callback(preloaded_app_conf, global_conf):
             calls['_global_conf_callback'] += 1
             self.assertEqual(
-                preloaded_app_conf, {'__file__': 'test', 'workers': 0})
+                preloaded_app_conf,
+                {'__file__': 'test', 'workers': 0, 'bind_port': 12345})
             self.assertEqual(global_conf, {'log_name': 'log_name'})
             global_conf['test1'] = to_inject
 
@@ -827,7 +828,7 @@ class TestWSGI(unittest.TestCase):
         def _initrp(conf_file, app_section, *args, **kwargs):
             calls['_initrp'] += 1
             return (
-                {'__file__': 'test', 'workers': 0},
+                {'__file__': 'test', 'workers': 0, 'bind_port': 12345},
                 'logger',
                 'log_name')
 
@@ -862,11 +863,17 @@ class TestWSGI(unittest.TestCase):
                                           mock_run_server):
         # Make sure the right strategy gets used in a number of different
         # config cases.
-        mock_per_port().do_bind_ports.return_value = 'stop early'
-        mock_workers().do_bind_ports.return_value = 'stop early'
+
+        class StopAtCreatingSockets(Exception):
+            '''Dummy exception to make sure we don't actually bind ports'''
+
+        mock_per_port().no_fork_sock.return_value = None
+        mock_per_port().new_worker_socks.side_effect = StopAtCreatingSockets
+        mock_workers().no_fork_sock.return_value = None
+        mock_workers().new_worker_socks.side_effect = StopAtCreatingSockets
         logger = FakeLogger()
         stub__initrp = [
-            {'__file__': 'test', 'workers': 2},  # conf
+            {'__file__': 'test', 'workers': 2, 'bind_port': 12345},  # conf
             logger,
             'log_name',
         ]
@@ -878,14 +885,13 @@ class TestWSGI(unittest.TestCase):
                 mock_per_port.reset_mock()
                 mock_workers.reset_mock()
                 logger._clear()
-                self.assertEqual(1, wsgi.run_wsgi('conf_file', server_type))
-                self.assertEqual([
-                    'stop early',
-                ], logger.get_lines_for_level('error'))
+                with self.assertRaises(StopAtCreatingSockets):
+                    wsgi.run_wsgi('conf_file', server_type)
                 self.assertEqual([], mock_per_port.mock_calls)
                 self.assertEqual([
                     mock.call(stub__initrp[0], logger),
-                    mock.call().do_bind_ports(),
+                    mock.call().no_fork_sock(),
+                    mock.call().new_worker_socks(),
                 ], mock_workers.mock_calls)
 
             stub__initrp[0]['servers_per_port'] = 3
@@ -893,26 +899,24 @@ class TestWSGI(unittest.TestCase):
                 mock_per_port.reset_mock()
                 mock_workers.reset_mock()
                 logger._clear()
-                self.assertEqual(1, wsgi.run_wsgi('conf_file', server_type))
-                self.assertEqual([
-                    'stop early',
-                ], logger.get_lines_for_level('error'))
+                with self.assertRaises(StopAtCreatingSockets):
+                    wsgi.run_wsgi('conf_file', server_type)
                 self.assertEqual([], mock_per_port.mock_calls)
                 self.assertEqual([
                     mock.call(stub__initrp[0], logger),
-                    mock.call().do_bind_ports(),
+                    mock.call().no_fork_sock(),
+                    mock.call().new_worker_socks(),
                 ], mock_workers.mock_calls)
 
             mock_per_port.reset_mock()
             mock_workers.reset_mock()
             logger._clear()
-            self.assertEqual(1, wsgi.run_wsgi('conf_file', 'object-server'))
-            self.assertEqual([
-                'stop early',
-            ], logger.get_lines_for_level('error'))
+            with self.assertRaises(StopAtCreatingSockets):
+                wsgi.run_wsgi('conf_file', 'object-server')
             self.assertEqual([
                 mock.call(stub__initrp[0], logger, servers_per_port=3),
-                mock.call().do_bind_ports(),
+                mock.call().no_fork_sock(),
+                mock.call().new_worker_socks(),
             ], mock_per_port.mock_calls)
             self.assertEqual([], mock_workers.mock_calls)
 
@@ -1086,8 +1090,8 @@ class TestSwiftHttpProtocol(unittest.Tes
                 b'POST /?and+it=fixes+params&PALMTREE=%F0%9F%8C%B4 HTTP/1.1')
 
 
-class TestProxyProtocol(unittest.TestCase):
-    def _run_bytes_through_protocol(self, bytes_from_client, protocol_class):
+class ProtocolTest(unittest.TestCase):
+    def _run_bytes_through_protocol(self, bytes_from_client):
         rfile = BytesIO(bytes_from_client)
         wfile = BytesIO()
 
@@ -1110,21 +1114,6 @@ class TestProxyProtocol(unittest.TestCas
             def waitall(self):
                 pass
 
-        def dinky_app(env, start_response):
-            start_response("200 OK", [])
-            body = '\r\n'.join([
-                'got addr: %s %s' % (
-                    env.get("REMOTE_ADDR", "<missing>"),
-                    env.get("REMOTE_PORT", "<missing>")),
-                'on addr: %s %s' % (
-                    env.get("SERVER_ADDR", "<missing>"),
-                    env.get("SERVER_PORT", "<missing>")),
-                'https is %s (scheme %s)' % (
-                    env.get("HTTPS", "<missing>"),
-                    env.get("wsgi.url_scheme", "<missing>")),
-            ]) + '\r\n'
-            return [body.encode("utf-8")]
-
         addr = ('127.0.0.1', 8359)
         fake_tcp_socket = mock.Mock(
             setsockopt=lambda *a: None,
@@ -1145,20 +1134,81 @@ class TestProxyProtocol(unittest.TestCas
         with mock.patch.object(wfile, 'close', lambda: None), \
                 mock.patch.object(rfile, 'close', lambda: None):
             eventlet.wsgi.server(
-                fake_listen_socket, dinky_app,
-                protocol=protocol_class,
+                fake_listen_socket, self.app,
+                protocol=self.protocol_class,
                 custom_pool=FakePool(),
                 log_output=False,  # quiet the test run
             )
         return wfile.getvalue()
 
+
+class TestSwiftHttpProtocolSomeMore(ProtocolTest):
+    protocol_class = wsgi.SwiftHttpProtocol
+
+    @staticmethod
+    def app(env, start_response):
+        start_response("200 OK", [])
+        return [wsgi_to_bytes(env['RAW_PATH_INFO'])]
+
+    def test_simple(self):
+        bytes_out = self._run_bytes_through_protocol((
+            b"GET /someurl HTTP/1.0\r\n"
+            b"User-Agent: something or other\r\n"
+            b"\r\n"
+        ))
+
+        lines = [l for l in bytes_out.split(b"\r\n") if l]
+        self.assertEqual(lines[0], b"HTTP/1.1 200 OK")  # sanity check
+        self.assertEqual(lines[-1], b'/someurl')
+
+    def test_quoted(self):
+        bytes_out = self._run_bytes_through_protocol((
+            b"GET /some%fFpath%D8%AA HTTP/1.0\r\n"
+            b"User-Agent: something or other\r\n"
+            b"\r\n"
+        ))
+
+        lines = [l for l in bytes_out.split(b"\r\n") if l]
+        self.assertEqual(lines[0], b"HTTP/1.1 200 OK")  # sanity check
+        self.assertEqual(lines[-1], b'/some%fFpath%D8%AA')
+
+    def test_messy(self):
+        bytes_out = self._run_bytes_through_protocol((
+            b"GET /oh\xffboy%what$now%E2%80%bd HTTP/1.0\r\n"
+            b"User-Agent: something or other\r\n"
+            b"\r\n"
+        ))
+
+        lines = [l for l in bytes_out.split(b"\r\n") if l]
+        self.assertEqual(lines[-1], b'/oh\xffboy%what$now%E2%80%bd')
+
+
+class TestProxyProtocol(ProtocolTest):
+    protocol_class = wsgi.SwiftHttpProxiedProtocol
+
+    @staticmethod
+    def app(env, start_response):
+        start_response("200 OK", [])
+        body = '\r\n'.join([
+            'got addr: %s %s' % (
+                env.get("REMOTE_ADDR", "<missing>"),
+                env.get("REMOTE_PORT", "<missing>")),
+            'on addr: %s %s' % (
+                env.get("SERVER_ADDR", "<missing>"),
+                env.get("SERVER_PORT", "<missing>")),
+            'https is %s (scheme %s)' % (
+                env.get("HTTPS", "<missing>"),
+                env.get("wsgi.url_scheme", "<missing>")),
+        ]) + '\r\n'
+        return [body.encode("utf-8")]
+
     def test_request_with_proxy(self):
         bytes_out = self._run_bytes_through_protocol((
             b"PROXY TCP4 192.168.0.1 192.168.0.11 56423 4433\r\n"
             b"GET /someurl HTTP/1.0\r\n"
             b"User-Agent: something or other\r\n"
             b"\r\n"
-        ), wsgi.SwiftHttpProxiedProtocol)
+        ))
 
         lines = [l for l in bytes_out.split(b"\r\n") if l]
         self.assertEqual(lines[0], b"HTTP/1.1 200 OK")  # sanity check
@@ -1174,7 +1224,7 @@ class TestProxyProtocol(unittest.TestCas
             b"GET /someurl HTTP/1.0\r\n"
             b"User-Agent: something or other\r\n"
             b"\r\n"
-        ), wsgi.SwiftHttpProxiedProtocol)
+        ))
 
         lines = [l for l in bytes_out.split(b"\r\n") if l]
         self.assertEqual(lines[0], b"HTTP/1.1 200 OK")  # sanity check
@@ -1194,7 +1244,7 @@ class TestProxyProtocol(unittest.TestCas
             b"User-Agent: something or other\r\n"
             b"Connection: close\r\n"
             b"\r\n"
-        ), wsgi.SwiftHttpProxiedProtocol)
+        ))
 
         lines = bytes_out.split(b"\r\n")
         self.assertEqual(lines[0], b"HTTP/1.1 200 OK")  # sanity check
@@ -1213,7 +1263,7 @@ class TestProxyProtocol(unittest.TestCas
             b"GET /someurl HTTP/1.0\r\n"
             b"User-Agent: something or other\r\n"
             b"\r\n"
-        ), wsgi.SwiftHttpProxiedProtocol)
+        ))
 
         lines = [l for l in bytes_out.split(b"\r\n") if l]
         self.assertIn(b"400 Invalid PROXY line", lines[0])
@@ -1223,8 +1273,7 @@ class TestProxyProtocol(unittest.TestCas
                          b'PROXYjojo a b c d e',
                          b'PROXY a b c d e',  # bad INET protocol and family
                          ]:
-            bytes_out = self._run_bytes_through_protocol(
-                bad_line, wsgi.SwiftHttpProxiedProtocol)
+            bytes_out = self._run_bytes_through_protocol(bad_line)
             lines = [l for l in bytes_out.split(b"\r\n") if l]
             self.assertIn(b"400 Invalid PROXY line", lines[0])
 
@@ -1240,7 +1289,7 @@ class TestProxyProtocol(unittest.TestCas
                                 b"GET /someurl HTTP/1.0\r\n"
                                 b"User-Agent: something or other\r\n"
                                 b"\r\n")
-            ), wsgi.SwiftHttpProxiedProtocol)
+            ))
             lines = [l for l in bytes_out.split(b"\r\n") if l]
             self.assertIn(b"200 OK", lines[0])
 
@@ -1286,12 +1335,16 @@ class TestProxyProtocol(unittest.TestCas
 
 class CommonTestMixin(object):
 
-    def test_post_fork_hook(self):
+    @mock.patch('swift.common.wsgi.capture_stdio')
+    def test_post_fork_hook(self, mock_capture):
         self.strategy.post_fork_hook()
 
         self.assertEqual([
             mock.call('bob'),
         ], self.mock_drop_privileges.mock_calls)
+        self.assertEqual([
+            mock.call(self.logger),
+        ], mock_capture.mock_calls)
 
 
 class TestServersPerPortStrategy(unittest.TestCase, CommonTestMixin):
@@ -1305,9 +1358,9 @@ class TestServersPerPortStrategy(unittes
             'bind_ip': '2.3.4.5',
         }
         self.servers_per_port = 3
-        self.s1, self.s2 = mock.MagicMock(), mock.MagicMock()
+        self.sockets = [mock.MagicMock() for _ in range(6)]
         patcher = mock.patch('swift.common.wsgi.get_socket',
-                             side_effect=[self.s1, self.s2])
+                             side_effect=self.sockets)
         self.mock_get_socket = patcher.start()
         self.addCleanup(patcher.stop)
         patcher = mock.patch('swift.common.wsgi.drop_privileges')
@@ -1346,39 +1399,10 @@ class TestServersPerPortStrategy(unittes
 
         self.assertEqual(15, self.strategy.loop_timeout())
 
-    def test_bind_ports(self):
-        self.strategy.do_bind_ports()
-
-        self.assertEqual(set((6006, 6007)), self.strategy.bind_ports)
-        self.assertEqual([
-            mock.call({'workers': 100,  # ignored
-                       'user': 'bob',
-                       'swift_dir': '/jim/cricket',
-                       'ring_check_interval': '76',
-                       'bind_ip': '2.3.4.5',
-                       'bind_port': 6006}),
-            mock.call({'workers': 100,  # ignored
-                       'user': 'bob',
-                       'swift_dir': '/jim/cricket',
-                       'ring_check_interval': '76',
-                       'bind_ip': '2.3.4.5',
-                       'bind_port': 6007}),
-        ], self.mock_get_socket.mock_calls)
-        self.assertEqual(
-            6006, self.strategy.port_pid_state.port_for_sock(self.s1))
-        self.assertEqual(
-            6007, self.strategy.port_pid_state.port_for_sock(self.s2))
-        # strategy binding no longer does clean_up_deemon_hygene() actions, the
-        # user of the strategy does.
-        self.assertEqual([], self.mock_setsid.mock_calls)
-        self.assertEqual([], self.mock_chdir.mock_calls)
-        self.assertEqual([], self.mock_umask.mock_calls)
-
     def test_no_fork_sock(self):
         self.assertIsNone(self.strategy.no_fork_sock())
 
     def test_new_worker_socks(self):
-        self.strategy.do_bind_ports()
         self.all_bind_ports_for_node.reset_mock()
 
         pid = 88
@@ -1389,8 +1413,12 @@ class TestServersPerPortStrategy(unittes
             pid += 1
 
         self.assertEqual([
-            (self.s1, 0), (self.s1, 1), (self.s1, 2),
-            (self.s2, 0), (self.s2, 1), (self.s2, 2),
+            (self.sockets[0], (6006, 0)),
+            (self.sockets[1], (6006, 1)),
+            (self.sockets[2], (6006, 2)),
+            (self.sockets[3], (6007, 0)),
+            (self.sockets[4], (6007, 1)),
+            (self.sockets[5], (6007, 2)),
         ], got_si)
         self.assertEqual([
             'Started child %d (PID %d) for port %d' % (0, 88, 6006),
@@ -1409,8 +1437,8 @@ class TestServersPerPortStrategy(unittes
         # Get rid of servers for ports which disappear from the ring
         self.ports = (6007,)
         self.all_bind_ports_for_node.return_value = set(self.ports)
-        self.s1.reset_mock()
-        self.s2.reset_mock()
+        for s in self.sockets:
+            s.reset_mock()
 
         with mock.patch('swift.common.wsgi.greenio') as mock_greenio:
             self.assertEqual([], list(self.strategy.new_worker_socks()))
@@ -1419,23 +1447,28 @@ class TestServersPerPortStrategy(unittes
             mock.call(),  # ring_check_interval has passed...
         ], self.all_bind_ports_for_node.mock_calls)
         self.assertEqual([
-            mock.call.shutdown_safe(self.s1),
-        ], mock_greenio.mock_calls)
-        self.assertEqual([
-            mock.call.close(),
-        ], self.s1.mock_calls)
-        self.assertEqual([], self.s2.mock_calls)  # not closed
-        self.assertEqual([
-            'Closing unnecessary sock for port %d' % 6006,
-        ], self.logger.get_lines_for_level('notice'))
+            [mock.call.close()]
+            for _ in range(3)
+        ], [s.mock_calls for s in self.sockets[:3]])
+        self.assertEqual({
+            ('shutdown_safe', (self.sockets[0],)),
+            ('shutdown_safe', (self.sockets[1],)),
+            ('shutdown_safe', (self.sockets[2],)),
+        }, {call[:2] for call in mock_greenio.mock_calls})
+        self.assertEqual([
+            [] for _ in range(3)
+        ], [s.mock_calls for s in self.sockets[3:]])  # not closed
+        self.assertEqual({
+            'Closing unnecessary sock for port %d (child pid %d)' % (6006, p)
+            for p in range(88, 91)
+        }, set(self.logger.get_lines_for_level('notice')))
         self.logger._clear()
 
         # Create new socket & workers for new ports that appear in ring
         self.ports = (6007, 6009)
         self.all_bind_ports_for_node.return_value = set(self.ports)
-        self.s1.reset_mock()
-        self.s2.reset_mock()
-        s3 = mock.MagicMock()
+        for s in self.sockets:
+            s.reset_mock()
         self.mock_get_socket.side_effect = Exception('ack')
 
         # But first make sure we handle failure to bind to the requested port!
@@ -1454,7 +1487,8 @@ class TestServersPerPortStrategy(unittes
         self.logger._clear()
 
         # Will keep trying, so let it succeed again
-        self.mock_get_socket.side_effect = [s3]
+        new_sockets = self.mock_get_socket.side_effect = [
+            mock.MagicMock() for _ in range(3)]
 
         got_si = []
         for s, i in self.strategy.new_worker_socks():
@@ -1463,7 +1497,7 @@ class TestServersPerPortStrategy(unittes
             pid += 1
 
         self.assertEqual([
-            (s3, 0), (s3, 1), (s3, 2),
+            (s, (6009, i)) for i, s in enumerate(new_sockets)
         ], got_si)
         self.assertEqual([
             'Started child %d (PID %d) for port %d' % (0, 94, 6009),
@@ -1479,6 +1513,11 @@ class TestServersPerPortStrategy(unittes
         # Restart a guy who died on us
         self.strategy.register_worker_exit(95)  # server_idx == 1
 
+        # TODO: check that the socket got cleaned up
+
+        new_socket = mock.MagicMock()
+        self.mock_get_socket.side_effect = [new_socket]
+
         got_si = []
         for s, i in self.strategy.new_worker_socks():
             got_si.append((s, i))
@@ -1486,7 +1525,7 @@ class TestServersPerPortStrategy(unittes
             pid += 1
 
         self.assertEqual([
-            (s3, 1),
+            (new_socket, (6009, 1)),
         ], got_si)
         self.assertEqual([
             'Started child %d (PID %d) for port %d' % (1, 97, 6009),
@@ -1494,7 +1533,7 @@ class TestServersPerPortStrategy(unittes
         self.logger._clear()
 
         # Check log_sock_exit
-        self.strategy.log_sock_exit(self.s2, 2)
+        self.strategy.log_sock_exit(self.sockets[5], (6007, 2))
         self.assertEqual([
             'Child %d (PID %d, port %d) exiting normally' % (
                 2, os.getpid(), 6007),
@@ -1506,21 +1545,22 @@ class TestServersPerPortStrategy(unittes
         self.assertIsNone(self.strategy.register_worker_exit(89))
 
     def test_shutdown_sockets(self):
-        self.strategy.do_bind_ports()
+        pid = 88
+        for s, i in self.strategy.new_worker_socks():
+            self.strategy.register_worker_start(s, i, pid)
+            pid += 1
 
         with mock.patch('swift.common.wsgi.greenio') as mock_greenio:
             self.strategy.shutdown_sockets()
 
         self.assertEqual([
-            mock.call.shutdown_safe(self.s1),
-            mock.call.shutdown_safe(self.s2),
+            mock.call.shutdown_safe(s)
+            for s in self.sockets
         ], mock_greenio.mock_calls)
         self.assertEqual([
-            mock.call.close(),
-        ], self.s1.mock_calls)
-        self.assertEqual([
-            mock.call.close(),
-        ], self.s2.mock_calls)
+            [mock.call.close()]
+            for _ in range(3)
+        ], [s.mock_calls for s in self.sockets[:3]])
 
 
 class TestWorkersStrategy(unittest.TestCase, CommonTestMixin):
@@ -1531,8 +1571,9 @@ class TestWorkersStrategy(unittest.TestC
             'user': 'bob',
         }
         self.strategy = wsgi.WorkersStrategy(self.conf, self.logger)
+        self.mock_socket = mock.Mock()
         patcher = mock.patch('swift.common.wsgi.get_socket',
-                             return_value='abc')
+                             return_value=self.mock_socket)
         self.mock_get_socket = patcher.start()
         self.addCleanup(patcher.stop)
         patcher = mock.patch('swift.common.wsgi.drop_privileges')
@@ -1548,41 +1589,19 @@ class TestWorkersStrategy(unittest.TestC
         # gets checked).
         self.assertEqual(0.5, self.strategy.loop_timeout())
 
-    def test_binding(self):
-        self.assertIsNone(self.strategy.do_bind_ports())
-
-        self.assertEqual('abc', self.strategy.sock)
-        self.assertEqual([
-            mock.call(self.conf),
-        ], self.mock_get_socket.mock_calls)
-        # strategy binding no longer drops privileges nor does
-        # clean_up_deemon_hygene() actions.
-        self.assertEqual([], self.mock_drop_privileges.mock_calls)
-        self.assertEqual([], self.mock_clean_up_daemon_hygene.mock_calls)
-
-        self.mock_get_socket.side_effect = wsgi.ConfigFilePortError()
-
-        self.assertEqual(
-            'bind_port wasn\'t properly set in the config file. '
-            'It must be explicitly set to a valid port number.',
-            self.strategy.do_bind_ports())
-
     def test_no_fork_sock(self):
-        self.strategy.do_bind_ports()
         self.assertIsNone(self.strategy.no_fork_sock())
 
         self.conf['workers'] = 0
         self.strategy = wsgi.WorkersStrategy(self.conf, self.logger)
-        self.strategy.do_bind_ports()
 
-        self.assertEqual('abc', self.strategy.no_fork_sock())
+        self.assertIs(self.mock_socket, self.strategy.no_fork_sock())
 
     def test_new_worker_socks(self):
-        self.strategy.do_bind_ports()
         pid = 88
         sock_count = 0
         for s, i in self.strategy.new_worker_socks():
-            self.assertEqual('abc', s)
+            self.assertEqual(self.mock_socket, s)
             self.assertIsNone(i)  # unused for this strategy
             self.strategy.register_worker_start(s, 'unused', pid)
             pid += 1
@@ -1605,7 +1624,7 @@ class TestWorkersStrategy(unittest.TestC
         ], self.logger.get_lines_for_level('error'))
 
         for s, i in self.strategy.new_worker_socks():
-            self.assertEqual('abc', s)
+            self.assertEqual(self.mock_socket, s)
             self.assertIsNone(i)  # unused for this strategy
             self.strategy.register_worker_start(s, 'unused', pid)
             pid += 1
@@ -1619,23 +1638,23 @@ class TestWorkersStrategy(unittest.TestC
         ], self.logger.get_lines_for_level('notice'))
 
     def test_shutdown_sockets(self):
-        self.mock_get_socket.return_value = mock.MagicMock()
-        self.strategy.do_bind_ports()
+        self.mock_get_socket.side_effect = sockets = [
+            mock.MagicMock(), mock.MagicMock()]
+
+        pid = 88
+        for s, i in self.strategy.new_worker_socks():
+            self.strategy.register_worker_start(s, 'unused', pid)
+            pid += 1
+
         with mock.patch('swift.common.wsgi.greenio') as mock_greenio:
             self.strategy.shutdown_sockets()
         self.assertEqual([
-            mock.call.shutdown_safe(self.mock_get_socket.return_value),
+            mock.call.shutdown_safe(s)
+            for s in sockets
         ], mock_greenio.mock_calls)
-        if six.PY2:
-            self.assertEqual([
-                mock.call.__nonzero__(),
-                mock.call.close(),
-            ], self.mock_get_socket.return_value.mock_calls)
-        else:
-            self.assertEqual([
-                mock.call.__bool__(),
-                mock.call.close(),
-            ], self.mock_get_socket.return_value.mock_calls)
+        self.assertEqual([
+            [mock.call.close()] for _ in range(2)
+        ], [s.mock_calls for s in sockets])
 
     def test_log_sock_exit(self):
         self.strategy.log_sock_exit('blahblah', 'blahblah')
diff -pruN 2.25.0-3/test/unit/container/test_backend.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/container/test_backend.py
--- 2.25.0-3/test/unit/container/test_backend.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/container/test_backend.py	2020-09-15 21:13:36.000000000 +0000
@@ -26,8 +26,10 @@ import random
 from collections import defaultdict
 from contextlib import contextmanager
 import sqlite3
+import string
 import pickle
 import json
+import itertools
 
 import six
 
@@ -441,6 +443,7 @@ class TestContainerBroker(unittest.TestC
             self.assertTrue(broker_to_test.empty())
 
         self.assertTrue(broker.empty())
+        self.assertFalse(broker.is_root_container())
         check_object_counted(broker, broker)
 
         # own shard range is not considered for object count
@@ -497,6 +500,20 @@ class TestContainerBroker(unittest.TestC
         own_sr.update_meta(3, 4, meta_timestamp=next(self.ts))
         broker.merge_shard_ranges([own_sr])
         self.assertTrue(broker.empty())
+        self.assertFalse(broker.is_deleted())
+        self.assertFalse(broker.is_root_container())
+
+        # sharder won't call delete_db() unless own_shard_range is deleted
+        own_sr.deleted = True
+        own_sr.timestamp = next(self.ts)
+        broker.merge_shard_ranges([own_sr])
+        broker.delete_db(next(self.ts).internal)
+
+        # Get a fresh broker, with instance cache unset
+        broker = ContainerBroker(db_path, account='.shards_a', container='cc')
+        self.assertTrue(broker.empty())
+        self.assertTrue(broker.is_deleted())
+        self.assertFalse(broker.is_root_container())
 
     def test_reclaim(self):
         broker = ContainerBroker(':memory:', account='test_account',
@@ -558,6 +575,98 @@ class TestContainerBroker(unittest.TestC
         broker.reclaim(Timestamp.now().internal, time())
         broker.delete_db(Timestamp.now().internal)
 
+    def test_batch_reclaim(self):
+        num_of_objects = 60
+        obj_specs = []
+        now = time()
+        top_of_the_minute = now - (now % 60)
+        c = itertools.cycle([True, False])
+        for m, is_deleted in six.moves.zip(range(num_of_objects), c):
+            offset = top_of_the_minute - (m * 60)
+            obj_specs.append((Timestamp(offset), is_deleted))
+        random.seed(now)
+        random.shuffle(obj_specs)
+        policy_indexes = list(p.idx for p in POLICIES)
+        broker = ContainerBroker(':memory:', account='test_account',
+                                 container='test_container')
+        broker.initialize(Timestamp('1').internal, 0)
+        for i, obj_spec in enumerate(obj_specs):
+            # with object12 before object2 and shuffled ts.internal we
+            # shouldn't be able to accidently rely on any implicit ordering
+            obj_name = 'object%s' % i
+            pidx = random.choice(policy_indexes)
+            ts, is_deleted = obj_spec
+            if is_deleted:
+                broker.delete_object(obj_name, ts.internal, pidx)
+            else:
+                broker.put_object(obj_name, ts.internal, 0, 'text/plain',
+                                  'etag', storage_policy_index=pidx)
+
+        def count_reclaimable(conn, reclaim_age):
+            return conn.execute(
+                "SELECT count(*) FROM object "
+                "WHERE deleted = 1 AND created_at < ?", (reclaim_age,)
+            ).fetchone()[0]
+
+        # This is intended to divide the set of timestamps exactly in half
+        # regardless of the value of now
+        reclaim_age = top_of_the_minute + 1 - (num_of_objects / 2 * 60)
+        with broker.get() as conn:
+            self.assertEqual(count_reclaimable(conn, reclaim_age),
+                             num_of_objects / 4)
+
+        orig__reclaim = broker._reclaim
+        trace = []
+
+        def tracing_reclaim(conn, age_timestamp, marker):
+            trace.append((age_timestamp, marker,
+                          count_reclaimable(conn, age_timestamp)))
+            return orig__reclaim(conn, age_timestamp, marker)
+
+        with mock.patch.object(broker, '_reclaim', new=tracing_reclaim), \
+                mock.patch('swift.common.db.RECLAIM_PAGE_SIZE', 10):
+            broker.reclaim(reclaim_age, reclaim_age)
+
+        with broker.get() as conn:
+            self.assertEqual(count_reclaimable(conn, reclaim_age), 0)
+        self.assertEqual(3, len(trace), trace)
+        self.assertEqual([age for age, marker, reclaimable in trace],
+                         [reclaim_age] * 3)
+        # markers are in-order
+        self.assertLess(trace[0][1], trace[1][1])
+        self.assertLess(trace[1][1], trace[2][1])
+        # reclaimable count gradually decreases
+        # generally, count1 > count2 > count3, but because of the randomness
+        # we may occassionally have count1 == count2 or count2 == count3
+        self.assertGreaterEqual(trace[0][2], trace[1][2])
+        self.assertGreaterEqual(trace[1][2], trace[2][2])
+        # technically, this might happen occasionally, but *really* rarely
+        self.assertTrue(trace[0][2] > trace[1][2] or
+                        trace[1][2] > trace[2][2])
+
+    def test_reclaim_with_duplicate_names(self):
+        broker = ContainerBroker(':memory:', account='test_account',
+                                 container='test_container')
+        broker.initialize(Timestamp('1').internal, 0)
+        now = time()
+        ages_ago = Timestamp(now - (3 * 7 * 24 * 60 * 60))
+        for i in range(10):
+            for spidx in range(10):
+                obj_name = 'object%s' % i
+                broker.delete_object(obj_name, ages_ago.internal, spidx)
+        reclaim_age = now - (2 * 7 * 24 * 60 * 60)
+        with broker.get() as conn:
+            self.assertEqual(conn.execute(
+                "SELECT count(*) FROM object "
+                "WHERE created_at < ?", (reclaim_age,)
+            ).fetchone()[0], 100)
+        with mock.patch('swift.common.db.RECLAIM_PAGE_SIZE', 10):
+            broker.reclaim(reclaim_age, reclaim_age)
+        with broker.get() as conn:
+            self.assertEqual(conn.execute(
+                "SELECT count(*) FROM object "
+            ).fetchone()[0], 0)
+
     @with_tempdir
     def test_reclaim_deadlock(self, tempdir):
         db_path = os.path.join(
@@ -642,10 +751,12 @@ class TestContainerBroker(unittest.TestC
         self.assertEqual(info['put_timestamp'], start.internal)
         self.assertTrue(Timestamp(info['created_at']) >= start)
         self.assertEqual(info['delete_timestamp'], '0')
-        if self.__class__ in (TestContainerBrokerBeforeMetadata,
-                              TestContainerBrokerBeforeXSync,
-                              TestContainerBrokerBeforeSPI,
-                              TestContainerBrokerBeforeShardRanges):
+        if self.__class__ in (
+                TestContainerBrokerBeforeMetadata,
+                TestContainerBrokerBeforeXSync,
+                TestContainerBrokerBeforeSPI,
+                TestContainerBrokerBeforeShardRanges,
+                TestContainerBrokerBeforeShardRangeReportedColumn):
             self.assertEqual(info['status_changed_at'], '0')
         else:
             self.assertEqual(info['status_changed_at'],
@@ -932,6 +1043,8 @@ class TestContainerBroker(unittest.TestC
                 "SELECT object_count FROM shard_range").fetchone()[0], 0)
             self.assertEqual(conn.execute(
                 "SELECT bytes_used FROM shard_range").fetchone()[0], 0)
+            self.assertEqual(conn.execute(
+                "SELECT reported FROM shard_range").fetchone()[0], 0)
 
         # Reput same event
         broker.merge_shard_ranges(
@@ -957,6 +1070,64 @@ class TestContainerBroker(unittest.TestC
                 "SELECT object_count FROM shard_range").fetchone()[0], 0)
             self.assertEqual(conn.execute(
                 "SELECT bytes_used FROM shard_range").fetchone()[0], 0)
+            self.assertEqual(conn.execute(
+                "SELECT reported FROM shard_range").fetchone()[0], 0)
+
+        # Mark it as reported
+        broker.merge_shard_ranges(
+            ShardRange('"a/{<shardrange \'&\' name>}"', timestamp,
+                       'low', 'up', meta_timestamp=meta_timestamp,
+                       reported=True))
+        with broker.get() as conn:
+            self.assertEqual(conn.execute(
+                "SELECT name FROM shard_range").fetchone()[0],
+                '"a/{<shardrange \'&\' name>}"')
+            self.assertEqual(conn.execute(
+                "SELECT timestamp FROM shard_range").fetchone()[0],
+                timestamp)
+            self.assertEqual(conn.execute(
+                "SELECT meta_timestamp FROM shard_range").fetchone()[0],
+                meta_timestamp)
+            self.assertEqual(conn.execute(
+                "SELECT lower FROM shard_range").fetchone()[0], 'low')
+            self.assertEqual(conn.execute(
+                "SELECT upper FROM shard_range").fetchone()[0], 'up')
+            self.assertEqual(conn.execute(
+                "SELECT deleted FROM shard_range").fetchone()[0], 0)
+            self.assertEqual(conn.execute(
+                "SELECT object_count FROM shard_range").fetchone()[0], 0)
+            self.assertEqual(conn.execute(
+                "SELECT bytes_used FROM shard_range").fetchone()[0], 0)
+            self.assertEqual(conn.execute(
+                "SELECT reported FROM shard_range").fetchone()[0], 1)
+
+        # Reporting latches it
+        broker.merge_shard_ranges(
+            ShardRange('"a/{<shardrange \'&\' name>}"', timestamp,
+                       'low', 'up', meta_timestamp=meta_timestamp,
+                       reported=False))
+        with broker.get() as conn:
+            self.assertEqual(conn.execute(
+                "SELECT name FROM shard_range").fetchone()[0],
+                '"a/{<shardrange \'&\' name>}"')
+            self.assertEqual(conn.execute(
+                "SELECT timestamp FROM shard_range").fetchone()[0],
+                timestamp)
+            self.assertEqual(conn.execute(
+                "SELECT meta_timestamp FROM shard_range").fetchone()[0],
+                meta_timestamp)
+            self.assertEqual(conn.execute(
+                "SELECT lower FROM shard_range").fetchone()[0], 'low')
+            self.assertEqual(conn.execute(
+                "SELECT upper FROM shard_range").fetchone()[0], 'up')
+            self.assertEqual(conn.execute(
+                "SELECT deleted FROM shard_range").fetchone()[0], 0)
+            self.assertEqual(conn.execute(
+                "SELECT object_count FROM shard_range").fetchone()[0], 0)
+            self.assertEqual(conn.execute(
+                "SELECT bytes_used FROM shard_range").fetchone()[0], 0)
+            self.assertEqual(conn.execute(
+                "SELECT reported FROM shard_range").fetchone()[0], 1)
 
         # Put new event
         timestamp = next(self.ts).internal
@@ -984,11 +1155,14 @@ class TestContainerBroker(unittest.TestC
                 "SELECT object_count FROM shard_range").fetchone()[0], 1)
             self.assertEqual(conn.execute(
                 "SELECT bytes_used FROM shard_range").fetchone()[0], 2)
+            self.assertEqual(conn.execute(
+                "SELECT reported FROM shard_range").fetchone()[0], 0)
 
         # Put old event
         broker.merge_shard_ranges(
             ShardRange('"a/{<shardrange \'&\' name>}"', old_put_timestamp,
-                       'lower', 'upper', 1, 2, meta_timestamp=meta_timestamp))
+                       'lower', 'upper', 1, 2, meta_timestamp=meta_timestamp,
+                       reported=True))
         with broker.get() as conn:
             self.assertEqual(conn.execute(
                 "SELECT name FROM shard_range").fetchone()[0],
@@ -1009,6 +1183,8 @@ class TestContainerBroker(unittest.TestC
                 "SELECT object_count FROM shard_range").fetchone()[0], 1)
             self.assertEqual(conn.execute(
                 "SELECT bytes_used FROM shard_range").fetchone()[0], 2)
+            self.assertEqual(conn.execute(
+                "SELECT reported FROM shard_range").fetchone()[0], 0)
 
         # Put old delete event
         broker.merge_shard_ranges(
@@ -1885,10 +2061,12 @@ class TestContainerBroker(unittest.TestC
         self.assertEqual(info['hash'], '00000000000000000000000000000000')
         self.assertEqual(info['put_timestamp'], Timestamp(1).internal)
         self.assertEqual(info['delete_timestamp'], '0')
-        if self.__class__ in (TestContainerBrokerBeforeMetadata,
-                              TestContainerBrokerBeforeXSync,
-                              TestContainerBrokerBeforeSPI,
-                              TestContainerBrokerBeforeShardRanges):
+        if self.__class__ in (
+                TestContainerBrokerBeforeMetadata,
+                TestContainerBrokerBeforeXSync,
+                TestContainerBrokerBeforeSPI,
+                TestContainerBrokerBeforeShardRanges,
+                TestContainerBrokerBeforeShardRangeReportedColumn):
             self.assertEqual(info['status_changed_at'], '0')
         else:
             self.assertEqual(info['status_changed_at'],
@@ -3182,10 +3360,12 @@ class TestContainerBroker(unittest.TestC
         self.assertEqual(0, info['storage_policy_index'])  # sanity check
         self.assertEqual(0, info['object_count'])
         self.assertEqual(0, info['bytes_used'])
-        if self.__class__ in (TestContainerBrokerBeforeMetadata,
-                              TestContainerBrokerBeforeXSync,
-                              TestContainerBrokerBeforeSPI,
-                              TestContainerBrokerBeforeShardRanges):
+        if self.__class__ in (
+                TestContainerBrokerBeforeMetadata,
+                TestContainerBrokerBeforeXSync,
+                TestContainerBrokerBeforeSPI,
+                TestContainerBrokerBeforeShardRanges,
+                TestContainerBrokerBeforeShardRangeReportedColumn):
             self.assertEqual(info['status_changed_at'], '0')
         else:
             self.assertEqual(timestamp.internal, info['status_changed_at'])
@@ -3749,6 +3929,45 @@ class TestContainerBroker(unittest.TestC
         self.assertFalse(actual)
 
     @with_tempdir
+    def test_overloap_shard_range_order(self, tempdir):
+        db_path = os.path.join(tempdir, 'container.db')
+        broker = ContainerBroker(db_path, account='a', container='c')
+        broker.initialize(next(self.ts).internal, 0)
+
+        epoch0 = next(self.ts)
+        epoch1 = next(self.ts)
+        shard_ranges = [
+            ShardRange('.shard_a/shard_%d-%d' % (e, s), epoch, l, u,
+                       state=ShardRange.ACTIVE)
+            for s, (l, u) in enumerate(zip(string.ascii_letters[:7],
+                                           string.ascii_letters[1:]))
+            for e, epoch in enumerate((epoch0, epoch1))
+        ]
+
+        random.shuffle(shard_ranges)
+        for sr in shard_ranges:
+            broker.merge_shard_ranges([sr])
+
+        expected = [
+            '.shard_a/shard_0-0',
+            '.shard_a/shard_1-0',
+            '.shard_a/shard_0-1',
+            '.shard_a/shard_1-1',
+            '.shard_a/shard_0-2',
+            '.shard_a/shard_1-2',
+            '.shard_a/shard_0-3',
+            '.shard_a/shard_1-3',
+            '.shard_a/shard_0-4',
+            '.shard_a/shard_1-4',
+            '.shard_a/shard_0-5',
+            '.shard_a/shard_1-5',
+            '.shard_a/shard_0-6',
+            '.shard_a/shard_1-6',
+        ]
+        self.assertEqual(expected, [
+            sr.name for sr in broker.get_shard_ranges()])
+
+    @with_tempdir
     def test_get_shard_ranges_with_sharding_overlaps(self, tempdir):
         db_path = os.path.join(tempdir, 'container.db')
         broker = ContainerBroker(db_path, account='a', container='c')
@@ -5222,6 +5441,75 @@ class TestContainerBrokerBeforeShardRang
                             FROM shard_range''')
 
 
+def pre_reported_create_shard_range_table(self, conn):
+    """
+    Copied from ContainerBroker before the
+    reported column was added; used for testing with
+    TestContainerBrokerBeforeShardRangeReportedColumn.
+
+    Create a shard_range table with no 'reported' column.
+
+    :param conn: DB connection object
+    """
+    conn.execute("""
+        CREATE TABLE shard_range (
+            ROWID INTEGER PRIMARY KEY AUTOINCREMENT,
+            name TEXT,
+            timestamp TEXT,
+            lower TEXT,
+            upper TEXT,
+            object_count INTEGER DEFAULT 0,
+            bytes_used INTEGER DEFAULT 0,
+            meta_timestamp TEXT,
+            deleted INTEGER DEFAULT 0,
+            state INTEGER,
+            state_timestamp TEXT,
+            epoch TEXT
+        );
+    """)
+
+    conn.execute("""
+        CREATE TRIGGER shard_range_update BEFORE UPDATE ON shard_range
+        BEGIN
+            SELECT RAISE(FAIL, 'UPDATE not allowed; DELETE and INSERT');
+        END;
+    """)
+
+
+class TestContainerBrokerBeforeShardRangeReportedColumn(
+        ContainerBrokerMigrationMixin, TestContainerBroker):
+    """
+    Tests for ContainerBroker against databases created
+    before the shard_ranges table was added.
+    """
+    # *grumble grumble* This should include container_info/policy_stat :-/
+    expected_db_tables = {'outgoing_sync', 'incoming_sync', 'object',
+                          'sqlite_sequence', 'container_stat', 'shard_range'}
+
+    def setUp(self):
+        super(TestContainerBrokerBeforeShardRangeReportedColumn,
+              self).setUp()
+        ContainerBroker.create_shard_range_table = \
+            pre_reported_create_shard_range_table
+
+        broker = ContainerBroker(':memory:', account='a', container='c')
+        broker.initialize(Timestamp('1').internal, 0)
+        with self.assertRaises(sqlite3.DatabaseError) as raised, \
+                broker.get() as conn:
+            conn.execute('''SELECT reported
+                            FROM shard_range''')
+        self.assertIn('no such column: reported', str(raised.exception))
+
+    def tearDown(self):
+        super(TestContainerBrokerBeforeShardRangeReportedColumn,
+              self).tearDown()
+        broker = ContainerBroker(':memory:', account='a', container='c')
+        broker.initialize(Timestamp('1').internal, 0)
+        with broker.get() as conn:
+            conn.execute('''SELECT reported
+                            FROM shard_range''')
+
+
 class TestUpdateNewItemFromExisting(unittest.TestCase):
     # TODO: add test scenarios that have swift_bytes in content_type
     t0 = '1234567890.00000'
diff -pruN 2.25.0-3/test/unit/container/test_reconciler.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/container/test_reconciler.py
--- 2.25.0-3/test/unit/container/test_reconciler.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/container/test_reconciler.py	2020-09-15 21:13:36.000000000 +0000
@@ -95,6 +95,7 @@ class FakeInternalClient(reconciler.Inte
         self.app = FakeStoragePolicySwift()
         self.user_agent = 'fake-internal-client'
         self.request_tries = 1
+        self.use_replication_network = True
         self.parse(listings)
 
     def parse(self, listings):
diff -pruN 2.25.0-3/test/unit/container/test_server.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/container/test_server.py
--- 2.25.0-3/test/unit/container/test_server.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/container/test_server.py	2020-09-15 21:13:36.000000000 +0000
@@ -2380,15 +2380,17 @@ class TestContainerController(unittest.T
                    'X-Container-Sysmeta-Test': 'set',
                    'X-Container-Meta-Test': 'persisted'}
 
-        # PUT shard range to non-existent container with non-autocreate prefix
-        req = Request.blank('/sda1/p/a/c', method='PUT', headers=headers,
-                            body=json.dumps([dict(shard_range)]))
+        # PUT shard range to non-existent container without autocreate flag
+        req = Request.blank(
+            '/sda1/p/.shards_a/shard_c', method='PUT', headers=headers,
+            body=json.dumps([dict(shard_range)]))
         resp = req.get_response(self.controller)
         self.assertEqual(404, resp.status_int)
 
-        # PUT shard range to non-existent container with autocreate prefix,
+        # PUT shard range to non-existent container with autocreate flag,
         # missing storage policy
         headers['X-Timestamp'] = next(ts_iter).internal
+        headers['X-Backend-Auto-Create'] = 't'
         req = Request.blank(
             '/sda1/p/.shards_a/shard_c', method='PUT', headers=headers,
             body=json.dumps([dict(shard_range)]))
@@ -2397,7 +2399,7 @@ class TestContainerController(unittest.T
         self.assertIn(b'X-Backend-Storage-Policy-Index header is required',
                       resp.body)
 
-        # PUT shard range to non-existent container with autocreate prefix
+        # PUT shard range to non-existent container with autocreate flag
         headers['X-Timestamp'] = next(ts_iter).internal
         policy_index = random.choice(POLICIES).idx
         headers['X-Backend-Storage-Policy-Index'] = str(policy_index)
@@ -2407,7 +2409,7 @@ class TestContainerController(unittest.T
         resp = req.get_response(self.controller)
         self.assertEqual(201, resp.status_int)
 
-        # repeat PUT of shard range to autocreated container - 204 response
+        # repeat PUT of shard range to autocreated container - 202 response
         headers['X-Timestamp'] = next(ts_iter).internal
         headers.pop('X-Backend-Storage-Policy-Index')  # no longer required
         req = Request.blank(
@@ -2416,7 +2418,7 @@ class TestContainerController(unittest.T
         resp = req.get_response(self.controller)
         self.assertEqual(202, resp.status_int)
 
-        # regular PUT to autocreated container - 204 response
+        # regular PUT to autocreated container - 202 response
         headers['X-Timestamp'] = next(ts_iter).internal
         req = Request.blank(
             '/sda1/p/.shards_a/shard_c', method='PUT',
@@ -4649,61 +4651,53 @@ class TestContainerController(unittest.T
                              "%d on param %s" % (resp.status_int, param))
 
     def test_put_auto_create(self):
-        headers = {'x-timestamp': Timestamp(1).internal,
-                   'x-size': '0',
-                   'x-content-type': 'text/plain',
-                   'x-etag': 'd41d8cd98f00b204e9800998ecf8427e'}
-
-        req = Request.blank('/sda1/p/a/c/o',
-                            environ={'REQUEST_METHOD': 'PUT'},
-                            headers=dict(headers))
-        resp = req.get_response(self.controller)
-        self.assertEqual(resp.status_int, 404)
-
-        req = Request.blank('/sda1/p/.a/c/o',
-                            environ={'REQUEST_METHOD': 'PUT'},
-                            headers=dict(headers))
-        resp = req.get_response(self.controller)
-        self.assertEqual(resp.status_int, 201)
-
-        req = Request.blank('/sda1/p/a/.c/o',
-                            environ={'REQUEST_METHOD': 'PUT'},
-                            headers=dict(headers))
-        resp = req.get_response(self.controller)
-        self.assertEqual(resp.status_int, 404)
+        def do_test(expected_status, path, extra_headers=None, body=None):
+            headers = {'x-timestamp': Timestamp(1).internal,
+                       'x-size': '0',
+                       'x-content-type': 'text/plain',
+                       'x-etag': 'd41d8cd98f00b204e9800998ecf8427e'}
+            if extra_headers:
+                headers.update(extra_headers)
+            req = Request.blank('/sda1/p/' + path,
+                                environ={'REQUEST_METHOD': 'PUT'},
+                                headers=headers, body=body)
+            resp = req.get_response(self.controller)
+            self.assertEqual(resp.status_int, expected_status)
 
-        req = Request.blank('/sda1/p/a/c/.o',
-                            environ={'REQUEST_METHOD': 'PUT'},
-                            headers=dict(headers))
-        resp = req.get_response(self.controller)
-        self.assertEqual(resp.status_int, 404)
+        do_test(404, 'a/c/o')
+        do_test(404, '.a/c/o', {'X-Backend-Auto-Create': 'no'})
+        do_test(201, '.a/c/o')
+        do_test(404, 'a/.c/o')
+        do_test(404, 'a/c/.o')
+        do_test(201, 'a/c/o', {'X-Backend-Auto-Create': 'yes'})
+
+        do_test(404, '.shards_a/c/o')
+        create_shard_headers = {
+            'X-Backend-Record-Type': 'shard',
+            'X-Backend-Storage-Policy-Index': '0'}
+        do_test(404, '.shards_a/c', create_shard_headers, '[]')
+        create_shard_headers['X-Backend-Auto-Create'] = 't'
+        do_test(201, '.shards_a/c', create_shard_headers, '[]')
 
     def test_delete_auto_create(self):
-        headers = {'x-timestamp': Timestamp(1).internal}
-
-        req = Request.blank('/sda1/p/a/c/o',
-                            environ={'REQUEST_METHOD': 'DELETE'},
-                            headers=dict(headers))
-        resp = req.get_response(self.controller)
-        self.assertEqual(resp.status_int, 404)
-
-        req = Request.blank('/sda1/p/.a/c/o',
-                            environ={'REQUEST_METHOD': 'DELETE'},
-                            headers=dict(headers))
-        resp = req.get_response(self.controller)
-        self.assertEqual(resp.status_int, 204)
-
-        req = Request.blank('/sda1/p/a/.c/o',
-                            environ={'REQUEST_METHOD': 'DELETE'},
-                            headers=dict(headers))
-        resp = req.get_response(self.controller)
-        self.assertEqual(resp.status_int, 404)
+        def do_test(expected_status, path, extra_headers=None):
+            headers = {'x-timestamp': Timestamp(1).internal}
+            if extra_headers:
+                headers.update(extra_headers)
+            req = Request.blank('/sda1/p/' + path,
+                                environ={'REQUEST_METHOD': 'DELETE'},
+                                headers=headers)
+            resp = req.get_response(self.controller)
+            self.assertEqual(resp.status_int, expected_status)
 
-        req = Request.blank('/sda1/p/a/.c/.o',
-                            environ={'REQUEST_METHOD': 'DELETE'},
-                            headers=dict(headers))
-        resp = req.get_response(self.controller)
-        self.assertEqual(resp.status_int, 404)
+        do_test(404, 'a/c/o')
+        do_test(404, '.a/c/o', {'X-Backend-Auto-Create': 'false'})
+        do_test(204, '.a/c/o')
+        do_test(404, 'a/.c/o')
+        do_test(404, 'a/.c/.o')
+        do_test(404, '.shards_a/c/o')
+        do_test(204, 'a/c/o', {'X-Backend-Auto-Create': 'true'})
+        do_test(204, '.shards_a/c/o', {'X-Backend-Auto-Create': 'true'})
 
     def test_content_type_on_HEAD(self):
         Request.blank('/sda1/p/a/o',
@@ -4825,7 +4819,7 @@ class TestContainerController(unittest.T
         # Test replication_server flag was set from configuration file.
         container_controller = container_server.ContainerController
         conf = {'devices': self.testdir, 'mount_check': 'false'}
-        self.assertIsNone(container_controller(conf).replication_server)
+        self.assertTrue(container_controller(conf).replication_server)
         for val in [True, '1', 'True', 'true']:
             conf['replication_server'] = val
             self.assertTrue(container_controller(conf).replication_server)
@@ -4923,7 +4917,7 @@ class TestContainerController(unittest.T
             self.assertEqual(response, answer)
             self.assertEqual(outbuf.getvalue()[:4], '405 ')
 
-    def test_call_incorrect_replication_method(self):
+    def test_replication_server_call_all_methods(self):
         inbuf = BytesIO()
         errbuf = StringIO()
         outbuf = StringIO()
@@ -4935,7 +4929,7 @@ class TestContainerController(unittest.T
             """Sends args to outbuf"""
             outbuf.writelines(status)
 
-        obj_methods = ['DELETE', 'PUT', 'HEAD', 'GET', 'POST', 'OPTIONS']
+        obj_methods = ['PUT', 'HEAD', 'GET', 'POST', 'DELETE', 'OPTIONS']
         for method in obj_methods:
             env = {'REQUEST_METHOD': method,
                    'SCRIPT_NAME': '',
@@ -4943,6 +4937,7 @@ class TestContainerController(unittest.T
                    'SERVER_NAME': '127.0.0.1',
                    'SERVER_PORT': '8080',
                    'SERVER_PROTOCOL': 'HTTP/1.0',
+                   'HTTP_X_TIMESTAMP': next(self.ts).internal,
                    'CONTENT_LENGTH': '0',
                    'wsgi.version': (1, 0),
                    'wsgi.url_scheme': 'http',
@@ -4953,7 +4948,7 @@ class TestContainerController(unittest.T
                    'wsgi.run_once': False}
             self.controller(env, start_response)
             self.assertEqual(errbuf.getvalue(), '')
-            self.assertEqual(outbuf.getvalue()[:4], '405 ')
+            self.assertIn(outbuf.getvalue()[:4], ('200 ', '201 ', '204 '))
 
     def test__call__raise_timeout(self):
         inbuf = WsgiBytesIO()
diff -pruN 2.25.0-3/test/unit/container/test_sharder.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/container/test_sharder.py
--- 2.25.0-3/test/unit/container/test_sharder.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/container/test_sharder.py	2020-09-15 21:13:36.000000000 +0000
@@ -171,7 +171,8 @@ class TestSharder(BaseTestSharder):
             'container-sharder', sharder.logger.logger.name)
         mock_ic.assert_called_once_with(
             '/etc/swift/internal-client.conf', 'Swift Container Sharder', 3,
-            allow_modify_pipeline=False)
+            allow_modify_pipeline=False,
+            use_replication_network=True)
 
         conf = {
             'mount_check': False, 'bind_ip': '10.11.12.13', 'bind_port': 62010,
@@ -221,7 +222,8 @@ class TestSharder(BaseTestSharder):
         sharder, mock_ic = do_test(conf, expected)
         mock_ic.assert_called_once_with(
             '/etc/swift/my-sharder-ic.conf', 'Swift Container Sharder', 2,
-            allow_modify_pipeline=False)
+            allow_modify_pipeline=False,
+            use_replication_network=True)
         self.assertEqual(self.logger.get_lines_for_level('warning'), [
             'Option auto_create_account_prefix is deprecated. '
             'Configure auto_create_account_prefix under the '
@@ -731,11 +733,12 @@ class TestSharder(BaseTestSharder):
         self.logger.clear()
         conf = conf or {}
         conf['devices'] = self.tempdir
+        fake_ring = FakeRing(replicas=replicas, separate_replication=True)
         with mock.patch(
                 'swift.container.sharder.internal_client.InternalClient'):
             with mock.patch(
                     'swift.common.db_replicator.ring.Ring',
-                    lambda *args, **kwargs: FakeRing(replicas=replicas)):
+                    return_value=fake_ring):
                 sharder = ContainerSharder(conf, logger=self.logger)
                 sharder._local_device_ids = {0, 1, 2}
                 sharder._replicate_object = mock.MagicMock(
@@ -4185,19 +4188,32 @@ class TestSharder(BaseTestSharder):
 
     def check_shard_ranges_sent(self, broker, expected_sent):
         bodies = []
+        servers = []
 
         def capture_send(conn, data):
             bodies.append(data)
 
+        def capture_connect(host, port, *a, **kw):
+            servers.append((host, port))
+
+        self.assertFalse(broker.get_own_shard_range().reported)  # sanity
         with self._mock_sharder() as sharder:
             with mocked_http_conn(204, 204, 204,
-                                  give_send=capture_send) as mock_conn:
+                                  give_send=capture_send,
+                                  give_connect=capture_connect) as mock_conn:
                 sharder._update_root_container(broker)
 
         for req in mock_conn.requests:
             self.assertEqual('PUT', req['method'])
         self.assertEqual([expected_sent] * 3,
                          [json.loads(b) for b in bodies])
+        self.assertEqual(servers, [
+            # NB: replication interfaces
+            ('10.0.1.0', 1100),
+            ('10.0.1.1', 1101),
+            ('10.0.1.2', 1102),
+        ])
+        self.assertTrue(broker.get_own_shard_range().reported)
 
     def test_update_root_container_own_range(self):
         broker = self._make_broker()
@@ -4230,6 +4246,32 @@ class TestSharder(BaseTestSharder):
             with annotate_failure(state):
                 check_only_own_shard_range_sent(state)
 
+    def test_update_root_container_already_reported(self):
+        broker = self._make_broker()
+
+        def check_already_reported_not_sent(state):
+            own_shard_range = broker.get_own_shard_range()
+
+            own_shard_range.reported = True
+            self.assertTrue(own_shard_range.update_state(
+                state, state_timestamp=next(self.ts_iter)))
+            # Check that updating state clears the flag
+            self.assertFalse(own_shard_range.reported)
+
+            # If we claim to have already updated...
+            own_shard_range.reported = True
+            broker.merge_shard_ranges([own_shard_range])
+
+            # ... then there's nothing to send
+            with self._mock_sharder() as sharder:
+                with mocked_http_conn() as mock_conn:
+                    sharder._update_root_container(broker)
+            self.assertFalse(mock_conn.requests)
+
+        for state in ShardRange.STATES:
+            with annotate_failure(state):
+                check_already_reported_not_sent(state)
+
     def test_update_root_container_all_ranges(self):
         broker = self._make_broker()
         other_shard_ranges = self._make_shard_ranges((('', 'h'), ('h', '')))
@@ -4598,6 +4640,7 @@ class TestSharder(BaseTestSharder):
         own_shard_range.deleted = 1
         own_shard_range.timestamp = Timestamp.now()
         broker.merge_shard_ranges([own_shard_range])
+        del shard_ranges[:]  # root responds with no shard ranges
         assert_ok()
         self.assertTrue(broker.is_deleted())
 
diff -pruN 2.25.0-3/test/unit/__init__.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/__init__.py
--- 2.25.0-3/test/unit/__init__.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/__init__.py	2020-09-15 21:13:36.000000000 +0000
@@ -215,12 +215,13 @@ class PatchPolicies(object):
 class FakeRing(Ring):
 
     def __init__(self, replicas=3, max_more_nodes=0, part_power=0,
-                 base_port=1000):
+                 base_port=1000, separate_replication=False):
         self.serialized_path = '/foo/bar/object.ring.gz'
         self._base_port = base_port
         self.max_more_nodes = max_more_nodes
         self._part_shift = 32 - part_power
         self._init_device_char()
+        self.separate_replication = separate_replication
         # 9 total nodes (6 more past the initial 3) is the cap, no matter if
         # this is set higher, or R^2 for R replicas
         self.set_replicas(replicas)
@@ -256,11 +257,16 @@ class FakeRing(Ring):
         for x in range(self.replicas):
             ip = '10.0.0.%s' % x
             port = self._base_port + x
+            if self.separate_replication:
+                repl_ip = '10.0.1.%s' % x
+                repl_port = port + 100
+            else:
+                repl_ip, repl_port = ip, port
             dev = {
                 'ip': ip,
-                'replication_ip': ip,
+                'replication_ip': repl_ip,
                 'port': port,
-                'replication_port': port,
+                'replication_port': repl_port,
                 'device': self.device_char,
                 'zone': x % 3,
                 'region': x % 2,
@@ -278,10 +284,17 @@ class FakeRing(Ring):
     def get_more_nodes(self, part):
         index_counter = itertools.count()
         for x in range(self.replicas, (self.replicas + self.max_more_nodes)):
-            yield {'ip': '10.0.0.%s' % x,
-                   'replication_ip': '10.0.0.%s' % x,
-                   'port': self._base_port + x,
-                   'replication_port': self._base_port + x,
+            ip = '10.0.0.%s' % x
+            port = self._base_port + x
+            if self.separate_replication:
+                repl_ip = '10.0.1.%s' % x
+                repl_port = port + 100
+            else:
+                repl_ip, repl_port = ip, port
+            yield {'ip': ip,
+                   'replication_ip': repl_ip,
+                   'port': port,
+                   'replication_port': repl_port,
                    'device': 'sda',
                    'zone': x % 3,
                    'region': x % 2,
@@ -1016,6 +1029,10 @@ def fake_http_connect(*code_iter, **kwar
         def getheader(self, name, default=None):
             return HeaderKeyDict(self.getheaders()).get(name, default)
 
+        def nuke_from_orbit(self):
+            # wrapped connections from buffered_http have this helper
+            self.close()
+
         def close(self):
             self.closed = True
 
@@ -1078,10 +1095,13 @@ def fake_http_connect(*code_iter, **kwar
             body = static_body or b''
         else:
             body = next(body_iter)
-        return FakeConn(status, etag, body=body, timestamp=timestamp,
+        conn = FakeConn(status, etag, body=body, timestamp=timestamp,
                         headers=headers, expect_headers=expect_headers,
                         connection_id=i, give_send=kwargs.get('give_send'),
                         give_expect=kwargs.get('give_expect'))
+        if 'capture_connections' in kwargs:
+            kwargs['capture_connections'].append(conn)
+        return conn
 
     connect.unexpected_requests = unexpected_requests
     connect.code_iter = code_iter
@@ -1092,6 +1112,7 @@ def fake_http_connect(*code_iter, **kwar
 @contextmanager
 def mocked_http_conn(*args, **kwargs):
     requests = []
+    responses = []
 
     def capture_requests(ip, port, method, path, headers, qs, ssl):
         if six.PY2 and not isinstance(ip, bytes):
@@ -1107,8 +1128,10 @@ def mocked_http_conn(*args, **kwargs):
         }
         requests.append(req)
     kwargs.setdefault('give_connect', capture_requests)
+    kwargs['capture_connections'] = responses
     fake_conn = fake_http_connect(*args, **kwargs)
     fake_conn.requests = requests
+    fake_conn.responses = responses
     with mocklib.patch('swift.common.bufferedhttp.http_connect_raw',
                        new=fake_conn):
         yield fake_conn
@@ -1172,6 +1195,10 @@ class StubResponse(object):
         fake_reason = ('Fake', 'This response is a lie.')
         self.reason = swob.RESPONSE_REASONS.get(status, fake_reason)[0]
 
+    def nuke_from_orbit(self):
+        if hasattr(self, 'swift_conn'):
+            self.swift_conn.close()
+
     def getheader(self, header_name, default=None):
         return self.headers.get(header_name, default)
 
@@ -1265,12 +1292,11 @@ def fake_ec_node_response(node_frags, po
     call_count = {}  # maps node index to get_response call count for node
 
     def _build_node_map(req, policy):
-        node_key = lambda n: (n['ip'], n['port'])
         part = utils.split_path(req['path'], 5, 5, True)[1]
         all_nodes.extend(policy.object_ring.get_part_nodes(part))
         all_nodes.extend(policy.object_ring.get_more_nodes(part))
         for i, node in enumerate(all_nodes):
-            node_map[node_key(node)] = i
+            node_map[(node['ip'], node['port'])] = i
             call_count[i] = 0
 
     # normalize node_frags to a list of fragments for each node even
diff -pruN 2.25.0-3/test/unit/obj/test_diskfile.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/obj/test_diskfile.py
--- 2.25.0-3/test/unit/obj/test_diskfile.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/obj/test_diskfile.py	2020-09-15 21:13:36.000000000 +0000
@@ -24,6 +24,7 @@ import mock
 import unittest
 import email
 import tempfile
+import threading
 import uuid
 import xattr
 import re
@@ -3705,6 +3706,91 @@ class DiskFileMixin(BaseDiskFileTestMixi
             # can close again
             writer.close()
 
+    def test_disk_file_concurrent_writes(self):
+        def threadA(df, events, errors):
+            try:
+                ts = self.ts()
+                with df.create() as writer:
+                    writer.write(b'dataA')
+                    writer.put({
+                        'X-Timestamp': ts.internal,
+                        'Content-Length': 5,
+                    })
+                    events[0].set()
+                    events[1].wait()
+                    writer.commit(ts)
+            except Exception as e:
+                errors.append(e)
+                raise
+
+        def threadB(df, events, errors):
+            try:
+                events[0].wait()
+                ts = self.ts()
+                with df.create() as writer:
+                    writer.write(b'dataB')
+                    writer.put({
+                        'X-Timestamp': ts.internal,
+                        'Content-Length': 5,
+                    })
+                    writer.commit(ts)
+                events[1].set()
+            except Exception as e:
+                errors.append(e)
+                raise
+
+        df = self._simple_get_diskfile()
+        events = [threading.Event(), threading.Event()]
+        errors = []
+
+        threads = [threading.Thread(target=tgt, args=(df, events, errors))
+                   for tgt in (threadA, threadB)]
+        for thread in threads:
+            thread.start()
+        for thread in threads:
+            thread.join()
+        self.assertFalse(errors)
+
+        with df.open(), open(df._data_file, 'rb') as fp:
+            self.assertEqual(b'dataB', fp.read())
+
+    def test_disk_file_concurrent_delete(self):
+        def threadA(df, events, errors):
+            try:
+                ts = self.ts()
+                with df.create() as writer:
+                    writer.write(b'dataA')
+                    writer.put({'X-Timestamp': ts.internal})
+                    events[0].set()
+                    events[1].wait()
+                    writer.commit(ts)
+            except Exception as e:
+                errors.append(e)
+                raise
+
+        def threadB(df, events, errors):
+            try:
+                events[0].wait()
+                df.delete(self.ts())
+                events[1].set()
+            except Exception as e:
+                errors.append(e)
+                raise
+
+        df = self._simple_get_diskfile()
+        events = [threading.Event(), threading.Event()]
+        errors = []
+
+        threads = [threading.Thread(target=tgt, args=(df, events, errors))
+                   for tgt in (threadA, threadB)]
+        for thread in threads:
+            thread.start()
+        for thread in threads:
+            thread.join()
+        self.assertFalse(errors)
+
+        self.assertRaises(DiskFileDeleted, df.open)
+
     def _get_open_disk_file(self, invalid_type=None, obj_name='o', fsize=1024,
                             csize=8, mark_deleted=False, prealloc=False,
                             ts=None, mount_check=False, extra_metadata=None,
diff -pruN 2.25.0-3/test/unit/obj/test_replicator.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/obj/test_replicator.py
--- 2.25.0-3/test/unit/obj/test_replicator.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/obj/test_replicator.py	2020-09-15 21:13:36.000000000 +0000
@@ -1919,7 +1919,7 @@ class TestObjectReplicator(unittest.Test
         # Check successful http_connection and exception with
         # incorrect pickle.loads(resp.read())
         resp.status = 200
-        resp.read.return_value = 'garbage'
+        resp.read.return_value = b'garbage'
         expect = 'Error syncing with node: %r: '
         for job in jobs:
             set_default(self)
@@ -1969,6 +1969,7 @@ class TestObjectReplicator(unittest.Test
         self.assertEqual(stats.suffix_sync, 2)
         self.assertEqual(stats.suffix_hash, 1)
         self.assertEqual(stats.suffix_count, 1)
+        self.assertEqual(stats.hashmatch, 0)
 
         # Efficient Replication Case
         set_default(self)
@@ -1989,6 +1990,7 @@ class TestObjectReplicator(unittest.Test
         self.assertEqual(stats.suffix_sync, 1)
         self.assertEqual(stats.suffix_hash, 1)
         self.assertEqual(stats.suffix_count, 1)
+        self.assertEqual(stats.hashmatch, 0)
 
         mock_http.reset_mock()
         self.logger.clear()
@@ -2015,6 +2017,39 @@ class TestObjectReplicator(unittest.Test
                                   '/a83', headers=self.headers))
         mock_http.assert_has_calls(reqs, any_order=True)
 
+    @mock.patch('swift.obj.replicator.tpool.execute')
+    @mock.patch('swift.obj.replicator.http_connect', autospec=True)
+    @mock.patch('swift.obj.replicator._do_listdir')
+    def test_update_local_hash_changes_during_replication(
+            self, mock_do_listdir, mock_http, mock_tpool_execute):
+        mock_http.return_value = answer = mock.MagicMock()
+        answer.getresponse.return_value = resp = mock.MagicMock()
+        resp.status = 200
+        resp.read.return_value = pickle.dumps({
+            'a83': 'c130a2c17ed45102aada0f4eee69494ff'})
+
+        self.replicator.sync = fake_sync = \
+            mock.MagicMock(return_value=(True, []))
+        local_job = [
+            job for job in self.replicator.collect_jobs()
+            if not job['delete']
+            and job['partition'] == '0' and int(job['policy']) == 0
+        ][0]
+
+        mock_tpool_execute.side_effect = [
+            (1, {'a83': 'ba47fd314242ec8c7efb91f5d57336e4'}),
+            (1, {'a83': 'c130a2c17ed45102aada0f4eee69494ff'}),
+        ]
+        self.replicator.update(local_job)
+        self.assertEqual(fake_sync.call_count, 0)
+        self.assertEqual(mock_http.call_count, 2)
+        stats = self.replicator.total_stats
+        self.assertEqual(stats.attempted, 1)
+        self.assertEqual(stats.suffix_sync, 0)
+        self.assertEqual(stats.suffix_hash, 1)
+        self.assertEqual(stats.suffix_count, 1)
+        self.assertEqual(stats.hashmatch, 2)
+
     def test_rsync_compress_different_region(self):
         self.assertEqual(self.replicator.sync_method, self.replicator.rsync)
         jobs = self.replicator.collect_jobs()
diff -pruN 2.25.0-3/test/unit/obj/test_server.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/obj/test_server.py
--- 2.25.0-3/test/unit/obj/test_server.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/obj/test_server.py	2020-09-15 21:13:36.000000000 +0000
@@ -3666,10 +3666,8 @@ class TestObjectController(unittest.Test
 
     def _create_ondisk_fragments(self, policy):
         # Create some on disk files...
-        ts_iter = make_timestamp_iter()
-
         # PUT at ts_0
-        ts_0 = next(ts_iter)
+        ts_0 = next(self.ts)
         body = b'OLDER'
         headers = {'X-Timestamp': ts_0.internal,
                    'Content-Length': '5',
@@ -3689,7 +3687,7 @@ class TestObjectController(unittest.Test
         self.assertEqual(resp.status_int, 201)
 
         # POST at ts_1
-        ts_1 = next(ts_iter)
+        ts_1 = next(self.ts)
         headers = {'X-Timestamp': ts_1.internal,
                    'X-Backend-Storage-Policy-Index': int(policy)}
         headers['X-Object-Meta-Test'] = 'abc'
@@ -3700,7 +3698,7 @@ class TestObjectController(unittest.Test
         self.assertEqual(resp.status_int, 202)
 
         # PUT again at ts_2 but without making the data file durable
-        ts_2 = next(ts_iter)
+        ts_2 = next(self.ts)
         body = b'NEWER'
         headers = {'X-Timestamp': ts_2.internal,
                    'Content-Length': '5',
@@ -7165,8 +7163,8 @@ class TestObjectController(unittest.Test
     def test_serv_reserv(self):
         # Test replication_server flag was set from configuration file.
         conf = {'devices': self.testdir, 'mount_check': 'false'}
-        self.assertEqual(
-            object_server.ObjectController(conf).replication_server, None)
+        self.assertTrue(
+            object_server.ObjectController(conf).replication_server)
         for val in [True, '1', 'True', 'true']:
             conf['replication_server'] = val
             self.assertTrue(
@@ -7276,8 +7274,8 @@ class TestObjectController(unittest.Test
                          ' /sda1/p/a/c/o" 405 91 "-" "-" "-" 1.0000 "-"'
                          ' 1234 -'])
 
-    def test_call_incorrect_replication_method(self):
-        inbuf = StringIO()
+    def test_replication_server_call_all_methods(self):
+        inbuf = WsgiBytesIO()
         errbuf = StringIO()
         outbuf = StringIO()
         self.object_controller = object_server.ObjectController(
@@ -7288,14 +7286,16 @@ class TestObjectController(unittest.Test
             """Sends args to outbuf"""
             outbuf.write(args[0])
 
-        obj_methods = ['DELETE', 'PUT', 'HEAD', 'GET', 'POST', 'OPTIONS']
+        obj_methods = ['PUT', 'HEAD', 'GET', 'POST', 'DELETE', 'OPTIONS']
         for method in obj_methods:
             env = {'REQUEST_METHOD': method,
+                   'HTTP_X_TIMESTAMP': next(self.ts).internal,
                    'SCRIPT_NAME': '',
-                   'PATH_INFO': '/sda1/p/a/c',
+                   'PATH_INFO': '/sda1/p/a/c/o',
                    'SERVER_NAME': '127.0.0.1',
                    'SERVER_PORT': '8080',
                    'SERVER_PROTOCOL': 'HTTP/1.0',
+                   'CONTENT_TYPE': 'text/plain',
                    'CONTENT_LENGTH': '0',
                    'wsgi.version': (1, 0),
                    'wsgi.url_scheme': 'http',
@@ -7306,7 +7306,7 @@ class TestObjectController(unittest.Test
                    'wsgi.run_once': False}
             self.object_controller(env, start_response)
             self.assertEqual(errbuf.getvalue(), '')
-            self.assertEqual(outbuf.getvalue()[:4], '405 ')
+            self.assertIn(outbuf.getvalue()[:4], ('201 ', '204 ', '200 '))
 
     def test_create_reserved_namespace_object(self):
         path = '/sda1/p/a/%sc/%so' % (utils.RESERVED_STR, utils.RESERVED_STR)
diff -pruN 2.25.0-3/test/unit/proxy/controllers/test_account.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/proxy/controllers/test_account.py
--- 2.25.0-3/test/unit/proxy/controllers/test_account.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/proxy/controllers/test_account.py	2020-09-15 21:13:36.000000000 +0000
@@ -21,7 +21,7 @@ from swift.common.middleware.acl import
 from swift.proxy import server as proxy_server
 from swift.proxy.controllers.base import headers_to_account_info
 from swift.common import constraints
-from test.unit import fake_http_connect, FakeRing, FakeMemcache
+from test.unit import fake_http_connect, FakeRing, mocked_http_conn
 from swift.common.storage_policy import StoragePolicy
 from swift.common.request_helpers import get_sys_meta_prefix
 import swift.proxy.controllers.base
@@ -32,9 +32,12 @@ from test.unit import patch_policies
 
 @patch_policies([StoragePolicy(0, 'zero', True, object_ring=FakeRing())])
 class TestAccountController(unittest.TestCase):
+
+    ACCOUNT_REPLICAS = 3
+
     def setUp(self):
         self.app = proxy_server.Application(
-            None, FakeMemcache(),
+            None,
             account_ring=FakeRing(), container_ring=FakeRing())
 
     def _make_callback_func(self, context):
@@ -64,15 +67,32 @@ class TestAccountController(unittest.Tes
 
     def test_account_info_in_response_env(self):
         controller = proxy_server.AccountController(self.app, 'AUTH_bob')
-        with mock.patch('swift.proxy.controllers.base.http_connect',
-                        fake_http_connect(200, body='')):
-            req = Request.blank('/v1/AUTH_bob', {'PATH_INFO': '/v1/AUTH_bob'})
+        with mocked_http_conn(200) as mock_conn:
+            req = Request.blank('/v1/AUTH_bob')
             resp = controller.HEAD(req)
         self.assertEqual(2, resp.status_int // 100)
-        self.assertIn('account/AUTH_bob', resp.environ['swift.infocache'])
-        self.assertEqual(
-            headers_to_account_info(resp.headers),
-            resp.environ['swift.infocache']['account/AUTH_bob'])
+        self.assertEqual(['/AUTH_bob'],
+                         # requests are like /sdX/0/..
+                         [r['path'][6:] for r in mock_conn.requests])
+        info_cache = resp.environ['swift.infocache']
+        self.assertIn('account/AUTH_bob', info_cache)
+        header_info = headers_to_account_info(resp.headers)
+        self.assertEqual(header_info, info_cache['account/AUTH_bob'])
+
+        # The failure doesn't lead to cache eviction
+        errors = [500] * self.ACCOUNT_REPLICAS
+        with mocked_http_conn(*errors) as mock_conn:
+            req = Request.blank('/v1/AUTH_bob', {
+                'PATH_INFO': '/v1/AUTH_bob', 'swift.infocache': info_cache})
+            resp = controller.HEAD(req)
+        self.assertEqual(5, resp.status_int // 100)
+        self.assertEqual(['/AUTH_bob'] * self.ACCOUNT_REPLICAS,
+                         # requests are like /sdX/0/..
+                         [r['path'][6:] for r in mock_conn.requests])
+        self.assertIs(info_cache, resp.environ['swift.infocache'])
+        # The *old* header info is all still there
+        self.assertIn('account/AUTH_bob', info_cache)
+        self.assertEqual(header_info, info_cache['account/AUTH_bob'])
 
     def test_swift_owner(self):
         owner_headers = {
@@ -98,6 +118,7 @@ class TestAccountController(unittest.Tes
 
     def test_get_deleted_account(self):
         resp_headers = {
+            'x-backend-timestamp': '123.456',
             'x-account-status': 'deleted',
         }
         controller = proxy_server.AccountController(self.app, 'a')
@@ -317,10 +338,12 @@ class TestAccountController(unittest.Tes
 @patch_policies(
     [StoragePolicy(0, 'zero', True, object_ring=FakeRing(replicas=4))])
 class TestAccountController4Replicas(TestAccountController):
+
+    ACCOUNT_REPLICAS = 4
+
     def setUp(self):
         self.app = proxy_server.Application(
             None,
-            FakeMemcache(),
             account_ring=FakeRing(replicas=4),
             container_ring=FakeRing(replicas=4))
 
@@ -389,11 +412,12 @@ class TestAccountController4Replicas(Tes
 class TestGetAccountInfo(unittest.TestCase):
     def setUp(self):
         self.app = proxy_server.Application(
-            None, FakeMemcache(),
+            None,
             account_ring=FakeRing(), container_ring=FakeRing())
 
     def test_get_deleted_account_410(self):
-        resp_headers = {'x-account-status': 'deleted'}
+        resp_headers = {'x-account-status': 'deleted',
+                        'x-backend-timestamp': '123.456'}
 
         req = Request.blank('/v1/a')
         with mock.patch('swift.proxy.controllers.base.http_connect',
diff -pruN 2.25.0-3/test/unit/proxy/controllers/test_base.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/proxy/controllers/test_base.py
--- 2.25.0-3/test/unit/proxy/controllers/test_base.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/proxy/controllers/test_base.py	2020-09-15 21:13:36.000000000 +0000
@@ -13,6 +13,7 @@
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
+from argparse import Namespace
 import itertools
 import json
 from collections import defaultdict
@@ -21,28 +22,27 @@ import mock
 
 import six
 
+from swift.proxy import server as proxy_server
 from swift.proxy.controllers.base import headers_to_container_info, \
     headers_to_account_info, headers_to_object_info, get_container_info, \
     get_cache_key, get_account_info, get_info, get_object_info, \
-    Controller, GetOrHeadHandler, bytes_to_skip
+    Controller, GetOrHeadHandler, bytes_to_skip, clear_info_cache, \
+    set_info_cache, NodeIter
 from swift.common.swob import Request, HTTPException, RESPONSE_REASONS, \
     bytes_to_wsgi
 from swift.common import exceptions
-from swift.common.utils import split_path, ShardRange, Timestamp
+from swift.common.utils import split_path, ShardRange, Timestamp, \
+    GreenthreadSafeIterator, GreenAsyncPile
 from swift.common.header_key_dict import HeaderKeyDict
 from swift.common.http import is_success
 from swift.common.storage_policy import StoragePolicy, StoragePolicyCollection
 from test.unit import (
-    fake_http_connect, FakeRing, FakeMemcache, PatchPolicies, FakeLogger,
-    make_timestamp_iter,
-    mocked_http_conn)
-from swift.proxy import server as proxy_server
+    fake_http_connect, FakeRing, FakeMemcache, PatchPolicies,
+    make_timestamp_iter, mocked_http_conn, patch_policies, debug_logger)
 from swift.common.request_helpers import (
     get_sys_meta_prefix, get_object_transient_sysmeta
 )
 
-from test.unit import patch_policies
-
 
 class FakeResponse(object):
 
@@ -178,13 +178,22 @@ class FakeCache(FakeMemcache):
         return self.stub or self.store.get(key)
 
 
-@patch_policies([StoragePolicy(0, 'zero', True, object_ring=FakeRing())])
-class TestFuncs(unittest.TestCase):
+class BaseTest(unittest.TestCase):
+
     def setUp(self):
-        self.app = proxy_server.Application(None, FakeMemcache(),
-                                            account_ring=FakeRing(),
-                                            container_ring=FakeRing(),
-                                            logger=FakeLogger())
+        self.logger = debug_logger()
+        self.cache = FakeCache()
+        self.conf = {}
+        self.account_ring = FakeRing()
+        self.container_ring = FakeRing()
+        self.app = proxy_server.Application(self.conf,
+                                            logger=self.logger,
+                                            account_ring=self.account_ring,
+                                            container_ring=self.container_ring)
+
+
+@patch_policies([StoragePolicy(0, 'zero', True, object_ring=FakeRing())])
+class TestFuncs(BaseTest):
 
     def test_get_info_zero_recheck(self):
         mock_cache = mock.Mock()
@@ -470,6 +479,36 @@ class TestFuncs(unittest.TestCase):
         resp = get_container_info(req.environ, 'xxx')
         self.assertEqual(resp['bytes'], 3867)
 
+    def test_info_clearing(self):
+        def check_in_cache(req, cache_key):
+            self.assertIn(cache_key, req.environ['swift.infocache'])
+            self.assertIn(cache_key, req.environ['swift.cache'].store)
+
+        def check_not_in_cache(req, cache_key):
+            self.assertNotIn(cache_key, req.environ['swift.infocache'])
+            self.assertNotIn(cache_key, req.environ['swift.cache'].store)
+
+        app = FakeApp(statuses=[200, 200])
+        acct_cache_key = get_cache_key("account")
+        cont_cache_key = get_cache_key("account", "cont")
+        req = Request.blank(
+            "/v1/account/cont", environ={"swift.cache": FakeCache()})
+        # populate caches
+        info = get_container_info(req.environ, app)
+        self.assertEqual(info['status'], 200)
+
+        check_in_cache(req, acct_cache_key)
+        check_in_cache(req, cont_cache_key)
+
+        clear_info_cache('app-is-unused', req.environ, 'account', 'cont')
+        check_in_cache(req, acct_cache_key)
+        check_not_in_cache(req, cont_cache_key)
+
+        # Can also use set_info_cache interface
+        set_info_cache('app-is-unused', req.environ, 'account', None, None)
+        check_not_in_cache(req, acct_cache_key)
+        check_not_in_cache(req, cont_cache_key)
+
     def test_get_account_info_swift_source(self):
         app = FakeApp()
         req = Request.blank("/v1/a", environ={'swift.cache': FakeCache()})
@@ -679,14 +718,16 @@ class TestFuncs(unittest.TestCase):
             resp,
             headers_to_container_info(headers.items(), 200))
 
-    def test_container_info_without_req(self):
+    def test_container_info_needs_req(self):
         base = Controller(self.app)
         base.account_name = 'a'
         base.container_name = 'c'
 
-        container_info = \
-            base.container_info(base.account_name,
-                                base.container_name)
+        with mock.patch('swift.proxy.controllers.base.'
+                        'http_connect', fake_http_connect(200)):
+            container_info = \
+                base.container_info(base.account_name,
+                                    base.container_name, Request.blank('/'))
         self.assertEqual(container_info['status'], 0)
 
     def test_headers_to_account_info_missing(self):
@@ -836,12 +877,15 @@ class TestFuncs(unittest.TestCase):
 
     def test_range_fast_forward(self):
         req = Request.blank('/')
-        handler = GetOrHeadHandler(None, req, None, None, None, None, {})
+        handler = GetOrHeadHandler(
+            self.app, req, None, Namespace(num_primary_nodes=3), None, None,
+            {})
         handler.fast_forward(50)
         self.assertEqual(handler.backend_headers['Range'], 'bytes=50-')
 
-        handler = GetOrHeadHandler(None, req, None, None, None, None,
-                                   {'Range': 'bytes=23-50'})
+        handler = GetOrHeadHandler(
+            self.app, req, None, Namespace(num_primary_nodes=3), None, None,
+            {'Range': 'bytes=23-50'})
         handler.fast_forward(20)
         self.assertEqual(handler.backend_headers['Range'], 'bytes=43-50')
         self.assertRaises(HTTPException,
@@ -849,13 +893,15 @@ class TestFuncs(unittest.TestCase):
         self.assertRaises(exceptions.RangeAlreadyComplete,
                           handler.fast_forward, 8)
 
-        handler = GetOrHeadHandler(None, req, None, None, None, None,
-                                   {'Range': 'bytes=23-'})
+        handler = GetOrHeadHandler(
+            self.app, req, None, Namespace(num_primary_nodes=3), None, None,
+            {'Range': 'bytes=23-'})
         handler.fast_forward(20)
         self.assertEqual(handler.backend_headers['Range'], 'bytes=43-')
 
-        handler = GetOrHeadHandler(None, req, None, None, None, None,
-                                   {'Range': 'bytes=-100'})
+        handler = GetOrHeadHandler(
+            self.app, req, None, Namespace(num_primary_nodes=3), None, None,
+            {'Range': 'bytes=-100'})
         handler.fast_forward(20)
         self.assertEqual(handler.backend_headers['Range'], 'bytes=-80')
         self.assertRaises(HTTPException,
@@ -863,8 +909,9 @@ class TestFuncs(unittest.TestCase):
         self.assertRaises(exceptions.RangeAlreadyComplete,
                           handler.fast_forward, 80)
 
-        handler = GetOrHeadHandler(None, req, None, None, None, None,
-                                   {'Range': 'bytes=0-0'})
+        handler = GetOrHeadHandler(
+            self.app, req, None, Namespace(num_primary_nodes=3), None, None,
+            {'Range': 'bytes=0-0'})
         self.assertRaises(exceptions.RangeAlreadyComplete,
                           handler.fast_forward, 1)
 
@@ -875,21 +922,26 @@ class TestFuncs(unittest.TestCase):
         # bytes of data, so then we get a new node, fast_forward(0), and
         # send out a new request. That new request must be for all 1000
         # bytes.
-        handler = GetOrHeadHandler(None, req, None, None, None, None, {})
+        handler = GetOrHeadHandler(
+            self.app, req, None, Namespace(num_primary_nodes=3), None, None,
+            {})
         handler.learn_size_from_content_range(0, 999, 1000)
         handler.fast_forward(0)
         self.assertEqual(handler.backend_headers['Range'], 'bytes=0-999')
 
         # Same story as above, but a 1-byte object so we can have our byte
         # indices be 0.
-        handler = GetOrHeadHandler(None, req, None, None, None, None, {})
+        handler = GetOrHeadHandler(
+            self.app, req, None, Namespace(num_primary_nodes=3), None, None,
+            {})
         handler.learn_size_from_content_range(0, 0, 1)
         handler.fast_forward(0)
         self.assertEqual(handler.backend_headers['Range'], 'bytes=0-0')
 
         # last 100 bytes
-        handler = GetOrHeadHandler(None, req, None, None, None, None,
-                                   {'Range': 'bytes=-100'})
+        handler = GetOrHeadHandler(
+            self.app, req, None, Namespace(num_primary_nodes=3), None, None,
+            {'Range': 'bytes=-100'})
         handler.learn_size_from_content_range(900, 999, 1000)
         handler.fast_forward(0)
         self.assertEqual(handler.backend_headers['Range'], 'bytes=900-999')
@@ -973,8 +1025,9 @@ class TestFuncs(unittest.TestCase):
             b'abcd', b'1234', b'abc', b'd1', b'234abcd1234abcd1', b'2'))
         req = Request.blank('/v1/a/c/o')
         node = {}
-        handler = GetOrHeadHandler(self.app, req, None, None, None, None, {},
-                                   client_chunk_size=8)
+        handler = GetOrHeadHandler(
+            self.app, req, None, Namespace(num_primary_nodes=3), None, None,
+            {}, client_chunk_size=8)
 
         app_iter = handler._make_app_iter(req, node, source)
         client_chunks = list(app_iter)
@@ -1017,8 +1070,8 @@ class TestFuncs(unittest.TestCase):
         source3 = TestSource([b'lots', b'more', b'data'])
         req = Request.blank('/v1/a/c/o')
         handler = GetOrHeadHandler(
-            self.app, req, 'Object', None, None, None, {},
-            client_chunk_size=8)
+            self.app, req, 'Object', Namespace(num_primary_nodes=1), None,
+            None, {}, client_chunk_size=8)
 
         range_headers = []
         sources = [(source2, node), (source3, node)]
@@ -1066,8 +1119,8 @@ class TestFuncs(unittest.TestCase):
         source2 = TestChunkedSource([b'efgh5678'])
         req = Request.blank('/v1/a/c/o')
         handler = GetOrHeadHandler(
-            self.app, req, 'Object', None, None, None, {},
-            client_chunk_size=8)
+            self.app, req, 'Object', Namespace(num_primary_nodes=1), None,
+            None, {}, client_chunk_size=8)
 
         app_iter = handler._make_app_iter(req, node, source1)
         with mock.patch.object(handler, '_get_source_and_node',
@@ -1098,7 +1151,8 @@ class TestFuncs(unittest.TestCase):
 
         node = {'ip': '1.2.3.4', 'port': 6200, 'device': 'sda'}
         handler = GetOrHeadHandler(
-            self.app, req, 'Object', None, None, 'some-path', {})
+            self.app, req, 'Object', Namespace(num_primary_nodes=1), None,
+            'some-path', {})
         app_iter = handler._make_app_iter(req, node, source)
         app_iter.close()
         self.app.logger.warning.assert_called_once_with(
@@ -1107,7 +1161,8 @@ class TestFuncs(unittest.TestCase):
         self.app.logger = mock.Mock()
         node = {'ip': '1.2.3.4', 'port': 6200, 'device': 'sda'}
         handler = GetOrHeadHandler(
-            self.app, req, 'Object', None, None, None, {})
+            self.app, req, 'Object', Namespace(num_primary_nodes=1), None,
+            None, {})
         app_iter = handler._make_app_iter(req, node, source)
         next(app_iter)
         app_iter.close()
@@ -1292,3 +1347,76 @@ class TestFuncs(unittest.TestCase):
         self.assertIn('Failed to get container listing', warning_lines[0])
         self.assertIn('/a/c', warning_lines[0])
         self.assertFalse(warning_lines[1:])
+
+
+@patch_policies([StoragePolicy(0, 'zero', True, object_ring=FakeRing())])
+class TestNodeIter(BaseTest):
+
+    def test_iter_default_fake_ring(self):
+        for ring in (self.account_ring, self.container_ring):
+            self.assertEqual(ring.replica_count, 3.0)
+            node_iter = NodeIter(self.app, ring, 0)
+            self.assertEqual(6, node_iter.nodes_left)
+            self.assertEqual(3, node_iter.primaries_left)
+            count = 0
+            for node in node_iter:
+                count += 1
+            self.assertEqual(count, 3)
+            self.assertEqual(0, node_iter.primaries_left)
+            # default fake_ring has NO handoffs, so nodes_left is kind of a lie
+            self.assertEqual(3, node_iter.nodes_left)
+
+    def test_iter_with_handoffs(self):
+        ring = FakeRing(replicas=3, max_more_nodes=20)  # handoffs available
+        policy = StoragePolicy(0, 'zero', object_ring=ring)
+        node_iter = NodeIter(self.app, policy.object_ring, 0, policy=policy)
+        self.assertEqual(6, node_iter.nodes_left)
+        self.assertEqual(3, node_iter.primaries_left)
+        primary_indexes = set()
+        handoff_indexes = []
+        count = 0
+        for node in node_iter:
+            if 'index' in node:
+                primary_indexes.add(node['index'])
+            else:
+                handoff_indexes.append(node['handoff_index'])
+            count += 1
+        self.assertEqual(count, 6)
+        self.assertEqual(0, node_iter.primaries_left)
+        self.assertEqual(0, node_iter.nodes_left)
+        self.assertEqual({0, 1, 2}, primary_indexes)
+        self.assertEqual([0, 1, 2], handoff_indexes)
+
+    def test_multi_iteration(self):
+        ring = FakeRing(replicas=8, max_more_nodes=20)
+        policy = StoragePolicy(0, 'ec', object_ring=ring)
+
+        # sanity
+        node_iter = NodeIter(self.app, policy.object_ring, 0, policy=policy)
+        self.assertEqual(16, len([n for n in node_iter]))
+
+        node_iter = NodeIter(self.app, policy.object_ring, 0, policy=policy)
+        self.assertEqual(16, node_iter.nodes_left)
+        self.assertEqual(8, node_iter.primaries_left)
+        pile = GreenAsyncPile(5)
+
+        def eat_node(node_iter):
+            return next(node_iter)
+
+        safe_iter = GreenthreadSafeIterator(node_iter)
+        for i in range(5):
+            pile.spawn(eat_node, safe_iter)
+
+        nodes = []
+        for node in pile:
+            nodes.append(node)
+
+        primary_indexes = {n['index'] for n in nodes}
+        self.assertEqual(5, len(primary_indexes))
+        self.assertEqual(3, node_iter.primaries_left)
+
+        # it's problematic we don't decrement nodes_left until we resume
+        self.assertEqual(12, node_iter.nodes_left)
+        for node in node_iter:
+            nodes.append(node)
+        self.assertEqual(17, len(nodes))
diff -pruN 2.25.0-3/test/unit/proxy/controllers/test_container.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/proxy/controllers/test_container.py
--- 2.25.0-3/test/unit/proxy/controllers/test_container.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/proxy/controllers/test_container.py	2020-09-15 21:13:36.000000000 +0000
@@ -27,7 +27,7 @@ from swift.common.swob import Request, b
 from swift.common.utils import ShardRange, Timestamp
 from swift.proxy import server as proxy_server
 from swift.proxy.controllers.base import headers_to_container_info, \
-    Controller, get_container_info
+    Controller, get_container_info, get_cache_key
 from test import annotate_failure
 from test.unit import fake_http_connect, FakeRing, FakeMemcache, \
     make_timestamp_iter
@@ -49,7 +49,7 @@ class TestContainerController(TestRingBa
         self.logger = debug_logger()
         self.container_ring = FakeRing(replicas=self.CONTAINER_REPLICAS,
                                        max_more_nodes=9)
-        self.app = proxy_server.Application(None, FakeMemcache(),
+        self.app = proxy_server.Application(None,
                                             logger=self.logger,
                                             account_ring=FakeRing(),
                                             container_ring=self.container_ring)
@@ -97,7 +97,9 @@ class TestContainerController(TestRingBa
             with mock.patch(
                     'swift.proxy.controllers.base.http_connect',
                     fake_http_connect(*responses)):
-                req = Request.blank('/v1/a/c')
+                cache = FakeMemcache()
+                cache.set(get_cache_key('a'), {'status': 204})
+                req = Request.blank('/v1/a/c', environ={'swift.cache': cache})
                 resp = getattr(controller, method)(req)
 
             self.assertEqual(expected,
@@ -106,19 +108,37 @@ class TestContainerController(TestRingBa
                              (expected, resp.status_int, str(responses)))
 
     def test_container_info_got_cached(self):
+        memcache = FakeMemcache()
         controller = proxy_server.ContainerController(self.app, 'a', 'c')
-        with mock.patch('swift.proxy.controllers.base.http_connect',
-                        fake_http_connect(200, 200, body='')):
-            req = Request.blank('/v1/a/c', {'PATH_INFO': '/v1/a/c'})
+        with mocked_http_conn(200, 200) as mock_conn:
+            req = Request.blank('/v1/a/c', {'swift.cache': memcache})
             resp = controller.HEAD(req)
         self.assertEqual(2, resp.status_int // 100)
+        self.assertEqual(['/a', '/a/c'],
+                         # requests are like /sdX/0/..
+                         [r['path'][6:] for r in mock_conn.requests])
         # Make sure it's in both swift.infocache and memcache
+        header_info = headers_to_container_info(resp.headers)
+        info_cache = resp.environ['swift.infocache']
+        self.assertIn("container/a/c", resp.environ['swift.infocache'])
+        self.assertEqual(header_info, info_cache['container/a/c'])
+        self.assertEqual(header_info, memcache.get('container/a/c'))
+
+        # The failure doesn't lead to cache eviction
+        errors = [500] * self.CONTAINER_REPLICAS * 2
+        with mocked_http_conn(*errors) as mock_conn:
+            req = Request.blank('/v1/a/c', {'swift.infocache': info_cache,
+                                            'swift.cache': memcache})
+            resp = controller.HEAD(req)
+        self.assertEqual(5, resp.status_int // 100)
+        self.assertEqual(['/a/c'] * self.CONTAINER_REPLICAS * 2,
+                         # requests are like /sdX/0/..
+                         [r['path'][6:] for r in mock_conn.requests])
+        self.assertIs(info_cache, resp.environ['swift.infocache'])
         self.assertIn("container/a/c", resp.environ['swift.infocache'])
-        self.assertEqual(
-            headers_to_container_info(resp.headers),
-            resp.environ['swift.infocache']['container/a/c'])
-        from_memcache = self.app.memcache.get('container/a/c')
-        self.assertTrue(from_memcache)
+        # NB: this is the *old* header_info, from the good req
+        self.assertEqual(header_info, info_cache['container/a/c'])
+        self.assertEqual(header_info, memcache.get('container/a/c'))
 
     @mock.patch('swift.proxy.controllers.container.clear_info_cache')
     @mock.patch.object(Controller, 'make_requests')
@@ -348,7 +368,8 @@ class TestContainerController(TestRingBa
             ([Timeout()] * nodes + [404] * handoffs, 503),
             ([Timeout()] * (nodes + handoffs), 503),
             ([Timeout()] * (nodes + handoffs - 1) + [404], 503),
-            ([Timeout()] * (nodes - 1) + [404] * (handoffs + 1), 404),
+            ([Timeout()] * (nodes - 1) + [404] * (handoffs + 1), 503),
+            ([Timeout()] * (nodes - 2) + [404] * (handoffs + 2), 404),
             ([500] * (nodes - 1) + [404] * (handoffs + 1), 503),
             ([503, 200], 200),
             ([507, 200], 200),
@@ -374,8 +395,14 @@ class TestContainerController(TestRingBa
                       '\n'.join(failures))
 
         # One more test, simulating all nodes being error-limited
+        class FakeIter(object):
+            num_primary_nodes = 3
+
+            def __iter__(self):
+                return iter([])
+
         with mocked_http_conn(), mock.patch.object(self.app, 'iter_nodes',
-                                                   return_value=[]):
+                                                   return_value=FakeIter()):
             req = Request.blank('/v1/a/c')
             resp = req.get_response(self.app)
             self.assertEqual(resp.status_int, 503)
diff -pruN 2.25.0-3/test/unit/proxy/controllers/test_obj.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/proxy/controllers/test_obj.py
--- 2.25.0-3/test/unit/proxy/controllers/test_obj.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/proxy/controllers/test_obj.py	2020-09-15 21:13:36.000000000 +0000
@@ -26,7 +26,8 @@ import json
 from hashlib import md5
 
 import mock
-from eventlet import Timeout
+from eventlet import Timeout, sleep
+from eventlet.queue import Empty
 
 import six
 from six import StringIO
@@ -48,10 +49,11 @@ from swift.proxy.controllers.base import
 from swift.common.storage_policy import POLICIES, ECDriverError, \
     StoragePolicy, ECStoragePolicy
 
-from test.unit import FakeRing, FakeMemcache, fake_http_connect, \
+from test.unit import FakeRing, fake_http_connect, \
     debug_logger, patch_policies, SlowBody, FakeStatus, \
     DEFAULT_TEST_EC_TYPE, encode_frag_archive_bodies, make_ec_object_stub, \
-    fake_ec_node_response, StubResponse, mocked_http_conn
+    fake_ec_node_response, StubResponse, mocked_http_conn, \
+    quiet_eventlet_exceptions
 from test.unit.proxy.test_server import node_error_count
 
 
@@ -178,7 +180,7 @@ class BaseObjectControllerMixin(object):
         # increase connection timeout to avoid intermittent failures
         conf = {'conn_timeout': 1.0}
         self.app = PatchedObjControllerApp(
-            conf, FakeMemcache(), account_ring=FakeRing(),
+            conf, account_ring=FakeRing(),
             container_ring=FakeRing(), logger=self.logger)
 
         # you can over-ride the container_info just by setting it on the app
@@ -968,7 +970,7 @@ class CommonObjectControllerMixin(BaseOb
             self, conf, policy_conf, policy, affinity_regions, affinity_count):
         conf['policy_config'] = policy_conf
         app = PatchedObjControllerApp(
-            conf, FakeMemcache(), account_ring=FakeRing(),
+            conf, account_ring=FakeRing(),
             container_ring=FakeRing(), logger=self.logger)
 
         controller = self.controller_cls(app, 'a', 'c', 'o')
@@ -1598,6 +1600,32 @@ class TestReplicatedObjController(Common
             resp = req.get_response(self.app)
         self.assertEqual(resp.status_int, 503)
 
+    def test_GET_primaries_error_during_rebalance(self):
+        def do_test(primary_codes, expected, include_timestamp=False):
+            random.shuffle(primary_codes)
+            handoff_codes = [404] * self.obj_ring.max_more_nodes
+            headers = None
+            if include_timestamp:
+                headers = [{'X-Backend-Timestamp': '123.456'}] * 3
+                headers.extend({} for _ in handoff_codes)
+            with set_http_connect(*primary_codes + handoff_codes,
+                                  headers=headers):
+                req = swift.common.swob.Request.blank('/v1/a/c/o')
+                resp = req.get_response(self.app)
+            self.assertEqual(resp.status_int, expected)
+
+        # with two of out three backend errors a client should retry
+        do_test([Timeout(), Exception('kaboom!'), 404], 503)
+        # unless there's a timestamp associated
+        do_test([Timeout(), Exception('kaboom!'), 404], 404,
+                include_timestamp=True)
+        # when there's more 404s, we trust it more
+        do_test([Timeout(), 404, 404], 404)
+        # unless we explicitly *don't* want to trust it
+        policy_opts = self.app.get_policy_options(None)
+        policy_opts.rebalance_missing_suppression_count = 2
+        do_test([Timeout(), 404, 404], 503)
+
     def test_GET_primaries_mixed_explode_and_timeout(self):
         req = swift.common.swob.Request.blank('/v1/a/c/o')
         primaries = []
@@ -1617,7 +1645,8 @@ class TestReplicatedObjController(Common
         # to the next node rather than hang the request
         headers = [{'X-Backend-Timestamp': 'not-a-timestamp'}, {}]
         codes = [200, 200]
-        with set_http_connect(*codes, headers=headers):
+        with quiet_eventlet_exceptions(), set_http_connect(
+                *codes, headers=headers):
             resp = req.get_response(self.app)
         self.assertEqual(resp.status_int, 200)
 
@@ -2058,6 +2087,7 @@ def capture_http_requests(get_response):
             self.req = req
             self.resp = None
             self.path = "/"
+            self.closed = False
 
         def getresponse(self):
             self.resp = get_response(self.req)
@@ -2072,6 +2102,9 @@ def capture_http_requests(get_response):
         def endheaders(self):
             pass
 
+        def close(self):
+            self.closed = True
+
     class ConnectionLog(object):
 
         def __init__(self):
@@ -2280,6 +2313,43 @@ class TestECObjController(ECObjectContro
         self.assertIn('Accept-Ranges', resp.headers)
         self.assertNotIn('Connection', resp.headers)
 
+    def test_GET_not_found_when_404_newer(self):
+        # if proxy receives a 404, it keeps waiting for other connections until
+        # max number of nodes in hopes of finding an object, but if 404 is
+        # more recent than a 200, then it should ignore 200 and return 404
+        req = swift.common.swob.Request.blank('/v1/a/c/o')
+        rest = 2 * self.policy.object_ring.replica_count - 2
+        codes = [200, 404] + [200] * rest
+        ts_iter = iter([1, 2] + [1] * rest)
+        with set_http_connect(*codes, timestamps=ts_iter):
+            resp = req.get_response(self.app)
+        self.assertEqual(resp.status_int, 404)
+
+    def test_GET_primaries_error_during_rebalance(self):
+        req = swift.common.swob.Request.blank('/v1/a/c/o')
+        codes = [404] * (2 * self.policy.object_ring.replica_count)
+        with mocked_http_conn(*codes):
+            resp = req.get_response(self.app)
+        self.assertEqual(resp.status_int, 404)
+        for i in range(self.policy.object_ring.replica_count - 2):
+            codes[i] = Timeout()
+            with mocked_http_conn(*codes):
+                resp = req.get_response(self.app)
+            self.assertEqual(resp.status_int, 404)
+            self.app._error_limiting = {}  # Reset error limiting
+
+        # one more timeout is past the tipping point
+        codes[self.policy.object_ring.replica_count - 2] = Timeout()
+        with mocked_http_conn(*codes):
+            resp = req.get_response(self.app)
+        self.assertEqual(resp.status_int, 503)
+        self.app._error_limiting = {}  # Reset error limiting
+
+        # unless we have tombstones
+        with mocked_http_conn(*codes, headers={'X-Backend-Timestamp': '1'}):
+            resp = req.get_response(self.app)
+        self.assertEqual(resp.status_int, 404)
+
     def _test_if_match(self, method):
         num_responses = self.policy.ec_ndata if method == 'GET' else 1
 
@@ -2397,6 +2467,261 @@ class TestECObjController(ECObjectContro
             resp = req.get_response(self.app)
         self.assertEqual(resp.status_int, 200)
 
+    def test_GET_no_response_error(self):
+        req = swift.common.swob.Request.blank('/v1/a/c/o')
+        with set_http_connect():
+            resp = req.get_response(self.app)
+        self.assertEqual(resp.status_int, 503)
+
+    def test_feed_remaining_primaries(self):
+        controller = self.controller_cls(
+            self.app, 'a', 'c', 'o')
+        safe_iter = utils.GreenthreadSafeIterator(self.app.iter_nodes(
+            self.policy.object_ring, 0, policy=self.policy))
+        controller._fragment_GET_request = lambda *a, **k: next(safe_iter)
+        pile = utils.GreenAsyncPile(self.policy.ec_ndata)
+        for i in range(self.policy.ec_ndata):
+            pile.spawn(controller._fragment_GET_request)
+        req = swob.Request.blank('/v1/a/c/o')
+
+        feeder_q = mock.MagicMock()
+
+        def feeder_timeout(*a, **kw):
+            # simulate trampoline
+            sleep()
+            # timeout immediately
+            raise Empty
+        feeder_q.get.side_effect = feeder_timeout
+        controller.feed_remaining_primaries(
+            safe_iter, pile, req, 0, self.policy,
+            mock.MagicMock(), feeder_q)
+        expected_timeout = self.app.get_policy_options(
+            self.policy).concurrency_timeout
+        expected_call = mock.call(timeout=expected_timeout)
+        expected_num_calls = self.policy.ec_nparity + 1
+        self.assertEqual(feeder_q.get.call_args_list,
+                         [expected_call] * expected_num_calls)
+
+    def test_GET_timeout(self):
+        req = swift.common.swob.Request.blank('/v1/a/c/o')
+        self.app.recoverable_node_timeout = 0.01
+        codes = [FakeStatus(404, response_sleep=1.0)] + \
+            [200] * (self.policy.ec_ndata)
+        with mocked_http_conn(*codes) as log:
+            resp = req.get_response(self.app)
+        self.assertEqual(resp.status_int, 200)
+        self.assertEqual(self.policy.ec_ndata + 1, len(log.requests))
+
+    def test_GET_with_slow_primaries(self):
+        segment_size = self.policy.ec_segment_size
+        test_data = (b'test' * segment_size)[:-743]
+        etag = md5(test_data).hexdigest()
+        ec_archive_bodies = self._make_ec_archive_bodies(test_data)
+        ts = self.ts()
+        headers = []
+        for i, body in enumerate(ec_archive_bodies):
+            headers.append({
+                'X-Object-Sysmeta-Ec-Etag': etag,
+                'X-Object-Sysmeta-Ec-Content-Length': len(body),
+                'X-Object-Sysmeta-Ec-Frag-Index':
+                    self.policy.get_backend_index(i),
+                'X-Backend-Timestamp': ts.internal,
+                'X-Timestamp': ts.normal,
+                'X-Backend-Durable-Timestamp': ts.internal,
+                'X-Backend-Data-Timestamp': ts.internal,
+            })
+
+        req = swift.common.swob.Request.blank('/v1/a/c/o')
+
+        policy_opts = self.app.get_policy_options(self.policy)
+        policy_opts.concurrent_gets = True
+        policy_opts.concurrency_timeout = 0.1
+
+        status_codes = ([
+            FakeStatus(200, response_sleep=2.0),
+        ] * self.policy.ec_nparity) + ([
+            FakeStatus(200),
+        ] * self.policy.ec_ndata)
+        self.assertEqual(len(status_codes), len(ec_archive_bodies))
+        with mocked_http_conn(*status_codes, body_iter=ec_archive_bodies,
+                              headers=headers) as log:
+            resp = req.get_response(self.app)
+        self.assertEqual(resp.status_int, 200)
+        self.assertEqual(len(log.requests),
+                         self.policy.ec_n_unique_fragments)
+
+    def test_GET_with_some_slow_primaries(self):
+        segment_size = self.policy.ec_segment_size
+        test_data = (b'test' * segment_size)[:-289]
+        etag = md5(test_data).hexdigest()
+        ec_archive_bodies = self._make_ec_archive_bodies(test_data)
+        ts = self.ts()
+        headers = []
+        for i, body in enumerate(ec_archive_bodies):
+            headers.append({
+                'X-Object-Sysmeta-Ec-Etag': etag,
+                'X-Object-Sysmeta-Ec-Content-Length': len(body),
+                'X-Object-Sysmeta-Ec-Frag-Index':
+                    self.policy.get_backend_index(i),
+                'X-Backend-Timestamp': ts.internal,
+                'X-Timestamp': ts.normal,
+                'X-Backend-Durable-Timestamp': ts.internal,
+                'X-Backend-Data-Timestamp': ts.internal,
+            })
+
+        req = swift.common.swob.Request.blank('/v1/a/c/o')
+
+        policy_opts = self.app.get_policy_options(self.policy)
+        policy_opts.concurrent_gets = True
+        policy_opts.concurrency_timeout = 0.1
+
+        slow_count = self.policy.ec_nparity
+        status_codes = ([
+            FakeStatus(200, response_sleep=2.0),
+        ] * slow_count) + ([
+            FakeStatus(200),
+        ] * (self.policy.ec_ndata - slow_count))
+        random.shuffle(status_codes)
+        status_codes.extend([
+            FakeStatus(200),
+        ] * slow_count)
+        self.assertEqual(len(status_codes), len(ec_archive_bodies))
+        with mocked_http_conn(*status_codes, body_iter=ec_archive_bodies,
+                              headers=headers) as log:
+            resp = req.get_response(self.app)
+        self.assertEqual(resp.status_int, 200)
+        self.assertEqual(len(log.requests),
+                         self.policy.ec_n_unique_fragments)
+
+    def test_GET_with_slow_nodes_and_failures(self):
+        segment_size = self.policy.ec_segment_size
+        test_data = (b'test' * segment_size)[:-289]
+        etag = md5(test_data).hexdigest()
+        ec_archive_bodies = self._make_ec_archive_bodies(test_data)
+        ts = self.ts()
+        headers = []
+        for i, body in enumerate(ec_archive_bodies):
+            headers.append({
+                'X-Object-Sysmeta-Ec-Etag': etag,
+                'X-Object-Sysmeta-Ec-Content-Length': len(body),
+                'X-Object-Sysmeta-Ec-Frag-Index':
+                    self.policy.get_backend_index(i),
+                'X-Backend-Timestamp': ts.internal,
+                'X-Timestamp': ts.normal,
+                'X-Backend-Durable-Timestamp': ts.internal,
+                'X-Backend-Data-Timestamp': ts.internal,
+            })
+
+        req = swift.common.swob.Request.blank('/v1/a/c/o')
+
+        policy_opts = self.app.get_policy_options(self.policy)
+        policy_opts.concurrent_gets = True
+        policy_opts.concurrency_timeout = 0.1
+
+        unused_resp = [
+            FakeStatus(200, response_sleep=2.0),
+            FakeStatus(200, response_sleep=2.0),
+            500,
+            416,
+        ]
+        self.assertEqual(len(unused_resp), self.policy.ec_nparity)
+        status_codes = (
+            [200] * (self.policy.ec_ndata - 4)) + unused_resp
+        self.assertEqual(len(status_codes), self.policy.ec_ndata)
+        # random.shuffle(status_codes)
+        # make up for the failures
+        status_codes.extend([200] * self.policy.ec_nparity)
+        self.assertEqual(len(status_codes), len(ec_archive_bodies))
+        bodies_with_errors = []
+        for code, body in zip(status_codes, ec_archive_bodies):
+            if code == 500:
+                bodies_with_errors.append('Kaboom')
+            elif code == 416:
+                bodies_with_errors.append('That Range is no.')
+            else:
+                bodies_with_errors.append(body)
+        with mocked_http_conn(*status_codes, body_iter=bodies_with_errors,
+                              headers=headers) as log:
+            resp = req.get_response(self.app)
+        self.assertEqual(resp.status_int, 200)
+        self.assertEqual(len(log.requests),
+                         self.policy.ec_n_unique_fragments)
+
+    def test_GET_with_one_slow_frag_lane(self):
+        segment_size = self.policy.ec_segment_size
+        test_data = (b'test' * segment_size)[:-454]
+        etag = md5(test_data).hexdigest()
+        ec_archive_bodies = self._make_ec_archive_bodies(test_data)
+        ts = self.ts()
+        headers = []
+        for i, body in enumerate(ec_archive_bodies):
+            headers.append({
+                'X-Object-Sysmeta-Ec-Etag': etag,
+                'X-Object-Sysmeta-Ec-Content-Length': len(body),
+                'X-Object-Sysmeta-Ec-Frag-Index':
+                    self.policy.get_backend_index(i),
+                'X-Backend-Timestamp': ts.internal,
+                'X-Timestamp': ts.normal,
+                'X-Backend-Durable-Timestamp': ts.internal,
+                'X-Backend-Data-Timestamp': ts.internal,
+            })
+
+        req = swift.common.swob.Request.blank('/v1/a/c/o')
+
+        policy_opts = self.app.get_policy_options(self.policy)
+        policy_opts.concurrent_gets = True
+        policy_opts.concurrency_timeout = 0.1
+
+        status_codes = [
+            FakeStatus(200, response_sleep=2.0),
+        ] + ([
+            FakeStatus(200),
+        ] * (self.policy.ec_ndata - 1))
+        random.shuffle(status_codes)
+        status_codes.extend([
+            FakeStatus(200, response_sleep=2.0),
+            FakeStatus(200, response_sleep=2.0),
+            FakeStatus(200, response_sleep=2.0),
+            FakeStatus(200),
+        ])
+        self.assertEqual(len(status_codes), len(ec_archive_bodies))
+        with mocked_http_conn(*status_codes, body_iter=ec_archive_bodies,
+                              headers=headers) as log:
+            resp = req.get_response(self.app)
+        self.assertEqual(resp.status_int, 200)
+        self.assertEqual(len(log.requests),
+                         self.policy.ec_n_unique_fragments)
+
+    def test_GET_with_concurrent_ec_extra_requests(self):
+        segment_size = self.policy.ec_segment_size
+        test_data = (b'test' * segment_size)[:-454]
+        etag = md5(test_data).hexdigest()
+        ec_archive_bodies = self._make_ec_archive_bodies(test_data)
+        ts = self.ts()
+        headers = []
+        for i, body in enumerate(ec_archive_bodies):
+            headers.append({
+                'X-Object-Sysmeta-Ec-Etag': etag,
+                'X-Object-Sysmeta-Ec-Content-Length': len(body),
+                'X-Object-Sysmeta-Ec-Frag-Index':
+                    self.policy.get_backend_index(i),
+                'X-Backend-Timestamp': ts.internal,
+                'X-Timestamp': ts.normal,
+                'X-Backend-Durable-Timestamp': ts.internal,
+                'X-Backend-Data-Timestamp': ts.internal,
+            })
+        policy_opts = self.app.get_policy_options(self.policy)
+        policy_opts.concurrent_ec_extra_requests = self.policy.ec_nparity - 1
+        req = swift.common.swob.Request.blank('/v1/a/c/o')
+        status_codes = [200] * (self.policy.object_ring.replicas - 1)
+        with mocked_http_conn(*status_codes, body_iter=ec_archive_bodies,
+                              headers=headers) as log:
+            resp = req.get_response(self.app)
+        self.assertEqual(resp.status_int, 200)
+        self.assertEqual(len(log.requests),
+                         self.policy.object_ring.replicas - 1)
+        self.assertEqual(resp.body, test_data)
+
     def test_GET_with_body(self):
         req = swift.common.swob.Request.blank('/v1/a/c/o')
         # turn a real body into fragments
@@ -2562,12 +2887,22 @@ class TestECObjController(ECObjectContro
         fake_response = self._fake_ec_node_response(node_frags)
 
         req = swob.Request.blank('/v1/a/c/o')
-        with capture_http_requests(fake_response) as log:
+        with mock.patch('swift.proxy.server.shuffle', lambda n: n), \
+                capture_http_requests(fake_response) as log:
             resp = req.get_response(self.app)
 
         self.assertEqual(resp.status_int, 200)
         self.assertEqual(resp.headers['etag'], obj2['etag'])
+        closed_conn = defaultdict(set)
+        for conn in log:
+            etag = conn.resp.headers['X-Object-Sysmeta-Ec-Etag']
+            closed_conn[etag].add(conn.closed)
+        self.assertEqual({
+            obj1['etag']: {True},
+            obj2['etag']: {False},
+        }, closed_conn)
         self.assertEqual(md5(resp.body).hexdigest(), obj2['etag'])
+        self.assertEqual({True}, {conn.closed for conn in log})
 
         collected_responses = defaultdict(set)
         for conn in log:
@@ -2575,17 +2910,13 @@ class TestECObjController(ECObjectContro
             index = conn.resp.headers['X-Object-Sysmeta-Ec-Frag-Index']
             collected_responses[etag].add(index)
 
-        # because the primary nodes are shuffled, it's possible the proxy
-        # didn't even notice the missed overwrite frag - but it might have
-        self.assertLessEqual(len(log), self.policy.ec_ndata + 1)
-        self.assertLessEqual(len(collected_responses), 2)
-
-        # ... regardless we should never need to fetch more than ec_ndata
-        # frags for any given etag
-        for etag, frags in collected_responses.items():
-            self.assertLessEqual(len(frags), self.policy.ec_ndata,
-                                 'collected %s frags for etag %s' % (
-                                     len(frags), etag))
+        self.assertEqual(len(log), self.policy.ec_ndata + 1)
+        expected = {
+            obj1['etag']: 1,
+            obj2['etag']: self.policy.ec_ndata,
+        }
+        self.assertEqual(expected, {
+            e: len(f) for e, f in collected_responses.items()})
 
     def test_GET_with_many_missed_overwrite_will_need_handoff(self):
         obj1 = self._make_ec_object_stub(pattern='obj1')
@@ -2744,6 +3075,15 @@ class TestECObjController(ECObjectContro
         with capture_http_requests(fake_response) as log:
             resp = req.get_response(self.app)
 
+        closed_conn = defaultdict(set)
+        for conn in log:
+            etag = conn.resp.headers.get('X-Object-Sysmeta-Ec-Etag')
+            closed_conn[etag].add(conn.closed)
+        self.assertEqual({
+            obj1['etag']: {True},
+            obj2['etag']: {True},
+            None: {True},
+        }, dict(closed_conn))
         self.assertEqual(resp.status_int, 503)
 
         collected_responses = defaultdict(set)
@@ -2843,7 +3183,7 @@ class TestECObjController(ECObjectContro
                 collected_indexes[fi].append(conn)
         self.assertEqual(len(collected_indexes), 7)
 
-    def test_GET_with_mixed_nondurable_frags_and_no_quorum_will_503(self):
+    def test_GET_with_mixed_nondurable_frags_and_will_404(self):
         # all nodes have a frag but there is no one set that reaches quorum,
         # which means there is no backend 404 response, but proxy should still
         # return 404 rather than 503
@@ -2893,10 +3233,12 @@ class TestECObjController(ECObjectContro
 
         collected_etags = set()
         collected_status = set()
+        closed_conn = defaultdict(set)
         for conn in log:
             etag = conn.resp.headers['X-Object-Sysmeta-Ec-Etag']
             collected_etags.add(etag)
             collected_status.add(conn.resp.status)
+            closed_conn[etag].add(conn.closed)
 
         # default node_iter will exhaust at 2 * replicas
         self.assertEqual(len(log), 2 * self.replicas())
@@ -2904,11 +3246,87 @@ class TestECObjController(ECObjectContro
             {obj1['etag'], obj2['etag'], obj3['etag'], obj4['etag']},
             collected_etags)
         self.assertEqual({200}, collected_status)
+        self.assertEqual({
+            obj1['etag']: {True},
+            obj2['etag']: {True},
+            obj3['etag']: {True},
+            obj4['etag']: {True},
+        }, closed_conn)
 
-    def test_GET_with_mixed_frags_and_no_quorum_will_503(self):
+    def test_GET_with_mixed_durable_and_nondurable_frags_will_503(self):
         # all nodes have a frag but there is no one set that reaches quorum,
-        # but since they're all marked durable (so we *should* be able to
-        # reconstruct), proxy will 503
+        # but since one is marked durable we *should* be able to reconstruct,
+        # so proxy should 503
+        obj1 = self._make_ec_object_stub(pattern='obj1')
+        obj2 = self._make_ec_object_stub(pattern='obj2')
+        obj3 = self._make_ec_object_stub(pattern='obj3')
+        obj4 = self._make_ec_object_stub(pattern='obj4')
+
+        node_frags = [
+            {'obj': obj1, 'frag': 0, 'durable': False},
+            {'obj': obj2, 'frag': 0, 'durable': False},
+            {'obj': obj3, 'frag': 0, 'durable': False},
+            {'obj': obj1, 'frag': 1, 'durable': False},
+            {'obj': obj2, 'frag': 1, 'durable': False},
+            {'obj': obj3, 'frag': 1, 'durable': False},
+            {'obj': obj1, 'frag': 2, 'durable': False},
+            {'obj': obj2, 'frag': 2, 'durable': False},
+            {'obj': obj3, 'frag': 2, 'durable': False},
+            {'obj': obj1, 'frag': 3, 'durable': False},
+            {'obj': obj2, 'frag': 3, 'durable': False},
+            {'obj': obj3, 'frag': 3, 'durable': False},
+            {'obj': obj1, 'frag': 4, 'durable': False},
+            {'obj': obj2, 'frag': 4, 'durable': False},
+            {'obj': obj3, 'frag': 4, 'durable': False},
+            {'obj': obj1, 'frag': 5, 'durable': False},
+            {'obj': obj2, 'frag': 5, 'durable': False},
+            {'obj': obj3, 'frag': 5, 'durable': False},
+            {'obj': obj1, 'frag': 6, 'durable': False},
+            {'obj': obj2, 'frag': 6, 'durable': False},
+            {'obj': obj3, 'frag': 6, 'durable': False},
+            {'obj': obj1, 'frag': 7, 'durable': False},
+            {'obj': obj2, 'frag': 7, 'durable': False},
+            {'obj': obj3, 'frag': 7},
+            {'obj': obj1, 'frag': 8, 'durable': False},
+            {'obj': obj2, 'frag': 8, 'durable': False},
+            {'obj': obj3, 'frag': 8, 'durable': False},
+            {'obj': obj4, 'frag': 8, 'durable': False},
+        ]
+
+        fake_response = self._fake_ec_node_response(node_frags)
+
+        req = swob.Request.blank('/v1/a/c/o')
+        with capture_http_requests(fake_response) as log:
+            resp = req.get_response(self.app)
+
+        self.assertEqual(resp.status_int, 503)
+
+        closed_conn = defaultdict(set)
+        collected_etags = set()
+        collected_status = set()
+        for conn in log:
+            etag = conn.resp.headers['X-Object-Sysmeta-Ec-Etag']
+            collected_etags.add(etag)
+            collected_status.add(conn.resp.status)
+            closed_conn[etag].add(conn.closed)
+
+        # default node_iter will exhaust at 2 * replicas
+        self.assertEqual(len(log), 2 * self.replicas())
+        self.assertEqual(
+            {obj1['etag'], obj2['etag'], obj3['etag'], obj4['etag']},
+            collected_etags)
+        self.assertEqual({200}, collected_status)
+        self.assertEqual({
+            obj1['etag']: {True},
+            obj2['etag']: {True},
+            obj3['etag']: {True},
+            obj4['etag']: {True},
+        }, closed_conn)
+
+    def test_GET_with_mixed_durable_frags_and_no_quorum_will_503(self):
+        # all nodes have a frag but there is no one set that reaches quorum,
+        # and since at least one is marked durable we *should* be able to
+        # reconstruct, so proxy will 503
         obj1 = self._make_ec_object_stub(pattern='obj1')
         obj2 = self._make_ec_object_stub(pattern='obj2')
         obj3 = self._make_ec_object_stub(pattern='obj3')
@@ -2953,12 +3371,17 @@ class TestECObjController(ECObjectContro
 
         self.assertEqual(resp.status_int, 503)
 
+        for conn in log:
+            etag = conn.resp.headers.get('X-Object-Sysmeta-Ec-Etag')
+
         collected_etags = set()
         collected_status = set()
+        closed_conn = defaultdict(set)
         for conn in log:
             etag = conn.resp.headers['X-Object-Sysmeta-Ec-Etag']
             collected_etags.add(etag)
             collected_status.add(conn.resp.status)
+            closed_conn[etag].add(conn.closed)
 
         # default node_iter will exhaust at 2 * replicas
         self.assertEqual(len(log), 2 * self.replicas())
@@ -2966,6 +3389,12 @@ class TestECObjController(ECObjectContro
             {obj1['etag'], obj2['etag'], obj3['etag'], obj4['etag']},
             collected_etags)
         self.assertEqual({200}, collected_status)
+        self.assertEqual({
+            obj1['etag']: {True},
+            obj2['etag']: {True},
+            obj3['etag']: {True},
+            obj4['etag']: {True},
+        }, closed_conn)
 
     def test_GET_with_quorum_durable_files(self):
         # verify that only (ec_nparity + 1) nodes need to be durable for a GET
@@ -2987,7 +3416,7 @@ class TestECObjController(ECObjectContro
             {'obj': obj1, 'frag': 11, 'durable': False},  # parity
             {'obj': obj1, 'frag': 12, 'durable': False},  # parity
             {'obj': obj1, 'frag': 13, 'durable': False},  # parity
-        ]  # handoffs not used in this scenario
+        ] + [[]] * self.replicas()  # handoffs all 404
 
         fake_response = self._fake_ec_node_response(list(node_frags))
 
@@ -2999,9 +3428,11 @@ class TestECObjController(ECObjectContro
         self.assertEqual(resp.headers['etag'], obj1['etag'])
         self.assertEqual(md5(resp.body).hexdigest(), obj1['etag'])
 
-        self.assertEqual(self.policy.ec_ndata, len(log))
+        self.assertGreaterEqual(len(log), self.policy.ec_ndata)
         collected_durables = []
         for conn in log:
+            if not conn.resp.headers.get('X-Backend-Data-Timestamp'):
+                continue
             if (conn.resp.headers.get('X-Backend-Durable-Timestamp')
                     == conn.resp.headers.get('X-Backend-Data-Timestamp')):
                 collected_durables.append(conn)
@@ -3030,7 +3461,7 @@ class TestECObjController(ECObjectContro
             {'obj': obj1, 'frag': 11, 'durable': False},  # parity
             {'obj': obj1, 'frag': 12, 'durable': False},  # parity
             {'obj': obj1, 'frag': 13, 'durable': False},  # parity
-        ]  # handoffs not used in this scenario
+        ] + [[]] * self.replicas()  # handoffs all 404
 
         fake_response = self._fake_ec_node_response(list(node_frags))
 
@@ -3044,6 +3475,8 @@ class TestECObjController(ECObjectContro
 
         collected_durables = []
         for conn in log:
+            if not conn.resp.headers.get('X-Backend-Data-Timestamp'):
+                continue
             if (conn.resp.headers.get('X-Backend-Durable-Timestamp')
                     == conn.resp.headers.get('X-Backend-Data-Timestamp')):
                 collected_durables.append(conn)
@@ -3115,9 +3548,18 @@ class TestECObjController(ECObjectContro
         fake_response = self._fake_ec_node_response(list(node_frags))
 
         req = swob.Request.blank('/v1/a/c/o')
-        with capture_http_requests(fake_response):
+        with capture_http_requests(fake_response) as log:
             resp = req.get_response(self.app)
 
+        closed_conn = defaultdict(set)
+        for conn in log:
+            etag = conn.resp.headers.get('X-Object-Sysmeta-Ec-Etag')
+            closed_conn[etag].add(conn.closed)
+        self.assertEqual({
+            obj1['etag']: {False},
+            obj2['etag']: {True},
+        }, closed_conn)
+
         self.assertEqual(resp.status_int, 200)
         self.assertEqual(resp.headers['etag'], obj1['etag'])
         self.assertEqual(md5(resp.body).hexdigest(), obj1['etag'])
@@ -3209,6 +3651,15 @@ class TestECObjController(ECObjectContro
         with capture_http_requests(fake_response) as log:
             resp = req.get_response(self.app)
 
+        closed_conn = defaultdict(set)
+        for conn in log:
+            etag = conn.resp.headers.get('X-Object-Sysmeta-Ec-Etag')
+            closed_conn[etag].add(conn.closed)
+        self.assertEqual({
+            obj1['etag']: {True},
+            obj2['etag']: {False},
+        }, closed_conn)
+
         self.assertEqual(resp.status_int, 200)
         self.assertEqual(resp.headers['etag'], obj2['etag'])
         self.assertEqual(md5(resp.body).hexdigest(), obj2['etag'])
@@ -3217,6 +3668,7 @@ class TestECObjController(ECObjectContro
         # min: proxy will GET 10 non-durable obj1 frags and then 10 obj frags
         self.assertGreaterEqual(len(log), 2 * self.policy.ec_ndata)
 
+    def test_GET_with_missing_durables_and_older_obscured_durables(self):
         # scenario: obj3 has 14 frags but only 2 are durable and these are
         # obscured by two non-durable frags of obj1. There is also a single
         # non-durable frag of obj2. The proxy will need to do at least 10
@@ -3245,7 +3697,7 @@ class TestECObjController(ECObjectContro
             [{'obj': obj3, 'frag': 11, 'durable': False}],
             [{'obj': obj3, 'frag': 12, 'durable': False}],
             [{'obj': obj3, 'frag': 13, 'durable': False}],
-        ]
+        ] + [[]] * self.replicas()  # handoffs 404
 
         fake_response = self._fake_ec_node_response(list(node_frags))
 
@@ -3257,7 +3709,7 @@ class TestECObjController(ECObjectContro
         self.assertEqual(resp.headers['etag'], obj3['etag'])
         self.assertEqual(md5(resp.body).hexdigest(), obj3['etag'])
         self.assertGreaterEqual(len(log), self.policy.ec_ndata + 1)
-        self.assertLessEqual(len(log), self.policy.ec_ndata + 4)
+        self.assertLessEqual(len(log), (self.policy.ec_ndata * 2) + 1)
 
     def test_GET_with_missing_durables_and_older_non_durables(self):
         # scenario: non-durable frags of newer obj1 obscure all frags
@@ -3439,7 +3891,7 @@ class TestECObjController(ECObjectContro
             StubResponse(416, frag_index=4),
             StubResponse(416, frag_index=5),
             StubResponse(416, frag_index=6),
-            # sneak in bogus extra responses
+            # sneak a couple bogus extra responses
             StubResponse(404),
             StubResponse(206, frag_index=8),
             # and then just "enough" more 416's
@@ -3457,8 +3909,10 @@ class TestECObjController(ECObjectContro
             resp = req.get_response(self.app)
 
         self.assertEqual(resp.status_int, 416)
-        # ec_ndata responses that must agree, plus the bogus extras
-        self.assertEqual(len(log), self.policy.ec_ndata + 2)
+        # we're going to engage ndata primaries, plus the bogus extra
+        # self.assertEqual(len(log), self.policy.ec_ndata + 2)
+        self.assertEqual([c.resp.status for c in log],
+                         ([416] * 7) + [404, 206] + ([416] * 3))
 
     def test_GET_with_missing_and_range_unsatisifiable(self):
         responses = [  # not quite ec_ndata frags on primaries
@@ -3598,6 +4052,16 @@ class TestECObjController(ECObjectContro
         with capture_http_requests(get_response) as log:
             resp = req.get_response(self.app)
 
+        closed_conn = defaultdict(set)
+        for conn in log:
+            etag = conn.resp.headers.get('X-Object-Sysmeta-Ec-Etag')
+            closed_conn[etag].add(conn.closed)
+        self.assertEqual({
+            old_etag: {True},
+            new_etag: {False},
+            None: {True},
+        }, dict(closed_conn))
+
         self.assertEqual(resp.status_int, 200)
         self.assertEqual(resp.body, new_data[:segment_size])
         self.assertEqual(len(log), self.policy.ec_ndata + 10)
@@ -3686,7 +4150,7 @@ class TestECObjController(ECObjectContro
         status_codes, body_iter, headers = zip(*responses + [
             (404, [b''], {}) for i in range(
                 self.policy.object_ring.max_more_nodes)])
-        with set_http_connect(*status_codes, body_iter=body_iter,
+        with mocked_http_conn(*status_codes, body_iter=body_iter,
                               headers=headers):
             resp = req.get_response(self.app)
             self.assertEqual(resp.status_int, 200)
@@ -3694,8 +4158,8 @@ class TestECObjController(ECObjectContro
             # resume but won't be able to give us all the right bytes
             self.assertNotEqual(md5(resp.body).hexdigest(), etag)
         error_lines = self.logger.get_lines_for_level('error')
-        self.assertEqual(self.replicas(), len(error_lines))
         nparity = self.policy.ec_nparity
+        self.assertGreater(len(error_lines), nparity)
         for line in error_lines[:nparity]:
             self.assertIn('retrying', line)
         for line in error_lines[nparity:]:
@@ -3706,7 +4170,10 @@ class TestECObjController(ECObjectContro
         test_data = (b'test' * segment_size)[:-333]
         etag = md5(test_data).hexdigest()
         ec_archive_bodies = self._make_ec_archive_bodies(test_data)
-        headers = {'X-Object-Sysmeta-Ec-Etag': etag}
+        headers = {
+            'X-Object-Sysmeta-Ec-Etag': etag,
+            'X-Object-Sysmeta-Ec-Content-Length': len(test_data),
+        }
         self.app.recoverable_node_timeout = 0.05
         # first one is slow
         responses = [(200, SlowBody(ec_archive_bodies[0], 0.1),
@@ -3723,11 +4190,107 @@ class TestECObjController(ECObjectContro
                               headers=headers):
             resp = req.get_response(self.app)
             self.assertEqual(resp.status_int, 200)
-            self.assertTrue(md5(resp.body).hexdigest(), etag)
+            self.assertEqual(md5(resp.body).hexdigest(), etag)
         error_lines = self.logger.get_lines_for_level('error')
         self.assertEqual(1, len(error_lines))
         self.assertIn('retrying', error_lines[0])
 
+    def test_GET_read_timeout_resume_mixed_etag(self):
+        segment_size = self.policy.ec_segment_size
+        test_data2 = (b'blah1' * segment_size)[:-333]
+        test_data1 = (b'test' * segment_size)[:-333]
+        etag2 = md5(test_data2).hexdigest()
+        etag1 = md5(test_data1).hexdigest()
+        ec_archive_bodies2 = self._make_ec_archive_bodies(test_data2)
+        ec_archive_bodies1 = self._make_ec_archive_bodies(test_data1)
+        headers2 = {'X-Object-Sysmeta-Ec-Etag': etag2,
+                    'X-Object-Sysmeta-Ec-Content-Length': len(test_data2),
+                    'X-Backend-Timestamp': self.ts().internal}
+        headers1 = {'X-Object-Sysmeta-Ec-Etag': etag1,
+                    'X-Object-Sysmeta-Ec-Content-Length': len(test_data1),
+                    'X-Backend-Timestamp': self.ts().internal}
+        responses = [
+            # 404
+            (404, [b''], {}),
+            # etag1
+            (200, ec_archive_bodies1[1], self._add_frag_index(1, headers1)),
+            # 404
+            (404, [b''], {}),
+            # etag1
+            (200, SlowBody(ec_archive_bodies1[3], 0.1), self._add_frag_index(
+                3, headers1)),
+            # etag2
+            (200, ec_archive_bodies2[4], self._add_frag_index(4, headers2)),
+            # etag1
+            (200, ec_archive_bodies1[5], self._add_frag_index(5, headers1)),
+            # etag2
+            (200, ec_archive_bodies2[6], self._add_frag_index(6, headers2)),
+            # etag1
+            (200, ec_archive_bodies1[7], self._add_frag_index(7, headers1)),
+            # etag2
+            (200, ec_archive_bodies2[8], self._add_frag_index(8, headers2)),
+            # etag1
+            (200, SlowBody(ec_archive_bodies1[9], 0.1), self._add_frag_index(
+                9, headers1)),
+            # etag2
+            (200, ec_archive_bodies2[10], self._add_frag_index(10, headers2)),
+            # etag1
+            (200, ec_archive_bodies1[11], self._add_frag_index(11, headers1)),
+            # etag2
+            (200, ec_archive_bodies2[12], self._add_frag_index(12, headers2)),
+            # 404
+            (404, [b''], {}),
+            # handoffs start here
+            # etag2
+            (200, ec_archive_bodies2[0], self._add_frag_index(0, headers2)),
+            # 404
+            (404, [b''], {}),
+            # etag1
+            (200, ec_archive_bodies1[2], self._add_frag_index(2, headers1)),
+            # 404
+            (404, [b''], {}),
+            # etag1
+            (200, ec_archive_bodies1[4], self._add_frag_index(4, headers1)),
+            # etag2
+            (200, ec_archive_bodies2[1], self._add_frag_index(1, headers2)),
+            # etag1
+            (200, ec_archive_bodies1[6], self._add_frag_index(6, headers1)),
+            # etag2
+            (200, ec_archive_bodies2[7], self._add_frag_index(7, headers2)),
+            # etag1
+            (200, ec_archive_bodies1[8], self._add_frag_index(8, headers1)),
+            # resume requests start here
+            # 404
+            (404, [b''], {}),
+            # etag2
+            (200, ec_archive_bodies2[3], self._add_frag_index(3, headers2)),
+            # 404
+            (404, [b''], {}),
+            # etag1
+            (200, ec_archive_bodies1[10], self._add_frag_index(10, headers1)),
+            # etag1
+            (200, ec_archive_bodies1[12], self._add_frag_index(12, headers1)),
+        ]
+        self.app.recoverable_node_timeout = 0.01
+        req = swob.Request.blank('/v1/a/c/o')
+        status_codes, body_iter, headers = zip(*responses)
+        with mocked_http_conn(*status_codes, body_iter=body_iter,
+                              headers=headers) as log:
+            resp = req.get_response(self.app)
+            self.assertEqual(resp.status_int, 200)
+            self.assertEqual(md5(resp.body).hexdigest(), etag1)
+        error_lines = self.logger.get_lines_for_level('error')
+        self.assertEqual(2, len(error_lines))
+        for line in error_lines:
+            self.assertIn('retrying', line)
+        etag2_conns = []
+        for conn in log.responses:
+            if conn.headers.get('X-Object-Sysmeta-Ec-Etag') == etag2:
+                etag2_conns.append(conn)
+        self.assertEqual(
+            ([True] * 8) + [False],  # the resumed etag2 doesn't get closed
+            [conn.closed for conn in etag2_conns])
+
     def test_fix_response_HEAD(self):
         headers = {'X-Object-Sysmeta-Ec-Content-Length': '10',
                    'X-Object-Sysmeta-Ec-Etag': 'foo'}
@@ -3811,6 +4374,43 @@ class TestECObjController(ECObjectContro
         self.assertEqual(resp.etag, body_etag)
         self.assertEqual(resp.headers['Accept-Ranges'], 'bytes')
 
+    def test_non_durable_ec_response_bucket(self):
+        ts = self.ts()
+        bucket = obj.ECGetResponseBucket(self.policy, ts)
+        self.assertEqual(bucket.shortfall, self.policy.ec_ndata)
+        for i in range(1, self.policy.ec_ndata - self.policy.ec_nparity + 1):
+            stub_getter = mock.MagicMock(last_status=200, last_headers={
+                'X-Backend-Timestamp': ts.internal,
+                'X-Object-Sysmeta-Ec-Etag': 'the-etag',
+                'X-Object-Sysmeta-Ec-Frag-Index': str(i),
+            })
+            bucket.add_response(stub_getter, None)
+            self.assertEqual(bucket.shortfall, self.policy.ec_ndata - i)
+        self.assertEqual(bucket.shortfall, self.policy.ec_nparity)
+        self.assertFalse(bucket.durable)
+        expectations = (
+            4,  # 7
+            4,  # 8
+            4,  # 9
+            4,  # 10
+            3,  # 11
+            2,  # 12
+            1,  # 13
+            1,  # 14
+        )
+        for i, expected in zip(range(
+                self.policy.ec_ndata - self.policy.ec_nparity + 1,
+                self.policy.object_ring.replica_count + 1), expectations):
+            stub_getter = mock.MagicMock(last_status=200, last_headers={
+                'X-Backend-Timestamp': ts.internal,
+                'X-Object-Sysmeta-Ec-Etag': 'the-etag',
+                'X-Object-Sysmeta-Ec-Frag-Index': str(i),
+            })
+            bucket.add_response(stub_getter, None)
+            msg = 'With %r resp, expected shortfall %s != %s' % (
+                bucket.gets.keys(), expected, bucket.shortfall)
+            self.assertEqual(bucket.shortfall, expected, msg)
+
 
 class TestECFunctions(unittest.TestCase):
     def test_chunk_transformer(self):
@@ -3955,7 +4555,8 @@ class TestECDuplicationObjController(
         # the backend requests will stop at enough ec_ndata responses
         self.assertEqual(
             len(frags), self.policy.ec_ndata,
-            'collected %s frags for etag %s' % (len(frags), etag))
+            'collected %s frags (expected %s) for etag %s' % (
+                len(frags), self.policy.ec_ndata, etag))
 
     # TODO: actually "frags" in node_frags is meaning "node_index" right now
     # in following tests. Reconsidering the name and semantics change needed.
diff -pruN 2.25.0-3/test/unit/proxy/test_server.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/proxy/test_server.py
--- 2.25.0-3/test/unit/proxy/test_server.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/proxy/test_server.py	2020-09-15 21:13:36.000000000 +0000
@@ -173,14 +173,6 @@ def set_node_errors(proxy_app, ring_node
     stats['last_error'] = last_error
 
 
-class FakeMemcacheReturnsNone(FakeMemcache):
-
-    def get(self, key):
-        # Returns None as the timestamp of the container; assumes we're only
-        # using the FakeMemcache for container existence checks.
-        return None
-
-
 @contextmanager
 def save_globals():
     orig_http_connect = getattr(swift.proxy.controllers.base, 'http_connect',
@@ -248,25 +240,27 @@ class TestController(unittest.TestCase):
 
     def setUp(self):
         skip_if_no_xattrs()
+        _test_servers[0]._error_limiting = {}  # clear out errors
         self.account_ring = FakeRing()
         self.container_ring = FakeRing()
         self.memcache = FakeMemcache()
-        app = proxy_server.Application(None, self.memcache,
+        app = proxy_server.Application(None,
                                        account_ring=self.account_ring,
                                        container_ring=self.container_ring)
         self.controller = swift.proxy.controllers.Controller(app)
 
         class FakeReq(object):
-            def __init__(self):
+            def __init__(self, memcache):
                 self.url = "/foo/bar"
                 self.method = "METHOD"
+                self.environ = {"swift.cache": memcache}
 
             def as_referer(self):
                 return self.method + ' ' + self.url
 
         self.account = 'some_account'
         self.container = 'some_container'
-        self.request = FakeReq()
+        self.request = FakeReq(self.memcache)
         self.read_acl = 'read_acl'
         self.write_acl = 'write_acl'
 
@@ -290,29 +284,31 @@ class TestController(unittest.TestCase):
         self.assertEqual(n, nodes)
 
     def test_account_info_container_count(self):
+        cache_key = get_cache_key(self.account)
         with save_globals():
             set_http_connect(200, count=123)
             partition, nodes, count = \
-                self.controller.account_info(self.account)
+                self.controller.account_info(self.account, self.request)
             self.assertEqual(count, 123)
         with save_globals():
             set_http_connect(200, count='123')
+            del self.request.environ['swift.infocache'][cache_key]
             partition, nodes, count = \
-                self.controller.account_info(self.account)
+                self.controller.account_info(self.account, self.request)
             self.assertEqual(count, 123)
         with save_globals():
-            cache_key = get_cache_key(self.account)
             account_info = {'status': 200, 'container_count': 1234}
             self.memcache.set(cache_key, account_info)
+            del self.request.environ['swift.infocache'][cache_key]
             partition, nodes, count = \
-                self.controller.account_info(self.account)
+                self.controller.account_info(self.account, self.request)
             self.assertEqual(count, 1234)
         with save_globals():
-            cache_key = get_cache_key(self.account)
             account_info = {'status': 200, 'container_count': '1234'}
             self.memcache.set(cache_key, account_info)
+            del self.request.environ['swift.infocache'][cache_key]
             partition, nodes, count = \
-                self.controller.account_info(self.account)
+                self.controller.account_info(self.account, self.request)
             self.assertEqual(count, 1234)
 
     def test_make_requests(self):
@@ -322,7 +318,7 @@ class TestController(unittest.TestCase):
                 self.controller.account_info(self.account, self.request)
             set_http_connect(201, raise_timeout_exc=True)
             self.controller._make_request(
-                nodes, partition, 'POST', '/', '', '', None,
+                nodes, partition, 'POST', '/', {}, '', None,
                 self.controller.app.logger.thread_locals)
 
     # tests if 200 is cached and used
@@ -407,7 +403,6 @@ class TestController(unittest.TestCase):
 
     def test_account_info_no_account(self):
         with save_globals():
-            self.memcache.store = {}
             set_http_connect(404, 404, 404)
             partition, nodes, count = \
                 self.controller.account_info(self.account, self.request)
@@ -514,13 +509,13 @@ class TestController(unittest.TestCase):
 
     def test_get_account_info_returns_values_as_strings(self):
         app = mock.MagicMock()
-        app.memcache = mock.MagicMock()
-        app.memcache.get = mock.MagicMock()
-        app.memcache.get.return_value = {
+        memcache = mock.MagicMock()
+        memcache.get = mock.MagicMock()
+        memcache.get.return_value = {
             u'foo': u'\u2603',
             u'meta': {u'bar': u'\u2603'},
             u'sysmeta': {u'baz': u'\u2603'}}
-        env = {'PATH_INFO': '/v1/a'}
+        env = {'PATH_INFO': '/v1/a', 'swift.cache': memcache}
         ai = get_account_info(env, app)
 
         # Test info is returned as strings
@@ -539,14 +534,14 @@ class TestController(unittest.TestCase):
 
     def test_get_container_info_returns_values_as_strings(self):
         app = mock.MagicMock()
-        app.memcache = mock.MagicMock()
-        app.memcache.get = mock.MagicMock()
-        app.memcache.get.return_value = {
+        memcache = mock.MagicMock()
+        memcache.get = mock.MagicMock()
+        memcache.get.return_value = {
             u'foo': u'\u2603',
             u'meta': {u'bar': u'\u2603'},
             u'sysmeta': {u'baz': u'\u2603'},
             u'cors': {u'expose_headers': u'\u2603'}}
-        env = {'PATH_INFO': '/v1/a/c'}
+        env = {'PATH_INFO': '/v1/a/c', 'swift.cache': memcache}
         ci = get_container_info(env, app)
 
         # Test info is returned as strings
@@ -578,7 +573,7 @@ class TestProxyServerConfiguration(unitt
     def _make_app(self, conf):
         self.logger.clear()
         # helper function to instantiate a proxy server instance
-        return proxy_server.Application(conf, FakeMemcache(),
+        return proxy_server.Application(conf,
                                         container_ring=FakeRing(),
                                         account_ring=FakeRing(),
                                         logger=self.logger)
@@ -634,7 +629,6 @@ class TestProxyServer(unittest.TestCase)
 
     def test_get_object_ring(self):
         baseapp = proxy_server.Application({},
-                                           FakeMemcache(),
                                            container_ring=FakeRing(),
                                            account_ring=FakeRing())
         with patch_policies([
@@ -664,7 +658,7 @@ class TestProxyServer(unittest.TestCase)
             def get_controller(self, path):
                 raise Exception('this shouldn\'t be caught')
 
-        app = MyApp(None, FakeMemcache(), account_ring=FakeRing(),
+        app = MyApp(None, account_ring=FakeRing(),
                     container_ring=FakeRing())
         req = Request.blank('/v1/account', environ={'REQUEST_METHOD': 'HEAD'})
         app.update_request(req)
@@ -673,7 +667,6 @@ class TestProxyServer(unittest.TestCase)
 
     def test_internal_method_request(self):
         baseapp = proxy_server.Application({},
-                                           FakeMemcache(),
                                            container_ring=FakeRing(),
                                            account_ring=FakeRing())
         resp = baseapp.handle_request(
@@ -682,7 +675,6 @@ class TestProxyServer(unittest.TestCase)
 
     def test_inexistent_method_request(self):
         baseapp = proxy_server.Application({},
-                                           FakeMemcache(),
                                            container_ring=FakeRing(),
                                            account_ring=FakeRing())
         resp = baseapp.handle_request(
@@ -691,7 +683,6 @@ class TestProxyServer(unittest.TestCase)
 
     def test_private_method_request(self):
         baseapp = proxy_server.Application({},
-                                           FakeMemcache(),
                                            container_ring=FakeRing(),
                                            account_ring=FakeRing())
         baseapp.logger = debug_logger()
@@ -722,12 +713,13 @@ class TestProxyServer(unittest.TestCase)
         # set account info
         fake_cache = FakeMemcache()
         fake_cache.store[get_cache_key('a')] = {'status': 200}
-        app = proxy_server.Application({}, fake_cache,
+        app = proxy_server.Application({},
                                        container_ring=FakeRing(),
                                        account_ring=FakeRing())
         # build internal container request
         container = get_reserved_name('c')
-        req = Request.blank('/v1/a/%s' % container)
+        req = Request.blank('/v1/a/%s' % container,
+                            {'swift.cache': fake_cache})
         app.update_request(req)
 
         # try client request to reserved name
@@ -748,7 +740,7 @@ class TestProxyServer(unittest.TestCase)
             called[0] = True
         with save_globals():
             set_http_connect(200)
-            app = proxy_server.Application(None, FakeMemcache(),
+            app = proxy_server.Application(None,
                                            account_ring=FakeRing(),
                                            container_ring=FakeRing())
             req = Request.blank('/v1/a')
@@ -763,7 +755,7 @@ class TestProxyServer(unittest.TestCase)
         def authorize(req):
             called[0] = True
             return HTTPUnauthorized(request=req)
-        app = proxy_server.Application(None, FakeMemcache(),
+        app = proxy_server.Application(None,
                                        account_ring=FakeRing(),
                                        container_ring=FakeRing())
         req = Request.blank('/v1/a')
@@ -776,7 +768,7 @@ class TestProxyServer(unittest.TestCase)
         swift_dir = mkdtemp()
         try:
             baseapp = proxy_server.Application({'swift_dir': swift_dir},
-                                               FakeMemcache(), FakeLogger(),
+                                               FakeLogger(),
                                                FakeRing(), FakeRing())
             resp = baseapp.handle_request(
                 Request.blank('/', environ={'CONTENT_LENGTH': '-1'}))
@@ -794,7 +786,7 @@ class TestProxyServer(unittest.TestCase)
         try:
             logger = FakeLogger()
             baseapp = proxy_server.Application({'swift_dir': swift_dir},
-                                               FakeMemcache(), logger,
+                                               logger,
                                                container_ring=FakeLogger(),
                                                account_ring=FakeRing())
             baseapp.handle_request(
@@ -814,7 +806,7 @@ class TestProxyServer(unittest.TestCase)
         try:
             logger = FakeLogger()
             baseapp = proxy_server.Application({'swift_dir': swift_dir},
-                                               FakeMemcache(), logger,
+                                               logger,
                                                container_ring=FakeLogger(),
                                                account_ring=FakeRing())
             baseapp.handle_request(
@@ -832,7 +824,6 @@ class TestProxyServer(unittest.TestCase)
             baseapp = proxy_server.Application({'swift_dir': swift_dir,
                                                 'deny_host_headers':
                                                 'invalid_host.com'},
-                                               FakeMemcache(),
                                                container_ring=FakeLogger(),
                                                account_ring=FakeRing())
             resp = baseapp.handle_request(
@@ -844,7 +835,6 @@ class TestProxyServer(unittest.TestCase)
 
     def test_node_timing(self):
         baseapp = proxy_server.Application({'sorting_method': 'timing'},
-                                           FakeMemcache(),
                                            container_ring=FakeRing(),
                                            account_ring=FakeRing())
         self.assertEqual(baseapp.node_timings, {})
@@ -876,7 +866,6 @@ class TestProxyServer(unittest.TestCase)
         nodes = list(nodes)
         conf = dict(conf, policy_config=policy_conf)
         baseapp = proxy_server.Application(conf,
-                                           FakeMemcache(),
                                            logger=FakeLogger(),
                                            container_ring=FakeRing(),
                                            account_ring=FakeRing())
@@ -1031,7 +1020,13 @@ class TestProxyServer(unittest.TestCase)
         req = Request.blank('/v1/account', environ={'REQUEST_METHOD': 'GET'})
 
         def fake_iter_nodes(*arg, **karg):
-            return iter(nodes)
+            class FakeNodeIter(object):
+                num_primary_nodes = 3
+
+                def __iter__(self):
+                    return iter(nodes)
+
+            return FakeNodeIter()
 
         class FakeConn(object):
             def __init__(self, ip, *args, **kargs):
@@ -1070,11 +1065,12 @@ class TestProxyServer(unittest.TestCase)
                 app_conf = {'concurrent_gets': 'on',
                             'concurrency_timeout': 0}
                 baseapp = proxy_server.Application(app_conf,
-                                                   FakeMemcache(),
                                                    container_ring=FakeRing(),
                                                    account_ring=FakeRing())
-                self.assertTrue(baseapp.concurrent_gets)
-                self.assertEqual(baseapp.concurrency_timeout, 0)
+                policy_opts = baseapp.get_policy_options(None)
+                self.assertTrue(policy_opts.concurrent_gets)
+                self.assertEqual(policy_opts.concurrency_timeout, 0)
+
                 baseapp.update_request(req)
                 resp = baseapp.handle_request(req)
 
@@ -1095,10 +1091,10 @@ class TestProxyServer(unittest.TestCase)
                 # Now lets set the concurrency_timeout
                 app_conf['concurrency_timeout'] = 2
                 baseapp = proxy_server.Application(app_conf,
-                                                   FakeMemcache(),
                                                    container_ring=FakeRing(),
                                                    account_ring=FakeRing())
-                self.assertEqual(baseapp.concurrency_timeout, 2)
+                policy_opts = baseapp.get_policy_options(None)
+                self.assertEqual(policy_opts.concurrency_timeout, 2)
                 baseapp.update_request(req)
                 resp = baseapp.handle_request(req)
 
@@ -1106,7 +1102,7 @@ class TestProxyServer(unittest.TestCase)
                 self.assertEqual(resp.body, b'Response from 127.0.0.2')
 
     def test_info_defaults(self):
-        app = proxy_server.Application({}, FakeMemcache(),
+        app = proxy_server.Application({},
                                        account_ring=FakeRing(),
                                        container_ring=FakeRing())
 
@@ -1121,7 +1117,7 @@ class TestProxyServer(unittest.TestCase)
 
     def test_get_info_controller(self):
         req = Request.blank('/info')
-        app = proxy_server.Application({}, FakeMemcache(),
+        app = proxy_server.Application({},
                                        account_ring=FakeRing(),
                                        container_ring=FakeRing())
 
@@ -1138,7 +1134,7 @@ class TestProxyServer(unittest.TestCase)
     def test_exception_occurred(self):
         def do_test(additional_info):
             logger = debug_logger('test')
-            app = proxy_server.Application({}, FakeMemcache(),
+            app = proxy_server.Application({},
                                            account_ring=FakeRing(),
                                            container_ring=FakeRing(),
                                            logger=logger)
@@ -1172,7 +1168,7 @@ class TestProxyServer(unittest.TestCase)
     def test_error_occurred(self):
         def do_test(msg):
             logger = debug_logger('test')
-            app = proxy_server.Application({}, FakeMemcache(),
+            app = proxy_server.Application({},
                                            account_ring=FakeRing(),
                                            container_ring=FakeRing(),
                                            logger=logger)
@@ -1198,7 +1194,7 @@ class TestProxyServer(unittest.TestCase)
 
     def test_error_limit_methods(self):
         logger = debug_logger('test')
-        app = proxy_server.Application({}, FakeMemcache(),
+        app = proxy_server.Application({},
                                        account_ring=FakeRing(),
                                        container_ring=FakeRing(),
                                        logger=logger)
@@ -1260,7 +1256,7 @@ class TestProxyServer(unittest.TestCase)
         self.assertEqual(4, node_error_count(app, node))
 
     def test_valid_api_version(self):
-        app = proxy_server.Application({}, FakeMemcache(),
+        app = proxy_server.Application({},
                                        account_ring=FakeRing(),
                                        container_ring=FakeRing())
 
@@ -1341,14 +1337,31 @@ class TestProxyServerLoading(unittest.Te
         }
         for policy in POLICIES:
             policy.object_ring = FakeRing()
-        app = proxy_server.Application(conf, FakeMemcache(), debug_logger(),
+        app = proxy_server.Application(conf, debug_logger(),
                                        FakeRing(), FakeRing())
         self.assertEqual(app.node_timeout, 2.3)
         self.assertEqual(app.recoverable_node_timeout, 1.4)
         self.assertEqual(app.conn_timeout, 0.7)
         self.assertEqual(app.client_timeout, 1.7)
         self.assertEqual(app.post_quorum_timeout, 0.3)
-        self.assertEqual(app.concurrency_timeout, 0.2)
+        self.assertEqual(app.get_policy_options(
+            None).concurrency_timeout, 0.2)
+
+    def test_concurrent_ec_options(self):
+        conf = {
+            'concurrent_gets': 'on',
+            'concurrency_timeout': '0.5',
+            'concurrent_ec_extra_requests': '4',
+        }
+        for policy in POLICIES:
+            policy.object_ring = FakeRing()
+        app = proxy_server.Application(conf, debug_logger(),
+                                       FakeRing(), FakeRing())
+        for policy in POLICIES:
+            policy_opts = app.get_policy_options(policy)
+            self.assertEqual(policy_opts.concurrent_ec_extra_requests, 4)
+            self.assertEqual(policy_opts.concurrent_gets, True)
+            self.assertEqual(policy_opts.concurrency_timeout, 0.5)
 
     def test_load_policy_rings(self):
         for policy in POLICIES:
@@ -1440,6 +1453,7 @@ class TestProxyServerConfigLoading(unitt
 
     def setUp(self):
         skip_if_no_xattrs()
+        _test_servers[0]._error_limiting = {}  # clear out errors
         self.tempdir = mkdtemp()
         account_ring_path = os.path.join(self.tempdir, 'account.ring.gz')
         write_fake_ring(account_ring_path)
@@ -1527,18 +1541,21 @@ class TestProxyServerConfigLoading(unitt
         write_affinity = r1
         write_affinity_node_count = 1 * replicas
         write_affinity_handoff_delete_count = 4
+        rebalance_missing_suppression_count = 2
         """
         expected_default = {"read_affinity": "",
                             "sorting_method": "shuffle",
                             "write_affinity": "",
                             "write_affinity_node_count_fn": 6,
-                            "write_affinity_handoff_delete_count": None}
+                            "write_affinity_handoff_delete_count": None,
+                            "rebalance_missing_suppression_count": 1}
         exp_options = {None: expected_default,
                        POLICIES[0]: {"read_affinity": "r1=100",
                                      "sorting_method": "affinity",
                                      "write_affinity": "r1",
                                      "write_affinity_node_count_fn": 3,
-                                     "write_affinity_handoff_delete_count": 4},
+                                     "write_affinity_handoff_delete_count": 4,
+                                     "rebalance_missing_suppression_count": 2},
                        POLICIES[1]: expected_default}
         exp_is_local = {POLICIES[0]: [({'region': 1, 'zone': 2}, True),
                                       ({'region': 2, 'zone': 1}, False)],
@@ -1551,25 +1568,53 @@ class TestProxyServerConfigLoading(unitt
             "ProxyOverrideOptions({}, {'sorting_method': 'shuffle', "
             "'read_affinity': '', 'write_affinity': '', "
             "'write_affinity_node_count': '2 * replicas', "
-            "'write_affinity_handoff_delete_count': None})",
+            "'write_affinity_handoff_delete_count': None, "
+            "'rebalance_missing_suppression_count': 1, "
+            "'concurrent_gets': False, 'concurrency_timeout': 0.5, "
+            "'concurrent_ec_extra_requests': 0"
+            "}, app)",
             repr(default_options))
         self.assertEqual(default_options, eval(repr(default_options), {
-            'ProxyOverrideOptions': default_options.__class__}))
+            'ProxyOverrideOptions': default_options.__class__, 'app': app}))
 
         policy_0_options = app.get_policy_options(POLICIES[0])
         self.assertEqual(
             "ProxyOverrideOptions({}, {'sorting_method': 'affinity', "
             "'read_affinity': 'r1=100', 'write_affinity': 'r1', "
             "'write_affinity_node_count': '1 * replicas', "
-            "'write_affinity_handoff_delete_count': 4})",
+            "'write_affinity_handoff_delete_count': 4, "
+            "'rebalance_missing_suppression_count': 2, "
+            "'concurrent_gets': False, 'concurrency_timeout': 0.5, "
+            "'concurrent_ec_extra_requests': 0"
+            "}, app)",
             repr(policy_0_options))
         self.assertEqual(policy_0_options, eval(repr(policy_0_options), {
-            'ProxyOverrideOptions': policy_0_options.__class__}))
+            'ProxyOverrideOptions': default_options.__class__, 'app': app}))
         self.assertNotEqual(default_options, policy_0_options)
 
         policy_1_options = app.get_policy_options(POLICIES[1])
         self.assertIs(default_options, policy_1_options)
 
+    def test_per_policy_conf_equality(self):
+        conf_sections = """
+        [app:proxy-server]
+        use = egg:swift#proxy
+        """
+        app = self._write_conf_and_load_app(conf_sections)
+        self.assertIs(app.get_policy_options(None),
+                      app.get_policy_options(POLICIES[0]))
+
+        conf_sections = """
+        [app:proxy-server]
+        use = egg:swift#proxy
+
+        [proxy-server:policy:0]
+        concurrent_ec_extra_requests = 1
+        """
+        app = self._write_conf_and_load_app(conf_sections)
+        self.assertNotEqual(app.get_policy_options(None),
+                            app.get_policy_options(POLICIES[0]))
+
     def test_per_policy_conf_inherits_defaults(self):
         conf_sections = """
         [app:proxy-server]
@@ -1997,6 +2042,39 @@ class TestProxyServerConfigLoading(unitt
         do_test('uno')
         do_test('0.0')
 
+    def test_per_policy_conf_overrides_default_concurrency_settings(self):
+        conf_sections = """
+        [app:proxy-server]
+        use = egg:swift#proxy
+        concurrent_gets = True
+        concurrency_timeout = 0.5
+
+        [proxy-server:policy:0]
+        concurrent_gets = off
+        concurrency_timeout = 0.6
+
+        [proxy-server:policy:1]
+        concurrent_gets = True
+        concurrency_timeout = 0.3
+        concurrent_ec_extra_requests = 1
+        """
+        exp_options = {
+            None: {
+                "concurrent_gets": True,
+                "concurrency_timeout": 0.5,
+                "concurrent_ec_extra_requests": 0,
+            }, POLICIES[0]: {
+                "concurrent_gets": False,
+                "concurrency_timeout": 0.6,
+                "concurrent_ec_extra_requests": 0,
+            }, POLICIES[1]: {
+                "concurrent_gets": True,
+                "concurrency_timeout": 0.3,
+                "concurrent_ec_extra_requests": 1,
+            }}
+        app = self._write_conf_and_load_app(conf_sections)
+        self._check_policy_options(app, exp_options, {})
+
 
 class TestProxyServerConfigStringLoading(TestProxyServerConfigLoading):
     # The proxy may be loaded from a conf string rather than a conf file, for
@@ -2023,7 +2101,6 @@ class BaseTestObjectController(object):
                 kwargs['raise_exc'] = raise_exc
 
             set_http_connect(*statuses, **kwargs)
-            self.app.memcache.store = {}
             req = Request.blank('/v1/a/c/o',
                                 headers={'Content-Length': '0',
                                          'Content-Type': 'text/plain'})
@@ -2036,7 +2113,6 @@ class BaseTestObjectController(object):
 
             # repeat test
             set_http_connect(*statuses, **kwargs)
-            self.app.memcache.store = {}
             req = Request.blank('/v1/a/c/o',
                                 headers={'Content-Length': '0',
                                          'Content-Type': 'text/plain'})
@@ -2170,8 +2246,9 @@ class TestReplicatedObjectController(
     """
     def setUp(self):
         skip_if_no_xattrs()
+        _test_servers[0]._error_limiting = {}  # clear out errors
         self.app = proxy_server.Application(
-            None, FakeMemcache(),
+            None,
             logger=debug_logger('proxy-ut'),
             account_ring=FakeRing(),
             container_ring=FakeRing())
@@ -3023,7 +3100,6 @@ class TestReplicatedObjectController(
             req = Request.blank('/v1/a/c/o.jpg', {})
             req.content_length = 0
             self.app.update_request(req)
-            self.app.memcache.store = {}
             res = controller.PUT(req)
             self.assertEqual(test_errors, [])
             self.assertTrue(res.status.startswith('201 '), res.status)
@@ -3052,7 +3128,6 @@ class TestReplicatedObjectController(
             req.content_length = 1
             req.body = 'a'
             self.app.update_request(req)
-            self.app.memcache.store = {}
             res = controller.PUT(req)
             self.assertEqual(test_errors, [])
             self.assertTrue(res.status.startswith('201 '))
@@ -3070,7 +3145,7 @@ class TestReplicatedObjectController(
         # not be used in ring order is if affinity is respected.
         with mock.patch('swift.proxy.server.shuffle', lambda x: x):
             app = proxy_server.Application(
-                conf, FakeMemcache(),
+                conf,
                 logger=debug_logger('proxy-ut'),
                 account_ring=FakeRing(),
                 container_ring=FakeRing())
@@ -3086,7 +3161,6 @@ class TestReplicatedObjectController(
                 req = Request.blank(
                     '/v1/a/c/o.jpg', method='PUT', body='a',
                     headers={'X-Backend-Storage-Policy-Index': str(policy)})
-                app.memcache.store = {}
                 res = controller.PUT(req)
         self.assertTrue(res.status.startswith('201 '))
         self.assertEqual(3, len(written_to))
@@ -3155,7 +3229,6 @@ class TestReplicatedObjectController(
             req = Request.blank('/v1/a/c/o.jpg', {})
             req.content_length = 1
             req.body = 'a'
-            self.app.memcache.store = {}
             res = controller.PUT(req)
             self.assertTrue(res.status.startswith('201 '))
 
@@ -3554,7 +3627,7 @@ class TestReplicatedObjectController(
             with open(os.path.join(swift_dir, 'mime.types'), 'w') as fp:
                 fp.write('foo/bar foo\n')
             proxy_server.Application({'swift_dir': swift_dir},
-                                     FakeMemcache(), FakeLogger(),
+                                     FakeLogger(),
                                      FakeRing(), FakeRing())
             self.assertEqual(proxy_server.mimetypes.guess_type('blah.foo')[0],
                              'foo/bar')
@@ -3573,7 +3646,6 @@ class TestReplicatedObjectController(
                 req = Request.blank('/v1/a/c/o.jpg', {})
                 req.content_length = 0
                 self.app.update_request(req)
-                self.app.memcache.store = {}
                 res = controller.PUT(req)
                 expected = str(expected)
                 self.assertEqual(res.status[:len(expected)], expected)
@@ -3590,7 +3662,6 @@ class TestReplicatedObjectController(
 
             def test_status_map(statuses, expected):
                 set_http_connect(*statuses)
-                self.app.memcache.store = {}
                 req = Request.blank('/v1/a/c/o.jpg', {})
                 req.content_length = 0
                 self.app.update_request(req)
@@ -3620,7 +3691,6 @@ class TestReplicatedObjectController(
                 self.app, 'account', 'container', 'object')
 
             def test_status_map(statuses, expected):
-                self.app.memcache.store = {}
                 set_http_connect(*statuses)
                 req = Request.blank('/v1/a/c/o.jpg',
                                     environ={'REQUEST_METHOD': 'PUT'},
@@ -3666,7 +3736,6 @@ class TestReplicatedObjectController(
                 self.app, 'account', 'container', 'object')
 
             def test_status_map(statuses, expected):
-                self.app.memcache.store = {}
                 set_http_connect(*statuses)
                 req = Request.blank('/v1/a/c/o.jpg', {})
                 req.content_length = 0
@@ -3686,7 +3755,6 @@ class TestReplicatedObjectController(
         with save_globals():
             def test_status_map(statuses, expected):
                 set_http_connect(*statuses)
-                self.app.memcache.store = {}
                 req = Request.blank('/v1/a/c/o', {}, method='POST',
                                     headers={'Content-Type': 'foo/bar'})
                 self.app.update_request(req)
@@ -3711,7 +3779,6 @@ class TestReplicatedObjectController(
         self.app.sort_nodes = lambda nodes, *args, **kwargs: nodes
 
         def do_test(resp_headers):
-            self.app.memcache.store = {}
             backend_requests = []
 
             def capture_requests(ip, port, method, path, headers, *args,
@@ -3779,7 +3846,6 @@ class TestReplicatedObjectController(
             self.assertEqual(container_headers, expected)
 
             # and again with policy override
-            self.app.memcache.store = {}
             backend_requests = []
             req = Request.blank('/v1/a/c/o', {}, method='POST',
                                 headers={'X-Object-Meta-Color': 'Blue',
@@ -3823,7 +3889,6 @@ class TestReplicatedObjectController(
         self.app.recheck_updating_shard_ranges = 0
 
         def do_test(method, sharding_state):
-            self.app.memcache.store = {}
             req = Request.blank('/v1/a/c/o', {}, method=method, body='',
                                 headers={'Content-Type': 'text/plain'})
 
@@ -3918,9 +3983,9 @@ class TestReplicatedObjectController(
         self.app.recheck_updating_shard_ranges = 3600
 
         def do_test(method, sharding_state):
-            self.app.memcache.store = {}
-            req = Request.blank('/v1/a/c/o', {}, method=method, body='',
-                                headers={'Content-Type': 'text/plain'})
+            req = Request.blank(
+                '/v1/a/c/o', {'swift.cache': FakeMemcache()},
+                method=method, body='', headers={'Content-Type': 'text/plain'})
 
             # we want the container_info response to say policy index of 1 and
             # sharding state
@@ -3977,8 +4042,8 @@ class TestReplicatedObjectController(
                 headers={'X-Backend-Record-Type': 'shard'})
 
             cache_key = 'shard-updating/a/c'
-            self.assertIn(cache_key, self.app.memcache.store)
-            self.assertEqual(self.app.memcache.store[cache_key],
+            self.assertIn(cache_key, req.environ['swift.cache'].store)
+            self.assertEqual(req.environ['swift.cache'].store[cache_key],
                              [dict(sr) for sr in shard_ranges])
             self.assertIn(cache_key, req.environ.get('swift.infocache'))
             self.assertEqual(req.environ['swift.infocache'][cache_key],
@@ -4037,9 +4102,11 @@ class TestReplicatedObjectController(
                 utils.ShardRange(
                     '.shards_a/c_nope', utils.Timestamp.now(), 'u', ''),
             ]
-            self.app.memcache.store = {'shard-updating/a/c': tuple(
-                dict(shard_range) for shard_range in shard_ranges)}
-            req = Request.blank('/v1/a/c/o', {}, method=method, body='',
+            cache = FakeMemcache()
+            cache.set('shard-updating/a/c', tuple(
+                dict(shard_range) for shard_range in shard_ranges))
+            req = Request.blank('/v1/a/c/o', {'swift.cache': cache},
+                                method=method, body='',
                                 headers={'Content-Type': 'text/plain'})
 
             # we want the container_info response to say policy index of 1 and
@@ -4122,7 +4189,6 @@ class TestReplicatedObjectController(
         with save_globals():
             def test_status_map(statuses, expected):
                 set_http_connect(*statuses)
-                self.app.memcache.store = {}
                 req = Request.blank('/v1/a/c/o', {'REQUEST_METHOD': 'DELETE'})
                 self.app.update_request(req)
                 res = req.get_response(self.app)
@@ -4139,7 +4205,6 @@ class TestReplicatedObjectController(
         with save_globals():
             def test_status_map(statuses, expected):
                 set_http_connect(*statuses)
-                self.app.memcache.store = {}
                 req = Request.blank('/v1/a/c/o', {'REQUEST_METHOD': 'HEAD'})
                 self.app.update_request(req)
                 res = req.get_response(self.app)
@@ -4170,7 +4235,6 @@ class TestReplicatedObjectController(
             def test_status_map(statuses, expected, timestamps,
                                 expected_timestamp):
                 set_http_connect(*statuses, timestamps=timestamps)
-                self.app.memcache.store = {}
                 req = Request.blank('/v1/a/c/o', {'REQUEST_METHOD': 'HEAD'},
                                     headers={'x-newest': 'true'})
                 self.app.update_request(req)
@@ -4201,7 +4265,6 @@ class TestReplicatedObjectController(
             def test_status_map(statuses, expected, timestamps,
                                 expected_timestamp):
                 set_http_connect(*statuses, timestamps=timestamps)
-                self.app.memcache.store = {}
                 req = Request.blank('/v1/a/c/o', {'REQUEST_METHOD': 'GET'},
                                     headers={'x-newest': 'true'})
                 self.app.update_request(req)
@@ -4228,7 +4291,6 @@ class TestReplicatedObjectController(
             def test_status_map(statuses, expected, timestamps,
                                 expected_timestamp):
                 set_http_connect(*statuses, timestamps=timestamps)
-                self.app.memcache.store = {}
                 req = Request.blank('/v1/a/c/o', {'REQUEST_METHOD': 'HEAD'})
                 self.app.update_request(req)
                 res = req.get_response(self.app)
@@ -4410,6 +4472,7 @@ class TestReplicatedObjectController(
 
             req = Request.blank('/v1/a/c/o',
                                 environ={'REQUEST_METHOD': 'PUT',
+                                         'swift.cache': FakeMemcache(),
                                          'wsgi.input': SlowBody()},
                                 headers={'Content-Length': '4',
                                          'Content-Type': 'text/plain'})
@@ -4419,11 +4482,8 @@ class TestReplicatedObjectController(
             resp = req.get_response(self.app)
             self.assertEqual(resp.status_int, 201)
             self.app.client_timeout = 0.05
-            req = Request.blank('/v1/a/c/o',
-                                environ={'REQUEST_METHOD': 'PUT',
-                                         'wsgi.input': SlowBody()},
-                                headers={'Content-Length': '4',
-                                         'Content-Type': 'text/plain'})
+
+            req.environ['wsgi.input'] = SlowBody()  # Need a fresh instance
             self.app.update_request(req)
             set_http_connect(201, 201, 201)
             #                obj  obj  obj
@@ -4537,7 +4597,8 @@ class TestReplicatedObjectController(
             for dev in object_ring.devs:
                 dev['ip'] = '127.0.0.1'
                 dev['port'] = 1
-            req = Request.blank('/v1/a/c/o', environ={'REQUEST_METHOD': 'GET'})
+            req = Request.blank('/v1/a/c/o', environ={
+                'REQUEST_METHOD': 'GET', 'swift.cache': FakeMemcache()})
             self.app.update_request(req)
 
             self.app.recoverable_node_timeout = 0.1
@@ -4561,7 +4622,6 @@ class TestReplicatedObjectController(
             resp = req.get_response(self.app)
             self.assertEqual(resp.body, b'lalala')
 
-            req = Request.blank('/v1/a/c/o', environ={'REQUEST_METHOD': 'GET'})
             set_http_connect(200, 200, 200, body=b'lalala',
                              slow=[1.0, 1.0], etags=['a', 'b', 'b'])
             resp = req.get_response(self.app)
@@ -4605,7 +4665,6 @@ class TestReplicatedObjectController(
 
     def test_node_request_setting(self):
         baseapp = proxy_server.Application({'request_node_count': '3'},
-                                           FakeMemcache(),
                                            container_ring=FakeRing(),
                                            account_ring=FakeRing())
         self.assertEqual(baseapp.request_node_count(3), 3)
@@ -4718,12 +4777,21 @@ class TestReplicatedObjectController(
                 object_ring.max_more_nodes = 0
 
     def test_iter_nodes_calls_sort_nodes(self):
-        with mock.patch.object(self.app, 'sort_nodes') as sort_nodes:
+        called = []
+
+        def fake_sort_nodes(nodes, **kwargs):
+            # caller might mutate the list we return during iteration, we're
+            # interested in the value as of call time
+            called.append(mock.call(list(nodes), **kwargs))
+            return nodes
+        with mock.patch.object(self.app, 'sort_nodes',
+                               side_effect=fake_sort_nodes):
             object_ring = self.app.get_object_ring(None)
             for node in self.app.iter_nodes(object_ring, 0):
                 pass
-            sort_nodes.assert_called_once_with(
-                object_ring.get_part_nodes(0), policy=None)
+            self.assertEqual(called, [
+                mock.call(object_ring.get_part_nodes(0), policy=None)
+            ])
 
     def test_iter_nodes_skips_error_limited(self):
         with mock.patch.object(self.app, 'sort_nodes',
@@ -4939,7 +5007,6 @@ class TestReplicatedObjectController(
 
     def test_acc_or_con_missing_returns_404(self):
         with save_globals():
-            self.app.memcache = FakeMemcacheReturnsNone()
             self.app._error_limiting = {}
             controller = ReplicatedObjectController(
                 self.app, 'account', 'container', 'object')
@@ -5036,7 +5103,6 @@ class TestReplicatedObjectController(
 
     def test_PUT_POST_requires_container_exist(self):
         with save_globals():
-            self.app.memcache = FakeMemcacheReturnsNone()
             controller = ReplicatedObjectController(
                 self.app, 'account', 'container', 'object')
 
@@ -5194,17 +5260,21 @@ class TestReplicatedObjectController(
         with save_globals():
             controller = ReplicatedObjectController(
                 self.app, 'account', 'container', 'object')
+            cache = FakeMemcache()
             set_http_connect(200, 200, 201, 201, 201)
             #                acct cont obj  obj  obj
-            req = Request.blank('/v1/a/c/o', environ={'REQUEST_METHOD': 'PUT'},
-                                headers={'Content-Length': '0'})
+            req = Request.blank(
+                '/v1/a/c/o',
+                environ={'REQUEST_METHOD': 'PUT', 'swift.cache': cache},
+                headers={'Content-Length': '0'})
             self.app.update_request(req)
             resp = controller.PUT(req)
             self.assertEqual(resp.status_int, 201)
 
             set_http_connect(201, 201, 201)
             req = Request.blank(
-                '/v1/a/c/o', environ={'REQUEST_METHOD': 'PUT'},
+                '/v1/a/c/o',
+                environ={'REQUEST_METHOD': 'PUT', 'swift.cache': cache},
                 headers={'Content-Length': '0',
                          'X-Object-Meta-' + (
                              'a' * constraints.MAX_META_NAME_LENGTH): 'v'})
@@ -5213,7 +5283,8 @@ class TestReplicatedObjectController(
             self.assertEqual(resp.status_int, 201)
             set_http_connect(201, 201, 201)
             req = Request.blank(
-                '/v1/a/c/o', environ={'REQUEST_METHOD': 'PUT'},
+                '/v1/a/c/o',
+                environ={'REQUEST_METHOD': 'PUT', 'swift.cache': cache},
                 headers={
                     'Content-Length': '0',
                     'X-Object-Meta-' + (
@@ -5223,16 +5294,19 @@ class TestReplicatedObjectController(
             self.assertEqual(resp.status_int, 400)
 
             set_http_connect(201, 201, 201)
-            req = Request.blank('/v1/a/c/o', environ={'REQUEST_METHOD': 'PUT'},
-                                headers={'Content-Length': '0',
-                                         'X-Object-Meta-Too-Long': 'a' *
-                                         constraints.MAX_META_VALUE_LENGTH})
+            req = Request.blank(
+                '/v1/a/c/o',
+                environ={'REQUEST_METHOD': 'PUT', 'swift.cache': cache},
+                headers={'Content-Length': '0',
+                         'X-Object-Meta-Too-Long': 'a' *
+                         constraints.MAX_META_VALUE_LENGTH})
             self.app.update_request(req)
             resp = controller.PUT(req)
             self.assertEqual(resp.status_int, 201)
             set_http_connect(201, 201, 201)
             req = Request.blank(
-                '/v1/a/c/o', environ={'REQUEST_METHOD': 'PUT'},
+                '/v1/a/c/o',
+                environ={'REQUEST_METHOD': 'PUT', 'swift.cache': cache},
                 headers={'Content-Length': '0',
                          'X-Object-Meta-Too-Long': 'a' *
                          (constraints.MAX_META_VALUE_LENGTH + 1)})
@@ -5244,8 +5318,10 @@ class TestReplicatedObjectController(
             headers = {'Content-Length': '0'}
             for x in range(constraints.MAX_META_COUNT):
                 headers['X-Object-Meta-%d' % x] = 'v'
-            req = Request.blank('/v1/a/c/o', environ={'REQUEST_METHOD': 'PUT'},
-                                headers=headers)
+            req = Request.blank(
+                '/v1/a/c/o',
+                environ={'REQUEST_METHOD': 'PUT', 'swift.cache': cache},
+                headers=headers)
             self.app.update_request(req)
             resp = controller.PUT(req)
             self.assertEqual(resp.status_int, 201)
@@ -5253,8 +5329,10 @@ class TestReplicatedObjectController(
             headers = {'Content-Length': '0'}
             for x in range(constraints.MAX_META_COUNT + 1):
                 headers['X-Object-Meta-%d' % x] = 'v'
-            req = Request.blank('/v1/a/c/o', environ={'REQUEST_METHOD': 'PUT'},
-                                headers=headers)
+            req = Request.blank(
+                '/v1/a/c/o',
+                environ={'REQUEST_METHOD': 'PUT', 'swift.cache': cache},
+                headers=headers)
             self.app.update_request(req)
             resp = controller.PUT(req)
             self.assertEqual(resp.status_int, 400)
@@ -5272,16 +5350,20 @@ class TestReplicatedObjectController(
             if constraints.MAX_META_OVERALL_SIZE - size > 1:
                 headers['X-Object-Meta-a'] = \
                     'a' * (constraints.MAX_META_OVERALL_SIZE - size - 1)
-            req = Request.blank('/v1/a/c/o', environ={'REQUEST_METHOD': 'PUT'},
-                                headers=headers)
+            req = Request.blank(
+                '/v1/a/c/o',
+                environ={'REQUEST_METHOD': 'PUT', 'swift.cache': cache},
+                headers=headers)
             self.app.update_request(req)
             resp = controller.PUT(req)
             self.assertEqual(resp.status_int, 201)
             set_http_connect(201, 201, 201)
             headers['X-Object-Meta-a'] = \
                 'a' * (constraints.MAX_META_OVERALL_SIZE - size)
-            req = Request.blank('/v1/a/c/o', environ={'REQUEST_METHOD': 'PUT'},
-                                headers=headers)
+            req = Request.blank(
+                '/v1/a/c/o',
+                environ={'REQUEST_METHOD': 'PUT', 'swift.cache': cache},
+                headers=headers)
             self.app.update_request(req)
             resp = controller.PUT(req)
             self.assertEqual(resp.status_int, 400)
@@ -5292,7 +5374,6 @@ class TestReplicatedObjectController(
         controller = ReplicatedObjectController(
             self.app, account, container, obj)
         self.app.update_request(req)
-        self.app.memcache.store = {}
         with save_globals():
             new_connect = set_http_connect(*args, **kwargs)
             yield controller
@@ -5702,7 +5783,7 @@ class TestReplicatedObjectController(
         # not be used in ring order is if affinity is respected.
         with mock.patch('swift.proxy.server.shuffle', lambda x: x):
             app = proxy_server.Application(
-                conf, FakeMemcache(),
+                conf,
                 logger=debug_logger('proxy-ut'),
                 account_ring=FakeRing(),
                 container_ring=FakeRing())
@@ -5718,7 +5799,6 @@ class TestReplicatedObjectController(
                 req = Request.blank(
                     '/v1/a/c/o.jpg',
                     headers={'X-Backend-Storage-Policy-Index': str(policy)})
-                app.memcache.store = {}
                 res = controller.GET(req)
         self.assertTrue(res.status.startswith('200 '))
         self.assertEqual(3, len(actual_nodes))
@@ -5818,7 +5898,6 @@ class TestReplicatedObjectController(
             controller = ReplicatedObjectController(
                 self.app, 'account', 'container', 'object')
             set_http_connect(200, 200, 202, 202, 202)
-            self.app.memcache.store = {}
             orig_time = time.time
             try:
                 t = time.time()
@@ -7317,7 +7396,7 @@ class BaseTestECObjectController(BaseTes
                 return super(WrappedTimeout, self).__exit__(typ, value, tb)
 
         timeouts = {}
-        with mock.patch('swift.proxy.controllers.base.WatchdogTimeout',
+        with mock.patch('swift.proxy.controllers.obj.WatchdogTimeout',
                         WrappedTimeout):
             with mock.patch.object(_test_servers[0], 'client_timeout', new=5):
                 # get object
@@ -7982,7 +8061,7 @@ class TestObjectDisconnectCleanup(unitte
                 continue
             device_path = os.path.join(_testdir, dev)
             for datadir in os.listdir(device_path):
-                if 'object' not in datadir:
+                if any(p in datadir for p in ('account', 'container')):
                     continue
                 data_path = os.path.join(device_path, datadir)
                 rmtree(data_path, ignore_errors=True)
@@ -7992,10 +8071,12 @@ class TestObjectDisconnectCleanup(unitte
         skip_if_no_xattrs()
         debug.hub_exceptions(False)
         self._cleanup_devices()
+        _test_servers[0]._error_limiting = {}  # clear out errors
 
     def tearDown(self):
         debug.hub_exceptions(True)
         self._cleanup_devices()
+        _test_servers[0]._error_limiting = {}  # clear out errors
 
     def _check_disconnect_cleans_up(self, policy_name, is_chunked=False):
         proxy_port = _test_sockets[0].getsockname()[1]
@@ -8088,8 +8169,9 @@ class TestObjectDisconnectCleanup(unitte
 class TestObjectECRangedGET(unittest.TestCase):
     def setUp(self):
         _test_servers[0].logger._clear()
+        _test_servers[0]._error_limiting = {}  # clear out errors
         self.app = proxy_server.Application(
-            None, FakeMemcache(),
+            None,
             logger=debug_logger('proxy-ut'),
             account_ring=FakeRing(),
             container_ring=FakeRing())
@@ -8098,6 +8180,7 @@ class TestObjectECRangedGET(unittest.Tes
         prosrv = _test_servers[0]
         self.assertFalse(prosrv.logger.get_lines_for_level('error'))
         self.assertFalse(prosrv.logger.get_lines_for_level('warning'))
+        prosrv._error_limiting = {}  # clear out errors
 
     @classmethod
     def setUpClass(cls):
@@ -8674,7 +8757,7 @@ class TestContainerController(unittest.T
 
     def setUp(self):
         self.app = proxy_server.Application(
-            None, FakeMemcache(),
+            None,
             account_ring=FakeRing(),
             container_ring=FakeRing(base_port=2000),
             logger=debug_logger())
@@ -8774,14 +8857,12 @@ class TestContainerController(unittest.T
             if raise_exc:
                 kwargs['raise_exc'] = raise_exc
             set_http_connect(*statuses, **kwargs)
-            self.app.memcache.store = {}
             req = Request.blank('/v1/a/c', headers={'Content-Length': '0',
                                 'Content-Type': 'text/plain'})
             self.app.update_request(req)
             res = method(req)
             self.assertEqual(res.status_int, expected)
             set_http_connect(*statuses, **kwargs)
-            self.app.memcache.store = {}
             req = Request.blank('/v1/a/c/', headers={'Content-Length': '0',
                                 'Content-Type': 'text/plain'})
             self.app.update_request(req)
@@ -8795,7 +8876,6 @@ class TestContainerController(unittest.T
             def test_status_map(statuses, expected,
                                 c_expected=None, a_expected=None, **kwargs):
                 set_http_connect(*statuses, **kwargs)
-                self.app.memcache.store = {}
                 req = Request.blank('/v1/a/c', {})
                 self.app.update_request(req)
                 res = controller.HEAD(req)
@@ -8823,7 +8903,6 @@ class TestContainerController(unittest.T
                     self.assertNotIn('account/a', res.environ)
 
                 set_http_connect(*statuses, **kwargs)
-                self.app.memcache.store = {}
                 req = Request.blank('/v1/a/c', {})
                 self.app.update_request(req)
                 res = controller.GET(req)
@@ -8882,7 +8961,6 @@ class TestContainerController(unittest.T
             with save_globals():
                 mock_conn = set_http_connect(200, 201, 201, 201,
                                              give_connect=capture_requests)
-                self.app.memcache.store = {}
                 req = Request.blank('/v1/a/test', method='PUT',
                                     headers={'Content-Length': 0})
                 if requested_policy:
@@ -8934,7 +9012,6 @@ class TestContainerController(unittest.T
 
             def test_status_map(statuses, expected, **kwargs):
                 set_http_connect(*statuses, **kwargs)
-                self.app.memcache.store = {}
                 req = Request.blank('/v1/a/c', {})
                 req.content_length = 0
                 self.app.update_request(req)
@@ -8994,7 +9071,6 @@ class TestContainerController(unittest.T
 
             def test_status_map(statuses, expected, headers=None, **kwargs):
                 set_http_connect(*statuses, **kwargs)
-                self.app.memcache.store = {}
                 req = Request.blank('/v1/a/c', {}, headers=headers)
                 req.content_length = 0
                 self.app.update_request(req)
@@ -9033,7 +9109,6 @@ class TestContainerController(unittest.T
 
             def test_status_map(statuses, expected, **kwargs):
                 set_http_connect(*statuses, **kwargs)
-                self.app.memcache.store = {}
                 req = Request.blank('/v1/a/c', {})
                 req.content_length = 0
                 self.app.update_request(req)
@@ -9126,7 +9201,6 @@ class TestContainerController(unittest.T
     def test_acc_missing_returns_404(self):
         for meth in ('DELETE', 'PUT'):
             with save_globals():
-                self.app.memcache = FakeMemcacheReturnsNone()
                 self.app._error_limiting = {}
                 controller = proxy_server.ContainerController(self.app,
                                                               'account',
@@ -9136,7 +9210,6 @@ class TestContainerController(unittest.T
                                      missing_container=True)
                 else:
                     set_http_connect(200, 200, 200, 200)
-                self.app.memcache.store = {}
                 req = Request.blank('/v1/a/c',
                                     environ={'REQUEST_METHOD': meth})
                 self.app.update_request(req)
@@ -9251,7 +9324,6 @@ class TestContainerController(unittest.T
             self.assert_status_map(controller.DELETE,
                                    (200, 204, 503, 404), 503)
 
-            self.app.memcache = FakeMemcacheReturnsNone()
             # 200: Account check, 404x3: Container check
             self.assert_status_map(controller.DELETE,
                                    (200, 404, 404, 404), 404)
@@ -9556,7 +9628,7 @@ class TestContainerController(unittest.T
         def _do_test(method):
             with save_globals():
                 swift.proxy.controllers.Controller.account_info = account_info
-                app = proxy_server.Application(None, FakeMemcache(),
+                app = proxy_server.Application(None,
                                                account_ring=FakeRing(),
                                                container_ring=FakeRing())
                 set_http_connect(201, 201, 201)
@@ -9595,7 +9667,7 @@ class TestContainerController(unittest.T
         def _do_test(method):
             with save_globals():
                 swift.proxy.controllers.Controller.account_info = account_info
-                app = proxy_server.Application(None, FakeMemcache(),
+                app = proxy_server.Application(None,
                                                account_ring=FakeRing(),
                                                container_ring=FakeRing())
                 set_http_connect(201, 201, 201)
@@ -9982,7 +10054,7 @@ class TestAccountController(unittest.Tes
 
     def setUp(self):
         conf = {'error_suppression_interval': 0}
-        self.app = proxy_server.Application(conf, FakeMemcache(),
+        self.app = proxy_server.Application(conf,
                                             account_ring=FakeRing(),
                                             container_ring=FakeRing())
 
@@ -10065,13 +10137,11 @@ class TestAccountController(unittest.Tes
             self.assert_status_map(controller.GET, (404, 404, 503), 404, 404)
             self.assert_status_map(controller.GET, (404, 503, 503), 503)
 
-            self.app.memcache = FakeMemcacheReturnsNone()
             self.assert_status_map(controller.GET, (404, 404, 404), 404, 404)
 
     def test_GET_autocreate(self):
         with save_globals():
             controller = proxy_server.AccountController(self.app, 'a')
-            self.app.memcache = FakeMemcacheReturnsNone()
             self.assertFalse(self.app.account_autocreate)
             # Repeat the test for autocreate = False and 404 by all
             self.assert_status_map(controller.GET,
@@ -10138,7 +10208,6 @@ class TestAccountController(unittest.Tes
         # Same behaviour as GET
         with save_globals():
             controller = proxy_server.AccountController(self.app, 'a')
-            self.app.memcache = FakeMemcacheReturnsNone()
             self.assertFalse(self.app.account_autocreate)
             self.assert_status_map(controller.HEAD,
                                    (404, 404, 404), 404)
@@ -10154,7 +10223,6 @@ class TestAccountController(unittest.Tes
     def test_POST_autocreate(self):
         with save_globals():
             controller = proxy_server.AccountController(self.app, 'a')
-            self.app.memcache = FakeMemcacheReturnsNone()
             # first test with autocreate being False
             self.assertFalse(self.app.account_autocreate)
             self.assert_status_map(controller.POST,
@@ -10176,7 +10244,6 @@ class TestAccountController(unittest.Tes
     def test_POST_autocreate_with_sysmeta(self):
         with save_globals():
             controller = proxy_server.AccountController(self.app, 'a')
-            self.app.memcache = FakeMemcacheReturnsNone()
             # first test with autocreate being False
             self.assertFalse(self.app.account_autocreate)
             self.assert_status_map(controller.POST,
@@ -10249,7 +10316,6 @@ class TestAccountController(unittest.Tes
 
             def test_status_map(statuses, expected, **kwargs):
                 set_http_connect(*statuses, **kwargs)
-                self.app.memcache.store = {}
                 req = Request.blank('/v1/a', {})
                 req.content_length = 0
                 self.app.update_request(req)
@@ -10452,7 +10518,6 @@ class TestAccountController(unittest.Tes
 
             def test_status_map(statuses, expected, **kwargs):
                 set_http_connect(*statuses, **kwargs)
-                self.app.memcache.store = {}
                 req = Request.blank('/v1/a', {'REQUEST_METHOD': 'DELETE'})
                 req.content_length = 0
                 self.app.update_request(req)
@@ -10475,7 +10540,6 @@ class TestAccountController(unittest.Tes
 
             def test_status_map(statuses, expected, **kwargs):
                 set_http_connect(*statuses, **kwargs)
-                self.app.memcache.store = {}
                 req = Request.blank('/v1/a?whoops',
                                     environ={'REQUEST_METHOD': 'DELETE'})
                 req.content_length = 0
@@ -10500,11 +10564,10 @@ class TestAccountControllerFakeGetRespon
     def setUp(self):
         conf = {'account_autocreate': 'yes'}
         self.app = listing_formats.ListingFilter(
-            proxy_server.Application(conf, FakeMemcache(),
+            proxy_server.Application(conf,
                                      account_ring=FakeRing(),
                                      container_ring=FakeRing()),
             {})
-        self.app.app.memcache = FakeMemcacheReturnsNone()
 
     def test_GET_autocreate_accept_json(self):
         with save_globals():
@@ -10611,7 +10674,7 @@ class TestAccountControllerFakeGetRespon
             version=2, acl_dict=acl)}
 
         app = proxy_server.Application(
-            None, FakeMemcache(), account_ring=FakeRing(),
+            None, account_ring=FakeRing(),
             container_ring=FakeRing())
 
         with save_globals():
@@ -10686,7 +10749,7 @@ class TestAccountControllerFakeGetRespon
             resps_to_send.append(canned_resp)
 
         app = proxy_server.Application(
-            None, FakeMemcache(), account_ring=FakeRing(),
+            None, account_ring=FakeRing(),
             container_ring=FakeRing())
         app.allow_account_management = True
 
@@ -10790,6 +10853,7 @@ class TestProxyObjectPerformance(unittes
         # various data paths between the proxy server and the object
         # server. Used as a play ground to debug buffer sizes for sockets.
         skip_if_no_xattrs()
+        _test_servers[0]._error_limiting = {}  # clear out errors
         prolis = _test_sockets[0]
         sock = connect_tcp(('localhost', prolis.getsockname()[1]))
         # Client is transmitting in 2 MB chunks
@@ -10854,7 +10918,7 @@ class TestSwiftInfo(unittest.TestCase):
         utils._swift_admin_info = {}
 
     def test_registered_defaults(self):
-        app = proxy_server.Application({}, FakeMemcache(),
+        app = proxy_server.Application({},
                                        account_ring=FakeRing(),
                                        container_ring=FakeRing())
         req = Request.blank('/info')
@@ -10910,6 +10974,7 @@ class TestSocketObjectVersions(unittest.
     def setUp(self):
         global _test_sockets
         skip_if_no_xattrs()
+        _test_servers[0]._error_limiting = {}  # clear out errors
         self.prolis = prolis = listen_zero()
         self._orig_prolis = _test_sockets[0]
         allowed_headers = ', '.join([
@@ -10944,6 +11009,7 @@ class TestSocketObjectVersions(unittest.
         global _test_sockets
         self.sockets[0] = self._orig_prolis
         _test_sockets = tuple(self.sockets)
+        _test_servers[0]._error_limiting = {}  # clear out errors
 
     def test_version_manifest(self, oc=b'versions', vc=b'vers', o=b'name'):
         versions_to_create = 3
diff -pruN 2.25.0-3/test/unit/proxy/test_sysmeta.py 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/proxy/test_sysmeta.py
--- 2.25.0-3/test/unit/proxy/test_sysmeta.py	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/test/unit/proxy/test_sysmeta.py	2020-09-15 21:13:36.000000000 +0000
@@ -132,7 +132,7 @@ class TestObjectSysmeta(unittest.TestCas
 
     def setUp(self):
         skip_if_no_xattrs()
-        self.app = proxy.Application(None, FakeMemcache(),
+        self.app = proxy.Application(None,
                                      logger=debug_logger('proxy-ut'),
                                      account_ring=FakeRing(replicas=1),
                                      container_ring=FakeRing(replicas=1))
@@ -227,8 +227,9 @@ class TestObjectSysmeta(unittest.TestCas
 
     def test_sysmeta_replaced_by_PUT(self):
         path = '/v1/a/c/o'
+        cache = FakeMemcache()
 
-        env = {'REQUEST_METHOD': 'PUT'}
+        env = {'REQUEST_METHOD': 'PUT', 'swift.cache': cache}
         hdrs = dict(self.original_sysmeta_headers_1)
         hdrs.update(self.original_sysmeta_headers_2)
         hdrs.update(self.original_meta_headers_1)
@@ -237,7 +238,7 @@ class TestObjectSysmeta(unittest.TestCas
         resp = req.get_response(self.app)
         self._assertStatus(resp, 201)
 
-        env = {'REQUEST_METHOD': 'PUT'}
+        env = {'REQUEST_METHOD': 'PUT', 'swift.cache': cache}
         hdrs = dict(self.changed_sysmeta_headers)
         hdrs.update(self.new_sysmeta_headers)
         hdrs.update(self.changed_meta_headers)
@@ -247,7 +248,7 @@ class TestObjectSysmeta(unittest.TestCas
         resp = req.get_response(self.app)
         self._assertStatus(resp, 201)
 
-        req = Request.blank(path, environ={})
+        req = Request.blank(path, environ={'swift.cache': cache})
         resp = req.get_response(self.app)
         self._assertStatus(resp, 200)
         self._assertInHeaders(resp, self.changed_sysmeta_headers)
@@ -257,29 +258,30 @@ class TestObjectSysmeta(unittest.TestCas
         self._assertInHeaders(resp, self.new_meta_headers)
         self._assertNotInHeaders(resp, self.original_meta_headers_2)
 
-    def _test_sysmeta_not_updated_by_POST(self, app):
+    def test_sysmeta_not_updated_by_POST(self):
         # check sysmeta is not changed by a POST but user meta is replaced
         path = '/v1/a/c/o'
+        cache = FakeMemcache()
 
-        env = {'REQUEST_METHOD': 'PUT'}
+        env = {'REQUEST_METHOD': 'PUT', 'swift.cache': cache}
         hdrs = dict(self.original_sysmeta_headers_1)
         hdrs.update(self.original_meta_headers_1)
         req = Request.blank(path, environ=env, headers=hdrs, body=b'x')
-        resp = req.get_response(app)
+        resp = req.get_response(self.app)
         self._assertStatus(resp, 201)
 
-        env = {'REQUEST_METHOD': 'POST'}
+        env = {'REQUEST_METHOD': 'POST', 'swift.cache': cache}
         hdrs = dict(self.changed_sysmeta_headers)
         hdrs.update(self.new_sysmeta_headers)
         hdrs.update(self.changed_meta_headers)
         hdrs.update(self.new_meta_headers)
         hdrs.update(self.bad_headers)
         req = Request.blank(path, environ=env, headers=hdrs)
-        resp = req.get_response(app)
+        resp = req.get_response(self.app)
         self._assertStatus(resp, 202)
 
-        req = Request.blank(path, environ={})
-        resp = req.get_response(app)
+        req = Request.blank(path, environ={'swift.cache': cache})
+        resp = req.get_response(self.app)
         self._assertStatus(resp, 200)
         self._assertInHeaders(resp, self.original_sysmeta_headers_1)
         self._assertNotInHeaders(resp, self.new_sysmeta_headers)
@@ -287,31 +289,28 @@ class TestObjectSysmeta(unittest.TestCas
         self._assertInHeaders(resp, self.new_meta_headers)
         self._assertNotInHeaders(resp, self.bad_headers)
 
-        env = {'REQUEST_METHOD': 'PUT'}
+        env = {'REQUEST_METHOD': 'PUT', 'swift.cache': cache}
         hdrs = dict(self.changed_sysmeta_headers)
         hdrs.update(self.new_sysmeta_headers)
         hdrs.update(self.bad_headers)
         req = Request.blank(path, environ=env, headers=hdrs, body=b'x')
-        resp = req.get_response(app)
+        resp = req.get_response(self.app)
         self._assertStatus(resp, 201)
 
-        req = Request.blank(path, environ={})
-        resp = req.get_response(app)
+        req = Request.blank(path, environ={'swift.cache': cache})
+        resp = req.get_response(self.app)
         self._assertStatus(resp, 200)
         self._assertInHeaders(resp, self.changed_sysmeta_headers)
         self._assertInHeaders(resp, self.new_sysmeta_headers)
         self._assertNotInHeaders(resp, self.original_sysmeta_headers_2)
 
-    def test_sysmeta_not_updated_by_POST(self):
-        # test fast-post by issuing requests to the proxy app
-        self._test_sysmeta_not_updated_by_POST(self.app)
-
     def test_sysmeta_updated_by_COPY(self):
         # check sysmeta is updated by a COPY in same way as user meta by
         # issuing requests to the copy middleware app
         path = '/v1/a/c/o'
         dest = '/c/o2'
-        env = {'REQUEST_METHOD': 'PUT'}
+        cache = FakeMemcache()
+        env = {'REQUEST_METHOD': 'PUT', 'swift.cache': cache}
         hdrs = dict(self.original_sysmeta_headers_1)
         hdrs.update(self.original_sysmeta_headers_2)
         hdrs.update(self.original_meta_headers_1)
@@ -322,7 +321,7 @@ class TestObjectSysmeta(unittest.TestCas
         resp = req.get_response(self.copy_app)
         self._assertStatus(resp, 201)
 
-        env = {'REQUEST_METHOD': 'COPY'}
+        env = {'REQUEST_METHOD': 'COPY', 'swift.cache': cache}
         hdrs = dict(self.changed_sysmeta_headers)
         hdrs.update(self.new_sysmeta_headers)
         hdrs.update(self.changed_meta_headers)
@@ -345,7 +344,7 @@ class TestObjectSysmeta(unittest.TestCas
         self._assertInHeaders(resp, self.original_transient_sysmeta_headers_2)
         self._assertNotInHeaders(resp, self.bad_headers)
 
-        req = Request.blank('/v1/a/c/o2', environ={})
+        req = Request.blank('/v1/a/c/o2', environ={'swift.cache': cache})
         resp = req.get_response(self.copy_app)
         self._assertStatus(resp, 200)
         self._assertInHeaders(resp, self.changed_sysmeta_headers)
@@ -363,7 +362,8 @@ class TestObjectSysmeta(unittest.TestCas
         # check sysmeta is updated by a PUT with x-copy-from in same way as
         # user meta by issuing requests to the copy middleware app
         path = '/v1/a/c/o'
-        env = {'REQUEST_METHOD': 'PUT'}
+        cache = FakeMemcache()
+        env = {'REQUEST_METHOD': 'PUT', 'swift.cache': cache}
         hdrs = dict(self.original_sysmeta_headers_1)
         hdrs.update(self.original_sysmeta_headers_2)
         hdrs.update(self.original_meta_headers_1)
@@ -372,7 +372,7 @@ class TestObjectSysmeta(unittest.TestCas
         resp = req.get_response(self.copy_app)
         self._assertStatus(resp, 201)
 
-        env = {'REQUEST_METHOD': 'PUT'}
+        env = {'REQUEST_METHOD': 'PUT', 'swift.cache': cache}
         hdrs = dict(self.changed_sysmeta_headers)
         hdrs.update(self.new_sysmeta_headers)
         hdrs.update(self.changed_meta_headers)
@@ -390,7 +390,7 @@ class TestObjectSysmeta(unittest.TestCas
         self._assertInHeaders(resp, self.original_meta_headers_2)
         self._assertNotInHeaders(resp, self.bad_headers)
 
-        req = Request.blank('/v1/a/c/o2', environ={})
+        req = Request.blank('/v1/a/c/o2', environ={'swift.cache': cache})
         resp = req.get_response(self.copy_app)
         self._assertStatus(resp, 200)
         self._assertInHeaders(resp, self.changed_sysmeta_headers)
@@ -401,40 +401,41 @@ class TestObjectSysmeta(unittest.TestCas
         self._assertInHeaders(resp, self.original_meta_headers_2)
         self._assertNotInHeaders(resp, self.bad_headers)
 
-    def _test_transient_sysmeta_replaced_by_PUT_or_POST(self, app):
+    def test_transient_sysmeta_replaced_by_PUT_or_POST(self):
         # check transient_sysmeta is replaced en-masse by a POST
         path = '/v1/a/c/o'
+        cache = FakeMemcache()
 
-        env = {'REQUEST_METHOD': 'PUT'}
+        env = {'REQUEST_METHOD': 'PUT', 'swift.cache': cache}
         hdrs = dict(self.original_transient_sysmeta_headers_1)
         hdrs.update(self.original_transient_sysmeta_headers_2)
         hdrs.update(self.original_meta_headers_1)
         req = Request.blank(path, environ=env, headers=hdrs, body=b'x')
-        resp = req.get_response(app)
+        resp = req.get_response(self.app)
         self._assertStatus(resp, 201)
 
         req = Request.blank(path, environ={})
-        resp = req.get_response(app)
+        resp = req.get_response(self.app)
         self._assertStatus(resp, 200)
         self._assertInHeaders(resp, self.original_transient_sysmeta_headers_1)
         self._assertInHeaders(resp, self.original_transient_sysmeta_headers_2)
         self._assertInHeaders(resp, self.original_meta_headers_1)
 
-        info = get_object_info(req.environ, app)
+        info = get_object_info(req.environ, self.app)
         self.assertEqual(2, len(info.get('transient_sysmeta', ())))
         self.assertEqual({'testa': 'A', 'testb': 'B'},
                          info['transient_sysmeta'])
 
         # POST will replace all existing transient_sysmeta and usermeta values
-        env = {'REQUEST_METHOD': 'POST'}
+        env = {'REQUEST_METHOD': 'POST', 'swift.cache': cache}
         hdrs = dict(self.changed_transient_sysmeta_headers)
         hdrs.update(self.new_transient_sysmeta_headers_1)
         req = Request.blank(path, environ=env, headers=hdrs)
-        resp = req.get_response(app)
+        resp = req.get_response(self.app)
         self._assertStatus(resp, 202)
 
         req = Request.blank(path, environ={})
-        resp = req.get_response(app)
+        resp = req.get_response(self.app)
         self._assertStatus(resp, 200)
         self._assertInHeaders(resp, self.changed_transient_sysmeta_headers)
         self._assertInHeaders(resp, self.new_transient_sysmeta_headers_1)
@@ -442,21 +443,21 @@ class TestObjectSysmeta(unittest.TestCas
         self._assertNotInHeaders(resp,
                                  self.original_transient_sysmeta_headers_2)
 
-        info = get_object_info(req.environ, app)
+        info = get_object_info(req.environ, self.app)
         self.assertEqual(2, len(info.get('transient_sysmeta', ())))
         self.assertEqual({'testa': 'changed_A', 'testc': 'C'},
                          info['transient_sysmeta'])
 
         # subsequent PUT replaces all transient_sysmeta and usermeta values
-        env = {'REQUEST_METHOD': 'PUT'}
+        env = {'REQUEST_METHOD': 'PUT', 'swift.cache': cache}
         hdrs = dict(self.new_transient_sysmeta_headers_2)
         hdrs.update(self.original_meta_headers_2)
         req = Request.blank(path, environ=env, headers=hdrs, body=b'x')
-        resp = req.get_response(app)
+        resp = req.get_response(self.app)
         self._assertStatus(resp, 201)
 
-        req = Request.blank(path, environ={})
-        resp = req.get_response(app)
+        req = Request.blank(path, environ={'swift.cache': cache})
+        resp = req.get_response(self.app)
         self._assertStatus(resp, 200)
         self._assertInHeaders(resp, self.original_meta_headers_2)
         self._assertInHeaders(resp, self.new_transient_sysmeta_headers_2)
@@ -470,9 +471,6 @@ class TestObjectSysmeta(unittest.TestCas
         self._assertNotInHeaders(resp,
                                  self.original_transient_sysmeta_headers_2)
 
-        info = get_object_info(req.environ, app)
+        info = get_object_info(req.environ, self.app)
         self.assertEqual(1, len(info.get('transient_sysmeta', ())))
         self.assertEqual({'testd': 'D'}, info['transient_sysmeta'])
-
-    def test_transient_sysmeta_replaced_by_PUT_or_POST(self):
-        self._test_transient_sysmeta_replaced_by_PUT_or_POST(self.app)
diff -pruN 2.25.0-3/tools/playbooks/common/install_dependencies.yaml 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/tools/playbooks/common/install_dependencies.yaml
--- 2.25.0-3/tools/playbooks/common/install_dependencies.yaml	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/tools/playbooks/common/install_dependencies.yaml	2020-09-15 21:13:36.000000000 +0000
@@ -14,12 +14,18 @@
 # limitations under the License.
 - hosts: all
   become: true
+  roles:
+    - ensure-pip
   tasks:
+    - name: upgrade pip
+      pip:
+        name: pip
+        extra_args: --upgrade
+
     - name: installing dependencies
       yum: name={{ item }} state=present
       with_items:
         - python-pyeclib
-        - python-pip
         - python-nose
         - python-swiftclient
 
diff -pruN 2.25.0-3/tools/playbooks/dsvm/pre.yaml 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/tools/playbooks/dsvm/pre.yaml
--- 2.25.0-3/tools/playbooks/dsvm/pre.yaml	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/tools/playbooks/dsvm/pre.yaml	2020-09-15 21:13:36.000000000 +0000
@@ -7,3 +7,6 @@
       bindep_dir: "{{ zuul_work_dir }}"
     - test-setup
     - ensure-tox
+    - additional-tempauth-users
+    - additional-keystone-users
+    - dsvm-additional-middlewares
diff -pruN 2.25.0-3/tools/playbooks/multinode_setup/configure_loopback.yaml 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/tools/playbooks/multinode_setup/configure_loopback.yaml
--- 2.25.0-3/tools/playbooks/multinode_setup/configure_loopback.yaml	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/tools/playbooks/multinode_setup/configure_loopback.yaml	2020-09-15 21:13:36.000000000 +0000
@@ -31,7 +31,7 @@
         state: directory
 
     - name: mount /mnt/sdb1
-      mount: name=/mnt/sdb1 src=/srv/swift-disk fstype=xfs opts="loop,noatime,nodiratime,logbufs=8" dump=0 passno=0 state=mounted
+      mount: name=/mnt/sdb1 src=/srv/swift-disk fstype=xfs opts="loop,noatime" dump=0 passno=0 state=mounted
 
     - name: create sub-partitions
       file:
diff -pruN 2.25.0-3/tools/playbooks/multinode_setup/make_rings.yaml 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/tools/playbooks/multinode_setup/make_rings.yaml
--- 2.25.0-3/tools/playbooks/multinode_setup/make_rings.yaml	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/tools/playbooks/multinode_setup/make_rings.yaml	2020-09-15 21:13:36.000000000 +0000
@@ -113,6 +113,16 @@
 - hosts: test-runner
   tasks:
 
+    - name: Set base port for old stable branches
+      set_fact:
+        swift_base_port: 6000
+      when: previous_swift_version | default(latest_swift_release.stdout) is match("^(rocky|stein|train|ussuri)-em.*|^2\.(1?[0-9]|2[0-5])\.|^(origin/)?stable/[a-u].*")
+
+    - name: Set base port for Victoria and later
+      set_fact:
+        swift_base_port: 6200
+      when: previous_swift_version | default(latest_swift_release.stdout) is not match("^(rocky|stein|train|ussuri)-em.*|^2\.(1?[0-9]|2[0-5])\.|^(origin/)?stable/[a-u].*")
+
     - name: create remakerings from template
       template: src=make_multinode_rings.j2 dest=/home/{{ ansible_ssh_user }}/make_multinode_rings mode=0755
 
diff -pruN 2.25.0-3/tools/playbooks/multinode_setup/templates/make_multinode_rings.j2 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/tools/playbooks/multinode_setup/templates/make_multinode_rings.j2
--- 2.25.0-3/tools/playbooks/multinode_setup/templates/make_multinode_rings.j2	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/tools/playbooks/multinode_setup/templates/make_multinode_rings.j2	2020-09-15 21:13:36.000000000 +0000
@@ -7,32 +7,32 @@ cd /home/{{ ansible_ssh_user }}/rings
 rm -f *.builder *.ring.gz backups/*.builder backups/*.ring.gz
 
 swift-ring-builder object.builder create 10 3 1
-swift-ring-builder object.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:6010/sdb1 1
-swift-ring-builder object.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:6010/sdb2 1
-swift-ring-builder object.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:6010/sdb3 1
+swift-ring-builder object.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:{{ swift_base_port + 10 }}/sdb1 1
+swift-ring-builder object.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:{{ swift_base_port + 10 }}/sdb2 1
+swift-ring-builder object.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:{{ swift_base_port + 10 }}/sdb3 1
 swift-ring-builder object.builder rebalance
 swift-ring-builder object-1.builder create 10 2 1
-swift-ring-builder object-1.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:6010/sdb1 1
-swift-ring-builder object-1.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:6010/sdb2 1
-swift-ring-builder object-1.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:6010/sdb3 1
+swift-ring-builder object-1.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:{{ swift_base_port + 10 }}/sdb1 1
+swift-ring-builder object-1.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:{{ swift_base_port + 10 }}/sdb2 1
+swift-ring-builder object-1.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:{{ swift_base_port + 10 }}/sdb3 1
 swift-ring-builder object-1.builder rebalance
 swift-ring-builder object-2.builder create 10 6 1
-swift-ring-builder object-2.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:6010/sdb1 1
-swift-ring-builder object-2.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:6010/sdb2 1
-swift-ring-builder object-2.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:6010/sdb3 1
-swift-ring-builder object-2.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:6010/sdb4 1
-swift-ring-builder object-2.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:6010/sdb5 1
-swift-ring-builder object-2.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:6010/sdb6 1
-swift-ring-builder object-2.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:6010/sdb7 1
-swift-ring-builder object-2.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:6010/sdb8 1
+swift-ring-builder object-2.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:{{ swift_base_port + 10 }}/sdb1 1
+swift-ring-builder object-2.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:{{ swift_base_port + 10 }}/sdb2 1
+swift-ring-builder object-2.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:{{ swift_base_port + 10 }}/sdb3 1
+swift-ring-builder object-2.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:{{ swift_base_port + 10 }}/sdb4 1
+swift-ring-builder object-2.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:{{ swift_base_port + 10 }}/sdb5 1
+swift-ring-builder object-2.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:{{ swift_base_port + 10 }}/sdb6 1
+swift-ring-builder object-2.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:{{ swift_base_port + 10 }}/sdb7 1
+swift-ring-builder object-2.builder add r1z1-{{ hostvars['object1'].nodepool.public_ipv4 }}:{{ swift_base_port + 10 }}/sdb8 1
 swift-ring-builder object-2.builder rebalance
 swift-ring-builder container.builder create 10 3 1
-swift-ring-builder container.builder add r1z1-{{ hostvars['container1'].nodepool.public_ipv4 }}:6011/sdb1 1
-swift-ring-builder container.builder add r1z1-{{ hostvars['container1'].nodepool.public_ipv4 }}:6011/sdb2 1
-swift-ring-builder container.builder add r1z1-{{ hostvars['container1'].nodepool.public_ipv4 }}:6011/sdb3 1
+swift-ring-builder container.builder add r1z1-{{ hostvars['container1'].nodepool.public_ipv4 }}:{{ swift_base_port + 11 }}/sdb1 1
+swift-ring-builder container.builder add r1z1-{{ hostvars['container1'].nodepool.public_ipv4 }}:{{ swift_base_port + 11 }}/sdb2 1
+swift-ring-builder container.builder add r1z1-{{ hostvars['container1'].nodepool.public_ipv4 }}:{{ swift_base_port + 11 }}/sdb3 1
 swift-ring-builder container.builder rebalance
 swift-ring-builder account.builder create 10 3 1
-swift-ring-builder account.builder add r1z1-{{ hostvars['account1'].nodepool.public_ipv4 }}:6012/sdb1 1
-swift-ring-builder account.builder add r1z1-{{ hostvars['account1'].nodepool.public_ipv4 }}:6012/sdb2 1
-swift-ring-builder account.builder add r1z1-{{ hostvars['account1'].nodepool.public_ipv4 }}:6012/sdb3 1
+swift-ring-builder account.builder add r1z1-{{ hostvars['account1'].nodepool.public_ipv4 }}:{{ swift_base_port + 12 }}/sdb1 1
+swift-ring-builder account.builder add r1z1-{{ hostvars['account1'].nodepool.public_ipv4 }}:{{ swift_base_port + 12 }}/sdb2 1
+swift-ring-builder account.builder add r1z1-{{ hostvars['account1'].nodepool.public_ipv4 }}:{{ swift_base_port + 12 }}/sdb3 1
 swift-ring-builder account.builder rebalance
diff -pruN 2.25.0-3/tools/playbooks/saio_single_node_setup/setup_saio.yaml 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/tools/playbooks/saio_single_node_setup/setup_saio.yaml
--- 2.25.0-3/tools/playbooks/saio_single_node_setup/setup_saio.yaml	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/tools/playbooks/saio_single_node_setup/setup_saio.yaml	2020-09-15 21:13:36.000000000 +0000
@@ -29,7 +29,7 @@
       file: path=/mnt/sdb1 state=directory
 
     - name: mount /mnt/sdb1
-      mount: name=/mnt/sdb1 src=/srv/swift-disk fstype=xfs opts="loop,noatime,nodiratime,logbufs=8" dump=0 passno=0 state=mounted
+      mount: name=/mnt/sdb1 src=/srv/swift-disk fstype=xfs opts="loop,noatime" dump=0 passno=0 state=mounted
 
     - name: create sub-partitions
       file: >
@@ -153,10 +153,12 @@
       with_items: "{{ find_result.files }}"
 
     - name: set the options in the proxy config file
-      shell:
-        cmd: |
-          crudini --set /etc/swift/proxy-server.conf app:proxy-server node_timeout 20
-        executable: /bin/bash
+      ini_file:
+        path: /etc/swift/proxy-server.conf
+        section: app:proxy-server
+        option: node_timeout
+        value: 20
+        create: no
 
     - name: copy the SAIO scripts for resetting the environment
       command: cp -r {{ zuul.project.src_dir }}/doc/saio/bin /home/{{ ansible_ssh_user }}/bin creates=/home/{{ ansible_ssh_user }}/bin
diff -pruN 2.25.0-3/tox.ini 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/tox.ini
--- 2.25.0-3/tox.ini	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/tox.ini	2020-09-15 21:13:36.000000000 +0000
@@ -21,6 +21,12 @@ whitelist_externals = find
                       rm
 passenv = SWIFT_* *_proxy
 
+[testenv:py27]
+deps =
+  -c{toxinidir}/py2-constraints.txt
+  -r{toxinidir}/requirements.txt
+  -r{toxinidir}/test-requirements.txt
+
 [testenv:cover]
 setenv = VIRTUAL_ENV={envdir}
          NOSE_WITH_COVERAGE=1
@@ -30,6 +36,7 @@ setenv = VIRTUAL_ENV={envdir}
 
 [testenv:pep8]
 basepython = python2.7
+deps = {[testenv:py27]deps}
 commands =
   flake8 {posargs:swift test doc setup.py}
   flake8 --filename=swift* bin
@@ -51,52 +58,31 @@ commands = ./.functests {posargs}
 setenv = SWIFT_TEST_IN_PROCESS=1
          SWIFT_TEST_IN_PROCESS_CONF_LOADER=ec
 
-[testenv:func-s3api-py3]
-basepython = python3
-commands = ./.functests {posargs}
-setenv = SWIFT_TEST_IN_PROCESS=1
-         SWIFT_TEST_IN_PROCESS_CONF_LOADER=s3api
-
 [testenv:func-encryption-py3]
 basepython = python3
 commands = ./.functests {posargs}
 setenv = SWIFT_TEST_IN_PROCESS=1
          SWIFT_TEST_IN_PROCESS_CONF_LOADER=encryption
 
-[testenv:func-domain-remap-staticweb-py3]
-basepython = python3
-commands = ./.functests {posargs}
-setenv = SWIFT_TEST_IN_PROCESS=1
-         SWIFT_TEST_IN_PROCESS_CONF_LOADER=domain_remap_staticweb
-
 [testenv:func]
 basepython = python2.7
+deps = {[testenv:py27]deps}
 commands = ./.functests {posargs}
 
 [testenv:func-encryption]
 basepython = python2.7
+deps = {[testenv:py27]deps}
 commands = ./.functests {posargs}
 setenv = SWIFT_TEST_IN_PROCESS=1
          SWIFT_TEST_IN_PROCESS_CONF_LOADER=encryption
 
-[testenv:func-domain-remap-staticweb]
-basepython = python2.7
-commands = ./.functests {posargs}
-setenv = SWIFT_TEST_IN_PROCESS=1
-         SWIFT_TEST_IN_PROCESS_CONF_LOADER=domain_remap_staticweb
-
 [testenv:func-ec]
 basepython = python2.7
+deps = {[testenv:py27]deps}
 commands = ./.functests {posargs}
 setenv = SWIFT_TEST_IN_PROCESS=1
          SWIFT_TEST_IN_PROCESS_CONF_LOADER=ec
 
-[testenv:func-s3api]
-basepython = python2.7
-commands = ./.functests {posargs}
-setenv = SWIFT_TEST_IN_PROCESS=1
-         SWIFT_TEST_IN_PROCESS_CONF_LOADER=s3api
-
 [testenv:venv]
 commands = {posargs}
 
@@ -131,10 +117,11 @@ commands = bandit -c bandit.yaml -r swif
 # changes to enable:
 # E402: module level import not at top of file
 # E731 do not assign a lambda expression, use a def
+# E741 ambiguous variable name
 # Swift team needs to decide if they want to enable either of these:
 # W503: line break before binary operator
 # W504: line break after binary operator
-ignore = H101,H202,H301,H306,H404,H405,H501,W503,W504,E402,E731
+ignore = H101,H202,H301,H306,H404,H405,H501,W503,W504,E402,E731,E741
 exclude = .venv,.tox,dist,*egg
 filename = *.py,bin/*
 show-source = True
diff -pruN 2.25.0-3/.zuul.yaml 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/.zuul.yaml
--- 2.25.0-3/.zuul.yaml	2020-04-18 00:12:48.000000000 +0000
+++ 2.25.1~git2020091517.f8a9a6e11-0ubuntu1/.zuul.yaml	2020-09-15 21:13:36.000000000 +0000
@@ -6,7 +6,7 @@
 
       It sets TMPDIR to an XFS mount point created via
       tools/test-setup.sh.
-    timeout: 2400
+    timeout: 3600
     vars:
       tox_environment:
         TMPDIR: '{{ ansible_env.HOME }}/xfstmp'
@@ -72,7 +72,7 @@
 - job:
     name: swift-tox-py38
     parent: swift-tox-base
-    nodeset: ubuntu-bionic
+    nodeset: ubuntu-focal
     description: |
       Run unit-tests for swift under cPython version 3.8.
 
@@ -140,30 +140,6 @@
       tox_envlist: func-ec-py3
 
 - job:
-    name: swift-tox-func-domain-remap-staticweb-py37
-    parent: swift-tox-func-py37
-    description: |
-      Run functional tests for swift under cPython version 3.7.
-
-      Uses tox with the ``func-domain-remap-staticweb-py3`` environment.
-      It sets TMPDIR to an XFS mount point created via
-      tools/test-setup.sh.
-    vars:
-      tox_envlist: func-domain-remap-staticweb-py3
-
-- job:
-    name: swift-tox-func-s3api-py37
-    parent: swift-tox-func-py37
-    description: |
-      Run functional tests for swift under cPython version 3.7.
-
-      Uses tox with the ``func-s3api`` environment.
-      It sets TMPDIR to an XFS mount point created via
-      tools/test-setup.sh.
-    vars:
-      tox_envlist: func-s3api-py3
-
-- job:
     name: swift-tox-func-py27-centos-7
     parent: swift-tox-func-py27
     nodeset: centos-7
@@ -203,30 +179,6 @@
     nodeset: centos-7
 
 - job:
-    name: swift-tox-func-domain-remap-staticweb-py27
-    parent: swift-tox-base
-    description: |
-      Run functional tests for swift under cPython version 2.7.
-
-      Uses tox with the ``func-domain-remap-staticweb`` environment.
-      It sets TMPDIR to an XFS mount point created via
-      tools/test-setup.sh.
-    vars:
-      tox_envlist: func-domain-remap-staticweb
-
-- job:
-    name: swift-tox-func-s3api-py27
-    parent: swift-tox-base
-    description: |
-      Run functional tests for swift under cPython version 2.7.
-
-      Uses tox with the ``func-s3api`` environment.
-      It sets TMPDIR to an XFS mount point created via
-      tools/test-setup.sh.
-    vars:
-      tox_envlist: func-s3api
-
-- job:
     name: swift-dsvm-functional
     parent: devstack-minimal
     description: |
@@ -235,16 +187,12 @@
       - opendev.org/openstack/requirements
       - opendev.org/openstack/swift
       - opendev.org/openstack/keystone
-    timeout: 2700
+    timeout: 3600
     vars:
       tox_constraints_file: '{{ ansible_user_dir }}/src/opendev.org/openstack/requirements/upper-constraints.txt'
       # This tox env get run twice; once for Keystone and once for tempauth
       tox_envlist: func
       devstack_localrc:
-        # Other services are fine to run py3
-        USE_PYTHON3: true
-        # explicitly state that we want to test swift under py2
-        DISABLED_PYTHON3_PACKAGES: 'swift'
         SWIFT_HASH: changeme
         # We don't need multiple replicas to run purely functional tests.
         # In fact, devstack special cases some things when there's only
@@ -258,26 +206,13 @@
       devstack_services:
         keystone: true
         swift: true
+        s3api: true
       zuul_work_dir: src/opendev.org/openstack/swift
     pre-run: tools/playbooks/dsvm/pre.yaml
     run: tools/playbooks/dsvm/run.yaml
     post-run: tools/playbooks/dsvm/post.yaml
 
 - job:
-    name: swift-dsvm-functional-py3
-    parent: swift-dsvm-functional
-    description: |
-      Setup a Swift/Keystone environment under py3 and run Swift's func tests
-      (also under py3).
-    vars:
-      # This tox env get run twice; once for Keystone and once for tempauth
-      tox_envlist: func-py3
-      devstack_localrc:
-        USE_PYTHON3: true
-        # explicitly clear swift's default-disabled status
-        DISABLED_PYTHON3_PACKAGES: ''
-
-- job:
     name: swift-dsvm-functional-ipv6
     parent: swift-dsvm-functional
     vars:
@@ -292,7 +227,7 @@
     nodeset: centos-7
     description: |
       Setup a SAIO dev environment and run ceph-s3tests
-    timeout: 2400
+    timeout: 3600
     pre-run:
       - tools/playbooks/common/install_dependencies.yaml
       - tools/playbooks/saio_single_node_setup/setup_saio.yaml
@@ -309,7 +244,7 @@
     nodeset: centos-7
     description: |
       Setup a SAIO dev environment and run Swift's probe tests
-    timeout: 3600
+    timeout: 5400
     pre-run:
       - tools/playbooks/common/install_dependencies.yaml
       - tools/playbooks/saio_single_node_setup/setup_saio.yaml
@@ -393,6 +328,18 @@
       previous_swift_version: origin/stable/train
 
 - job:
+    name: swift-multinode-rolling-upgrade-ussuri
+    parent: swift-multinode-rolling-upgrade
+    vars:
+      previous_swift_version: origin/stable/ussuri
+
+- job:
+    name: swift-multinode-rolling-upgrade-master
+    parent: swift-multinode-rolling-upgrade
+    vars:
+      previous_swift_version: origin/master
+
+- job:
     name: swift-tox-lower-constraints
     parent: openstack-tox-lower-constraints
     vars:
@@ -526,54 +473,34 @@
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-tox-func-encryption-py27:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
-        - swift-tox-func-domain-remap-staticweb-py27:
-            irrelevant-files:
-              - ^(api-ref|doc|releasenotes)/.*$
-              - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-tox-func-ec-py27:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
-        - swift-tox-func-s3api-py27:
-            irrelevant-files:
-              - ^(api-ref|doc|releasenotes)/.*$
-              - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
 
         # py3 functional tests
         - swift-tox-func-py37:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-tox-func-encryption-py37:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
-        - swift-tox-func-domain-remap-staticweb-py37:
-            irrelevant-files:
-              - ^(api-ref|doc|releasenotes)/.*$
-              - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-tox-func-ec-py37:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
-        - swift-tox-func-s3api-py37:
-            irrelevant-files:
-              - ^(api-ref|doc|releasenotes)/.*$
-              - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
 
         # Other tests
         - swift-tox-func-s3api-ceph-s3tests-tempauth:
@@ -583,29 +510,24 @@
               # Also keep doc/s3api -- it holds known failures for these tests
               - ^doc/(requirements.txt|(manpages|source)/.*)$
               - ^test/(unit|probe)/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-probetests-centos-7:
             irrelevant-files:
               - ^(api-ref|releasenotes)/.*$
               # Keep doc/saio -- we use those sample configs in the saio playbooks
               - ^doc/(requirements.txt|(manpages|s3api|source)/.*)$
               - ^test/(unit|functional)/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-dsvm-functional:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
-        - swift-dsvm-functional-py3:
-            irrelevant-files:
-              - ^(api-ref|doc|releasenotes)/.*$
-              - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-dsvm-functional-ipv6:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-tox-lower-constraints:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
@@ -619,22 +541,24 @@
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
+            # 2.25.0 had a test issue; see https://review.opendev.org/#/c/721518/
+            voting: false
         - tempest-integrated-object-storage:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - tempest-ipv6-only:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
-        - grenade-py3:
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
+        - grenade:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
     gate:
       jobs:
         # For gate jobs, err towards running more jobs (so, generally avoid
@@ -649,36 +573,27 @@
         - swift-tox-py38
         - swift-tox-func-py27
         - swift-tox-func-encryption-py27
-        - swift-tox-func-domain-remap-staticweb-py27
         - swift-tox-func-ec-py27
-        - swift-tox-func-s3api-py27
         - swift-tox-func-py37
         - swift-tox-func-encryption
-        - swift-tox-func-domain-remap-staticweb-py37
         - swift-tox-func-ec-py37
-        - swift-tox-func-s3api-py37
         - swift-probetests-centos-7:
             irrelevant-files:
               - ^(api-ref|releasenotes)/.*$
               # Keep doc/saio -- we use those sample configs in the saio playbooks
               - ^doc/(requirements.txt|(manpages|s3api|source)/.*)$
               - ^test/(unit|functional)/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-dsvm-functional:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
-        - swift-dsvm-functional-py3:
-            irrelevant-files:
-              - ^(api-ref|doc|releasenotes)/.*$
-              - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-dsvm-functional-ipv6:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/probe/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - swift-tox-lower-constraints:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
@@ -692,17 +607,17 @@
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
         - tempest-ipv6-only:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
-        - grenade-py3:
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
+        - grenade:
             irrelevant-files:
               - ^(api-ref|doc|releasenotes)/.*$
               - ^test/.*$
-              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG)$
+              - ^(.gitreview|.mailmap|AUTHORS|CHANGELOG|.*\.rst)$
     experimental:
       jobs:
         - swift-tox-py27-centos-7
@@ -712,6 +627,9 @@
         - swift-multinode-rolling-upgrade-rocky
         - swift-multinode-rolling-upgrade-stein
         - swift-multinode-rolling-upgrade-train
+        - swift-multinode-rolling-upgrade-ussuri
+        - swift-multinode-rolling-upgrade-master:
+            branches: master
 
     post:
       jobs:
